/*! For license information please see module.js.LICENSE.txt */
define(["@grafana/data","rxjs","@grafana/runtime","lodash","react","@grafana/ui","@emotion/css","moment","redux","react-redux","@emotion/react","react-dom"],((e,t,r,n,o,i,a,s,l,u,c,d)=>(()=>{var p,f,h={8572:(e,t,r)=>{"use strict";r.r(t),r.d(t,{AND:()=>g,AS:()=>f,ASC:()=>c,BY:()=>l,COMPARISON_OPERATORS:()=>O,DESC:()=>u,EQUALS:()=>y,FROM:()=>o,GROUP:()=>a,LIMIT:()=>d,LOGICAL_OPERATORS:()=>m,NOT_EQUALS:()=>b,OR:()=>v,ORDER:()=>s,SCHEMA:()=>h,SELECT:()=>n,STD_OPERATORS:()=>E,WHERE:()=>i,WITH:()=>p,conf:()=>S,language:()=>w});const n="select",o="from",i="where",a="group",s="order",l="by",u="desc",c="asc",d="limit",p="with",f="as",h="schema",g="AND",v="OR",m=[g,v],y="=",b="!=",O=[y,b],E=[...O],S={comments:{lineComment:"--",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}]},w={defaultToken:"",tokenPostfix:".sql",ignoreCase:!0,brackets:[{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"}],keywords:["ABORT","ABSOLUTE","ACTION","ADA","ADD","AFTER","ALL","ALLOCATE","ALTER","ALWAYS","ANALYZE","AND","ANY","ARE","AS","ASC","ASSERTION","AT","ATTACH","AUTHORIZATION","AUTOINCREMENT","AVG","BACKUP","BEFORE","BEGIN","BETWEEN","BIT","BIT_LENGTH","BOTH","BREAK","BROWSE","BULK","BY","CASCADE","CASCADED","CASE","CAST","CATALOG","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CHECKPOINT","CLOSE","CLUSTERED","COALESCE","COLLATE","COLLATION","COLUMN","COMMIT","COMPUTE","CONFLICT","CONNECT","CONNECTION","CONSTRAINT","CONSTRAINTS","CONTAINS","CONTAINSTABLE","CONTINUE","CONVERT","CORRESPONDING","COUNT","CREATE","CROSS","CURRENT","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATE","DAY","DBCC","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFERRABLE","DEFERRED","DELETE","DENY","DESC","DESCRIBE","DESCRIPTOR","DETACH","DIAGNOSTICS","DISCONNECT","DISK","DISTINCT","DISTRIBUTED","DO","DOMAIN","DOUBLE","DROP","DUMP","EACH","ELSE","END","END-EXEC","ERRLVL","ESCAPE","EXCEPT","EXCEPTION","EXCLUDE","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXPLAIN","EXTERNAL","EXTRACT","FAIL","FALSE","FETCH","FILE","FILLFACTOR","FILTER","FIRST","FLOAT","FOLLOWING","FOR","FOREIGN","FORTRAN","FOUND","FREETEXT","FREETEXTTABLE","FROM","FULL","FUNCTION","GENERATED","GET","GLOB","GLOBAL","GO","GOTO","GRANT","GROUP","GROUPS","HAVING","HOLDLOCK","HOUR","IDENTITY","IDENTITYCOL","IDENTITY_INSERT","IF","IGNORE","IMMEDIATE","IN","INCLUDE","INDEX","INDEXED","INDICATOR","INITIALLY","INNER","INPUT","INSENSITIVE","INSERT","INSTEAD","INT","INTEGER","INTERSECT","INTERVAL","INTO","IS","ISNULL","ISOLATION","JOIN","KEY","KILL","LANGUAGE","LAST","LEADING","LEFT","LEVEL","LIKE","LIMIT","LINENO","LOAD","LOCAL","LOWER","MATCH","MATERIALIZED","MAX","MERGE","MIN","MINUTE","MODULE","MONTH","NAMES","NATIONAL","NATURAL","NCHAR","NEXT","NO","NOCHECK","NONCLUSTERED","NONE","NOT","NOTHING","NOTNULL","NULL","NULLIF","NULLS","NUMERIC","OCTET_LENGTH","OF","OFF","OFFSET","OFFSETS","ON","ONLY","OPEN","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","OPTION","OR","ORDER","OTHERS","OUTER","OUTPUT","OVER","OVERLAPS","PAD","PARTIAL","PARTITION","PASCAL","PERCENT","PIVOT","PLAN","POSITION","PRAGMA","PRECEDING","PRECISION","PREPARE","PRESERVE","PRIMARY","PRINT","PRIOR","PRIVILEGES","PROC","PROCEDURE","PUBLIC","QUERY","RAISE","RAISERROR","RANGE","READ","READTEXT","REAL","RECONFIGURE","RECURSIVE","REFERENCES","REGEXP","REINDEX","RELATIVE","RELEASE","RENAME","REPLACE","REPLICATION","RESTORE","RESTRICT","RETURN","RETURNING","REVERT","REVOKE","RIGHT","ROLLBACK","ROW","ROWCOUNT","ROWGUIDCOL","ROWS","RULE","SAVE","SAVEPOINT","SCHEMA","SCROLL","SECOND","SECTION","SECURITYAUDIT","SELECT","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","SESSION","SESSION_USER","SET","SETUSER","SHUTDOWN","SIZE","SMALLINT","SOME","SPACE","SQL","SQLCA","SQLCODE","SQLERROR","SQLSTATE","SQLWARNING","STATISTICS","SUBSTRING","SUM","SYSTEM_USER","TABLE","TABLESAMPLE","TEMP","TEMPORARY","TEXTSIZE","THEN","TIES","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TOP","TRAILING","TRAN","TRANSACTION","TRANSLATE","TRANSLATION","TRIGGER","TRIM","TRUE","TRUNCATE","TRY_CONVERT","TSEQUAL","UNBOUNDED","UNION","UNIQUE","UNKNOWN","UNPIVOT","UPDATE","UPDATETEXT","UPPER","USAGE","USE","USER","USING","VACUUM","VALUE","VALUES","VARCHAR","VARYING","VIEW","VIRTUAL","WAITFOR","WHEN","WHENEVER","WHERE","WHILE","WINDOW","WITH","WITHIN GROUP","WITHOUT","WORK","WRITE","WRITETEXT","YEAR","ZONE"],operators:["EXCEPT","INTERSECT","UNION","APPLY","CROSS","FULL","INNER","JOIN","LEFT","OUTER","RIGHT","CONTAINS","FREETEXT","IS","NULL","PIVOT","UNPIVOT","MATCHED"],logicalOperators:["ALL","AND","ANY","BETWEEN","EXISTS","IN","LIKE","NOT","OR","SOME"],comparisonOperators:["<>",">","<",">=","<=","=","!=","&","~","^","%"],builtinFunctions:["AVG","CHECKSUM_AGG","COUNT","COUNT_BIG","GROUPING","GROUPING_ID","MAX","MIN","SUM","STDEV","STDEVP","VAR","VARP","CUME_DIST","FIRST_VALUE","LAG","LAST_VALUE","LEAD","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","COLLATE","COLLATIONPROPERTY","TERTIARY_WEIGHTS","FEDERATION_FILTERING_VALUE","CAST","CONVERT","PARSE","TRY_CAST","TRY_CONVERT","TRY_PARSE","ASYMKEY_ID","ASYMKEYPROPERTY","CERTPROPERTY","CERT_ID","CRYPT_GEN_RANDOM","DECRYPTBYASYMKEY","DECRYPTBYCERT","DECRYPTBYKEY","DECRYPTBYKEYAUTOASYMKEY","DECRYPTBYKEYAUTOCERT","DECRYPTBYPASSPHRASE","ENCRYPTBYASYMKEY","ENCRYPTBYCERT","ENCRYPTBYKEY","ENCRYPTBYPASSPHRASE","HASHBYTES","IS_OBJECTSIGNED","KEY_GUID","KEY_ID","KEY_NAME","SIGNBYASYMKEY","SIGNBYCERT","SYMKEYPROPERTY","VERIFYSIGNEDBYCERT","VERIFYSIGNEDBYASYMKEY","CURSOR_STATUS","DATALENGTH","IDENT_CURRENT","IDENT_INCR","IDENT_SEED","IDENTITY","SQL_VARIANT_PROPERTY","CURRENT_TIMESTAMP","DATEADD","DATEDIFF","DATEFROMPARTS","DATENAME","DATEPART","DATETIME2FROMPARTS","DATETIMEFROMPARTS","DATETIMEOFFSETFROMPARTS","DAY","EOMONTH","GETDATE","GETUTCDATE","ISDATE","MONTH","SMALLDATETIMEFROMPARTS","SWITCHOFFSET","SYSDATETIME","SYSDATETIMEOFFSET","SYSUTCDATETIME","TIMEFROMPARTS","TODATETIMEOFFSET","YEAR","CHOOSE","COALESCE","IIF","NULLIF","ABS","ACOS","ASIN","ATAN","ATN2","CEILING","COS","COT","DEGREES","EXP","FLOOR","LOG","LOG10","PI","POWER","RADIANS","RAND","ROUND","SIGN","SIN","SQRT","SQUARE","TAN","APP_NAME","APPLOCK_MODE","APPLOCK_TEST","ASSEMBLYPROPERTY","COL_LENGTH","COL_NAME","COLUMNPROPERTY","DATABASE_PRINCIPAL_ID","DATABASEPROPERTYEX","DB_ID","DB_NAME","FILE_ID","FILE_IDEX","FILE_NAME","FILEGROUP_ID","FILEGROUP_NAME","FILEGROUPPROPERTY","FILEPROPERTY","FULLTEXTCATALOGPROPERTY","FULLTEXTSERVICEPROPERTY","INDEX_COL","INDEXKEY_PROPERTY","INDEXPROPERTY","OBJECT_DEFINITION","OBJECT_ID","OBJECT_NAME","OBJECT_SCHEMA_NAME","OBJECTPROPERTY","OBJECTPROPERTYEX","ORIGINAL_DB_NAME","PARSENAME","SCHEMA_ID","SCHEMA_NAME","SCOPE_IDENTITY","SERVERPROPERTY","STATS_DATE","TYPE_ID","TYPE_NAME","TYPEPROPERTY","DENSE_RANK","NTILE","RANK","ROW_NUMBER","PUBLISHINGSERVERNAME","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","CERTENCODED","CERTPRIVATEKEY","CURRENT_USER","HAS_DBACCESS","HAS_PERMS_BY_NAME","IS_MEMBER","IS_ROLEMEMBER","IS_SRVROLEMEMBER","LOGINPROPERTY","ORIGINAL_LOGIN","PERMISSIONS","PWDENCRYPT","PWDCOMPARE","SESSION_USER","SESSIONPROPERTY","SUSER_ID","SUSER_NAME","SUSER_SID","SUSER_SNAME","SYSTEM_USER","USER","USER_ID","USER_NAME","ASCII","CHAR","CHARINDEX","CONCAT","DIFFERENCE","FORMAT","LEFT","LEN","LOWER","LTRIM","NCHAR","PATINDEX","QUOTENAME","REPLACE","REPLICATE","REVERSE","RIGHT","RTRIM","SOUNDEX","SPACE","STR","STUFF","SUBSTRING","UNICODE","UPPER","BINARY_CHECKSUM","CHECKSUM","CONNECTIONPROPERTY","CONTEXT_INFO","CURRENT_REQUEST_ID","ERROR_LINE","ERROR_NUMBER","ERROR_MESSAGE","ERROR_PROCEDURE","ERROR_SEVERITY","ERROR_STATE","FORMATMESSAGE","GETANSINULL","GET_FILESTREAM_TRANSACTION_CONTEXT","HOST_ID","HOST_NAME","ISNULL","ISNUMERIC","MIN_ACTIVE_ROWVERSION","NEWID","NEWSEQUENTIALID","ROWCOUNT_BIG","XACT_STATE","TEXTPTR","TEXTVALID","COLUMNS_UPDATED","EVENTDATA","TRIGGER_NESTLEVEL","UPDATE","CHANGETABLE","CHANGE_TRACKING_CONTEXT","CHANGE_TRACKING_CURRENT_VERSION","CHANGE_TRACKING_IS_COLUMN_IN_MASK","CHANGE_TRACKING_MIN_VALID_VERSION","CONTAINSTABLE","FREETEXTTABLE","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","FILETABLEROOTPATH","GETFILENAMESPACEPATH","GETPATHLOCATOR","PATHNAME","GET_TRANSMISSION_STATUS"],builtinVariables:["@@DATEFIRST","@@DBTS","@@LANGID","@@LANGUAGE","@@LOCK_TIMEOUT","@@MAX_CONNECTIONS","@@MAX_PRECISION","@@NESTLEVEL","@@OPTIONS","@@REMSERVER","@@SERVERNAME","@@SERVICENAME","@@SPID","@@TEXTSIZE","@@VERSION","@@CURSOR_ROWS","@@FETCH_STATUS","@@DATEFIRST","@@PROCID","@@ERROR","@@IDENTITY","@@ROWCOUNT","@@TRANCOUNT","@@CONNECTIONS","@@CPU_BUSY","@@IDLE","@@IO_BUSY","@@PACKET_ERRORS","@@PACK_RECEIVED","@@PACK_SENT","@@TIMETICKS","@@TOTAL_ERRORS","@@TOTAL_READ","@@TOTAL_WRITE"],pseudoColumns:["$ACTION","$IDENTITY","$ROWGUID","$PARTITION"],tokenizer:{root:[{include:"@templateVariables"},{include:"@macros"},{include:"@comments"},{include:"@whitespace"},{include:"@pseudoColumns"},{include:"@numbers"},{include:"@strings"},{include:"@complexIdentifiers"},{include:"@scopes"},{include:"@schemaTable"},[/[;,.]/,"delimiter"],[/[()]/,"@brackets"],[/[\w@#$|<|>|=|!|%|&|+|\|-|*|/|~|^]+/,{cases:{"@operators":"operator","@comparisonOperators":"operator","@logicalOperators":"operator","@builtinVariables":"predefined","@builtinFunctions":"predefined","@keywords":"keyword","@default":"identifier"}}]],templateVariables:[[/\$[a-zA-Z0-9]+/,"variable"]],macros:[[/\$__[a-zA-Z0-9-_]+/,"type"]],schemaTable:[[/(\w+)\./,"identifier"],[/(\w+\.\w+)/,"identifier"]],whitespace:[[/\s+/,"white"]],comments:[[/--+.*/,"comment"],[/\/\*/,{token:"comment.quote",next:"@comment"}]],comment:[[/[^*/]+/,"comment"],[/\*\//,{token:"comment.quote",next:"@pop"}],[/./,"comment"]],pseudoColumns:[[/[$][A-Za-z_][\w@#$]*/,{cases:{"@pseudoColumns":"predefined","@default":"identifier"}}]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/N'/,{token:"string",next:"@string"}],[/'/,{token:"string",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string",next:"@pop"}]],complexIdentifiers:[[/\[/,{token:"identifier.quote",next:"@bracketedIdentifier"}],[/"/,{token:"identifier.quote",next:"@quotedIdentifier"}]],bracketedIdentifier:[[/[^\]]+/,"identifier"],[/]]/,"identifier"],[/]/,{token:"identifier.quote",next:"@pop"}]],quotedIdentifier:[[/[^"]+/,"identifier"],[/""/,"identifier"],[/"/,{token:"identifier.quote",next:"@pop"}]],scopes:[[/BEGIN\s+(DISTRIBUTED\s+)?TRAN(SACTION)?\b/i,"keyword"],[/BEGIN\s+TRY\b/i,{token:"keyword.try"}],[/END\s+TRY\b/i,{token:"keyword.try"}],[/BEGIN\s+CATCH\b/i,{token:"keyword.catch"}],[/END\s+CATCH\b/i,{token:"keyword.catch"}],[/(BEGIN|CASE)\b/i,{token:"keyword.block"}],[/END\b/i,{token:"keyword.block"}],[/WHEN\b/i,{token:"keyword.choice"}],[/THEN\b/i,{token:"keyword.choice"}]]}}},2863:e=>{var t={animationIterationCount:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridRow:!0,gridColumn:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,stopOpacity:!0,strokeDashoffset:!0,strokeOpacity:!0,strokeWidth:!0};e.exports=function(e,r){return"number"!=typeof r||t[e]?r:r+"px"}},3523:e=>{var t=function(){"use strict";function e(e,t){return null!=t&&e instanceof t}var t,r,n;try{t=Map}catch(e){t=function(){}}try{r=Set}catch(e){r=function(){}}try{n=Promise}catch(e){n=function(){}}function o(i,s,l,u,c){"object"==typeof s&&(l=s.depth,u=s.prototype,c=s.includeNonEnumerable,s=s.circular);var d=[],p=[],f="undefined"!=typeof Buffer;return void 0===s&&(s=!0),void 0===l&&(l=1/0),function i(l,h){if(null===l)return null;if(0===h)return l;var g,v;if("object"!=typeof l)return l;if(e(l,t))g=new t;else if(e(l,r))g=new r;else if(e(l,n))g=new n((function(e,t){l.then((function(t){e(i(t,h-1))}),(function(e){t(i(e,h-1))}))}));else if(o.__isArray(l))g=[];else if(o.__isRegExp(l))g=new RegExp(l.source,a(l)),l.lastIndex&&(g.lastIndex=l.lastIndex);else if(o.__isDate(l))g=new Date(l.getTime());else{if(f&&Buffer.isBuffer(l))return g=Buffer.allocUnsafe?Buffer.allocUnsafe(l.length):new Buffer(l.length),l.copy(g),g;e(l,Error)?g=Object.create(l):void 0===u?(v=Object.getPrototypeOf(l),g=Object.create(v)):(g=Object.create(u),v=u)}if(s){var m=d.indexOf(l);if(-1!=m)return p[m];d.push(l),p.push(g)}for(var y in e(l,t)&&l.forEach((function(e,t){var r=i(t,h-1),n=i(e,h-1);g.set(r,n)})),e(l,r)&&l.forEach((function(e){var t=i(e,h-1);g.add(t)})),l){var b;v&&(b=Object.getOwnPropertyDescriptor(v,y)),b&&null==b.set||(g[y]=i(l[y],h-1))}if(Object.getOwnPropertySymbols){var O=Object.getOwnPropertySymbols(l);for(y=0;y<O.length;y++){var E=O[y];(!(w=Object.getOwnPropertyDescriptor(l,E))||w.enumerable||c)&&(g[E]=i(l[E],h-1),w.enumerable||Object.defineProperty(g,E,{enumerable:!1}))}}if(c){var S=Object.getOwnPropertyNames(l);for(y=0;y<S.length;y++){var w,T=S[y];(w=Object.getOwnPropertyDescriptor(l,T))&&w.enumerable||(g[T]=i(l[T],h-1),Object.defineProperty(g,T,{enumerable:!1}))}}return g}(i,l)}function i(e){return Object.prototype.toString.call(e)}function a(e){var t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),t}return o.clonePrototype=function(e){if(null===e)return null;var t=function(){};return t.prototype=e,new t},o.__objToStr=i,o.__isDate=function(e){return"object"==typeof e&&"[object Date]"===i(e)},o.__isArray=function(e){return"object"==typeof e&&"[object Array]"===i(e)},o.__isRegExp=function(e){return"object"==typeof e&&"[object RegExp]"===i(e)},o.__getRegExpFlags=a,o}();e.exports&&(e.exports=t)},4221:(e,t,r)=>{"use strict";var n=r(1882),o={"text/plain":"Text","text/html":"Url",default:"Text"};e.exports=function(e,t){var r,i,a,s,l,u,c=!1;t||(t={}),r=t.debug||!1;try{if(a=n(),s=document.createRange(),l=document.getSelection(),(u=document.createElement("span")).textContent=e,u.style.all="unset",u.style.position="fixed",u.style.top=0,u.style.clip="rect(0, 0, 0, 0)",u.style.whiteSpace="pre",u.style.webkitUserSelect="text",u.style.MozUserSelect="text",u.style.msUserSelect="text",u.style.userSelect="text",u.addEventListener("copy",(function(n){if(n.stopPropagation(),t.format)if(n.preventDefault(),void 0===n.clipboardData){r&&console.warn("unable to use e.clipboardData"),r&&console.warn("trying IE specific stuff"),window.clipboardData.clearData();var i=o[t.format]||o.default;window.clipboardData.setData(i,e)}else n.clipboardData.clearData(),n.clipboardData.setData(t.format,e);t.onCopy&&(n.preventDefault(),t.onCopy(n.clipboardData))})),document.body.appendChild(u),s.selectNodeContents(u),l.addRange(s),!document.execCommand("copy"))throw new Error("copy command was unsuccessful");c=!0}catch(n){r&&console.error("unable to copy using execCommand: ",n),r&&console.warn("trying IE specific stuff");try{window.clipboardData.setData(t.format||"text",e),t.onCopy&&t.onCopy(window.clipboardData),c=!0}catch(n){r&&console.error("unable to copy using clipboardData: ",n),r&&console.error("falling back to prompt"),i=function(e){var t=(/mac os x/i.test(navigator.userAgent)?"⌘":"Ctrl")+"+C";return e.replace(/#{\s*key\s*}/g,t)}("message"in t?t.message:"Copy to clipboard: #{key}, Enter"),window.prompt(i,e)}}finally{l&&("function"==typeof l.removeRange?l.removeRange(s):l.removeAllRanges()),u&&document.body.removeChild(u),a()}return c}},49:(e,t,r)=>{var n=r(5345),o=r(4882),i={float:"cssFloat"},a=r(2863);function s(e,t,r){var s=i[t];if(void 0===s&&(s=function(e){var t=o(e),r=n(t);return i[t]=i[e]=i[r]=r,r}(t)),s){if(void 0===r)return e.style[s];e.style[s]=a(s,r)}}function l(){2===arguments.length?"string"==typeof arguments[1]?arguments[0].style.cssText=arguments[1]:function(e,t){for(var r in t)t.hasOwnProperty(r)&&s(e,r,t[r])}(arguments[0],arguments[1]):s(arguments[0],arguments[1],arguments[2])}e.exports=l,e.exports.set=l,e.exports.get=function(e,t){return Array.isArray(t)?t.reduce((function(t,r){return t[r]=s(e,r||""),t}),{}):s(e,t||"")}},9083:(e,t,r)=>{var n;!function(){"use strict";var o=!("undefined"==typeof window||!window.document||!window.document.createElement),i={canUseDOM:o,canUseWorkers:"undefined"!=typeof Worker,canUseEventListeners:o&&!(!window.addEventListener&&!window.attachEvent),canUseViewport:o&&!!window.screen};void 0===(n=function(){return i}.call(t,r,t,e))||(e.exports=n)}()},9874:(e,t,r)=>{"use strict";var n=r(300),o={childContextTypes:!0,contextType:!0,contextTypes:!0,defaultProps:!0,displayName:!0,getDefaultProps:!0,getDerivedStateFromError:!0,getDerivedStateFromProps:!0,mixins:!0,propTypes:!0,type:!0},i={name:!0,length:!0,prototype:!0,caller:!0,callee:!0,arguments:!0,arity:!0},a={$$typeof:!0,compare:!0,defaultProps:!0,displayName:!0,propTypes:!0,type:!0},s={};function l(e){return n.isMemo(e)?a:s[e.$$typeof]||o}s[n.ForwardRef]={$$typeof:!0,render:!0,defaultProps:!0,displayName:!0,propTypes:!0},s[n.Memo]=a;var u=Object.defineProperty,c=Object.getOwnPropertyNames,d=Object.getOwnPropertySymbols,p=Object.getOwnPropertyDescriptor,f=Object.getPrototypeOf,h=Object.prototype;e.exports=function e(t,r,n){if("string"!=typeof r){if(h){var o=f(r);o&&o!==h&&e(t,o,n)}var a=c(r);d&&(a=a.concat(d(r)));for(var s=l(t),g=l(r),v=0;v<a.length;++v){var m=a[v];if(!(i[m]||n&&n[m]||g&&g[m]||s&&s[m])){var y=p(r,m);try{u(t,m,y)}catch(e){}}}}return t}},3520:(e,t)=>{"use strict";var r="function"==typeof Symbol&&Symbol.for,n=r?Symbol.for("react.element"):60103,o=r?Symbol.for("react.portal"):60106,i=r?Symbol.for("react.fragment"):60107,a=r?Symbol.for("react.strict_mode"):60108,s=r?Symbol.for("react.profiler"):60114,l=r?Symbol.for("react.provider"):60109,u=r?Symbol.for("react.context"):60110,c=r?Symbol.for("react.async_mode"):60111,d=r?Symbol.for("react.concurrent_mode"):60111,p=r?Symbol.for("react.forward_ref"):60112,f=r?Symbol.for("react.suspense"):60113,h=r?Symbol.for("react.suspense_list"):60120,g=r?Symbol.for("react.memo"):60115,v=r?Symbol.for("react.lazy"):60116,m=r?Symbol.for("react.block"):60121,y=r?Symbol.for("react.fundamental"):60117,b=r?Symbol.for("react.responder"):60118,O=r?Symbol.for("react.scope"):60119;function E(e){if("object"==typeof e&&null!==e){var t=e.$$typeof;switch(t){case n:switch(e=e.type){case c:case d:case i:case s:case a:case f:return e;default:switch(e=e&&e.$$typeof){case u:case p:case v:case g:case l:return e;default:return t}}case o:return t}}}function S(e){return E(e)===d}t.AsyncMode=c,t.ConcurrentMode=d,t.ContextConsumer=u,t.ContextProvider=l,t.Element=n,t.ForwardRef=p,t.Fragment=i,t.Lazy=v,t.Memo=g,t.Portal=o,t.Profiler=s,t.StrictMode=a,t.Suspense=f,t.isAsyncMode=function(e){return S(e)||E(e)===c},t.isConcurrentMode=S,t.isContextConsumer=function(e){return E(e)===u},t.isContextProvider=function(e){return E(e)===l},t.isElement=function(e){return"object"==typeof e&&null!==e&&e.$$typeof===n},t.isForwardRef=function(e){return E(e)===p},t.isFragment=function(e){return E(e)===i},t.isLazy=function(e){return E(e)===v},t.isMemo=function(e){return E(e)===g},t.isPortal=function(e){return E(e)===o},t.isProfiler=function(e){return E(e)===s},t.isStrictMode=function(e){return E(e)===a},t.isSuspense=function(e){return E(e)===f},t.isValidElementType=function(e){return"string"==typeof e||"function"==typeof e||e===i||e===d||e===s||e===a||e===f||e===h||"object"==typeof e&&null!==e&&(e.$$typeof===v||e.$$typeof===g||e.$$typeof===l||e.$$typeof===u||e.$$typeof===p||e.$$typeof===y||e.$$typeof===b||e.$$typeof===O||e.$$typeof===m)},t.typeOf=E},300:(e,t,r)=>{"use strict";e.exports=r(3520)},502:function(e,t,r){var n,o;n=function(){"use strict";Array.isArray||(Array.isArray=function(e){return"[object Array]"===Object.prototype.toString.call(e)});var e={},t={"==":function(e,t){return e==t},"===":function(e,t){return e===t},"!=":function(e,t){return e!=t},"!==":function(e,t){return e!==t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},"<":function(e,t,r){return void 0===r?e<t:e<t&&t<r},"<=":function(e,t,r){return void 0===r?e<=t:e<=t&&t<=r},"!!":function(t){return e.truthy(t)},"!":function(t){return!e.truthy(t)},"%":function(e,t){return e%t},log:function(e){return console.log(e),e},in:function(e,t){return!(!t||void 0===t.indexOf)&&-1!==t.indexOf(e)},cat:function(){return Array.prototype.join.call(arguments,"")},substr:function(e,t,r){if(r<0){var n=String(e).substr(t);return n.substr(0,n.length+r)}return String(e).substr(t,r)},"+":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)+parseFloat(t,10)}),0)},"*":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)*parseFloat(t,10)}))},"-":function(e,t){return void 0===t?-e:e-t},"/":function(e,t){return e/t},min:function(){return Math.min.apply(this,arguments)},max:function(){return Math.max.apply(this,arguments)},merge:function(){return Array.prototype.reduce.call(arguments,(function(e,t){return e.concat(t)}),[])},var:function(e,t){var r=void 0===t?null:t,n=this;if(void 0===e||""===e||null===e)return n;for(var o=String(e).split("."),i=0;i<o.length;i++){if(null==n)return r;if(void 0===(n=n[o[i]]))return r}return n},missing:function(){for(var t=[],r=Array.isArray(arguments[0])?arguments[0]:arguments,n=0;n<r.length;n++){var o=r[n],i=e.apply({var:o},this);null!==i&&""!==i||t.push(o)}return t},missing_some:function(t,r){var n=e.apply({missing:r},this);return r.length-n.length>=t?[]:n}};return e.is_logic=function(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length},e.truthy=function(e){return!(Array.isArray(e)&&0===e.length||!e)},e.get_operator=function(e){return Object.keys(e)[0]},e.get_values=function(t){return t[e.get_operator(t)]},e.apply=function(r,n){if(Array.isArray(r))return r.map((function(t){return e.apply(t,n)}));if(!e.is_logic(r))return r;var o,i,a,s,l,u=e.get_operator(r),c=r[u];if(Array.isArray(c)||(c=[c]),"if"===u||"?:"==u){for(o=0;o<c.length-1;o+=2)if(e.truthy(e.apply(c[o],n)))return e.apply(c[o+1],n);return c.length===o+1?e.apply(c[o],n):null}if("and"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),!e.truthy(i))return i;return i}if("or"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),e.truthy(i))return i;return i}if("filter"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.filter((function(t){return e.truthy(e.apply(a,t))})):[];if("map"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.map((function(t){return e.apply(a,t)})):[];if("reduce"===u)return s=e.apply(c[0],n),a=c[1],l=void 0!==c[2]?c[2]:null,Array.isArray(s)?s.reduce((function(t,r){return e.apply(a,{current:r,accumulator:t})}),l):l;if("all"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(!e.truthy(e.apply(a,s[o])))return!1;return!0}if("none"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!0;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!1;return!0}if("some"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!0;return!1}if(c=c.map((function(t){return e.apply(t,n)})),t.hasOwnProperty(u)&&"function"==typeof t[u])return t[u].apply(n,c);if(u.indexOf(".")>0){var d=String(u).split("."),p=t;for(o=0;o<d.length;o++){if(!p.hasOwnProperty(d[o]))throw new Error("Unrecognized operation "+u+" (failed at "+d.slice(0,o+1).join(".")+")");p=p[d[o]]}return p.apply(n,c)}throw new Error("Unrecognized operation "+u)},e.uses_data=function(t){var r=[];if(e.is_logic(t)){var n=e.get_operator(t),o=t[n];Array.isArray(o)||(o=[o]),"var"===n?r.push(o[0]):o.forEach((function(t){r.push.apply(r,e.uses_data(t))}))}return function(e){for(var t=[],r=0,n=e.length;r<n;r++)-1===t.indexOf(e[r])&&t.push(e[r]);return t}(r)},e.add_operation=function(e,r){t[e]=r},e.rm_operation=function(e){delete t[e]},e.rule_like=function(t,r){if(r===t)return!0;if("@"===r)return!0;if("number"===r)return"number"==typeof t;if("string"===r)return"string"==typeof t;if("array"===r)return Array.isArray(t)&&!e.is_logic(t);if(e.is_logic(r)){if(e.is_logic(t)){var n=e.get_operator(r),o=e.get_operator(t);if("@"===n||n===o)return e.rule_like(e.get_values(t,!1),e.get_values(r,!1))}return!1}if(Array.isArray(r)){if(Array.isArray(t)){if(r.length!==t.length)return!1;for(var i=0;i<r.length;i+=1)if(!e.rule_like(t[i],r[i]))return!1;return!0}return!1}return!1},e},void 0===(o=n.call(t,r,t,e))||(e.exports=o)},5948:(e,t,r)=>{var n=r(2062)(r(9965),"DataView");e.exports=n},4845:(e,t,r)=>{var n=r(5504),o=r(5270),i=r(4769),a=r(2637),s=r(1077);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},1999:(e,t,r)=>{var n=r(7718),o=r(4272),i=r(5107),a=r(1055),s=r(4647);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},5455:(e,t,r)=>{var n=r(2062)(r(9965),"Map");e.exports=n},1549:(e,t,r)=>{var n=r(6400),o=r(7014),i=r(1793),a=r(6429),s=r(821);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},6420:(e,t,r)=>{var n=r(2062)(r(9965),"Promise");e.exports=n},2833:(e,t,r)=>{var n=r(2062)(r(9965),"Set");e.exports=n},8283:(e,t,r)=>{var n=r(1549),o=r(228),i=r(3683);function a(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new n;++t<r;)this.add(e[t])}a.prototype.add=a.prototype.push=o,a.prototype.has=i,e.exports=a},8545:(e,t,r)=>{var n=r(1999),o=r(5052),i=r(4250),a=r(4773),s=r(6921),l=r(5745);function u(e){var t=this.__data__=new n(e);this.size=t.size}u.prototype.clear=o,u.prototype.delete=i,u.prototype.get=a,u.prototype.has=s,u.prototype.set=l,e.exports=u},2609:(e,t,r)=>{var n=r(9965).Symbol;e.exports=n},3604:(e,t,r)=>{var n=r(9965).Uint8Array;e.exports=n},8143:(e,t,r)=>{var n=r(2062)(r(9965),"WeakMap");e.exports=n},1929:e=>{e.exports=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}},6433:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n&&!1!==t(e[r],r,e););return e}},9386:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=0,i=[];++r<n;){var a=e[r];t(a,r,e)&&(i[o++]=a)}return i}},6791:(e,t,r)=>{var n=r(2784),o=r(5196),i=r(4913),a=r(4264),s=r(6665),l=r(5087),u=Object.prototype.hasOwnProperty;e.exports=function(e,t){var r=i(e),c=!r&&o(e),d=!r&&!c&&a(e),p=!r&&!c&&!d&&l(e),f=r||c||d||p,h=f?n(e.length,String):[],g=h.length;for(var v in e)!t&&!u.call(e,v)||f&&("length"==v||d&&("offset"==v||"parent"==v)||p&&("buffer"==v||"byteLength"==v||"byteOffset"==v)||s(v,g))||h.push(v);return h}},1428:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}},8256:e=>{e.exports=function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}},9272:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}},237:(e,t,r)=>{var n=r(2464),o=r(6424);e.exports=function(e,t,r){(void 0!==r&&!o(e[t],r)||void 0===r&&!(t in e))&&n(e,t,r)}},8131:(e,t,r)=>{var n=r(2464),o=r(6424),i=Object.prototype.hasOwnProperty;e.exports=function(e,t,r){var a=e[t];i.call(e,t)&&o(a,r)&&(void 0!==r||t in e)||n(e,t,r)}},3481:(e,t,r)=>{var n=r(6424);e.exports=function(e,t){for(var r=e.length;r--;)if(n(e[r][0],t))return r;return-1}},4861:(e,t,r)=>{var n=r(4735),o=r(3790);e.exports=function(e,t){return e&&n(t,o(t),e)}},7838:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e,t){return e&&n(t,o(t),e)}},2464:(e,t,r)=>{var n=r(9611);e.exports=function(e,t,r){"__proto__"==t&&n?n(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}},5725:e=>{e.exports=function(e,t,r){return e==e&&(void 0!==r&&(e=e<=r?e:r),void 0!==t&&(e=e>=t?e:t)),e}},6575:(e,t,r)=>{var n=r(8545),o=r(6433),i=r(8131),a=r(4861),s=r(7838),l=r(8986),u=r(1231),c=r(1711),d=r(1476),p=r(7749),f=r(869),h=r(6053),g=r(509),v=r(1343),m=r(1225),y=r(4913),b=r(4264),O=r(146),E=r(9834),S=r(8696),w=r(3790),T=r(5961),x="[object Arguments]",_="[object Function]",C="[object Object]",R={};R[x]=R["[object Array]"]=R["[object ArrayBuffer]"]=R["[object DataView]"]=R["[object Boolean]"]=R["[object Date]"]=R["[object Float32Array]"]=R["[object Float64Array]"]=R["[object Int8Array]"]=R["[object Int16Array]"]=R["[object Int32Array]"]=R["[object Map]"]=R["[object Number]"]=R[C]=R["[object RegExp]"]=R["[object Set]"]=R["[object String]"]=R["[object Symbol]"]=R["[object Uint8Array]"]=R["[object Uint8ClampedArray]"]=R["[object Uint16Array]"]=R["[object Uint32Array]"]=!0,R["[object Error]"]=R[_]=R["[object WeakMap]"]=!1,e.exports=function e(t,r,I,A,j,P){var L,k=1&r,N=2&r,D=4&r;if(I&&(L=j?I(t,A,j,P):I(t)),void 0!==L)return L;if(!E(t))return t;var F=y(t);if(F){if(L=g(t),!k)return u(t,L)}else{var M=h(t),V=M==_||"[object GeneratorFunction]"==M;if(b(t))return l(t,k);if(M==C||M==x||V&&!j){if(L=N||V?{}:m(t),!k)return N?d(t,s(L,t)):c(t,a(L,t))}else{if(!R[M])return j?t:{};L=v(t,M,k)}}P||(P=new n);var U=P.get(t);if(U)return U;P.set(t,L),S(t)?t.forEach((function(n){L.add(e(n,r,I,n,t,P))})):O(t)&&t.forEach((function(n,o){L.set(o,e(n,r,I,o,t,P))}));var B=F?void 0:(D?N?f:p:N?T:w)(t);return o(B||t,(function(n,o){B&&(n=t[o=n]),i(L,o,e(n,r,I,o,t,P))})),L}},3088:(e,t,r)=>{var n=r(9834),o=Object.create,i=function(){function e(){}return function(t){if(!n(t))return{};if(o)return o(t);e.prototype=t;var r=new e;return e.prototype=void 0,r}}();e.exports=i},3323:e=>{e.exports=function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}},1360:(e,t,r)=>{var n=r(8256),o=r(5043);e.exports=function e(t,r,i,a,s){var l=-1,u=t.length;for(i||(i=o),s||(s=[]);++l<u;){var c=t[l];r>0&&i(c)?r>1?e(c,r-1,i,a,s):n(s,c):a||(s[s.length]=c)}return s}},6057:(e,t,r)=>{var n=r(5845)();e.exports=n},5473:(e,t,r)=>{var n=r(6057),o=r(3790);e.exports=function(e,t){return e&&n(e,t,o)}},2718:(e,t,r)=>{var n=r(2361),o=r(8197);e.exports=function(e,t){for(var r=0,i=(t=n(t,e)).length;null!=e&&r<i;)e=e[o(t[r++])];return r&&r==i?e:void 0}},8359:(e,t,r)=>{var n=r(8256),o=r(4913);e.exports=function(e,t,r){var i=t(e);return o(e)?i:n(i,r(e))}},9048:(e,t,r)=>{var n=r(2609),o=r(2899),i=r(7222),a=n?n.toStringTag:void 0;e.exports=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":a&&a in Object(e)?o(e):i(e)}},3613:e=>{e.exports=function(e,t){return null!=e&&t in Object(e)}},9555:(e,t,r)=>{var n=r(3323),o=r(8967),i=r(5951);e.exports=function(e,t,r){return t==t?i(e,t,r):n(e,o,r)}},3070:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return o(e)&&"[object Arguments]"==n(e)}},590:(e,t,r)=>{var n=r(9132),o=r(9466);e.exports=function e(t,r,i,a,s){return t===r||(null==t||null==r||!o(t)&&!o(r)?t!=t&&r!=r:n(t,r,i,a,e,s))}},9132:(e,t,r)=>{var n=r(8545),o=r(4807),i=r(898),a=r(3409),s=r(6053),l=r(4913),u=r(4264),c=r(5087),d="[object Arguments]",p="[object Array]",f="[object Object]",h=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,g,v,m){var y=l(e),b=l(t),O=y?p:s(e),E=b?p:s(t),S=(O=O==d?f:O)==f,w=(E=E==d?f:E)==f,T=O==E;if(T&&u(e)){if(!u(t))return!1;y=!0,S=!1}if(T&&!S)return m||(m=new n),y||c(e)?o(e,t,r,g,v,m):i(e,t,O,r,g,v,m);if(!(1&r)){var x=S&&h.call(e,"__wrapped__"),_=w&&h.call(t,"__wrapped__");if(x||_){var C=x?e.value():e,R=_?t.value():t;return m||(m=new n),v(C,R,r,g,m)}}return!!T&&(m||(m=new n),a(e,t,r,g,v,m))}},2052:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Map]"==n(e)}},7799:(e,t,r)=>{var n=r(8545),o=r(590);e.exports=function(e,t,r,i){var a=r.length,s=a,l=!i;if(null==e)return!s;for(e=Object(e);a--;){var u=r[a];if(l&&u[2]?u[1]!==e[u[0]]:!(u[0]in e))return!1}for(;++a<s;){var c=(u=r[a])[0],d=e[c],p=u[1];if(l&&u[2]){if(void 0===d&&!(c in e))return!1}else{var f=new n;if(i)var h=i(d,p,c,e,t,f);if(!(void 0===h?o(p,d,3,i,f):h))return!1}}return!0}},8967:e=>{e.exports=function(e){return e!=e}},4363:(e,t,r)=>{var n=r(1866),o=r(3248),i=r(9834),a=r(3761),s=/^\[object .+?Constructor\]$/,l=Function.prototype,u=Object.prototype,c=l.toString,d=u.hasOwnProperty,p=RegExp("^"+c.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=function(e){return!(!i(e)||o(e))&&(n(e)?p:s).test(a(e))}},5206:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Set]"==n(e)}},9653:(e,t,r)=>{var n=r(9048),o=r(582),i=r(9466),a={};a["[object Float32Array]"]=a["[object Float64Array]"]=a["[object Int8Array]"]=a["[object Int16Array]"]=a["[object Int32Array]"]=a["[object Uint8Array]"]=a["[object Uint8ClampedArray]"]=a["[object Uint16Array]"]=a["[object Uint32Array]"]=!0,a["[object Arguments]"]=a["[object Array]"]=a["[object ArrayBuffer]"]=a["[object Boolean]"]=a["[object DataView]"]=a["[object Date]"]=a["[object Error]"]=a["[object Function]"]=a["[object Map]"]=a["[object Number]"]=a["[object Object]"]=a["[object RegExp]"]=a["[object Set]"]=a["[object String]"]=a["[object WeakMap]"]=!1,e.exports=function(e){return i(e)&&o(e.length)&&!!a[n(e)]}},3245:(e,t,r)=>{var n=r(8271),o=r(4458),i=r(912),a=r(4913),s=r(6711);e.exports=function(e){return"function"==typeof e?e:null==e?i:"object"==typeof e?a(e)?o(e[0],e[1]):n(e):s(e)}},6504:(e,t,r)=>{var n=r(5735),o=r(9458),i=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return o(e);var t=[];for(var r in Object(e))i.call(e,r)&&"constructor"!=r&&t.push(r);return t}},9399:(e,t,r)=>{var n=r(9834),o=r(5735),i=r(2693),a=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return i(e);var t=o(e),r=[];for(var s in e)("constructor"!=s||!t&&a.call(e,s))&&r.push(s);return r}},8271:(e,t,r)=>{var n=r(7799),o=r(520),i=r(7405);e.exports=function(e){var t=o(e);return 1==t.length&&t[0][2]?i(t[0][0],t[0][1]):function(r){return r===e||n(r,e,t)}}},4458:(e,t,r)=>{var n=r(590),o=r(5612),i=r(4055),a=r(6394),s=r(2308),l=r(7405),u=r(8197);e.exports=function(e,t){return a(e)&&s(t)?l(u(e),t):function(r){var a=o(r,e);return void 0===a&&a===t?i(r,e):n(t,a,3)}}},9058:(e,t,r)=>{var n=r(8545),o=r(237),i=r(6057),a=r(8120),s=r(9834),l=r(5961),u=r(4302);e.exports=function e(t,r,c,d,p){t!==r&&i(r,(function(i,l){if(p||(p=new n),s(i))a(t,r,l,c,e,d,p);else{var f=d?d(u(t,l),i,l+"",t,r,p):void 0;void 0===f&&(f=i),o(t,l,f)}}),l)}},8120:(e,t,r)=>{var n=r(237),o=r(8986),i=r(7961),a=r(1231),s=r(1225),l=r(5196),u=r(4913),c=r(7965),d=r(4264),p=r(1866),f=r(9834),h=r(5219),g=r(5087),v=r(4302),m=r(5148);e.exports=function(e,t,r,y,b,O,E){var S=v(e,r),w=v(t,r),T=E.get(w);if(T)n(e,r,T);else{var x=O?O(S,w,r+"",e,t,E):void 0,_=void 0===x;if(_){var C=u(w),R=!C&&d(w),I=!C&&!R&&g(w);x=w,C||R||I?u(S)?x=S:c(S)?x=a(S):R?(_=!1,x=o(w,!0)):I?(_=!1,x=i(w,!0)):x=[]:h(w)||l(w)?(x=S,l(S)?x=m(S):f(S)&&!p(S)||(x=s(w))):_=!1}_&&(E.set(w,x),b(x,w,y,O,E),E.delete(w)),n(e,r,x)}}},1:(e,t,r)=>{var n=r(9916),o=r(4055);e.exports=function(e,t){return n(e,t,(function(t,r){return o(e,r)}))}},9916:(e,t,r)=>{var n=r(2718),o=r(3746),i=r(2361);e.exports=function(e,t,r){for(var a=-1,s=t.length,l={};++a<s;){var u=t[a],c=n(e,u);r(c,u)&&o(l,i(u,e),c)}return l}},645:e=>{e.exports=function(e){return function(t){return null==t?void 0:t[e]}}},5319:(e,t,r)=>{var n=r(2718);e.exports=function(e){return function(t){return n(t,e)}}},9383:e=>{var t=Math.ceil,r=Math.max;e.exports=function(e,n,o,i){for(var a=-1,s=r(t((n-e)/(o||1)),0),l=Array(s);s--;)l[i?s:++a]=e,e+=o;return l}},1459:e=>{var t=Math.floor;e.exports=function(e,r){var n="";if(!e||r<1||r>9007199254740991)return n;do{r%2&&(n+=e),(r=t(r/2))&&(e+=e)}while(r);return n}},1110:(e,t,r)=>{var n=r(912),o=r(3090),i=r(7281);e.exports=function(e,t){return i(o(e,t,n),e+"")}},3746:(e,t,r)=>{var n=r(8131),o=r(2361),i=r(6665),a=r(9834),s=r(8197);e.exports=function(e,t,r,l){if(!a(e))return e;for(var u=-1,c=(t=o(t,e)).length,d=c-1,p=e;null!=p&&++u<c;){var f=s(t[u]),h=r;if("__proto__"===f||"constructor"===f||"prototype"===f)return e;if(u!=d){var g=p[f];void 0===(h=l?l(g,f,p):void 0)&&(h=a(g)?g:i(t[u+1])?[]:{})}n(p,f,h),p=p[f]}return e}},4450:(e,t,r)=>{var n=r(6534),o=r(9611),i=r(912),a=o?function(e,t){return o(e,"toString",{configurable:!0,enumerable:!1,value:n(t),writable:!0})}:i;e.exports=a},312:e=>{e.exports=function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}},2784:e=>{e.exports=function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}},9764:(e,t,r)=>{var n=r(2609),o=r(1428),i=r(4913),a=r(7386),s=n?n.prototype:void 0,l=s?s.toString:void 0;e.exports=function e(t){if("string"==typeof t)return t;if(i(t))return o(t,e)+"";if(a(t))return l?l.call(t):"";var r=t+"";return"0"==r&&1/t==-1/0?"-0":r}},7248:(e,t,r)=>{var n=r(1272),o=/^\s+/;e.exports=function(e){return e?e.slice(0,n(e)+1).replace(o,""):e}},277:e=>{e.exports=function(e){return function(t){return e(t)}}},6744:(e,t,r)=>{var n=r(2361),o=r(8906),i=r(2473),a=r(8197);e.exports=function(e,t){return t=n(t,e),null==(e=i(e,t))||delete e[a(o(t))]}},1282:(e,t,r)=>{var n=r(1428);e.exports=function(e,t){return n(t,(function(t){return e[t]}))}},3840:e=>{e.exports=function(e,t){return e.has(t)}},2361:(e,t,r)=>{var n=r(4913),o=r(6394),i=r(266),a=r(3158);e.exports=function(e,t){return n(e)?e:o(e,t)?[e]:i(a(e))}},2511:(e,t,r)=>{var n=r(3604);e.exports=function(e){var t=new e.constructor(e.byteLength);return new n(t).set(new n(e)),t}},8986:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o?n.Buffer:void 0,s=a?a.allocUnsafe:void 0;e.exports=function(e,t){if(t)return e.slice();var r=e.length,n=s?s(r):new e.constructor(r);return e.copy(n),n}},3081:(e,t,r)=>{var n=r(2511);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}},6945:e=>{var t=/\w*$/;e.exports=function(e){var r=new e.constructor(e.source,t.exec(e));return r.lastIndex=e.lastIndex,r}},6952:(e,t,r)=>{var n=r(2609),o=n?n.prototype:void 0,i=o?o.valueOf:void 0;e.exports=function(e){return i?Object(i.call(e)):{}}},7961:(e,t,r)=>{var n=r(2511);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}},1231:e=>{e.exports=function(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}},4735:(e,t,r)=>{var n=r(8131),o=r(2464);e.exports=function(e,t,r,i){var a=!r;r||(r={});for(var s=-1,l=t.length;++s<l;){var u=t[s],c=i?i(r[u],e[u],u,r,e):void 0;void 0===c&&(c=e[u]),a?o(r,u,c):n(r,u,c)}return r}},1711:(e,t,r)=>{var n=r(4735),o=r(6600);e.exports=function(e,t){return n(e,o(e),t)}},1476:(e,t,r)=>{var n=r(4735),o=r(8455);e.exports=function(e,t){return n(e,o(e),t)}},2489:(e,t,r)=>{var n=r(9965)["__core-js_shared__"];e.exports=n},9511:(e,t,r)=>{var n=r(1110),o=r(3632);e.exports=function(e){return n((function(t,r){var n=-1,i=r.length,a=i>1?r[i-1]:void 0,s=i>2?r[2]:void 0;for(a=e.length>3&&"function"==typeof a?(i--,a):void 0,s&&o(r[0],r[1],s)&&(a=i<3?void 0:a,i=1),t=Object(t);++n<i;){var l=r[n];l&&e(t,l,n,a)}return t}))}},5845:e=>{e.exports=function(e){return function(t,r,n){for(var o=-1,i=Object(t),a=n(t),s=a.length;s--;){var l=a[e?s:++o];if(!1===r(i[l],l,i))break}return t}}},8580:(e,t,r)=>{var n=r(9383),o=r(3632),i=r(1144);e.exports=function(e){return function(t,r,a){return a&&"number"!=typeof a&&o(t,r,a)&&(r=a=void 0),t=i(t),void 0===r?(r=t,t=0):r=i(r),a=void 0===a?t<r?1:-1:i(a),n(t,r,a,e)}}},2050:(e,t,r)=>{var n=r(5219);e.exports=function(e){return n(e)?void 0:e}},9611:(e,t,r)=>{var n=r(2062),o=function(){try{var e=n(Object,"defineProperty");return e({},"",{}),e}catch(e){}}();e.exports=o},4807:(e,t,r)=>{var n=r(8283),o=r(9272),i=r(3840);e.exports=function(e,t,r,a,s,l){var u=1&r,c=e.length,d=t.length;if(c!=d&&!(u&&d>c))return!1;var p=l.get(e),f=l.get(t);if(p&&f)return p==t&&f==e;var h=-1,g=!0,v=2&r?new n:void 0;for(l.set(e,t),l.set(t,e);++h<c;){var m=e[h],y=t[h];if(a)var b=u?a(y,m,h,t,e,l):a(m,y,h,e,t,l);if(void 0!==b){if(b)continue;g=!1;break}if(v){if(!o(t,(function(e,t){if(!i(v,t)&&(m===e||s(m,e,r,a,l)))return v.push(t)}))){g=!1;break}}else if(m!==y&&!s(m,y,r,a,l)){g=!1;break}}return l.delete(e),l.delete(t),g}},898:(e,t,r)=>{var n=r(2609),o=r(3604),i=r(6424),a=r(4807),s=r(9885),l=r(6295),u=n?n.prototype:void 0,c=u?u.valueOf:void 0;e.exports=function(e,t,r,n,u,d,p){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new o(e),new o(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return i(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var f=s;case"[object Set]":var h=1&n;if(f||(f=l),e.size!=t.size&&!h)return!1;var g=p.get(e);if(g)return g==t;n|=2,p.set(e,t);var v=a(f(e),f(t),n,u,d,p);return p.delete(e),v;case"[object Symbol]":if(c)return c.call(e)==c.call(t)}return!1}},3409:(e,t,r)=>{var n=r(7749),o=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,i,a,s){var l=1&r,u=n(e),c=u.length;if(c!=n(t).length&&!l)return!1;for(var d=c;d--;){var p=u[d];if(!(l?p in t:o.call(t,p)))return!1}var f=s.get(e),h=s.get(t);if(f&&h)return f==t&&h==e;var g=!0;s.set(e,t),s.set(t,e);for(var v=l;++d<c;){var m=e[p=u[d]],y=t[p];if(i)var b=l?i(y,m,p,t,e,s):i(m,y,p,e,t,s);if(!(void 0===b?m===y||a(m,y,r,i,s):b)){g=!1;break}v||(v="constructor"==p)}if(g&&!v){var O=e.constructor,E=t.constructor;O==E||!("constructor"in e)||!("constructor"in t)||"function"==typeof O&&O instanceof O&&"function"==typeof E&&E instanceof E||(g=!1)}return s.delete(e),s.delete(t),g}},8496:(e,t,r)=>{var n=r(9234),o=r(3090),i=r(7281);e.exports=function(e){return i(o(e,void 0,n),e+"")}},6392:(e,t,r)=>{var n="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g;e.exports=n},7749:(e,t,r)=>{var n=r(8359),o=r(6600),i=r(3790);e.exports=function(e){return n(e,i,o)}},869:(e,t,r)=>{var n=r(8359),o=r(8455),i=r(5961);e.exports=function(e){return n(e,i,o)}},3707:(e,t,r)=>{var n=r(9178);e.exports=function(e,t){var r=e.__data__;return n(t)?r["string"==typeof t?"string":"hash"]:r.map}},520:(e,t,r)=>{var n=r(2308),o=r(3790);e.exports=function(e){for(var t=o(e),r=t.length;r--;){var i=t[r],a=e[i];t[r]=[i,a,n(a)]}return t}},2062:(e,t,r)=>{var n=r(4363),o=r(5240);e.exports=function(e,t){var r=o(e,t);return n(r)?r:void 0}},6607:(e,t,r)=>{var n=r(8303)(Object.getPrototypeOf,Object);e.exports=n},2899:(e,t,r)=>{var n=r(2609),o=Object.prototype,i=o.hasOwnProperty,a=o.toString,s=n?n.toStringTag:void 0;e.exports=function(e){var t=i.call(e,s),r=e[s];try{e[s]=void 0;var n=!0}catch(e){}var o=a.call(e);return n&&(t?e[s]=r:delete e[s]),o}},6600:(e,t,r)=>{var n=r(9386),o=r(8721),i=Object.prototype.propertyIsEnumerable,a=Object.getOwnPropertySymbols,s=a?function(e){return null==e?[]:(e=Object(e),n(a(e),(function(t){return i.call(e,t)})))}:o;e.exports=s},8455:(e,t,r)=>{var n=r(8256),o=r(6607),i=r(6600),a=r(8721),s=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)n(t,i(e)),e=o(e);return t}:a;e.exports=s},6053:(e,t,r)=>{var n=r(5948),o=r(5455),i=r(6420),a=r(2833),s=r(8143),l=r(9048),u=r(3761),c="[object Map]",d="[object Promise]",p="[object Set]",f="[object WeakMap]",h="[object DataView]",g=u(n),v=u(o),m=u(i),y=u(a),b=u(s),O=l;(n&&O(new n(new ArrayBuffer(1)))!=h||o&&O(new o)!=c||i&&O(i.resolve())!=d||a&&O(new a)!=p||s&&O(new s)!=f)&&(O=function(e){var t=l(e),r="[object Object]"==t?e.constructor:void 0,n=r?u(r):"";if(n)switch(n){case g:return h;case v:return c;case m:return d;case y:return p;case b:return f}return t}),e.exports=O},5240:e=>{e.exports=function(e,t){return null==e?void 0:e[t]}},1518:(e,t,r)=>{var n=r(2361),o=r(5196),i=r(4913),a=r(6665),s=r(582),l=r(8197);e.exports=function(e,t,r){for(var u=-1,c=(t=n(t,e)).length,d=!1;++u<c;){var p=l(t[u]);if(!(d=null!=e&&r(e,p)))break;e=e[p]}return d||++u!=c?d:!!(c=null==e?0:e.length)&&s(c)&&a(p,c)&&(i(e)||o(e))}},5504:(e,t,r)=>{var n=r(8034);e.exports=function(){this.__data__=n?n(null):{},this.size=0}},5270:e=>{e.exports=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}},4769:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;if(n){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return o.call(t,e)?t[e]:void 0}},2637:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;return n?void 0!==t[e]:o.call(t,e)}},1077:(e,t,r)=>{var n=r(8034);e.exports=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=n&&void 0===t?"__lodash_hash_undefined__":t,this}},509:e=>{var t=Object.prototype.hasOwnProperty;e.exports=function(e){var r=e.length,n=new e.constructor(r);return r&&"string"==typeof e[0]&&t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}},1343:(e,t,r)=>{var n=r(2511),o=r(3081),i=r(6945),a=r(6952),s=r(7961);e.exports=function(e,t,r){var l=e.constructor;switch(t){case"[object ArrayBuffer]":return n(e);case"[object Boolean]":case"[object Date]":return new l(+e);case"[object DataView]":return o(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return s(e,r);case"[object Map]":case"[object Set]":return new l;case"[object Number]":case"[object String]":return new l(e);case"[object RegExp]":return i(e);case"[object Symbol]":return a(e)}}},1225:(e,t,r)=>{var n=r(3088),o=r(6607),i=r(5735);e.exports=function(e){return"function"!=typeof e.constructor||i(e)?{}:n(o(e))}},5043:(e,t,r)=>{var n=r(2609),o=r(5196),i=r(4913),a=n?n.isConcatSpreadable:void 0;e.exports=function(e){return i(e)||o(e)||!!(a&&e&&e[a])}},6665:e=>{var t=/^(?:0|[1-9]\d*)$/;e.exports=function(e,r){var n=typeof e;return!!(r=null==r?9007199254740991:r)&&("number"==n||"symbol"!=n&&t.test(e))&&e>-1&&e%1==0&&e<r}},3632:(e,t,r)=>{var n=r(6424),o=r(7134),i=r(6665),a=r(9834);e.exports=function(e,t,r){if(!a(r))return!1;var s=typeof t;return!!("number"==s?o(r)&&i(t,r.length):"string"==s&&t in r)&&n(r[t],e)}},6394:(e,t,r)=>{var n=r(4913),o=r(7386),i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;e.exports=function(e,t){if(n(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!o(e))||a.test(e)||!i.test(e)||null!=t&&e in Object(t)}},9178:e=>{e.exports=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}},3248:(e,t,r)=>{var n,o=r(2489),i=(n=/[^.]+$/.exec(o&&o.keys&&o.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"";e.exports=function(e){return!!i&&i in e}},5735:e=>{var t=Object.prototype;e.exports=function(e){var r=e&&e.constructor;return e===("function"==typeof r&&r.prototype||t)}},2308:(e,t,r)=>{var n=r(9834);e.exports=function(e){return e==e&&!n(e)}},7718:e=>{e.exports=function(){this.__data__=[],this.size=0}},4272:(e,t,r)=>{var n=r(3481),o=Array.prototype.splice;e.exports=function(e){var t=this.__data__,r=n(t,e);return!(r<0||(r==t.length-1?t.pop():o.call(t,r,1),--this.size,0))}},5107:(e,t,r)=>{var n=r(3481);e.exports=function(e){var t=this.__data__,r=n(t,e);return r<0?void 0:t[r][1]}},1055:(e,t,r)=>{var n=r(3481);e.exports=function(e){return n(this.__data__,e)>-1}},4647:(e,t,r)=>{var n=r(3481);e.exports=function(e,t){var r=this.__data__,o=n(r,e);return o<0?(++this.size,r.push([e,t])):r[o][1]=t,this}},6400:(e,t,r)=>{var n=r(4845),o=r(1999),i=r(5455);e.exports=function(){this.size=0,this.__data__={hash:new n,map:new(i||o),string:new n}}},7014:(e,t,r)=>{var n=r(3707);e.exports=function(e){var t=n(this,e).delete(e);return this.size-=t?1:0,t}},1793:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).get(e)}},6429:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).has(e)}},821:(e,t,r)=>{var n=r(3707);e.exports=function(e,t){var r=n(this,e),o=r.size;return r.set(e,t),this.size+=r.size==o?0:1,this}},9885:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}},7405:e=>{e.exports=function(e,t){return function(r){return null!=r&&r[e]===t&&(void 0!==t||e in Object(r))}}},2848:(e,t,r)=>{var n=r(3272);e.exports=function(e){var t=n(e,(function(e){return 500===r.size&&r.clear(),e})),r=t.cache;return t}},8034:(e,t,r)=>{var n=r(2062)(Object,"create");e.exports=n},9458:(e,t,r)=>{var n=r(8303)(Object.keys,Object);e.exports=n},2693:e=>{e.exports=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t}},1977:(e,t,r)=>{e=r.nmd(e);var n=r(6392),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o&&n.process,s=function(){try{return i&&i.require&&i.require("util").types||a&&a.binding&&a.binding("util")}catch(e){}}();e.exports=s},7222:e=>{var t=Object.prototype.toString;e.exports=function(e){return t.call(e)}},8303:e=>{e.exports=function(e,t){return function(r){return e(t(r))}}},3090:(e,t,r)=>{var n=r(1929),o=Math.max;e.exports=function(e,t,r){return t=o(void 0===t?e.length-1:t,0),function(){for(var i=arguments,a=-1,s=o(i.length-t,0),l=Array(s);++a<s;)l[a]=i[t+a];a=-1;for(var u=Array(t+1);++a<t;)u[a]=i[a];return u[t]=r(l),n(e,this,u)}}},2473:(e,t,r)=>{var n=r(2718),o=r(312);e.exports=function(e,t){return t.length<2?e:n(e,o(t,0,-1))}},9965:(e,t,r)=>{var n=r(6392),o="object"==typeof self&&self&&self.Object===Object&&self,i=n||o||Function("return this")();e.exports=i},4302:e=>{e.exports=function(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}},228:e=>{e.exports=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}},3683:e=>{e.exports=function(e){return this.__data__.has(e)}},6295:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}},7281:(e,t,r)=>{var n=r(4450),o=r(435)(n);e.exports=o},435:e=>{var t=Date.now;e.exports=function(e){var r=0,n=0;return function(){var o=t(),i=16-(o-n);if(n=o,i>0){if(++r>=800)return arguments[0]}else r=0;return e.apply(void 0,arguments)}}},5052:(e,t,r)=>{var n=r(1999);e.exports=function(){this.__data__=new n,this.size=0}},4250:e=>{e.exports=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}},4773:e=>{e.exports=function(e){return this.__data__.get(e)}},6921:e=>{e.exports=function(e){return this.__data__.has(e)}},5745:(e,t,r)=>{var n=r(1999),o=r(5455),i=r(1549);e.exports=function(e,t){var r=this.__data__;if(r instanceof n){var a=r.__data__;if(!o||a.length<199)return a.push([e,t]),this.size=++r.size,this;r=this.__data__=new i(a)}return r.set(e,t),this.size=r.size,this}},5951:e=>{e.exports=function(e,t,r){for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}},266:(e,t,r)=>{var n=r(2848),o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,i=/\\(\\)?/g,a=n((function(e){var t=[];return 46===e.charCodeAt(0)&&t.push(""),e.replace(o,(function(e,r,n,o){t.push(n?o.replace(i,"$1"):r||e)})),t}));e.exports=a},8197:(e,t,r)=>{var n=r(7386);e.exports=function(e){if("string"==typeof e||n(e))return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}},3761:e=>{var t=Function.prototype.toString;e.exports=function(e){if(null!=e){try{return t.call(e)}catch(e){}try{return e+""}catch(e){}}return""}},1272:e=>{var t=/\s/;e.exports=function(e){for(var r=e.length;r--&&t.test(e.charAt(r)););return r}},6534:e=>{e.exports=function(e){return function(){return e}}},9517:(e,t,r)=>{var n=r(9834),o=r(2220),i=r(3662),a=Math.max,s=Math.min;e.exports=function(e,t,r){var l,u,c,d,p,f,h=0,g=!1,v=!1,m=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function y(t){var r=l,n=u;return l=u=void 0,h=t,d=e.apply(n,r)}function b(e){var r=e-f;return void 0===f||r>=t||r<0||v&&e-h>=c}function O(){var e=o();if(b(e))return E(e);p=setTimeout(O,function(e){var r=t-(e-f);return v?s(r,c-(e-h)):r}(e))}function E(e){return p=void 0,m&&l?y(e):(l=u=void 0,d)}function S(){var e=o(),r=b(e);if(l=arguments,u=this,f=e,r){if(void 0===p)return function(e){return h=e,p=setTimeout(O,t),g?y(e):d}(f);if(v)return clearTimeout(p),p=setTimeout(O,t),y(f)}return void 0===p&&(p=setTimeout(O,t)),d}return t=i(t)||0,n(r)&&(g=!!r.leading,c=(v="maxWait"in r)?a(i(r.maxWait)||0,t):c,m="trailing"in r?!!r.trailing:m),S.cancel=function(){void 0!==p&&clearTimeout(p),h=0,l=f=u=p=void 0},S.flush=function(){return void 0===p?d:E(o())},S}},6424:e=>{e.exports=function(e,t){return e===t||e!=e&&t!=t}},8472:(e,t,r)=>{var n=r(3158),o=/[\\^$.*+?()[\]{}|]/g,i=RegExp(o.source);e.exports=function(e){return(e=n(e))&&i.test(e)?e.replace(o,"\\$&"):e}},9234:(e,t,r)=>{var n=r(1360);e.exports=function(e){return null!=e&&e.length?n(e,1):[]}},5612:(e,t,r)=>{var n=r(2718);e.exports=function(e,t,r){var o=null==e?void 0:n(e,t);return void 0===o?r:o}},4055:(e,t,r)=>{var n=r(3613),o=r(1518);e.exports=function(e,t){return null!=e&&o(e,t,n)}},912:e=>{e.exports=function(e){return e}},1283:(e,t,r)=>{var n=r(9555),o=r(7134),i=r(8951),a=r(5729),s=r(1624),l=Math.max;e.exports=function(e,t,r,u){e=o(e)?e:s(e),r=r&&!u?a(r):0;var c=e.length;return r<0&&(r=l(c+r,0)),i(e)?r<=c&&e.indexOf(t,r)>-1:!!c&&n(e,t,r)>-1}},5196:(e,t,r)=>{var n=r(3070),o=r(9466),i=Object.prototype,a=i.hasOwnProperty,s=i.propertyIsEnumerable,l=n(function(){return arguments}())?n:function(e){return o(e)&&a.call(e,"callee")&&!s.call(e,"callee")};e.exports=l},4913:e=>{var t=Array.isArray;e.exports=t},7134:(e,t,r)=>{var n=r(1866),o=r(582);e.exports=function(e){return null!=e&&o(e.length)&&!n(e)}},7965:(e,t,r)=>{var n=r(7134),o=r(9466);e.exports=function(e){return o(e)&&n(e)}},4264:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=r(9375),i=t&&!t.nodeType&&t,a=i&&e&&!e.nodeType&&e,s=a&&a.exports===i?n.Buffer:void 0,l=(s?s.isBuffer:void 0)||o;e.exports=l},7969:(e,t,r)=>{var n=r(6504),o=r(6053),i=r(5196),a=r(4913),s=r(7134),l=r(4264),u=r(5735),c=r(5087),d=Object.prototype.hasOwnProperty;e.exports=function(e){if(null==e)return!0;if(s(e)&&(a(e)||"string"==typeof e||"function"==typeof e.splice||l(e)||c(e)||i(e)))return!e.length;var t=o(e);if("[object Map]"==t||"[object Set]"==t)return!e.size;if(u(e))return!n(e).length;for(var r in e)if(d.call(e,r))return!1;return!0}},1866:(e,t,r)=>{var n=r(9048),o=r(9834);e.exports=function(e){if(!o(e))return!1;var t=n(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}},582:e=>{e.exports=function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}},146:(e,t,r)=>{var n=r(2052),o=r(277),i=r(1977),a=i&&i.isMap,s=a?o(a):n;e.exports=s},9834:e=>{e.exports=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}},9466:e=>{e.exports=function(e){return null!=e&&"object"==typeof e}},5219:(e,t,r)=>{var n=r(9048),o=r(6607),i=r(9466),a=Function.prototype,s=Object.prototype,l=a.toString,u=s.hasOwnProperty,c=l.call(Object);e.exports=function(e){if(!i(e)||"[object Object]"!=n(e))return!1;var t=o(e);if(null===t)return!0;var r=u.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&l.call(r)==c}},8696:(e,t,r)=>{var n=r(5206),o=r(277),i=r(1977),a=i&&i.isSet,s=a?o(a):n;e.exports=s},8951:(e,t,r)=>{var n=r(9048),o=r(4913),i=r(9466);e.exports=function(e){return"string"==typeof e||!o(e)&&i(e)&&"[object String]"==n(e)}},7386:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return"symbol"==typeof e||o(e)&&"[object Symbol]"==n(e)}},5087:(e,t,r)=>{var n=r(9653),o=r(277),i=r(1977),a=i&&i.isTypedArray,s=a?o(a):n;e.exports=s},3790:(e,t,r)=>{var n=r(6791),o=r(6504),i=r(7134);e.exports=function(e){return i(e)?n(e):o(e)}},5961:(e,t,r)=>{var n=r(6791),o=r(9399),i=r(7134);e.exports=function(e){return i(e)?n(e,!0):o(e)}},8906:e=>{e.exports=function(e){var t=null==e?0:e.length;return t?e[t-1]:void 0}},1612:(e,t,r)=>{var n=r(2464),o=r(5473),i=r(3245);e.exports=function(e,t){var r={};return t=i(t,3),o(e,(function(e,o,i){n(r,o,t(e,o,i))})),r}},3272:(e,t,r)=>{var n=r(1549);function o(e,t){if("function"!=typeof e||null!=t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a)||i,a};return r.cache=new(o.Cache||n),r}o.Cache=n,e.exports=o},4308:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r){n(e,t,r)}));e.exports=o},2815:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r,o){n(e,t,r,o)}));e.exports=o},2220:(e,t,r)=>{var n=r(9965);e.exports=function(){return n.Date.now()}},7027:(e,t,r)=>{var n=r(1428),o=r(6575),i=r(6744),a=r(2361),s=r(4735),l=r(2050),u=r(8496),c=r(869),d=u((function(e,t){var r={};if(null==e)return r;var u=!1;t=n(t,(function(t){return t=a(t,e),u||(u=t.length>1),t})),s(e,c(e),r),u&&(r=o(r,7,l));for(var d=t.length;d--;)i(r,t[d]);return r}));e.exports=d},8831:(e,t,r)=>{var n=r(1),o=r(8496)((function(e,t){return null==e?{}:n(e,t)}));e.exports=o},350:(e,t,r)=>{var n=r(1428),o=r(3245),i=r(9916),a=r(869);e.exports=function(e,t){if(null==e)return{};var r=n(a(e),(function(e){return[e]}));return t=o(t),i(e,r,(function(e,r){return t(e,r[0])}))}},6711:(e,t,r)=>{var n=r(645),o=r(5319),i=r(6394),a=r(8197);e.exports=function(e){return i(e)?n(a(e)):o(e)}},2285:(e,t,r)=>{var n=r(8580)();e.exports=n},9901:(e,t,r)=>{var n=r(1459),o=r(3632),i=r(5729),a=r(3158);e.exports=function(e,t,r){return t=(r?o(e,t,r):void 0===t)?1:i(t),n(a(e),t)}},3547:(e,t,r)=>{var n=r(5725),o=r(9764),i=r(5729),a=r(3158);e.exports=function(e,t,r){return e=a(e),r=null==r?0:n(i(r),0,e.length),t=o(t),e.slice(r,r+t.length)==t}},8721:e=>{e.exports=function(){return[]}},9375:e=>{e.exports=function(){return!1}},1144:(e,t,r)=>{var n=r(3662),o=1/0;e.exports=function(e){return e?(e=n(e))===o||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:0===e?e:0}},5729:(e,t,r)=>{var n=r(1144);e.exports=function(e){var t=n(e),r=t%1;return t==t?r?t-r:t:0}},3662:(e,t,r)=>{var n=r(7248),o=r(9834),i=r(7386),a=/^[-+]0x[0-9a-f]+$/i,s=/^0b[01]+$/i,l=/^0o[0-7]+$/i,u=parseInt;e.exports=function(e){if("number"==typeof e)return e;if(i(e))return NaN;if(o(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=o(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=n(e);var r=s.test(e);return r||l.test(e)?u(e.slice(2),r?2:8):a.test(e)?NaN:+e}},5148:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e){return n(e,o(e))}},3158:(e,t,r)=>{var n=r(9764);e.exports=function(e){return null==e?"":n(e)}},1624:(e,t,r)=>{var n=r(1282),o=r(3790);e.exports=function(e){return null==e?[]:n(e,o(e))}},857:function(e){e.exports=function(){"use strict";var e={isEqual:!0,isMatchingKey:!0,isPromise:!0,maxSize:!0,onCacheAdd:!0,onCacheChange:!0,onCacheHit:!0,transformKey:!0},t=Array.prototype.slice;function r(e){var r=e.length;return r?1===r?[e[0]]:2===r?[e[0],e[1]]:3===r?[e[0],e[1],e[2]]:t.call(e,0):[]}function n(e,t){return e===t||e!=e&&t!=t}function o(e,t){var r={};for(var n in e)r[n]=e[n];for(var n in t)r[n]=t[n];return r}var i=function(){function e(e){this.keys=[],this.values=[],this.options=e;var t="function"==typeof e.isMatchingKey;t?this.getKeyIndex=this._getKeyIndexFromMatchingKey:e.maxSize>1?this.getKeyIndex=this._getKeyIndexForMany:this.getKeyIndex=this._getKeyIndexForSingle,this.canTransformKey="function"==typeof e.transformKey,this.shouldCloneArguments=this.canTransformKey||t,this.shouldUpdateOnAdd="function"==typeof e.onCacheAdd,this.shouldUpdateOnChange="function"==typeof e.onCacheChange,this.shouldUpdateOnHit="function"==typeof e.onCacheHit}return Object.defineProperty(e.prototype,"size",{get:function(){return this.keys.length},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"snapshot",{get:function(){return{keys:r(this.keys),size:this.size,values:r(this.values)}},enumerable:!1,configurable:!0}),e.prototype._getKeyIndexFromMatchingKey=function(e){var t=this.options,r=t.isMatchingKey,n=t.maxSize,o=this.keys,i=o.length;if(!i)return-1;if(r(o[0],e))return 0;if(n>1)for(var a=1;a<i;a++)if(r(o[a],e))return a;return-1},e.prototype._getKeyIndexForMany=function(e){var t=this.options.isEqual,r=this.keys,n=r.length;if(!n)return-1;if(1===n)return this._getKeyIndexForSingle(e);var o,i,a=e.length;if(a>1){for(var s=0;s<n;s++)if((o=r[s]).length===a){for(i=0;i<a&&t(o[i],e[i]);i++);if(i===a)return s}}else for(s=0;s<n;s++)if((o=r[s]).length===a&&t(o[0],e[0]))return s;return-1},e.prototype._getKeyIndexForSingle=function(e){var t=this.keys;if(!t.length)return-1;var r=t[0],n=r.length;if(e.length!==n)return-1;var o=this.options.isEqual;if(n>1){for(var i=0;i<n;i++)if(!o(r[i],e[i]))return-1;return 0}return o(r[0],e[0])?0:-1},e.prototype.orderByLru=function(e,t,r){for(var n=this.keys,o=this.values,i=n.length,a=r;a--;)n[a+1]=n[a],o[a+1]=o[a];n[0]=e,o[0]=t;var s=this.options.maxSize;i===s&&r===i?(n.pop(),o.pop()):r>=s&&(n.length=o.length=s)},e.prototype.updateAsyncCache=function(e){var t=this,r=this.options,n=r.onCacheChange,o=r.onCacheHit,i=this.keys[0],a=this.values[0];this.values[0]=a.then((function(r){return t.shouldUpdateOnHit&&o(t,t.options,e),t.shouldUpdateOnChange&&n(t,t.options,e),r}),(function(e){var r=t.getKeyIndex(i);throw-1!==r&&(t.keys.splice(r,1),t.values.splice(r,1)),e}))},e}();return function t(a,s){if(void 0===s&&(s={}),function(e){return"function"==typeof e&&e.isMemoized}(a))return t(a.fn,o(a.options,s));if("function"!=typeof a)throw new TypeError("You must pass a function to `memoize`.");var l=s.isEqual,u=void 0===l?n:l,c=s.isMatchingKey,d=s.isPromise,p=void 0!==d&&d,f=s.maxSize,h=void 0===f?1:f,g=s.onCacheAdd,v=s.onCacheChange,m=s.onCacheHit,y=s.transformKey,b=o({isEqual:u,isMatchingKey:c,isPromise:p,maxSize:h,onCacheAdd:g,onCacheChange:v,onCacheHit:m,transformKey:y},function(t){var r={};for(var n in t)e[n]||(r[n]=t[n]);return r}(s)),O=new i(b),E=O.keys,S=O.values,w=O.canTransformKey,T=O.shouldCloneArguments,x=O.shouldUpdateOnAdd,_=O.shouldUpdateOnChange,C=O.shouldUpdateOnHit,R=function(){var e=T?r(arguments):arguments;w&&(e=y(e));var t=E.length?O.getKeyIndex(e):-1;if(-1!==t)C&&m(O,b,R),t&&(O.orderByLru(E[t],S[t],t),_&&v(O,b,R));else{var n=a.apply(this,arguments),o=T?e:r(arguments);O.orderByLru(o,n,E.length),p&&O.updateAsyncCache(R),x&&g(O,b,R),_&&v(O,b,R)}return S[0]};return R.cache=O,R.fn=a,R.isMemoized=!0,R.options=b,R}}()},9923:function(e){(function(){var t,r,n,o,i,a;"undefined"!=typeof performance&&null!==performance&&performance.now?e.exports=function(){return performance.now()}:"undefined"!=typeof process&&null!==process&&process.hrtime?(e.exports=function(){return(t()-i)/1e6},r=process.hrtime,o=(t=function(){var e;return 1e9*(e=r())[0]+e[1]})(),a=1e9*process.uptime(),i=o-a):Date.now?(e.exports=function(){return Date.now()-n},n=Date.now()):(e.exports=function(){return(new Date).getTime()-n},n=(new Date).getTime())}).call(this)},5345:e=>{var t=null,r=["Webkit","Moz","O","ms"];e.exports=function(e){t||(t=document.createElement("div"));var n=t.style;if(e in n)return e;for(var o=e.charAt(0).toUpperCase()+e.slice(1),i=r.length;i>=0;i--){var a=r[i]+o;if(a in n)return a}return!1}},4790:(e,t,r)=>{"use strict";var n=r(4621);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var s=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw s.name="Invariant Violation",s}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},7028:(e,t,r)=>{e.exports=r(4790)()},4621:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},8010:(e,t,r)=>{for(var n=r(9923),o="undefined"==typeof window?r.g:window,i=["moz","webkit"],a="AnimationFrame",s=o["request"+a],l=o["cancel"+a]||o["cancelRequest"+a],u=0;!s&&u<i.length;u++)s=o[i[u]+"Request"+a],l=o[i[u]+"Cancel"+a]||o[i[u]+"CancelRequest"+a];if(!s||!l){var c=0,d=0,p=[],f=1e3/60;s=function(e){if(0===p.length){var t=n(),r=Math.max(0,f-(t-c));c=r+t,setTimeout((function(){var e=p.slice(0);p.length=0;for(var t=0;t<e.length;t++)if(!e[t].cancelled)try{e[t].callback(c)}catch(e){setTimeout((function(){throw e}),0)}}),Math.round(r))}return p.push({handle:++d,callback:e,cancelled:!1}),d},l=function(e){for(var t=0;t<p.length;t++)p[t].handle===e&&(p[t].cancelled=!0)}}e.exports=function(e){return s.call(o,e)},e.exports.cancel=function(){l.apply(o,arguments)},e.exports.polyfill=function(e){e||(e=o),e.requestAnimationFrame=s,e.cancelAnimationFrame=l}},5903:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e};t.renderViewDefault=function(e){return i.default.createElement("div",e)},t.renderTrackHorizontalDefault=function(e){var t=e.style,r=a(e,["style"]),o=n({},t,{right:2,bottom:2,left:2,borderRadius:3});return i.default.createElement("div",n({style:o},r))},t.renderTrackVerticalDefault=function(e){var t=e.style,r=a(e,["style"]),o=n({},t,{right:2,bottom:2,top:2,borderRadius:3});return i.default.createElement("div",n({style:o},r))},t.renderThumbHorizontalDefault=function(e){var t=e.style,r=a(e,["style"]),o=n({},t,{cursor:"pointer",borderRadius:"inherit",backgroundColor:"rgba(0,0,0,.2)"});return i.default.createElement("div",n({style:o},r))},t.renderThumbVerticalDefault=function(e){var t=e.style,r=a(e,["style"]),o=n({},t,{cursor:"pointer",borderRadius:"inherit",backgroundColor:"rgba(0,0,0,.2)"});return i.default.createElement("div",n({style:o},r))};var o,i=(o=r(5959))&&o.__esModule?o:{default:o};function a(e,t){var r={};for(var n in e)t.indexOf(n)>=0||Object.prototype.hasOwnProperty.call(e,n)&&(r[n]=e[n]);return r}},3135:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},o=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),i=r(8010),a=m(i),s=m(r(49)),l=r(5959),u=m(r(7028)),c=m(r(8476)),d=m(r(8963)),p=m(r(5740)),f=m(r(4109)),h=m(r(2766)),g=r(3601),v=r(5903);function m(e){return e&&e.__esModule?e:{default:e}}var y=function(e){function t(e){var r;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t);for(var n=arguments.length,o=Array(n>1?n-1:0),i=1;i<n;i++)o[i-1]=arguments[i];var a=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(r=t.__proto__||Object.getPrototypeOf(t)).call.apply(r,[this,e].concat(o)));return a.getScrollLeft=a.getScrollLeft.bind(a),a.getScrollTop=a.getScrollTop.bind(a),a.getScrollWidth=a.getScrollWidth.bind(a),a.getScrollHeight=a.getScrollHeight.bind(a),a.getClientWidth=a.getClientWidth.bind(a),a.getClientHeight=a.getClientHeight.bind(a),a.getValues=a.getValues.bind(a),a.getThumbHorizontalWidth=a.getThumbHorizontalWidth.bind(a),a.getThumbVerticalHeight=a.getThumbVerticalHeight.bind(a),a.getScrollLeftForOffset=a.getScrollLeftForOffset.bind(a),a.getScrollTopForOffset=a.getScrollTopForOffset.bind(a),a.scrollLeft=a.scrollLeft.bind(a),a.scrollTop=a.scrollTop.bind(a),a.scrollToLeft=a.scrollToLeft.bind(a),a.scrollToTop=a.scrollToTop.bind(a),a.scrollToRight=a.scrollToRight.bind(a),a.scrollToBottom=a.scrollToBottom.bind(a),a.handleTrackMouseEnter=a.handleTrackMouseEnter.bind(a),a.handleTrackMouseLeave=a.handleTrackMouseLeave.bind(a),a.handleHorizontalTrackMouseDown=a.handleHorizontalTrackMouseDown.bind(a),a.handleVerticalTrackMouseDown=a.handleVerticalTrackMouseDown.bind(a),a.handleHorizontalThumbMouseDown=a.handleHorizontalThumbMouseDown.bind(a),a.handleVerticalThumbMouseDown=a.handleVerticalThumbMouseDown.bind(a),a.handleWindowResize=a.handleWindowResize.bind(a),a.handleScroll=a.handleScroll.bind(a),a.handleDrag=a.handleDrag.bind(a),a.handleDragEnd=a.handleDragEnd.bind(a),a.state={didMountUniversal:!1},a}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(t,e),o(t,[{key:"componentDidMount",value:function(){this.addListeners(),this.update(),this.componentDidMountUniversal()}},{key:"componentDidMountUniversal",value:function(){this.props.universal&&this.setState({didMountUniversal:!0})}},{key:"componentDidUpdate",value:function(){this.update()}},{key:"componentWillUnmount",value:function(){this.removeListeners(),(0,i.cancel)(this.requestFrame),clearTimeout(this.hideTracksTimeout),clearInterval(this.detectScrollingInterval)}},{key:"getScrollLeft",value:function(){return this.view?this.view.scrollLeft:0}},{key:"getScrollTop",value:function(){return this.view?this.view.scrollTop:0}},{key:"getScrollWidth",value:function(){return this.view?this.view.scrollWidth:0}},{key:"getScrollHeight",value:function(){return this.view?this.view.scrollHeight:0}},{key:"getClientWidth",value:function(){return this.view?this.view.clientWidth:0}},{key:"getClientHeight",value:function(){return this.view?this.view.clientHeight:0}},{key:"getValues",value:function(){var e=this.view||{},t=e.scrollLeft,r=void 0===t?0:t,n=e.scrollTop,o=void 0===n?0:n,i=e.scrollWidth,a=void 0===i?0:i,s=e.scrollHeight,l=void 0===s?0:s,u=e.clientWidth,c=void 0===u?0:u,d=e.clientHeight,p=void 0===d?0:d;return{left:r/(a-c)||0,top:o/(l-p)||0,scrollLeft:r,scrollTop:o,scrollWidth:a,scrollHeight:l,clientWidth:c,clientHeight:p}}},{key:"getThumbHorizontalWidth",value:function(){var e=this.props,t=e.thumbSize,r=e.thumbMinSize,n=this.view,o=n.scrollWidth,i=n.clientWidth,a=(0,f.default)(this.trackHorizontal),s=Math.ceil(i/o*a);return a<=s?0:t||Math.max(s,r)}},{key:"getThumbVerticalHeight",value:function(){var e=this.props,t=e.thumbSize,r=e.thumbMinSize,n=this.view,o=n.scrollHeight,i=n.clientHeight,a=(0,h.default)(this.trackVertical),s=Math.ceil(i/o*a);return a<=s?0:t||Math.max(s,r)}},{key:"getScrollLeftForOffset",value:function(e){var t=this.view,r=t.scrollWidth,n=t.clientWidth;return e/((0,f.default)(this.trackHorizontal)-this.getThumbHorizontalWidth())*(r-n)}},{key:"getScrollTopForOffset",value:function(e){var t=this.view,r=t.scrollHeight,n=t.clientHeight;return e/((0,h.default)(this.trackVertical)-this.getThumbVerticalHeight())*(r-n)}},{key:"scrollLeft",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0;this.view&&(this.view.scrollLeft=e)}},{key:"scrollTop",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0;this.view&&(this.view.scrollTop=e)}},{key:"scrollToLeft",value:function(){this.view&&(this.view.scrollLeft=0)}},{key:"scrollToTop",value:function(){this.view&&(this.view.scrollTop=0)}},{key:"scrollToRight",value:function(){this.view&&(this.view.scrollLeft=this.view.scrollWidth)}},{key:"scrollToBottom",value:function(){this.view&&(this.view.scrollTop=this.view.scrollHeight)}},{key:"addListeners",value:function(){if("undefined"!=typeof document&&this.view){var e=this.view,t=this.trackHorizontal,r=this.trackVertical,n=this.thumbHorizontal,o=this.thumbVertical;e.addEventListener("scroll",this.handleScroll),(0,d.default)()&&(t.addEventListener("mouseenter",this.handleTrackMouseEnter),t.addEventListener("mouseleave",this.handleTrackMouseLeave),t.addEventListener("mousedown",this.handleHorizontalTrackMouseDown),r.addEventListener("mouseenter",this.handleTrackMouseEnter),r.addEventListener("mouseleave",this.handleTrackMouseLeave),r.addEventListener("mousedown",this.handleVerticalTrackMouseDown),n.addEventListener("mousedown",this.handleHorizontalThumbMouseDown),o.addEventListener("mousedown",this.handleVerticalThumbMouseDown),window.addEventListener("resize",this.handleWindowResize))}}},{key:"removeListeners",value:function(){if("undefined"!=typeof document&&this.view){var e=this.view,t=this.trackHorizontal,r=this.trackVertical,n=this.thumbHorizontal,o=this.thumbVertical;e.removeEventListener("scroll",this.handleScroll),(0,d.default)()&&(t.removeEventListener("mouseenter",this.handleTrackMouseEnter),t.removeEventListener("mouseleave",this.handleTrackMouseLeave),t.removeEventListener("mousedown",this.handleHorizontalTrackMouseDown),r.removeEventListener("mouseenter",this.handleTrackMouseEnter),r.removeEventListener("mouseleave",this.handleTrackMouseLeave),r.removeEventListener("mousedown",this.handleVerticalTrackMouseDown),n.removeEventListener("mousedown",this.handleHorizontalThumbMouseDown),o.removeEventListener("mousedown",this.handleVerticalThumbMouseDown),window.removeEventListener("resize",this.handleWindowResize),this.teardownDragging())}}},{key:"handleScroll",value:function(e){var t=this,r=this.props,n=r.onScroll,o=r.onScrollFrame;n&&n(e),this.update((function(e){var r=e.scrollLeft,n=e.scrollTop;t.viewScrollLeft=r,t.viewScrollTop=n,o&&o(e)})),this.detectScrolling()}},{key:"handleScrollStart",value:function(){var e=this.props.onScrollStart;e&&e(),this.handleScrollStartAutoHide()}},{key:"handleScrollStartAutoHide",value:function(){this.props.autoHide&&this.showTracks()}},{key:"handleScrollStop",value:function(){var e=this.props.onScrollStop;e&&e(),this.handleScrollStopAutoHide()}},{key:"handleScrollStopAutoHide",value:function(){this.props.autoHide&&this.hideTracks()}},{key:"handleWindowResize",value:function(){(0,d.default)(!1),this.forceUpdate()}},{key:"handleHorizontalTrackMouseDown",value:function(e){e.preventDefault();var t=e.target,r=e.clientX,n=t.getBoundingClientRect().left,o=this.getThumbHorizontalWidth(),i=Math.abs(n-r)-o/2;this.view.scrollLeft=this.getScrollLeftForOffset(i)}},{key:"handleVerticalTrackMouseDown",value:function(e){e.preventDefault();var t=e.target,r=e.clientY,n=t.getBoundingClientRect().top,o=this.getThumbVerticalHeight(),i=Math.abs(n-r)-o/2;this.view.scrollTop=this.getScrollTopForOffset(i)}},{key:"handleHorizontalThumbMouseDown",value:function(e){e.preventDefault(),this.handleDragStart(e);var t=e.target,r=e.clientX,n=t.offsetWidth,o=t.getBoundingClientRect().left;this.prevPageX=n-(r-o)}},{key:"handleVerticalThumbMouseDown",value:function(e){e.preventDefault(),this.handleDragStart(e);var t=e.target,r=e.clientY,n=t.offsetHeight,o=t.getBoundingClientRect().top;this.prevPageY=n-(r-o)}},{key:"setupDragging",value:function(){(0,s.default)(document.body,g.disableSelectStyle),document.addEventListener("mousemove",this.handleDrag),document.addEventListener("mouseup",this.handleDragEnd),document.onselectstart=p.default}},{key:"teardownDragging",value:function(){(0,s.default)(document.body,g.disableSelectStyleReset),document.removeEventListener("mousemove",this.handleDrag),document.removeEventListener("mouseup",this.handleDragEnd),document.onselectstart=void 0}},{key:"handleDragStart",value:function(e){this.dragging=!0,e.stopImmediatePropagation(),this.setupDragging()}},{key:"handleDrag",value:function(e){if(this.prevPageX){var t=e.clientX,r=-this.trackHorizontal.getBoundingClientRect().left+t-(this.getThumbHorizontalWidth()-this.prevPageX);this.view.scrollLeft=this.getScrollLeftForOffset(r)}if(this.prevPageY){var n=e.clientY,o=-this.trackVertical.getBoundingClientRect().top+n-(this.getThumbVerticalHeight()-this.prevPageY);this.view.scrollTop=this.getScrollTopForOffset(o)}return!1}},{key:"handleDragEnd",value:function(){this.dragging=!1,this.prevPageX=this.prevPageY=0,this.teardownDragging(),this.handleDragEndAutoHide()}},{key:"handleDragEndAutoHide",value:function(){this.props.autoHide&&this.hideTracks()}},{key:"handleTrackMouseEnter",value:function(){this.trackMouseOver=!0,this.handleTrackMouseEnterAutoHide()}},{key:"handleTrackMouseEnterAutoHide",value:function(){this.props.autoHide&&this.showTracks()}},{key:"handleTrackMouseLeave",value:function(){this.trackMouseOver=!1,this.handleTrackMouseLeaveAutoHide()}},{key:"handleTrackMouseLeaveAutoHide",value:function(){this.props.autoHide&&this.hideTracks()}},{key:"showTracks",value:function(){clearTimeout(this.hideTracksTimeout),(0,s.default)(this.trackHorizontal,{opacity:1}),(0,s.default)(this.trackVertical,{opacity:1})}},{key:"hideTracks",value:function(){var e=this;if(!this.dragging&&!this.scrolling&&!this.trackMouseOver){var t=this.props.autoHideTimeout;clearTimeout(this.hideTracksTimeout),this.hideTracksTimeout=setTimeout((function(){(0,s.default)(e.trackHorizontal,{opacity:0}),(0,s.default)(e.trackVertical,{opacity:0})}),t)}}},{key:"detectScrolling",value:function(){var e=this;this.scrolling||(this.scrolling=!0,this.handleScrollStart(),this.detectScrollingInterval=setInterval((function(){e.lastViewScrollLeft===e.viewScrollLeft&&e.lastViewScrollTop===e.viewScrollTop&&(clearInterval(e.detectScrollingInterval),e.scrolling=!1,e.handleScrollStop()),e.lastViewScrollLeft=e.viewScrollLeft,e.lastViewScrollTop=e.viewScrollTop}),100))}},{key:"raf",value:function(e){var t=this;this.requestFrame&&a.default.cancel(this.requestFrame),this.requestFrame=(0,a.default)((function(){t.requestFrame=void 0,e()}))}},{key:"update",value:function(e){var t=this;this.raf((function(){return t._update(e)}))}},{key:"_update",value:function(e){var t=this.props,r=t.onUpdate,n=t.hideTracksWhenNotNeeded,o=this.getValues();if((0,d.default)()){var i=o.scrollLeft,a=o.clientWidth,l=o.scrollWidth,u=(0,f.default)(this.trackHorizontal),c=this.getThumbHorizontalWidth(),p={width:c,transform:"translateX("+i/(l-a)*(u-c)+"px)"},g=o.scrollTop,v=o.clientHeight,m=o.scrollHeight,y=(0,h.default)(this.trackVertical),b=this.getThumbVerticalHeight(),O={height:b,transform:"translateY("+g/(m-v)*(y-b)+"px)"};if(n){var E={visibility:l>a?"visible":"hidden"},S={visibility:m>v?"visible":"hidden"};(0,s.default)(this.trackHorizontal,E),(0,s.default)(this.trackVertical,S)}(0,s.default)(this.thumbHorizontal,p),(0,s.default)(this.thumbVertical,O)}r&&r(o),"function"==typeof e&&e(o)}},{key:"render",value:function(){var e=this,t=(0,d.default)(),r=this.props,o=(r.onScroll,r.onScrollFrame,r.onScrollStart,r.onScrollStop,r.onUpdate,r.renderView),i=r.renderTrackHorizontal,a=r.renderTrackVertical,s=r.renderThumbHorizontal,u=r.renderThumbVertical,p=r.tagName,f=(r.hideTracksWhenNotNeeded,r.autoHide),h=(r.autoHideTimeout,r.autoHideDuration),v=(r.thumbSize,r.thumbMinSize,r.universal),m=r.autoHeight,y=r.autoHeightMin,b=r.autoHeightMax,O=r.style,E=r.children,S=function(e,t){var r={};for(var n in e)t.indexOf(n)>=0||Object.prototype.hasOwnProperty.call(e,n)&&(r[n]=e[n]);return r}(r,["onScroll","onScrollFrame","onScrollStart","onScrollStop","onUpdate","renderView","renderTrackHorizontal","renderTrackVertical","renderThumbHorizontal","renderThumbVertical","tagName","hideTracksWhenNotNeeded","autoHide","autoHideTimeout","autoHideDuration","thumbSize","thumbMinSize","universal","autoHeight","autoHeightMin","autoHeightMax","style","children"]),w=this.state.didMountUniversal,T=n({},g.containerStyleDefault,m&&n({},g.containerStyleAutoHeight,{minHeight:y,maxHeight:b}),O),x=n({},g.viewStyleDefault,{marginRight:t?-t:0,marginBottom:t?-t:0},m&&n({},g.viewStyleAutoHeight,{minHeight:(0,c.default)(y)?"calc("+y+" + "+t+"px)":y+t,maxHeight:(0,c.default)(b)?"calc("+b+" + "+t+"px)":b+t}),m&&v&&!w&&{minHeight:y,maxHeight:b},v&&!w&&g.viewStyleUniversalInitial),_={transition:"opacity "+h+"ms",opacity:0},C=n({},g.trackHorizontalStyleDefault,f&&_,(!t||v&&!w)&&{display:"none"}),R=n({},g.trackVerticalStyleDefault,f&&_,(!t||v&&!w)&&{display:"none"});return(0,l.createElement)(p,n({},S,{style:T,ref:function(t){e.container=t}}),[(0,l.cloneElement)(o({style:x}),{key:"view",ref:function(t){e.view=t}},E),(0,l.cloneElement)(i({style:C}),{key:"trackHorizontal",ref:function(t){e.trackHorizontal=t}},(0,l.cloneElement)(s({style:g.thumbHorizontalStyleDefault}),{ref:function(t){e.thumbHorizontal=t}})),(0,l.cloneElement)(a({style:R}),{key:"trackVertical",ref:function(t){e.trackVertical=t}},(0,l.cloneElement)(u({style:g.thumbVerticalStyleDefault}),{ref:function(t){e.thumbVertical=t}}))])}}]),t}(l.Component);t.default=y,y.propTypes={onScroll:u.default.func,onScrollFrame:u.default.func,onScrollStart:u.default.func,onScrollStop:u.default.func,onUpdate:u.default.func,renderView:u.default.func,renderTrackHorizontal:u.default.func,renderTrackVertical:u.default.func,renderThumbHorizontal:u.default.func,renderThumbVertical:u.default.func,tagName:u.default.string,thumbSize:u.default.number,thumbMinSize:u.default.number,hideTracksWhenNotNeeded:u.default.bool,autoHide:u.default.bool,autoHideTimeout:u.default.number,autoHideDuration:u.default.number,autoHeight:u.default.bool,autoHeightMin:u.default.oneOfType([u.default.number,u.default.string]),autoHeightMax:u.default.oneOfType([u.default.number,u.default.string]),universal:u.default.bool,style:u.default.object,children:u.default.node},y.defaultProps={renderView:v.renderViewDefault,renderTrackHorizontal:v.renderTrackHorizontalDefault,renderTrackVertical:v.renderTrackVerticalDefault,renderThumbHorizontal:v.renderThumbHorizontalDefault,renderThumbVertical:v.renderThumbVerticalDefault,tagName:"div",thumbMinSize:30,hideTracksWhenNotNeeded:!1,autoHide:!1,autoHideTimeout:1e3,autoHideDuration:200,autoHeight:!1,autoHeightMin:0,autoHeightMax:200,universal:!1}},3601:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.containerStyleDefault={position:"relative",overflow:"hidden",width:"100%",height:"100%"},t.containerStyleAutoHeight={height:"auto"},t.viewStyleDefault={position:"absolute",top:0,left:0,right:0,bottom:0,overflow:"scroll",WebkitOverflowScrolling:"touch"},t.viewStyleAutoHeight={position:"relative",top:void 0,left:void 0,right:void 0,bottom:void 0},t.viewStyleUniversalInitial={overflow:"hidden",marginRight:0,marginBottom:0},t.trackHorizontalStyleDefault={position:"absolute",height:6},t.trackVerticalStyleDefault={position:"absolute",width:6},t.thumbHorizontalStyleDefault={position:"relative",display:"block",height:"100%"},t.thumbVerticalStyleDefault={position:"relative",display:"block",width:"100%"},t.disableSelectStyle={userSelect:"none"},t.disableSelectStyleReset={userSelect:""}},1332:(e,t,r)=>{"use strict";var n,o=(n=r(3135))&&n.__esModule?n:{default:n};t.Ay=o.default,o.default},2766:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.clientHeight,r=getComputedStyle(e),n=r.paddingTop,o=r.paddingBottom;return t-parseFloat(n)-parseFloat(o)}},4109:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){var t=e.clientWidth,r=getComputedStyle(e),n=r.paddingLeft,o=r.paddingRight;return t-parseFloat(n)-parseFloat(o)}},8963:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(){if((!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&!1!==i)return i;if("undefined"!=typeof document){var e=document.createElement("div");(0,o.default)(e,{width:100,height:100,position:"absolute",top:-9999,overflow:"scroll",MsOverflowStyle:"scrollbar"}),document.body.appendChild(e),i=e.offsetWidth-e.clientWidth,document.body.removeChild(e)}else i=0;return i||0};var n,o=(n=r(49))&&n.__esModule?n:{default:n},i=!1},8476:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){return"string"==typeof e}},5740:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(){return!1}},8641:(e,t,r)=>{"use strict";var n=r(5959);function o(e){for(var t="https://reactjs.org/docs/error-decoder.html?invariant="+e,r=1;r<arguments.length;r++)t+="&args[]="+encodeURIComponent(arguments[r]);return"Minified React error #"+e+"; visit "+t+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var i=Object.prototype.hasOwnProperty,a=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,s={},l={};function u(e){return!!i.call(l,e)||!i.call(s,e)&&(a.test(e)?l[e]=!0:(s[e]=!0,!1))}function c(e,t,r,n,o,i,a){this.acceptsBooleans=2===t||3===t||4===t,this.attributeName=n,this.attributeNamespace=o,this.mustUseProperty=r,this.propertyName=e,this.type=t,this.sanitizeURL=i,this.removeEmptyString=a}var d={};"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach((function(e){d[e]=new c(e,0,!1,e,null,!1,!1)})),[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach((function(e){var t=e[0];d[t]=new c(t,1,!1,e[1],null,!1,!1)})),["contentEditable","draggable","spellCheck","value"].forEach((function(e){d[e]=new c(e,2,!1,e.toLowerCase(),null,!1,!1)})),["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach((function(e){d[e]=new c(e,2,!1,e,null,!1,!1)})),"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach((function(e){d[e]=new c(e,3,!1,e.toLowerCase(),null,!1,!1)})),["checked","multiple","muted","selected"].forEach((function(e){d[e]=new c(e,3,!0,e,null,!1,!1)})),["capture","download"].forEach((function(e){d[e]=new c(e,4,!1,e,null,!1,!1)})),["cols","rows","size","span"].forEach((function(e){d[e]=new c(e,6,!1,e,null,!1,!1)})),["rowSpan","start"].forEach((function(e){d[e]=new c(e,5,!1,e.toLowerCase(),null,!1,!1)}));var p=/[\-:]([a-z])/g;function f(e){return e[1].toUpperCase()}"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach((function(e){var t=e.replace(p,f);d[t]=new c(t,1,!1,e,null,!1,!1)})),"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach((function(e){var t=e.replace(p,f);d[t]=new c(t,1,!1,e,"http://www.w3.org/1999/xlink",!1,!1)})),["xml:base","xml:lang","xml:space"].forEach((function(e){var t=e.replace(p,f);d[t]=new c(t,1,!1,e,"http://www.w3.org/XML/1998/namespace",!1,!1)})),["tabIndex","crossOrigin"].forEach((function(e){d[e]=new c(e,1,!1,e.toLowerCase(),null,!1,!1)})),d.xlinkHref=new c("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1),["src","href","action","formAction"].forEach((function(e){d[e]=new c(e,1,!1,e.toLowerCase(),null,!0,!0)}));var h={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},g=["Webkit","ms","Moz","O"];Object.keys(h).forEach((function(e){g.forEach((function(t){t=t+e.charAt(0).toUpperCase()+e.substring(1),h[t]=h[e]}))}));var v=/["'&<>]/;function m(e){if("boolean"==typeof e||"number"==typeof e)return""+e;e=""+e;var t=v.exec(e);if(t){var r,n="",o=0;for(r=t.index;r<e.length;r++){switch(e.charCodeAt(r)){case 34:t="&quot;";break;case 38:t="&amp;";break;case 39:t="&#x27;";break;case 60:t="&lt;";break;case 62:t="&gt;";break;default:continue}o!==r&&(n+=e.substring(o,r)),o=r+1,n+=t}e=o!==r?n+e.substring(o,r):n}return e}var y=/([A-Z])/g,b=/^ms-/,O=Array.isArray;function E(e,t){return{insertionMode:e,selectedValue:t}}var S=new Map;function w(e,t,r){if("object"!=typeof r)throw Error(o(62));for(var n in t=!0,r)if(i.call(r,n)){var a=r[n];if(null!=a&&"boolean"!=typeof a&&""!==a){if(0===n.indexOf("--")){var s=m(n);a=m((""+a).trim())}else{s=n;var l=S.get(s);void 0!==l||(l=m(s.replace(y,"-$1").toLowerCase().replace(b,"-ms-")),S.set(s,l)),s=l,a="number"==typeof a?0===a||i.call(h,n)?""+a:a+"px":m((""+a).trim())}t?(t=!1,e.push(' style="',s,":",a)):e.push(";",s,":",a)}}t||e.push('"')}function T(e,t,r,n){switch(r){case"style":return void w(e,t,n);case"defaultValue":case"defaultChecked":case"innerHTML":case"suppressContentEditableWarning":case"suppressHydrationWarning":return}if(!(2<r.length)||"o"!==r[0]&&"O"!==r[0]||"n"!==r[1]&&"N"!==r[1])if(null!==(t=d.hasOwnProperty(r)?d[r]:null)){switch(typeof n){case"function":case"symbol":return;case"boolean":if(!t.acceptsBooleans)return}switch(r=t.attributeName,t.type){case 3:n&&e.push(" ",r,'=""');break;case 4:!0===n?e.push(" ",r,'=""'):!1!==n&&e.push(" ",r,'="',m(n),'"');break;case 5:isNaN(n)||e.push(" ",r,'="',m(n),'"');break;case 6:!isNaN(n)&&1<=n&&e.push(" ",r,'="',m(n),'"');break;default:t.sanitizeURL&&(n=""+n),e.push(" ",r,'="',m(n),'"')}}else if(u(r)){switch(typeof n){case"function":case"symbol":return;case"boolean":if("data-"!==(t=r.toLowerCase().slice(0,5))&&"aria-"!==t)return}e.push(" ",r,'="',m(n),'"')}}function x(e,t,r){if(null!=t){if(null!=r)throw Error(o(60));if("object"!=typeof t||!("__html"in t))throw Error(o(61));null!=(t=t.__html)&&e.push(""+t)}}function _(e,t,r,n){e.push(I(r));var o,a=r=null;for(o in t)if(i.call(t,o)){var s=t[o];if(null!=s)switch(o){case"children":r=s;break;case"dangerouslySetInnerHTML":a=s;break;default:T(e,n,o,s)}}return e.push(">"),x(e,a,r),"string"==typeof r?(e.push(m(r)),null):r}var C=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,R=new Map;function I(e){var t=R.get(e);if(void 0===t){if(!C.test(e))throw Error(o(65,e));t="<"+e,R.set(e,t)}return t}function A(e,t,r){if(e.push('\x3c!--$?--\x3e<template id="'),null===r)throw Error(o(395));return e.push(r),e.push('"></template>')}var j=/[<\u2028\u2029]/g;function P(e){return JSON.stringify(e).replace(j,(function(e){switch(e){case"<":return"\\u003c";case"\u2028":return"\\u2028";case"\u2029":return"\\u2029";default:throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React")}}))}function L(e,t,r,n){return r.generateStaticMarkup?(e.push(m(t)),!1):(""===t?e=n:(n&&e.push("\x3c!-- --\x3e"),e.push(m(t)),e=!0),e)}var k=Object.assign,N=Symbol.for("react.element"),D=Symbol.for("react.portal"),F=Symbol.for("react.fragment"),M=Symbol.for("react.strict_mode"),V=Symbol.for("react.profiler"),U=Symbol.for("react.provider"),B=Symbol.for("react.context"),z=Symbol.for("react.forward_ref"),$=Symbol.for("react.suspense"),W=Symbol.for("react.suspense_list"),H=Symbol.for("react.memo"),q=Symbol.for("react.lazy"),G=Symbol.for("react.scope"),K=Symbol.for("react.debug_trace_mode"),Y=Symbol.for("react.legacy_hidden"),X=Symbol.for("react.default_value"),Q=Symbol.iterator;function J(e){if(null==e)return null;if("function"==typeof e)return e.displayName||e.name||null;if("string"==typeof e)return e;switch(e){case F:return"Fragment";case D:return"Portal";case V:return"Profiler";case M:return"StrictMode";case $:return"Suspense";case W:return"SuspenseList"}if("object"==typeof e)switch(e.$$typeof){case B:return(e.displayName||"Context")+".Consumer";case U:return(e._context.displayName||"Context")+".Provider";case z:var t=e.render;return(e=e.displayName)||(e=""!==(e=t.displayName||t.name||"")?"ForwardRef("+e+")":"ForwardRef"),e;case H:return null!==(t=e.displayName||null)?t:J(e.type)||"Memo";case q:t=e._payload,e=e._init;try{return J(e(t))}catch(e){}}return null}var Z={};function ee(e,t){if(!(e=e.contextTypes))return Z;var r,n={};for(r in e)n[r]=t[r];return n}var te=null;function re(e,t){if(e!==t){e.context._currentValue2=e.parentValue,e=e.parent;var r=t.parent;if(null===e){if(null!==r)throw Error(o(401))}else{if(null===r)throw Error(o(401));re(e,r)}t.context._currentValue2=t.value}}function ne(e){e.context._currentValue2=e.parentValue,null!==(e=e.parent)&&ne(e)}function oe(e){var t=e.parent;null!==t&&oe(t),e.context._currentValue2=e.value}function ie(e,t){if(e.context._currentValue2=e.parentValue,null===(e=e.parent))throw Error(o(402));e.depth===t.depth?re(e,t):ie(e,t)}function ae(e,t){var r=t.parent;if(null===r)throw Error(o(402));e.depth===r.depth?re(e,r):ae(e,r),t.context._currentValue2=t.value}function se(e){var t=te;t!==e&&(null===t?oe(e):null===e?ne(t):t.depth===e.depth?re(t,e):t.depth>e.depth?ie(t,e):ae(t,e),te=e)}var le={isMounted:function(){return!1},enqueueSetState:function(e,t){null!==(e=e._reactInternals).queue&&e.queue.push(t)},enqueueReplaceState:function(e,t){(e=e._reactInternals).replace=!0,e.queue=[t]},enqueueForceUpdate:function(){}};function ue(e,t,r,n){var o=void 0!==e.state?e.state:null;e.updater=le,e.props=r,e.state=o;var i={queue:[],replace:!1};e._reactInternals=i;var a=t.contextType;if(e.context="object"==typeof a&&null!==a?a._currentValue2:n,"function"==typeof(a=t.getDerivedStateFromProps)&&(o=null==(a=a(r,o))?o:k({},o,a),e.state=o),"function"!=typeof t.getDerivedStateFromProps&&"function"!=typeof e.getSnapshotBeforeUpdate&&("function"==typeof e.UNSAFE_componentWillMount||"function"==typeof e.componentWillMount))if(t=e.state,"function"==typeof e.componentWillMount&&e.componentWillMount(),"function"==typeof e.UNSAFE_componentWillMount&&e.UNSAFE_componentWillMount(),t!==e.state&&le.enqueueReplaceState(e,e.state,null),null!==i.queue&&0<i.queue.length)if(t=i.queue,a=i.replace,i.queue=null,i.replace=!1,a&&1===t.length)e.state=t[0];else{for(i=a?t[0]:e.state,o=!0,a=a?1:0;a<t.length;a++){var s=t[a];null!=(s="function"==typeof s?s.call(e,i,r,n):s)&&(o?(o=!1,i=k({},i,s)):k(i,s))}e.state=i}else i.queue=null}var ce={id:1,overflow:""};function de(e,t,r){var n=e.id;e=e.overflow;var o=32-pe(n)-1;n&=~(1<<o),r+=1;var i=32-pe(t)+o;if(30<i){var a=o-o%5;return i=(n&(1<<a)-1).toString(32),n>>=a,o-=a,{id:1<<32-pe(t)+o|r<<o|n,overflow:i+e}}return{id:1<<i|r<<o|n,overflow:e}}var pe=Math.clz32?Math.clz32:function(e){return 0==(e>>>=0)?32:31-(fe(e)/he|0)|0},fe=Math.log,he=Math.LN2,ge="function"==typeof Object.is?Object.is:function(e,t){return e===t&&(0!==e||1/e==1/t)||e!=e&&t!=t},ve=null,me=null,ye=null,be=null,Oe=!1,Ee=!1,Se=0,we=null,Te=0;function xe(){if(null===ve)throw Error(o(321));return ve}function _e(){if(0<Te)throw Error(o(312));return{memoizedState:null,queue:null,next:null}}function Ce(){return null===be?null===ye?(Oe=!1,ye=be=_e()):(Oe=!0,be=ye):null===be.next?(Oe=!1,be=be.next=_e()):(Oe=!0,be=be.next),be}function Re(){me=ve=null,Ee=!1,ye=null,Te=0,be=we=null}function Ie(e,t){return"function"==typeof t?t(e):t}function Ae(e,t,r){if(ve=xe(),be=Ce(),Oe){var n=be.queue;if(t=n.dispatch,null!==we&&void 0!==(r=we.get(n))){we.delete(n),n=be.memoizedState;do{n=e(n,r.action),r=r.next}while(null!==r);return be.memoizedState=n,[n,t]}return[be.memoizedState,t]}return e=e===Ie?"function"==typeof t?t():t:void 0!==r?r(t):t,be.memoizedState=e,e=(e=be.queue={last:null,dispatch:null}).dispatch=Pe.bind(null,ve,e),[be.memoizedState,e]}function je(e,t){if(ve=xe(),t=void 0===t?null:t,null!==(be=Ce())){var r=be.memoizedState;if(null!==r&&null!==t){var n=r[1];e:if(null===n)n=!1;else{for(var o=0;o<n.length&&o<t.length;o++)if(!ge(t[o],n[o])){n=!1;break e}n=!0}if(n)return r[0]}}return e=e(),be.memoizedState=[e,t],e}function Pe(e,t,r){if(25<=Te)throw Error(o(301));if(e===ve)if(Ee=!0,e={action:r,next:null},null===we&&(we=new Map),void 0===(r=we.get(t)))we.set(t,e);else{for(t=r;null!==t.next;)t=t.next;t.next=e}}function Le(){throw Error(o(394))}function ke(){}var Ne={readContext:function(e){return e._currentValue2},useContext:function(e){return xe(),e._currentValue2},useMemo:je,useReducer:Ae,useRef:function(e){ve=xe();var t=(be=Ce()).memoizedState;return null===t?(e={current:e},be.memoizedState=e):t},useState:function(e){return Ae(Ie,e)},useInsertionEffect:ke,useLayoutEffect:function(){},useCallback:function(e,t){return je((function(){return e}),t)},useImperativeHandle:ke,useEffect:ke,useDebugValue:ke,useDeferredValue:function(e){return xe(),e},useTransition:function(){return xe(),[!1,Le]},useId:function(){var e=me.treeContext,t=e.overflow;e=((e=e.id)&~(1<<32-pe(e)-1)).toString(32)+t;var r=De;if(null===r)throw Error(o(404));return t=Se++,e=":"+r.idPrefix+"R"+e,0<t&&(e+="H"+t.toString(32)),e+":"},useMutableSource:function(e,t){return xe(),t(e._source)},useSyncExternalStore:function(e,t,r){if(void 0===r)throw Error(o(407));return r()}},De=null,Fe=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentDispatcher;function Me(e){return console.error(e),null}function Ve(){}function Ue(e,t,r,n,o,i,a,s){e.allPendingTasks++,null===r?e.pendingRootTasks++:r.pendingTasks++;var l={node:t,ping:function(){var t=e.pingedTasks;t.push(l),1===t.length&&tt(e)},blockedBoundary:r,blockedSegment:n,abortSet:o,legacyContext:i,context:a,treeContext:s};return o.add(l),l}function Be(e,t,r,n,o,i){return{status:0,id:-1,index:t,parentFlushed:!1,chunks:[],children:[],formatContext:n,boundary:r,lastPushedText:o,textEmbedded:i}}function ze(e,t){if(null!=(e=e.onError(t))&&"string"!=typeof e)throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "'+typeof e+'" instead');return e}function $e(e,t){var r=e.onShellError;r(t),(r=e.onFatalError)(t),null!==e.destination?(e.status=2,e.destination.destroy(t)):(e.status=1,e.fatalError=t)}function We(e,t,r,n,o){for(ve={},me=t,Se=0,e=r(n,o);Ee;)Ee=!1,Se=0,Te+=1,be=null,e=r(n,o);return Re(),e}function He(e,t,r,n){var i=r.render(),a=n.childContextTypes;if(null!=a){var s=t.legacyContext;if("function"!=typeof r.getChildContext)n=s;else{for(var l in r=r.getChildContext())if(!(l in a))throw Error(o(108,J(n)||"Unknown",l));n=k({},s,r)}t.legacyContext=n,Ke(e,t,i),t.legacyContext=s}else Ke(e,t,i)}function qe(e,t){if(e&&e.defaultProps){for(var r in t=k({},t),e=e.defaultProps)void 0===t[r]&&(t[r]=e[r]);return t}return t}function Ge(e,t,r,a,s){if("function"==typeof r)if(r.prototype&&r.prototype.isReactComponent){s=ee(r,t.legacyContext);var l=r.contextType;ue(l=new r(a,"object"==typeof l&&null!==l?l._currentValue2:s),r,a,s),He(e,t,l,r)}else{s=We(e,t,r,a,l=ee(r,t.legacyContext));var c=0!==Se;if("object"==typeof s&&null!==s&&"function"==typeof s.render&&void 0===s.$$typeof)ue(s,r,a,l),He(e,t,s,r);else if(c){a=t.treeContext,t.treeContext=de(a,1,0);try{Ke(e,t,s)}finally{t.treeContext=a}}else Ke(e,t,s)}else{if("string"!=typeof r){switch(r){case Y:case K:case M:case V:case F:case W:return void Ke(e,t,a.children);case G:throw Error(o(343));case $:e:{r=t.blockedBoundary,s=t.blockedSegment,l=a.fallback,a=a.children;var d={id:null,rootSegmentID:-1,parentFlushed:!1,pendingTasks:0,forceClientRender:!1,completedSegments:[],byteSize:0,fallbackAbortableTasks:c=new Set,errorDigest:null},p=Be(0,s.chunks.length,d,s.formatContext,!1,!1);s.children.push(p),s.lastPushedText=!1;var f=Be(0,0,null,s.formatContext,!1,!1);f.parentFlushed=!0,t.blockedBoundary=d,t.blockedSegment=f;try{if(Xe(e,t,a),e.responseState.generateStaticMarkup||f.lastPushedText&&f.textEmbedded&&f.chunks.push("\x3c!-- --\x3e"),f.status=1,Ze(d,f),0===d.pendingTasks)break e}catch(t){f.status=4,d.forceClientRender=!0,d.errorDigest=ze(e,t)}finally{t.blockedBoundary=r,t.blockedSegment=s}t=Ue(e,l,r,p,c,t.legacyContext,t.context,t.treeContext),e.pingedTasks.push(t)}return}if("object"==typeof r&&null!==r)switch(r.$$typeof){case z:if(a=We(e,t,r.render,a,s),0!==Se){r=t.treeContext,t.treeContext=de(r,1,0);try{Ke(e,t,a)}finally{t.treeContext=r}}else Ke(e,t,a);return;case H:return void Ge(e,t,r=r.type,a=qe(r,a),s);case U:if(s=a.children,r=r._context,a=a.value,l=r._currentValue2,r._currentValue2=a,te=a={parent:c=te,depth:null===c?0:c.depth+1,context:r,parentValue:l,value:a},t.context=a,Ke(e,t,s),null===(e=te))throw Error(o(403));return a=e.parentValue,e.context._currentValue2=a===X?e.context._defaultValue:a,e=te=e.parent,void(t.context=e);case B:return void Ke(e,t,a=(a=a.children)(r._currentValue2));case q:return void Ge(e,t,r=(s=r._init)(r._payload),a=qe(r,a),void 0)}throw Error(o(130,null==r?r:typeof r,""))}switch(l=function(e,t,r,a,s){switch(t){case"select":e.push(I("select"));var l=null,c=null;for(h in r)if(i.call(r,h)){var d=r[h];if(null!=d)switch(h){case"children":l=d;break;case"dangerouslySetInnerHTML":c=d;break;case"defaultValue":case"value":break;default:T(e,a,h,d)}}return e.push(">"),x(e,c,l),l;case"option":c=s.selectedValue,e.push(I("option"));var p=d=null,f=null,h=null;for(l in r)if(i.call(r,l)){var g=r[l];if(null!=g)switch(l){case"children":d=g;break;case"selected":f=g;break;case"dangerouslySetInnerHTML":h=g;break;case"value":p=g;default:T(e,a,l,g)}}if(null!=c)if(r=null!==p?""+p:function(e){var t="";return n.Children.forEach(e,(function(e){null!=e&&(t+=e)})),t}(d),O(c)){for(a=0;a<c.length;a++)if(""+c[a]===r){e.push(' selected=""');break}}else""+c===r&&e.push(' selected=""');else f&&e.push(' selected=""');return e.push(">"),x(e,h,d),d;case"textarea":for(d in e.push(I("textarea")),h=c=l=null,r)if(i.call(r,d)&&null!=(p=r[d]))switch(d){case"children":h=p;break;case"value":l=p;break;case"defaultValue":c=p;break;case"dangerouslySetInnerHTML":throw Error(o(91));default:T(e,a,d,p)}if(null===l&&null!==c&&(l=c),e.push(">"),null!=h){if(null!=l)throw Error(o(92));if(O(h)&&1<h.length)throw Error(o(93));l=""+h}return"string"==typeof l&&"\n"===l[0]&&e.push("\n"),null!==l&&e.push(m(""+l)),null;case"input":for(c in e.push(I("input")),p=h=d=l=null,r)if(i.call(r,c)&&null!=(f=r[c]))switch(c){case"children":case"dangerouslySetInnerHTML":throw Error(o(399,"input"));case"defaultChecked":p=f;break;case"defaultValue":d=f;break;case"checked":h=f;break;case"value":l=f;break;default:T(e,a,c,f)}return null!==h?T(e,a,"checked",h):null!==p&&T(e,a,"checked",p),null!==l?T(e,a,"value",l):null!==d&&T(e,a,"value",d),e.push("/>"),null;case"menuitem":for(var v in e.push(I("menuitem")),r)if(i.call(r,v)&&null!=(l=r[v]))switch(v){case"children":case"dangerouslySetInnerHTML":throw Error(o(400));default:T(e,a,v,l)}return e.push(">"),null;case"title":for(g in e.push(I("title")),l=null,r)if(i.call(r,g)&&null!=(c=r[g]))switch(g){case"children":l=c;break;case"dangerouslySetInnerHTML":throw Error(o(434));default:T(e,a,g,c)}return e.push(">"),l;case"listing":case"pre":for(p in e.push(I(t)),c=l=null,r)if(i.call(r,p)&&null!=(d=r[p]))switch(p){case"children":l=d;break;case"dangerouslySetInnerHTML":c=d;break;default:T(e,a,p,d)}if(e.push(">"),null!=c){if(null!=l)throw Error(o(60));if("object"!=typeof c||!("__html"in c))throw Error(o(61));null!=(r=c.__html)&&("string"==typeof r&&0<r.length&&"\n"===r[0]?e.push("\n",r):e.push(""+r))}return"string"==typeof l&&"\n"===l[0]&&e.push("\n"),l;case"area":case"base":case"br":case"col":case"embed":case"hr":case"img":case"keygen":case"link":case"meta":case"param":case"source":case"track":case"wbr":for(var y in e.push(I(t)),r)if(i.call(r,y)&&null!=(l=r[y]))switch(y){case"children":case"dangerouslySetInnerHTML":throw Error(o(399,t));default:T(e,a,y,l)}return e.push("/>"),null;case"annotation-xml":case"color-profile":case"font-face":case"font-face-src":case"font-face-uri":case"font-face-format":case"font-face-name":case"missing-glyph":return _(e,r,t,a);case"html":return 0===s.insertionMode&&e.push("<!DOCTYPE html>"),_(e,r,t,a);default:if(-1===t.indexOf("-")&&"string"!=typeof r.is)return _(e,r,t,a);for(f in e.push(I(t)),c=l=null,r)if(i.call(r,f)&&null!=(d=r[f]))switch(f){case"children":l=d;break;case"dangerouslySetInnerHTML":c=d;break;case"style":w(e,a,d);break;case"suppressContentEditableWarning":case"suppressHydrationWarning":break;default:u(f)&&"function"!=typeof d&&"symbol"!=typeof d&&e.push(" ",f,'="',m(d),'"')}return e.push(">"),x(e,c,l),l}}((s=t.blockedSegment).chunks,r,a,e.responseState,s.formatContext),s.lastPushedText=!1,c=s.formatContext,s.formatContext=function(e,t,r){switch(t){case"select":return E(1,null!=r.value?r.value:r.defaultValue);case"svg":return E(2,null);case"math":return E(3,null);case"foreignObject":return E(1,null);case"table":return E(4,null);case"thead":case"tbody":case"tfoot":return E(5,null);case"colgroup":return E(7,null);case"tr":return E(6,null)}return 4<=e.insertionMode||0===e.insertionMode?E(1,null):e}(c,r,a),Xe(e,t,l),s.formatContext=c,r){case"area":case"base":case"br":case"col":case"embed":case"hr":case"img":case"input":case"keygen":case"link":case"meta":case"param":case"source":case"track":case"wbr":break;default:s.chunks.push("</",r,">")}s.lastPushedText=!1}}function Ke(e,t,r){if(t.node=r,"object"==typeof r&&null!==r){switch(r.$$typeof){case N:return void Ge(e,t,r.type,r.props,r.ref);case D:throw Error(o(257));case q:var n=r._init;return void Ke(e,t,r=n(r._payload))}if(O(r))return void Ye(e,t,r);if((n=null===r||"object"!=typeof r?null:"function"==typeof(n=Q&&r[Q]||r["@@iterator"])?n:null)&&(n=n.call(r))){if(!(r=n.next()).done){var i=[];do{i.push(r.value),r=n.next()}while(!r.done);Ye(e,t,i)}return}throw e=Object.prototype.toString.call(r),Error(o(31,"[object Object]"===e?"object with keys {"+Object.keys(r).join(", ")+"}":e))}"string"==typeof r?(n=t.blockedSegment).lastPushedText=L(t.blockedSegment.chunks,r,e.responseState,n.lastPushedText):"number"==typeof r&&((n=t.blockedSegment).lastPushedText=L(t.blockedSegment.chunks,""+r,e.responseState,n.lastPushedText))}function Ye(e,t,r){for(var n=r.length,o=0;o<n;o++){var i=t.treeContext;t.treeContext=de(i,n,o);try{Xe(e,t,r[o])}finally{t.treeContext=i}}}function Xe(e,t,r){var n=t.blockedSegment.formatContext,o=t.legacyContext,i=t.context;try{return Ke(e,t,r)}catch(l){if(Re(),"object"!=typeof l||null===l||"function"!=typeof l.then)throw t.blockedSegment.formatContext=n,t.legacyContext=o,t.context=i,se(i),l;r=l;var a=t.blockedSegment,s=Be(0,a.chunks.length,null,a.formatContext,a.lastPushedText,!0);a.children.push(s),a.lastPushedText=!1,e=Ue(e,t.node,t.blockedBoundary,s,t.abortSet,t.legacyContext,t.context,t.treeContext).ping,r.then(e,e),t.blockedSegment.formatContext=n,t.legacyContext=o,t.context=i,se(i)}}function Qe(e){var t=e.blockedBoundary;(e=e.blockedSegment).status=3,et(this,t,e)}function Je(e,t,r){var n=e.blockedBoundary;e.blockedSegment.status=3,null===n?(t.allPendingTasks--,2!==t.status&&(t.status=2,null!==t.destination&&t.destination.push(null))):(n.pendingTasks--,n.forceClientRender||(n.forceClientRender=!0,e=void 0===r?Error(o(432)):r,n.errorDigest=t.onError(e),n.parentFlushed&&t.clientRenderedBoundaries.push(n)),n.fallbackAbortableTasks.forEach((function(e){return Je(e,t,r)})),n.fallbackAbortableTasks.clear(),t.allPendingTasks--,0===t.allPendingTasks&&(n=t.onAllReady)())}function Ze(e,t){if(0===t.chunks.length&&1===t.children.length&&null===t.children[0].boundary){var r=t.children[0];r.id=t.id,r.parentFlushed=!0,1===r.status&&Ze(e,r)}else e.completedSegments.push(t)}function et(e,t,r){if(null===t){if(r.parentFlushed){if(null!==e.completedRootSegment)throw Error(o(389));e.completedRootSegment=r}e.pendingRootTasks--,0===e.pendingRootTasks&&(e.onShellError=Ve,(t=e.onShellReady)())}else t.pendingTasks--,t.forceClientRender||(0===t.pendingTasks?(r.parentFlushed&&1===r.status&&Ze(t,r),t.parentFlushed&&e.completedBoundaries.push(t),t.fallbackAbortableTasks.forEach(Qe,e),t.fallbackAbortableTasks.clear()):r.parentFlushed&&1===r.status&&(Ze(t,r),1===t.completedSegments.length&&t.parentFlushed&&e.partialBoundaries.push(t)));e.allPendingTasks--,0===e.allPendingTasks&&(e=e.onAllReady)()}function tt(e){if(2!==e.status){var t=te,r=Fe.current;Fe.current=Ne;var n=De;De=e.responseState;try{var o,i=e.pingedTasks;for(o=0;o<i.length;o++){var a=i[o],s=e,l=a.blockedSegment;if(0===l.status){se(a.context);try{Ke(s,a,a.node),s.responseState.generateStaticMarkup||l.lastPushedText&&l.textEmbedded&&l.chunks.push("\x3c!-- --\x3e"),a.abortSet.delete(a),l.status=1,et(s,a.blockedBoundary,l)}catch(e){if(Re(),"object"==typeof e&&null!==e&&"function"==typeof e.then){var u=a.ping;e.then(u,u)}else{a.abortSet.delete(a),l.status=4;var c=a.blockedBoundary,d=e,p=ze(s,d);null===c?$e(s,d):(c.pendingTasks--,c.forceClientRender||(c.forceClientRender=!0,c.errorDigest=p,c.parentFlushed&&s.clientRenderedBoundaries.push(c))),s.allPendingTasks--,0===s.allPendingTasks&&(0,s.onAllReady)()}}}}i.splice(0,o),null!==e.destination&&st(e,e.destination)}catch(t){ze(e,t),$e(e,t)}finally{De=n,Fe.current=r,r===Ne&&se(t)}}}function rt(e,t,r){switch(r.parentFlushed=!0,r.status){case 0:var n=r.id=e.nextSegmentId++;return r.lastPushedText=!1,r.textEmbedded=!1,e=e.responseState,t.push('<template id="'),t.push(e.placeholderPrefix),e=n.toString(16),t.push(e),t.push('"></template>');case 1:r.status=2;var i=!0;n=r.chunks;var a=0;r=r.children;for(var s=0;s<r.length;s++){for(i=r[s];a<i.index;a++)t.push(n[a]);i=nt(e,t,i)}for(;a<n.length-1;a++)t.push(n[a]);return a<n.length&&(i=t.push(n[a])),i;default:throw Error(o(390))}}function nt(e,t,r){var n=r.boundary;if(null===n)return rt(e,t,r);if(n.parentFlushed=!0,n.forceClientRender)return e.responseState.generateStaticMarkup||(n=n.errorDigest,t.push("\x3c!--$!--\x3e"),t.push("<template"),n&&(t.push(' data-dgst="'),n=m(n),t.push(n),t.push('"')),t.push("></template>")),rt(e,t,r),!!e.responseState.generateStaticMarkup||t.push("\x3c!--/$--\x3e");if(0<n.pendingTasks){n.rootSegmentID=e.nextSegmentId++,0<n.completedSegments.length&&e.partialBoundaries.push(n);var i=e.responseState,a=i.nextSuspenseID++;return i=i.boundaryPrefix+a.toString(16),n=n.id=i,A(t,e.responseState,n),rt(e,t,r),t.push("\x3c!--/$--\x3e")}if(n.byteSize>e.progressiveChunkSize)return n.rootSegmentID=e.nextSegmentId++,e.completedBoundaries.push(n),A(t,e.responseState,n.id),rt(e,t,r),t.push("\x3c!--/$--\x3e");if(e.responseState.generateStaticMarkup||t.push("\x3c!--$--\x3e"),1!==(r=n.completedSegments).length)throw Error(o(391));return nt(e,t,r[0]),!!e.responseState.generateStaticMarkup||t.push("\x3c!--/$--\x3e")}function ot(e,t,r){return function(e,t,r,n){switch(r.insertionMode){case 0:case 1:return e.push('<div hidden id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 2:return e.push('<svg aria-hidden="true" style="display:none" id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 3:return e.push('<math aria-hidden="true" style="display:none" id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 4:return e.push('<table hidden id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 5:return e.push('<table hidden><tbody id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 6:return e.push('<table hidden><tr id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');case 7:return e.push('<table hidden><colgroup id="'),e.push(t.segmentPrefix),t=n.toString(16),e.push(t),e.push('">');default:throw Error(o(397))}}(t,e.responseState,r.formatContext,r.id),nt(e,t,r),function(e,t){switch(t.insertionMode){case 0:case 1:return e.push("</div>");case 2:return e.push("</svg>");case 3:return e.push("</math>");case 4:return e.push("</table>");case 5:return e.push("</tbody></table>");case 6:return e.push("</tr></table>");case 7:return e.push("</colgroup></table>");default:throw Error(o(397))}}(t,r.formatContext)}function it(e,t,r){for(var n=r.completedSegments,i=0;i<n.length;i++)at(e,t,r,n[i]);if(n.length=0,e=e.responseState,n=r.id,r=r.rootSegmentID,t.push(e.startInlineScript),e.sentCompleteBoundaryFunction?t.push('$RC("'):(e.sentCompleteBoundaryFunction=!0,t.push('function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}};$RC("')),null===n)throw Error(o(395));return r=r.toString(16),t.push(n),t.push('","'),t.push(e.segmentPrefix),t.push(r),t.push('")<\/script>')}function at(e,t,r,n){if(2===n.status)return!0;var i=n.id;if(-1===i){if(-1===(n.id=r.rootSegmentID))throw Error(o(392));return ot(e,t,n)}return ot(e,t,n),e=e.responseState,t.push(e.startInlineScript),e.sentCompleteSegmentFunction?t.push('$RS("'):(e.sentCompleteSegmentFunction=!0,t.push('function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("')),t.push(e.segmentPrefix),i=i.toString(16),t.push(i),t.push('","'),t.push(e.placeholderPrefix),t.push(i),t.push('")<\/script>')}function st(e,t){try{var r=e.completedRootSegment;if(null!==r&&0===e.pendingRootTasks){nt(e,t,r),e.completedRootSegment=null;var n=e.responseState.bootstrapChunks;for(r=0;r<n.length-1;r++)t.push(n[r]);r<n.length&&t.push(n[r])}var i,a=e.clientRenderedBoundaries;for(i=0;i<a.length;i++){var s=a[i];n=t;var l=e.responseState,u=s.id,c=s.errorDigest,d=s.errorMessage,p=s.errorComponentStack;if(n.push(l.startInlineScript),l.sentClientRenderFunction?n.push('$RX("'):(l.sentClientRenderFunction=!0,n.push('function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};$RX("')),null===u)throw Error(o(395));if(n.push(u),n.push('"'),c||d||p){n.push(",");var f=P(c||"");n.push(f)}if(d||p){n.push(",");var h=P(d||"");n.push(h)}if(p){n.push(",");var g=P(p);n.push(g)}if(!n.push(")<\/script>"))return e.destination=null,i++,void a.splice(0,i)}a.splice(0,i);var v=e.completedBoundaries;for(i=0;i<v.length;i++)if(!it(e,t,v[i]))return e.destination=null,i++,void v.splice(0,i);v.splice(0,i);var m=e.partialBoundaries;for(i=0;i<m.length;i++){var y=m[i];e:{a=e,s=t;var b=y.completedSegments;for(l=0;l<b.length;l++)if(!at(a,s,y,b[l])){l++,b.splice(0,l);var O=!1;break e}b.splice(0,l),O=!0}if(!O)return e.destination=null,i++,void m.splice(0,i)}m.splice(0,i);var E=e.completedBoundaries;for(i=0;i<E.length;i++)if(!it(e,t,E[i]))return e.destination=null,i++,void E.splice(0,i);E.splice(0,i)}finally{0===e.allPendingTasks&&0===e.pingedTasks.length&&0===e.clientRenderedBoundaries.length&&0===e.completedBoundaries.length&&t.push(null)}}function lt(e,t){try{var r=e.abortableTasks;r.forEach((function(r){return Je(r,e,t)})),r.clear(),null!==e.destination&&st(e,e.destination)}catch(t){ze(e,t),$e(e,t)}}function ut(){}function ct(e,t,r,n){var i=!1,a=null,s="",l={push:function(e){return null!==e&&(s+=e),!0},destroy:function(e){i=!0,a=e}},u=!1;if(e=function(e,t,r,n,o,i,a,s,l){var u=[],c=new Set;return(r=Be(t={destination:null,responseState:t,progressiveChunkSize:n,status:0,fatalError:null,nextSegmentId:0,allPendingTasks:0,pendingRootTasks:0,completedRootSegment:null,abortableTasks:c,pingedTasks:u,clientRenderedBoundaries:[],completedBoundaries:[],partialBoundaries:[],onError:void 0===o?Me:o,onAllReady:Ve,onShellReady:void 0===a?Ve:a,onShellError:Ve,onFatalError:Ve},0,null,r,!1,!1)).parentFlushed=!0,e=Ue(t,e,null,r,c,Z,null,ce),u.push(e),t}(e,function(e,t){return{bootstrapChunks:[],startInlineScript:"<script>",placeholderPrefix:(t=void 0===t?"":t)+"P:",segmentPrefix:t+"S:",boundaryPrefix:t+"B:",idPrefix:t,nextSuspenseID:0,sentCompleteSegmentFunction:!1,sentCompleteBoundaryFunction:!1,sentClientRenderFunction:!1,generateStaticMarkup:e}}(r,t?t.identifierPrefix:void 0),{insertionMode:1,selectedValue:null},1/0,ut,0,(function(){u=!0})),tt(e),lt(e,n),1===e.status)e.status=2,l.destroy(e.fatalError);else if(2!==e.status&&null===e.destination){e.destination=l;try{st(e,l)}catch(t){ze(e,t),$e(e,t)}}if(i)throw a;if(!u)throw Error(o(426));return s}t.renderToNodeStream=function(){throw Error(o(207))},t.renderToStaticMarkup=function(e,t){return ct(e,t,!0,'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToReadableStream" which supports Suspense on the server')},t.renderToStaticNodeStream=function(){throw Error(o(208))},t.renderToString=function(e,t){return ct(e,t,!1,'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToReadableStream" which supports Suspense on the server')},t.version="18.2.0"},1679:(e,t,r)=>{"use strict";var n=r(5959);function o(e){for(var t="https://reactjs.org/docs/error-decoder.html?invariant="+e,r=1;r<arguments.length;r++)t+="&args[]="+encodeURIComponent(arguments[r]);return"Minified React error #"+e+"; visit "+t+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var i=null,a=0;function s(e,t){if(0!==t.length)if(512<t.length)0<a&&(e.enqueue(new Uint8Array(i.buffer,0,a)),i=new Uint8Array(512),a=0),e.enqueue(t);else{var r=i.length-a;r<t.length&&(0===r?e.enqueue(i):(i.set(t.subarray(0,r),a),e.enqueue(i),t=t.subarray(r)),i=new Uint8Array(512),a=0),i.set(t,a),a+=t.length}}function l(e,t){return s(e,t),!0}function u(e){i&&0<a&&(e.enqueue(new Uint8Array(i.buffer,0,a)),i=null,a=0)}var c=new TextEncoder;function d(e){return c.encode(e)}function p(e){return c.encode(e)}function f(e,t){"function"==typeof e.error?e.error(t):e.close()}var h=Object.prototype.hasOwnProperty,g=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,v={},m={};function y(e){return!!h.call(m,e)||!h.call(v,e)&&(g.test(e)?m[e]=!0:(v[e]=!0,!1))}function b(e,t,r,n,o,i,a){this.acceptsBooleans=2===t||3===t||4===t,this.attributeName=n,this.attributeNamespace=o,this.mustUseProperty=r,this.propertyName=e,this.type=t,this.sanitizeURL=i,this.removeEmptyString=a}var O={};"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach((function(e){O[e]=new b(e,0,!1,e,null,!1,!1)})),[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach((function(e){var t=e[0];O[t]=new b(t,1,!1,e[1],null,!1,!1)})),["contentEditable","draggable","spellCheck","value"].forEach((function(e){O[e]=new b(e,2,!1,e.toLowerCase(),null,!1,!1)})),["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach((function(e){O[e]=new b(e,2,!1,e,null,!1,!1)})),"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach((function(e){O[e]=new b(e,3,!1,e.toLowerCase(),null,!1,!1)})),["checked","multiple","muted","selected"].forEach((function(e){O[e]=new b(e,3,!0,e,null,!1,!1)})),["capture","download"].forEach((function(e){O[e]=new b(e,4,!1,e,null,!1,!1)})),["cols","rows","size","span"].forEach((function(e){O[e]=new b(e,6,!1,e,null,!1,!1)})),["rowSpan","start"].forEach((function(e){O[e]=new b(e,5,!1,e.toLowerCase(),null,!1,!1)}));var E=/[\-:]([a-z])/g;function S(e){return e[1].toUpperCase()}"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach((function(e){var t=e.replace(E,S);O[t]=new b(t,1,!1,e,null,!1,!1)})),"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach((function(e){var t=e.replace(E,S);O[t]=new b(t,1,!1,e,"http://www.w3.org/1999/xlink",!1,!1)})),["xml:base","xml:lang","xml:space"].forEach((function(e){var t=e.replace(E,S);O[t]=new b(t,1,!1,e,"http://www.w3.org/XML/1998/namespace",!1,!1)})),["tabIndex","crossOrigin"].forEach((function(e){O[e]=new b(e,1,!1,e.toLowerCase(),null,!1,!1)})),O.xlinkHref=new b("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1),["src","href","action","formAction"].forEach((function(e){O[e]=new b(e,1,!1,e.toLowerCase(),null,!0,!0)}));var w={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},T=["Webkit","ms","Moz","O"];Object.keys(w).forEach((function(e){T.forEach((function(t){t=t+e.charAt(0).toUpperCase()+e.substring(1),w[t]=w[e]}))}));var x=/["'&<>]/;function _(e){if("boolean"==typeof e||"number"==typeof e)return""+e;e=""+e;var t=x.exec(e);if(t){var r,n="",o=0;for(r=t.index;r<e.length;r++){switch(e.charCodeAt(r)){case 34:t="&quot;";break;case 38:t="&amp;";break;case 39:t="&#x27;";break;case 60:t="&lt;";break;case 62:t="&gt;";break;default:continue}o!==r&&(n+=e.substring(o,r)),o=r+1,n+=t}e=o!==r?n+e.substring(o,r):n}return e}var C=/([A-Z])/g,R=/^ms-/,I=Array.isArray,A=p("<script>"),j=p("<\/script>"),P=p('<script src="'),L=p('<script type="module" src="'),k=p('" async=""><\/script>'),N=/(<\/|<)(s)(cript)/gi;function D(e,t,r,n){return t+("s"===r?"\\u0073":"\\u0053")+n}function F(e,t){return{insertionMode:e,selectedValue:t}}var M=p("\x3c!-- --\x3e");function V(e,t,r,n){return""===t?n:(n&&e.push(M),e.push(d(_(t))),!0)}var U=new Map,B=p(' style="'),z=p(":"),$=p(";");function W(e,t,r){if("object"!=typeof r)throw Error(o(62));for(var n in t=!0,r)if(h.call(r,n)){var i=r[n];if(null!=i&&"boolean"!=typeof i&&""!==i){if(0===n.indexOf("--")){var a=d(_(n));i=d(_((""+i).trim()))}else{a=n;var s=U.get(a);void 0!==s||(s=p(_(a.replace(C,"-$1").toLowerCase().replace(R,"-ms-"))),U.set(a,s)),a=s,i="number"==typeof i?0===i||h.call(w,n)?d(""+i):d(i+"px"):d(_((""+i).trim()))}t?(t=!1,e.push(B,a,z,i)):e.push($,a,z,i)}}t||e.push(G)}var H=p(" "),q=p('="'),G=p('"'),K=p('=""');function Y(e,t,r,n){switch(r){case"style":return void W(e,t,n);case"defaultValue":case"defaultChecked":case"innerHTML":case"suppressContentEditableWarning":case"suppressHydrationWarning":return}if(!(2<r.length)||"o"!==r[0]&&"O"!==r[0]||"n"!==r[1]&&"N"!==r[1])if(null!==(t=O.hasOwnProperty(r)?O[r]:null)){switch(typeof n){case"function":case"symbol":return;case"boolean":if(!t.acceptsBooleans)return}switch(r=d(t.attributeName),t.type){case 3:n&&e.push(H,r,K);break;case 4:!0===n?e.push(H,r,K):!1!==n&&e.push(H,r,q,d(_(n)),G);break;case 5:isNaN(n)||e.push(H,r,q,d(_(n)),G);break;case 6:!isNaN(n)&&1<=n&&e.push(H,r,q,d(_(n)),G);break;default:t.sanitizeURL&&(n=""+n),e.push(H,r,q,d(_(n)),G)}}else if(y(r)){switch(typeof n){case"function":case"symbol":return;case"boolean":if("data-"!==(t=r.toLowerCase().slice(0,5))&&"aria-"!==t)return}e.push(H,d(r),q,d(_(n)),G)}}var X=p(">"),Q=p("/>");function J(e,t,r){if(null!=t){if(null!=r)throw Error(o(60));if("object"!=typeof t||!("__html"in t))throw Error(o(61));null!=(t=t.__html)&&e.push(d(""+t))}}var Z=p(' selected=""');function ee(e,t,r,n){e.push(oe(r));var o,i=r=null;for(o in t)if(h.call(t,o)){var a=t[o];if(null!=a)switch(o){case"children":r=a;break;case"dangerouslySetInnerHTML":i=a;break;default:Y(e,n,o,a)}}return e.push(X),J(e,i,r),"string"==typeof r?(e.push(d(_(r))),null):r}var te=p("\n"),re=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,ne=new Map;function oe(e){var t=ne.get(e);if(void 0===t){if(!re.test(e))throw Error(o(65,e));t=p("<"+e),ne.set(e,t)}return t}var ie=p("<!DOCTYPE html>");var ae=p("</"),se=p(">"),le=p('<template id="'),ue=p('"></template>'),ce=p("\x3c!--$--\x3e"),de=p('\x3c!--$?--\x3e<template id="'),pe=p('"></template>'),fe=p("\x3c!--$!--\x3e"),he=p("\x3c!--/$--\x3e"),ge=p("<template"),ve=p('"'),me=p(' data-dgst="');p(' data-msg="'),p(' data-stck="');var ye=p("></template>");function be(e,t,r){if(s(e,de),null===r)throw Error(o(395));return s(e,r),l(e,pe)}var Oe=p('<div hidden id="'),Ee=p('">'),Se=p("</div>"),we=p('<svg aria-hidden="true" style="display:none" id="'),Te=p('">'),xe=p("</svg>"),_e=p('<math aria-hidden="true" style="display:none" id="'),Ce=p('">'),Re=p("</math>"),Ie=p('<table hidden id="'),Ae=p('">'),je=p("</table>"),Pe=p('<table hidden><tbody id="'),Le=p('">'),ke=p("</tbody></table>"),Ne=p('<table hidden><tr id="'),De=p('">'),Fe=p("</tr></table>"),Me=p('<table hidden><colgroup id="'),Ve=p('">'),Ue=p("</colgroup></table>"),Be=p('function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("'),ze=p('$RS("'),$e=p('","'),We=p('")<\/script>'),He=p('function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}};$RC("'),qe=p('$RC("'),Ge=p('","'),Ke=p('")<\/script>'),Ye=p('function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};$RX("'),Xe=p('$RX("'),Qe=p('"'),Je=p(")<\/script>"),Ze=p(","),et=/[<\u2028\u2029]/g;function tt(e){return JSON.stringify(e).replace(et,(function(e){switch(e){case"<":return"\\u003c";case"\u2028":return"\\u2028";case"\u2029":return"\\u2029";default:throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React")}}))}var rt=Object.assign,nt=Symbol.for("react.element"),ot=Symbol.for("react.portal"),it=Symbol.for("react.fragment"),at=Symbol.for("react.strict_mode"),st=Symbol.for("react.profiler"),lt=Symbol.for("react.provider"),ut=Symbol.for("react.context"),ct=Symbol.for("react.forward_ref"),dt=Symbol.for("react.suspense"),pt=Symbol.for("react.suspense_list"),ft=Symbol.for("react.memo"),ht=Symbol.for("react.lazy"),gt=Symbol.for("react.scope"),vt=Symbol.for("react.debug_trace_mode"),mt=Symbol.for("react.legacy_hidden"),yt=Symbol.for("react.default_value"),bt=Symbol.iterator;function Ot(e){if(null==e)return null;if("function"==typeof e)return e.displayName||e.name||null;if("string"==typeof e)return e;switch(e){case it:return"Fragment";case ot:return"Portal";case st:return"Profiler";case at:return"StrictMode";case dt:return"Suspense";case pt:return"SuspenseList"}if("object"==typeof e)switch(e.$$typeof){case ut:return(e.displayName||"Context")+".Consumer";case lt:return(e._context.displayName||"Context")+".Provider";case ct:var t=e.render;return(e=e.displayName)||(e=""!==(e=t.displayName||t.name||"")?"ForwardRef("+e+")":"ForwardRef"),e;case ft:return null!==(t=e.displayName||null)?t:Ot(e.type)||"Memo";case ht:t=e._payload,e=e._init;try{return Ot(e(t))}catch(e){}}return null}var Et={};function St(e,t){if(!(e=e.contextTypes))return Et;var r,n={};for(r in e)n[r]=t[r];return n}var wt=null;function Tt(e,t){if(e!==t){e.context._currentValue=e.parentValue,e=e.parent;var r=t.parent;if(null===e){if(null!==r)throw Error(o(401))}else{if(null===r)throw Error(o(401));Tt(e,r)}t.context._currentValue=t.value}}function xt(e){e.context._currentValue=e.parentValue,null!==(e=e.parent)&&xt(e)}function _t(e){var t=e.parent;null!==t&&_t(t),e.context._currentValue=e.value}function Ct(e,t){if(e.context._currentValue=e.parentValue,null===(e=e.parent))throw Error(o(402));e.depth===t.depth?Tt(e,t):Ct(e,t)}function Rt(e,t){var r=t.parent;if(null===r)throw Error(o(402));e.depth===r.depth?Tt(e,r):Rt(e,r),t.context._currentValue=t.value}function It(e){var t=wt;t!==e&&(null===t?_t(e):null===e?xt(t):t.depth===e.depth?Tt(t,e):t.depth>e.depth?Ct(t,e):Rt(t,e),wt=e)}var At={isMounted:function(){return!1},enqueueSetState:function(e,t){null!==(e=e._reactInternals).queue&&e.queue.push(t)},enqueueReplaceState:function(e,t){(e=e._reactInternals).replace=!0,e.queue=[t]},enqueueForceUpdate:function(){}};function jt(e,t,r,n){var o=void 0!==e.state?e.state:null;e.updater=At,e.props=r,e.state=o;var i={queue:[],replace:!1};e._reactInternals=i;var a=t.contextType;if(e.context="object"==typeof a&&null!==a?a._currentValue:n,"function"==typeof(a=t.getDerivedStateFromProps)&&(o=null==(a=a(r,o))?o:rt({},o,a),e.state=o),"function"!=typeof t.getDerivedStateFromProps&&"function"!=typeof e.getSnapshotBeforeUpdate&&("function"==typeof e.UNSAFE_componentWillMount||"function"==typeof e.componentWillMount))if(t=e.state,"function"==typeof e.componentWillMount&&e.componentWillMount(),"function"==typeof e.UNSAFE_componentWillMount&&e.UNSAFE_componentWillMount(),t!==e.state&&At.enqueueReplaceState(e,e.state,null),null!==i.queue&&0<i.queue.length)if(t=i.queue,a=i.replace,i.queue=null,i.replace=!1,a&&1===t.length)e.state=t[0];else{for(i=a?t[0]:e.state,o=!0,a=a?1:0;a<t.length;a++){var s=t[a];null!=(s="function"==typeof s?s.call(e,i,r,n):s)&&(o?(o=!1,i=rt({},i,s)):rt(i,s))}e.state=i}else i.queue=null}var Pt={id:1,overflow:""};function Lt(e,t,r){var n=e.id;e=e.overflow;var o=32-kt(n)-1;n&=~(1<<o),r+=1;var i=32-kt(t)+o;if(30<i){var a=o-o%5;return i=(n&(1<<a)-1).toString(32),n>>=a,o-=a,{id:1<<32-kt(t)+o|r<<o|n,overflow:i+e}}return{id:1<<i|r<<o|n,overflow:e}}var kt=Math.clz32?Math.clz32:function(e){return 0==(e>>>=0)?32:31-(Nt(e)/Dt|0)|0},Nt=Math.log,Dt=Math.LN2,Ft="function"==typeof Object.is?Object.is:function(e,t){return e===t&&(0!==e||1/e==1/t)||e!=e&&t!=t},Mt=null,Vt=null,Ut=null,Bt=null,zt=!1,$t=!1,Wt=0,Ht=null,qt=0;function Gt(){if(null===Mt)throw Error(o(321));return Mt}function Kt(){if(0<qt)throw Error(o(312));return{memoizedState:null,queue:null,next:null}}function Yt(){return null===Bt?null===Ut?(zt=!1,Ut=Bt=Kt()):(zt=!0,Bt=Ut):null===Bt.next?(zt=!1,Bt=Bt.next=Kt()):(zt=!0,Bt=Bt.next),Bt}function Xt(){Vt=Mt=null,$t=!1,Ut=null,qt=0,Bt=Ht=null}function Qt(e,t){return"function"==typeof t?t(e):t}function Jt(e,t,r){if(Mt=Gt(),Bt=Yt(),zt){var n=Bt.queue;if(t=n.dispatch,null!==Ht&&void 0!==(r=Ht.get(n))){Ht.delete(n),n=Bt.memoizedState;do{n=e(n,r.action),r=r.next}while(null!==r);return Bt.memoizedState=n,[n,t]}return[Bt.memoizedState,t]}return e=e===Qt?"function"==typeof t?t():t:void 0!==r?r(t):t,Bt.memoizedState=e,e=(e=Bt.queue={last:null,dispatch:null}).dispatch=er.bind(null,Mt,e),[Bt.memoizedState,e]}function Zt(e,t){if(Mt=Gt(),t=void 0===t?null:t,null!==(Bt=Yt())){var r=Bt.memoizedState;if(null!==r&&null!==t){var n=r[1];e:if(null===n)n=!1;else{for(var o=0;o<n.length&&o<t.length;o++)if(!Ft(t[o],n[o])){n=!1;break e}n=!0}if(n)return r[0]}}return e=e(),Bt.memoizedState=[e,t],e}function er(e,t,r){if(25<=qt)throw Error(o(301));if(e===Mt)if($t=!0,e={action:r,next:null},null===Ht&&(Ht=new Map),void 0===(r=Ht.get(t)))Ht.set(t,e);else{for(t=r;null!==t.next;)t=t.next;t.next=e}}function tr(){throw Error(o(394))}function rr(){}var nr={readContext:function(e){return e._currentValue},useContext:function(e){return Gt(),e._currentValue},useMemo:Zt,useReducer:Jt,useRef:function(e){Mt=Gt();var t=(Bt=Yt()).memoizedState;return null===t?(e={current:e},Bt.memoizedState=e):t},useState:function(e){return Jt(Qt,e)},useInsertionEffect:rr,useLayoutEffect:function(){},useCallback:function(e,t){return Zt((function(){return e}),t)},useImperativeHandle:rr,useEffect:rr,useDebugValue:rr,useDeferredValue:function(e){return Gt(),e},useTransition:function(){return Gt(),[!1,tr]},useId:function(){var e=Vt.treeContext,t=e.overflow;e=((e=e.id)&~(1<<32-kt(e)-1)).toString(32)+t;var r=or;if(null===r)throw Error(o(404));return t=Wt++,e=":"+r.idPrefix+"R"+e,0<t&&(e+="H"+t.toString(32)),e+":"},useMutableSource:function(e,t){return Gt(),t(e._source)},useSyncExternalStore:function(e,t,r){if(void 0===r)throw Error(o(407));return r()}},or=null,ir=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentDispatcher;function ar(e){return console.error(e),null}function sr(){}function lr(e,t,r,n,o,i,a,s){e.allPendingTasks++,null===r?e.pendingRootTasks++:r.pendingTasks++;var l={node:t,ping:function(){var t=e.pingedTasks;t.push(l),1===t.length&&wr(e)},blockedBoundary:r,blockedSegment:n,abortSet:o,legacyContext:i,context:a,treeContext:s};return o.add(l),l}function ur(e,t,r,n,o,i){return{status:0,id:-1,index:t,parentFlushed:!1,chunks:[],children:[],formatContext:n,boundary:r,lastPushedText:o,textEmbedded:i}}function cr(e,t){if(null!=(e=e.onError(t))&&"string"!=typeof e)throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "'+typeof e+'" instead');return e}function dr(e,t){var r=e.onShellError;r(t),(r=e.onFatalError)(t),null!==e.destination?(e.status=2,f(e.destination,t)):(e.status=1,e.fatalError=t)}function pr(e,t,r,n,o){for(Mt={},Vt=t,Wt=0,e=r(n,o);$t;)$t=!1,Wt=0,qt+=1,Bt=null,e=r(n,o);return Xt(),e}function fr(e,t,r,n){var i=r.render(),a=n.childContextTypes;if(null!=a){var s=t.legacyContext;if("function"!=typeof r.getChildContext)n=s;else{for(var l in r=r.getChildContext())if(!(l in a))throw Error(o(108,Ot(n)||"Unknown",l));n=rt({},s,r)}t.legacyContext=n,vr(e,t,i),t.legacyContext=s}else vr(e,t,i)}function hr(e,t){if(e&&e.defaultProps){for(var r in t=rt({},t),e=e.defaultProps)void 0===t[r]&&(t[r]=e[r]);return t}return t}function gr(e,t,r,i,a){if("function"==typeof r)if(r.prototype&&r.prototype.isReactComponent){a=St(r,t.legacyContext);var s=r.contextType;jt(s=new r(i,"object"==typeof s&&null!==s?s._currentValue:a),r,i,a),fr(e,t,s,r)}else{a=pr(e,t,r,i,s=St(r,t.legacyContext));var l=0!==Wt;if("object"==typeof a&&null!==a&&"function"==typeof a.render&&void 0===a.$$typeof)jt(a,r,i,s),fr(e,t,a,r);else if(l){i=t.treeContext,t.treeContext=Lt(i,1,0);try{vr(e,t,a)}finally{t.treeContext=i}}else vr(e,t,a)}else{if("string"!=typeof r){switch(r){case mt:case vt:case at:case st:case it:case pt:return void vr(e,t,i.children);case gt:throw Error(o(343));case dt:e:{r=t.blockedBoundary,a=t.blockedSegment,s=i.fallback,i=i.children;var u={id:null,rootSegmentID:-1,parentFlushed:!1,pendingTasks:0,forceClientRender:!1,completedSegments:[],byteSize:0,fallbackAbortableTasks:l=new Set,errorDigest:null},c=ur(0,a.chunks.length,u,a.formatContext,!1,!1);a.children.push(c),a.lastPushedText=!1;var p=ur(0,0,null,a.formatContext,!1,!1);p.parentFlushed=!0,t.blockedBoundary=u,t.blockedSegment=p;try{if(yr(e,t,i),p.lastPushedText&&p.textEmbedded&&p.chunks.push(M),p.status=1,Er(u,p),0===u.pendingTasks)break e}catch(t){p.status=4,u.forceClientRender=!0,u.errorDigest=cr(e,t)}finally{t.blockedBoundary=r,t.blockedSegment=a}t=lr(e,s,r,c,l,t.legacyContext,t.context,t.treeContext),e.pingedTasks.push(t)}return}if("object"==typeof r&&null!==r)switch(r.$$typeof){case ct:if(i=pr(e,t,r.render,i,a),0!==Wt){r=t.treeContext,t.treeContext=Lt(r,1,0);try{vr(e,t,i)}finally{t.treeContext=r}}else vr(e,t,i);return;case ft:return void gr(e,t,r=r.type,i=hr(r,i),a);case lt:if(a=i.children,r=r._context,i=i.value,s=r._currentValue,r._currentValue=i,wt=i={parent:l=wt,depth:null===l?0:l.depth+1,context:r,parentValue:s,value:i},t.context=i,vr(e,t,a),null===(e=wt))throw Error(o(403));return i=e.parentValue,e.context._currentValue=i===yt?e.context._defaultValue:i,e=wt=e.parent,void(t.context=e);case ut:return void vr(e,t,i=(i=i.children)(r._currentValue));case ht:return void gr(e,t,r=(a=r._init)(r._payload),i=hr(r,i),void 0)}throw Error(o(130,null==r?r:typeof r,""))}switch(s=function(e,t,r,i,a){switch(t){case"select":e.push(oe("select"));var s=null,l=null;for(f in r)if(h.call(r,f)){var u=r[f];if(null!=u)switch(f){case"children":s=u;break;case"dangerouslySetInnerHTML":l=u;break;case"defaultValue":case"value":break;default:Y(e,i,f,u)}}return e.push(X),J(e,l,s),s;case"option":l=a.selectedValue,e.push(oe("option"));var c=u=null,p=null,f=null;for(s in r)if(h.call(r,s)){var g=r[s];if(null!=g)switch(s){case"children":u=g;break;case"selected":p=g;break;case"dangerouslySetInnerHTML":f=g;break;case"value":c=g;default:Y(e,i,s,g)}}if(null!=l)if(r=null!==c?""+c:function(e){var t="";return n.Children.forEach(e,(function(e){null!=e&&(t+=e)})),t}(u),I(l)){for(i=0;i<l.length;i++)if(""+l[i]===r){e.push(Z);break}}else""+l===r&&e.push(Z);else p&&e.push(Z);return e.push(X),J(e,f,u),u;case"textarea":for(u in e.push(oe("textarea")),f=l=s=null,r)if(h.call(r,u)&&null!=(c=r[u]))switch(u){case"children":f=c;break;case"value":s=c;break;case"defaultValue":l=c;break;case"dangerouslySetInnerHTML":throw Error(o(91));default:Y(e,i,u,c)}if(null===s&&null!==l&&(s=l),e.push(X),null!=f){if(null!=s)throw Error(o(92));if(I(f)&&1<f.length)throw Error(o(93));s=""+f}return"string"==typeof s&&"\n"===s[0]&&e.push(te),null!==s&&e.push(d(_(""+s))),null;case"input":for(l in e.push(oe("input")),c=f=u=s=null,r)if(h.call(r,l)&&null!=(p=r[l]))switch(l){case"children":case"dangerouslySetInnerHTML":throw Error(o(399,"input"));case"defaultChecked":c=p;break;case"defaultValue":u=p;break;case"checked":f=p;break;case"value":s=p;break;default:Y(e,i,l,p)}return null!==f?Y(e,i,"checked",f):null!==c&&Y(e,i,"checked",c),null!==s?Y(e,i,"value",s):null!==u&&Y(e,i,"value",u),e.push(Q),null;case"menuitem":for(var v in e.push(oe("menuitem")),r)if(h.call(r,v)&&null!=(s=r[v]))switch(v){case"children":case"dangerouslySetInnerHTML":throw Error(o(400));default:Y(e,i,v,s)}return e.push(X),null;case"title":for(g in e.push(oe("title")),s=null,r)if(h.call(r,g)&&null!=(l=r[g]))switch(g){case"children":s=l;break;case"dangerouslySetInnerHTML":throw Error(o(434));default:Y(e,i,g,l)}return e.push(X),s;case"listing":case"pre":for(c in e.push(oe(t)),l=s=null,r)if(h.call(r,c)&&null!=(u=r[c]))switch(c){case"children":s=u;break;case"dangerouslySetInnerHTML":l=u;break;default:Y(e,i,c,u)}if(e.push(X),null!=l){if(null!=s)throw Error(o(60));if("object"!=typeof l||!("__html"in l))throw Error(o(61));null!=(r=l.__html)&&("string"==typeof r&&0<r.length&&"\n"===r[0]?e.push(te,d(r)):e.push(d(""+r)))}return"string"==typeof s&&"\n"===s[0]&&e.push(te),s;case"area":case"base":case"br":case"col":case"embed":case"hr":case"img":case"keygen":case"link":case"meta":case"param":case"source":case"track":case"wbr":for(var m in e.push(oe(t)),r)if(h.call(r,m)&&null!=(s=r[m]))switch(m){case"children":case"dangerouslySetInnerHTML":throw Error(o(399,t));default:Y(e,i,m,s)}return e.push(Q),null;case"annotation-xml":case"color-profile":case"font-face":case"font-face-src":case"font-face-uri":case"font-face-format":case"font-face-name":case"missing-glyph":return ee(e,r,t,i);case"html":return 0===a.insertionMode&&e.push(ie),ee(e,r,t,i);default:if(-1===t.indexOf("-")&&"string"!=typeof r.is)return ee(e,r,t,i);for(p in e.push(oe(t)),l=s=null,r)if(h.call(r,p)&&null!=(u=r[p]))switch(p){case"children":s=u;break;case"dangerouslySetInnerHTML":l=u;break;case"style":W(e,i,u);break;case"suppressContentEditableWarning":case"suppressHydrationWarning":break;default:y(p)&&"function"!=typeof u&&"symbol"!=typeof u&&e.push(H,d(p),q,d(_(u)),G)}return e.push(X),J(e,l,s),s}}((a=t.blockedSegment).chunks,r,i,e.responseState,a.formatContext),a.lastPushedText=!1,l=a.formatContext,a.formatContext=function(e,t,r){switch(t){case"select":return F(1,null!=r.value?r.value:r.defaultValue);case"svg":return F(2,null);case"math":return F(3,null);case"foreignObject":return F(1,null);case"table":return F(4,null);case"thead":case"tbody":case"tfoot":return F(5,null);case"colgroup":return F(7,null);case"tr":return F(6,null)}return 4<=e.insertionMode||0===e.insertionMode?F(1,null):e}(l,r,i),yr(e,t,s),a.formatContext=l,r){case"area":case"base":case"br":case"col":case"embed":case"hr":case"img":case"input":case"keygen":case"link":case"meta":case"param":case"source":case"track":case"wbr":break;default:a.chunks.push(ae,d(r),se)}a.lastPushedText=!1}}function vr(e,t,r){if(t.node=r,"object"==typeof r&&null!==r){switch(r.$$typeof){case nt:return void gr(e,t,r.type,r.props,r.ref);case ot:throw Error(o(257));case ht:var n=r._init;return void vr(e,t,r=n(r._payload))}if(I(r))return void mr(e,t,r);if((n=null===r||"object"!=typeof r?null:"function"==typeof(n=bt&&r[bt]||r["@@iterator"])?n:null)&&(n=n.call(r))){if(!(r=n.next()).done){var i=[];do{i.push(r.value),r=n.next()}while(!r.done);mr(e,t,i)}return}throw e=Object.prototype.toString.call(r),Error(o(31,"[object Object]"===e?"object with keys {"+Object.keys(r).join(", ")+"}":e))}"string"==typeof r?(n=t.blockedSegment).lastPushedText=V(t.blockedSegment.chunks,r,e.responseState,n.lastPushedText):"number"==typeof r&&((n=t.blockedSegment).lastPushedText=V(t.blockedSegment.chunks,""+r,e.responseState,n.lastPushedText))}function mr(e,t,r){for(var n=r.length,o=0;o<n;o++){var i=t.treeContext;t.treeContext=Lt(i,n,o);try{yr(e,t,r[o])}finally{t.treeContext=i}}}function yr(e,t,r){var n=t.blockedSegment.formatContext,o=t.legacyContext,i=t.context;try{return vr(e,t,r)}catch(l){if(Xt(),"object"!=typeof l||null===l||"function"!=typeof l.then)throw t.blockedSegment.formatContext=n,t.legacyContext=o,t.context=i,It(i),l;r=l;var a=t.blockedSegment,s=ur(0,a.chunks.length,null,a.formatContext,a.lastPushedText,!0);a.children.push(s),a.lastPushedText=!1,e=lr(e,t.node,t.blockedBoundary,s,t.abortSet,t.legacyContext,t.context,t.treeContext).ping,r.then(e,e),t.blockedSegment.formatContext=n,t.legacyContext=o,t.context=i,It(i)}}function br(e){var t=e.blockedBoundary;(e=e.blockedSegment).status=3,Sr(this,t,e)}function Or(e,t,r){var n=e.blockedBoundary;e.blockedSegment.status=3,null===n?(t.allPendingTasks--,2!==t.status&&(t.status=2,null!==t.destination&&t.destination.close())):(n.pendingTasks--,n.forceClientRender||(n.forceClientRender=!0,e=void 0===r?Error(o(432)):r,n.errorDigest=t.onError(e),n.parentFlushed&&t.clientRenderedBoundaries.push(n)),n.fallbackAbortableTasks.forEach((function(e){return Or(e,t,r)})),n.fallbackAbortableTasks.clear(),t.allPendingTasks--,0===t.allPendingTasks&&(n=t.onAllReady)())}function Er(e,t){if(0===t.chunks.length&&1===t.children.length&&null===t.children[0].boundary){var r=t.children[0];r.id=t.id,r.parentFlushed=!0,1===r.status&&Er(e,r)}else e.completedSegments.push(t)}function Sr(e,t,r){if(null===t){if(r.parentFlushed){if(null!==e.completedRootSegment)throw Error(o(389));e.completedRootSegment=r}e.pendingRootTasks--,0===e.pendingRootTasks&&(e.onShellError=sr,(t=e.onShellReady)())}else t.pendingTasks--,t.forceClientRender||(0===t.pendingTasks?(r.parentFlushed&&1===r.status&&Er(t,r),t.parentFlushed&&e.completedBoundaries.push(t),t.fallbackAbortableTasks.forEach(br,e),t.fallbackAbortableTasks.clear()):r.parentFlushed&&1===r.status&&(Er(t,r),1===t.completedSegments.length&&t.parentFlushed&&e.partialBoundaries.push(t)));e.allPendingTasks--,0===e.allPendingTasks&&(e=e.onAllReady)()}function wr(e){if(2!==e.status){var t=wt,r=ir.current;ir.current=nr;var n=or;or=e.responseState;try{var o,i=e.pingedTasks;for(o=0;o<i.length;o++){var a=i[o],s=e,l=a.blockedSegment;if(0===l.status){It(a.context);try{vr(s,a,a.node),l.lastPushedText&&l.textEmbedded&&l.chunks.push(M),a.abortSet.delete(a),l.status=1,Sr(s,a.blockedBoundary,l)}catch(e){if(Xt(),"object"==typeof e&&null!==e&&"function"==typeof e.then){var u=a.ping;e.then(u,u)}else{a.abortSet.delete(a),l.status=4;var c=a.blockedBoundary,d=e,p=cr(s,d);null===c?dr(s,d):(c.pendingTasks--,c.forceClientRender||(c.forceClientRender=!0,c.errorDigest=p,c.parentFlushed&&s.clientRenderedBoundaries.push(c))),s.allPendingTasks--,0===s.allPendingTasks&&(0,s.onAllReady)()}}}}i.splice(0,o),null!==e.destination&&Ir(e,e.destination)}catch(t){cr(e,t),dr(e,t)}finally{or=n,ir.current=r,r===nr&&It(t)}}}function Tr(e,t,r){switch(r.parentFlushed=!0,r.status){case 0:var n=r.id=e.nextSegmentId++;return r.lastPushedText=!1,r.textEmbedded=!1,e=e.responseState,s(t,le),s(t,e.placeholderPrefix),s(t,e=d(n.toString(16))),l(t,ue);case 1:r.status=2;var i=!0;n=r.chunks;var a=0;r=r.children;for(var u=0;u<r.length;u++){for(i=r[u];a<i.index;a++)s(t,n[a]);i=xr(e,t,i)}for(;a<n.length-1;a++)s(t,n[a]);return a<n.length&&(i=l(t,n[a])),i;default:throw Error(o(390))}}function xr(e,t,r){var n=r.boundary;if(null===n)return Tr(e,t,r);if(n.parentFlushed=!0,n.forceClientRender)n=n.errorDigest,l(t,fe),s(t,ge),n&&(s(t,me),s(t,d(_(n))),s(t,ve)),l(t,ye),Tr(e,t,r);else if(0<n.pendingTasks){n.rootSegmentID=e.nextSegmentId++,0<n.completedSegments.length&&e.partialBoundaries.push(n);var i=e.responseState,a=i.nextSuspenseID++;i=p(i.boundaryPrefix+a.toString(16)),n=n.id=i,be(t,e.responseState,n),Tr(e,t,r)}else if(n.byteSize>e.progressiveChunkSize)n.rootSegmentID=e.nextSegmentId++,e.completedBoundaries.push(n),be(t,e.responseState,n.id),Tr(e,t,r);else{if(l(t,ce),1!==(r=n.completedSegments).length)throw Error(o(391));xr(e,t,r[0])}return l(t,he)}function _r(e,t,r){return function(e,t,r,n){switch(r.insertionMode){case 0:case 1:return s(e,Oe),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Ee);case 2:return s(e,we),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Te);case 3:return s(e,_e),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Ce);case 4:return s(e,Ie),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Ae);case 5:return s(e,Pe),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Le);case 6:return s(e,Ne),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,De);case 7:return s(e,Me),s(e,t.segmentPrefix),s(e,d(n.toString(16))),l(e,Ve);default:throw Error(o(397))}}(t,e.responseState,r.formatContext,r.id),xr(e,t,r),function(e,t){switch(t.insertionMode){case 0:case 1:return l(e,Se);case 2:return l(e,xe);case 3:return l(e,Re);case 4:return l(e,je);case 5:return l(e,ke);case 6:return l(e,Fe);case 7:return l(e,Ue);default:throw Error(o(397))}}(t,r.formatContext)}function Cr(e,t,r){for(var n=r.completedSegments,i=0;i<n.length;i++)Rr(e,t,r,n[i]);if(n.length=0,e=e.responseState,n=r.id,r=r.rootSegmentID,s(t,e.startInlineScript),e.sentCompleteBoundaryFunction?s(t,qe):(e.sentCompleteBoundaryFunction=!0,s(t,He)),null===n)throw Error(o(395));return r=d(r.toString(16)),s(t,n),s(t,Ge),s(t,e.segmentPrefix),s(t,r),l(t,Ke)}function Rr(e,t,r,n){if(2===n.status)return!0;var i=n.id;if(-1===i){if(-1===(n.id=r.rootSegmentID))throw Error(o(392));return _r(e,t,n)}return _r(e,t,n),s(t,(e=e.responseState).startInlineScript),e.sentCompleteSegmentFunction?s(t,ze):(e.sentCompleteSegmentFunction=!0,s(t,Be)),s(t,e.segmentPrefix),s(t,i=d(i.toString(16))),s(t,$e),s(t,e.placeholderPrefix),s(t,i),l(t,We)}function Ir(e,t){i=new Uint8Array(512),a=0;try{var r=e.completedRootSegment;if(null!==r&&0===e.pendingRootTasks){xr(e,t,r),e.completedRootSegment=null;var n=e.responseState.bootstrapChunks;for(r=0;r<n.length-1;r++)s(t,n[r]);r<n.length&&l(t,n[r])}var c,p=e.clientRenderedBoundaries;for(c=0;c<p.length;c++){var f=p[c];n=t;var h=e.responseState,g=f.id,v=f.errorDigest,m=f.errorMessage,y=f.errorComponentStack;if(s(n,h.startInlineScript),h.sentClientRenderFunction?s(n,Xe):(h.sentClientRenderFunction=!0,s(n,Ye)),null===g)throw Error(o(395));if(s(n,g),s(n,Qe),(v||m||y)&&(s(n,Ze),s(n,d(tt(v||"")))),(m||y)&&(s(n,Ze),s(n,d(tt(m||"")))),y&&(s(n,Ze),s(n,d(tt(y)))),!l(n,Je))return e.destination=null,c++,void p.splice(0,c)}p.splice(0,c);var b=e.completedBoundaries;for(c=0;c<b.length;c++)if(!Cr(e,t,b[c]))return e.destination=null,c++,void b.splice(0,c);b.splice(0,c),u(t),i=new Uint8Array(512),a=0;var O=e.partialBoundaries;for(c=0;c<O.length;c++){var E=O[c];e:{p=e,f=t;var S=E.completedSegments;for(h=0;h<S.length;h++)if(!Rr(p,f,E,S[h])){h++,S.splice(0,h);var w=!1;break e}S.splice(0,h),w=!0}if(!w)return e.destination=null,c++,void O.splice(0,c)}O.splice(0,c);var T=e.completedBoundaries;for(c=0;c<T.length;c++)if(!Cr(e,t,T[c]))return e.destination=null,c++,void T.splice(0,c);T.splice(0,c)}finally{u(t),0===e.allPendingTasks&&0===e.pingedTasks.length&&0===e.clientRenderedBoundaries.length&&0===e.completedBoundaries.length&&t.close()}}function Ar(e,t){try{var r=e.abortableTasks;r.forEach((function(r){return Or(r,e,t)})),r.clear(),null!==e.destination&&Ir(e,e.destination)}catch(t){cr(e,t),dr(e,t)}}t.renderToReadableStream=function(e,t){return new Promise((function(r,n){var o,i,a=new Promise((function(e,t){i=e,o=t})),s=function(e,t,r,n,o,i,a,s,l){var u=[],c=new Set;return(r=ur(t={destination:null,responseState:t,progressiveChunkSize:void 0===n?12800:n,status:0,fatalError:null,nextSegmentId:0,allPendingTasks:0,pendingRootTasks:0,completedRootSegment:null,abortableTasks:c,pingedTasks:u,clientRenderedBoundaries:[],completedBoundaries:[],partialBoundaries:[],onError:void 0===o?ar:o,onAllReady:void 0===i?sr:i,onShellReady:void 0===a?sr:a,onShellError:void 0===s?sr:s,onFatalError:void 0===l?sr:l},0,null,r,!1,!1)).parentFlushed=!0,e=lr(t,e,null,r,c,Et,null,Pt),u.push(e),t}(e,function(e,t,r,n,o){e=void 0===e?"":e,t=void 0===t?A:p('<script nonce="'+_(t)+'">');var i=[];if(void 0!==r&&i.push(t,d((""+r).replace(N,D)),j),void 0!==n)for(r=0;r<n.length;r++)i.push(P,d(_(n[r])),k);if(void 0!==o)for(n=0;n<o.length;n++)i.push(L,d(_(o[n])),k);return{bootstrapChunks:i,startInlineScript:t,placeholderPrefix:p(e+"P:"),segmentPrefix:p(e+"S:"),boundaryPrefix:e+"B:",idPrefix:e,nextSuspenseID:0,sentCompleteSegmentFunction:!1,sentCompleteBoundaryFunction:!1,sentClientRenderFunction:!1}}(t?t.identifierPrefix:void 0,t?t.nonce:void 0,t?t.bootstrapScriptContent:void 0,t?t.bootstrapScripts:void 0,t?t.bootstrapModules:void 0),function(e){return F("http://www.w3.org/2000/svg"===e?2:"http://www.w3.org/1998/Math/MathML"===e?3:0,null)}(t?t.namespaceURI:void 0),t?t.progressiveChunkSize:void 0,t?t.onError:void 0,i,(function(){var e=new ReadableStream({type:"bytes",pull:function(e){if(1===s.status)s.status=2,f(e,s.fatalError);else if(2!==s.status&&null===s.destination){s.destination=e;try{Ir(s,e)}catch(e){cr(s,e),dr(s,e)}}},cancel:function(){Ar(s)}},{highWaterMark:0});e.allReady=a,r(e)}),(function(e){a.catch((function(){})),n(e)}),o);if(t&&t.signal){var l=t.signal,u=function(){Ar(s,l.reason),l.removeEventListener("abort",u)};l.addEventListener("abort",u)}wr(s)}))},t.version="18.2.0"},952:(e,t,r)=>{"use strict";var n,o;n=r(8641),o=r(1679),t.version=n.version,t.renderToString=n.renderToString,t.renderToStaticMarkup=n.renderToStaticMarkup,t.renderToNodeStream=n.renderToNodeStream,t.renderToStaticNodeStream=n.renderToStaticNodeStream,t.renderToReadableStream=o.renderToReadableStream},6563:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isNavigator=t.isBrowser=t.off=t.on=t.noop=void 0,t.noop=function(){},t.on=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.addEventListener&&e.addEventListener.apply(e,t)},t.off=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.removeEventListener&&e.removeEventListener.apply(e,t)},t.isBrowser="undefined"!=typeof window,t.isNavigator="undefined"!=typeof navigator},1777:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(5053));t.A=function(e,t){void 0===t&&(t=[]);var r=i.default(e,t,{loading:!0}),n=r[0],a=r[1];return o.useEffect((function(){a()}),[a]),n}},5053:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(7016),o=r(5959),i=n.__importDefault(r(9812));t.default=function(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var a=o.useRef(0),s=i.default(),l=o.useState(r),u=l[0],c=l[1],d=o.useCallback((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o=++a.current;return u.loading||c((function(e){return n.__assign(n.__assign({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return s()&&o===a.current&&c({value:e,loading:!1}),e}),(function(e){return s()&&o===a.current&&c({error:e,loading:!1}),e}))}),t);return[u,d]}},990:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(1854));t.A=function(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var n=i.default(e,t),a=n[0],s=n[1],l=n[2];return o.useEffect(l,r),[a,s]}},6943:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959),o=r(6563).isBrowser?n.useLayoutEffect:n.useEffect;t.default=o},8145:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(6943)),a=r(6563),s={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};t.A=a.isBrowser&&void 0!==window.ResizeObserver?function(){var e=o.useState(null),t=e[0],r=e[1],n=o.useState(s),a=n[0],l=n[1],u=o.useMemo((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,i=t.height,a=t.top,s=t.left,u=t.bottom,c=t.right;l({x:r,y:n,width:o,height:i,top:a,left:s,bottom:u,right:c})}}))}),[]);return i.default((function(){if(t)return u.observe(t),function(){u.disconnect()}}),[t]),[r,a]}:function(){return[a.noop,s]}},9812:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(){var e=n.useRef(!1),t=n.useCallback((function(){return e.current}),[]);return n.useEffect((function(){return e.current=!0,function(){e.current=!1}}),[]),t}},1854:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(e,t){void 0===t&&(t=0);var r=n.useRef(!1),o=n.useRef(),i=n.useRef(e),a=n.useCallback((function(){return r.current}),[]),s=n.useCallback((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),l=n.useCallback((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return n.useEffect((function(){i.current=e}),[e]),n.useEffect((function(){return s(),l}),[t]),[a,l,s]}},8044:(e,t,r)=>{"use strict";var n=r(5959),o=Symbol.for("react.element"),i=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,s=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,l={key:!0,ref:!0,__self:!0,__source:!0};function u(e,t,r){var n,i={},u=null,c=null;for(n in void 0!==r&&(u=""+r),void 0!==t.key&&(u=""+t.key),void 0!==t.ref&&(c=t.ref),t)a.call(t,n)&&!l.hasOwnProperty(n)&&(i[n]=t[n]);if(e&&e.defaultProps)for(n in t=e.defaultProps)void 0===i[n]&&(i[n]=t[n]);return{$$typeof:o,type:e,key:u,ref:c,props:i,_owner:s.current}}t.Fragment=i,t.jsx=u,t.jsxs=u},9728:(e,t,r)=>{"use strict";e.exports=r(8044)},9264:(e,t,r)=>{const n=Symbol("SemVer ANY");class o{static get ANY(){return n}constructor(e,t){if(t=i(t),e instanceof o){if(e.loose===!!t.loose)return e;e=e.value}e=e.trim().split(/\s+/).join(" "),u("comparator",e,t),this.options=t,this.loose=!!t.loose,this.parse(e),this.semver===n?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}parse(e){const t=this.options.loose?a[s.COMPARATORLOOSE]:a[s.COMPARATOR],r=e.match(t);if(!r)throw new TypeError(`Invalid comparator: ${e}`);this.operator=void 0!==r[1]?r[1]:"","="===this.operator&&(this.operator=""),r[2]?this.semver=new c(r[2],this.options.loose):this.semver=n}toString(){return this.value}test(e){if(u("Comparator.test",e,this.options.loose),this.semver===n||e===n)return!0;if("string"==typeof e)try{e=new c(e,this.options)}catch(e){return!1}return l(e,this.operator,this.semver,this.options)}intersects(e,t){if(!(e instanceof o))throw new TypeError("a Comparator is required");return""===this.operator?""===this.value||new d(e.value,t).test(this.value):""===e.operator?""===e.value||new d(this.value,t).test(e.semver):!((t=i(t)).includePrerelease&&("<0.0.0-0"===this.value||"<0.0.0-0"===e.value)||!t.includePrerelease&&(this.value.startsWith("<0.0.0")||e.value.startsWith("<0.0.0"))||(!this.operator.startsWith(">")||!e.operator.startsWith(">"))&&(!this.operator.startsWith("<")||!e.operator.startsWith("<"))&&(this.semver.version!==e.semver.version||!this.operator.includes("=")||!e.operator.includes("="))&&!(l(this.semver,"<",e.semver,t)&&this.operator.startsWith(">")&&e.operator.startsWith("<"))&&!(l(this.semver,">",e.semver,t)&&this.operator.startsWith("<")&&e.operator.startsWith(">")))}}e.exports=o;const i=r(9547),{safeRe:a,t:s}=r(5750),l=r(4991),u=r(1064),c=r(4708),d=r(2839)},2839:(e,t,r)=>{const n=/\s+/g;class o{constructor(e,t){if(t=a(t),e instanceof o)return e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease?e:new o(e.raw,t);if(e instanceof s)return this.raw=e.value,this.set=[[e]],this.formatted=void 0,this;if(this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease,this.raw=e.trim().replace(n," "),this.set=this.raw.split("||").map((e=>this.parseRange(e.trim()))).filter((e=>e.length)),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){const e=this.set[0];if(this.set=this.set.filter((e=>!m(e[0]))),0===this.set.length)this.set=[e];else if(this.set.length>1)for(const e of this.set)if(1===e.length&&y(e[0])){this.set=[e];break}}this.formatted=void 0}get range(){if(void 0===this.formatted){this.formatted="";for(let e=0;e<this.set.length;e++){e>0&&(this.formatted+="||");const t=this.set[e];for(let e=0;e<t.length;e++)e>0&&(this.formatted+=" "),this.formatted+=t[e].toString().trim()}}return this.formatted}format(){return this.range}toString(){return this.range}parseRange(e){const t=((this.options.includePrerelease&&g)|(this.options.loose&&v))+":"+e,r=i.get(t);if(r)return r;const n=this.options.loose,o=n?c[d.HYPHENRANGELOOSE]:c[d.HYPHENRANGE];e=e.replace(o,A(this.options.includePrerelease)),l("hyphen replace",e),e=e.replace(c[d.COMPARATORTRIM],p),l("comparator trim",e),e=e.replace(c[d.TILDETRIM],f),l("tilde trim",e),e=e.replace(c[d.CARETTRIM],h),l("caret trim",e);let a=e.split(" ").map((e=>O(e,this.options))).join(" ").split(/\s+/).map((e=>I(e,this.options)));n&&(a=a.filter((e=>(l("loose invalid filter",e,this.options),!!e.match(c[d.COMPARATORLOOSE]))))),l("range list",a);const u=new Map,y=a.map((e=>new s(e,this.options)));for(const e of y){if(m(e))return[e];u.set(e.value,e)}u.size>1&&u.has("")&&u.delete("");const b=[...u.values()];return i.set(t,b),b}intersects(e,t){if(!(e instanceof o))throw new TypeError("a Range is required");return this.set.some((r=>b(r,t)&&e.set.some((e=>b(e,t)&&r.every((r=>e.every((e=>r.intersects(e,t)))))))))}test(e){if(!e)return!1;if("string"==typeof e)try{e=new u(e,this.options)}catch(e){return!1}for(let t=0;t<this.set.length;t++)if(j(this.set[t],e,this.options))return!0;return!1}}e.exports=o;const i=new(r(122)),a=r(9547),s=r(9264),l=r(1064),u=r(4708),{safeRe:c,t:d,comparatorTrimReplace:p,tildeTrimReplace:f,caretTrimReplace:h}=r(5750),{FLAG_INCLUDE_PRERELEASE:g,FLAG_LOOSE:v}=r(2074),m=e=>"<0.0.0-0"===e.value,y=e=>""===e.value,b=(e,t)=>{let r=!0;const n=e.slice();let o=n.pop();for(;r&&n.length;)r=n.every((e=>o.intersects(e,t))),o=n.pop();return r},O=(e,t)=>(l("comp",e,t),e=T(e,t),l("caret",e),e=S(e,t),l("tildes",e),e=_(e,t),l("xrange",e),e=R(e,t),l("stars",e),e),E=e=>!e||"x"===e.toLowerCase()||"*"===e,S=(e,t)=>e.trim().split(/\s+/).map((e=>w(e,t))).join(" "),w=(e,t)=>{const r=t.loose?c[d.TILDELOOSE]:c[d.TILDE];return e.replace(r,((t,r,n,o,i)=>{let a;return l("tilde",e,t,r,n,o,i),E(r)?a="":E(n)?a=`>=${r}.0.0 <${+r+1}.0.0-0`:E(o)?a=`>=${r}.${n}.0 <${r}.${+n+1}.0-0`:i?(l("replaceTilde pr",i),a=`>=${r}.${n}.${o}-${i} <${r}.${+n+1}.0-0`):a=`>=${r}.${n}.${o} <${r}.${+n+1}.0-0`,l("tilde return",a),a}))},T=(e,t)=>e.trim().split(/\s+/).map((e=>x(e,t))).join(" "),x=(e,t)=>{l("caret",e,t);const r=t.loose?c[d.CARETLOOSE]:c[d.CARET],n=t.includePrerelease?"-0":"";return e.replace(r,((t,r,o,i,a)=>{let s;return l("caret",e,t,r,o,i,a),E(r)?s="":E(o)?s=`>=${r}.0.0${n} <${+r+1}.0.0-0`:E(i)?s="0"===r?`>=${r}.${o}.0${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.0${n} <${+r+1}.0.0-0`:a?(l("replaceCaret pr",a),s="0"===r?"0"===o?`>=${r}.${o}.${i}-${a} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}-${a} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i}-${a} <${+r+1}.0.0-0`):(l("no pr"),s="0"===r?"0"===o?`>=${r}.${o}.${i}${n} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i} <${+r+1}.0.0-0`),l("caret return",s),s}))},_=(e,t)=>(l("replaceXRanges",e,t),e.split(/\s+/).map((e=>C(e,t))).join(" ")),C=(e,t)=>{e=e.trim();const r=t.loose?c[d.XRANGELOOSE]:c[d.XRANGE];return e.replace(r,((r,n,o,i,a,s)=>{l("xRange",e,r,n,o,i,a,s);const u=E(o),c=u||E(i),d=c||E(a),p=d;return"="===n&&p&&(n=""),s=t.includePrerelease?"-0":"",u?r=">"===n||"<"===n?"<0.0.0-0":"*":n&&p?(c&&(i=0),a=0,">"===n?(n=">=",c?(o=+o+1,i=0,a=0):(i=+i+1,a=0)):"<="===n&&(n="<",c?o=+o+1:i=+i+1),"<"===n&&(s="-0"),r=`${n+o}.${i}.${a}${s}`):c?r=`>=${o}.0.0${s} <${+o+1}.0.0-0`:d&&(r=`>=${o}.${i}.0${s} <${o}.${+i+1}.0-0`),l("xRange return",r),r}))},R=(e,t)=>(l("replaceStars",e,t),e.trim().replace(c[d.STAR],"")),I=(e,t)=>(l("replaceGTE0",e,t),e.trim().replace(c[t.includePrerelease?d.GTE0PRE:d.GTE0],"")),A=e=>(t,r,n,o,i,a,s,l,u,c,d,p)=>`${r=E(n)?"":E(o)?`>=${n}.0.0${e?"-0":""}`:E(i)?`>=${n}.${o}.0${e?"-0":""}`:a?`>=${r}`:`>=${r}${e?"-0":""}`} ${l=E(u)?"":E(c)?`<${+u+1}.0.0-0`:E(d)?`<${u}.${+c+1}.0-0`:p?`<=${u}.${c}.${d}-${p}`:e?`<${u}.${c}.${+d+1}-0`:`<=${l}`}`.trim(),j=(e,t,r)=>{for(let r=0;r<e.length;r++)if(!e[r].test(t))return!1;if(t.prerelease.length&&!r.includePrerelease){for(let r=0;r<e.length;r++)if(l(e[r].semver),e[r].semver!==s.ANY&&e[r].semver.prerelease.length>0){const n=e[r].semver;if(n.major===t.major&&n.minor===t.minor&&n.patch===t.patch)return!0}return!1}return!0}},4708:(e,t,r)=>{const n=r(1064),{MAX_LENGTH:o,MAX_SAFE_INTEGER:i}=r(2074),{safeRe:a,t:s}=r(5750),l=r(9547),{compareIdentifiers:u}=r(1427);class c{constructor(e,t){if(t=l(t),e instanceof c){if(e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease)return e;e=e.version}else if("string"!=typeof e)throw new TypeError(`Invalid version. Must be a string. Got type "${typeof e}".`);if(e.length>o)throw new TypeError(`version is longer than ${o} characters`);n("SemVer",e,t),this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease;const r=e.trim().match(t.loose?a[s.LOOSE]:a[s.FULL]);if(!r)throw new TypeError(`Invalid Version: ${e}`);if(this.raw=e,this.major=+r[1],this.minor=+r[2],this.patch=+r[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");r[4]?this.prerelease=r[4].split(".").map((e=>{if(/^[0-9]+$/.test(e)){const t=+e;if(t>=0&&t<i)return t}return e})):this.prerelease=[],this.build=r[5]?r[5].split("."):[],this.format()}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(e){if(n("SemVer.compare",this.version,this.options,e),!(e instanceof c)){if("string"==typeof e&&e===this.version)return 0;e=new c(e,this.options)}return e.version===this.version?0:this.compareMain(e)||this.comparePre(e)}compareMain(e){return e instanceof c||(e=new c(e,this.options)),u(this.major,e.major)||u(this.minor,e.minor)||u(this.patch,e.patch)}comparePre(e){if(e instanceof c||(e=new c(e,this.options)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;let t=0;do{const r=this.prerelease[t],o=e.prerelease[t];if(n("prerelease compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return u(r,o)}while(++t)}compareBuild(e){e instanceof c||(e=new c(e,this.options));let t=0;do{const r=this.build[t],o=e.build[t];if(n("build compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return u(r,o)}while(++t)}inc(e,t,r){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t,r);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t,r);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t,r),this.inc("pre",t,r);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t,r),this.inc("pre",t,r);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":{const e=Number(r)?1:0;if(!t&&!1===r)throw new Error("invalid increment argument: identifier is empty");if(0===this.prerelease.length)this.prerelease=[e];else{let n=this.prerelease.length;for(;--n>=0;)"number"==typeof this.prerelease[n]&&(this.prerelease[n]++,n=-2);if(-1===n){if(t===this.prerelease.join(".")&&!1===r)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(e)}}if(t){let n=[t,e];!1===r&&(n=[t]),0===u(this.prerelease[0],t)?isNaN(this.prerelease[1])&&(this.prerelease=n):this.prerelease=n}break}default:throw new Error(`invalid increment argument: ${e}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}}e.exports=c},8854:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null}},4991:(e,t,r)=>{const n=r(1409),o=r(6031),i=r(9308),a=r(3833),s=r(2083),l=r(4624);e.exports=(e,t,r,u)=>{switch(t){case"===":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e===r;case"!==":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e!==r;case"":case"=":case"==":return n(e,r,u);case"!=":return o(e,r,u);case">":return i(e,r,u);case">=":return a(e,r,u);case"<":return s(e,r,u);case"<=":return l(e,r,u);default:throw new TypeError(`Invalid operator: ${t}`)}}},362:(e,t,r)=>{const n=r(4708),o=r(4256),{safeRe:i,t:a}=r(5750);e.exports=(e,t)=>{if(e instanceof n)return e;if("number"==typeof e&&(e=String(e)),"string"!=typeof e)return null;let r=null;if((t=t||{}).rtl){const n=t.includePrerelease?i[a.COERCERTLFULL]:i[a.COERCERTL];let o;for(;(o=n.exec(e))&&(!r||r.index+r[0].length!==e.length);)r&&o.index+o[0].length===r.index+r[0].length||(r=o),n.lastIndex=o.index+o[1].length+o[2].length;n.lastIndex=-1}else r=e.match(t.includePrerelease?i[a.COERCEFULL]:i[a.COERCE]);if(null===r)return null;const s=r[2],l=r[3]||"0",u=r[4]||"0",c=t.includePrerelease&&r[5]?`-${r[5]}`:"",d=t.includePrerelease&&r[6]?`+${r[6]}`:"";return o(`${s}.${l}.${u}${c}${d}`,t)}},7565:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r)=>{const o=new n(e,r),i=new n(t,r);return o.compare(i)||o.compareBuild(i)}},5699:(e,t,r)=>{const n=r(3440);e.exports=(e,t)=>n(e,t,!0)},3440:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r)=>new n(e,r).compare(new n(t,r))},4952:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,null,!0),o=n(t,null,!0),i=r.compare(o);if(0===i)return null;const a=i>0,s=a?r:o,l=a?o:r,u=!!s.prerelease.length;if(l.prerelease.length&&!u)return l.patch||l.minor?s.patch?"patch":s.minor?"minor":"major":"major";const c=u?"pre":"";return r.major!==o.major?c+"major":r.minor!==o.minor?c+"minor":r.patch!==o.patch?c+"patch":"prerelease"}},1409:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>0===n(e,t,r)},9308:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)>0},3833:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)>=0},2479:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r,o,i)=>{"string"==typeof r&&(i=o,o=r,r=void 0);try{return new n(e instanceof n?e.version:e,r).inc(t,o,i).version}catch(e){return null}}},2083:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)<0},4624:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)<=0},1034:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).major},9406:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).minor},6031:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>0!==n(e,t,r)},4256:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r=!1)=>{if(e instanceof n)return e;try{return new n(e,t)}catch(e){if(!r)return null;throw e}}},5229:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).patch},6513:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,t);return r&&r.prerelease.length?r.prerelease:null}},7618:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(t,e,r)},1173:(e,t,r)=>{const n=r(7565);e.exports=(e,t)=>e.sort(((e,r)=>n(r,e,t)))},3238:(e,t,r)=>{const n=r(2839);e.exports=(e,t,r)=>{try{t=new n(t,r)}catch(e){return!1}return t.test(e)}},3559:(e,t,r)=>{const n=r(7565);e.exports=(e,t)=>e.sort(((e,r)=>n(e,r,t)))},9881:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,t);return r?r.version:null}},709:(e,t,r)=>{const n=r(5750),o=r(2074),i=r(4708),a=r(1427),s=r(4256),l=r(9881),u=r(8854),c=r(2479),d=r(4952),p=r(1034),f=r(9406),h=r(5229),g=r(6513),v=r(3440),m=r(7618),y=r(5699),b=r(7565),O=r(3559),E=r(1173),S=r(9308),w=r(2083),T=r(1409),x=r(6031),_=r(3833),C=r(4624),R=r(4991),I=r(362),A=r(9264),j=r(2839),P=r(3238),L=r(3327),k=r(6988),N=r(2366),D=r(7453),F=r(130),M=r(7715),V=r(7379),U=r(110),B=r(284),z=r(8285),$=r(2008);e.exports={parse:s,valid:l,clean:u,inc:c,diff:d,major:p,minor:f,patch:h,prerelease:g,compare:v,rcompare:m,compareLoose:y,compareBuild:b,sort:O,rsort:E,gt:S,lt:w,eq:T,neq:x,gte:_,lte:C,cmp:R,coerce:I,Comparator:A,Range:j,satisfies:P,toComparators:L,maxSatisfying:k,minSatisfying:N,minVersion:D,validRange:F,outside:M,gtr:V,ltr:U,intersects:B,simplifyRange:z,subset:$,SemVer:i,re:n.re,src:n.src,tokens:n.t,SEMVER_SPEC_VERSION:o.SEMVER_SPEC_VERSION,RELEASE_TYPES:o.RELEASE_TYPES,compareIdentifiers:a.compareIdentifiers,rcompareIdentifiers:a.rcompareIdentifiers}},2074:e=>{const t=Number.MAX_SAFE_INTEGER||9007199254740991;e.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:16,MAX_SAFE_BUILD_LENGTH:250,MAX_SAFE_INTEGER:t,RELEASE_TYPES:["major","premajor","minor","preminor","patch","prepatch","prerelease"],SEMVER_SPEC_VERSION:"2.0.0",FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2}},1064:e=>{const t="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...e)=>console.error("SEMVER",...e):()=>{};e.exports=t},1427:e=>{const t=/^[0-9]+$/,r=(e,r)=>{const n=t.test(e),o=t.test(r);return n&&o&&(e=+e,r=+r),e===r?0:n&&!o?-1:o&&!n?1:e<r?-1:1};e.exports={compareIdentifiers:r,rcompareIdentifiers:(e,t)=>r(t,e)}},122:e=>{e.exports=class{constructor(){this.max=1e3,this.map=new Map}get(e){const t=this.map.get(e);return void 0===t?void 0:(this.map.delete(e),this.map.set(e,t),t)}delete(e){return this.map.delete(e)}set(e,t){if(!this.delete(e)&&void 0!==t){if(this.map.size>=this.max){const e=this.map.keys().next().value;this.delete(e)}this.map.set(e,t)}return this}}},9547:e=>{const t=Object.freeze({loose:!0}),r=Object.freeze({});e.exports=e=>e?"object"!=typeof e?t:e:r},5750:(e,t,r)=>{const{MAX_SAFE_COMPONENT_LENGTH:n,MAX_SAFE_BUILD_LENGTH:o,MAX_LENGTH:i}=r(2074),a=r(1064),s=(t=e.exports={}).re=[],l=t.safeRe=[],u=t.src=[],c=t.t={};let d=0;const p="[a-zA-Z0-9-]",f=[["\\s",1],["\\d",i],[p,o]],h=(e,t,r)=>{const n=(e=>{for(const[t,r]of f)e=e.split(`${t}*`).join(`${t}{0,${r}}`).split(`${t}+`).join(`${t}{1,${r}}`);return e})(t),o=d++;a(e,o,t),c[e]=o,u[o]=t,s[o]=new RegExp(t,r?"g":void 0),l[o]=new RegExp(n,r?"g":void 0)};h("NUMERICIDENTIFIER","0|[1-9]\\d*"),h("NUMERICIDENTIFIERLOOSE","\\d+"),h("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${p}*`),h("MAINVERSION",`(${u[c.NUMERICIDENTIFIER]})\\.(${u[c.NUMERICIDENTIFIER]})\\.(${u[c.NUMERICIDENTIFIER]})`),h("MAINVERSIONLOOSE",`(${u[c.NUMERICIDENTIFIERLOOSE]})\\.(${u[c.NUMERICIDENTIFIERLOOSE]})\\.(${u[c.NUMERICIDENTIFIERLOOSE]})`),h("PRERELEASEIDENTIFIER",`(?:${u[c.NUMERICIDENTIFIER]}|${u[c.NONNUMERICIDENTIFIER]})`),h("PRERELEASEIDENTIFIERLOOSE",`(?:${u[c.NUMERICIDENTIFIERLOOSE]}|${u[c.NONNUMERICIDENTIFIER]})`),h("PRERELEASE",`(?:-(${u[c.PRERELEASEIDENTIFIER]}(?:\\.${u[c.PRERELEASEIDENTIFIER]})*))`),h("PRERELEASELOOSE",`(?:-?(${u[c.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${u[c.PRERELEASEIDENTIFIERLOOSE]})*))`),h("BUILDIDENTIFIER",`${p}+`),h("BUILD",`(?:\\+(${u[c.BUILDIDENTIFIER]}(?:\\.${u[c.BUILDIDENTIFIER]})*))`),h("FULLPLAIN",`v?${u[c.MAINVERSION]}${u[c.PRERELEASE]}?${u[c.BUILD]}?`),h("FULL",`^${u[c.FULLPLAIN]}$`),h("LOOSEPLAIN",`[v=\\s]*${u[c.MAINVERSIONLOOSE]}${u[c.PRERELEASELOOSE]}?${u[c.BUILD]}?`),h("LOOSE",`^${u[c.LOOSEPLAIN]}$`),h("GTLT","((?:<|>)?=?)"),h("XRANGEIDENTIFIERLOOSE",`${u[c.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`),h("XRANGEIDENTIFIER",`${u[c.NUMERICIDENTIFIER]}|x|X|\\*`),h("XRANGEPLAIN",`[v=\\s]*(${u[c.XRANGEIDENTIFIER]})(?:\\.(${u[c.XRANGEIDENTIFIER]})(?:\\.(${u[c.XRANGEIDENTIFIER]})(?:${u[c.PRERELEASE]})?${u[c.BUILD]}?)?)?`),h("XRANGEPLAINLOOSE",`[v=\\s]*(${u[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${u[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${u[c.XRANGEIDENTIFIERLOOSE]})(?:${u[c.PRERELEASELOOSE]})?${u[c.BUILD]}?)?)?`),h("XRANGE",`^${u[c.GTLT]}\\s*${u[c.XRANGEPLAIN]}$`),h("XRANGELOOSE",`^${u[c.GTLT]}\\s*${u[c.XRANGEPLAINLOOSE]}$`),h("COERCEPLAIN",`(^|[^\\d])(\\d{1,${n}})(?:\\.(\\d{1,${n}}))?(?:\\.(\\d{1,${n}}))?`),h("COERCE",`${u[c.COERCEPLAIN]}(?:$|[^\\d])`),h("COERCEFULL",u[c.COERCEPLAIN]+`(?:${u[c.PRERELEASE]})?`+`(?:${u[c.BUILD]})?(?:$|[^\\d])`),h("COERCERTL",u[c.COERCE],!0),h("COERCERTLFULL",u[c.COERCEFULL],!0),h("LONETILDE","(?:~>?)"),h("TILDETRIM",`(\\s*)${u[c.LONETILDE]}\\s+`,!0),t.tildeTrimReplace="$1~",h("TILDE",`^${u[c.LONETILDE]}${u[c.XRANGEPLAIN]}$`),h("TILDELOOSE",`^${u[c.LONETILDE]}${u[c.XRANGEPLAINLOOSE]}$`),h("LONECARET","(?:\\^)"),h("CARETTRIM",`(\\s*)${u[c.LONECARET]}\\s+`,!0),t.caretTrimReplace="$1^",h("CARET",`^${u[c.LONECARET]}${u[c.XRANGEPLAIN]}$`),h("CARETLOOSE",`^${u[c.LONECARET]}${u[c.XRANGEPLAINLOOSE]}$`),h("COMPARATORLOOSE",`^${u[c.GTLT]}\\s*(${u[c.LOOSEPLAIN]})$|^$`),h("COMPARATOR",`^${u[c.GTLT]}\\s*(${u[c.FULLPLAIN]})$|^$`),h("COMPARATORTRIM",`(\\s*)${u[c.GTLT]}\\s*(${u[c.LOOSEPLAIN]}|${u[c.XRANGEPLAIN]})`,!0),t.comparatorTrimReplace="$1$2$3",h("HYPHENRANGE",`^\\s*(${u[c.XRANGEPLAIN]})\\s+-\\s+(${u[c.XRANGEPLAIN]})\\s*$`),h("HYPHENRANGELOOSE",`^\\s*(${u[c.XRANGEPLAINLOOSE]})\\s+-\\s+(${u[c.XRANGEPLAINLOOSE]})\\s*$`),h("STAR","(<|>)?=?\\s*\\*"),h("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$"),h("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$")},7379:(e,t,r)=>{const n=r(7715);e.exports=(e,t,r)=>n(e,t,">",r)},284:(e,t,r)=>{const n=r(2839);e.exports=(e,t,r)=>(e=new n(e,r),t=new n(t,r),e.intersects(t,r))},110:(e,t,r)=>{const n=r(7715);e.exports=(e,t,r)=>n(e,t,"<",r)},6988:(e,t,r)=>{const n=r(4708),o=r(2839);e.exports=(e,t,r)=>{let i=null,a=null,s=null;try{s=new o(t,r)}catch(e){return null}return e.forEach((e=>{s.test(e)&&(i&&-1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},2366:(e,t,r)=>{const n=r(4708),o=r(2839);e.exports=(e,t,r)=>{let i=null,a=null,s=null;try{s=new o(t,r)}catch(e){return null}return e.forEach((e=>{s.test(e)&&(i&&1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},7453:(e,t,r)=>{const n=r(4708),o=r(2839),i=r(9308);e.exports=(e,t)=>{e=new o(e,t);let r=new n("0.0.0");if(e.test(r))return r;if(r=new n("0.0.0-0"),e.test(r))return r;r=null;for(let t=0;t<e.set.length;++t){const o=e.set[t];let a=null;o.forEach((e=>{const t=new n(e.semver.version);switch(e.operator){case">":0===t.prerelease.length?t.patch++:t.prerelease.push(0),t.raw=t.format();case"":case">=":a&&!i(t,a)||(a=t);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${e.operator}`)}})),!a||r&&!i(r,a)||(r=a)}return r&&e.test(r)?r:null}},7715:(e,t,r)=>{const n=r(4708),o=r(9264),{ANY:i}=o,a=r(2839),s=r(3238),l=r(9308),u=r(2083),c=r(4624),d=r(3833);e.exports=(e,t,r,p)=>{let f,h,g,v,m;switch(e=new n(e,p),t=new a(t,p),r){case">":f=l,h=c,g=u,v=">",m=">=";break;case"<":f=u,h=d,g=l,v="<",m="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(s(e,t,p))return!1;for(let r=0;r<t.set.length;++r){const n=t.set[r];let a=null,s=null;if(n.forEach((e=>{e.semver===i&&(e=new o(">=0.0.0")),a=a||e,s=s||e,f(e.semver,a.semver,p)?a=e:g(e.semver,s.semver,p)&&(s=e)})),a.operator===v||a.operator===m)return!1;if((!s.operator||s.operator===v)&&h(e,s.semver))return!1;if(s.operator===m&&g(e,s.semver))return!1}return!0}},8285:(e,t,r)=>{const n=r(3238),o=r(3440);e.exports=(e,t,r)=>{const i=[];let a=null,s=null;const l=e.sort(((e,t)=>o(e,t,r)));for(const e of l)n(e,t,r)?(s=e,a||(a=e)):(s&&i.push([a,s]),s=null,a=null);a&&i.push([a,null]);const u=[];for(const[e,t]of i)e===t?u.push(e):t||e!==l[0]?t?e===l[0]?u.push(`<=${t}`):u.push(`${e} - ${t}`):u.push(`>=${e}`):u.push("*");const c=u.join(" || "),d="string"==typeof t.raw?t.raw:String(t);return c.length<d.length?c:t}},2008:(e,t,r)=>{const n=r(2839),o=r(9264),{ANY:i}=o,a=r(3238),s=r(3440),l=[new o(">=0.0.0-0")],u=[new o(">=0.0.0")],c=(e,t,r)=>{if(e===t)return!0;if(1===e.length&&e[0].semver===i){if(1===t.length&&t[0].semver===i)return!0;e=r.includePrerelease?l:u}if(1===t.length&&t[0].semver===i){if(r.includePrerelease)return!0;t=u}const n=new Set;let o,c,f,h,g,v,m;for(const t of e)">"===t.operator||">="===t.operator?o=d(o,t,r):"<"===t.operator||"<="===t.operator?c=p(c,t,r):n.add(t.semver);if(n.size>1)return null;if(o&&c){if(f=s(o.semver,c.semver,r),f>0)return null;if(0===f&&(">="!==o.operator||"<="!==c.operator))return null}for(const e of n){if(o&&!a(e,String(o),r))return null;if(c&&!a(e,String(c),r))return null;for(const n of t)if(!a(e,String(n),r))return!1;return!0}let y=!(!c||r.includePrerelease||!c.semver.prerelease.length)&&c.semver,b=!(!o||r.includePrerelease||!o.semver.prerelease.length)&&o.semver;y&&1===y.prerelease.length&&"<"===c.operator&&0===y.prerelease[0]&&(y=!1);for(const e of t){if(m=m||">"===e.operator||">="===e.operator,v=v||"<"===e.operator||"<="===e.operator,o)if(b&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===b.major&&e.semver.minor===b.minor&&e.semver.patch===b.patch&&(b=!1),">"===e.operator||">="===e.operator){if(h=d(o,e,r),h===e&&h!==o)return!1}else if(">="===o.operator&&!a(o.semver,String(e),r))return!1;if(c)if(y&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===y.major&&e.semver.minor===y.minor&&e.semver.patch===y.patch&&(y=!1),"<"===e.operator||"<="===e.operator){if(g=p(c,e,r),g===e&&g!==c)return!1}else if("<="===c.operator&&!a(c.semver,String(e),r))return!1;if(!e.operator&&(c||o)&&0!==f)return!1}return!(o&&v&&!c&&0!==f||c&&m&&!o&&0!==f||b||y)},d=(e,t,r)=>{if(!e)return t;const n=s(e.semver,t.semver,r);return n>0?e:n<0||">"===t.operator&&">="===e.operator?t:e},p=(e,t,r)=>{if(!e)return t;const n=s(e.semver,t.semver,r);return n<0?e:n>0||"<"===t.operator&&"<="===e.operator?t:e};e.exports=(e,t,r={})=>{if(e===t)return!0;e=new n(e,r),t=new n(t,r);let o=!1;e:for(const n of e.set){for(const e of t.set){const t=c(n,e,r);if(o=o||null!==t,t)continue e}if(o)return!1}return!0}},3327:(e,t,r)=>{const n=r(2839);e.exports=(e,t)=>new n(e,t).set.map((e=>e.map((e=>e.value)).join(" ").trim().split(" ")))},130:(e,t,r)=>{const n=r(2839);e.exports=(e,t)=>{try{return new n(e,t).range||"*"}catch(e){return null}}},138:function(e){var t;t=function(){return function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{configurable:!1,enumerable:!0,get:n})},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=3)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelNode={create:function(e,t){var r,n={},o=e||"Abstract",i=[],a=null;if(n._type=o,n.getType=function(){return o},n.setType=function(e){o=e},n.getChildren=function(){return i},n.addChild=function(e){if(e){if(!e.setParent)throw{name:"Error",message:"Trying to add a child which is not a node: "+JSON.stringify(e)};e.setParent(n),i.push(e)}},n.getParent=function(){return a},n.setParent=function(e){a=e},n.getContext=function(e){return r||e.activeContext.peek()},n.setContext=function(e){r=e},n.getStartPosition=function(){return t>>16},n.getEndPosition=function(){return 65535&t},n.getValue=function(){throw{name:"MethodNotImplementedException",message:"SpelNode#getValue() must be overridden."}},n.toString=function(){var e="Kind: "+n.getType();e+=", Children: [";for(var t=0,r=n.getChildren().length;t<r;t+=1)e+="{"+n.getChildren()[t]+"}, ";return e+"]"},0===t)throw{name:"Error",message:"Position cannot be 0"};for(var s=arguments.length,l=Array(s>2?s-2:0),u=2;u<s;u++)l[u-2]=arguments[u];return l&&l.forEach((function(e){n.addChild(e)})),n}}},function(e,t,r){"use strict";function n(e){this.elements=e||[]}Object.defineProperty(t,"__esModule",{value:!0}),t.Stack=n,n.prototype.push=function(e){return this.elements.push(e),e},n.prototype.pop=function(){return this.elements.pop()},n.prototype.peek=function(){return this.elements[this.elements.length-1]},n.prototype.empty=function(){return this.elements.length>0},n.prototype.search=function(e){return this.elements.length-this.elements.indexOf(e)}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n={LITERAL_INT:1,LITERAL_LONG:2,LITERAL_HEXINT:3,LITERAL_HEXLONG:4,LITERAL_STRING:5,LITERAL_REAL:6,LITERAL_REAL_FLOAT:7,LPAREN:"(",RPAREN:")",COMMA:",",IDENTIFIER:0,COLON:":",HASH:"#",RSQUARE:"]",LSQUARE:"[",LCURLY:"{",RCURLY:"}",DOT:".",PLUS:"+",STAR:"*",MINUS:"-",SELECT_FIRST:"^[",SELECT_LAST:"$[",QMARK:"?",PROJECT:"![",DIV:"/",GE:">=",GT:">",LE:"<=",LT:"<",EQ:"==",NE:"!=",MOD:"%",NOT:"!",ASSIGN:"=",INSTANCEOF:"instanceof",MATCHES:"matches",BETWEEN:"between",SELECT:"?[",POWER:"^",ELVIS:"?:",SAFE_NAVI:"?.",BEAN_REF:"@",SYMBOLIC_OR:"||",SYMBOLIC_AND:"&&",INC:"++",DEC:"--"};function o(e){this.type=e,this.tokenChars=n[e],this._hasPayload="string"!=typeof n[e],"number"==typeof n[e]&&(this._ordinal=n[e])}for(var i in n)n.hasOwnProperty(i)&&(o[i]=new o(i));o.prototype.toString=function(){return this.type+(0!==this.tokenChars.length?"("+this.tokenChars+")":"")},o.prototype.getLength=function(){return this.tokenChars.length},o.prototype.hasPayload=function(){return this._hasPayload},o.prototype.valueOf=function(e){for(var t in n)if(n.hasOwnProperty(t)&&n[t]===e)return o[t]},o.prototype.ordinal=function(){return this._ordinal},t.TokenKind=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext=t.SpelExpressionEvaluator=void 0;var n=r(4),o=r(50);t.SpelExpressionEvaluator=n.SpelExpressionEvaluator,t.StandardContext=o.StandardContext},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionEvaluator=void 0;var n=r(5),o=r(1),i={compile:function(e){var t=(0,n.SpelExpressionParser)().parse(e);return{eval:function(e,r){return function(e,t,r){var n,i=new o.Stack;return t||(t={}),i.push(t),n={rootContext:t,activeContext:i,locals:r},e.getValue(n)}(t,e,r)},_compiledExpression:t}},eval:function(e,t,r){return i.compile(e).eval(t,r)}};t.SpelExpressionEvaluator=i},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionParser=void 0;var n=r(2),o=r(6),i=r(8),a=r(9),s=r(10),l=r(11),u=r(12),c=r(13),d=r(14),p=r(15),f=r(16),h=r(17),g=r(18),v=r(19),m=r(20),y=r(21),b=r(22),O=r(23),E=r(24),S=r(25),w=r(26),T=r(27),x=r(28),_=r(29),C=r(30),R=r(31),I=r(32),A=r(33),j=r(34),P=r(35),L=r(36),k=r(37),N=r(38),D=r(39),F=r(40),M=r(41),V=r(42),U=r(43),B=r(44),z=r(45),$=r(46),W=r(47),H=r(48),q=r(49);t.SpelExpressionParser=function(){var e,t,r,G,K=new RegExp("[\\p{L}\\p{N}_$]+"),Y=[];function X(){var e=Q();if(Se()){var t=Te();if(t.getKind()===n.TokenKind.ASSIGN){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-1))),we();var r=Q();return g.Assign.create(Re(t),e,r)}if(t.getKind()===n.TokenKind.ELVIS){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-2))),we();var o=X();return null===o&&(o=l.NullLiteral.create(Ie(t.startPos+1,t.endPos+1))),N.Elvis.create(Re(t),e,o)}if(t.getKind()===n.TokenKind.QMARK){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-1))),we();var i=X();me(n.TokenKind.COLON);var a=X();return k.Ternary.create(Re(t),e,i,a)}}return e}function Q(){for(var e=J();Ee("or")||ye(n.TokenKind.SYMBOLIC_OR);){var t=we(),r=J();_e(t,e,r),e=P.OpOr.create(Re(t),e,r)}return e}function J(){for(var e=Z();Ee("and")||ye(n.TokenKind.SYMBOLIC_AND);){var t=we(),r=Z();_e(t,e,r),e=j.OpAnd.create(Re(t),e,r)}return e}function Z(){var e=ee(),t=function(){var e=Te();if(null===e)return null;if(e.isNumericRelationalOperator())return e;if(e.isIdentifier()){var t=e.stringValue();if("instanceof"===t.toLowerCase())return e.asInstanceOfToken();if("matches"===t.toLowerCase())return e.asMatchesToken();if("between"===t.toLowerCase())return e.asBetweenToken()}return null}();if(null!==t){var r=we(),o=ee();_e(r,e,o);var i=t.kind;if(t.isNumericRelationalOperator()){var a=Re(r);return i===n.TokenKind.GT?b.OpGT.create(a,e,o):i===n.TokenKind.LT?E.OpLT.create(a,e,o):i===n.TokenKind.LE?O.OpLE.create(a,e,o):i===n.TokenKind.GE?y.OpGE.create(a,e,o):i===n.TokenKind.EQ?v.OpEQ.create(a,e,o):m.OpNE.create(a,e,o)}return i===n.TokenKind.INSTANCEOF?U.OpInstanceof.create(Re(r),e,o):i===n.TokenKind.MATCHES?L.OpMatches.create(Re(r),e,o):B.OpBetween.create(Re(r),e,o)}return e}function ee(){for(var e=te();Oe(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.INC);){var t=we(),r=te();Ce(t,r),t.getKind()===n.TokenKind.PLUS?e=S.OpPlus.create(Re(t),e,r):t.getKind()===n.TokenKind.MINUS&&(e=w.OpMinus.create(Re(t),e,r))}return e}function te(){for(var e=re();Oe(n.TokenKind.STAR,n.TokenKind.DIV,n.TokenKind.MOD);){var t=we(),r=re();_e(t,e,r),e=t.getKind()===n.TokenKind.STAR?T.OpMultiply.create(Re(t),e,r):t.getKind()===n.TokenKind.DIV?x.OpDivide.create(Re(t),e,r):_.OpModulus.create(Re(t),e,r)}return e}function re(){var e,t=ne();if(ye(n.TokenKind.POWER)){e=we();var r=ne();return Ce(e,r),C.OpPower.create(Re(e),t,r)}return null!==t&&Oe(n.TokenKind.INC,n.TokenKind.DEC)?(e=we()).getKind()===n.TokenKind.INC?R.OpInc.create(Re(e),!0,t):I.OpDec.create(Re(e),!0,t):t}function ne(){var e,t;return Oe(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.NOT)?(e=we(),t=ne(),e.getKind()===n.TokenKind.NOT?A.OpNot.create(Re(e),t):e.getKind()===n.TokenKind.PLUS?S.OpPlus.create(Re(e),t):w.OpMinus.create(Re(e),t)):Oe(n.TokenKind.INC,n.TokenKind.DEC)?(e=we(),t=ne(),e.getKind()===n.TokenKind.INC?R.OpInc.create(Re(e),!1,t):I.OpDec.create(Re(e),!1,t)):function(){var e=[],t=function(){var e=Te();if(null===e)return!1;if(e.getKind()===n.TokenKind.LITERAL_INT||e.getKind()===n.TokenKind.LITERAL_LONG)ge(a.NumberLiteral.create(parseInt(e.stringValue(),10),Re(e)));else if(e.getKind()===n.TokenKind.LITERAL_REAL||e.getKind()===n.TokenKind.LITERAL_REAL_FLOAT)ge(a.NumberLiteral.create(parseFloat(e.stringValue()),Re(e)));else if(e.getKind()===n.TokenKind.LITERAL_HEXINT||e.getKind()===n.TokenKind.LITERAL_HEXLONG)ge(a.NumberLiteral.create(parseInt(e.stringValue(),16),Re(e)));else if(Ee("true"))ge(i.BooleanLiteral.create(!0,Re(e)));else if(Ee("false"))ge(i.BooleanLiteral.create(!1,Re(e)));else{if(e.getKind()!==n.TokenKind.LITERAL_STRING)return!1;ge(s.StringLiteral.create(e.stringValue(),Re(e)))}return we(),!0}()||function(){if(ye(n.TokenKind.LPAREN)){we();var e=X();return me(n.TokenKind.RPAREN),ge(e),!0}return!1}()||function(){if(ye(n.TokenKind.IDENTIFIER)){var e=Te();if("T"!==e.stringValue())return!1;var t=we();if(ye(n.TokenKind.RSQUARE))return ge(d.PropertyReference.create(t.stringValue(),Re(t))),!0;me(n.TokenKind.LPAREN);for(var r=pe(),o=0;be(n.TokenKind.LSQUARE,!0);)me(n.TokenKind.RSQUARE),o++;return me(n.TokenKind.RPAREN),ge(z.TypeReference.create(Re(e),r,o)),!0}return!1}()||function(){if(ye(n.TokenKind.IDENTIFIER)){var e=Te();return"null"===e.stringValue().toLowerCase()&&(we(),ge(l.NullLiteral.create(Re(e))),!0)}return!1}()||function(){if(Ee("new")){var e=we();if(ye(n.TokenKind.RSQUARE))return ge(d.PropertyReference.create(e.stringValue(),Re(e))),!0;var t=pe(),r=[];if(r.push(t),ye(n.TokenKind.LSQUARE)){for(var o=[];be(n.TokenKind.LSQUARE,!0);)ye(n.TokenKind.RSQUARE)?o.push(null):o.push(X()),me(n.TokenKind.RSQUARE);ue()&&r.push(ve()),ge(q.ConstructorReference.create(Re(e),o,r))}else i=r,ye(n.TokenKind.LPAREN)||xe(Re(Te()),"MISSING_CONSTRUCTOR_ARGS"),se(i),me(n.TokenKind.RPAREN),ge(q.ConstructorReference.create(Re(e),r));return!0}var i;return!1}()||he(!1)||ie()||function(){if(ye(n.TokenKind.BEAN_REF)){var e=we(),t=null,r=null;return ye(n.TokenKind.IDENTIFIER)?r=(t=me(n.TokenKind.IDENTIFIER)).data:ye(n.TokenKind.LITERAL_STRING)?r=(r=(t=me(n.TokenKind.LITERAL_STRING)).stringValue()).substring(1,r.length()-1):xe(e.startPos,"INVALID_BEAN_REFERENCE"),ge($.BeanReference.create(Re(t),r)),!0}return!1}()||le(!1)||de(!1)||ce()||ue()?ve():null;for(e.push(t);oe();)e.push(ve());return 1===e.length?e[0]:f.CompoundExpression.create(Ie(t.getStartPosition(),e[e.length-1].getEndPosition()),e)}()}function oe(){var e,t,r;return null!==(e=Oe(n.TokenKind.DOT,n.TokenKind.SAFE_NAVI)?(t=we(),he(r=t.getKind()===n.TokenKind.SAFE_NAVI)||ie()||le(r)||de(r)?ve():(null===Te()?xe(t.startPos,"OOD"):xe(t.startPos,"UNEXPECTED_DATA_AFTER_DOT",function(e){return e.getKind().hasPayload()?e.stringValue():e.getKind().toString().toLowerCase()}(Te())),null)):ye(n.TokenKind.LSQUARE)&&ce()?ve():null)&&(ge(e),!0)}function ie(){if(!ye(n.TokenKind.HASH))return!1;var e=we(),t=me(n.TokenKind.IDENTIFIER),r=ae();return null===r?(ge(p.VariableReference.create(t.data,Ie(e.startPos,t.endPos))),!0):(ge(u.FunctionReference.create(t.data,Ie(e.startPos,t.endPos),r)),!0)}function ae(){if(!ye(n.TokenKind.LPAREN))return null;var e=[];return se(e),me(n.TokenKind.RPAREN),e}function se(e){var t,r=Te().startPos;do{we();var o=Te();null===o&&xe(r,"RUN_OUT_OF_ARGUMENTS"),o.getKind()!==n.TokenKind.RPAREN&&e.push(X()),t=Te()}while(null!==t&&t.kind===n.TokenKind.COMMA);null===t&&xe(r,"RUN_OUT_OF_ARGUMENTS")}function le(e){var t=Te();if(!be(n.TokenKind.PROJECT,!0))return!1;var r=X();return me(n.TokenKind.RSQUARE),ge(V.Projection.create(e,Re(t),r)),!0}function ue(){var e=Te(),t=[];if(!be(n.TokenKind.LCURLY,!0))return!1;var r=null,o=Te();if(be(n.TokenKind.RCURLY,!0))r=D.InlineList.create(Ie(e.startPos,o.endPos));else if(be(n.TokenKind.COLON,!0))o=me(n.TokenKind.RCURLY),r=F.InlineMap.create(Ie(e.startPos,o.endPos));else{var i=X();if(ye(n.TokenKind.RCURLY))t.push(i),o=me(n.TokenKind.RCURLY),r=D.InlineList.create(Ie(e.startPos,o.endPos),t);else if(be(n.TokenKind.COMMA,!0)){t.push(i);do{t.push(X())}while(be(n.TokenKind.COMMA,!0));o=me(n.TokenKind.RCURLY),r=D.InlineList.create(Re(e.startPos,o.endPos),t)}else if(be(n.TokenKind.COLON,!0)){var a=[];for(a.push(i),a.push(X());be(n.TokenKind.COMMA,!0);)a.push(X()),me(n.TokenKind.COLON),a.push(X());o=me(n.TokenKind.RCURLY),r=F.InlineMap.create(Ie(e.startPos,o.endPos),a)}else xe(e.startPos,"OOD")}return ge(r),!0}function ce(){var e=Te();if(!be(n.TokenKind.LSQUARE,!0))return!1;var t=X();return me(n.TokenKind.RSQUARE),ge(h.Indexer.create(Re(e),t)),!0}function de(e){var t=Te();if(!function(){if(!Se())return!1;var e=Te();return e.getKind()===n.TokenKind.SELECT||e.getKind()===n.TokenKind.SELECT_FIRST||e.getKind()===n.TokenKind.SELECT_LAST}())return!1;we();var r=X();return null===r&&xe(Re(t),"MISSING_SELECTION_EXPRESSION"),me(n.TokenKind.RSQUARE),t.getKind()===n.TokenKind.SELECT_FIRST?ge(M.Selection.create(e,M.Selection.FIRST,Re(t),r)):t.getKind()===n.TokenKind.SELECT_LAST?ge(M.Selection.create(e,M.Selection.LAST,Re(t),r)):ge(M.Selection.create(e,M.Selection.ALL,Re(t),r)),!0}function pe(){for(var t=[],r=Te();fe(r);)we(),r.kind!==n.TokenKind.DOT&&t.push(W.Identifier.create(r.stringValue(),Re(r))),r=Te();t.length||(null===r&&xe(e.length(),"OOD"),xe(r.startPos,"NOT_EXPECTED_TOKEN","qualified ID",r.getKind().toString().toLowerCase()));var o=Ie(t[0].getStartPosition(),t[t.length-1].getEndPosition());return H.QualifiedIdentifier.create(o,t)}function fe(e){if(null===e||e.kind===n.TokenKind.LITERAL_STRING)return!1;if(e.kind===n.TokenKind.DOT||e.kind===n.TokenKind.IDENTIFIER)return!0;var t=e.stringValue();return t&&t.length&&K.test(t)}function he(e){if(ye(n.TokenKind.IDENTIFIER)){var t=we(),r=ae();return null===r?(ge(d.PropertyReference.create(e,t.stringValue(),Re(t))),!0):(ge(c.MethodReference.create(e,t.stringValue(),Re(t),r)),!0)}return!1}function ge(e){Y.push(e)}function ve(){return Y.pop()}function me(t){var r=we();return null===r&&xe(e.length,"OOD"),r.getKind()!==t&&xe(r.startPos,"NOT_EXPECTED_TOKEN",t.toString().toLowerCase(),r.getKind().toString().toLowerCase()),r}function ye(e){return be(e,!1)}function be(e,t){if(!Se())return!1;var r=Te();return r.getKind()===e?(t&&G++,!0):e===n.TokenKind.IDENTIFIER&&r.getKind().ordinal()>=n.TokenKind.DIV.ordinal()&&r.getKind().ordinal()<=n.TokenKind.NOT.ordinal()&&null!==r.data}function Oe(){if(!Se())return!1;for(var e=Te(),t=Array.prototype.slice.call(arguments),r=0,n=t.length;r<n;r+=1)if(e.getKind()===t[r])return!0;return!1}function Ee(e){if(!Se())return!1;var t=Te();return t.getKind()===n.TokenKind.IDENTIFIER&&t.stringValue().toLowerCase()===e.toLowerCase()}function Se(){return G<t.length}function we(){return G>=r?null:t[G++]}function Te(){return G>=r?null:t[G]}function xe(t,r,n,o){throw n&&(r+="\nExpected: "+n),o&&(r+="\nActual: "+o),{name:"InternalParseException",message:"Error occurred while attempting to parse expression '"+e+"' at position "+t+". Message: "+r}}function _e(e,t,r){!function(e,t){null===t&&xe(e.startPos,"LEFT_OPERAND_PROBLEM")}(e,t),Ce(e,r)}function Ce(e,t){null===t&&xe(e.startPos,"RIGHT_OPERAND_PROBLEM")}function Re(e){return(e.startPos<<16)+e.endPos}function Ie(e,t){return(e<<16)+t}return{setConfiguration:function(e){},parse:function(n,i){try{e=n,t=o.Tokenizer.tokenize(n),r=t.length,G=0,Y=[];var a=X();return Se()&&xe(Te().startPos,"MORE_INPUT",we().toString()),a}catch(e){throw e.message}}}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Tokenizer=void 0;var n=r(7),o=r(2),i=["DIV","EQ","GE","GT","LE","LT","MOD","NE","NOT"],a=[];!function(){var e;for(e="0".charCodeAt(0);e<="9".charCodeAt(0);e+=1)a[e]|=3;for(e="A".charCodeAt(0);e<="F".charCodeAt(0);e+=1)a[e]|=2;for(e="a".charCodeAt(0);e<="f".charCodeAt(0);e+=1)a[e]|=2;for(e="A".charCodeAt(0);e<="Z".charCodeAt(0);e+=1)a[e]|=4;for(e="a".charCodeAt(0);e<="z".charCodeAt(0);e+=1)a[e]|=4}(),t.Tokenizer={tokenize:function(e){var t=e,r=e+"\0",s=r.length,l=0,u=[];function c(){for(var e,i=l,a=!1;!a;)if("'"===(e=r[l+=1])&&("'"===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,m(i,l),i,l))}function d(){for(var e,i=l,a=!1;!a;)if('"'===(e=r[l+=1])&&('"'===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating double-quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,m(i,l),i,l))}function p(e){var n,o,i,a=!1,s=l,u=r[l+1];if(!e||"x"!==u&&"X"!==u){do{l+=1}while(T(r[l]));if("."===(u=r[l])){a=!0,n=l;do{l+=1}while(T(r[l]));if(l===n+1)return void h(m(s,l=n),!1,s,l)}if(o=l,E("L","l")){if(a)throw{name:"SpelParseException",message:"Real cannot be long in expression ("+t+") at position "+l};h(m(s,o),!0,s,o),l+=1}else if(function(e){return"e"===e||"E"===e}(r[l])){a=!0,function(e){return"+"===e||"-"===e}(r[l+=1])&&(l+=1);do{l+=1}while(T(r[l]));i=!1,S(r[l])?(i=!0,o=l+=1):w(r[l])&&(o=l+=1),v(m(s,l),i,s,l)}else i=!1,S(u=r[l])?(a=!0,i=!0,o=l+=1):w(u)&&(a=!0,o=l+=1),a?v(m(s,o),i,s,o):h(m(s,o),!1,s,o)}else{l+=1;do{l+=1}while(_(r[l]));E("L","l")?(g(m(s+2,l),!0,s,l),l+=1):g(m(s+2,l),!1,s,l)}}function f(){var e,t,a,s=l;do{l+=1}while(x(a=r[l])||T(a)||"_"===a||"$"===a);e=m(s,l),(l-s==2||l-s==3)&&(t=e.toUpperCase(),i.indexOf(t)>=0)?function(e,t,r){u.push(new n.Token(e,r,t,t+e.getLength()))}(o.TokenKind.valueOf(t),s,e):u.push(new n.Token(o.TokenKind.IDENTIFIER,e.replace("\0",""),s,l))}function h(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_LONG,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_INT,e,r,i))}function g(e,r,i,a){if(0===e.length)throw r?{name:"SpelParseException",message:"Not a long in expression ("+t+") at position "+l}:{name:"SpelParseException",message:"Not an int in expression ("+t+") at position "+l};r?u.push(new n.Token(o.TokenKind.LITERAL_HEXLONG,e,i,a)):u.push(new n.Token(o.TokenKind.LITERAL_HEXINT,e,i,a))}function v(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_REAL_FLOAT,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_REAL,e,r,i))}function m(e,t){return r.substring(e,t)}function y(e){return 2===e.tokenChars.length&&r[l]===e.tokenChars[0]&&r[l+1]===e.tokenChars[1]}function b(e){u.push(new n.Token(e,null,l,l+1)),l+=1}function O(e){u.push(new n.Token(e,null,l,l+2)),l+=2}function E(e,t){var n=r[l];return n===e||n===t}function S(e){return"f"===e||"F"===e}function w(e){return"d"===e||"D"===e}function T(e){return!(e.charCodeAt(0)>255||!(1&a[e.charCodeAt(0)]))}function x(e){return!(e.charCodeAt(0)>255||!(4&a[e.charCodeAt(0)]))}function _(e){return!(e.charCodeAt(0)>255||!(2&a[e.charCodeAt(0)]))}return function(){for(var e;l<s;)if(x(e=r[l]))f();else switch(e){case"+":y(o.TokenKind.INC)?O(o.TokenKind.INC):b(o.TokenKind.PLUS);break;case"_":f();break;case"-":y(o.TokenKind.DEC)?O(o.TokenKind.DEC):b(o.TokenKind.MINUS);break;case":":b(o.TokenKind.COLON);break;case".":b(o.TokenKind.DOT);break;case",":b(o.TokenKind.COMMA);break;case"*":b(o.TokenKind.STAR);break;case"/":b(o.TokenKind.DIV);break;case"%":b(o.TokenKind.MOD);break;case"(":b(o.TokenKind.LPAREN);break;case")":b(o.TokenKind.RPAREN);break;case"[":b(o.TokenKind.LSQUARE);break;case"#":b(o.TokenKind.HASH);break;case"]":b(o.TokenKind.RSQUARE);break;case"{":b(o.TokenKind.LCURLY);break;case"}":b(o.TokenKind.RCURLY);break;case"@":b(o.TokenKind.BEAN_REF);break;case"^":y(o.TokenKind.SELECT_FIRST)?O(o.TokenKind.SELECT_FIRST):b(o.TokenKind.POWER);break;case"!":y(o.TokenKind.NE)?O(o.TokenKind.NE):y(o.TokenKind.PROJECT)?O(o.TokenKind.PROJECT):b(o.TokenKind.NOT);break;case"=":y(o.TokenKind.EQ)?O(o.TokenKind.EQ):b(o.TokenKind.ASSIGN);break;case"&":if(!y(o.TokenKind.SYMBOLIC_AND))throw{name:"SpelParseException",message:"Missing character '&' in expression ("+t+") at position "+l};O(o.TokenKind.SYMBOLIC_AND);break;case"|":if(!y(o.TokenKind.SYMBOLIC_OR))throw{name:"SpelParseException",message:"Missing character '|' in expression ("+t+") at position "+l};O(o.TokenKind.SYMBOLIC_OR);break;case"?":y(o.TokenKind.SELECT)?O(o.TokenKind.SELECT):y(o.TokenKind.ELVIS)?O(o.TokenKind.ELVIS):y(o.TokenKind.SAFE_NAVI)?O(o.TokenKind.SAFE_NAVI):b(o.TokenKind.QMARK);break;case"$":y(o.TokenKind.SELECT_LAST)?O(o.TokenKind.SELECT_LAST):f();break;case">":y(o.TokenKind.GE)?O(o.TokenKind.GE):b(o.TokenKind.GT);break;case"<":y(o.TokenKind.LE)?O(o.TokenKind.LE):b(o.TokenKind.LT);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":p("0"===e);break;case" ":case"\t":case"\r":case"\n":case"\0":l+=1;break;case"'":c();break;case'"':d();break;case"\\":throw{name:"SpelParseException",message:"Unexpected escape character in expression ("+t+") at position "+l};default:throw{name:"SpelParseException",message:"Cannot handle character '"+e+"' in expression ("+t+") at position "+l}}}(),u}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Token=void 0;var n=r(2);function o(e,t,r,n){this.kind=e,this.startPos=r,this.endPos=n,t&&(this.data=t)}o.prototype.getKind=function(){return this.kind},o.prototype.toString=function(){var e="[";return e+=this.kind.toString(),this.kind.hasPayload()&&(e+=":"+this.data),(e+="]")+"("+this.startPos+","+this.endPos+")"},o.prototype.isIdentifier=function(){return this.kind===n.TokenKind.IDENTIFIER},o.prototype.isNumericRelationalOperator=function(){return this.kind===n.TokenKind.GT||this.kind===n.TokenKind.GE||this.kind===n.TokenKind.LT||this.kind===n.TokenKind.LE||this.kind===n.TokenKind.EQ||this.kind===n.TokenKind.NE},o.prototype.stringValue=function(){return this.data},o.prototype.asInstanceOfToken=function(){return new o(n.TokenKind.INSTANCEOF,this.startPos,this.endPos)},o.prototype.asMatchesToken=function(){return new o(n.TokenKind.MATCHES,this.startPos,this.endPos)},o.prototype.asBetweenToken=function(){return new o(n.TokenKind.BETWEEN,this.startPos,this.endPos)},o.prototype.getStartPosition=function(){return this.startPos},o.prototype.getEndPosition=function(){return this.endPos},t.Token=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BooleanLiteral=void 0;var n=r(0);t.BooleanLiteral={create:function(e,t){var r=n.SpelNode.create("boolean",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NumberLiteral=void 0;var n=r(0);t.NumberLiteral={create:function(e,t){var r=n.SpelNode.create("number",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringLiteral=void 0;var n=r(0);t.StringLiteral={create:function(e,t){var r=n.SpelNode.create("string",t);return e=function(e){return("'"===e[0]&&"'"===e[e.length-1]||'"'===e[0]&&'"'===e[e.length-1])&&(e=e.substring(1,e.length-1)),e.replace(/''/g,"'").replace(/""/g,'"')}(e),r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullLiteral=void 0;var n=r(0);t.NullLiteral={create:function(e,t){var r=n.SpelNode.create("null",t);return r.getValue=function(){return null},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FunctionReference=void 0;var n=r(0),o=r(1);t.FunctionReference={create:function(e,t,r){var i=n.SpelNode.create("function",t);return i.getRaw=function(){return{functionName:e,args:r}},i.getValue=function(t){var n=t.locals||{},i=t.rootContext,a=[];if(r.forEach((function(e){var r=t.activeContext;t.activeContext=new o.Stack,t.activeContext.push(t.rootContext),a.push(e.getValue(t)),t.activeContext=r})),n[e])return n[e].apply(i,a);throw{name:"FunctionDoesNotExistException",message:"Function '"+e+"' does not exist."}},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MethodReference=void 0;var n=r(0),o=r(1);t.MethodReference={create:function(e,t,r,i){var a=n.SpelNode.create("method",r);return a.getRaw=function(){return{methodName:t,args:i}},a.getValue=function(r){var n,a=r.activeContext.peek(),s=[];if(!a)throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."};function l(r){if(null==r){if(e)return null;throw{name:"NullPointerException",message:"Method "+t+" does not exist."}}return r}if(i.forEach((function(e){var t=r.activeContext;r.activeContext=new o.Stack,r.activeContext.push(r.rootContext),s.push(e.getValue(r)),r.activeContext=t})),"get"===t.substr(0,3)&&!a[t])return l(a[t.charAt(3).toLowerCase()+t.substring(4)]);if("set"===t.substr(0,3)&&!a[t])return a[t.charAt(3).toLowerCase()+t.substring(4)]=s[0];if(Array.isArray(a)){if("size"===t)return a.length;if("contains"===t)return a.includes(s[0])}return(n=l(a[t]))?n.apply(a,s):null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyReference=void 0;var n=r(0);t.PropertyReference={create:function(e,t,r){var o=n.SpelNode.create("property",r);return o.getRaw=function(){return t},o.getValue=function(r){var n=r.activeContext.peek();if(!n){if(e)return null;throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."}}if(void 0===n[t]||null===n[t]){if(e)return null;if("size"===t&&Array.isArray(n))return n.length;throw{name:"NullPointerException",message:"Property '"+t+"' does not exist."}}return n[t]},o.setValue=function(e,r){var n=r.activeContext.peek();if(!n)throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t+"' for an undefined context."};return n[t]=e},o.getName=function(){return t},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VariableReference=void 0;var n=r(0);t.VariableReference={create:function(e,t){var r=n.SpelNode.create("variable",t);return r.getRaw=function(){return e},r.getValue=function(t){var r=t.activeContext.peek(),n=t.locals;if(!r)throw{name:"ContextDoesNotExistException",message:"Attempting to look up variable '"+e+"' for an undefined context."};return"this"===e?r:"root"===e?t.rootContext:n[e]},r.setValue=function(t,r){return r.locals[e]=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CompoundExpression=void 0;var n=r(0);t.CompoundExpression={create:function(e,t){var r=n.SpelNode.create.apply(null,["compound",e].concat(t));function o(e){var t,n=r.getChildren().length;for(t=0;t<n;t+=1)"indexer"===r.getChildren()[t].getType()?e.activeContext.push(e.activeContext.peek()[r.getChildren()[t].getValue(e)]):e.activeContext.push(r.getChildren()[t].getValue(e));return function(){for(t=0;t<n;t+=1)e.activeContext.pop()}}return r.getValue=function(e){var t;if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};var r=o(e);return t=e.activeContext.peek(),r(),t},r.setValue=function(e,t){var n=o(t),i=r.getChildren().length;return t.activeContext.pop(),e=r.getChildren()[i-1].setValue(e,t),t.activeContext.push(null),n(),e},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Indexer=void 0;var n=r(0),o=r(1);t.Indexer={create:function(e,t){var r=n.SpelNode.create.apply(null,["indexer",e].concat(t));return r.getValue=function(e){var t,n,i=e.activeContext,a=r.getChildren().length;if(e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};for(t=0;t<a;t+=1)e.activeContext.push(r.getChildren()[t].getValue(e));for(n=e.activeContext.peek(),t=0;t<a;t+=1)e.activeContext.pop();return e.activeContext=i,n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Assign=void 0;var n=r(0);t.Assign={create:function(e,t,r){var o=n.SpelNode.create("assign",e,t,r);return o.getValue=function(e){if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t.getValue(e)+"' for an undefined context."};return t.setValue(r.getValue(e),e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpEQ=void 0;var n=r(0);t.OpEQ={create:function(e,t,r){var o=n.SpelNode.create("op-eq",e,t,r);return o.getValue=function(e){return t.getValue(e)===r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNE=void 0;var n=r(0);t.OpNE={create:function(e,t,r){var o=n.SpelNode.create("op-ne",e,t,r);return o.getValue=function(e){return t.getValue(e)!==r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGE=void 0;var n=r(0);t.OpGE={create:function(e,t,r){var o=n.SpelNode.create("op-ge",e,t,r);return o.getValue=function(e){return t.getValue(e)>=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGT=void 0;var n=r(0);t.OpGT={create:function(e,t,r){var o=n.SpelNode.create("op-gt",e,t,r);return o.getValue=function(e){return t.getValue(e)>r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLE=void 0;var n=r(0);t.OpLE={create:function(e,t,r){var o=n.SpelNode.create("op-le",e,t,r);return o.getValue=function(e){return t.getValue(e)<=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLT=void 0;var n=r(0);t.OpLT={create:function(e,t,r){var o=n.SpelNode.create("op-lt",e,t,r);return o.getValue=function(e){return t.getValue(e)<r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPlus=void 0;var n=r(0);t.OpPlus={create:function(e,t,r){var o=n.SpelNode.create("op-plus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)+r.getValue(e):+t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMinus=void 0;var n=r(0);t.OpMinus={create:function(e,t,r){var o=n.SpelNode.create("op-minus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)-r.getValue(e):-t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMultiply=void 0;var n=r(0);t.OpMultiply={create:function(e,t,r){var o=n.SpelNode.create("op-multiply",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);if("number"==typeof n&&"number"==typeof o)return n*o;if("string"==typeof n&&"number"==typeof o){for(var i="",a=0;a<o;a+=1)i+=n;return i}return null},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDivide=void 0;var n=r(0);t.OpDivide={create:function(e,t,r){var o=n.SpelNode.create("op-divide",e,t,r);return o.getValue=function(e){return t.getValue(e)/r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpModulus=void 0;var n=r(0);t.OpModulus={create:function(e,t,r){var o=n.SpelNode.create("op-modulus",e,t,r);return o.getValue=function(e){return t.getValue(e)%r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPower=void 0;var n=r(0);t.OpPower={create:function(e,t,r){var o=n.SpelNode.create("op-power",e,t,r);return o.getValue=function(e){return Math.pow(t.getValue(e),r.getValue(e))},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInc=void 0;var n=r(0);t.OpInc={create:function(e,t,r){var o=n.SpelNode.create("op-inc",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n+1,e),t?n:n+1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDec=void 0;var n=r(0);t.OpDec={create:function(e,t,r){var o=n.SpelNode.create("op-dec",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n-1,e),t?n:n-1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNot=void 0;var n=r(0);t.OpNot={create:function(e,t){var r=n.SpelNode.create("op-not",e,t);return r.getValue=function(e){return!t.getValue(e)},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpAnd=void 0;var n=r(0);t.OpAnd={create:function(e,t,r){var o=n.SpelNode.create("op-and",e,t,r);return o.getValue=function(e){return!!t.getValue(e)&&!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpOr=void 0;var n=r(0);t.OpOr={create:function(e,t,r){var o=n.SpelNode.create("op-or",e,t,r);return o.getValue=function(e){return!!t.getValue(e)||!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMatches=void 0;var n=r(0);t.OpMatches={create:function(e,t,r){var o=n.SpelNode.create("matches",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);try{return!!new RegExp(o).exec(n)}catch(e){throw{name:"EvaluationException",message:e.toString()}}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ternary=void 0;var n=r(0);t.Ternary={create:function(e,t,r,o){var i=n.SpelNode.create("ternary",e,t,r,o);return i.getValue=function(e){return t.getValue(e)?r.getValue(e):o.getValue(e)},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Elvis=void 0;var n=r(0);t.Elvis={create:function(e,t,r){var o=n.SpelNode.create("elvis",e,t,r);return o.getValue=function(e){return null!==t.getValue(e)?t.getValue(e):r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineList=void 0;var n=r(0);t.InlineList={create:function(e,t){var r=n.SpelNode.create("list",e),o=[].concat(t||[]);return r.getRaw=function(){return o},r.getValue=function(e){return o.map((function(t){return t.getValue(e)}))},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineMap=void 0;var n=r(0);t.InlineMap={create:function(e,t){var r=n.SpelNode.create("map",e),o=[].concat(t||[]);return r.getValue=function(e){var t=!0,r=null,n={};return o.forEach((function(o){t?r="property"===o.getType()?o.getName():o.getValue(e):n[r]=o.getValue(e),t=!t})),n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}t.Selection={create:function(e,t,r,a){var s=o.SpelNode.create("selection",r,a);return s.getValue=function(e){var r=e.activeContext.peek();if(r){if(Array.isArray(r))return function(e,t,r,n){var o=e.filter((function(e){return i(e,r,n)}));switch(t){case"ALL":return o;case"FIRST":return o[0]||null;case"LAST":return o.length?o[o.length-1]:null}}(r,t,a,e);if("object"===(void 0===r?"undefined":n(r)))return function(e,t,r,n){var o,a,s={},l=[],u={};for(a in e)e.hasOwnProperty(a)&&i(o={key:a,value:e[a]},r,n)&&l.push(o);switch(t){case"ALL":return l.forEach((function(e){s[e.key]=e.value})),s;case"FIRST":return l.length?(u[l[0].key]=l[0].value,u):null;case"LAST":return l.length?(u[l[l.length-1].key]=l[l.length-1].value,u):null}l.forEach((function(e){s[e.key]=e.value}))}(r,t,a,e)}return null},s},FIRST:"FIRST",LAST:"LAST",ALL:"ALL"}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Projection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){return e.map((function(e){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}))}t.Projection={create:function(e,t,r){var a=o.SpelNode.create("projection",t,r);return a.getValue=function(e){var t,o=e.activeContext.peek(),a=[];if(Array.isArray(o))return i(o,r,e);if("object"===(void 0===o?"undefined":n(o))){for(t in o)o.hasOwnProperty(t)&&a.push(o[t]);return i(a,r,e)}return null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInstanceof=void 0;var n=r(0);t.OpInstanceof={create:function(e,t,r){var o=n.SpelNode.create("instanceof",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpInstanceOf: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpBetween=void 0;var n=r(0);t.OpBetween={create:function(e,t,r){var o=n.SpelNode.create("between",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpBetween: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TypeReference=void 0;var n=r(0);t.TypeReference={create:function(e,t,r){return(t=n.SpelNode.create("typeref",e,t)).getValue=function(e){throw{name:"MethodNotImplementedException",message:"TypeReference: Not implemented"}},t}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BeanReference=void 0;var n=r(0);t.BeanReference={create:function(e,t){var r=n.SpelNode.create("beanref",e);return r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"BeanReference: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Identifier=void 0;var n=r(0);t.Identifier={create:function(e,t){var r=n.SpelNode.create("identifier",t);return r.getRaw=function(){return e},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"Identifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QualifiedIdentifier=void 0;var n=r(0);t.QualifiedIdentifier={create:function(e,t){var r=n.SpelNode.create.apply(n.SpelNode,["qualifiedidentifier",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(t)));return r.getRaw=function(){return t.map((function(e){return e.getRaw()}))},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"QualifiedIdentifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConstructorReference=void 0;var n=r(0),o=r(1);t.ConstructorReference={create:function(e,t,r){var i,a=void 0!==r;a?i=t.length&&t[0]&&"number"===t[0].getType()?t[0].getValue():null:(r=t,t=void 0);var s,l=(s=r,Array.isArray(s)?s:Array.from(s)),u=(l[0],l.slice(1)),c=n.SpelNode.create.apply(n.SpelNode,["constructorref",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(r)));return c.getRaw=function(){return i},c.getValue=function(e){if(a&&u.length<=1){var t=[];return u.forEach((function(r){var n=e.activeContext;e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),t.push(r.getValue(e)),e.activeContext=n})),1===u.length?t[0]:i?new Array(i):[]}throw{name:"MethodNotImplementedException",message:"ConstructorReference: Not implemented"}},c}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext={create:function(e,t){var r={};return r.authentication=e||{},r.principal=t||{},r.hasRole=function(e){var t=!1;return!!e&&!(!r.authentication&&!Array.isArray(r.authentication.authorities))&&(r.authentication.authorities.forEach((function(r){r.authority.toLowerCase()===e.toLowerCase()&&(t=!0)})),t)},r.hasPermission=function(){var e=Array.prototype.slice.call(arguments);if(1===e.length)return r.hasRole(e[0])},r}}}])},e.exports=t()},9157:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=l(r(1283)),o=l(r(1025)),i=l(r(2520)),a=l(r(9137)),s=l(r(9429));function l(e){return e&&e.__esModule?e:{default:e}}function u(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var c=function(e){return e.replace(/[\t ]+$/,"")},d=function(){function e(t,r,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t||{},this.indentation=new i.default(this.cfg.indent),this.inlineBlock=new a.default,this.params=new s.default(this.cfg.params),this.tokenizer=r,this.tokenOverride=n,this.previousReservedWord={},this.tokens=[],this.index=0}var t,r;return t=e,r=[{key:"format",value:function(e){return this.tokens=this.tokenizer.tokenize(e),this.getFormattedQueryFromTokens().trim()}},{key:"getFormattedQueryFromTokens",value:function(){var e=this,t="";return this.tokens.forEach((function(r,n){e.index=n,e.tokenOverride&&(r=e.tokenOverride(r,e.previousReservedWord)||r),r.type===o.default.WHITESPACE||(r.type===o.default.LINE_COMMENT?t=e.formatLineComment(r,t):r.type===o.default.BLOCK_COMMENT?t=e.formatBlockComment(r,t):r.type===o.default.RESERVED_TOP_LEVEL?(t=e.formatTopLevelReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_TOP_LEVEL_NO_INDENT?(t=e.formatTopLevelReservedWordNoIndent(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_NEWLINE?(t=e.formatNewlineReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED?(t=e.formatWithSpaces(r,t),e.previousReservedWord=r):t=r.type===o.default.OPEN_PAREN?e.formatOpeningParentheses(r,t):r.type===o.default.CLOSE_PAREN?e.formatClosingParentheses(r,t):r.type===o.default.PLACEHOLDER?e.formatPlaceholder(r,t):","===r.value?e.formatComma(r,t):":"===r.value?e.formatWithSpaceAfter(r,t):"."===r.value?e.formatWithoutSpaces(r,t):";"===r.value?e.formatQuerySeparator(r,t):e.formatWithSpaces(r,t))})),t}},{key:"formatLineComment",value:function(e,t){return this.addNewline(t+e.value)}},{key:"formatBlockComment",value:function(e,t){return this.addNewline(this.addNewline(t)+this.indentComment(e.value))}},{key:"indentComment",value:function(e){return e.replace(/\n[\t ]*/g,"\n"+this.indentation.getIndent()+" ")}},{key:"formatTopLevelReservedWordNoIndent",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatTopLevelReservedWord",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t),this.indentation.increaseTopLevel(),t+=this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatNewlineReservedWord",value:function(e,t){return this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value))+" "}},{key:"equalizeWhitespace",value:function(e){return e.replace(/[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+/g," ")}},{key:"formatOpeningParentheses",value:function(e,t){var r=[o.default.WHITESPACE,o.default.OPEN_PAREN,o.default.LINE_COMMENT];return(0,n.default)(r,this.previousToken().type)||(t=c(t)),t+=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.beginIfPossible(this.tokens,this.index),this.inlineBlock.isActive()||(this.indentation.increaseBlockLevel(),t=this.addNewline(t)),t}},{key:"formatClosingParentheses",value:function(e,t){return e.value=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.isActive()?(this.inlineBlock.end(),this.formatWithSpaceAfter(e,t)):(this.indentation.decreaseBlockLevel(),this.formatWithSpaces(e,this.addNewline(t)))}},{key:"formatPlaceholder",value:function(e,t){return t+this.params.get(e)+" "}},{key:"formatComma",value:function(e,t){return t=c(t)+e.value+" ",this.inlineBlock.isActive()||/^LIMIT$/i.test(this.previousReservedWord.value)?t:this.addNewline(t)}},{key:"formatWithSpaceAfter",value:function(e,t){return c(t)+e.value+" "}},{key:"formatWithoutSpaces",value:function(e,t){return c(t)+e.value}},{key:"formatWithSpaces",value:function(e,t){return t+("reserved"===e.type?this.formatReservedWord(e.value):e.value)+" "}},{key:"formatReservedWord",value:function(e){return this.cfg.uppercase?e.toUpperCase():e}},{key:"formatQuerySeparator",value:function(e,t){return this.indentation.resetIndentation(),c(t)+e.value+"\n".repeat(this.cfg.linesBetweenQueries||1)}},{key:"addNewline",value:function(e){return(e=c(e)).endsWith("\n")||(e+="\n"),e+this.indentation.getIndent()}},{key:"previousToken",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.tokens[this.index-e]||{}}}],r&&u(t.prototype,r),e}();t.default=d,e.exports=t.default},2520:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9901)),o=i(r(8906));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s="top-level",l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.indent=t||"  ",this.indentTypes=[]}var t,r;return t=e,(r=[{key:"getIndent",value:function(){return(0,n.default)(this.indent,this.indentTypes.length)}},{key:"increaseTopLevel",value:function(){this.indentTypes.push(s)}},{key:"increaseBlockLevel",value:function(){this.indentTypes.push("block-level")}},{key:"decreaseTopLevel",value:function(){(0,o.default)(this.indentTypes)===s&&this.indentTypes.pop()}},{key:"decreaseBlockLevel",value:function(){for(;this.indentTypes.length>0&&this.indentTypes.pop()===s;);}},{key:"resetIndentation",value:function(){this.indentTypes=[]}}])&&a(t.prototype,r),e}();t.default=l,e.exports=t.default},9137:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n,o=(n=r(1025))&&n.__esModule?n:{default:n};function i(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.level=0}var t,r;return t=e,(r=[{key:"beginIfPossible",value:function(e,t){0===this.level&&this.isInlineBlock(e,t)?this.level=1:this.level>0?this.level++:this.level=0}},{key:"end",value:function(){this.level--}},{key:"isActive",value:function(){return this.level>0}},{key:"isInlineBlock",value:function(e,t){for(var r=0,n=0,i=t;i<e.length;i++){var a=e[i];if((r+=a.value.length)>50)return!1;if(a.type===o.default.OPEN_PAREN)n++;else if(a.type===o.default.CLOSE_PAREN&&0==--n)return!0;if(this.isForbiddenToken(a))return!1}return!1}},{key:"isForbiddenToken",value:function(e){var t=e.type,r=e.value;return t===o.default.RESERVED_TOP_LEVEL||t===o.default.RESERVED_NEWLINE||t===o.default.COMMENT||t===o.default.BLOCK_COMMENT||";"===r}}])&&i(t.prototype,r),e}();t.default=a,e.exports=t.default},9429:(e,t)=>{"use strict";function r(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.params=t,this.index=0}var t,n;return t=e,(n=[{key:"get",value:function(e){var t=e.key,r=e.value;return this.params?t?this.params[t]:this.params[this.index++]:r}}])&&r(t.prototype,n),e}();t.default=n,e.exports=t.default},3202:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(7969)),o=a(r(8472)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.WHITESPACE_REGEX=/^([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+)/,this.NUMBER_REGEX=/^((\x2D[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*)?[0-9]+(\.[0-9]+)?|0x[0-9A-Fa-f]+|0b[01]+)\b/,this.OPERATOR_REGEX=/^(!=|<>|==|<=|>=|!<|!>|\|\||::|\x2D>>|\x2D>|~~\*|~~|!~~\*|!~~|~\*|!~\*|!~|:=|(?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))/,this.BLOCK_COMMENT_REGEX=/^(\/\*(?:[\0-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*?(?:\*\/|$))/,this.LINE_COMMENT_REGEX=this.createLineCommentRegex(t.lineCommentTypes),this.RESERVED_TOP_LEVEL_REGEX=this.createReservedWordRegex(t.reservedTopLevelWords),this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX=this.createReservedWordRegex(t.reservedTopLevelWordsNoIndent),this.RESERVED_NEWLINE_REGEX=this.createReservedWordRegex(t.reservedNewlineWords),this.RESERVED_PLAIN_REGEX=this.createReservedWordRegex(t.reservedWords),this.WORD_REGEX=this.createWordRegex(t.specialWordChars),this.STRING_REGEX=this.createStringRegex(t.stringTypes),this.OPEN_PAREN_REGEX=this.createParenRegex(t.openParens),this.CLOSE_PAREN_REGEX=this.createParenRegex(t.closeParens),this.INDEXED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.indexedPlaceholderTypes,"[0-9]*"),this.IDENT_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,"[a-zA-Z0-9._$]+"),this.STRING_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,this.createStringPattern(t.stringTypes))}var t,r;return t=e,r=[{key:"createLineCommentRegex",value:function(e){return new RegExp("^((?:".concat(e.map((function(e){return(0,o.default)(e)})).join("|"),").*?(?:\r\n|\r|\n|$))"),"u")}},{key:"createReservedWordRegex",value:function(e){var t=e.join("|").replace(/ /g,"\\s+");return new RegExp("^(".concat(t,")\\b"),"iu")}},{key:"createWordRegex",value:function(){return new RegExp("^([\\p{Alphabetic}\\p{Mark}\\p{Decimal_Number}\\p{Connector_Punctuation}\\p{Join_Control}".concat((arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).join(""),"]+)"),"u")}},{key:"createStringRegex",value:function(e){return new RegExp("^("+this.createStringPattern(e)+")","u")}},{key:"createStringPattern",value:function(e){var t={"``":"((`[^`]*($|`))+)","[]":"((\\[[^\\]]*($|\\]))(\\][^\\]]*($|\\]))*)",'""':'(("[^"\\\\]*(?:\\\\.[^"\\\\]*)*("|$))+)',"''":"(('[^'\\\\]*(?:\\\\.[^'\\\\]*)*('|$))+)","N''":"((N'[^N'\\\\]*(?:\\\\.[^N'\\\\]*)*('|$))+)"};return e.map((function(e){return t[e]})).join("|")}},{key:"createParenRegex",value:function(e){var t=this;return new RegExp("^("+e.map((function(e){return t.escapeParen(e)})).join("|")+")","iu")}},{key:"escapeParen",value:function(e){return 1===e.length?(0,o.default)(e):"\\b"+e+"\\b"}},{key:"createPlaceholderRegex",value:function(e,t){if((0,n.default)(e))return!1;var r=e.map(o.default).join("|");return new RegExp("^((?:".concat(r,")(?:").concat(t,"))"),"u")}},{key:"tokenize",value:function(e){if(!e)return[];for(var t,r=[];e.length;)t=this.getNextToken(e,t),e=e.substring(t.value.length),r.push(t);return r}},{key:"getNextToken",value:function(e,t){return this.getWhitespaceToken(e)||this.getCommentToken(e)||this.getStringToken(e)||this.getOpenParenToken(e)||this.getCloseParenToken(e)||this.getPlaceholderToken(e)||this.getNumberToken(e)||this.getReservedWordToken(e,t)||this.getWordToken(e)||this.getOperatorToken(e)}},{key:"getWhitespaceToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WHITESPACE,regex:this.WHITESPACE_REGEX})}},{key:"getCommentToken",value:function(e){return this.getLineCommentToken(e)||this.getBlockCommentToken(e)}},{key:"getLineCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.LINE_COMMENT,regex:this.LINE_COMMENT_REGEX})}},{key:"getBlockCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.BLOCK_COMMENT,regex:this.BLOCK_COMMENT_REGEX})}},{key:"getStringToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.STRING,regex:this.STRING_REGEX})}},{key:"getOpenParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPEN_PAREN,regex:this.OPEN_PAREN_REGEX})}},{key:"getCloseParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.CLOSE_PAREN,regex:this.CLOSE_PAREN_REGEX})}},{key:"getPlaceholderToken",value:function(e){return this.getIdentNamedPlaceholderToken(e)||this.getStringNamedPlaceholderToken(e)||this.getIndexedPlaceholderToken(e)}},{key:"getIdentNamedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.IDENT_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getStringNamedPlaceholderToken",value:function(e){var t=this;return this.getPlaceholderTokenWithKey({input:e,regex:this.STRING_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return t.getEscapedPlaceholderKey({key:e.slice(2,-1),quoteChar:e.slice(-1)})}})}},{key:"getIndexedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.INDEXED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getPlaceholderTokenWithKey",value:function(e){var t=e.input,r=e.regex,n=e.parseKey,o=this.getTokenOnFirstMatch({input:t,regex:r,type:i.default.PLACEHOLDER});return o&&(o.key=n(o.value)),o}},{key:"getEscapedPlaceholderKey",value:function(e){var t=e.key,r=e.quoteChar;return t.replace(new RegExp((0,o.default)("\\"+r),"gu"),r)}},{key:"getNumberToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.NUMBER,regex:this.NUMBER_REGEX})}},{key:"getOperatorToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPERATOR,regex:this.OPERATOR_REGEX})}},{key:"getReservedWordToken",value:function(e,t){if(!t||!t.value||"."!==t.value)return this.getTopLevelReservedToken(e)||this.getNewlineReservedToken(e)||this.getTopLevelReservedTokenNoIndent(e)||this.getPlainReservedToken(e)}},{key:"getTopLevelReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL,regex:this.RESERVED_TOP_LEVEL_REGEX})}},{key:"getNewlineReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_NEWLINE,regex:this.RESERVED_NEWLINE_REGEX})}},{key:"getTopLevelReservedTokenNoIndent",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL_NO_INDENT,regex:this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX})}},{key:"getPlainReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED,regex:this.RESERVED_PLAIN_REGEX})}},{key:"getWordToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WORD,regex:this.WORD_REGEX})}},{key:"getTokenOnFirstMatch",value:function(e){var t=e.input,r=e.type,n=e.regex,o=t.match(n);if(o)return{type:r,value:o[1]}}}],r&&s(t.prototype,r),e}();t.default=l,e.exports=t.default},1025:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default={WHITESPACE:"whitespace",WORD:"word",STRING:"string",RESERVED:"reserved",RESERVED_TOP_LEVEL:"reserved-top-level",RESERVED_TOP_LEVEL_NO_INDENT:"reserved-top-level-no-indent",RESERVED_NEWLINE:"reserved-newline",OPERATOR:"operator",OPEN_PAREN:"open-paren",CLOSE_PAREN:"close-paren",LINE_COMMENT:"line-comment",BLOCK_COMMENT:"block-comment",NUMBER:"number",PLACEHOLDER:"placeholder"},e.exports=t.default},4377:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ABS","ACTIVATE","ALIAS","ALL","ALLOCATE","ALLOW","ALTER","ANY","ARE","ARRAY","AS","ASC","ASENSITIVE","ASSOCIATE","ASUTIME","ASYMMETRIC","AT","ATOMIC","ATTRIBUTES","AUDIT","AUTHORIZATION","AUX","AUXILIARY","AVG","BEFORE","BEGIN","BETWEEN","BIGINT","BINARY","BLOB","BOOLEAN","BOTH","BUFFERPOOL","BY","CACHE","CALL","CALLED","CAPTURE","CARDINALITY","CASCADED","CASE","CAST","CCSID","CEIL","CEILING","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CLOB","CLONE","CLOSE","CLUSTER","COALESCE","COLLATE","COLLECT","COLLECTION","COLLID","COLUMN","COMMENT","COMMIT","CONCAT","CONDITION","CONNECT","CONNECTION","CONSTRAINT","CONTAINS","CONTINUE","CONVERT","CORR","CORRESPONDING","COUNT","COUNT_BIG","COVAR_POP","COVAR_SAMP","CREATE","CROSS","CUBE","CUME_DIST","CURRENT","CURRENT_DATE","CURRENT_DEFAULT_TRANSFORM_GROUP","CURRENT_LC_CTYPE","CURRENT_PATH","CURRENT_ROLE","CURRENT_SCHEMA","CURRENT_SERVER","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_TIMEZONE","CURRENT_TRANSFORM_GROUP_FOR_TYPE","CURRENT_USER","CURSOR","CYCLE","DATA","DATABASE","DATAPARTITIONNAME","DATAPARTITIONNUM","DATE","DAY","DAYS","DB2GENERAL","DB2GENRL","DB2SQL","DBINFO","DBPARTITIONNAME","DBPARTITIONNUM","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFAULTS","DEFINITION","DELETE","DENSERANK","DENSE_RANK","DEREF","DESCRIBE","DESCRIPTOR","DETERMINISTIC","DIAGNOSTICS","DISABLE","DISALLOW","DISCONNECT","DISTINCT","DO","DOCUMENT","DOUBLE","DROP","DSSIZE","DYNAMIC","EACH","EDITPROC","ELEMENT","ELSE","ELSEIF","ENABLE","ENCODING","ENCRYPTION","END","END-EXEC","ENDING","ERASE","ESCAPE","EVERY","EXCEPTION","EXCLUDING","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXP","EXPLAIN","EXTENDED","EXTERNAL","EXTRACT","FALSE","FENCED","FETCH","FIELDPROC","FILE","FILTER","FINAL","FIRST","FLOAT","FLOOR","FOR","FOREIGN","FREE","FULL","FUNCTION","FUSION","GENERAL","GENERATED","GET","GLOBAL","GOTO","GRANT","GRAPHIC","GROUP","GROUPING","HANDLER","HASH","HASHED_VALUE","HINT","HOLD","HOUR","HOURS","IDENTITY","IF","IMMEDIATE","IN","INCLUDING","INCLUSIVE","INCREMENT","INDEX","INDICATOR","INDICATORS","INF","INFINITY","INHERIT","INNER","INOUT","INSENSITIVE","INSERT","INT","INTEGER","INTEGRITY","INTERSECTION","INTERVAL","INTO","IS","ISOBID","ISOLATION","ITERATE","JAR","JAVA","KEEP","KEY","LABEL","LANGUAGE","LARGE","LATERAL","LC_CTYPE","LEADING","LEAVE","LEFT","LIKE","LINKTYPE","LN","LOCAL","LOCALDATE","LOCALE","LOCALTIME","LOCALTIMESTAMP","LOCATOR","LOCATORS","LOCK","LOCKMAX","LOCKSIZE","LONG","LOOP","LOWER","MAINTAINED","MATCH","MATERIALIZED","MAX","MAXVALUE","MEMBER","MERGE","METHOD","MICROSECOND","MICROSECONDS","MIN","MINUTE","MINUTES","MINVALUE","MOD","MODE","MODIFIES","MODULE","MONTH","MONTHS","MULTISET","NAN","NATIONAL","NATURAL","NCHAR","NCLOB","NEW","NEW_TABLE","NEXTVAL","NO","NOCACHE","NOCYCLE","NODENAME","NODENUMBER","NOMAXVALUE","NOMINVALUE","NONE","NOORDER","NORMALIZE","NORMALIZED","NOT","NULL","NULLIF","NULLS","NUMERIC","NUMPARTS","OBID","OCTET_LENGTH","OF","OFFSET","OLD","OLD_TABLE","ON","ONLY","OPEN","OPTIMIZATION","OPTIMIZE","OPTION","ORDER","OUT","OUTER","OVER","OVERLAPS","OVERLAY","OVERRIDING","PACKAGE","PADDED","PAGESIZE","PARAMETER","PART","PARTITION","PARTITIONED","PARTITIONING","PARTITIONS","PASSWORD","PATH","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","PIECESIZE","PLAN","POSITION","POWER","PRECISION","PREPARE","PREVVAL","PRIMARY","PRIQTY","PRIVILEGES","PROCEDURE","PROGRAM","PSID","PUBLIC","QUERY","QUERYNO","RANGE","RANK","READ","READS","REAL","RECOVERY","RECURSIVE","REF","REFERENCES","REFERENCING","REFRESH","REGR_AVGX","REGR_AVGY","REGR_COUNT","REGR_INTERCEPT","REGR_R2","REGR_SLOPE","REGR_SXX","REGR_SXY","REGR_SYY","RELEASE","RENAME","REPEAT","RESET","RESIGNAL","RESTART","RESTRICT","RESULT","RESULT_SET_LOCATOR","RETURN","RETURNS","REVOKE","RIGHT","ROLE","ROLLBACK","ROLLUP","ROUND_CEILING","ROUND_DOWN","ROUND_FLOOR","ROUND_HALF_DOWN","ROUND_HALF_EVEN","ROUND_HALF_UP","ROUND_UP","ROUTINE","ROW","ROWNUMBER","ROWS","ROWSET","ROW_NUMBER","RRN","RUN","SAVEPOINT","SCHEMA","SCOPE","SCRATCHPAD","SCROLL","SEARCH","SECOND","SECONDS","SECQTY","SECURITY","SENSITIVE","SEQUENCE","SESSION","SESSION_USER","SIGNAL","SIMILAR","SIMPLE","SMALLINT","SNAN","SOME","SOURCE","SPECIFIC","SPECIFICTYPE","SQL","SQLEXCEPTION","SQLID","SQLSTATE","SQLWARNING","SQRT","STACKED","STANDARD","START","STARTING","STATEMENT","STATIC","STATMENT","STAY","STDDEV_POP","STDDEV_SAMP","STOGROUP","STORES","STYLE","SUBMULTISET","SUBSTRING","SUM","SUMMARY","SYMMETRIC","SYNONYM","SYSFUN","SYSIBM","SYSPROC","SYSTEM","SYSTEM_USER","TABLE","TABLESAMPLE","TABLESPACE","THEN","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TRAILING","TRANSACTION","TRANSLATE","TRANSLATION","TREAT","TRIGGER","TRIM","TRUE","TRUNCATE","TYPE","UESCAPE","UNDO","UNIQUE","UNKNOWN","UNNEST","UNTIL","UPPER","USAGE","USER","USING","VALIDPROC","VALUE","VARCHAR","VARIABLE","VARIANT","VARYING","VAR_POP","VAR_SAMP","VCAT","VERSION","VIEW","VOLATILE","VOLUMES","WHEN","WHENEVER","WHILE","WIDTH_BUCKET","WINDOW","WITH","WITHIN","WITHOUT","WLM","WRITE","XMLELEMENT","XMLEXISTS","XMLNAMESPACES","YEAR","YEARS"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INTERSECT","LIMIT","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS JOIN","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``","[]"],openParens:["("],closeParens:[")"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["#","@"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},9445:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ALL","ALTER","ANALYZE","AND","ANY","ARRAY","AS","ASC","BEGIN","BETWEEN","BINARY","BOOLEAN","BREAK","BUCKET","BUILD","BY","CALL","CASE","CAST","CLUSTER","COLLATE","COLLECTION","COMMIT","CONNECT","CONTINUE","CORRELATE","COVER","CREATE","DATABASE","DATASET","DATASTORE","DECLARE","DECREMENT","DELETE","DERIVED","DESC","DESCRIBE","DISTINCT","DO","DROP","EACH","ELEMENT","ELSE","END","EVERY","EXCEPT","EXCLUDE","EXECUTE","EXISTS","EXPLAIN","FALSE","FETCH","FIRST","FLATTEN","FOR","FORCE","FROM","FUNCTION","GRANT","GROUP","GSI","HAVING","IF","IGNORE","ILIKE","IN","INCLUDE","INCREMENT","INDEX","INFER","INLINE","INNER","INSERT","INTERSECT","INTO","IS","JOIN","KEY","KEYS","KEYSPACE","KNOWN","LAST","LEFT","LET","LETTING","LIKE","LIMIT","LSM","MAP","MAPPING","MATCHED","MATERIALIZED","MERGE","MISSING","NAMESPACE","NEST","NOT","NULL","NUMBER","OBJECT","OFFSET","ON","OPTION","OR","ORDER","OUTER","OVER","PARSE","PARTITION","PASSWORD","PATH","POOL","PREPARE","PRIMARY","PRIVATE","PRIVILEGE","PROCEDURE","PUBLIC","RAW","REALM","REDUCE","RENAME","RETURN","RETURNING","REVOKE","RIGHT","ROLE","ROLLBACK","SATISFIES","SCHEMA","SELECT","SELF","SEMI","SET","SHOW","SOME","START","STATISTICS","STRING","SYSTEM","THEN","TO","TRANSACTION","TRIGGER","TRUE","TRUNCATE","UNDER","UNION","UNIQUE","UNKNOWN","UNNEST","UNSET","UPDATE","UPSERT","USE","USER","USING","VALIDATE","VALUE","VALUED","VALUES","VIA","VIEW","WHEN","WHERE","WHILE","WITH","WITHIN","WORK","XOR"],u=["DELETE FROM","EXCEPT ALL","EXCEPT","EXPLAIN DELETE FROM","EXPLAIN UPDATE","EXPLAIN UPSERT","FROM","GROUP BY","HAVING","INFER","INSERT INTO","LET","LIMIT","MERGE","NEST","ORDER BY","PREPARE","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UNNEST","UPDATE","UPSERT","USE KEYS","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``"],openParens:["(","[","{"],closeParens:[")","]","}"],namedPlaceholderTypes:["$"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7881:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(9157)),o=a(r(3202)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["A","ACCESSIBLE","AGENT","AGGREGATE","ALL","ALTER","ANY","ARRAY","AS","ASC","AT","ATTRIBUTE","AUTHID","AVG","BETWEEN","BFILE_BASE","BINARY_INTEGER","BINARY","BLOB_BASE","BLOCK","BODY","BOOLEAN","BOTH","BOUND","BREADTH","BULK","BY","BYTE","C","CALL","CALLING","CASCADE","CASE","CHAR_BASE","CHAR","CHARACTER","CHARSET","CHARSETFORM","CHARSETID","CHECK","CLOB_BASE","CLONE","CLOSE","CLUSTER","CLUSTERS","COALESCE","COLAUTH","COLLECT","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPILED","COMPRESS","CONNECT","CONSTANT","CONSTRUCTOR","CONTEXT","CONTINUE","CONVERT","COUNT","CRASH","CREATE","CREDENTIAL","CURRENT","CURRVAL","CURSOR","CUSTOMDATUM","DANGLING","DATA","DATE_BASE","DATE","DAY","DECIMAL","DEFAULT","DEFINE","DELETE","DEPTH","DESC","DETERMINISTIC","DIRECTORY","DISTINCT","DO","DOUBLE","DROP","DURATION","ELEMENT","ELSIF","EMPTY","END","ESCAPE","EXCEPTIONS","EXCLUSIVE","EXECUTE","EXISTS","EXIT","EXTENDS","EXTERNAL","EXTRACT","FALSE","FETCH","FINAL","FIRST","FIXED","FLOAT","FOR","FORALL","FORCE","FROM","FUNCTION","GENERAL","GOTO","GRANT","GROUP","HASH","HEAP","HIDDEN","HOUR","IDENTIFIED","IF","IMMEDIATE","IN","INCLUDING","INDEX","INDEXES","INDICATOR","INDICES","INFINITE","INSTANTIABLE","INT","INTEGER","INTERFACE","INTERVAL","INTO","INVALIDATE","IS","ISOLATION","JAVA","LANGUAGE","LARGE","LEADING","LENGTH","LEVEL","LIBRARY","LIKE","LIKE2","LIKE4","LIKEC","LIMITED","LOCAL","LOCK","LONG","MAP","MAX","MAXLEN","MEMBER","MERGE","MIN","MINUTE","MLSLABEL","MOD","MODE","MONTH","MULTISET","NAME","NAN","NATIONAL","NATIVE","NATURAL","NATURALN","NCHAR","NEW","NEXTVAL","NOCOMPRESS","NOCOPY","NOT","NOWAIT","NULL","NULLIF","NUMBER_BASE","NUMBER","OBJECT","OCICOLL","OCIDATE","OCIDATETIME","OCIDURATION","OCIINTERVAL","OCILOBLOCATOR","OCINUMBER","OCIRAW","OCIREF","OCIREFCURSOR","OCIROWID","OCISTRING","OCITYPE","OF","OLD","ON","ONLY","OPAQUE","OPEN","OPERATOR","OPTION","ORACLE","ORADATA","ORDER","ORGANIZATION","ORLANY","ORLVARY","OTHERS","OUT","OVERLAPS","OVERRIDING","PACKAGE","PARALLEL_ENABLE","PARAMETER","PARAMETERS","PARENT","PARTITION","PASCAL","PCTFREE","PIPE","PIPELINED","PLS_INTEGER","PLUGGABLE","POSITIVE","POSITIVEN","PRAGMA","PRECISION","PRIOR","PRIVATE","PROCEDURE","PUBLIC","RAISE","RANGE","RAW","READ","REAL","RECORD","REF","REFERENCE","RELEASE","RELIES_ON","REM","REMAINDER","RENAME","RESOURCE","RESULT_CACHE","RESULT","RETURN","RETURNING","REVERSE","REVOKE","ROLLBACK","ROW","ROWID","ROWNUM","ROWTYPE","SAMPLE","SAVE","SAVEPOINT","SB1","SB2","SB4","SEARCH","SECOND","SEGMENT","SELF","SEPARATE","SEQUENCE","SERIALIZABLE","SHARE","SHORT","SIZE_T","SIZE","SMALLINT","SOME","SPACE","SPARSE","SQL","SQLCODE","SQLDATA","SQLERRM","SQLNAME","SQLSTATE","STANDARD","START","STATIC","STDDEV","STORED","STRING","STRUCT","STYLE","SUBMULTISET","SUBPARTITION","SUBSTITUTABLE","SUBTYPE","SUCCESSFUL","SUM","SYNONYM","SYSDATE","TABAUTH","TABLE","TDO","THE","THEN","TIME","TIMESTAMP","TIMEZONE_ABBR","TIMEZONE_HOUR","TIMEZONE_MINUTE","TIMEZONE_REGION","TO","TRAILING","TRANSACTION","TRANSACTIONAL","TRIGGER","TRUE","TRUSTED","TYPE","UB1","UB2","UB4","UID","UNDER","UNIQUE","UNPLUG","UNSIGNED","UNTRUSTED","USE","USER","USING","VALIDATE","VALIST","VALUE","VARCHAR","VARCHAR2","VARIABLE","VARIANCE","VARRAY","VARYING","VIEW","VIEWS","VOID","WHENEVER","WHILE","WITH","WORK","WRAPPED","WRITE","YEAR","ZONE"],c=["ADD","ALTER COLUMN","ALTER TABLE","BEGIN","CONNECT BY","DECLARE","DELETE FROM","DELETE","END","EXCEPT","EXCEPTION","FETCH FIRST","FROM","GROUP BY","HAVING","INSERT INTO","INSERT","LIMIT","LOOP","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","START WITH","UPDATE","VALUES","WHERE"],d=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],p=["AND","CROSS APPLY","CROSS JOIN","ELSE","END","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],f=function(e,t){if(e.type===i.default.RESERVED_TOP_LEVEL&&"SET"===e.value&&"BY"===t.value)return e.type=i.default.RESERVED,e},h=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:c,reservedNewlineWords:p,reservedTopLevelWordsNoIndent:d,stringTypes:['""',"N''","''","``"],openParens:["(","CASE","BEGIN"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["_","$","#",".","@"]})),new n.default(this.cfg,l,f).format(e)}}])&&s(t.prototype,r),e}();t.default=h,e.exports=t.default},1432:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ACCESSIBLE","ACTION","AGAINST","AGGREGATE","ALGORITHM","ALL","ALTER","ANALYSE","ANALYZE","AS","ASC","AUTOCOMMIT","AUTO_INCREMENT","BACKUP","BEGIN","BETWEEN","BINLOG","BOTH","CASCADE","CASE","CHANGE","CHANGED","CHARACTER SET","CHARSET","CHECK","CHECKSUM","COLLATE","COLLATION","COLUMN","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPRESSED","CONCURRENT","CONSTRAINT","CONTAINS","CONVERT","CREATE","CROSS","CURRENT_TIMESTAMP","DATABASE","DATABASES","DAY","DAY_HOUR","DAY_MINUTE","DAY_SECOND","DEFAULT","DEFINER","DELAYED","DELETE","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DO","DROP","DUMPFILE","DUPLICATE","DYNAMIC","ELSE","ENCLOSED","END","ENGINE","ENGINES","ENGINE_TYPE","ESCAPE","ESCAPED","EVENTS","EXEC","EXECUTE","EXISTS","EXPLAIN","EXTENDED","FAST","FETCH","FIELDS","FILE","FIRST","FIXED","FLUSH","FOR","FORCE","FOREIGN","FULL","FULLTEXT","FUNCTION","GLOBAL","GRANT","GRANTS","GROUP_CONCAT","HEAP","HIGH_PRIORITY","HOSTS","HOUR","HOUR_MINUTE","HOUR_SECOND","IDENTIFIED","IF","IFNULL","IGNORE","IN","INDEX","INDEXES","INFILE","INSERT","INSERT_ID","INSERT_METHOD","INTERVAL","INTO","INVOKER","IS","ISOLATION","KEY","KEYS","KILL","LAST_INSERT_ID","LEADING","LEVEL","LIKE","LINEAR","LINES","LOAD","LOCAL","LOCK","LOCKS","LOGS","LOW_PRIORITY","MARIA","MASTER","MASTER_CONNECT_RETRY","MASTER_HOST","MASTER_LOG_FILE","MATCH","MAX_CONNECTIONS_PER_HOUR","MAX_QUERIES_PER_HOUR","MAX_ROWS","MAX_UPDATES_PER_HOUR","MAX_USER_CONNECTIONS","MEDIUM","MERGE","MINUTE","MINUTE_SECOND","MIN_ROWS","MODE","MODIFY","MONTH","MRG_MYISAM","MYISAM","NAMES","NATURAL","NOT","NOW()","NULL","OFFSET","ON DELETE","ON UPDATE","ON","ONLY","OPEN","OPTIMIZE","OPTION","OPTIONALLY","OUTFILE","PACK_KEYS","PAGE","PARTIAL","PARTITION","PARTITIONS","PASSWORD","PRIMARY","PRIVILEGES","PROCEDURE","PROCESS","PROCESSLIST","PURGE","QUICK","RAID0","RAID_CHUNKS","RAID_CHUNKSIZE","RAID_TYPE","RANGE","READ","READ_ONLY","READ_WRITE","REFERENCES","REGEXP","RELOAD","RENAME","REPAIR","REPEATABLE","REPLACE","REPLICATION","RESET","RESTORE","RESTRICT","RETURN","RETURNS","REVOKE","RLIKE","ROLLBACK","ROW","ROWS","ROW_FORMAT","SECOND","SECURITY","SEPARATOR","SERIALIZABLE","SESSION","SHARE","SHOW","SHUTDOWN","SLAVE","SONAME","SOUNDS","SQL","SQL_AUTO_IS_NULL","SQL_BIG_RESULT","SQL_BIG_SELECTS","SQL_BIG_TABLES","SQL_BUFFER_RESULT","SQL_CACHE","SQL_CALC_FOUND_ROWS","SQL_LOG_BIN","SQL_LOG_OFF","SQL_LOG_UPDATE","SQL_LOW_PRIORITY_UPDATES","SQL_MAX_JOIN_SIZE","SQL_NO_CACHE","SQL_QUOTE_SHOW_CREATE","SQL_SAFE_UPDATES","SQL_SELECT_LIMIT","SQL_SLAVE_SKIP_COUNTER","SQL_SMALL_RESULT","SQL_WARNINGS","START","STARTING","STATUS","STOP","STORAGE","STRAIGHT_JOIN","STRING","STRIPED","SUPER","TABLE","TABLES","TEMPORARY","TERMINATED","THEN","TO","TRAILING","TRANSACTIONAL","TRUE","TRUNCATE","TYPE","TYPES","UNCOMMITTED","UNIQUE","UNLOCK","UNSIGNED","USAGE","USE","USING","VARIABLES","VIEW","WHEN","WITH","WORK","WRITE","YEAR_MONTH"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INSERT","LIMIT","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS APPLY","CROSS JOIN","ELSE","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"N''","''","``","[]"],openParens:["(","CASE"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:["@",":"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7409:(e,t,r)=>{"use strict";t.Ay=void 0;var n=s(r(4377)),o=s(r(9445)),i=s(r(7881)),a=s(r(1432));function s(e){return e&&e.__esModule?e:{default:e}}var l={format:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};switch(t.language){case"db2":return new n.default(t).format(e);case"n1ql":return new o.default(t).format(e);case"pl/sql":return new i.default(t).format(e);case"sql":case void 0:return new a.default(t).format(e);default:throw Error("Unsupported SQL dialect: ".concat(t.language))}}};t.Ay=l},358:(e,t,r)=>{e.exports=r(3231)},3231:(e,t)=>{var r=t,n=/`/g,o=/\./g,i=/[\0\b\t\n\r\x1a\"\'\\]/g,a={"\0":"\\0","\b":"\\b","\t":"\\t","\n":"\\n","\r":"\\r","":"\\Z",'"':'\\"',"'":"\\'","\\":"\\\\"};function s(e){for(var t,r=i.lastIndex=0,n="";t=i.exec(e);)n+=e.slice(r,t.index)+a[t[0]],r=i.lastIndex;return 0===r?"'"+e+"'":r<e.length?"'"+n+e.slice(r)+"'":"'"+n+"'"}function l(e,t){for(e=e.toString();e.length<t;)e="0"+e;return e}r.escapeId=function(e,t){if(Array.isArray(e)){for(var i="",a=0;a<e.length;a++)i+=(0===a?"":", ")+r.escapeId(e[a],t);return i}return t?"`"+String(e).replace(n,"``")+"`":"`"+String(e).replace(n,"``").replace(o,"`.`")+"`"},r.escape=function(e,t,n){if(null==e)return"NULL";switch(typeof e){case"boolean":return e?"true":"false";case"number":return e+"";case"object":return"[object Date]"===Object.prototype.toString.call(e)?r.dateToString(e,n||"local"):Array.isArray(e)?r.arrayToList(e,n):Buffer.isBuffer(e)?r.bufferToString(e):"function"==typeof e.toSqlString?String(e.toSqlString()):t?s(e.toString()):r.objectToValues(e,n);default:return s(e)}},r.arrayToList=function(e,t){for(var n="",o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?n+=(0===o?"":", ")+"("+r.arrayToList(i,t)+")":n+=(0===o?"":", ")+r.escape(i,!0,t)}return n},r.format=function(e,t,n,o){if(null==t)return e;Array.isArray(t)||(t=[t]);for(var i,a=0,s=/\?+/g,l="",u=0;u<t.length&&(i=s.exec(e));){var c=i[0].length;if(!(c>2)){var d=2===c?r.escapeId(t[u]):r.escape(t[u],n,o);l+=e.slice(a,i.index)+d,a=s.lastIndex,u++}}return 0===a?e:a<e.length?l+e.slice(a):l},r.dateToString=function(e,t){var r,n,o,i,a,u,c,d=new Date(e);if(isNaN(d.getTime()))return"NULL";if("local"===t)r=d.getFullYear(),n=d.getMonth()+1,o=d.getDate(),i=d.getHours(),a=d.getMinutes(),u=d.getSeconds(),c=d.getMilliseconds();else{var p=function(e){if("Z"===e)return 0;var t=e.match(/([\+\-\s])(\d\d):?(\d\d)?/);return!!t&&("-"===t[1]?-1:1)*(parseInt(t[2],10)+(t[3]?parseInt(t[3],10):0)/60)*60}(t);!1!==p&&0!==p&&d.setTime(d.getTime()+6e4*p),r=d.getUTCFullYear(),n=d.getUTCMonth()+1,o=d.getUTCDate(),i=d.getUTCHours(),a=d.getUTCMinutes(),u=d.getUTCSeconds(),c=d.getUTCMilliseconds()}return s(l(r,4)+"-"+l(n,2)+"-"+l(o,2)+" "+l(i,2)+":"+l(a,2)+":"+l(u,2)+"."+l(c,3))},r.bufferToString=function(e){return"X"+s(e.toString("hex"))},r.objectToValues=function(e,t){var n="";for(var o in e){var i=e[o];"function"!=typeof i&&(n+=(0===n.length?"":", ")+r.escapeId(o)+" = "+r.escape(i,!0,t))}return n},r.raw=function(e){if("string"!=typeof e)throw new TypeError("argument sql must be a string");return{toSqlString:function(){return e}}}},4882:(e,t,r)=>{var n=r(5534);e.exports=function(e){return n(e).replace(/\s(\w)/g,(function(e,t){return t.toUpperCase()}))}},7188:e=>{e.exports=function(e){return t.test(e)?e.toLowerCase():r.test(e)?(function(e){return e.replace(o,(function(e,t){return t?" "+t:""}))}(e)||e).toLowerCase():n.test(e)?function(e){return e.replace(i,(function(e,t,r){return t+" "+r.toLowerCase().split("").join(" ")}))}(e).toLowerCase():e.toLowerCase()};var t=/\s/,r=/(_|-|\.|:)/,n=/([a-z][A-Z]|[A-Z][a-z])/,o=/[\W_]+(.|$)/g,i=/(.)([A-Z]+)/g},5534:(e,t,r)=>{var n=r(7188);e.exports=function(e){return n(e).replace(/[\W_]+(.|$)/g,(function(e,t){return t?" "+t:""})).trim()}},1882:e=>{e.exports=function(){var e=document.getSelection();if(!e.rangeCount)return function(){};for(var t=document.activeElement,r=[],n=0;n<e.rangeCount;n++)r.push(e.getRangeAt(n));switch(t.tagName.toUpperCase()){case"INPUT":case"TEXTAREA":t.blur();break;default:t=null}return e.removeAllRanges(),function(){"Caret"===e.type&&e.removeAllRanges(),e.rangeCount||r.forEach((function(t){e.addRange(t)})),t&&t.focus()}}},627:e=>{e.exports={area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0}},6089:e=>{"use strict";e.exports=a},9089:e=>{"use strict";e.exports=c},7781:t=>{"use strict";t.exports=e},8531:e=>{"use strict";e.exports=r},2007:e=>{"use strict";e.exports=i},3241:e=>{"use strict";e.exports=n},2468:e=>{"use strict";e.exports=s},5959:e=>{"use strict";e.exports=o},8398:e=>{"use strict";e.exports=d},200:e=>{"use strict";e.exports=u},7694:e=>{"use strict";e.exports=l},1269:e=>{"use strict";e.exports=t},8911:(e,t,r)=>{var n=r(5992).default;function o(){"use strict";e.exports=o=function(){return r},e.exports.__esModule=!0,e.exports.default=e.exports;var t,r={},i=Object.prototype,a=i.hasOwnProperty,s=Object.defineProperty||function(e,t,r){e[t]=r.value},l="function"==typeof Symbol?Symbol:{},u=l.iterator||"@@iterator",c=l.asyncIterator||"@@asyncIterator",d=l.toStringTag||"@@toStringTag";function p(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{p({},"")}catch(t){p=function(e,t,r){return e[t]=r}}function f(e,t,r,n){var o=t&&t.prototype instanceof O?t:O,i=Object.create(o.prototype),a=new L(n||[]);return s(i,"_invoke",{value:I(e,r,a)}),i}function h(e,t,r){try{return{type:"normal",arg:e.call(t,r)}}catch(e){return{type:"throw",arg:e}}}r.wrap=f;var g="suspendedStart",v="suspendedYield",m="executing",y="completed",b={};function O(){}function E(){}function S(){}var w={};p(w,u,(function(){return this}));var T=Object.getPrototypeOf,x=T&&T(T(k([])));x&&x!==i&&a.call(x,u)&&(w=x);var _=S.prototype=O.prototype=Object.create(w);function C(e){["next","throw","return"].forEach((function(t){p(e,t,(function(e){return this._invoke(t,e)}))}))}function R(e,t){function r(o,i,s,l){var u=h(e[o],e,i);if("throw"!==u.type){var c=u.arg,d=c.value;return d&&"object"==n(d)&&a.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,s,l)}),(function(e){r("throw",e,s,l)})):t.resolve(d).then((function(e){c.value=e,s(c)}),(function(e){return r("throw",e,s,l)}))}l(u.arg)}var o;s(this,"_invoke",{value:function(e,n){function i(){return new t((function(t,o){r(e,n,t,o)}))}return o=o?o.then(i,i):i()}})}function I(e,r,n){var o=g;return function(i,a){if(o===m)throw Error("Generator is already running");if(o===y){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var s=n.delegate;if(s){var l=A(s,n);if(l){if(l===b)continue;return l}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===g)throw o=y,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=m;var u=h(e,r,n);if("normal"===u.type){if(o=n.done?y:v,u.arg===b)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(o=y,n.method="throw",n.arg=u.arg)}}}function A(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,A(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a '"+n+"' method")),b;var i=h(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,b;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,b):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,b)}function j(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function P(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function L(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(j,this),this.reset(!0)}function k(e){if(e||""===e){var r=e[u];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function r(){for(;++o<e.length;)if(a.call(e,o))return r.value=e[o],r.done=!1,r;return r.value=t,r.done=!0,r};return i.next=i}}throw new TypeError(n(e)+" is not iterable")}return E.prototype=S,s(_,"constructor",{value:S,configurable:!0}),s(S,"constructor",{value:E,configurable:!0}),E.displayName=p(S,d,"GeneratorFunction"),r.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===E||"GeneratorFunction"===(t.displayName||t.name))},r.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,S):(e.__proto__=S,p(e,d,"GeneratorFunction")),e.prototype=Object.create(_),e},r.awrap=function(e){return{__await:e}},C(R.prototype),p(R.prototype,c,(function(){return this})),r.AsyncIterator=R,r.async=function(e,t,n,o,i){void 0===i&&(i=Promise);var a=new R(f(e,t,n,o),i);return r.isGeneratorFunction(t)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},C(_),p(_,d,"Generator"),p(_,u,(function(){return this})),p(_,"toString",(function(){return"[object Generator]"})),r.keys=function(e){var t=Object(e),r=[];for(var n in t)r.push(n);return r.reverse(),function e(){for(;r.length;){var n=r.pop();if(n in t)return e.value=n,e.done=!1,e}return e.done=!0,e}},r.values=k,L.prototype={constructor:L,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(P),!e)for(var r in this)"t"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function n(n,o){return s.type="throw",s.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],s=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var l=a.call(i,"catchLoc"),u=a.call(i,"finallyLoc");if(l&&u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(l){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&a.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,b):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),b},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.finallyLoc===e)return this.complete(r.completion,r.afterLoc),P(r),b}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.tryLoc===e){var n=r.completion;if("throw"===n.type){var o=n.arg;P(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:k(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),b}},r}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},5992:e=>{function t(r){return e.exports=t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},6834:(e,t,r)=>{var n=r(8911)();e.exports=n;try{regeneratorRuntime=n}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=n:Function("r","regeneratorRuntime = r")(n)}},2584:(e,t)=>{var r;!function(){"use strict";var n={}.hasOwnProperty;function o(){for(var e="",t=0;t<arguments.length;t++){var r=arguments[t];r&&(e=a(e,i(r)))}return e}function i(e){if("string"==typeof e||"number"==typeof e)return e;if("object"!=typeof e)return"";if(Array.isArray(e))return o.apply(null,e);if(e.toString!==Object.prototype.toString&&!e.toString.toString().includes("[native code]"))return e.toString();var t="";for(var r in e)n.call(e,r)&&e[r]&&(t=a(t,r));return t}function a(e,t){return t?e?e+" "+t:e+t:e}e.exports?(o.default=o,e.exports=o):void 0===(r=function(){return o}.apply(t,[]))||(e.exports=r)}()},7016:(e,t,r)=>{"use strict";r.r(t),r.d(t,{__addDisposableResource:()=>k,__assign:()=>i,__asyncDelegator:()=>x,__asyncGenerator:()=>T,__asyncValues:()=>_,__await:()=>w,__awaiter:()=>h,__classPrivateFieldGet:()=>j,__classPrivateFieldIn:()=>L,__classPrivateFieldSet:()=>P,__createBinding:()=>v,__decorate:()=>s,__disposeResources:()=>D,__esDecorate:()=>u,__exportStar:()=>m,__extends:()=>o,__generator:()=>g,__importDefault:()=>A,__importStar:()=>I,__makeTemplateObject:()=>C,__metadata:()=>f,__param:()=>l,__propKey:()=>d,__read:()=>b,__rest:()=>a,__rewriteRelativeImportExtension:()=>F,__runInitializers:()=>c,__setFunctionName:()=>p,__spread:()=>O,__spreadArray:()=>S,__spreadArrays:()=>E,__values:()=>y,default:()=>M});var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)};function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var i=function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},i.apply(this,arguments)};function a(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}function s(e,t,r,n){var o,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)(o=e[s])&&(a=(i<3?o(a):i>3?o(t,r,a):o(t,r))||a);return i>3&&a&&Object.defineProperty(t,r,a),a}function l(e,t){return function(r,n){t(r,n,e)}}function u(e,t,r,n,o,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var s,l=n.kind,u="getter"===l?"get":"setter"===l?"set":"value",c=!t&&e?n.static?e:e.prototype:null,d=t||(c?Object.getOwnPropertyDescriptor(c,n.name):{}),p=!1,f=r.length-1;f>=0;f--){var h={};for(var g in n)h[g]="access"===g?{}:n[g];for(var g in n.access)h.access[g]=n.access[g];h.addInitializer=function(e){if(p)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var v=(0,r[f])("accessor"===l?{get:d.get,set:d.set}:d[u],h);if("accessor"===l){if(void 0===v)continue;if(null===v||"object"!=typeof v)throw new TypeError("Object expected");(s=a(v.get))&&(d.get=s),(s=a(v.set))&&(d.set=s),(s=a(v.init))&&o.unshift(s)}else(s=a(v))&&("field"===l?o.unshift(s):d[u]=s)}c&&Object.defineProperty(c,n.name,d),p=!0}function c(e,t,r){for(var n=arguments.length>2,o=0;o<t.length;o++)r=n?t[o].call(e,r):t[o].call(e);return n?r:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function p(e,t,r){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:r?"".concat(r," ",t):t})}function f(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function h(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{l(n.next(e))}catch(e){i(e)}}function s(e){try{l(n.throw(e))}catch(e){i(e)}}function l(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,s)}l((n=n.apply(e,t||[])).next())}))}function g(e,t){var r,n,o,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]},a=Object.create(("function"==typeof Iterator?Iterator:Object).prototype);return a.next=s(0),a.throw=s(1),a.return=s(2),"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(s){return function(l){return function(s){if(r)throw new TypeError("Generator is already executing.");for(;a&&(a=0,s[0]&&(i=0)),i;)try{if(r=1,n&&(o=2&s[0]?n.return:s[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,s[1])).done)return o;switch(n=0,o&&(s=[2&s[0],o.value]),s[0]){case 0:case 1:o=s;break;case 4:return i.label++,{value:s[1],done:!1};case 5:i.label++,n=s[1],s=[0];continue;case 7:s=i.ops.pop(),i.trys.pop();continue;default:if(!((o=(o=i.trys).length>0&&o[o.length-1])||6!==s[0]&&2!==s[0])){i=0;continue}if(3===s[0]&&(!o||s[1]>o[0]&&s[1]<o[3])){i.label=s[1];break}if(6===s[0]&&i.label<o[1]){i.label=o[1],o=s;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(s);break}o[2]&&i.ops.pop(),i.trys.pop();continue}s=t.call(e,i)}catch(e){s=[6,e],n=0}finally{r=o=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,l])}}}var v=Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]};function m(e,t){for(var r in e)"default"===r||Object.prototype.hasOwnProperty.call(t,r)||v(t,e,r)}function y(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function O(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function E(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),o=0;for(t=0;t<r;t++)for(var i=arguments[t],a=0,s=i.length;a<s;a++,o++)n[o]=i[a];return n}function S(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}function w(e){return this instanceof w?(this.v=e,this):new w(e)}function T(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,o=r.apply(e,t||[]),i=[];return n=Object.create(("function"==typeof AsyncIterator?AsyncIterator:Object).prototype),a("next"),a("throw"),a("return",(function(e){return function(t){return Promise.resolve(t).then(e,u)}})),n[Symbol.asyncIterator]=function(){return this},n;function a(e,t){o[e]&&(n[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||s(e,t)}))},t&&(n[e]=t(n[e])))}function s(e,t){try{(r=o[e](t)).value instanceof w?Promise.resolve(r.value.v).then(l,u):c(i[0][2],r)}catch(e){c(i[0][3],e)}var r}function l(e){s("next",e)}function u(e){s("throw",e)}function c(e,t){e(t),i.shift(),i.length&&s(i[0][0],i[0][1])}}function x(e){var t,r;return t={},n("next"),n("throw",(function(e){throw e})),n("return"),t[Symbol.iterator]=function(){return this},t;function n(n,o){t[n]=e[n]?function(t){return(r=!r)?{value:w(e[n](t)),done:!1}:o?o(t):t}:o}}function _(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e=y(e),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}}function C(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var R=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function I(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&v(t,e,r);return R(t,e),t}function A(e){return e&&e.__esModule?e:{default:e}}function j(e,t,r,n){if("a"===r&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===r?n:"a"===r?n.call(e):n?n.value:t.get(e)}function P(e,t,r,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!o:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(e,r):o?o.value=r:t.set(e,r),r}function L(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}function k(e,t,r){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var n,o;if(r){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");n=t[Symbol.asyncDispose]}if(void 0===n){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");n=t[Symbol.dispose],r&&(o=n)}if("function"!=typeof n)throw new TypeError("Object not disposable.");o&&(n=function(){try{o.call(this)}catch(e){return Promise.reject(e)}}),e.stack.push({value:t,dispose:n,async:r})}else r&&e.stack.push({async:!0});return t}var N="function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};function D(e){function t(t){e.error=e.hasError?new N(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}var r,n=0;return function o(){for(;r=e.stack.pop();)try{if(!r.async&&1===n)return n=0,e.stack.push(r),Promise.resolve().then(o);if(r.dispose){var i=r.dispose.call(r.value);if(r.async)return n|=2,Promise.resolve(i).then(o,(function(e){return t(e),o()}))}else n|=1}catch(e){t(e)}if(1===n)return e.hasError?Promise.reject(e.error):Promise.resolve();if(e.hasError)throw e.error}()}function F(e,t){return"string"==typeof e&&/^\.\.?\//.test(e)?e.replace(/\.(tsx)$|((?:\.d)?)((?:\.[^./]+?)?)\.([cm]?)ts$/i,(function(e,r,n,o,i){return r?t?".jsx":".js":!n||o&&i?n+o+"."+i.toLowerCase()+"js":e})):e}const M={__extends:o,__assign:i,__rest:a,__decorate:s,__param:l,__esDecorate:u,__runInitializers:c,__propKey:d,__setFunctionName:p,__metadata:f,__awaiter:h,__generator:g,__createBinding:v,__exportStar:m,__values:y,__read:b,__spread:O,__spreadArrays:E,__spreadArray:S,__await:w,__asyncGenerator:T,__asyncDelegator:x,__asyncValues:_,__makeTemplateObject:C,__importStar:I,__importDefault:A,__classPrivateFieldGet:j,__classPrivateFieldSet:P,__classPrivateFieldIn:L,__addDisposableResource:k,__disposeResources:D,__rewriteRelativeImportExtension:F}}},g={};function v(e){var t=g[e];if(void 0!==t)return t.exports;var r=g[e]={id:e,loaded:!1,exports:{}};return h[e].call(r.exports,r,r.exports,v),r.loaded=!0,r.exports}v.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return v.d(t,{a:t}),t},f=Object.getPrototypeOf?e=>Object.getPrototypeOf(e):e=>e.__proto__,v.t=function(e,t){if(1&t&&(e=this(e)),8&t)return e;if("object"==typeof e&&e){if(4&t&&e.__esModule)return e;if(16&t&&"function"==typeof e.then)return e}var r=Object.create(null);v.r(r);var n={};p=p||[null,f({}),f([]),f(f)];for(var o=2&t&&e;"object"==typeof o&&!~p.indexOf(o);o=f(o))Object.getOwnPropertyNames(o).forEach((t=>n[t]=()=>e[t]));return n.default=()=>e,v.d(r,n),r},v.d=(e,t)=>{for(var r in t)v.o(t,r)&&!v.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},v.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),v.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),v.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},v.nmd=e=>(e.paths=[],e.children||(e.children=[]),e);var m={};return(()=>{"use strict";v.r(m),v.d(m,{plugin:()=>oN});var e={};v.r(e),v.d(e,{applyToJS:()=>Hl,cleanJSX:()=>Kl,deepEqual:()=>Ul,deepFreeze:()=>eu,escapeRegExp:()=>ql,getFirstDefined:()=>nu,getLogger:()=>ru,getOpCardinality:()=>Vl,isDirtyJSX:()=>Yl,isImmutable:()=>zl,isImmutableList:()=>$l,isJSX:()=>Xl,isJsonCompatible:()=>tu,isJsonLogic:()=>Ql,isObject:()=>Dl,logger:()=>ou,mergeArraysSmart:()=>Zl,mergeCustomizerNoArrays:()=>Gl,omit:()=>Ml,opDefKeysToOmit:()=>Nl,shallowCopy:()=>Fl,shallowEqual:()=>Bl,sleep:()=>Jl,toImmutableList:()=>Wl,uuid:()=>Pl,widgetDefKeysToOmit:()=>kl});var t={};v.r(t),v.d(t,{getItemInListValues:()=>Ou,getListValue:()=>xu,getTitleInListValues:()=>Eu,getValueInListValues:()=>Su,listValuesToArray:()=>bu,makeCustomListValue:()=>yu,mapListValues:()=>wu,searchListValue:()=>Tu,toListValue:()=>mu});var r={};v.r(r),v.d(r,{_fixImmutableValue:()=>Vu,expandTreePath:()=>_u,expandTreeSubpath:()=>Cu,fixEmptyGroupsInTree:()=>ju,fixPathsInTree:()=>Au,getFlatTree:()=>Pu,getItemByPath:()=>Ru,getLightTree:()=>Nu,getSwitchValues:()=>Du,getTotalReordableNodesCountInTree:()=>Lu,getTotalRulesCountInTree:()=>ku,hasChildren:()=>Mu,immutableToJs:()=>Hl,isEmptyTree:()=>Fu,isImmutable:()=>zl,jsToImmutable:()=>Wu,removeIsLockedInTree:()=>Iu,toImmutableList:()=>Wl});var n={};v.r(n),v.d(n,{SqlString:()=>wc,mongoEmptyValue:()=>xc,spelEscape:()=>Cc,spelFixList:()=>_c,spelFormatConcat:()=>Rc,spelImportConcat:()=>Ic,sqlEmptyValue:()=>Tc,stringifyForDisplay:()=>Ac,wrapWithBrackets:()=>jc});var o={};v.r(o),v.d(o,{_loadFromJsonLogic:()=>ic,_loadFromSpel:()=>ad,getTree:()=>Uu,isImmutableTree:()=>zu,isJsonLogic:()=>Ql,isTree:()=>$u,jsToImmutable:()=>Wu,loadFromJsonLogic:()=>oc,loadFromSpel:()=>id,loadTree:()=>Bu});var i={};v.r(i),v.d(i,{createListFromArray:()=>Bd,createListWithOneElement:()=>Ud,defaultConjunction:()=>Nd,defaultGroupConjunction:()=>kd,defaultGroupProperties:()=>Dd,defaultItemProperties:()=>Fd,defaultOperatorOptions:()=>Pd,defaultRoot:()=>Vd,defaultRule:()=>Md,defaultRuleProperties:()=>Ld,emptyProperties:()=>zd,getDefaultField:()=>Rd,getDefaultFieldSrc:()=>Ad,getDefaultOperator:()=>jd,getDefaultSubField:()=>Id});var a={};v.r(a),v.d(a,{_validateTree:()=>zf,checkTree:()=>Mf,getNewValueForFieldOp:()=>Jf,getTreeBadFields:()=>Ff,isValidTree:()=>Df,sanitizeTree:()=>Uf,translateValidation:()=>jf,validateAndFixTree:()=>Bf,validateRange:()=>Qf,validateTree:()=>Vf,validateValue:()=>Gf});var s={};v.r(s),v.d(s,{completeFuncValue:()=>eh,getCompatibleArgsOnFuncChange:()=>sh,setArgValue:()=>ih,setArgValueSrc:()=>ah,setFunc:()=>th,setFuncDefaultArg:()=>nh});var l={};v.r(l),v.d(l,{calculateValueType:()=>ph,completeValue:()=>Ph,filterValueSourcesForField:()=>bh,formatFieldName:()=>Sh,getFieldPartsConfigs:()=>gh,getFieldPathLabels:()=>hh,getFirstOperator:()=>dh,getFuncPathLabels:()=>fh,getOneChildOrDescendant:()=>Lh,getOperatorsForField:()=>ch,getOperatorsForType:()=>uh,getValueLabel:()=>vh,getValueSourcesForFieldOp:()=>Oh,getWidgetForFieldOp:()=>Eh,getWidgetsForFieldOp:()=>yh,isEmptyGroupChildren:()=>Ch,isEmptyItem:()=>wh,isEmptyRuleGroupExtPropertiesAndChildren:()=>xh,isEmptyRuleProperties:()=>Ih,selectTypes:()=>lh,whatRulePropertiesAreCompleted:()=>Ah});var u={};v.r(u),v.d(u,{_getFromConfigCache:()=>Qg,_saveToConfigCache:()=>Jg,_widgetDefKeysToOmit:()=>Fg,applyJsonLogic:()=>zh,cleanJSX:()=>Kl,compileConfig:()=>sg,compressConfig:()=>ig,configKeys:()=>Yh,createConfigMemo:()=>wg,decompressConfig:()=>ag,extendConfig:()=>Rg,findExtendedConfigInAllMemos:()=>Sg,getCommonMemo:()=>Eg,getFieldConfig:()=>ev,getFieldId:()=>Xg,getFieldParts:()=>Kg,getFieldPath:()=>Gg,getFieldPathParts:()=>Yg,getFieldRawConfig:()=>Bg,getFieldSrc:()=>Zg,getFieldWidgetConfig:()=>rv,getFirstField:()=>nv,getFuncArgConfig:()=>Hg,getFuncConfig:()=>Wg,getFuncSignature:()=>$g,getOperatorConfig:()=>tv,isDirtyJSX:()=>Yl,isFieldDescendantOfField:()=>qg,isJSX:()=>Xl,iterateFields:()=>Vg,iterateFuncs:()=>Mg,normalizeField:()=>zg});var c={};v.r(c),v.d(c,{_mongodbFormat:()=>jv,_spelFormat:()=>Vc,_sqlFormat:()=>$v,elasticSearchFormat:()=>tm,jsonLogicFormat:()=>hv,mongodbFormat:()=>Av,queryBuilderFormat:()=>av,queryString:()=>Gd,spelFormat:()=>Mc,sqlFormat:()=>zv});var d={};v.r(d),v.d(d,{fixListValuesGroupOrder:()=>hm,getListValue:()=>xu,listValueToOption:()=>fm,mergeListValues:()=>cm,optionToListValue:()=>dm,optionsToListValues:()=>pm,simulateAsyncFetch:()=>um});var p={};v.r(p),v.d(p,{Autocomplete:()=>d,ConfigUtils:()=>u,DefaultUtils:()=>i,ExportUtils:()=>n,FuncUtils:()=>s,ListUtils:()=>t,OtherUtils:()=>e,RuleUtils:()=>l,TreeUtils:()=>r,Validation:()=>a,checkTree:()=>Mf,clone:()=>Fh(),compressConfig:()=>ig,decompressConfig:()=>ag,getSwitchValues:()=>Du,i18n:()=>Pf,isValidTree:()=>Df,moment:()=>Gu(),sanitizeTree:()=>Uf,uuid:()=>Pl,validateAndFixTree:()=>Bf,validateTree:()=>Vf});var f={};v.r(f),v.d(f,{LINEAR_REGRESSION:()=>bm,LOWER:()=>mm,NOW:()=>gm,RELATIVE_DATETIME:()=>vm,UPPER:()=>ym});var h={};v.r(h),v.d(h,{addCaseGroup:()=>xy,addDefaultCaseGroup:()=>Ty,addGroup:()=>_y,addRule:()=>Sy,moveItem:()=>Ry,removeGroup:()=>Cy,removeRule:()=>wy,setTree:()=>Ey});var g={};v.r(g),v.d(g,{setConjunction:()=>Iy,setLock:()=>jy,setNot:()=>Ay});var y={};v.r(y),v.d(y,{setField:()=>Py,setFieldSrc:()=>Ly,setFuncValue:()=>Fy,setOperator:()=>ky,setOperatorOption:()=>My,setValue:()=>Ny,setValueSrc:()=>Dy});var b={};v.r(b),v.d(b,{bindActionCreators:()=>hb,isUsingLegacyReactDomRender:()=>cb,liteShouldComponentUpdate:()=>db,pureShouldComponentUpdate:()=>pb,useOnPropsChanged:()=>fb});var O={};v.r(O),v.d(O,{FuncWidget:()=>cE,ValueFieldWidget:()=>pw,VanillaBooleanWidget:()=>fw,VanillaButton:()=>Iw,VanillaButtonGroup:()=>jw,VanillaConjs:()=>Cw,VanillaDateTimeWidget:()=>bw,VanillaDateWidget:()=>vw,VanillaFieldSelect:()=>_w,VanillaIcon:()=>Aw,VanillaMultiSelectWidget:()=>Ew,VanillaNumberWidget:()=>Tw,VanillaProvider:()=>Nw,VanillaSelectWidget:()=>ww,VanillaSliderWidget:()=>xw,VanillaSwitch:()=>Lw,VanillaTextAreaWidget:()=>gw,VanillaTextWidget:()=>hw,VanillaTimeWidget:()=>mw,VanillaValueSources:()=>Pw,vanillaConfirm:()=>kw});var E={};v.r(E),v.d(E,{ProximityOperator:()=>Mw});var S,w=v(7781);!function(e){e.Timeseries="time_series",e.Table="table"}(S||(S={}));const T=[{label:"Time series",value:"time_series"},{label:"Table",value:"table"}],x=null!==w.toOption&&void 0!==w.toOption?w.toOption:e=>({label:e,value:e});var _=v(1269);function C(e){return"function"==typeof e}var R=function(e,t){return R=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},R(e,t)};function I(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}R(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}function A(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function j(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function P(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}Object.create,Object.create,"function"==typeof SuppressedError&&SuppressedError;var L,k,N=(L=function(e){return function(t){e(this),this.message=t?t.length+" errors occurred during unsubscription:\n"+t.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=t}},k=L((function(e){Error.call(e),e.stack=(new Error).stack})),k.prototype=Object.create(Error.prototype),k.prototype.constructor=k,k);function D(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}var F=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._finalizers=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,n,o;if(!this.closed){this.closed=!0;var i=this._parentage;if(i)if(this._parentage=null,Array.isArray(i))try{for(var a=A(i),s=a.next();!s.done;s=a.next())s.value.remove(this)}catch(t){e={error:t}}finally{try{s&&!s.done&&(t=a.return)&&t.call(a)}finally{if(e)throw e.error}}else i.remove(this);var l=this.initialTeardown;if(C(l))try{l()}catch(e){o=e instanceof N?e.errors:[e]}var u=this._finalizers;if(u){this._finalizers=null;try{for(var c=A(u),d=c.next();!d.done;d=c.next()){var p=d.value;try{M(p)}catch(e){o=null!=o?o:[],e instanceof N?o=P(P([],j(o)),j(e.errors)):o.push(e)}}}catch(e){r={error:e}}finally{try{d&&!d.done&&(n=c.return)&&n.call(c)}finally{if(r)throw r.error}}}if(o)throw new N(o)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)M(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._finalizers=null!==(r=this._finalizers)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&D(t,e)},e.prototype.remove=function(t){var r=this._finalizers;r&&D(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function M(e){C(e)?e():e.unsubscribe()}F.EMPTY;var V=null,U=null,B=!1,z=!1,$={setTimeout:function(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];var o=$.delegate;return(null==o?void 0:o.setTimeout)?o.setTimeout.apply(o,P([e,t],j(r))):setTimeout.apply(void 0,P([e,t],j(r)))},clearTimeout:function(e){var t=$.delegate;return((null==t?void 0:t.clearTimeout)||clearTimeout)(e)},delegate:void 0};function W(){}var H=q("C",void 0,void 0);function q(e,t,r){return{kind:e,value:t,error:r}}var G=function(e){function t(t){var r,n=e.call(this)||this;return n.isStopped=!1,t?(n.destination=t,((r=t)instanceof F||r&&"closed"in r&&C(r.remove)&&C(r.add)&&C(r.unsubscribe))&&t.add(n)):n.destination=ee,n}return I(t,e),t.create=function(e,t,r){return new Q(e,t,r)},t.prototype.next=function(e){this.isStopped?Z(function(e){return q("N",e,void 0)}(e),this):this._next(e)},t.prototype.error=function(e){this.isStopped?Z(q("E",void 0,e),this):(this.isStopped=!0,this._error(e))},t.prototype.complete=function(){this.isStopped?Z(H,this):(this.isStopped=!0,this._complete())},t.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},t.prototype._next=function(e){this.destination.next(e)},t.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},t.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},t}(F),K=Function.prototype.bind;function Y(e,t){return K.call(e,t)}var X=function(){function e(e){this.partialObserver=e}return e.prototype.next=function(e){var t=this.partialObserver;if(t.next)try{t.next(e)}catch(e){J(e)}},e.prototype.error=function(e){var t=this.partialObserver;if(t.error)try{t.error(e)}catch(e){J(e)}else J(e)},e.prototype.complete=function(){var e=this.partialObserver;if(e.complete)try{e.complete()}catch(e){J(e)}},e}(),Q=function(e){function t(t,r,n){var o,i,a=e.call(this)||this;return C(t)||!t?o={next:null!=t?t:void 0,error:null!=r?r:void 0,complete:null!=n?n:void 0}:a&&z?((i=Object.create(t)).unsubscribe=function(){return a.unsubscribe()},o={next:t.next&&Y(t.next,i),error:t.error&&Y(t.error,i),complete:t.complete&&Y(t.complete,i)}):o=t,a.destination=new X(o),a}return I(t,e),t}(G);function J(e){B||function(e){$.setTimeout((function(){if(!V)throw e;V(e)}))}(e)}function Z(e,t){var r=U;r&&$.setTimeout((function(){return r(e,t)}))}var ee={closed:!0,next:W,error:function(e){throw e},complete:W},te=function(e){function t(t,r,n,o,i,a){var s=e.call(this,t)||this;return s.onFinalize=i,s.shouldUnsubscribe=a,s._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,s._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,s._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,s}return I(t,e),t.prototype.unsubscribe=function(){var t;if(!this.shouldUnsubscribe||this.shouldUnsubscribe()){var r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))}},t}(G);function re(e,t){return r=function(r,n){var o=0;r.subscribe(new te(n,(function(r){n.next(e.call(t,r,o++))}),void 0,void 0,void 0))},function(e){if(function(e){return C(null==e?void 0:e.lift)}(e))return e.lift((function(e){try{return r(e,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")};var r}var ne=(e=>(e[e.Comparison=0]="Comparison",e[e.Logical=1]="Logical",e))(ne||{}),oe=(e=>(e[e.Value=0]="Value",e[e.Filter=1]="Filter",e[e.Group=2]="Group",e[e.Column=3]="Column",e[e.Table=4]="Table",e))(oe||{}),ie=(e=>(e.Parenthesis="delimiter.parenthesis.sql",e.Whitespace="white.sql",e.Keyword="keyword.sql",e.Delimiter="delimiter.sql",e.Operator="operator.sql",e.Identifier="identifier.sql",e.IdentifierQuote="identifier.quote.sql",e.Type="type.sql",e.Function="predefined.sql",e.Number="number.sql",e.String="string.sql",e.Variable="variable.sql",e))(ie||{}),ae=(e=>(e.Unknown="unknown",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.AfterSelectKeyword="afterSelectKeyword",e.AfterSelectArguments="afterSelectArguments",e.AfterSelectFuncFirstArgument="afterSelectFuncFirstArgument",e.SelectAlias="selectAlias",e.AfterFromKeyword="afterFromKeyword",e.AfterTable="afterTable",e.SchemaFuncFirstArgument="schemaFuncFirstArgument",e.SchemaFuncExtraArgument="schemaFuncExtraArgument",e.FromKeyword="fromKeyword",e.AfterFrom="afterFrom",e.WhereKeyword="whereKeyword",e.WhereComparisonOperator="whereComparisonOperator",e.WhereValue="whereValue",e.AfterWhereFunctionArgument="afterWhereFunctionArgument",e.AfterGroupByFunctionArgument="afterGroupByFunctionArgument",e.AfterWhereValue="afterWhereValue",e.AfterGroupByKeywords="afterGroupByKeywords",e.AfterGroupBy="afterGroupBy",e.AfterOrderByKeywords="afterOrderByKeywords",e.AfterOrderByFunction="afterOrderByFunction",e.AfterOrderByDirection="afterOrderByDirection",e.AfterIsOperator="afterIsOperator",e.AfterIsNotOperator="afterIsNotOperator",e.AfterSchema="afterSchema",e))(ae||{}),se=(e=>(e.Schemas="schemas",e.Tables="tables",e.Columns="columns",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.FunctionsWithArguments="functionsWithArguments",e.FromKeyword="fromKeyword",e.WhereKeyword="whereKeyword",e.GroupByKeywords="groupByKeywords",e.OrderByKeywords="orderByKeywords",e.FunctionsWithoutArguments="functionsWithoutArguments",e.LimitKeyword="limitKeyword",e.SortOrderDirectionKeyword="sortOrderDirectionKeyword",e.ComparisonOperators="comparisonOperators",e.LogicalOperators="logicalOperators",e.SelectMacro="selectMacro",e.TableMacro="tableMacro",e.FilterMacro="filterMacro",e.GroupMacro="groupMacro",e.BoolValues="boolValues",e.NullValue="nullValue",e.NotKeyword="notKeyword",e.TemplateVariables="templateVariables",e.StarWildCard="starWildCard",e))(se||{}),le=(e=>(e.High="a",e.MediumHigh="d",e.Medium="g",e.MediumLow="k",e.Low="q",e))(le||{}),ue=(e=>(e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet",e))(ue||{}),ce=(e=>(e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet",e))(ce||{}),de=(e=>(e.Builder="builder",e.Code="code",e))(de||{}),pe=v(8531),fe=v(3241);class he{transformMetricFindResponse(e){const t=[],r=e.fields.find((e=>"__text"===e.name)),n=e.fields.find((e=>"__value"===e.name));if(r&&n)for(let e=0;e<r.values.length;e++)t.push({text:""+r.values[e],value:""+n.values[e]});else for(const r of e.fields)for(const e of r.values)t.push({text:e});return(0,fe.uniqBy)(t,"text")}}var ge=v(9728),ve=v(5959),me=v.t(ve,2),ye=v.n(ve),be=v(7016);function Oe(){var e=(0,ve.useRef)(!1),t=(0,ve.useCallback)((function(){return e.current}),[]);return(0,ve.useEffect)((function(){return e.current=!0,function(){e.current=!1}}),[]),t}function Ee(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var n=(0,ve.useRef)(0),o=Oe(),i=(0,ve.useState)(r),a=i[0],s=i[1],l=(0,ve.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var i=++n.current;return a.loading||s((function(e){return(0,be.__assign)((0,be.__assign)({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return o()&&i===n.current&&s({value:e,loading:!1}),e}),(function(e){return o()&&i===n.current&&s({error:e,loading:!1}),e}))}),t);return[a,l]}function Se(e,t){void 0===t&&(t=[]);var r=Ee(e,t,{loading:!0}),n=r[0],o=r[1];return(0,ve.useEffect)((function(){o()}),[o]),n}var we,Te,xe=v(2007);!function(e){e.String="string"}(we||(we={})),function(e){e.Property="property",e.Operator="operator",e.Or="or",e.And="and",e.GroupBy="groupBy",e.Function="function",e.FunctionParameter="functionParameter"}(Te||(Te={}));const _e=e=>{if(!e)return!1;const t=e.some((e=>{var t,r;return(null===(t=e.parameters)||void 0===t?void 0:t.length)||(null===(r=e.parameters)||void 0===r?void 0:r.some((e=>e.name)))})),r=e.some((e=>e.name));return t||r};function Ce(e){return{type:Te.GroupBy,property:{type:we.String,name:e}}}function Re(e){return{type:Te.Function,name:e,parameters:[]}}function Ie(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ae(e){let t=(null==e?void 0:e.editorMode)||de.Builder;var r;void 0===(null==e?void 0:e.editorMode)&&void 0!==(null==e?void 0:e.rawSql)&&(t=de.Code);const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ie(e,t,r[t])}))}return e}({},e),i=null!=(i={refId:(null==e?void 0:e.refId)||"A",format:void 0!==(null==e?void 0:e.format)?e.format:S.Table,rawSql:(null==e?void 0:e.rawSql)||"",editorMode:t,sql:null!==(r=null==e?void 0:e.sql)&&void 0!==r?r:{columns:[Re()],groupBy:[Ce()],limit:50}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;return n}var je=v(4221),Pe=v.n(je);const Le=function(){var e=Oe(),t=function(e){void 0===e&&(e={});var t=(0,ve.useState)(e),r=t[0],n=t[1];return[r,(0,ve.useCallback)((function(e){n((function(t){return Object.assign({},t,e instanceof Function?e(t):e)}))}),[])]}({value:void 0,error:void 0,noUserInteraction:!0}),r=t[0],n=t[1];return[r,(0,ve.useCallback)((function(t){var r,o;if(e())try{if("string"!=typeof t&&"number"!=typeof t){var i=new Error("Cannot copy typeof "+typeof t+" to clipboard, must be a string");return void n({value:t,error:i,noUserInteraction:!0})}if(""===t)return i=new Error("Cannot copy empty string to clipboard."),void n({value:t,error:i,noUserInteraction:!0});o=t.toString(),r=Pe()(o),n({value:o,error:void 0,noUserInteraction:r})}catch(i){n({value:o,error:i,noUserInteraction:r})}}),[])]};var ke=v(709);function Ne(e,t="latest"){return De(e,t.replace(/\-.*/,""))}function De(e,t){const r={};for(const[n,o]of Object.entries(e))Fe(o)?r[n]=De(o,t):(Ve(o,n),r[n]=Me(o,t));return r}function Fe(e){if("object"==typeof e){const[t]=Object.keys(e);return!(0,ke.valid)(t)}return!1}function Me(e,t){let r,n=Object.keys(e).sort(ke.compare);if("latest"===t)return e[n[n.length-1]];for(const e of n)(0,ke.gte)(t,e)&&(r=e);return r||(r=n[n.length-1]),e[r]}function Ve(e,t){if(!Object.keys(e).every((e=>(0,ke.valid)(e))))throw new Error(`Invalid semver version: '${t}'`)}const Ue="8.5.0",Be={RadioButton:{container:{"10.2.3":"data-testid radio-button"}},Breadcrumbs:{breadcrumb:{"9.4.0":e=>`data-testid ${e} breadcrumb`}},TimePicker:{openButton:{[Ue]:"data-testid TimePicker Open Button"},overlayContent:{"10.2.3":"data-testid TimePicker Overlay Content"},fromField:{"10.2.3":"data-testid Time Range from field",[Ue]:"Time Range from field"},toField:{"10.2.3":"data-testid Time Range to field",[Ue]:"Time Range to field"},applyTimeRange:{[Ue]:"data-testid TimePicker submit button"},copyTimeRange:{"10.4.0":"data-testid TimePicker copy button"},pasteTimeRange:{"10.4.0":"data-testid TimePicker paste button"},calendar:{label:{"10.2.3":"data-testid Time Range calendar",[Ue]:"Time Range calendar"},openButton:{"10.2.3":"data-testid Open time range calendar",[Ue]:"Open time range calendar"},closeButton:{"10.2.3":"data-testid Close time range Calendar",[Ue]:"Close time range Calendar"}},absoluteTimeRangeTitle:{[Ue]:"data-testid-absolute-time-range-narrow"}},DataSourcePermissions:{form:{"9.5.0":()=>'form[name="addPermission"]'},roleType:{"9.5.0":"Role to add new permission to"},rolePicker:{"9.5.0":"Built-in role picker"},permissionLevel:{"9.5.0":"Permission Level"}},DateTimePicker:{input:{"10.2.3":"data-testid date-time-input"}},DataSource:{TestData:{QueryTab:{scenarioSelectContainer:{[Ue]:"Test Data Query scenario select container"},scenarioSelect:{[Ue]:"Test Data Query scenario select"},max:{[Ue]:"TestData max"},min:{[Ue]:"TestData min"},noise:{[Ue]:"TestData noise"},seriesCount:{[Ue]:"TestData series count"},spread:{[Ue]:"TestData spread"},startValue:{[Ue]:"TestData start value"},drop:{[Ue]:"TestData drop values"}}},DataSourceHttpSettings:{urlInput:{"10.4.0":"data-testid Datasource HTTP settings url",[Ue]:"Datasource HTTP settings url"}},Jaeger:{traceIDInput:{[Ue]:"Trace ID"}},Prometheus:{configPage:{connectionSettings:{[Ue]:"Data source connection URL"},manageAlerts:{"10.4.0":"prometheus-alerts-manager"},scrapeInterval:{"10.4.0":"data-testid scrape interval"},queryTimeout:{"10.4.0":"data-testid query timeout"},defaultEditor:{"10.4.0":"data-testid default editor"},disableMetricLookup:{"10.4.0":"disable-metric-lookup"},prometheusType:{"10.4.0":"data-testid prometheus type"},prometheusVersion:{"10.4.0":"data-testid prometheus version"},cacheLevel:{"10.4.0":"data-testid cache level"},incrementalQuerying:{"10.4.0":"prometheus-incremental-querying"},queryOverlapWindow:{"10.4.0":"data-testid query overlap window"},disableRecordingRules:{"10.4.0":"disable-recording-rules"},customQueryParameters:{"10.4.0":"data-testid custom query parameters"},httpMethod:{"10.4.0":"data-testid http method"},exemplarsAddButton:{"10.3.0":"data-testid Add exemplar config button",[Ue]:"Add exemplar config button"},internalLinkSwitch:{"10.3.0":"data-testid Internal link switch",[Ue]:"Internal link switch"},codeModeMetricNamesSuggestionLimit:{"11.1.0":"data-testid code mode metric names suggestion limit"}},queryEditor:{explain:{"10.4.0":"data-testid prometheus explain switch wrapper"},editorToggle:{"10.4.0":"data-testid QueryEditorModeToggle"},options:{"10.4.0":"data-testid prometheus options"},legend:{"10.4.0":"data-testid prometheus legend wrapper"},format:{"10.4.0":"data-testid prometheus format"},step:{"10.4.0":"prometheus-step"},type:{"10.4.0":"data-testid prometheus type"},exemplars:{"10.4.0":"prometheus-exemplars"},builder:{metricSelect:{"10.4.0":"data-testid metric select"},hints:{"10.4.0":"data-testid prometheus hints"},metricsExplorer:{"10.4.0":"data-testid metrics explorer"},queryAdvisor:{"10.4.0":"data-testid query advisor"}},code:{queryField:{"10.4.0":"data-testid prometheus query field"},metricsCountInfo:{"11.1.0":"data-testid metrics count disclaimer"},metricsBrowser:{openButton:{"10.4.0":"data-testid open metrics browser"},selectMetric:{"10.4.0":"data-testid select a metric"},seriesLimit:{"10.3.1":"data-testid series limit"},metricList:{"10.4.0":"data-testid metric list"},labelNamesFilter:{"10.4.0":"data-testid label names filter"},labelValuesFilter:{"10.4.0":"data-testid label values filter"},useQuery:{"10.4.0":"data-testid use query"},useAsRateQuery:{"10.4.0":"data-testid use as rate query"},validateSelector:{"10.4.0":"data-testid validate selector"},clear:{"10.4.0":"data-testid clear"}}}},exemplarMarker:{"10.3.0":"data-testid Exemplar marker",[Ue]:"Exemplar marker"},variableQueryEditor:{queryType:{"10.4.0":"data-testid query type"},labelnames:{metricRegex:{"10.4.0":"data-testid label names metric regex"}},labelValues:{labelSelect:{"10.4.0":"data-testid label values label select"}},metricNames:{metricRegex:{"10.4.0":"data-testid metric names metric regex"}},varQueryResult:{"10.4.0":"data-testid variable query result"},seriesQuery:{"10.4.0":"data-testid prometheus series query"},classicQuery:{"10.4.0":"data-testid prometheus classic query"}},annotations:{minStep:{"10.4.0":"prometheus-annotation-min-step"},title:{"10.4.0":"data-testid prometheus annotation title"},tags:{"10.4.0":"data-testid prometheus annotation tags"},text:{"10.4.0":"data-testid prometheus annotation text"},seriesValueAsTimestamp:{"10.4.0":"data-testid prometheus annotation series value as timestamp"}}}},Menu:{MenuComponent:{[Ue]:e=>`${e} menu`},MenuGroup:{[Ue]:e=>`${e} menu group`},MenuItem:{[Ue]:e=>`${e} menu item`},SubMenu:{container:{"10.3.0":"data-testid SubMenu container",[Ue]:"SubMenu container"},icon:{"10.3.0":"data-testid SubMenu icon",[Ue]:"SubMenu icon"}}},Panels:{Panel:{title:{[Ue]:e=>`data-testid Panel header ${e}`},content:{"11.1.0":"data-testid panel content"},headerItems:{"10.2.0":e=>`data-testid Panel header item ${e}`},menuItems:{"9.5.0":e=>`data-testid Panel menu item ${e}`},menu:{"9.5.0":e=>`data-testid Panel menu ${e}`},containerByTitle:{[Ue]:e=>`${e} panel`},headerCornerInfo:{[Ue]:e=>`Panel header ${e}`},status:{"10.2.0":e=>`data-testid Panel status ${e}`,[Ue]:e=>"Panel status"},loadingBar:{"10.0.0":()=>"Panel loading bar"},HoverWidget:{container:{"10.1.0":"data-testid hover-header-container",[Ue]:"hover-header-container"},dragIcon:{"10.0.0":"data-testid drag-icon"}},PanelDataErrorMessage:{"10.4.0":"data-testid Panel data error message"}},Visualization:{Graph:{container:{"9.5.0":"Graph container"},VisualizationTab:{legendSection:{[Ue]:"Legend section"}},Legend:{legendItemAlias:{[Ue]:e=>`gpl alias ${e}`},showLegendSwitch:{[Ue]:"gpl show legend"}},xAxis:{labels:{[Ue]:()=>"div.flot-x-axis > div.flot-tick-label"}}},BarGauge:{valueV2:{[Ue]:"data-testid Bar gauge value"}},PieChart:{svgSlice:{"10.3.0":"data testid Pie Chart Slice"}},Text:{container:{[Ue]:()=>".markdown-html"}},Table:{header:{[Ue]:"table header"},footer:{[Ue]:"table-footer"},body:{"10.2.0":"data-testid table body"}}}},VizLegend:{seriesName:{"10.3.0":e=>`data-testid VizLegend series ${e}`}},Drawer:{General:{title:{[Ue]:e=>`Drawer title ${e}`},expand:{[Ue]:"Drawer expand"},contract:{[Ue]:"Drawer contract"},close:{"10.3.0":"data-testid Drawer close",[Ue]:"Drawer close"},rcContentWrapper:{"9.4.0":()=>".rc-drawer-content-wrapper"},subtitle:{"10.4.0":"data-testid drawer subtitle"}},DashboardSaveDrawer:{saveButton:{"11.1.0":"data-testid Save dashboard drawer button"},saveAsButton:{"11.1.0":"data-testid Save as dashboard drawer button"},saveAsTitleInput:{"11.1.0":"Save dashboard title field"}}},PanelEditor:{General:{content:{"11.1.0":"data-testid Panel editor content",[Ue]:"Panel editor content"}},OptionsPane:{content:{"11.1.0":"data-testid Panel editor option pane content",[Ue]:"Panel editor option pane content"},select:{[Ue]:"Panel editor option pane select"},fieldLabel:{[Ue]:e=>`${e} field property editor`},fieldInput:{"11.0.0":e=>`data-testid Panel editor option pane field input ${e}`}},DataPane:{content:{"11.1.0":"data-testid Panel editor data pane content",[Ue]:"Panel editor data pane content"}},applyButton:{"9.2.0":"data-testid Apply changes and go back to dashboard"},toggleVizPicker:{"10.0.0":"data-testid toggle-viz-picker",[Ue]:"toggle-viz-picker"},toggleVizOptions:{"10.1.0":"data-testid toggle-viz-options",[Ue]:"toggle-viz-options"},toggleTableView:{"11.1.0":"data-testid toggle-table-view",[Ue]:"toggle-table-view"},showZoomField:{"10.2.0":"Map controls Show zoom control field property editor"},showAttributionField:{"10.2.0":"Map controls Show attribution field property editor"},showScaleField:{"10.2.0":"Map controls Show scale field property editor"},showMeasureField:{"10.2.0":"Map controls Show measure tools field property editor"},showDebugField:{"10.2.0":"Map controls Show debug field property editor"},measureButton:{"9.2.0":"show measure tools"}},PanelInspector:{Data:{content:{[Ue]:"Panel inspector Data content"}},Stats:{content:{[Ue]:"Panel inspector Stats content"}},Json:{content:{"11.1.0":"data-testid Panel inspector Json content",[Ue]:"Panel inspector Json content"}},Query:{content:{[Ue]:"Panel inspector Query content"},refreshButton:{[Ue]:"Panel inspector Query refresh button"},jsonObjectKeys:{[Ue]:()=>".json-formatter-key"}}},Tab:{title:{"11.2.0":e=>`data-testid Tab ${e}`},active:{[Ue]:()=>'[class*="-activeTabStyle"]'}},RefreshPicker:{runButtonV2:{[Ue]:"data-testid RefreshPicker run button"},intervalButtonV2:{[Ue]:"data-testid RefreshPicker interval button"}},QueryTab:{content:{[Ue]:"Query editor tab content"},queryInspectorButton:{[Ue]:"Query inspector button"},queryHistoryButton:{"10.2.0":"data-testid query-history-button",[Ue]:"query-history-button"},addQuery:{"10.2.0":"data-testid query-tab-add-query",[Ue]:"Query editor add query button"},queryGroupTopSection:{"11.2.0":"data-testid query group top section"},addExpression:{"11.2.0":"data-testid query-tab-add-expression"}},QueryHistory:{queryText:{"9.0.0":"Query text"}},QueryEditorRows:{rows:{[Ue]:"Query editor row"}},QueryEditorRow:{actionButton:{"10.4.0":e=>`data-testid ${e}`},title:{[Ue]:e=>`Query editor row title ${e}`},container:{[Ue]:e=>`Query editor row ${e}`}},AlertTab:{content:{"10.2.3":"data-testid Alert editor tab content",[Ue]:"Alert editor tab content"}},AlertRules:{groupToggle:{"11.0.0":"data-testid group-collapse-toggle"},toggle:{"11.0.0":"data-testid collapse-toggle"},expandedContent:{"11.0.0":"data-testid expanded-content"},previewButton:{"11.1.0":"data-testid alert-rule preview-button"},ruleNameField:{"11.1.0":"data-testid alert-rule name-field"},newFolderButton:{"11.1.0":"data-testid alert-rule new-folder-button"},newFolderNameField:{"11.1.0":"data-testid alert-rule name-folder-name-field"},newFolderNameCreateButton:{"11.1.0":"data-testid alert-rule name-folder-name-create-button"},newEvaluationGroupButton:{"11.1.0":"data-testid alert-rule new-evaluation-group-button"},newEvaluationGroupName:{"11.1.0":"data-testid alert-rule new-evaluation-group-name"},newEvaluationGroupInterval:{"11.1.0":"data-testid alert-rule new-evaluation-group-interval"},newEvaluationGroupCreate:{"11.1.0":"data-testid alert-rule new-evaluation-group-create-button"}},Alert:{alertV2:{[Ue]:e=>`data-testid Alert ${e}`}},TransformTab:{content:{"10.1.0":"data-testid Transform editor tab content",[Ue]:"Transform editor tab content"},newTransform:{"10.1.0":e=>`data-testid New transform ${e}`},transformationEditor:{"10.1.0":e=>`data-testid Transformation editor ${e}`},transformationEditorDebugger:{"10.1.0":e=>`data-testid Transformation editor debugger ${e}`}},Transforms:{card:{"10.1.0":e=>`data-testid New transform ${e}`},disableTransformationButton:{"10.4.0":"data-testid Disable transformation button"},Reduce:{modeLabel:{"10.2.3":"data-testid Transform mode label",[Ue]:"Transform mode label"},calculationsLabel:{"10.2.3":"data-testid Transform calculations label",[Ue]:"Transform calculations label"}},SpatialOperations:{actionLabel:{"9.1.2":"root Action field property editor"},locationLabel:{"10.2.0":"root Location Mode field property editor"},location:{autoOption:{"9.1.2":"Auto location option"},coords:{option:{"9.1.2":"Coords location option"},latitudeFieldLabel:{"9.1.2":"root Latitude field field property editor"},longitudeFieldLabel:{"9.1.2":"root Longitude field field property editor"}},geohash:{option:{"9.1.2":"Geohash location option"},geohashFieldLabel:{"9.1.2":"root Geohash field field property editor"}},lookup:{option:{"9.1.2":"Lookup location option"},lookupFieldLabel:{"9.1.2":"root Lookup field field property editor"},gazetteerFieldLabel:{"9.1.2":"root Gazetteer field property editor"}}}},searchInput:{"10.2.3":"data-testid search transformations",[Ue]:"search transformations"},noTransformationsMessage:{"10.2.3":"data-testid no transformations message"},addTransformationButton:{"10.1.0":"data-testid add transformation button",[Ue]:"add transformation button"},removeAllTransformationsButton:{"10.4.0":"data-testid remove all transformations button"}},NavBar:{Configuration:{button:{"9.5.0":"Configuration"}},Toggle:{button:{"10.2.3":"data-testid Toggle menu",[Ue]:"Toggle menu"}},Reporting:{button:{"9.5.0":"Reporting"}}},NavMenu:{Menu:{"10.2.3":"data-testid navigation mega-menu"},item:{"9.5.0":"data-testid Nav menu item"}},NavToolbar:{container:{"9.4.0":"data-testid Nav toolbar"},commandPaletteTrigger:{"11.4.0":"data-testid Command palette trigger"},shareDashboard:{"11.1.0":"data-testid Share dashboard"},markAsFavorite:{"11.1.0":"data-testid Mark as favorite"},editDashboard:{editButton:{"11.1.0":"data-testid Edit dashboard button"},saveButton:{"11.1.0":"data-testid Save dashboard button"},exitButton:{"11.1.0":"data-testid Exit edit mode button"},settingsButton:{"11.1.0":"data-testid Dashboard settings"},addRowButton:{"11.1.0":"data-testid Add row button"},addLibraryPanelButton:{"11.1.0":"data-testid Add a panel from the panel library button"},addVisualizationButton:{"11.1.0":"data-testid Add new visualization menu item"},pastePanelButton:{"11.1.0":"data-testid Paste panel button"},discardChangesButton:{"11.1.0":"data-testid Discard changes button"},discardLibraryPanelButton:{"11.1.0":"data-testid Discard library panel button"},unlinkLibraryPanelButton:{"11.1.0":"data-testid Unlink library panel button"},saveLibraryPanelButton:{"11.1.0":"data-testid Save library panel button"},backToDashboardButton:{"11.1.0":"data-testid Back to dashboard button"}}},PageToolbar:{container:{[Ue]:()=>".page-toolbar"},item:{[Ue]:e=>`${e}`},itemButton:{"9.5.0":e=>`data-testid ${e}`}},QueryEditorToolbarItem:{button:{[Ue]:e=>`QueryEditor toolbar item button ${e}`}},BackButton:{backArrow:{"10.3.0":"data-testid Go Back",[Ue]:"Go Back"}},OptionsGroup:{group:{"11.1.0":e=>e?`data-testid Options group ${e}`:"data-testid Options group",[Ue]:e=>e?`Options group ${e}`:"Options group"},toggle:{"11.1.0":e=>e?`data-testid Options group ${e} toggle`:"data-testid Options group toggle",[Ue]:e=>e?`Options group ${e} toggle`:"Options group toggle"}},PluginVisualization:{item:{[Ue]:e=>`Plugin visualization item ${e}`},current:{[Ue]:()=>'[class*="-currentVisualizationItem"]'}},Select:{option:{"11.1.0":"data-testid Select option",[Ue]:"Select option"},toggleAllOptions:{"11.3.0":"data-testid toggle all options"},input:{[Ue]:()=>'input[id*="time-options-input"]'},singleValue:{[Ue]:()=>'div[class*="-singleValue"]'}},FieldConfigEditor:{content:{[Ue]:"Field config editor content"}},OverridesConfigEditor:{content:{[Ue]:"Field overrides editor content"}},FolderPicker:{containerV2:{[Ue]:"data-testid Folder picker select container"},input:{"10.4.0":"data-testid folder-picker-input"}},ReadonlyFolderPicker:{container:{[Ue]:"data-testid Readonly folder picker select container"}},DataSourcePicker:{container:{"10.0.0":"data-testid Data source picker select container",[Ue]:"Data source picker select container"},inputV2:{"10.1.0":"data-testid Select a data source",[Ue]:"Select a data source"},dataSourceList:{"10.4.0":"data-testid Data source list dropdown"},advancedModal:{dataSourceList:{"10.4.0":"data-testid Data source list"},builtInDataSourceList:{"10.4.0":"data-testid Built in data source list"}}},TimeZonePicker:{containerV2:{[Ue]:"data-testid Time zone picker select container"},changeTimeSettingsButton:{"11.0.0":"data-testid Time zone picker Change time settings button"}},WeekStartPicker:{containerV2:{[Ue]:"data-testid Choose starting day of the week"},placeholder:{[Ue]:"Choose starting day of the week"}},TraceViewer:{spanBar:{"9.0.0":"data-testid SpanBar--wrapper"}},QueryField:{container:{"10.3.0":"data-testid Query field",[Ue]:"Query field"}},QueryBuilder:{queryPatterns:{"10.3.0":"data-testid Query patterns",[Ue]:"Query patterns"},labelSelect:{"10.3.0":"data-testid Select label",[Ue]:"Select label"},inputSelect:{"11.1.0":"data-testid Select label-input"},valueSelect:{"10.3.0":"data-testid Select value",[Ue]:"Select value"},matchOperatorSelect:{"10.3.0":"data-testid Select match operator",[Ue]:"Select match operator"}},ValuePicker:{button:{"10.3.0":e=>`data-testid Value picker button ${e}`},select:{"10.3.0":e=>`data-testid Value picker select ${e}`}},Search:{sectionV2:{[Ue]:"data-testid Search section"},itemsV2:{[Ue]:"data-testid Search items"},cards:{[Ue]:"data-testid Search cards"},collapseFolder:{[Ue]:e=>`data-testid Collapse folder ${e}`},expandFolder:{[Ue]:e=>`data-testid Expand folder ${e}`},dashboardItem:{[Ue]:e=>`data-testid Dashboard search item ${e}`},dashboardCard:{[Ue]:e=>`data-testid Search card ${e}`},folderHeader:{"9.3.0":e=>`data-testid Folder header ${e}`},folderContent:{"9.3.0":e=>`data-testid Folder content ${e}`},dashboardItems:{[Ue]:"data-testid Dashboard search item"}},DashboardLinks:{container:{[Ue]:"data-testid Dashboard link container"},dropDown:{[Ue]:"data-testid Dashboard link dropdown"},link:{[Ue]:"data-testid Dashboard link"}},LoadingIndicator:{icon:{"10.4.0":"data-testid Loading indicator",[Ue]:"Loading indicator"}},CallToActionCard:{buttonV2:{[Ue]:e=>`data-testid Call to action button ${e}`}},DataLinksContextMenu:{singleLink:{"10.3.0":"data-testid Data link",[Ue]:"Data link"}},CodeEditor:{container:{"10.2.3":"data-testid Code editor container",[Ue]:"Code editor container"}},ReactMonacoEditor:{editorLazy:{"11.1.0":"data-testid ReactMonacoEditor editorLazy"}},DashboardImportPage:{textarea:{[Ue]:"data-testid-import-dashboard-textarea"},submit:{[Ue]:"data-testid-load-dashboard"}},ImportDashboardForm:{name:{[Ue]:"data-testid-import-dashboard-title"},submit:{[Ue]:"data-testid-import-dashboard-submit"}},PanelAlertTabContent:{content:{"10.2.3":"data-testid Unified alert editor tab content",[Ue]:"Unified alert editor tab content"}},VisualizationPreview:{card:{[Ue]:e=>`data-testid suggestion-${e}`}},ColorSwatch:{name:{[Ue]:"data-testid-colorswatch"}},DashboardRow:{title:{[Ue]:e=>`data-testid dashboard-row-title-${e}`}},UserProfile:{profileSaveButton:{[Ue]:"data-testid-user-profile-save"},preferencesSaveButton:{[Ue]:"data-testid-shared-prefs-save"},orgsTable:{[Ue]:"data-testid-user-orgs-table"},sessionsTable:{[Ue]:"data-testid-user-sessions-table"},extensionPointTabs:{"10.2.3":"data-testid-extension-point-tabs"},extensionPointTab:{"10.2.3":e=>`data-testid-extension-point-tab-${e}`}},FileUpload:{inputField:{"9.0.0":"data-testid-file-upload-input-field"},fileNameSpan:{"9.0.0":"data-testid-file-upload-file-name"}},DebugOverlay:{wrapper:{"9.2.0":"debug-overlay"}},OrgRolePicker:{input:{"9.5.0":"Role"}},AnalyticsToolbarButton:{button:{"9.5.0":"Dashboard insights"}},Variables:{variableOption:{"9.5.0":"data-testid variable-option"},variableLinkWrapper:{"11.1.1":"data-testid variable-link-wrapper"}},Annotations:{annotationsTypeInput:{"11.1.0":"data-testid annotations-type-input",[Ue]:"annotations-type-input"},annotationsChoosePanelInput:{"11.1.0":"data-testid choose-panels-input",[Ue]:"choose-panels-input"},editor:{testButton:{"11.0.0":"data-testid annotations-test-button"},resultContainer:{"11.0.0":"data-testid annotations-query-result-container"}}},Tooltip:{container:{"10.2.0":"data-testid tooltip"}},ReturnToPrevious:{buttonGroup:{"11.0.0":"data-testid dismissable button group"},backButton:{"11.0.0":"data-testid back"},dismissButton:{"11.0.0":"data-testid dismiss"}},SQLQueryEditor:{selectColumn:{"11.0.0":"data-testid select-column"},selectAggregation:{"11.0.0":"data-testid select-aggregation"},selectAlias:{"11.0.0":"data-testid select-alias"},filterConjunction:{"11.0.0":"data-testid filter-conjunction"},filterField:{"11.0.0":"data-testid filter-field"},filterOperator:{"11.0.0":"data-testid filter-operator"},headerTableSelector:{"11.0.0":"data-testid header-table-selector"},headerFilterSwitch:{"11.0.0":"data-testid header-filter-switch"},headerGroupSwitch:{"11.0.0":"data-testid header-group-switch"},headerOrderSwitch:{"11.0.0":"data-testid header-order-switch"},headerPreviewSwitch:{"11.0.0":"data-testid header-preview-switch"}},EntityNotFound:{container:{"11.2.0":"data-testid entity-not-found"}}},ze={pages:Ne({Alerting:{AddAlertRule:{url:{"10.1.0":"/alerting/new/alerting",[Ue]:"/alerting/new"}},EditAlertRule:{url:{[Ue]:e=>`alerting/${e}/edit`}}},Login:{url:{[Ue]:"/login"},username:{"10.2.3":"data-testid Username input field",[Ue]:"Username input field"},password:{"10.2.3":"data-testid Password input field",[Ue]:"Password input field"},submit:{"10.2.3":"data-testid Login button",[Ue]:"Login button"},skip:{"10.2.3":"data-testid Skip change password button"}},Home:{url:{[Ue]:"/"}},DataSource:{name:{"10.3.0":"data-testid Data source settings page name input field",[Ue]:"Data source settings page name input field"},delete:{[Ue]:"Data source settings page Delete button"},readOnly:{"10.3.0":"data-testid Data source settings page read only message",[Ue]:"Data source settings page read only message"},saveAndTest:{"10.0.0":"data-testid Data source settings page Save and Test button",[Ue]:"Data source settings page Save and Test button"},alert:{"10.3.0":"data-testid Data source settings page Alert",[Ue]:"Data source settings page Alert"}},DataSources:{url:{[Ue]:"/datasources"},dataSources:{[Ue]:e=>`Data source list item ${e}`}},EditDataSource:{url:{"9.5.0":e=>`/datasources/edit/${e}`},settings:{"9.5.0":"Datasource settings page basic settings"}},AddDataSource:{url:{[Ue]:"/datasources/new"},dataSourcePluginsV2:{"9.3.1":e=>`Add new data source ${e}`,[Ue]:e=>`Data source plugin item ${e}`}},ConfirmModal:{delete:{"10.0.0":"data-testid Confirm Modal Danger Button",[Ue]:"Confirm Modal Danger Button"}},AddDashboard:{url:{[Ue]:"/dashboard/new"},itemButton:{"9.5.0":e=>`data-testid ${e}`},addNewPanel:{"11.1.0":"data-testid Add new panel",[Ue]:"Add new panel"},itemButtonAddViz:{[Ue]:"Add new visualization menu item"},addNewRow:{"11.1.0":"data-testid Add new row",[Ue]:"Add new row"},addNewPanelLibrary:{"11.1.0":"data-testid Add new panel from panel library",[Ue]:"Add new panel from panel library"},Settings:{Annotations:{List:{url:{[Ue]:"/dashboard/new?orgId=1&editview=annotations"}},Edit:{url:{[Ue]:e=>`/dashboard/new?editview=annotations&editIndex=${e}`}}},Variables:{List:{url:{"11.3.0":"/dashboard/new?orgId=1&editview=variables",[Ue]:"/dashboard/new?orgId=1&editview=templating"}},Edit:{url:{[Ue]:e=>`/dashboard/new?orgId=1&editview=templating&editIndex=${e}`}}}}},Dashboard:{url:{[Ue]:e=>`/d/${e}`},DashNav:{nav:{[Ue]:"Dashboard navigation"},navV2:{[Ue]:"data-testid Dashboard navigation"},publicDashboardTag:{"9.1.0":"data-testid public dashboard tag"},shareButton:{"10.4.0":"data-testid share-button"},scrollContainer:{"11.1.0":"data-testid Dashboard canvas scroll container"},newShareButton:{container:{"11.1.0":"data-testid new share button"},shareLink:{"11.1.0":"data-testid new share link-button"},arrowMenu:{"11.1.0":"data-testid new share button arrow menu"},menu:{container:{"11.1.0":"data-testid new share button menu"},shareInternally:{"11.1.0":"data-testid new share button share internally"},shareExternally:{"11.1.1":"data-testid new share button share externally"},shareSnapshot:{"11.2.0":"data-testid new share button share snapshot"}}},NewExportButton:{container:{"11.2.0":"data-testid new export button"},arrowMenu:{"11.2.0":"data-testid new export button arrow menu"},Menu:{container:{"11.2.0":"data-testid new export button menu"},exportAsJson:{"11.2.0":"data-testid new export button export as json"}}},playlistControls:{prev:{"11.0.0":"data-testid playlist previous dashboard button"},stop:{"11.0.0":"data-testid playlist stop dashboard button"},next:{"11.0.0":"data-testid playlist next dashboard button"}}},Controls:{"11.1.0":"data-testid dashboard controls"},SubMenu:{submenu:{[Ue]:"Dashboard submenu"},submenuItem:{[Ue]:"data-testid template variable"},submenuItemLabels:{[Ue]:e=>`data-testid Dashboard template variables submenu Label ${e}`},submenuItemValueDropDownValueLinkTexts:{[Ue]:e=>`data-testid Dashboard template variables Variable Value DropDown value link text ${e}`},submenuItemValueDropDownDropDown:{[Ue]:"Variable options"},submenuItemValueDropDownOptionTexts:{[Ue]:e=>`data-testid Dashboard template variables Variable Value DropDown option text ${e}`},Annotations:{annotationsWrapper:{"10.0.0":"data-testid annotation-wrapper"},annotationLabel:{"10.0.0":e=>`data-testid Dashboard annotations submenu Label ${e}`},annotationToggle:{"10.0.0":e=>`data-testid Dashboard annotations submenu Toggle ${e}`}}},Settings:{Actions:{close:{"9.5.0":"data-testid dashboard-settings-close"}},General:{deleteDashBoard:{"11.1.0":"data-testid Dashboard settings page delete dashboard button"},sectionItems:{[Ue]:e=>`Dashboard settings section item ${e}`},saveDashBoard:{[Ue]:"Dashboard settings aside actions Save button"},saveAsDashBoard:{[Ue]:"Dashboard settings aside actions Save As button"},title:{"11.2.0":"General"}},Annotations:{Edit:{urlParams:{[Ue]:e=>`editview=annotations&editIndex=${e}`}},List:{url:{[Ue]:e=>`/d/${e}?editview=annotations`},addAnnotationCTAV2:{[Ue]:"data-testid Call to action button Add annotation query"},annotations:{"10.4.0":"data-testid list-annotations"}},Settings:{name:{"11.1.0":"data-testid Annotations settings name input",[Ue]:"Annotations settings name input"}},NewAnnotation:{panelFilterSelect:{"10.0.0":"data-testid annotations-panel-filter"},showInLabel:{"11.1.0":"data-testid show-in-label"},previewInDashboard:{"10.0.0":"data-testid annotations-preview"},delete:{"10.4.0":"data-testid annotations-delete"},apply:{"10.4.0":"data-testid annotations-apply"},enable:{"10.4.0":"data-testid annotation-enable"},hide:{"10.4.0":"data-testid annotation-hide"}}},Variables:{List:{url:{[Ue]:e=>`/d/${e}?editview=templating`},addVariableCTAV2:{[Ue]:"data-testid Call to action button Add variable"},newButton:{[Ue]:"Variable editor New variable button"},table:{[Ue]:"Variable editor Table"},tableRowNameFields:{[Ue]:e=>`Variable editor Table Name field ${e}`},tableRowDefinitionFields:{"10.1.0":e=>`Variable editor Table Definition field ${e}`},tableRowArrowUpButtons:{[Ue]:e=>`Variable editor Table ArrowUp button ${e}`},tableRowArrowDownButtons:{[Ue]:e=>`Variable editor Table ArrowDown button ${e}`},tableRowDuplicateButtons:{[Ue]:e=>`Variable editor Table Duplicate button ${e}`},tableRowRemoveButtons:{[Ue]:e=>`Variable editor Table Remove button ${e}`}},Edit:{urlParams:{[Ue]:e=>`editview=templating&editIndex=${e}`},General:{headerLink:{[Ue]:"Variable editor Header link"},modeLabelNew:{[Ue]:"Variable editor Header mode New"},modeLabelEdit:{[Ue]:"Variable editor Header mode Edit"},generalNameInput:{[Ue]:"Variable editor Form Name field"},generalNameInputV2:{[Ue]:"data-testid Variable editor Form Name field"},generalTypeSelect:{[Ue]:"Variable editor Form Type select"},generalTypeSelectV2:{[Ue]:"data-testid Variable editor Form Type select"},generalLabelInput:{[Ue]:"Variable editor Form Label field"},generalLabelInputV2:{[Ue]:"data-testid Variable editor Form Label field"},generalHideSelect:{[Ue]:"Variable editor Form Hide select"},generalHideSelectV2:{[Ue]:"data-testid Variable editor Form Hide select"},selectionOptionsMultiSwitch:{"10.4.0":"data-testid Variable editor Form Multi switch",[Ue]:"Variable editor Form Multi switch"},selectionOptionsIncludeAllSwitch:{"10.4.0":"data-testid Variable editor Form IncludeAll switch",[Ue]:"Variable editor Form IncludeAll switch"},selectionOptionsCustomAllInput:{"10.4.0":"data-testid Variable editor Form IncludeAll field",[Ue]:"Variable editor Form IncludeAll field"},previewOfValuesOption:{"10.4.0":"data-testid Variable editor Preview of Values option",[Ue]:"Variable editor Preview of Values option"},submitButton:{"10.4.0":"data-testid Variable editor Run Query button",[Ue]:"Variable editor Submit button"},applyButton:{"9.3.0":"data-testid Variable editor Apply button"}},QueryVariable:{queryOptionsDataSourceSelect:{"10.4.0":"data-testid Select a data source","10.0.0":"data-testid Data source picker select container",[Ue]:"Data source picker select container"},queryOptionsRefreshSelect:{[Ue]:"Variable editor Form Query Refresh select"},queryOptionsRefreshSelectV2:{[Ue]:"data-testid Variable editor Form Query Refresh select"},queryOptionsRegExInput:{[Ue]:"Variable editor Form Query RegEx field"},queryOptionsRegExInputV2:{[Ue]:"data-testid Variable editor Form Query RegEx field"},queryOptionsSortSelect:{[Ue]:"Variable editor Form Query Sort select"},queryOptionsSortSelectV2:{[Ue]:"data-testid Variable editor Form Query Sort select"},queryOptionsQueryInput:{"10.4.0":"data-testid Variable editor Form Default Variable Query Editor textarea"},valueGroupsTagsEnabledSwitch:{[Ue]:"Variable editor Form Query UseTags switch"},valueGroupsTagsTagsQueryInput:{[Ue]:"Variable editor Form Query TagsQuery field"},valueGroupsTagsTagsValuesQueryInput:{[Ue]:"Variable editor Form Query TagsValuesQuery field"}},ConstantVariable:{constantOptionsQueryInput:{[Ue]:"Variable editor Form Constant Query field"},constantOptionsQueryInputV2:{[Ue]:"data-testid Variable editor Form Constant Query field"}},DatasourceVariable:{datasourceSelect:{[Ue]:"data-testid datasource variable datasource type"}},TextBoxVariable:{textBoxOptionsQueryInput:{[Ue]:"Variable editor Form TextBox Query field"},textBoxOptionsQueryInputV2:{[Ue]:"data-testid Variable editor Form TextBox Query field"}},CustomVariable:{customValueInput:{[Ue]:"data-testid custom-variable-input"}},IntervalVariable:{intervalsValueInput:{[Ue]:"data-testid interval variable intervals input"},autoEnabledCheckbox:{"10.4.0":"data-testid interval variable auto value checkbox"},stepCountIntervalSelect:{"10.4.0":"data-testid interval variable step count input"},minIntervalInput:{"10.4.0":"data-testid interval variable mininum interval input"}},GroupByVariable:{dataSourceSelect:{"10.4.0":"data-testid Select a data source"},infoText:{"10.4.0":"data-testid group by variable info text"},modeToggle:{"10.4.0":"data-testid group by variable mode toggle"}},AdHocFiltersVariable:{datasourceSelect:{"10.4.0":"data-testid Select a data source"},infoText:{"10.4.0":"data-testid ad-hoc filters variable info text"},modeToggle:{"11.0.0":"data-testid ad-hoc filters variable mode toggle"}}}}},Annotations:{marker:{"10.0.0":"data-testid annotation-marker"}},Rows:{Repeated:{ConfigSection:{warningMessage:{"10.2.0":"data-testid Repeated rows warning message"}}}}},Dashboards:{url:{[Ue]:"/dashboards"},dashboards:{"10.2.0":e=>`Dashboard search item ${e}`}},SaveDashboardAsModal:{newName:{"10.2.0":"Save dashboard title field"},save:{"10.2.0":"Save dashboard button"}},SaveDashboardModal:{save:{"10.2.0":"Dashboard settings Save Dashboard Modal Save button"},saveVariables:{"10.2.0":"Dashboard settings Save Dashboard Modal Save variables checkbox"},saveTimerange:{"10.2.0":"Dashboard settings Save Dashboard Modal Save timerange checkbox"},saveRefresh:{"11.1.0":"Dashboard settings Save Dashboard Modal Save refresh checkbox"}},SharePanelModal:{linkToRenderedImage:{[Ue]:"Link to rendered image"}},ShareDashboardModal:{PublicDashboard:{WillBePublicCheckbox:{"9.1.0":"data-testid public dashboard will be public checkbox"},LimitedDSCheckbox:{"9.1.0":"data-testid public dashboard limited datasources checkbox"},CostIncreaseCheckbox:{"9.1.0":"data-testid public dashboard cost may increase checkbox"},PauseSwitch:{"9.5.0":"data-testid public dashboard pause switch"},EnableAnnotationsSwitch:{"9.3.0":"data-testid public dashboard on off switch for annotations"},CreateButton:{"9.5.0":"data-testid public dashboard create button"},DeleteButton:{"9.3.0":"data-testid public dashboard delete button"},CopyUrlInput:{"9.1.0":"data-testid public dashboard copy url input"},CopyUrlButton:{"9.1.0":"data-testid public dashboard copy url button"},SettingsDropdown:{"10.1.0":"data-testid public dashboard settings dropdown"},TemplateVariablesWarningAlert:{"9.1.0":"data-testid public dashboard disabled template variables alert"},UnsupportedDataSourcesWarningAlert:{"9.5.0":"data-testid public dashboard unsupported data sources alert"},NoUpsertPermissionsWarningAlert:{"9.5.0":"data-testid public dashboard no upsert permissions alert"},EnableTimeRangeSwitch:{"9.4.0":"data-testid public dashboard on off switch for time range"},EmailSharingConfiguration:{Container:{"9.5.0":"data-testid email sharing config container"},ShareType:{"9.5.0":"data-testid public dashboard share type"},EmailSharingInput:{"9.5.0":"data-testid public dashboard email sharing input"},EmailSharingInviteButton:{"9.5.0":"data-testid public dashboard email sharing invite button"},EmailSharingList:{"9.5.0":"data-testid public dashboard email sharing list"},DeleteEmail:{"9.5.0":"data-testid public dashboard delete email button"},ReshareLink:{"9.5.0":"data-testid public dashboard reshare link button"}}},SnapshotScene:{url:{"11.1.0":e=>`/dashboard/snapshot/${e}`},PublishSnapshot:{"11.1.0":"data-testid publish snapshot button"},CopyUrlButton:{"11.1.0":"data-testid snapshot copy url button"},CopyUrlInput:{"11.1.0":"data-testid snapshot copy url input"}}},ShareDashboardDrawer:{ShareInternally:{container:{"11.3.0":"data-testid share internally drawer container"},lockTimeRangeSwitch:{"11.3.0":"data-testid share internally lock time range switch"},shortenUrlSwitch:{"11.3.0":"data-testid share internally shorten url switch"},copyUrlButton:{"11.3.0":"data-testid share internally copy url button"}},ShareExternally:{container:{"11.3.0":"data-testid share externally drawer container"},publicAlert:{"11.3.0":"data-testid public share alert"},emailSharingAlert:{"11.3.0":"data-testid email share alert"},shareTypeSelect:{"11.3.0":"data-testid share externally share type select"},Creation:{PublicShare:{createButton:{"11.3.0":"data-testid public share dashboard create button"},cancelButton:{"11.3.0":"data-testid public share dashboard cancel button"}},EmailShare:{createButton:{"11.3.0":"data-testid email share dashboard create button"},cancelButton:{"11.3.0":"data-testid email share dashboard cancel button"}},willBePublicCheckbox:{"11.3.0":"data-testid share dashboard will be public checkbox"}},Configuration:{enableTimeRangeSwitch:{"11.3.0":"data-testid share externally enable time range switch"},enableAnnotationsSwitch:{"11.3.0":"data-testid share externally enable annotations switch"},copyUrlButton:{"11.3.0":"data-testid share externally copy url button"},revokeAccessButton:{"11.3.0":"data-testid share externally revoke access button"},toggleAccessButton:{"11.3.0":"data-testid share externally pause or resume access button"}}},ShareSnapshot:{url:{"11.3.0":e=>`/dashboard/snapshot/${e}`},container:{"11.3.0":"data-testid share snapshot drawer container"},publishSnapshot:{"11.3.0":"data-testid share snapshot publish button"},copyUrlButton:{"11.3.0":"data-testid share snapshot copy url button"}}},ExportDashboardDrawer:{ExportAsJson:{container:{"11.3.0":"data-testid export as json drawer container"},codeEditor:{"11.3.0":"data-testid export as json code editor"},exportExternallyToggle:{"11.3.0":"data-testid export as json externally switch"},saveToFileButton:{"11.3.0":"data-testid export as json save to file button"},copyToClipboardButton:{"11.3.0":"data-testid export as json copy to clipboard button"},cancelButton:{"11.3.0":"data-testid export as json cancel button"}}},PublicDashboard:{page:{"9.5.0":"public-dashboard-page"},NotAvailable:{container:{"9.5.0":"public-dashboard-not-available"},title:{"9.5.0":"public-dashboard-title"},pausedDescription:{"9.5.0":"public-dashboard-paused-description"}},footer:{"11.0.0":"public-dashboard-footer"}},PublicDashboardScene:{loadingPage:{"11.0.0":"public-dashboard-scene-loading-page"},page:{"11.0.0":"public-dashboard-scene-page"},controls:{"11.0.0":"public-dashboard-controls"}},RequestViewAccess:{form:{"9.5.0":"request-view-access-form"},recipientInput:{"9.5.0":"request-view-access-recipient-input"},submitButton:{"9.5.0":"request-view-access-submit-button"}},PublicDashboardConfirmAccess:{submitButton:{"10.2.0":"data-testid confirm-access-submit-button"}},Explore:{url:{[Ue]:"/explore"},General:{container:{[Ue]:"data-testid Explore"},graph:{[Ue]:"Explore Graph"},table:{[Ue]:"Explore Table"},scrollView:{"9.0.0":"data-testid explorer scroll view"}},QueryHistory:{container:{"11.1.0":"data-testid QueryHistory"}}},SoloPanel:{url:{[Ue]:e=>`/d-solo/${e}`}},PluginsList:{page:{[Ue]:"Plugins list page"},list:{[Ue]:"Plugins list"},listItem:{[Ue]:"Plugins list item"},signatureErrorNotice:{"10.3.0":"data-testid Unsigned plugins notice",[Ue]:"Unsigned plugins notice"}},PluginPage:{page:{[Ue]:"Plugin page"},signatureInfo:{"10.3.0":"data-testid Plugin signature info",[Ue]:"Plugin signature info"},disabledInfo:{"10.3.0":"data-testid Plugin disabled info",[Ue]:"Plugin disabled info"}},PlaylistForm:{name:{[Ue]:"Playlist name"},interval:{[Ue]:"Playlist interval"},itemDelete:{"10.2.0":"data-testid playlist-form-delete-item"}},BrowseDashboards:{table:{body:{"10.2.0":"data-testid browse-dashboards-table"},row:{"10.2.0":e=>`data-testid browse dashboards row ${e}`},checkbox:{"10.0.0":e=>`data-testid ${e} checkbox`}},NewFolderForm:{form:{"10.2.0":"data-testid new folder form"},nameInput:{"10.2.0":"data-testid new-folder-name-input"},createButton:{"10.2.0":"data-testid new-folder-create-button"}}},Search:{url:{"9.3.0":"/?search=openn"},FolderView:{url:{"9.3.0":"/?search=open&layout=folders"}}},PublicDashboards:{ListItem:{linkButton:{"9.3.0":"public-dashboard-link-button"},configButton:{"9.3.0":"public-dashboard-configuration-button"},trashcanButton:{"9.3.0":"public-dashboard-remove-button"},pauseSwitch:{"10.1.0":"data-testid public dashboard pause switch"}}},UserListPage:{tabs:{allUsers:{"10.0.0":"data-testid all-users-tab"},orgUsers:{"10.0.0":"data-testid org-users-tab"},anonUserDevices:{"10.2.3":"data-testid anon-user-devices-tab"},publicDashboardsUsers:{"10.0.0":"data-testid public-dashboards-users-tab"},users:{"10.0.0":"data-testid users-tab"}},org:{url:{"9.5.0":"/org/users"}},admin:{url:{"9.5.0":"/admin/users"}},publicDashboards:{container:{"11.1.0":"data-testid public-dashboards-users-list"}},UserListAdminPage:{container:{"10.0.0":"data-testid user-list-admin-page"}},UsersListPage:{container:{"10.0.0":"data-testid users-list-page"}},UserAnonListPage:{container:{"10.4.0":"data-testid user-anon-list-page"}},UsersListPublicDashboardsPage:{container:{"10.0.0":"data-testid users-list-public-dashboards-page"},DashboardsListModal:{listItem:{"10.0.0":e=>`data-testid dashboards-list-item-${e}`}}}},ProfilePage:{url:{"10.2.0":"/profile"}},Plugin:{url:{[Ue]:e=>`/plugins/${e}`}}}),components:Ne(Be)};var $e=v(6089);const We=({children:e})=>{const t=(0,xe.useStyles2)(He);return ye().createElement("div",{className:t.root},e)},He=e=>({root:(0,$e.css)({display:"flex",flexWrap:"wrap",alignItems:"center",gap:e.spacing(3),minHeight:e.spacing(4)})});var qe=Object.defineProperty,Ge=Object.defineProperties,Ke=Object.getOwnPropertyDescriptors,Ye=Object.getOwnPropertySymbols,Xe=Object.prototype.hasOwnProperty,Qe=Object.prototype.propertyIsEnumerable,Je=(e,t,r)=>t in e?qe(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Ze=(e,t)=>{for(var r in t||(t={}))Xe.call(t,r)&&Je(e,r,t[r]);if(Ye)for(var r of Ye(t))Qe.call(t,r)&&Je(e,r,t[r]);return e},et=(e,t)=>Ge(e,Ke(t)),tt=(e,t)=>{var r={};for(var n in e)Xe.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Ye)for(var n of Ye(e))t.indexOf(n)<0&&Qe.call(e,n)&&(r[n]=e[n]);return r};function rt(e){var t=e,{label:r}=t,n=tt(t,["label"]);const o=(0,xe.useStyles2)(it),[i]=(0,ve.useState)((()=>Math.random().toString(16).slice(2))),a={SelectContainer:nt,ValueContainer:ot,SingleValue:ot};return ye().createElement("div",{className:o.root},r&&ye().createElement("label",{className:o.label,htmlFor:i},r,":"," "),ye().createElement(xe.Select,et(Ze({openMenuOnFocus:!0,inputId:i},n),{components:a})))}const nt=e=>{const{children:t}=e,r=(0,xe.useStyles2)(it);return ye().createElement(xe.SelectContainer,et(Ze({},e),{className:(0,$e.cx)(e.className,r.container)}),t)},ot=e=>{const{className:t,children:r}=e,n=(0,xe.useStyles2)(it);return ye().createElement("div",{className:(0,$e.cx)(t,n.valueContainer)},r)},it=e=>({root:(0,$e.css)({display:"flex",fontSize:12,alignItems:"center"}),label:(0,$e.css)({color:e.colors.text.secondary,whiteSpace:"nowrap"}),container:(0,$e.css)({background:"none",borderColor:"transparent"}),valueContainer:(0,$e.css)({display:"flex",alignItems:"center",flex:"initial",color:e.colors.text.secondary,fontSize:12})}),at=({grow:e,shrink:t})=>ye().createElement("div",{style:{display:"block",flexGrow:e,flexShrink:t}});var st=Object.getOwnPropertySymbols,lt=Object.prototype.hasOwnProperty,ut=Object.prototype.propertyIsEnumerable;const ct=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)lt.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&st)for(var n of st(e))t.indexOf(n)<0&&ut.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);const o=(0,xe.useStyles2)((0,ve.useCallback)((e=>dt(e,n)),[n]));return ye().createElement("div",{className:o.root},r)},dt=(e,t)=>{var r,n,o;return{root:(0,$e.css)({display:"flex",flexDirection:null!=(r=t.direction)?r:"row",flexWrap:null==(n=t.wrap)||n?"wrap":void 0,alignItems:t.alignItems,gap:e.spacing(null!=(o=t.gap)?o:2),flexGrow:t.flexGrow})}},pt=({children:e})=>{const t=(0,xe.useStyles2)(ft);return ye().createElement("div",{className:t.root},ye().createElement(ct,{gap:2},e))},ft=e=>({root:(0,$e.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(1)})}),ht=({v:e=0,h:t=0,layout:r="block"})=>{const n=(0,xe.useStyles2)((0,ve.useCallback)((n=>gt(n,{v:e,h:t,layout:r})),[e,t,r]));return ye().createElement("span",{className:(0,$e.cx)(n.wrapper)})},gt=(e,t)=>{var r,n;return{wrapper:(0,$e.css)([{paddingRight:e.spacing(null!=(r=t.h)?r:0),paddingBottom:e.spacing(null!=(n=t.v)?n:0)},"inline"===t.layout&&{display:"inline-block"},"block"===t.layout&&{display:"block"}])}};var vt=Object.defineProperty,mt=Object.getOwnPropertySymbols,yt=Object.prototype.hasOwnProperty,bt=Object.prototype.propertyIsEnumerable,Ot=(e,t,r)=>t in e?vt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Et=e=>{var t;const r=e,{label:n,optional:o,tooltip:i,tooltipInteractive:a,children:s,width:l}=r,u=((e,t)=>{var r={};for(var n in e)yt.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&mt)for(var n of mt(e))t.indexOf(n)<0&&bt.call(e,n)&&(r[n]=e[n]);return r})(r,["label","optional","tooltip","tooltipInteractive","children","width"]),c=(0,xe.useStyles2)((0,ve.useCallback)((e=>St(e,l)),[l])),d=(null==u?void 0:u.htmlFor)||(null==(t=xe.ReactUtils)?void 0:t.getChildId(s)),p=ye().createElement(ye().Fragment,null,ye().createElement("label",{className:c.label,htmlFor:d},n,o&&ye().createElement("span",{className:c.optional}," - optional"),i&&ye().createElement(xe.Tooltip,{placement:"top",content:i,theme:"info",interactive:a},ye().createElement(xe.Icon,{tabIndex:0,name:"info-circle",size:"sm",className:c.icon}))),ye().createElement(ht,{v:.5}));return ye().createElement("div",{className:c.root},ye().createElement(xe.Field,((e,t)=>{for(var r in t||(t={}))yt.call(t,r)&&Ot(e,r,t[r]);if(mt)for(var r of mt(t))bt.call(t,r)&&Ot(e,r,t[r]);return e})({className:c.field,label:p},u),s))},St=(e,t)=>({root:(0,$e.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,$e.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,$e.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,$e.css)({marginBottom:0}),icon:(0,$e.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})});function wt({isOpen:e,onCancel:t,onDiscard:r,onCopy:n}){const o=(0,ve.useRef)(null),i=(0,xe.useStyles2)(Tt);return(0,ve.useEffect)((()=>{var t;e&&(null===(t=o.current)||void 0===t||t.focus())}),[e]),(0,ge.jsxs)(xe.Modal,{title:(0,ge.jsxs)("div",{className:i.modalHeaderTitle,children:[(0,ge.jsx)(xe.Icon,{name:"exclamation-triangle",size:"lg"}),(0,ge.jsx)("span",{className:i.titleText,children:"Warning"})]}),onDismiss:t,isOpen:e,children:[(0,ge.jsx)("p",{children:"Builder mode does not display changes made in code. The query builder will display the last changes you made in builder mode."}),(0,ge.jsx)("p",{children:"Do you want to copy your code to the clipboard?"}),(0,ge.jsxs)(xe.Modal.ButtonRow,{children:[(0,ge.jsx)(xe.Button,{type:"button",variant:"secondary",onClick:t,fill:"outline",children:"Cancel"}),(0,ge.jsx)(xe.Button,{variant:"destructive",type:"button",onClick:r,ref:o,children:"Discard code and switch"}),(0,ge.jsx)(xe.Button,{variant:"primary",onClick:n,children:"Copy code and switch"})]})]})}const Tt=e=>({titleText:(0,$e.css)({paddingLeft:e.spacing(2)}),modalHeaderTitle:(0,$e.css)({fontSize:e.typography.size.lg,float:"left",paddingTop:e.spacing(1),margin:e.spacing(0,2)})}),xt=()=>!!pe.config.featureToggles.sqlDatasourceDatabaseSelection;function _t(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Ct(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){_t(i,n,o,a,s,"next",e)}function s(e){_t(i,n,o,a,s,"throw",e)}a(void 0)}))}}const Rt=({dataset:e,db:t,dialect:r,onChange:n,inputId:o,preconfiguredDataset:i})=>{const a=!!i||"postgres"===r,s=Se(Ct((function*(){return xt()&&a?(n(x(i)),[x(i)]):(e&&n(x(e)),(yield t.datasets()).map(x))})),[]);return(0,ve.useEffect)((()=>{xt()||(e?s.value&&void 0===s.value.find((t=>t.value===e))&&s.value.length>0&&n(s.value[0]):s.value&&s.value[0]&&n(s.value[0]))}),[s.value,n,e]),(0,ge.jsx)(xe.Select,{"aria-label":"Dataset selector",inputId:o,value:e,options:s.value,onChange:n,disabled:s.loading,isLoading:s.loading,menuShouldPortal:!0})};function It(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function At(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){It(i,n,o,a,s,"next",e)}function s(e){It(i,n,o,a,s,"throw",e)}a(void 0)}))}}const jt=({db:e,dataset:t,table:r,className:n,onChange:o,inputId:i})=>{const a=Se(At((function*(){return t?(yield e.tables(t)).map(w.toOption):[]})),[t]);return(0,ge.jsx)(xe.Select,{className:n,disabled:a.loading,"aria-label":"Table selector",inputId:i,"data-testid":ze.components.SQLQueryEditor.headerTableSelector,value:r,options:a.value,onChange:o,isLoading:a.loading,menuShouldPortal:!0,placeholder:a.loading?"Loading tables":"Select table"})};function Pt(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Lt(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Pt(e,t,r[t])}))}return e}function kt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Nt=[{label:"Builder",value:de.Builder},{label:"Code",value:de.Code}];function Dt({db:e,dialect:t,isQueryRunnable:r,onChange:n,onQueryRowChange:o,onRunQuery:i,preconfiguredDataset:a,query:s,queryRowFilter:l}){const{editorMode:u}=s,[c,d]=Le(),[p,f]=(0,ve.useState)(!1),h=e.toRawSql,g=(0,ve.useId)(),v=(0,ve.useCallback)((e=>{var t;e===de.Code&&(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedEditorMode:de.Code}),u!==de.Code?n(kt(Lt({},s),{editorMode:e})):f(!0)}),[u,n,s]);return(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsxs)(We,{children:[(0,ge.jsx)(rt,{label:"Format",value:s.format,placeholder:"Select format",menuShouldPortal:!0,onChange:e=>{var t;const r=kt(Lt({},s),{format:void 0!==e.value?e.value:S.Table});(0,pe.reportInteraction)("grafana_sql_format_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedFormat:r.format}),n(r)},options:T}),u===de.Builder&&(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xe.InlineSwitch,{id:`sql-filter-${g}`,label:"Filter","data-testid":ze.components.SQLQueryEditor.headerFilterSwitch,transparent:!0,showLabel:!0,value:l.filter,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_filter_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(kt(Lt({},l),{filter:e.target.checked})))}}),(0,ge.jsx)(xe.InlineSwitch,{id:`sql-group-${g}`,label:"Group","data-testid":ze.components.SQLQueryEditor.headerGroupSwitch,transparent:!0,showLabel:!0,value:l.group,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_group_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(kt(Lt({},l),{group:e.target.checked})))}}),(0,ge.jsx)(xe.InlineSwitch,{id:`sql-order-${g}`,label:"Order","data-testid":ze.components.SQLQueryEditor.headerOrderSwitch,transparent:!0,showLabel:!0,value:l.order,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_order_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(kt(Lt({},l),{order:e.target.checked})))}}),(0,ge.jsx)(xe.InlineSwitch,{id:`sql-preview-${g}`,label:"Preview","data-testid":ze.components.SQLQueryEditor.headerPreviewSwitch,transparent:!0,showLabel:!0,value:l.preview,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_preview_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(kt(Lt({},l),{preview:e.target.checked})))}})]}),(0,ge.jsx)(at,{grow:1}),r?(0,ge.jsx)(xe.Button,{icon:"play",variant:"primary",size:"sm",onClick:()=>i(),children:"Run query"}):(0,ge.jsx)(xe.Tooltip,{theme:"error",content:(0,ge.jsxs)(ge.Fragment,{children:["Your query is invalid. Check below for details. ",(0,ge.jsx)("br",{}),"However, you can still run this query."]}),placement:"top",children:(0,ge.jsx)(xe.Button,{icon:"exclamation-triangle",variant:"secondary",size:"sm",onClick:()=>i(),children:"Run query"})}),(0,ge.jsx)(xe.RadioButtonGroup,{options:Nt,size:"sm",value:u,onChange:v}),(0,ge.jsx)(wt,{isOpen:p,onCopy:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"copy"}),f(!1),d(s.rawSql),n(kt(Lt({},s),{rawSql:h(s),editorMode:de.Builder}))},onDiscard:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"discard"}),f(!1),n(kt(Lt({},s),{rawSql:h(s),editorMode:de.Builder}))},onCancel:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"cancel"}),f(!1)}})]}),u===de.Builder&&(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xe.Space,{v:.5}),(0,ge.jsxs)(pt,{children:["influx"!==t&&!(!xt()&&"postgres"===t)&&(0,ge.jsx)(Et,{label:"Dataset",width:25,children:(0,ge.jsx)(Rt,{db:e,inputId:`sql-dataset-${g}`,dataset:s.dataset,dialect:t,preconfiguredDataset:a,onChange:e=>{if(e.value===s.dataset)return;const t=kt(Lt({},s),{dataset:e.value,table:void 0,sql:void 0,rawSql:""});n(t)}})}),(0,ge.jsx)(Et,{label:"Table",width:25,children:(0,ge.jsx)(jt,{db:e,inputId:`sql-tableselect-${g}`,dataset:s.dataset||a,table:s.table,onChange:e=>{if(e.value===s.table)return;const t=kt(Lt({},s),{table:e.value,sql:void 0,rawSql:""});n(t)}})})]})]})]})}var Ft=function(){},Mt="undefined"!=typeof window;const Vt=Mt?ve.useLayoutEffect:ve.useEffect;var Ut={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};const Bt=Mt&&void 0!==window.ResizeObserver?function(){var e=(0,ve.useState)(null),t=e[0],r=e[1],n=(0,ve.useState)(Ut),o=n[0],i=n[1],a=(0,ve.useMemo)((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,a=t.height,s=t.top,l=t.left,u=t.bottom,c=t.right;i({x:r,y:n,width:o,height:a,top:s,left:l,bottom:u,right:c})}}))}),[]);return Vt((function(){if(t)return a.observe(t),function(){a.disconnect()}}),[t]),[r,o]}:function(){return[Ft,Ut]};let zt;zt="undefined"!=typeof window?window:"undefined"!=typeof self?self:v.g;let $t=null,Wt=null;const Ht=zt.clearTimeout,qt=zt.setTimeout,Gt=zt.cancelAnimationFrame||zt.mozCancelAnimationFrame||zt.webkitCancelAnimationFrame,Kt=zt.requestAnimationFrame||zt.mozRequestAnimationFrame||zt.webkitRequestAnimationFrame;null==Gt||null==Kt?($t=Ht,Wt=function(e){return qt(e,20)}):($t=function([e,t]){Gt(e),Ht(t)},Wt=function(e){const t=Kt((function(){Ht(r),e()})),r=qt((function(){Gt(t),e()}),20);return[t,r]});class Yt extends ve.Component{constructor(...e){super(...e),this.state={height:this.props.defaultHeight||0,scaledHeight:this.props.defaultHeight||0,scaledWidth:this.props.defaultWidth||0,width:this.props.defaultWidth||0},this._autoSizer=null,this._detectElementResize=null,this._parentNode=null,this._resizeObserver=null,this._timeoutId=null,this._onResize=()=>{this._timeoutId=null;const{disableHeight:e,disableWidth:t,onResize:r}=this.props;if(this._parentNode){const n=window.getComputedStyle(this._parentNode)||{},o=parseFloat(n.paddingLeft||"0"),i=parseFloat(n.paddingRight||"0"),a=parseFloat(n.paddingTop||"0"),s=parseFloat(n.paddingBottom||"0"),l=this._parentNode.getBoundingClientRect(),u=l.height-a-s,c=l.width-o-i,d=this._parentNode.offsetHeight-a-s,p=this._parentNode.offsetWidth-o-i;(e||this.state.height===d&&this.state.scaledHeight===u)&&(t||this.state.width===p&&this.state.scaledWidth===c)||(this.setState({height:d,width:p,scaledHeight:u,scaledWidth:c}),"function"==typeof r&&r({height:d,scaledHeight:u,scaledWidth:c,width:p}))}},this._setRef=e=>{this._autoSizer=e}}componentDidMount(){const{nonce:e}=this.props,t=this._autoSizer?this._autoSizer.parentNode:null;if(null!=t&&t.ownerDocument&&t.ownerDocument.defaultView&&t instanceof t.ownerDocument.defaultView.HTMLElement){this._parentNode=t;const r=t.ownerDocument.defaultView.ResizeObserver;null!=r?(this._resizeObserver=new r((()=>{this._timeoutId=setTimeout(this._onResize,0)})),this._resizeObserver.observe(t)):(this._detectElementResize=function(e){let t,r,n,o,i,a,s;const l="undefined"!=typeof document&&document.attachEvent;if(!l){a=function(e){const t=e.__resizeTriggers__,r=t.firstElementChild,n=t.lastElementChild,o=r.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,o.style.width=r.offsetWidth+1+"px",o.style.height=r.offsetHeight+1+"px",r.scrollLeft=r.scrollWidth,r.scrollTop=r.scrollHeight},i=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height},s=function(e){if(e.target.className&&"function"==typeof e.target.className.indexOf&&e.target.className.indexOf("contract-trigger")<0&&e.target.className.indexOf("expand-trigger")<0)return;const t=this;a(this),this.__resizeRAF__&&$t(this.__resizeRAF__),this.__resizeRAF__=Wt((function(){i(t)&&(t.__resizeLast__.width=t.offsetWidth,t.__resizeLast__.height=t.offsetHeight,t.__resizeListeners__.forEach((function(r){r.call(t,e)})))}))};let e=!1,l="";n="animationstart";const u="Webkit Moz O ms".split(" ");let c="webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "),d="";{const t=document.createElement("fakeelement");if(void 0!==t.style.animationName&&(e=!0),!1===e)for(let r=0;r<u.length;r++)if(void 0!==t.style[u[r]+"AnimationName"]){d=u[r],l="-"+d.toLowerCase()+"-",n=c[r],e=!0;break}}r="resizeanim",t="@"+l+"keyframes "+r+" { from { opacity: 0; } to { opacity: 0; } } ",o=l+"animation: 1ms "+r+"; "}return{addResizeListener:function(i,u){if(l)i.attachEvent("onresize",u);else{if(!i.__resizeTriggers__){const l=i.ownerDocument,u=zt.getComputedStyle(i);u&&"static"===u.position&&(i.style.position="relative"),function(r){if(!r.getElementById("detectElementResize")){const n=(t||"")+".resize-triggers { "+(o||"")+'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',i=r.head||r.getElementsByTagName("head")[0],a=r.createElement("style");a.id="detectElementResize",a.type="text/css",null!=e&&a.setAttribute("nonce",e),a.styleSheet?a.styleSheet.cssText=n:a.appendChild(r.createTextNode(n)),i.appendChild(a)}}(l),i.__resizeLast__={},i.__resizeListeners__=[],(i.__resizeTriggers__=l.createElement("div")).className="resize-triggers";const c=l.createElement("div");c.className="expand-trigger",c.appendChild(l.createElement("div"));const d=l.createElement("div");d.className="contract-trigger",i.__resizeTriggers__.appendChild(c),i.__resizeTriggers__.appendChild(d),i.appendChild(i.__resizeTriggers__),a(i),i.addEventListener("scroll",s,!0),n&&(i.__resizeTriggers__.__animationListener__=function(e){e.animationName===r&&a(i)},i.__resizeTriggers__.addEventListener(n,i.__resizeTriggers__.__animationListener__))}i.__resizeListeners__.push(u)}},removeResizeListener:function(e,t){if(l)e.detachEvent("onresize",t);else if(e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(t),1),!e.__resizeListeners__.length){e.removeEventListener("scroll",s,!0),e.__resizeTriggers__.__animationListener__&&(e.__resizeTriggers__.removeEventListener(n,e.__resizeTriggers__.__animationListener__),e.__resizeTriggers__.__animationListener__=null);try{e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__)}catch(e){}}}}}(e),this._detectElementResize.addResizeListener(t,this._onResize)),this._onResize()}}componentWillUnmount(){this._parentNode&&(this._detectElementResize&&this._detectElementResize.removeResizeListener(this._parentNode,this._onResize),null!==this._timeoutId&&clearTimeout(this._timeoutId),this._resizeObserver&&this._resizeObserver.disconnect())}render(){const{children:e,defaultHeight:t,defaultWidth:r,disableHeight:n=!1,disableWidth:o=!1,doNotBailOutOnEmptyChildren:i=!1,nonce:a,onResize:s,style:l={},tagName:u="div",...c}=this.props,{height:d,scaledHeight:p,scaledWidth:f,width:h}=this.state,g={overflow:"visible"},v={};let m=!1;return n||(0===d&&(m=!0),g.height=0,v.height=d,v.scaledHeight=p),o||(0===h&&(m=!0),g.width=0,v.width=h,v.scaledWidth=f),i&&(m=!1),(0,ve.createElement)(u,{ref:this._setRef,style:{...g,...l},...c},!m&&e(v))}}var Xt=Object.defineProperty,Qt=Object.getOwnPropertySymbols,Jt=Object.prototype.hasOwnProperty,Zt=Object.prototype.propertyIsEnumerable,er=(e,t,r)=>t in e?Xt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const tr=(e,t,r={})=>{const n=((e,t)=>{for(var r in t||(t={}))Jt.call(t,r)&&er(e,r,t[r]);if(Qt)for(var r of Qt(t))Zt.call(t,r)&&er(e,r,t[r]);return e})({label:e,insertText:e,kind:ue.Field,sortText:le.Medium,range:t},r);return n};var rr=Object.defineProperty,nr=Object.defineProperties,or=Object.getOwnPropertyDescriptors,ir=Object.getOwnPropertySymbols,ar=Object.prototype.hasOwnProperty,sr=Object.prototype.propertyIsEnumerable,lr=(e,t,r)=>t in e?rr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,ur=(e,t)=>{for(var r in t||(t={}))ar.call(t,r)&&lr(e,r,t[r]);if(ir)for(var r of ir(t))sr.call(t,r)&&lr(e,r,t[r]);return e},cr=(e,t)=>nr(e,or(t));const dr=()=>[{id:ae.SelectKeyword,name:ae.SelectKeyword,kind:[se.SelectKeyword]},{id:ae.WithKeyword,name:ae.WithKeyword,kind:[se.WithKeyword]},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,kind:[se.StarWildCard,se.FunctionsWithArguments,se.Columns,se.SelectMacro]},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,kind:[se.Columns]},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,kind:[se.Columns]},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,kind:[se.Columns]},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,kind:[se.Columns]},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,kind:[se.Schemas,se.Tables,se.TableMacro]},{id:ae.AfterSchema,name:ae.AfterSchema,kind:[se.Tables,se.TableMacro]},{id:ae.SelectAlias,name:ae.SelectAlias,kind:[se.Columns,se.FunctionsWithArguments]},{id:ae.FromKeyword,name:ae.FromKeyword,kind:[se.FromKeyword]},{id:ae.AfterFrom,name:ae.AfterFrom,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterTable,name:ae.AfterTable,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.WhereKeyword,name:ae.WhereKeyword,kind:[se.Columns,se.FilterMacro,se.TemplateVariables]},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,kind:[se.ComparisonOperators]},{id:ae.WhereValue,name:ae.WhereValue,kind:[se.FilterMacro,se.TemplateVariables]},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,kind:[se.LogicalOperators,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword,se.Columns,se.TemplateVariables]},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,kind:[se.GroupMacro,se.Columns]},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,kind:[se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,kind:[se.Columns]},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,kind:[se.SortOrderDirectionKeyword,se.LimitKeyword]},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,kind:[se.LimitKeyword]},{id:ae.AfterIsOperator,name:ae.AfterOrderByDirection,kind:[se.NotKeyword,se.NullValue,se.BoolValues]},{id:ae.AfterIsNotOperator,name:ae.AfterOrderByDirection,kind:[se.NullValue,se.BoolValues]}];class pr{constructor(e,t,r,n,o){this.type=e,this.value=t,this.range=r,this.previous=n,this.next=o}isKeyword(){return this.type===ie.Keyword}isWhiteSpace(){return this.type===ie.Whitespace}isParenthesis(){return this.type===ie.Parenthesis}isIdentifier(){return this.type===ie.Identifier}isString(){return this.type===ie.String}isNumber(){return this.type===ie.Number}isDoubleQuotedString(){return this.type===ie.Type}isVariable(){return this.type===ie.Variable}isFunction(){return this.type===ie.Function}isOperator(){return this.type===ie.Operator}isTemplateVariable(){return this.type===ie.Variable}is(e,t){const r=this.type===e;return void 0!==t?r&&fr(e,this,t):r}getPreviousNonWhiteSpaceToken(){let e=this.previous;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.previous}return null}getPreviousOfType(e,t){let r=this.previous;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&fr(e,r,t):n)return r;r=r.previous}return null}getPreviousUntil(e,t,r){let n=[],o=this.previous;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.previous;continue}const i=o.type===e;if(void 0!==r?i&&fr(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.previous}return n}getNextUntil(e,t,r){let n=[],o=this.next;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.next;continue}const i=o.type===e;if(void 0!==r?i&&fr(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.next}return n}getPreviousKeyword(){let e=this.previous;for(;null!=e;){if(e.isKeyword())return e;e=e.previous}return null}getNextNonWhiteSpaceToken(){let e=this.next;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.next}return null}getNextOfType(e,t){let r=this.next;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&fr(e,r,t):n)return r;r=r.next}return null}}function fr(e,t,r){return e===ie.Keyword||e===ie.Operator?t.value.toLowerCase()===r.toString().toLowerCase():t.value===r}var hr=v(8572);const gr=e=>{var t;const r=(e=>{const t=(e=>{var t;return null!=(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,hr.SELECT))?t:null})(e);return null==t?void 0:t.getNextOfType(ie.Keyword,hr.FROM)})(e),n=null==r?void 0:r.getNextNonWhiteSpaceToken();return(null==n?void 0:n.isVariable())||(null==n?void 0:n.isKeyword())&&(null==(t=n.next)?void 0:t.is(ie.Parenthesis,"("))?null:n},vr=e=>{const t=null==e?void 0:e.value.split(".");return 1===(null==t?void 0:t.length)?{table:t[0]}:2===(null==t?void 0:t.length)?{schema:t[0],table:t[1]}:null},mr={id:"editor.action.triggerSuggest",title:""};var yr,br=new Uint8Array(16);function Or(){if(!yr&&!(yr="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return yr(br)}const Er=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var Sr=[],wr=0;wr<256;++wr)Sr.push((wr+256).toString(16).substr(1));const Tr=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Sr[e[t+0]]+Sr[e[t+1]]+Sr[e[t+2]]+Sr[e[t+3]]+"-"+Sr[e[t+4]]+Sr[e[t+5]]+"-"+Sr[e[t+6]]+Sr[e[t+7]]+"-"+Sr[e[t+8]]+Sr[e[t+9]]+"-"+Sr[e[t+10]]+Sr[e[t+11]]+Sr[e[t+12]]+Sr[e[t+13]]+Sr[e[t+14]]+Sr[e[t+15]]).toLowerCase();if(!function(e){return"string"==typeof e&&Er.test(e)}(r))throw TypeError("Stringified UUID is invalid");return r},xr=function(e,t,r){var n=(e=e||{}).random||(e.rng||Or)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t){r=r||0;for(var o=0;o<16;++o)t[r+o]=n[o];return t}return Tr(n)},_r=(e,t,r)=>()=>[{id:se.SelectKeyword,name:se.SelectKeyword,suggestions:(e,t)=>Promise.resolve([{label:"SELECT <column>",insertText:"SELECT $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:mr,sortText:le.Medium},{label:"SELECT <column> FROM <table>",insertText:"SELECT $2 FROM $1",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:mr,sortText:le.Medium}])},{id:se.TemplateVariables,name:se.TemplateVariables,suggestions:(e,t)=>{const r=(0,pe.getTemplateSrv)();return r?Promise.resolve(r.getVariables().map((e=>{const t=`$${e.name}`,n=r.replace(t);return{label:t,detail:`(Template Variable) ${n}`,kind:ue.Snippet,documentation:`(Template Variable) ${n}`,insertText:`\\$${e.name} `,insertTextRules:ce.InsertAsSnippet,command:mr,sortText:le.Low}}))):Promise.resolve([])}},{id:se.SelectMacro,name:se.SelectMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Value||e.type===oe.Column)).map(Cr)])},{id:se.TableMacro,name:se.TableMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Table)).map(Cr)])},{id:se.GroupMacro,name:se.GroupMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Group)).map(Cr)])},{id:se.FilterMacro,name:se.FilterMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Filter)).map(Cr)])},{id:se.WithKeyword,name:se.WithKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WITH <alias> AS ( ... )",insertText:"WITH $1  AS ( $2 )",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:mr,sortText:le.Medium}])},{id:se.StarWildCard,name:se.StarWildCard,suggestions:(e,t)=>Promise.resolve([{label:"*",insertText:"* $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Field,command:mr,sortText:le.High}])},{id:se.FunctionsWithArguments,name:se.FunctionsWithArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}($0)`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:mr,sortText:le.MediumLow})))])},{id:se.FunctionsWithoutArguments,name:se.FunctionsWithoutArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}()`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:mr,sortText:le.MediumHigh})))])},{id:se.FromKeyword,name:se.FromKeyword,suggestions:(e,t)=>Promise.resolve([{label:"FROM",insertText:"FROM $0",command:mr,insertTextRules:ce.InsertAsSnippet,kind:ue.Keyword}])},{id:se.Schemas,name:se.Schemas,suggestions:(e,t)=>Promise.resolve([])},{id:se.Tables,name:se.Tables,suggestions:(e,t)=>Promise.resolve([])},{id:se.Columns,name:se.Columns,suggestions:(e,t)=>Promise.resolve([])},{id:se.LogicalOperators,name:se.LogicalOperators,suggestions:(e,r)=>Promise.resolve(t.list().filter((e=>e.type===ne.Logical)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:mr,sortText:le.MediumHigh,kind:ue.Operator}))))},{id:se.WhereKeyword,name:se.WhereKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WHERE",insertText:"WHERE ",command:mr,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.ComparisonOperators,name:se.ComparisonOperators,suggestions:(e,r)=>Promise.resolve([...t.list().filter((e=>e.type===ne.Comparison)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:mr,sortText:le.MediumHigh,kind:ue.Operator}))),{label:"IN (...)",insertText:"IN ( $0 )",command:mr,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"NOT IN (...)",insertText:"NOT IN ( $0 )",command:mr,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"IS",insertText:"IS",command:mr,sortText:le.Medium,kind:ue.Operator},{label:"IS NOT",insertText:"IS NOT",command:mr,sortText:le.Medium,kind:ue.Operator}])},{id:se.GroupByKeywords,name:se.GroupByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"GROUP BY",insertText:"GROUP BY ",command:mr,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.OrderByKeywords,name:se.OrderByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"ORDER BY",insertText:"ORDER BY ",command:mr,sortText:le.Medium,kind:ue.Keyword},{label:"ORDER BY(ascending)",insertText:"ORDER BY $1 ASC ",command:mr,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet},{label:"ORDER BY(descending)",insertText:"ORDER BY $1 DESC",command:mr,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet}])},{id:se.LimitKeyword,name:se.LimitKeyword,suggestions:(e,t)=>Promise.resolve([{label:"LIMIT",insertText:"LIMIT ",command:mr,sortText:le.MediumLow,kind:ue.Keyword}])},{id:se.SortOrderDirectionKeyword,name:se.SortOrderDirectionKeyword,suggestions:(e,t)=>Promise.resolve([hr.ASC,hr.DESC].map((e=>({label:e,insertText:`${e} `,command:mr,kind:ue.Keyword}))))},{id:se.NotKeyword,name:se.NotKeyword,suggestions:()=>Promise.resolve([{label:"NOT",insertText:"NOT",command:mr,kind:ue.Keyword,sortText:le.High}])},{id:se.BoolValues,name:se.BoolValues,suggestions:()=>Promise.resolve(["TRUE","FALSE"].map((e=>({label:e,insertText:`${e}`,command:mr,kind:ue.Keyword,sortText:le.Medium}))))},{id:se.NullValue,name:se.NullValue,suggestions:()=>Promise.resolve(["NULL"].map((e=>({label:e,insertText:`${e}`,command:mr,kind:ue.Keyword,sortText:le.Low}))))}];function Cr(e){return{label:e.name,insertText:`${"\\"+e.text}${t=e.args,t?"(".concat(t.map(((e,t)=>`\${${t}:${e}}`)).join(", ")).concat(")"):"()"} `,insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,documentation:e.description,command:mr};var t}function Rr(){return[{id:ae.SelectKeyword,name:ae.SelectKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,hr.SELECT)||e.is(ie.Keyword,hr.SELECT)&&null===e.previous||n||e.isIdentifier()&&(n||null===(null==e?void 0:e.previous))||e.isIdentifier()&&hr.SELECT.startsWith(e.value.toLowerCase()))},{id:ae.WithKeyword,name:ae.WithKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,hr.WITH)&&null===e.previous||e.isIdentifier()&&hr.WITH.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,resolve:(e,t,r,n)=>Boolean((null==r?void 0:r.value.toLowerCase())===hr.SELECT)},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.SELECT&&","===(null==r?void 0:r.value))},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,resolve:(e,t,r,n)=>Boolean(((null==t?void 0:t.value.toLowerCase())===hr.SELECT||(null==t?void 0:t.value.toLowerCase())===hr.AS)&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,hr.WHERE))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,hr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,hr.GROUP))&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))))}},{id:ae.SelectAlias,name:ae.SelectAlias,resolve:(e,t,r,n)=>","===(null==r?void 0:r.value)&&(null==t?void 0:t.value.toLowerCase())===hr.AS},{id:ae.FromKeyword,name:ae.FromKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.SELECT&&","!==(null==r?void 0:r.value)||((null==e?void 0:e.isKeyword())||(null==e?void 0:e.isIdentifier()))&&hr.FROM.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,resolve:(e,t,r,n)=>Boolean(!(null==e?void 0:e.value.includes("."))&&(null==r?void 0:r.value.toLowerCase())===hr.FROM)},{id:ae.AfterSchema,name:ae.AfterSchema,resolve:(e,t,r,n)=>((null==e?void 0:e.isWhiteSpace())&&(null==e?void 0:e.next)&&(r=(e=null==e?void 0:e.previous).getPreviousNonWhiteSpaceToken()),Boolean((null==e?void 0:e.isIdentifier())&&(null==e?void 0:e.value.endsWith("."))&&(null==r?void 0:r.value.toLowerCase())===hr.FROM))},{id:ae.AfterFrom,name:ae.AfterFrom,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.FROM&&(null==r?void 0:r.isDoubleQuotedString())||(null==t?void 0:t.value.toLowerCase())===hr.FROM&&(null==r?void 0:r.isIdentifier())||(null==t?void 0:t.value.toLowerCase())===hr.FROM&&(null==r?void 0:r.isVariable()))},{id:ae.AfterTable,name:ae.AfterTable,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.FROM&&((null==r?void 0:r.isVariable())||""!==(null==r?void 0:r.value)&&(null==r?void 0:r.value.toLowerCase())!==hr.FROM))},{id:ae.WhereKeyword,name:ae.WhereKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.WHERE&&((null==r?void 0:r.isKeyword())||(null==r?void 0:r.is(ie.Parenthesis,"("))||(null==r?void 0:r.is(ie.Operator,hr.AND))))},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.value.toLowerCase())===hr.WHERE&&!(null==(o=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:o.isOperator())&&!(null==e?void 0:e.is(ie.Delimiter,"."))&&!(null==e?void 0:e.isParenthesis())&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())))}},{id:ae.WhereValue,name:ae.WhereValue,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===hr.WHERE&&(null==r?void 0:r.isOperator()))},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,resolve:(e,t,r,n)=>{var o,i,a;return Boolean((null==t?void 0:t.value.toLowerCase())===hr.WHERE&&((null==r?void 0:r.is(ie.Operator,"and"))||(null==r?void 0:r.is(ie.Operator,"or"))||(null==r?void 0:r.isString())||(null==r?void 0:r.isNumber())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))||(null==r?void 0:r.isTemplateVariable())||(null==r?void 0:r.is(ie.IdentifierQuote))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Identifier))&&(null==(a=null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.getPreviousNonWhiteSpaceToken())?void 0:a.is(ie.IdentifierQuote))))}},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,hr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,hr.GROUP))&&((null==r?void 0:r.is(ie.Keyword,hr.BY))||(null==r?void 0:r.is(ie.Delimiter,","))))}},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,hr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,hr.GROUP))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))}},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Keyword,hr.BY))&&(null==(o=null==r?void 0:r.getPreviousKeyword())?void 0:o.is(ie.Keyword,hr.ORDER)))}},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,resolve:(e,t,r,n)=>{var o,i;return Boolean((null==t?void 0:t.is(ie.Keyword,hr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,hr.ORDER))&&(null==r?void 0:r.is(ie.Parenthesis))&&(null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.is(ie.Function)))}},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,hr.DESC))||(null==t?void 0:t.is(ie.Keyword,hr.ASC)))},{id:ae.AfterIsOperator,name:ae.AfterIsOperator,resolve:(e,t,r,n)=>Boolean(null==r?void 0:r.is(ie.Operator,"IS"))},{id:ae.AfterIsNotOperator,name:ae.AfterIsNotOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Operator,"NOT"))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Operator,"IS")))}}]}let Ir={logger:()=>{}},Ar=()=>{};xe.attachDebugger&&xe.createLogger&&(Ir=(0,xe.createLogger)("SQLEditor"),Ar=Ir.logger,(0,xe.attachDebugger)("sqleditor",void 0,Ir));const jr="column",Pr=[{id:"$__timeFilter(dateColumn)",name:"$__timeFilter(dateColumn)",text:"$__timeFilter",args:[jr],type:oe.Filter,description:"Will be replaced by a time range filter using the specified column name. For example, dateColumn BETWEEN FROM_UNIXTIME(1494410783) AND FROM_UNIXTIME(1494410983)"},{id:"$__timeFrom()",name:"$__timeFrom()",text:"$__timeFrom",args:[],type:oe.Filter,description:"Will be replaced by the start of the currently active time selection. For example, FROM_UNIXTIME(1494410783)"},{id:"$__timeTo()",name:"$__timeTo()",text:"$__timeTo",args:[],type:oe.Filter,description:"Will be replaced by the end of the currently active time selection. For example, FROM_UNIXTIME(1494410983)"},{id:"$__timeGroup(dateColumn, '5m')",name:"$__timeGroup(dateColumn, '5m')",text:"$__timeGroup",args:[jr,"'5m'"],type:oe.Value,description:"Will be replaced by an expression usable in GROUP BY clause. For example, *cast(cast(UNIX_TIMESTAMP(dateColumn)/(300) as signed)*300 as signed),*"},{id:"$__table",name:"$__table",text:"$__table",args:[],type:oe.Table,description:"Will be replaced by the query table."},{id:"$__column",name:"$__column",text:"$__column",args:[],type:oe.Column,description:"Will be replaced by the query column."}];function Lr(e,t){var r,n,o;const i={triggerCharacters:["."," ","$",",","(","'"]};t&&Array.isArray(t.builtinFunctions)&&(i.supportedFunctions=()=>t.builtinFunctions.map((e=>({id:e,name:e}))));const a=[];return(null==(r=null==t?void 0:t.comparisonOperators)?void 0:r.length)&&a.push(...t.comparisonOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Comparison})))),t.logicalOperators=null!=(n=t.logicalOperators)?n:t.operators,(null==(o=null==t?void 0:t.logicalOperators)?void 0:o.length)&&a.push(...t.logicalOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Logical})))),i.supportedOperators=()=>a,i.supportedMacros=()=>Pr,i}const kr={id:"standardSql",extensions:[".sql"],aliases:["sql"],mimetypes:[],loader:()=>Promise.resolve().then(v.bind(v,8572)),completionProvider:Lr};var Nr=Object.defineProperty,Dr=Object.defineProperties,Fr=Object.getOwnPropertyDescriptors,Mr=Object.getOwnPropertySymbols,Vr=Object.prototype.hasOwnProperty,Ur=Object.prototype.propertyIsEnumerable,Br=(e,t,r)=>t in e?Nr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,zr=(e,t)=>{for(var r in t||(t={}))Vr.call(t,r)&&Br(e,r,t[r]);if(Mr)for(var r of Mr(t))Ur.call(t,r)&&Br(e,r,t[r]);return e},$r=(e,t)=>Dr(e,Fr(t));const Wr=new Map,Hr=new Map,qr=({children:e,onBlur:t,onChange:r,query:n,language:o={id:"sql"},width:i,height:a})=>{const s=(0,ve.useRef)(null),l=(0,ve.useRef)(),u=(0,ve.useMemo)((()=>{const e=xr(),t=`${o.id}-${e}`;return l.current=t,t}),[o.id]);(0,ve.useEffect)((()=>()=>{l.current&&Hr.delete(l.current),Ar(`Removing instance cache ${l.current}`,!1,Hr)}),[]);const c=(0,ve.useCallback)((()=>{s.current&&s.current.getAction("editor.action.formatDocument").run()}),[]);return ye().createElement("div",{style:{width:i}},ye().createElement(xe.CodeEditor,{height:a||"240px",width:i?i-2+"px":void 0,language:u,value:n,onBlur:e=>{r&&r(e,!1),t&&t(e)},showMiniMap:!1,showLineNumbers:!0,onEditorDidMount:(e,t)=>{s.current=e,e.onDidChangeModelContent((t=>{const n=e.getValue();r&&r(n,!1)})),e.addCommand(t.KeyMod.CtrlCmd|t.KeyCode.Enter,(()=>{const t=e.getValue();r&&r(t,!0)})),e.onKeyUp((t=>{84===t.keyCode&&e.trigger(mr.id,mr.id,{})})),Gr(t,o,u)}}),e&&e({formatQuery:c}))},Gr=async(e,t,r)=>{const n=((e,t)=>{if("sql"!==(null==t?void 0:t.id)&&!t.loader){Ar(`Loading language '${null==t?void 0:t.id}' from Monaco registry`,!1);const r=e.languages.getLanguages().find((({id:e})=>e===(null==t?void 0:t.id)));if(!r)throw Error(`Unknown Monaco language ${null==t?void 0:t.id}`);return zr(zr({completionProvider:Lr},r),t)}return zr(zr({},kr),t)})(e,t);if(!n.loader)return;const{language:o,conf:i}=await n.loader(e);if(e.languages.register({id:r}),e.languages.setMonarchTokensProvider(r,zr({},o)),e.languages.setLanguageConfiguration(r,zr({},i)),n.formatter&&e.languages.registerDocumentFormattingEditProvider(r,{provideDocumentFormattingEdits:e=>{var r;const n=null==(r=t.formatter)?void 0:r.call(t,e.getValue());return[{range:e.getFullModelRange(),text:n||""}]}}),n.completionProvider){const i=n.completionProvider(e,o);!function(e,t,r){var n;Wr.has(e)||function(e){Wr.has(e)||Wr.set(e,{functions:new w.Registry,operators:new w.Registry,suggestionKinds:new w.Registry(dr),positionResolvers:new w.Registry(Rr),macros:new w.Registry}),Wr.get(e)}(e);const o=Wr.get(e);Hr.has(t)||Hr.set(t,new w.Registry(_r(o.functions,o.operators,o.macros)));const i=Hr.get(t);if(r.supportedFunctions)for(const e of r.supportedFunctions())o.functions.getIfExists(e.id)||o.functions.register(e);if(r.supportedOperators)for(const e of r.supportedOperators())o.operators.getIfExists(e.id)||o.operators.register($r(zr({},e),{name:e.id}));if(r.supportedMacros)for(const e of r.supportedMacros())o.macros.getIfExists(e.id)||o.macros.register($r(zr({},e),{name:e.id}));if(r.customStatementPlacement)for(const e of r.customStatementPlacement()){const t=o.positionResolvers.getIfExists(e.id);if(t){const r=t.resolve;t.resolve=(...t)=>{const n=e.resolve(...t);return e.overrideDefault?n:r(...t)||n}}else o.positionResolvers.register($r(zr({},e),{id:e.id,name:e.id})),o.suggestionKinds.register({id:e.id,name:e.id,kind:[]})}if(r.customSuggestionKinds)for(const e of r.customSuggestionKinds()){if(null==(n=e.applyTo)||n.forEach((t=>{const r=o.suggestionKinds.getIfExists(t);r&&-1===r.kind.indexOf(e.id)&&r.kind.push(e.id)})),e.overrideDefault){const t=i.get(e.id);if(void 0!==t){t.suggestions=e.suggestionsResolver;continue}}i.register({id:e.id,name:e.id,suggestions:e.suggestionsResolver})}if(r.schemas){const e=i.get(se.Schemas),t=e.suggestions;e.suggestions=async(e,n)=>{const o=await t(e,n);if(!r.schemas)return[...o];const i=(await r.schemas.resolve()).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}.`,command:mr,kind:ue.Module,sortText:le.High}}));return[...o,...i]}}if(r.tables){const e=i.get(se.Tables),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a,s,l;const u=await t(e,n),c=gr(e.currentToken),d=(null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:vr)(c);return[...u,...(null!=(l=await(null==(s=null==(a=r.tables)?void 0:a.resolve)?void 0:s.call(a,d)))?l:[]).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}${e.completion===e.name?" $0":""}`,insertTextRules:ce.InsertAsSnippet,command:mr,kind:ue.Field,sortText:le.MediumHigh}}))]}}if(r.columns){const e=i.get(se.Columns),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a;const s=await t(e,n),l=gr(e.currentToken);let u;const c=null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:vr;l&&l.value&&(u=c(l));let d=[];if(u){const e=await(null==(a=r.columns)?void 0:a.resolve(u));d=e?e.map((e=>{var t;return{label:e.name,insertText:null!=(t=e.completion)?t:e.name,kind:ue.Field,sortText:le.High,detail:e.type,documentation:e.description}})):[]}return[...s,...d]}}}(t.id,r,i);const a=Wr.get(t.id),s=Hr.get(r),l=async(t,n,o,i)=>{const l=function(e,t,r,n="sql"){var o;let i=null,a=null;const s=e.editor.tokenize(null!=(o=t.getValue())?o:"",n);for(let o=0;o<s.length;o++){const l=s[o];if(!l.length&&a){const e={offset:0,type:ie.Whitespace,language:n,_tokenBrand:void 0};l.push(e)}for(let n=0;n<l.length;n++){const s=l[n];let u=l.length>n+1?l[n+1].offset+1:t.getLineLength(o+1)+1;const c={startLineNumber:o+1,startColumn:0===s.offset?0:s.offset+1,endLineNumber:o+1,endColumn:u},d=t.getValueInRange(c),p=new pr(s.type,d,c,a,null);e.Range.containsPosition(c,r)&&(i=p),a&&(a.next=p),a=p}}return i}(e,t,n,r),u=function(e,t){var r;const n=null==e?void 0:e.getPreviousNonWhiteSpaceToken(),o=null==e?void 0:e.getPreviousKeyword(),i=null==(r=null==e?void 0:e.getPreviousNonWhiteSpaceToken())?void 0:r.is(ie.Operator,"/"),a=t.list(),s=[];for(const t of a)t.resolve(e,null!=o?o:null,null!=n?n:null,Boolean(i))&&s.push(t.id);return 0===s.length?[ae.Unknown]:s}(l,a.positionResolvers),c=function(e,t){let r=[];for(let n=0;n<e.length;n++){const o=t.getIfExists(e[n]);o&&(r=r.concat(o.kind))}return r}(u,a.suggestionKinds);Ar("Statement position",!1,u),Ar("Suggestion kinds",!1,c);const d={position:n,currentToken:l,statementPosition:u,kind:c,range:e.Range.fromPositions(n)},p=await(async(e,t,r,n,o)=>{let i=[];const a=(null==t?void 0:t.isWhiteSpace())||(null==t?void 0:t.isParenthesis())||(null==t?void 0:t.isIdentifier())&&t.value.endsWith(".")||!(null==t?void 0:t.range)?e.Range.fromPositions(n.position):null==t?void 0:t.range;for(const t of[...new Set(r)]){const r=o.getIfExists(t);if(r){const t=await r.suggestions(cr(ur({},n),{range:a}),e);i=[...i,...t.map((e=>tr(e.label,a,ur({kind:e.kind},e))))]}}return Promise.resolve(i)})(e,l,c,d,s);return{suggestions:p}};e.languages.registerCompletionItemProvider(r,$r(zr({},i),{provideCompletionItems:l}))}};function Kr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Yr({children:e,onChange:t,query:r,width:n,height:o,editorLanguageDefinition:i}){const a=(0,ve.useRef)(r);(0,ve.useEffect)((()=>{a.current=r}),[r]);const s=(0,ve.useCallback)(((e,r)=>{const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Kr(e,t,r[t])}))}return e}({},a.current),i=null!=(i={rawQuery:!0,rawSql:e})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;t(n,r)}),[t]);return(0,ge.jsx)(qr,{width:n,height:o,query:r.rawSql,onChange:s,language:i,children:e})}var Xr=v(990);function Qr(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Jr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Qr(i,n,o,a,s,"next",e)}function s(e){Qr(i,n,o,a,s,"throw",e)}a(void 0)}))}}function Zr({db:e,query:t,onValidate:r,range:n}){var o;const[i,a]=(0,ve.useState)(),s=(0,xe.useTheme2)(),l=(0,ve.useMemo)((()=>(0,w.getValueFormat)("bytes")),[]),u=(0,ve.useMemo)((()=>({error:(0,$e.css)({color:s.colors.error.text,fontSize:s.typography.bodySmall.fontSize,fontFamily:s.typography.fontFamilyMonospace}),valid:(0,$e.css)({color:s.colors.success.text}),info:(0,$e.css)({color:s.colors.text.secondary})})),[s]),[c,d]=Ee(function(){var t=Jr((function*(t){var r;return""===(null===(r=t.rawSql)||void 0===r?void 0:r.trim())?null:yield e.validateQuery(t,n)}));return function(e){return t.apply(this,arguments)}}(),[e]),[]=(0,Xr.A)(Jr((function*(){const e=yield d(t);return e&&a(e),null})),1e3,[t,d]);if((0,ve.useEffect)((()=>{(null==i?void 0:i.isError)&&r(!1),(null==i?void 0:i.isValid)&&r(!0)}),[i,r]),!c.value&&!c.loading)return null;const p=(null===(o=c.value)||void 0===o?void 0:o.error)?function(e){const t=e.split(":");return t.length>2?t.slice(2).join(":"):e}(c.value.error):"";return(0,ge.jsxs)(ge.Fragment,{children:[c.loading&&(0,ge.jsxs)("div",{className:u.info,children:[(0,ge.jsx)(xe.Spinner,{inline:!0,size:"xs"})," Validating query..."]}),!c.loading&&c.value&&(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(ge.Fragment,{children:c.value.isValid&&c.value.statistics&&(0,ge.jsxs)("div",{className:u.valid,children:[(0,ge.jsx)(xe.Icon,{name:"check"})," This query will process"," ",(0,ge.jsx)("strong",{children:(0,w.formattedValueToString)(l(c.value.statistics.TotalBytesProcessed))})," ","when run."]})}),(0,ge.jsx)(ge.Fragment,{children:c.value.isError&&(0,ge.jsx)("div",{className:u.error,children:p})})]})]})}function en(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function tn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){en(e,t,r[t])}))}return e}function rn(e){var{showTools:t,onFormatCode:r,onExpand:n,isExpanded:o}=e,i=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["showTools","onFormatCode","onExpand","isExpanded"]);const a=(0,xe.useTheme2)(),[s,l]=(0,ve.useState)(),u=(0,ve.useMemo)((()=>({container:(0,$e.css)({border:`1px solid ${a.colors.border.medium}`,borderTop:"none",padding:a.spacing(.5,.5,.5,.5),display:"flex",flexGrow:1,justifyContent:"space-between",fontSize:a.typography.bodySmall.fontSize}),error:(0,$e.css)({color:a.colors.error.text,fontSize:a.typography.bodySmall.fontSize,fontFamily:a.typography.fontFamilyMonospace}),valid:(0,$e.css)({color:a.colors.success.text}),info:(0,$e.css)({color:a.colors.text.secondary}),hint:(0,$e.css)({color:a.colors.text.disabled,whiteSpace:"nowrap",cursor:"help"})})),[a]);let c={};return t||void 0!==s||(c={height:0,padding:0,visibility:"hidden"}),(0,ge.jsxs)("div",{className:u.container,style:c,children:[(0,ge.jsx)("div",{children:i.onValidate&&(0,ge.jsx)(Zr,(d=tn({},i),p={onValidate:e=>{l(e),i.onValidate(e)}},p=null!=p?p:{},Object.getOwnPropertyDescriptors?Object.defineProperties(d,Object.getOwnPropertyDescriptors(p)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(p)).forEach((function(e){Object.defineProperty(d,e,Object.getOwnPropertyDescriptor(p,e))})),d))}),t&&(0,ge.jsx)("div",{children:(0,ge.jsxs)(xe.HorizontalGroup,{spacing:"sm",children:[r&&(0,ge.jsx)(xe.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_query_formatted",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type}),r()},name:"brackets-curly",size:"xs",tooltip:"Format query"}),n&&(0,ge.jsx)(xe.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type,expanded:!o}),n(!o)},name:o?"angle-up":"angle-down",size:"xs",tooltip:o?"Collapse editor":"Expand editor"}),(0,ge.jsx)(xe.Tooltip,{content:"Hit CTRL/CMD+Return to run query",children:(0,ge.jsx)(xe.Icon,{className:u.hint,name:"keyboard"})})]})})]});var d,p}function nn({db:e,query:t,onChange:r,onRunQuery:n,onValidate:o,queryToValidate:i,range:a}){const s=(0,xe.useTheme2)(),l=(0,xe.useStyles2)(on),[u,c]=(0,ve.useState)(!1),[d,p]=Bt(),[f,h]=Bt(),g=(0,ve.useMemo)((()=>e.getEditorLanguageDefinition()),[e]),v=(n,s)=>(0,ge.jsx)(Yr,{editorLanguageDefinition:g,query:t,width:n,height:s?s-p.height:void 0,onChange:r,children:({formatQuery:t})=>(0,ge.jsx)("div",{ref:d,children:(0,ge.jsx)(rn,{db:e,query:i,onValidate:o,onFormatCode:t,showTools:!0,range:a,onExpand:c,isExpanded:u})})}),m=(e=!1)=>e?(0,ge.jsx)(Yt,{children:({width:e,height:t})=>v(e,t)}):(0,ge.jsx)("div",{ref:f,children:v()});return(0,ge.jsxs)(ge.Fragment,{children:[u?(0,ge.jsx)("div",{style:{width:h.width,height:h.height,background:s.colors.background.primary,display:"flex",alignItems:"center",justifyContent:"center"},children:"Editing in expanded code editor"}):m(),u&&(0,ge.jsx)(xe.Modal,{title:`Query ${t.refId}`,closeOnBackdropClick:!1,closeOnEscape:!1,className:l.modal,contentClassName:l.modalContent,isOpen:u,onDismiss:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=t.datasource)||void 0===e?void 0:e.type,expanded:!1}),c(!1)},children:m(!0)})]})}function on(e){return{modal:(0,$e.css)({width:"95vw",height:"95vh"}),modalContent:(0,$e.css)({height:"100%",paddingTop:0})}}const an=({children:e})=>ye().createElement(ct,{gap:.5,direction:"column"},e);var sn=v(7409);function ln(e){return sn.Ay.format(e).replace(/(\$ \{ .* \})|(\$ __)|(\$ \w+)/g,(e=>e.replace(/\s/g,"")))}function un({rawSql:e,datasourceType:t}){const[r,n]=Le(),o=(0,xe.useStyles2)(cn),i=(0,ge.jsxs)("div",{className:o.labelWrapper,children:[(0,ge.jsx)("span",{className:o.label,children:"Preview"}),(0,ge.jsx)(xe.IconButton,{tooltip:"Copy to clipboard",onClick:()=>(e=>{n(e),(0,pe.reportInteraction)("grafana_sql_preview_copied",{datasource:t})})(e),name:"copy"})]});return(0,ge.jsx)(xe.Field,{label:i,className:o.grow,children:(0,ge.jsx)(xe.CodeEditor,{language:"sql",height:80,value:ln(e),monacoOptions:{scrollbar:{vertical:"hidden"},scrollBeyondLastLine:!1},readOnly:!0,showMiniMap:!1})})}function cn(e){return{grow:(0,$e.css)({flexGrow:1}),label:(0,$e.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),labelWrapper:(0,$e.css)({display:"flex",justifyContent:"space-between",paddingBottom:e.spacing(.5)})}}function dn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function pn({query:e,onQueryChange:t,db:r}){const n=(0,ve.useCallback)((n=>{const o=(0,r.toRawSql)({sql:n,dataset:e.dataset,table:e.table,refId:e.refId}),i=(a=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){dn(e,t,r[t])}))}return e}({},e),s=null!=(s={sql:n,rawSql:o})?s:{},Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(s)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(s)).forEach((function(e){Object.defineProperty(a,e,Object.getOwnPropertyDescriptor(s,e))})),a);var a,s;t(i)}),[r,t,e]);return{onSqlChange:n}}const fn=ye().forwardRef((function({items:e,renderItem:t,onChange:r},n){return ye().createElement(ct,null,e.map(((n,o)=>ye().createElement("div",{key:o},t(n,(t=>((t,n)=>{const o=[...e];o[t]=n,r(o)})(o,t)),(()=>(t=>{const n=[...e];n.splice(t,1),r(n)})(o)))))),ye().createElement(xe.Button,{ref:n,onClick:()=>{const t=[...e,{}];r(t)},variant:"secondary",size:"md",icon:"plus","aria-label":"Add",type:"button"}))})),hn=({children:e})=>{const t=(0,xe.useStyles2)(vn),r=ve.Children.map(e,(e=>(0,ve.isValidElement)(e)&&e.props.invalid?(0,ve.cloneElement)(e,{className:(0,$e.cx)(e.props.className,t.invalidChild)}):e));return ye().createElement("div",{className:t.root},r)},gn=["","base","hovered","invalid","focused"],vn=()=>({root:(0,$e.css)({display:"flex","> *":{"&:not(:first-child)":{marginLeft:-1},"&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0},"&:not(:first-child):not(:last-child)":{borderRadius:0},position:"relative",zIndex:gn.indexOf("base"),"&:hover":{zIndex:gn.indexOf("hovered")},"&:focus-within":{zIndex:gn.indexOf("focused")}}}),invalidChild:(0,$e.css)({zIndex:gn.indexOf("invalid")})});var mn=Object.defineProperty,yn=Object.defineProperties,bn=Object.getOwnPropertyDescriptors,On=Object.getOwnPropertySymbols,En=Object.prototype.hasOwnProperty,Sn=Object.prototype.propertyIsEnumerable,wn=(e,t,r)=>t in e?mn(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Tn=e=>{var t=e,{className:r}=t,n=((e,t)=>{var r={};for(var n in e)En.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&On)for(var n of On(e))t.indexOf(n)<0&&Sn.call(e,n)&&(r[n]=e[n]);return r})(t,["className"]);const o=(0,xe.useStyles2)(xn);return ye().createElement(xe.Button,((e,t)=>yn(e,bn(t)))(((e,t)=>{for(var r in t||(t={}))En.call(t,r)&&wn(e,r,t[r]);if(On)for(var r of On(t))Sn.call(t,r)&&wn(e,r,t[r]);return e})({},n),{className:(0,$e.cx)(r,o.button)}))},xn=e=>({button:(0,$e.css)({paddingLeft:e.spacing(1.5),paddingRight:e.spacing(1.5)})});function _n(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Cn({sql:e,columns:t,onSqlChange:r}){const n=(0,ve.useCallback)((t=>{const n=t.map((e=>{var t;return Ce(null===(t=e.property)||void 0===t?void 0:t.name)})),o=(i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){_n(e,t,r[t])}))}return e}({},e),a=null!=(a={groupBy:n})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;r(o)}),[r,e]);return(0,ge.jsx)(fn,{items:e.groupBy,onChange:n,renderItem:Rn({options:t})})}function Rn({options:e}){return function(t,r,n){var o;return(0,ge.jsxs)(hn,{children:[(0,ge.jsx)(xe.Select,{value:(null===(o=t.property)||void 0===o?void 0:o.name)?(0,w.toOption)(t.property.name):null,"aria-label":"Group by",options:e,menuShouldPortal:!0,onChange:({value:e})=>e&&r(Ce(e))}),(0,ge.jsx)(Tn,{title:"Remove group by column",icon:"times",variant:"secondary",onClick:n})]})}}function In({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=pn({query:t,onQueryChange:r,db:n});return(0,ge.jsx)(Cn,{columns:e,sql:t.sql,onSqlChange:o})}function An(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function jn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){An(e,t,r[t])}))}return e}function Pn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Ln=[{description:"Sort by ascending",value:"ASC",icon:"sort-amount-up"},{description:"Sort by descending",value:"DESC",icon:"sort-amount-down"}];function kn({sql:e,onSqlChange:t,columns:r,showOffset:n}){var o,i;const a=(0,ve.useCallback)((r=>{const n=Pn(jn({},e),{orderByDirection:r});t(n)}),[t,e]),s=(0,ve.useCallback)((r=>{const n=Pn(jn({},e),{limit:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),l=(0,ve.useCallback)((r=>{const n=Pn(jn({},e),{offset:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),u=(0,ve.useCallback)((r=>{const n=Pn(jn({},e),{orderBy:(o=null==r?void 0:r.value,{type:Te.Property,property:{type:we.String,name:o}})});var o;null===r&&(n.orderByDirection=void 0),t(n)}),[t,e]);return(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(Et,{label:"Order by",width:25,children:(0,ge.jsxs)(hn,{children:[(0,ge.jsx)(xe.Select,{"aria-label":"Order by",options:r,value:(null===(o=e.orderBy)||void 0===o?void 0:o.property.name)?(0,w.toOption)(e.orderBy.property.name):null,isClearable:!0,menuShouldPortal:!0,onChange:u}),(0,ge.jsx)(xe.Space,{h:1.5}),(0,ge.jsx)(xe.RadioButtonGroup,{options:Ln,disabled:!(null==e||null===(i=e.orderBy)||void 0===i?void 0:i.property.name),value:e.orderByDirection,onChange:a})]})}),(0,ge.jsx)(Et,{label:"Limit",optional:!0,width:25,children:(0,ge.jsx)(xe.Input,{type:"number",min:0,id:(0,fe.uniqueId)("limit-"),value:e.limit||"",onChange:s})}),n&&(0,ge.jsx)(Et,{label:"Offset",optional:!0,width:25,children:(0,ge.jsx)(xe.Input,{type:"number",id:(0,fe.uniqueId)("offset-"),value:e.offset||"",onChange:l})})]})}function Nn({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=pn({query:t,onQueryChange:r,db:n});let i=[];if(e){var a,s;const r=null===(s=t.sql)||void 0===s||null===(a=s.columns)||void 0===a?void 0:a.map(((e,t)=>{var r,n;const o=e.name?`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>e.name))})`:null===(n=e.parameters)||void 0===n?void 0:n.map((e=>e.name));return{value:o,label:`${t+1} - ${o}`}}));i=[{value:"",label:"Selected columns",options:r,expanded:!0},...e]}return(0,ge.jsx)(kn,{sql:t.sql,onSqlChange:o,columns:i})}const Dn=["AVG","COUNT","MAX","MIN","SUM"],Fn=["$__time","$__timeEpoch","$__timeFilter","$__timeFrom","$__timeTo","$__timeGroup","$__timeGroupAlias","$__unixEpochFilter","$__unixEpochNanoFilter","$__unixEpochNanoFrom","$__unixEpochNanoTo","$__unixEpochGroup","$__unixEpochGroupAlias"];function Mn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Vn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Mn(e,t,r[t])}))}return e}function Un(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Bn={label:"*",value:"*"};function zn({sql:e,format:t,columns:r,onSqlChange:n,functions:o}){var i;const a=(0,xe.useStyles2)($n),s=[Bn,...r||[]],l=[];t===S.Timeseries&&(l.push({label:"time",value:"time"}),l.push({label:"value",value:"value"}));const u=(0,ve.useCallback)(((t,r)=>o=>{var i,a;let s=Vn({},t);(null===(i=t.parameters)||void 0===i?void 0:i.length)?s.parameters=t.parameters.map((e=>e.type===Te.FunctionParameter?Un(Vn({},e),{name:o.value}):e)):s.parameters=[{type:Te.FunctionParameter,name:o.value}];const l=Un(Vn({},e),{columns:null===(a=e.columns)||void 0===a?void 0:a.map(((e,t)=>t===r?s:e))});n(l)}),[n,e]),c=(0,ve.useCallback)(((t,r)=>o=>{var i;const a=Un(Vn({},t),{name:null==o?void 0:o.value}),s=Un(Vn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(s)}),[n,e]),d=(0,ve.useCallback)(((t,r)=>o=>{var i;let a=Vn({},t);var s;null!==o?a=Un(Vn({},t),{alias:`"${null==o||null===(s=o.value)||void 0===s?void 0:s.trim()}"`}):delete a.alias;const l=Un(Vn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(l)}),[n,e]),p=(0,ve.useCallback)((t=>()=>{const r=[...e.columns];r.splice(t,1);const o=Un(Vn({},e),{columns:r});n(o)}),[n,e]),f=(0,ve.useCallback)((()=>{const t=Un(Vn({},e),{columns:[...e.columns,Re()]});n(t)}),[n,e]);return(0,ge.jsxs)(ct,{gap:2,wrap:!0,direction:"column",children:[null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>(0,ge.jsx)("div",{children:(0,ge.jsxs)(ct,{gap:2,alignItems:"end",children:[(0,ge.jsx)(Et,{label:"Column",width:25,children:(0,ge.jsx)(xe.Select,{value:Wn(e),"data-testid":ze.components.SQLQueryEditor.selectColumn,options:s,inputId:`select-column-${t}-${(0,fe.uniqueId)()}`,menuShouldPortal:!0,allowCustomValue:!0,onChange:u(e,t)})}),(0,ge.jsx)(Et,{label:"Aggregation",optional:!0,width:25,children:(0,ge.jsx)(xe.Select,{value:e.name?(0,w.toOption)(e.name):null,inputId:`select-aggregation-${t}-${(0,fe.uniqueId)()}`,"data-testid":ze.components.SQLQueryEditor.selectAggregation,isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0,options:o,onChange:c(e,t)})}),(0,ge.jsx)(Et,{label:"Alias",optional:!0,width:15,children:(0,ge.jsx)(xe.Select,{value:e.alias?(0,w.toOption)(e.alias):null,inputId:`select-alias-${t}-${(0,fe.uniqueId)()}`,"data-testid":ze.components.SQLQueryEditor.selectAlias,options:l,onChange:d(e,t),isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0})}),(0,ge.jsx)(xe.Button,{title:"Remove column",type:"button",icon:"trash-alt",variant:"secondary",size:"md",onClick:p(t)})]})},t))),(0,ge.jsx)(xe.Button,{type:"button",onClick:f,variant:"secondary",title:"Add column",size:"md",icon:"plus",className:a.addButton})]})}const $n=()=>({addButton:(0,$e.css)({alignSelf:"flex-start"})});function Wn({parameters:e}){const t=null==e?void 0:e.find((e=>e.type===Te.FunctionParameter));return(null==t?void 0:t.name)?(0,w.toOption)(t.name):null}function Hn({fields:e,query:t,onQueryChange:r,db:n}){var o;const{onSqlChange:i}=pn({query:t,onQueryChange:r,db:n}),a=[...Dn,...(null===(o=n.functions)||void 0===o?void 0:o.call(n))||[]].map(w.toOption);return(0,ge.jsx)(zn,{columns:e,sql:t.sql,format:t.format,functions:a,onSqlChange:i})}var qn=v(1777);function Gn(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Kn(e){return Kn="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Kn(e)}function Yn(e){var t=function(e,t){if("object"!=Kn(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,"string");if("object"!=Kn(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"==Kn(t)?t:t+""}function Xn(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,Yn(n.key),n)}}function Qn(e,t,r){return t&&Xn(e.prototype,t),r&&Xn(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function Jn(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function Zn(e,t){if(t&&("object"==Kn(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return Jn(e)}function eo(e){return eo=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},eo(e)}function to(e,t){return to=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},to(e,t)}function ro(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&to(e,t)}function no(e,t,r){return(t=Yn(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function oo(e){if(Array.isArray(e))return e}function io(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=Array(t);r<t;r++)n[r]=e[r];return n}function ao(e,t){if(e){if("string"==typeof e)return io(e,t);var r={}.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?io(e,t):void 0}}function so(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function lo(e,t){return oo(e)||function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,s=[],l=!0,u=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;l=!1}else for(;!(l=(n=i.call(r)).done)&&(s.push(n.value),s.length!==t);l=!0);}catch(e){u=!0,o=e}finally{try{if(!l&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(u)throw o}}return s}}(e,t)||ao(e,t)||so()}function uo(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function co(e){return function(e){if(Array.isArray(e))return io(e)}(e)||uo(e)||ao(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var po="delete",fo=5,ho=1<<fo,go=ho-1,vo={};function mo(e){e&&(e.value=!0)}function yo(){}function bo(e){return void 0===e.size&&(e.size=e.__iterate(Eo)),e.size}function Oo(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?bo(e)+t:t}function Eo(){return!0}function So(e,t,r){return(0===e&&!_o(e)||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function wo(e,t){return xo(e,t,0)}function To(e,t){return xo(e,t,t)}function xo(e,t,r){return void 0===e?r:_o(e)?t===1/0?t:0|Math.max(0,t+e):void 0===t||t===e?e:0|Math.min(t,e)}function _o(e){return e<0||0===e&&1/e==-1/0}var Co="@@__IMMUTABLE_ITERABLE__@@";function Ro(e){return Boolean(e&&e[Co])}var Io="@@__IMMUTABLE_KEYED__@@";function Ao(e){return Boolean(e&&e[Io])}var jo="@@__IMMUTABLE_INDEXED__@@";function Po(e){return Boolean(e&&e[jo])}function Lo(e){return Ao(e)||Po(e)}var ko=function(e){return Ro(e)?e:ai(e)},No=function(e){function t(e){return Ao(e)?e:si(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(ko),Do=function(e){function t(e){return Po(e)?e:li(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(ko),Fo=function(e){function t(e){return Ro(e)&&!Lo(e)?e:ui(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(ko);ko.Keyed=No,ko.Indexed=Do,ko.Set=Fo;var Mo="@@__IMMUTABLE_SEQ__@@";function Vo(e){return Boolean(e&&e[Mo])}var Uo="@@__IMMUTABLE_RECORD__@@";function Bo(e){return Boolean(e&&e[Uo])}function zo(e){return Ro(e)||Bo(e)}var $o="@@__IMMUTABLE_ORDERED__@@";function Wo(e){return Boolean(e&&e[$o])}var Ho=0,qo=1,Go=2,Ko="function"==typeof Symbol&&Symbol.iterator,Yo="@@iterator",Xo=Ko||Yo,Qo=function(e){this.next=e};function Jo(e,t,r,n){var o=0===e?t:1===e?r:[t,r];return n?n.value=o:n={value:o,done:!1},n}function Zo(){return{value:void 0,done:!0}}function ei(e){return!!Array.isArray(e)||!!ni(e)}function ti(e){return e&&"function"==typeof e.next}function ri(e){var t=ni(e);return t&&t.call(e)}function ni(e){var t=e&&(Ko&&e[Ko]||e[Yo]);if("function"==typeof t)return t}Qo.prototype.toString=function(){return"[Iterator]"},Qo.KEYS=Ho,Qo.VALUES=qo,Qo.ENTRIES=Go,Qo.prototype.inspect=Qo.prototype.toSource=function(){return this.toString()},Qo.prototype[Xo]=function(){return this};var oi=Object.prototype.hasOwnProperty;function ii(e){return!(!Array.isArray(e)&&"string"!=typeof e)||e&&"object"==typeof e&&Number.isInteger(e.length)&&e.length>=0&&(0===e.length?1===Object.keys(e).length:e.hasOwnProperty(e.length-1))}var ai=function(e){function t(e){return null==e?hi():zo(e)?e.toSeq():function(e){var t,r,n=mi(e);if(n)return(r=ni(t=e))&&r===t.entries?n.fromEntrySeq():function(e){var t=ni(e);return t&&t===e.keys}(e)?n.toSetSeq():n;if("object"==typeof e)return new di(e);throw new TypeError("Expected Array or collection object of values, or keyed object: "+e)}(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq {","}")},t.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},t.prototype.__iterate=function(e,t){var r=this._cache;if(r){for(var n=r.length,o=0;o!==n;){var i=r[t?n-++o:o++];if(!1===e(i[1],i[0],this))break}return o}return this.__iterateUncached(e,t)},t.prototype.__iterator=function(e,t){var r=this._cache;if(r){var n=r.length,o=0;return new Qo((function(){if(o===n)return{value:void 0,done:!0};var i=r[t?n-++o:o++];return Jo(e,i[0],i[1])}))}return this.__iteratorUncached(e,t)},t}(ko),si=function(e){function t(e){return null==e?hi().toKeyedSeq():Ro(e)?Ao(e)?e.toSeq():e.fromEntrySeq():Bo(e)?e.toSeq():gi(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toKeyedSeq=function(){return this},t}(ai),li=function(e){function t(e){return null==e?hi():Ro(e)?Ao(e)?e.entrySeq():e.toIndexedSeq():Bo(e)?e.toSeq().entrySeq():vi(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toIndexedSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq [","]")},t}(ai),ui=function(e){function t(e){return(Ro(e)&&!Lo(e)?e:li(e)).toSetSeq()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toSetSeq=function(){return this},t}(ai);ai.isSeq=Vo,ai.Keyed=si,ai.Set=ui,ai.Indexed=li,ai.prototype[Mo]=!0;var ci=function(e){function t(e){this._array=e,this.size=e.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this.has(e)?this._array[Oo(this,e)]:t},t.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length,o=0;o!==n;){var i=t?n-++o:o++;if(!1===e(r[i],i,this))break}return o},t.prototype.__iterator=function(e,t){var r=this._array,n=r.length,o=0;return new Qo((function(){if(o===n)return{value:void 0,done:!0};var i=t?n-++o:o++;return Jo(e,i,r[i])}))},t}(li),di=function(e){function t(e){var t=Object.keys(e).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e):[]);this._object=e,this._keys=t,this.size=t.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},t.prototype.has=function(e){return oi.call(this._object,e)},t.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,o=n.length,i=0;i!==o;){var a=n[t?o-++i:i++];if(!1===e(r[a],a,this))break}return i},t.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,o=n.length,i=0;return new Qo((function(){if(i===o)return{value:void 0,done:!0};var a=n[t?o-++i:i++];return Jo(e,a,r[a])}))},t}(si);di.prototype[$o]=!0;var pi,fi=function(e){function t(e){this._collection=e,this.size=e.length||e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=ri(this._collection),n=0;if(ti(r))for(var o;!(o=r.next()).done&&!1!==e(o.value,n++,this););return n},t.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=ri(this._collection);if(!ti(r))return new Qo(Zo);var n=0;return new Qo((function(){var t=r.next();return t.done?t:Jo(e,n++,t.value)}))},t}(li);function hi(){return pi||(pi=new ci([]))}function gi(e){var t=mi(e);if(t)return t.fromEntrySeq();if("object"==typeof e)return new di(e);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+e)}function vi(e){var t=mi(e);if(t)return t;throw new TypeError("Expected Array or collection object of values: "+e)}function mi(e){return ii(e)?new ci(e):ei(e)?new fi(e):void 0}var yi="@@__IMMUTABLE_MAP__@@";function bi(e){return Boolean(e&&e[yi])}function Oi(e){return bi(e)&&Wo(e)}function Ei(e){return Boolean(e&&"function"==typeof e.equals&&"function"==typeof e.hashCode)}function Si(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!!(Ei(e)&&Ei(t)&&e.equals(t))}var wi="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function Ti(e){return e>>>1&1073741824|3221225471&e}var xi=Object.prototype.valueOf;function _i(e){if(null==e)return Ci(e);if("function"==typeof e.hashCode)return Ti(e.hashCode(e));var t,r,n,o=(t=e).valueOf!==xi&&"function"==typeof t.valueOf?t.valueOf(t):t;if(null==o)return Ci(o);switch(typeof o){case"boolean":return o?1108378657:1108378656;case"number":return function(e){if(e!=e||e===1/0)return 0;var t=0|e;for(t!==e&&(t^=4294967295*e);e>4294967295;)t^=e/=4294967295;return Ti(t)}(o);case"string":return o.length>Fi?(void 0===(n=Ui[r=o])&&(n=Ri(r),Vi===Mi&&(Vi=0,Ui={}),Vi++,Ui[r]=n),n):Ri(o);case"object":case"function":return function(e){var t;if(Li&&void 0!==(t=Pi.get(e)))return t;if(void 0!==(t=e[Di]))return t;if(!Ai){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[Di]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=ji(),Li)Pi.set(e,t);else{if(void 0!==Ii&&!1===Ii(e))throw new Error("Non-extensible objects are not allowed as keys.");if(Ai)Object.defineProperty(e,Di,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[Di]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[Di]=t}}return t}(o);case"symbol":return function(e){var t=ki[e];return void 0!==t||(t=ji(),ki[e]=t),t}(o);default:if("function"==typeof o.toString)return Ri(o.toString());throw new Error("Value type "+typeof o+" cannot be hashed.")}}function Ci(e){return null===e?1108378658:1108378659}function Ri(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return Ti(t)}var Ii=Object.isExtensible,Ai=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();function ji(){var e=++Ni;return 1073741824&Ni&&(Ni=0),e}var Pi,Li="function"==typeof WeakMap;Li&&(Pi=new WeakMap);var ki=Object.create(null),Ni=0,Di="__immutablehash__";"function"==typeof Symbol&&(Di=Symbol(Di));var Fi=16,Mi=255,Vi=0,Ui={},Bi=function(e){function t(e,t){this._iter=e,this._useKeys=t,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this._iter.get(e,t)},t.prototype.has=function(e){return this._iter.has(e)},t.prototype.valueSeq=function(){return this._iter.valueSeq()},t.prototype.reverse=function(){var e=this,t=Gi(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},t.prototype.map=function(e,t){var r=this,n=qi(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t,n){return e(t,n,r)}),t)},t.prototype.__iterator=function(e,t){return this._iter.__iterator(e,t)},t}(si);Bi.prototype[$o]=!0;var zi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.includes=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this,n=0;return t&&bo(this),this._iter.__iterate((function(o){return e(o,t?r.size-++n:n++,r)}),t)},t.prototype.__iterator=function(e,t){var r=this,n=this._iter.__iterator(qo,t),o=0;return t&&bo(this),new Qo((function(){var i=n.next();return i.done?i:Jo(e,t?r.size-++o:o++,i.value,i)}))},t}(li),$i=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.has=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(qo,t);return new Qo((function(){var t=r.next();return t.done?t:Jo(e,t.value,t.value,t)}))},t}(ui),Wi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.entrySeq=function(){return this._iter.toSeq()},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){if(t){na(t);var n=Ro(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(qo,t);return new Qo((function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){na(n);var o=Ro(n);return Jo(e,o?n.get(0):n[0],o?n.get(1):n[1],t)}}}))},t}(si);function Hi(e){var t=ia(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=aa,t.__iterateUncached=function(t,r){var n=this;return e.__iterate((function(e,r){return!1!==t(r,e,n)}),r)},t.__iteratorUncached=function(t,r){if(t===Go){var n=e.__iterator(t,r);return new Qo((function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e}))}return e.__iterator(t===qo?Ho:qo,r)},t}function qi(e,t,r){var n=ia(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,o){var i=e.get(n,vo);return i===vo?o:t.call(r,i,n,e)},n.__iterateUncached=function(n,o){var i=this;return e.__iterate((function(e,o,a){return!1!==n(t.call(r,e,o,a),o,i)}),o)},n.__iteratorUncached=function(n,o){var i=e.__iterator(Go,o);return new Qo((function(){var o=i.next();if(o.done)return o;var a=o.value,s=a[0];return Jo(n,s,t.call(r,a[1],s,e),o)}))},n}function Gi(e,t){var r=this,n=ia(e);return n._iter=e,n.size=e.size,n.reverse=function(){return e},e.flip&&(n.flip=function(){var t=Hi(e);return t.reverse=function(){return e.flip()},t}),n.get=function(r,n){return e.get(t?r:-1-r,n)},n.has=function(r){return e.has(t?r:-1-r)},n.includes=function(t){return e.includes(t)},n.cacheResult=aa,n.__iterate=function(r,n){var o=this,i=0;return n&&bo(e),e.__iterate((function(e,a){return r(e,t?a:n?o.size-++i:i++,o)}),!n)},n.__iterator=function(n,o){var i=0;o&&bo(e);var a=e.__iterator(Go,!o);return new Qo((function(){var e=a.next();if(e.done)return e;var s=e.value;return Jo(n,t?s[0]:o?r.size-++i:i++,s[1],e)}))},n}function Ki(e,t,r,n){var o=ia(e);return n&&(o.has=function(n){var o=e.get(n,vo);return o!==vo&&!!t.call(r,o,n,e)},o.get=function(n,o){var i=e.get(n,vo);return i!==vo&&t.call(r,i,n,e)?i:o}),o.__iterateUncached=function(o,i){var a=this,s=0;return e.__iterate((function(e,i,l){if(t.call(r,e,i,l))return s++,o(e,n?i:s-1,a)}),i),s},o.__iteratorUncached=function(o,i){var a=e.__iterator(Go,i),s=0;return new Qo((function(){for(;;){var i=a.next();if(i.done)return i;var l=i.value,u=l[0],c=l[1];if(t.call(r,c,u,e))return Jo(o,n?u:s++,c,i)}}))},o}function Yi(e,t,r,n){var o=e.size;if(So(t,r,o))return e;if(void 0===o&&(t<0||r<0))return Yi(e.toSeq().cacheResult(),t,r,n);var i,a=wo(t,o),s=To(r,o)-a;s==s&&(i=s<0?0:s);var l=ia(e);return l.size=0===i?i:e.size&&i||void 0,!n&&Vo(e)&&i>=0&&(l.get=function(t,r){return(t=Oo(this,t))>=0&&t<i?e.get(t+a,r):r}),l.__iterateUncached=function(t,r){var o=this;if(0===i)return 0;if(r)return this.cacheResult().__iterate(t,r);var s=0,l=!0,u=0;return e.__iterate((function(e,r){if(!l||!(l=s++<a))return u++,!1!==t(e,n?r:u-1,o)&&u!==i})),u},l.__iteratorUncached=function(t,r){if(0!==i&&r)return this.cacheResult().__iterator(t,r);if(0===i)return new Qo(Zo);var o=e.__iterator(t,r),s=0,l=0;return new Qo((function(){for(;s++<a;)o.next();if(++l>i)return{value:void 0,done:!0};var e=o.next();return n||t===qo||e.done?e:Jo(t,l-1,t===Ho?void 0:e.value[1],e)}))},l}function Xi(e,t,r,n){var o=ia(e);return o.__iterateUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterate(o,i);var s=!0,l=0;return e.__iterate((function(e,i,u){if(!s||!(s=t.call(r,e,i,u)))return l++,o(e,n?i:l-1,a)})),l},o.__iteratorUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterator(o,i);var s=e.__iterator(Go,i),l=!0,u=0;return new Qo((function(){var e,i,c;do{if((e=s.next()).done)return n||o===qo?e:Jo(o,u++,o===Ho?void 0:e.value[1],e);var d=e.value;i=d[0],c=d[1],l&&(l=t.call(r,c,i,a))}while(l);return o===Go?e:Jo(o,i,c,e)}))},o}function Qi(e,t,r){var n=ia(e);return n.__iterateUncached=function(o,i){if(i)return this.cacheResult().__iterate(o,i);var a=0,s=!1;return function e(l,u){l.__iterate((function(i,l){return(!t||u<t)&&Ro(i)?e(i,u+1):(a++,!1===o(i,r?l:a-1,n)&&(s=!0)),!s}),i)}(e,0),a},n.__iteratorUncached=function(n,o){if(o)return this.cacheResult().__iterator(n,o);var i=e.__iterator(n,o),a=[],s=0;return new Qo((function(){for(;i;){var e=i.next();if(!1===e.done){var l=e.value;if(n===Go&&(l=l[1]),t&&!(a.length<t)||!Ro(l))return r?e:Jo(n,s++,l,e);a.push(i),i=l.__iterator(n,o)}else i=a.pop()}return{value:void 0,done:!0}}))},n}function Ji(e,t,r){t||(t=sa);var n=Ao(e),o=0,i=e.toSeq().map((function(t,n){return[n,t,o++,r?r(t,n,e):t]})).valueSeq().toArray();return i.sort((function(e,r){return t(e[3],r[3])||e[2]-r[2]})).forEach(n?function(e,t){i[t].length=2}:function(e,t){i[t]=e[1]}),n?si(i):Po(e)?li(i):ui(i)}function Zi(e,t,r){if(t||(t=sa),r){var n=e.toSeq().map((function(t,n){return[t,r(t,n,e)]})).reduce((function(e,r){return ea(t,e[1],r[1])?r:e}));return n&&n[0]}return e.reduce((function(e,r){return ea(t,e,r)?r:e}))}function ea(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function ta(e,t,r,n){var o=ia(e),i=new ci(r).map((function(e){return e.size}));return o.size=n?i.max():i.min(),o.__iterate=function(e,t){for(var r,n=this.__iterator(qo,t),o=0;!(r=n.next()).done&&!1!==e(r.value,o++,this););return o},o.__iteratorUncached=function(e,o){var i=r.map((function(e){return e=ko(e),ri(o?e.reverse():e)})),a=0,s=!1;return new Qo((function(){var r;return s||(r=i.map((function(e){return e.next()})),s=n?r.every((function(e){return e.done})):r.some((function(e){return e.done}))),s?{value:void 0,done:!0}:Jo(e,a++,t.apply(null,r.map((function(e){return e.value}))))}))},o}function ra(e,t){return e===t?e:Vo(e)?t:e.constructor(t)}function na(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function oa(e){return Ao(e)?No:Po(e)?Do:Fo}function ia(e){return Object.create((Ao(e)?si:Po(e)?li:ui).prototype)}function aa(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):ai.prototype.cacheResult.call(this)}function sa(e,t){return void 0===e&&void 0===t?0:void 0===e?1:void 0===t?-1:e>t?1:e<t?-1:0}function la(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),o=0;o<r;o++)n[o]=e[o+t];return n}function ua(e,t){if(!e)throw new Error(t)}function ca(e){ua(e!==1/0,"Cannot perform this action with an infinite size.")}function da(e){if(ii(e)&&"string"!=typeof e)return e;if(Wo(e))return e.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+e)}zi.prototype.cacheResult=Bi.prototype.cacheResult=$i.prototype.cacheResult=Wi.prototype.cacheResult=aa;var pa=Object.prototype.toString;function fa(e){if(!e||"object"!=typeof e||"[object Object]"!==pa.call(e))return!1;var t=Object.getPrototypeOf(e);if(null===t)return!0;for(var r=t,n=Object.getPrototypeOf(t);null!==n;)r=n,n=Object.getPrototypeOf(r);return r===t}function ha(e){return"object"==typeof e&&(zo(e)||Array.isArray(e)||fa(e))}function ga(e){try{return"string"==typeof e?JSON.stringify(e):String(e)}catch(t){return JSON.stringify(e)}}function va(e,t){return zo(e)?e.has(t):ha(e)&&oi.call(e,t)}function ma(e,t,r){return zo(e)?e.get(t,r):va(e,t)?"function"==typeof e.get?e.get(t):e[t]:r}function ya(e){if(Array.isArray(e))return la(e);var t={};for(var r in e)oi.call(e,r)&&(t[r]=e[r]);return t}function ba(e,t){if(!ha(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(zo(e)){if(!e.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+e);return e.remove(t)}if(!oi.call(e,t))return e;var r=ya(e);return Array.isArray(r)?r.splice(t,1):delete r[t],r}function Oa(e,t,r){if(!ha(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(zo(e)){if(!e.set)throw new TypeError("Cannot update immutable value without .set() method: "+e);return e.set(t,r)}if(oi.call(e,t)&&r===e[t])return e;var n=ya(e);return n[t]=r,n}function Ea(e,t,r,n){n||(n=r,r=void 0);var o=Sa(zo(e),e,da(t),0,r,n);return o===vo?r:o}function Sa(e,t,r,n,o,i){var a=t===vo;if(n===r.length){var s=a?o:t,l=i(s);return l===s?t:l}if(!a&&!ha(t))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(ga)+"]: "+t);var u=r[n],c=a?vo:ma(t,u,vo),d=Sa(c===vo?e:zo(c),c,r,n+1,o,i);return d===c?t:d===vo?ba(t,u):Oa(a?e?ts():{}:t,u,d)}function wa(e,t,r){return Ea(e,t,vo,(function(){return r}))}function Ta(e,t){return wa(this,e,t)}function xa(e,t){return Ea(e,t,(function(){return vo}))}function _a(e){return xa(this,e)}function Ca(e,t,r,n){return Ea(e,[t],r,n)}function Ra(e,t,r){return 1===arguments.length?e(this):Ca(this,e,t,r)}function Ia(e,t,r){return Ea(this,e,t,r)}function Aa(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Pa(this,e)}function ja(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];if("function"!=typeof e)throw new TypeError("Invalid merger function: "+e);return Pa(this,t,e)}function Pa(e,t,r){for(var n=[],o=0;o<t.length;o++){var i=No(t[o]);0!==i.size&&n.push(i)}return 0===n.length?e:0!==e.toSeq().size||e.__ownerID||1!==n.length?e.withMutations((function(e){for(var t=r?function(t,n){Ca(e,n,vo,(function(e){return e===vo?t:r(e,t,n)}))}:function(t,r){e.set(r,t)},o=0;o<n.length;o++)n[o].forEach(t)})):e.constructor(n[0])}function La(e,t,r){return ka(e,t,function(e){return function t(r,n,o){return ha(r)&&ha(n)&&(i=n,a=ai(r),s=ai(i),Po(a)===Po(s)&&Ao(a)===Ao(s))?ka(r,[n],t):e?e(r,n,o):n;var i,a,s}}(r))}function ka(e,t,r){if(!ha(e))throw new TypeError("Cannot merge into non-data-structure value: "+e);if(zo(e))return"function"==typeof r&&e.mergeWith?e.mergeWith.apply(e,[r].concat(t)):e.merge?e.merge.apply(e,t):e.concat.apply(e,t);for(var n=Array.isArray(e),o=e,i=n?Do:No,a=n?function(t){o===e&&(o=ya(o)),o.push(t)}:function(t,n){var i=oi.call(o,n),a=i&&r?r(o[n],t,n):t;i&&a===o[n]||(o===e&&(o=ya(o)),o[n]=a)},s=0;s<t.length;s++)i(t[s]).forEach(a);return o}function Na(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return La(this,e)}function Da(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return La(this,t,e)}function Fa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Ea(this,e,ts(),(function(e){return ka(e,t)}))}function Ma(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Ea(this,e,ts(),(function(e){return La(e,t)}))}function Va(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this}function Ua(){return this.__ownerID?this:this.__ensureOwner(new yo)}function Ba(){return this.__ensureOwner()}function za(){return this.__altered}var $a=function(e){function t(t){return null==t?ts():bi(t)&&!Wo(t)?t:ts().withMutations((function(r){var n=e(t);ca(n.size),n.forEach((function(e,t){return r.set(t,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return ts().withMutations((function(t){for(var r=0;r<e.length;r+=2){if(r+1>=e.length)throw new Error("Missing value for key: "+e[r]);t.set(e[r],e[r+1])}}))},t.prototype.toString=function(){return this.__toString("Map {","}")},t.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},t.prototype.set=function(e,t){return rs(this,e,t)},t.prototype.remove=function(e){return rs(this,e,vo)},t.prototype.deleteAll=function(e){var t=ko(e);return 0===t.size?this:this.withMutations((function(e){t.forEach((function(t){return e.remove(t)}))}))},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):ts()},t.prototype.sort=function(e){return Cs(Ji(this,e))},t.prototype.sortBy=function(e,t){return Cs(Ji(this,t,e))},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){n.forEach((function(o,i){n.set(i,e.call(t,o,i,r))}))}))},t.prototype.__iterator=function(e,t){return new Qa(this,e,t)},t.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate((function(t){return n++,e(t[1],t[0],r)}),t),n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?es(this.size,this._root,e,this.__hash):0===this.size?ts():(this.__ownerID=e,this.__altered=!1,this)},t}(No);$a.isMap=bi;var Wa=$a.prototype;Wa[yi]=!0,Wa[po]=Wa.remove,Wa.removeAll=Wa.deleteAll,Wa.setIn=Ta,Wa.removeIn=Wa.deleteIn=_a,Wa.update=Ra,Wa.updateIn=Ia,Wa.merge=Wa.concat=Aa,Wa.mergeWith=ja,Wa.mergeDeep=Na,Wa.mergeDeepWith=Da,Wa.mergeIn=Fa,Wa.mergeDeepIn=Ma,Wa.withMutations=Va,Wa.wasAltered=za,Wa.asImmutable=Ba,Wa["@@transducer/init"]=Wa.asMutable=Ua,Wa["@@transducer/step"]=function(e,t){return e.set(t[0],t[1])},Wa["@@transducer/result"]=function(e){return e.asImmutable()};var Ha=function(e,t){this.ownerID=e,this.entries=t};Ha.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(Si(r,o[i][0]))return o[i][1];return n},Ha.prototype.update=function(e,t,r,n,o,i,a){for(var s=o===vo,l=this.entries,u=0,c=l.length;u<c&&!Si(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(mo(a),(s||!d)&&mo(i),!s||1!==l.length){if(!d&&!s&&l.length>=ls)return function(e,t,r,n){e||(e=new yo);for(var o=new Ya(e,_i(r),[r,n]),i=0;i<t.length;i++){var a=t[i];o=o.update(e,0,void 0,a[0],a[1])}return o}(e,l,n,o);var p=e&&e===this.ownerID,f=p?l:la(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Ha(e,f)}};var qa=function(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r};qa.prototype.get=function(e,t,r,n){void 0===t&&(t=_i(r));var o=1<<((0===e?t:t>>>e)&go),i=this.bitmap;return i&o?this.nodes[as(i&o-1)].get(e+fo,t,r,n):n},qa.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=_i(n));var s=(0===t?r:r>>>t)&go,l=1<<s,u=this.bitmap,c=!!(u&l);if(!c&&o===vo)return this;var d=as(u&l-1),p=this.nodes,f=c?p[d]:void 0,h=ns(f,e,t+fo,r,n,o,i,a);if(h===f)return this;if(!c&&h&&p.length>=us)return function(e,t,r,n,o){for(var i=0,a=new Array(ho),s=0;0!==r;s++,r>>>=1)a[s]=1&r?t[i++]:void 0;return a[n]=o,new Ga(e,i+1,a)}(e,p,u,s,h);if(c&&!h&&2===p.length&&os(p[1^d]))return p[1^d];if(c&&h&&1===p.length&&os(h))return h;var g=e&&e===this.ownerID,v=c?h?u:u^l:u|l,m=c?h?ss(p,d,h,g):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var o=new Array(n),i=0,a=0;a<n;a++)a===t&&(i=1),o[a]=e[a+i];return o}(p,d,g):function(e,t,r,n){var o=e.length+1;if(n&&t+1===o)return e[t]=r,e;for(var i=new Array(o),a=0,s=0;s<o;s++)s===t?(i[s]=r,a=-1):i[s]=e[s+a];return i}(p,d,h,g);return g?(this.bitmap=v,this.nodes=m,this):new qa(e,v,m)};var Ga=function(e,t,r){this.ownerID=e,this.count=t,this.nodes=r};Ga.prototype.get=function(e,t,r,n){void 0===t&&(t=_i(r));var o=(0===e?t:t>>>e)&go,i=this.nodes[o];return i?i.get(e+fo,t,r,n):n},Ga.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=_i(n));var s=(0===t?r:r>>>t)&go,l=o===vo,u=this.nodes,c=u[s];if(l&&!c)return this;var d=ns(c,e,t+fo,r,n,o,i,a);if(d===c)return this;var p=this.count;if(c){if(!d&&--p<cs)return function(e,t,r,n){for(var o=0,i=0,a=new Array(r),s=0,l=1,u=t.length;s<u;s++,l<<=1){var c=t[s];void 0!==c&&s!==n&&(o|=l,a[i++]=c)}return new qa(e,o,a)}(e,u,p,s)}else p++;var f=e&&e===this.ownerID,h=ss(u,s,d,f);return f?(this.count=p,this.nodes=h,this):new Ga(e,p,h)};var Ka=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r};Ka.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(Si(r,o[i][0]))return o[i][1];return n},Ka.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=_i(n));var s=o===vo;if(r!==this.keyHash)return s?this:(mo(a),mo(i),is(this,e,t,r,[n,o]));for(var l=this.entries,u=0,c=l.length;u<c&&!Si(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(mo(a),(s||!d)&&mo(i),s&&2===c)return new Ya(e,this.keyHash,l[1^u]);var p=e&&e===this.ownerID,f=p?l:la(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Ka(e,this.keyHash,f)};var Ya=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r};Ya.prototype.get=function(e,t,r,n){return Si(r,this.entry[0])?this.entry[1]:n},Ya.prototype.update=function(e,t,r,n,o,i,a){var s=o===vo,l=Si(n,this.entry[0]);return(l?o===this.entry[1]:s)?this:(mo(a),s?void mo(i):l?e&&e===this.ownerID?(this.entry[1]=o,this):new Ya(e,this.keyHash,[n,o]):(mo(i),is(this,e,t,_i(n),[n,o])))},Ha.prototype.iterate=Ka.prototype.iterate=function(e,t){for(var r=this.entries,n=0,o=r.length-1;n<=o;n++)if(!1===e(r[t?o-n:n]))return!1},qa.prototype.iterate=Ga.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,o=r.length-1;n<=o;n++){var i=r[t?o-n:n];if(i&&!1===i.iterate(e,t))return!1}},Ya.prototype.iterate=function(e,t){return e(this.entry)};var Xa,Qa=function(e){function t(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&Za(e._root)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r=t.node,n=t.index++,o=void 0;if(r.entry){if(0===n)return Ja(e,r.entry)}else if(r.entries){if(n<=(o=r.entries.length-1))return Ja(e,r.entries[this._reverse?o-n:n])}else if(n<=(o=r.nodes.length-1)){var i=r.nodes[this._reverse?o-n:n];if(i){if(i.entry)return Ja(e,i.entry);t=this._stack=Za(i,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}},t}(Qo);function Ja(e,t){return Jo(e,t[0],t[1])}function Za(e,t){return{node:e,index:0,__prev:t}}function es(e,t,r,n){var o=Object.create(Wa);return o.size=e,o._root=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function ts(){return Xa||(Xa=es(0))}function rs(e,t,r){var n,o;if(e._root){var i={value:!1},a={value:!1};if(n=ns(e._root,e.__ownerID,0,void 0,t,r,i,a),!a.value)return e;o=e.size+(i.value?r===vo?-1:1:0)}else{if(r===vo)return e;o=1,n=new Ha(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=o,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?es(o,n):ts()}function ns(e,t,r,n,o,i,a,s){return e?e.update(t,r,n,o,i,a,s):i===vo?e:(mo(s),mo(a),new Ya(t,n,[o,i]))}function os(e){return e.constructor===Ya||e.constructor===Ka}function is(e,t,r,n,o){if(e.keyHash===n)return new Ka(t,n,[e.entry,o]);var i,a=(0===r?e.keyHash:e.keyHash>>>r)&go,s=(0===r?n:n>>>r)&go,l=a===s?[is(e,t,r+fo,n,o)]:(i=new Ya(t,n,o),a<s?[e,i]:[i,e]);return new qa(t,1<<a|1<<s,l)}function as(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,127&(e+=e>>8)+(e>>16)}function ss(e,t,r,n){var o=n?e:la(e);return o[t]=r,o}var ls=ho/4,us=ho/2,cs=ho/4,ds="@@__IMMUTABLE_LIST__@@";function ps(e){return Boolean(e&&e[ds])}var fs=function(e){function t(t){var r=Os();if(null==t)return r;if(ps(t))return t;var n=e(t),o=n.size;return 0===o?r:(ca(o),o>0&&o<ho?bs(0,o,fo,null,new gs(n.toArray())):r.withMutations((function(e){e.setSize(o),n.forEach((function(t,r){return e.set(r,t)}))})))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("List [","]")},t.prototype.get=function(e,t){if((e=Oo(this,e))>=0&&e<this.size){var r=ws(this,e+=this._origin);return r&&r.array[e&go]}return t},t.prototype.set=function(e,t){return function(e,t,r){if((t=Oo(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations((function(e){t<0?Ts(e,t).set(0,r):Ts(e,0,t+1).set(t,r)}));t+=e._origin;var n=e._tail,o=e._root,i={value:!1};return t>=xs(e._capacity)?n=Es(n,e.__ownerID,0,t,r,i):o=Es(o,e.__ownerID,e._level,t,r,i),i.value?e.__ownerID?(e._root=o,e._tail=n,e.__hash=void 0,e.__altered=!0,e):bs(e._origin,e._capacity,e._level,o,n):e}(this,e,t)},t.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},t.prototype.insert=function(e,t){return this.splice(e,0,t)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=fo,this._root=this._tail=this.__hash=void 0,this.__altered=!0,this):Os()},t.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations((function(r){Ts(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])}))},t.prototype.pop=function(){return Ts(this,0,-1)},t.prototype.unshift=function(){var e=arguments;return this.withMutations((function(t){Ts(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])}))},t.prototype.shift=function(){return Ts(this,1)},t.prototype.concat=function(){for(var t=arguments,r=[],n=0;n<arguments.length;n++){var o=t[n],i=e("string"!=typeof o&&ei(o)?o:[o]);0!==i.size&&r.push(i)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations((function(e){r.forEach((function(t){return t.forEach((function(t){return e.push(t)}))}))})):this.constructor(r[0])},t.prototype.setSize=function(e){return Ts(this,0,e)},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){for(var o=0;o<r.size;o++)n.set(o,e.call(t,n.get(o),o,r))}))},t.prototype.slice=function(e,t){var r=this.size;return So(e,t,r)?this:Ts(this,wo(e,r),To(t,r))},t.prototype.__iterator=function(e,t){var r=t?this.size:0,n=ys(this,t);return new Qo((function(){var o=n();return o===ms?{value:void 0,done:!0}:Jo(e,t?--r:r++,o)}))},t.prototype.__iterate=function(e,t){for(var r,n=t?this.size:0,o=ys(this,t);(r=o())!==ms&&!1!==e(r,t?--n:n++,this););return n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?bs(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):0===this.size?Os():(this.__ownerID=e,this.__altered=!1,this)},t}(Do);fs.isList=ps;var hs=fs.prototype;hs[ds]=!0,hs[po]=hs.remove,hs.merge=hs.concat,hs.setIn=Ta,hs.deleteIn=hs.removeIn=_a,hs.update=Ra,hs.updateIn=Ia,hs.mergeIn=Fa,hs.mergeDeepIn=Ma,hs.withMutations=Va,hs.wasAltered=za,hs.asImmutable=Ba,hs["@@transducer/init"]=hs.asMutable=Ua,hs["@@transducer/step"]=function(e,t){return e.push(t)},hs["@@transducer/result"]=function(e){return e.asImmutable()};var gs=function(e,t){this.array=e,this.ownerID=t};gs.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&go;if(n>=this.array.length)return new gs([],e);var o,i=0===n;if(t>0){var a=this.array[n];if((o=a&&a.removeBefore(e,t-fo,r))===a&&i)return this}if(i&&!o)return this;var s=Ss(this,e);if(!i)for(var l=0;l<n;l++)s.array[l]=void 0;return o&&(s.array[n]=o),s},gs.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,o=r-1>>>t&go;if(o>=this.array.length)return this;if(t>0){var i=this.array[o];if((n=i&&i.removeAfter(e,t-fo,r))===i&&o===this.array.length-1)return this}var a=Ss(this,e);return a.array.splice(o+1),n&&(a.array[o]=n),a};var vs,ms={};function ys(e,t){var r=e._origin,n=e._capacity,o=xs(n),i=e._tail;return function e(a,s,l){return 0===s?function(e,a){var s=a===o?i&&i.array:e&&e.array,l=a>r?0:r-a,u=n-a;return u>ho&&(u=ho),function(){if(l===u)return ms;var e=t?--u:l++;return s&&s[e]}}(a,l):function(o,i,a){var s,l=o&&o.array,u=a>r?0:r-a>>i,c=1+(n-a>>i);return c>ho&&(c=ho),function(){for(;;){if(s){var r=s();if(r!==ms)return r;s=null}if(u===c)return ms;var n=t?--c:u++;s=e(l&&l[n],i-fo,a+(n<<i))}}}(a,s,l)}(e._root,e._level,0)}function bs(e,t,r,n,o,i,a){var s=Object.create(hs);return s.size=t-e,s._origin=e,s._capacity=t,s._level=r,s._root=n,s._tail=o,s.__ownerID=i,s.__hash=a,s.__altered=!1,s}function Os(){return vs||(vs=bs(0,0,fo))}function Es(e,t,r,n,o,i){var a,s=n>>>r&go,l=e&&s<e.array.length;if(!l&&void 0===o)return e;if(r>0){var u=e&&e.array[s],c=Es(u,t,r-fo,n,o,i);return c===u?e:((a=Ss(e,t)).array[s]=c,a)}return l&&e.array[s]===o?e:(i&&mo(i),a=Ss(e,t),void 0===o&&s===a.array.length-1?a.array.pop():a.array[s]=o,a)}function Ss(e,t){return t&&e&&t===e.ownerID?e:new gs(e?e.array.slice():[],t)}function ws(e,t){if(t>=xs(e._capacity))return e._tail;if(t<1<<e._level+fo){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&go],n-=fo;return r}}function Ts(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new yo,o=e._origin,i=e._capacity,a=o+t,s=void 0===r?i:r<0?i+r:o+r;if(a===o&&s===i)return e;if(a>=s)return e.clear();for(var l=e._level,u=e._root,c=0;a+c<0;)u=new gs(u&&u.array.length?[void 0,u]:[],n),c+=1<<(l+=fo);c&&(a+=c,o+=c,s+=c,i+=c);for(var d=xs(i),p=xs(s);p>=1<<l+fo;)u=new gs(u&&u.array.length?[u]:[],n),l+=fo;var f=e._tail,h=p<d?ws(e,s-1):p>d?new gs([],n):f;if(f&&p>d&&a<i&&f.array.length){for(var g=u=Ss(u,n),v=l;v>fo;v-=fo){var m=d>>>v&go;g=g.array[m]=Ss(g.array[m],n)}g.array[d>>>fo&go]=f}if(s<i&&(h=h&&h.removeAfter(n,0,s)),a>=p)a-=p,s-=p,l=fo,u=null,h=h&&h.removeBefore(n,0,a);else if(a>o||p<d){for(c=0;u;){var y=a>>>l&go;if(y!==p>>>l&go)break;y&&(c+=(1<<l)*y),l-=fo,u=u.array[y]}u&&a>o&&(u=u.removeBefore(n,l,a-c)),u&&p<d&&(u=u.removeAfter(n,l,p-c)),c&&(a-=c,s-=c)}return e.__ownerID?(e.size=s-a,e._origin=a,e._capacity=s,e._level=l,e._root=u,e._tail=h,e.__hash=void 0,e.__altered=!0,e):bs(a,s,l,u,h)}function xs(e){return e<ho?0:e-1>>>fo<<fo}var _s,Cs=function(e){function t(e){return null==e?Is():Oi(e)?e:Is().withMutations((function(t){var r=No(e);ca(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this.__altered=!0,this):Is()},t.prototype.set=function(e,t){return As(this,e,t)},t.prototype.remove=function(e){return As(this,e,vo)},t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate((function(t){return t&&e(t[1],t[0],r)}),t)},t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?Rs(t,r,e,this.__hash):0===this.size?Is():(this.__ownerID=e,this.__altered=!1,this._map=t,this._list=r,this)},t}($a);function Rs(e,t,r,n){var o=Object.create(Cs.prototype);return o.size=e?e.size:0,o._map=e,o._list=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Is(){return _s||(_s=Rs(ts(),Os()))}function As(e,t,r){var n,o,i=e._map,a=e._list,s=i.get(t),l=void 0!==s;if(r===vo){if(!l)return e;a.size>=ho&&a.size>=2*i.size?(n=(o=a.filter((function(e,t){return void 0!==e&&s!==t}))).toKeyedSeq().map((function(e){return e[0]})).flip().toMap(),e.__ownerID&&(n.__ownerID=o.__ownerID=e.__ownerID)):(n=i.remove(t),o=s===a.size-1?a.pop():a.set(s,void 0))}else if(l){if(r===a.get(s)[1])return e;n=i,o=a.set(s,[t,r])}else n=i.set(t,a.size),o=a.set(a.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=o,e.__hash=void 0,e.__altered=!0,e):Rs(n,o)}Cs.isOrderedMap=Oi,Cs.prototype[$o]=!0,Cs.prototype[po]=Cs.prototype.remove;var js="@@__IMMUTABLE_STACK__@@";function Ps(e){return Boolean(e&&e[js])}var Ls=function(e){function t(e){return null==e?Fs():Ps(e)?e:Fs().pushAll(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("Stack [","]")},t.prototype.get=function(e,t){var r=this._head;for(e=Oo(this,e);r&&e--;)r=r.next;return r?r.value:t},t.prototype.peek=function(){return this._head&&this._head.value},t.prototype.push=function(){var e=arguments;if(0===arguments.length)return this;for(var t=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:e[n],next:r};return this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):Ds(t,r)},t.prototype.pushAll=function(t){if(0===(t=e(t)).size)return this;if(0===this.size&&Ps(t))return t;ca(t.size);var r=this.size,n=this._head;return t.__iterate((function(e){r++,n={value:e,next:n}}),!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):Ds(r,n)},t.prototype.pop=function(){return this.slice(1)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):Fs()},t.prototype.slice=function(t,r){if(So(t,r,this.size))return this;var n=wo(t,this.size);if(To(r,this.size)!==this.size)return e.prototype.slice.call(this,t,r);for(var o=this.size-n,i=this._head;n--;)i=i.next;return this.__ownerID?(this.size=o,this._head=i,this.__hash=void 0,this.__altered=!0,this):Ds(o,i)},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Ds(this.size,this._head,e,this.__hash):0===this.size?Fs():(this.__ownerID=e,this.__altered=!1,this)},t.prototype.__iterate=function(e,t){var r=this;if(t)return new ci(this.toArray()).__iterate((function(t,n){return e(t,n,r)}),t);for(var n=0,o=this._head;o&&!1!==e(o.value,n++,this);)o=o.next;return n},t.prototype.__iterator=function(e,t){if(t)return new ci(this.toArray()).__iterator(e,t);var r=0,n=this._head;return new Qo((function(){if(n){var t=n.value;return n=n.next,Jo(e,r++,t)}return{value:void 0,done:!0}}))},t}(Do);Ls.isStack=Ps;var ks,Ns=Ls.prototype;function Ds(e,t,r,n){var o=Object.create(Ns);return o.size=e,o._head=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Fs(){return ks||(ks=Ds(0))}Ns[js]=!0,Ns.shift=Ns.pop,Ns.unshift=Ns.push,Ns.unshiftAll=Ns.pushAll,Ns.withMutations=Va,Ns.wasAltered=za,Ns.asImmutable=Ba,Ns["@@transducer/init"]=Ns.asMutable=Ua,Ns["@@transducer/step"]=function(e,t){return e.unshift(t)},Ns["@@transducer/result"]=function(e){return e.asImmutable()};var Ms="@@__IMMUTABLE_SET__@@";function Vs(e){return Boolean(e&&e[Ms])}function Us(e){return Vs(e)&&Wo(e)}function Bs(e,t){if(e===t)return!0;if(!Ro(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||Ao(e)!==Ao(t)||Po(e)!==Po(t)||Wo(e)!==Wo(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!Lo(e);if(Wo(e)){var n=e.entries();return t.every((function(e,t){var o=n.next().value;return o&&Si(o[1],e)&&(r||Si(o[0],t))}))&&n.next().done}var o=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{o=!0;var i=e;e=t,t=i}var a=!0,s=t.__iterate((function(t,n){if(r?!e.has(t):o?!Si(t,e.get(n,vo)):!Si(e.get(n,vo),t))return a=!1,!1}));return a&&e.size===s}function zs(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}function $s(e){if(!e||"object"!=typeof e)return e;if(!Ro(e)){if(!ha(e))return e;e=ai(e)}if(Ao(e)){var t={};return e.__iterate((function(e,r){t[r]=$s(e)})),t}var r=[];return e.__iterate((function(e){r.push($s(e))})),r}var Ws=function(e){function t(t){return null==t?Ys():Vs(t)&&!Wo(t)?t:Ys().withMutations((function(r){var n=e(t);ca(n.size),n.forEach((function(e){return r.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(No(e).keySeq())},t.intersect=function(e){return(e=ko(e).toArray()).length?qs.intersect.apply(t(e.pop()),e):Ys()},t.union=function(e){return(e=ko(e).toArray()).length?qs.union.apply(t(e.pop()),e):Ys()},t.prototype.toString=function(){return this.__toString("Set {","}")},t.prototype.has=function(e){return this._map.has(e)},t.prototype.add=function(e){return Gs(this,this._map.set(e,e))},t.prototype.remove=function(e){return Gs(this,this._map.remove(e))},t.prototype.clear=function(){return Gs(this,this._map.clear())},t.prototype.map=function(e,t){var r=this,n=!1,o=Gs(this,this._map.mapEntries((function(o){var i=o[1],a=e.call(t,i,i,r);return a!==i&&(n=!0),[a,a]}),t));return n?o:this},t.prototype.union=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return 0===(t=t.filter((function(e){return 0!==e.size}))).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations((function(r){for(var n=0;n<t.length;n++)"string"==typeof t[n]?r.add(t[n]):e(t[n]).forEach((function(e){return r.add(e)}))})):this.constructor(t[0])},t.prototype.intersect=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.every((function(t){return t.includes(e)}))||n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.subtract=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.some((function(t){return t.includes(e)}))&&n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.sort=function(e){return hl(Ji(this,e))},t.prototype.sortBy=function(e,t){return hl(Ji(this,t,e))},t.prototype.wasAltered=function(){return this._map.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){return this._map.__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):0===this.size?this.__empty():(this.__ownerID=e,this._map=t,this)},t}(Fo);Ws.isSet=Vs;var Hs,qs=Ws.prototype;function Gs(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function Ks(e,t){var r=Object.create(qs);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function Ys(){return Hs||(Hs=Ks(ts()))}qs[Ms]=!0,qs[po]=qs.remove,qs.merge=qs.concat=qs.union,qs.withMutations=Va,qs.asImmutable=Ba,qs["@@transducer/init"]=qs.asMutable=Ua,qs["@@transducer/step"]=function(e,t){return e.add(t)},qs["@@transducer/result"]=function(e){return e.asImmutable()},qs.__empty=Ys,qs.__make=Ks;var Xs,Qs=function(e){function t(e,r,n){if(!(this instanceof t))return new t(e,r,n);if(ua(0!==n,"Cannot step a Range by 0"),e=e||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<e&&(n=-n),this._start=e,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-e)/n-1)+1),0===this.size){if(Xs)return Xs;Xs=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},t.prototype.get=function(e,t){return this.has(e)?this._start+Oo(this,e)*this._step:t},t.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},t.prototype.slice=function(e,r){return So(e,r,this.size)?this:(e=wo(e,this.size),(r=To(r,this.size))<=e?new t(0,0):new t(this.get(e,this._end),this.get(r,this._end),this._step))},t.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},t.prototype.lastIndexOf=function(e){return this.indexOf(e)},t.prototype.__iterate=function(e,t){for(var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;i!==r&&!1!==e(o,t?r-++i:i++,this);)o+=t?-n:n;return i},t.prototype.__iterator=function(e,t){var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;return new Qo((function(){if(i===r)return{value:void 0,done:!0};var a=o;return o+=t?-n:n,Jo(e,t?r-++i:i++,a)}))},t.prototype.equals=function(e){return e instanceof t?this._start===e._start&&this._end===e._end&&this._step===e._step:Bs(this,e)},t}(li);function Js(e,t,r){for(var n=da(t),o=0;o!==n.length;)if((e=ma(e,n[o++],vo))===vo)return r;return e}function Zs(e,t){return Js(this,e,t)}function el(e,t){return Js(e,t,vo)!==vo}function tl(){ca(this.size);var e={};return this.__iterate((function(t,r){e[r]=t})),e}ko.isIterable=Ro,ko.isKeyed=Ao,ko.isIndexed=Po,ko.isAssociative=Lo,ko.isOrdered=Wo,ko.Iterator=Qo,zs(ko,{toArray:function(){ca(this.size);var e=new Array(this.size||0),t=Ao(this),r=0;return this.__iterate((function(n,o){e[r++]=t?[o,n]:n})),e},toIndexedSeq:function(){return new zi(this)},toJS:function(){return $s(this)},toKeyedSeq:function(){return new Bi(this,!0)},toMap:function(){return $a(this.toKeyedSeq())},toObject:tl,toOrderedMap:function(){return Cs(this.toKeyedSeq())},toOrderedSet:function(){return hl(Ao(this)?this.valueSeq():this)},toSet:function(){return Ws(Ao(this)?this.valueSeq():this)},toSetSeq:function(){return new $i(this)},toSeq:function(){return Po(this)?this.toIndexedSeq():Ao(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return Ls(Ao(this)?this.valueSeq():this)},toList:function(){return fs(Ao(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return ra(this,function(e,t){var r=Ao(e),n=[e].concat(t).map((function(e){return Ro(e)?r&&(e=No(e)):e=r?gi(e):vi(Array.isArray(e)?e:[e]),e})).filter((function(e){return 0!==e.size}));if(0===n.length)return e;if(1===n.length){var o=n[0];if(o===e||r&&Ao(o)||Po(e)&&Po(o))return o}var i=new ci(n);return r?i=i.toKeyedSeq():Po(e)||(i=i.toSetSeq()),(i=i.flatten(!0)).size=n.reduce((function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}}),0),i}(this,e))},includes:function(e){return this.some((function(t){return Si(t,e)}))},entries:function(){return this.__iterator(Go)},every:function(e,t){ca(this.size);var r=!0;return this.__iterate((function(n,o,i){if(!e.call(t,n,o,i))return r=!1,!1})),r},filter:function(e,t){return ra(this,Ki(this,e,t,!0))},partition:function(e,t){return function(e,t,r){var n=Ao(e),o=[[],[]];e.__iterate((function(i,a){o[t.call(r,i,a,e)?1:0].push(n?[a,i]:i)}));var i=oa(e);return o.map((function(t){return ra(e,i(t))}))}(this,e,t)},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return ca(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){ca(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate((function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""})),t},keys:function(){return this.__iterator(Ho)},map:function(e,t){return ra(this,qi(this,e,t))},reduce:function(e,t,r){return al(this,e,t,r,arguments.length<2,!1)},reduceRight:function(e,t,r){return al(this,e,t,r,arguments.length<2,!0)},reverse:function(){return ra(this,Gi(this,!0))},slice:function(e,t){return ra(this,Yi(this,e,t,!0))},some:function(e,t){ca(this.size);var r=!1;return this.__iterate((function(n,o,i){if(e.call(t,n,o,i))return r=!0,!1})),r},sort:function(e){return ra(this,Ji(this,e))},values:function(){return this.__iterator(qo)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(e,t){return bo(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=$a().asMutable();return e.__iterate((function(o,i){n.update(t.call(r,o,i,e),0,(function(e){return e+1}))})),n.asImmutable()}(this,e,t)},equals:function(e){return Bs(this,e)},entrySeq:function(){var e=this;if(e._cache)return new ci(e._cache);var t=e.toSeq().map(ll).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(ul(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate((function(r,o,i){if(e.call(t,r,o,i))return n=[o,r],!1})),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(e){return this.find(Eo,null,e)},flatMap:function(e,t){return ra(this,function(e,t,r){var n=oa(e);return e.toSeq().map((function(o,i){return n(t.call(r,o,i,e))})).flatten(!0)}(this,e,t))},flatten:function(e){return ra(this,Qi(this,e,!0))},fromEntrySeq:function(){return new Wi(this)},get:function(e,t){return this.find((function(t,r){return Si(r,e)}),void 0,t)},getIn:Zs,groupBy:function(e,t){return function(e,t,r){var n=Ao(e),o=(Wo(e)?Cs():$a()).asMutable();e.__iterate((function(i,a){o.update(t.call(r,i,a,e),(function(e){return(e=e||[]).push(n?[a,i]:i),e}))}));var i=oa(e);return o.map((function(t){return ra(e,i(t))})).asImmutable()}(this,e,t)},has:function(e){return this.get(e,vo)!==vo},hasIn:function(e){return el(this,e)},isSubset:function(e){return e="function"==typeof e.includes?e:ko(e),this.every((function(t){return e.includes(t)}))},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:ko(e)).isSubset(this)},keyOf:function(e){return this.findKey((function(t){return Si(t,e)}))},keySeq:function(){return this.toSeq().map(sl).toIndexedSeq()},last:function(e){return this.toSeq().reverse().first(e)},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return Zi(this,e)},maxBy:function(e,t){return Zi(this,t,e)},min:function(e){return Zi(this,e?cl(e):pl)},minBy:function(e,t){return Zi(this,t?cl(t):pl,e)},rest:function(){return this.slice(1)},skip:function(e){return 0===e?this:this.slice(Math.max(0,e))},skipLast:function(e){return 0===e?this:this.slice(0,-Math.max(0,e))},skipWhile:function(e,t){return ra(this,Xi(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(ul(e),t)},sortBy:function(e,t){return ra(this,Ji(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return this.slice(-Math.max(0,e))},takeWhile:function(e,t){return ra(this,function(e,t,r){var n=ia(e);return n.__iterateUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterate(n,o);var a=0;return e.__iterate((function(e,o,s){return t.call(r,e,o,s)&&++a&&n(e,o,i)})),a},n.__iteratorUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterator(n,o);var a=e.__iterator(Go,o),s=!0;return new Qo((function(){if(!s)return{value:void 0,done:!0};var e=a.next();if(e.done)return e;var o=e.value,l=o[0],u=o[1];return t.call(r,u,l,i)?n===Go?e:Jo(n,l,u,e):(s=!1,{value:void 0,done:!0})}))},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(ul(e),t)},update:function(e){return e(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=Wo(e),r=Ao(e),n=t?1:0;return function(e,t){return t=wi(t,3432918353),t=wi(t<<15|t>>>-15,461845907),t=wi(t<<13|t>>>-13,5),t=wi((t=t+3864292196^e)^t>>>16,2246822507),t=Ti((t=wi(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+fl(_i(e),_i(t))|0}:function(e,t){n=n+fl(_i(e),_i(t))|0}:t?function(e){n=31*n+_i(e)|0}:function(e){n=n+_i(e)|0}),n)}(this))}});var rl=ko.prototype;rl[Co]=!0,rl[Xo]=rl.values,rl.toJSON=rl.toArray,rl.__toStringMapper=ga,rl.inspect=rl.toSource=function(){return this.toString()},rl.chain=rl.flatMap,rl.contains=rl.includes,zs(No,{flip:function(){return ra(this,Hi(this))},mapEntries:function(e,t){var r=this,n=0;return ra(this,this.toSeq().map((function(o,i){return e.call(t,[i,o],n++,r)})).fromEntrySeq())},mapKeys:function(e,t){var r=this;return ra(this,this.toSeq().flip().map((function(n,o){return e.call(t,n,o,r)})).flip())}});var nl=No.prototype;nl[Io]=!0,nl[Xo]=rl.entries,nl.toJSON=tl,nl.__toStringMapper=function(e,t){return ga(t)+": "+ga(e)},zs(Do,{toKeyedSeq:function(){return new Bi(this,!1)},filter:function(e,t){return ra(this,Ki(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return ra(this,Gi(this,!1))},slice:function(e,t){return ra(this,Yi(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(t||0,0),0===r||2===r&&!t)return this;e=wo(e,e<0?this.count():this.size);var n=this.slice(0,e);return ra(this,1===r?n:n.concat(la(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(e){return this.get(0,e)},flatten:function(e){return ra(this,Qi(this,e,!1))},get:function(e,t){return(e=Oo(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find((function(t,r){return r===e}),void 0,t)},has:function(e){return(e=Oo(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return ra(this,function(e,t){var r=ia(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var o=this,i=0;return e.__iterate((function(e){return(!i||!1!==r(t,i++,o))&&!1!==r(e,i++,o)}),n),i},r.__iteratorUncached=function(r,n){var o,i=e.__iterator(qo,n),a=0;return new Qo((function(){return(!o||a%2)&&(o=i.next()).done?o:a%2?Jo(r,a++,t):Jo(r,a++,o.value,o)}))},r}(this,e))},interleave:function(){var e=[this].concat(la(arguments)),t=ta(this.toSeq(),li.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),ra(this,r)},keySeq:function(){return Qs(0,this.size)},last:function(e){return this.get(-1,e)},skipWhile:function(e,t){return ra(this,Xi(this,e,t,!1))},zip:function(){return ra(this,ta(this,dl,[this].concat(la(arguments))))},zipAll:function(){return ra(this,ta(this,dl,[this].concat(la(arguments)),!0))},zipWith:function(e){var t=la(arguments);return t[0]=this,ra(this,ta(this,e,t))}});var ol=Do.prototype;ol[jo]=!0,ol[$o]=!0,zs(Fo,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}});var il=Fo.prototype;function al(e,t,r,n,o,i){return ca(e.size),e.__iterate((function(e,i,a){o?(o=!1,r=e):r=t.call(n,r,e,i,a)}),i),r}function sl(e,t){return t}function ll(e,t){return[t,e]}function ul(e){return function(){return!e.apply(this,arguments)}}function cl(e){return function(){return-e.apply(this,arguments)}}function dl(){return la(arguments)}function pl(e,t){return e<t?1:e>t?-1:0}function fl(e,t){return e^t+2654435769+(e<<6)+(e>>2)}il.has=rl.includes,il.contains=il.includes,il.keys=il.values,zs(si,nl),zs(li,ol),zs(ui,il);var hl=function(e){function t(e){return null==e?yl():Us(e)?e:yl().withMutations((function(t){var r=Fo(e);ca(r.size),r.forEach((function(e){return t.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(No(e).keySeq())},t.prototype.toString=function(){return this.__toString("OrderedSet {","}")},t}(Ws);hl.isOrderedSet=Us;var gl,vl=hl.prototype;function ml(e,t){var r=Object.create(vl);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function yl(){return gl||(gl=ml(Is()))}vl[$o]=!0,vl.zip=ol.zip,vl.zipWith=ol.zipWith,vl.zipAll=ol.zipAll,vl.__empty=yl,vl.__make=ml;var bl=function(e,t){var r;!function(e){if(Bo(e))throw new Error("Can not call `Record` with an immutable Record as default values. Use a plain javascript object instead.");if(zo(e))throw new Error("Can not call `Record` with an immutable Collection as default values. Use a plain javascript object instead.");if(null===e||"object"!=typeof e)throw new Error("Can not call `Record` with a non-object as default values. Use a plain javascript object instead.")}(e);var n=function(i){var a=this;if(i instanceof n)return i;if(!(this instanceof n))return new n(i);if(!r){r=!0;var s=Object.keys(e),l=o._indices={};o._name=t,o._keys=s,o._defaultValues=e;for(var u=0;u<s.length;u++){var c=s[u];l[c]=u,o[c]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+Sl(this)+' with property "'+c+'" since that property name is part of the Record API.'):Tl(o,c)}}return this.__ownerID=void 0,this._values=fs().withMutations((function(e){e.setSize(a._keys.length),No(i).forEach((function(t,r){e.set(a._indices[r],t===a._defaultValues[r]?void 0:t)}))})),this},o=n.prototype=Object.create(Ol);return o.constructor=n,t&&(n.displayName=t),n};bl.prototype.toString=function(){for(var e,t=Sl(this)+" { ",r=this._keys,n=0,o=r.length;n!==o;n++)t+=(n?", ":"")+(e=r[n])+": "+ga(this.get(e));return t+" }"},bl.prototype.equals=function(e){return this===e||Bo(e)&&wl(this).equals(wl(e))},bl.prototype.hashCode=function(){return wl(this).hashCode()},bl.prototype.has=function(e){return this._indices.hasOwnProperty(e)},bl.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._indices[e],n=this._values.get(r);return void 0===n?this._defaultValues[e]:n},bl.prototype.set=function(e,t){if(this.has(e)){var r=this._values.set(this._indices[e],t===this._defaultValues[e]?void 0:t);if(r!==this._values&&!this.__ownerID)return El(this,r)}return this},bl.prototype.remove=function(e){return this.set(e)},bl.prototype.clear=function(){var e=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:El(this,e)},bl.prototype.wasAltered=function(){return this._values.wasAltered()},bl.prototype.toSeq=function(){return wl(this)},bl.prototype.toJS=function(){return $s(this)},bl.prototype.entries=function(){return this.__iterator(Go)},bl.prototype.__iterator=function(e,t){return wl(this).__iterator(e,t)},bl.prototype.__iterate=function(e,t){return wl(this).__iterate(e,t)},bl.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._values.__ensureOwner(e);return e?El(this,t,e):(this.__ownerID=e,this._values=t,this)},bl.isRecord=Bo,bl.getDescriptiveName=Sl;var Ol=bl.prototype;function El(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._values=t,n.__ownerID=r,n}function Sl(e){return e.constructor.displayName||e.constructor.name||"Record"}function wl(e){return gi(e._keys.map((function(t){return[t,e.get(t)]})))}function Tl(e,t){try{Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){ua(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}catch(e){}}Ol[Uo]=!0,Ol[po]=Ol.remove,Ol.deleteIn=Ol.removeIn=_a,Ol.getIn=Zs,Ol.hasIn=rl.hasIn,Ol.merge=Aa,Ol.mergeWith=ja,Ol.mergeIn=Fa,Ol.mergeDeep=Na,Ol.mergeDeepWith=Da,Ol.mergeDeepIn=Ma,Ol.setIn=Ta,Ol.update=Ra,Ol.updateIn=Ia,Ol.withMutations=Va,Ol.asMutable=Ua,Ol.asImmutable=Ba,Ol[Xo]=Ol.entries,Ol.toJSON=Ol.toObject=rl.toObject,Ol.inspect=Ol.toSource=function(){return this.toString()};var xl,_l=function(e){function t(e,r){if(!(this instanceof t))return new t(e,r);if(this._value=e,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(xl)return xl;xl=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},t.prototype.get=function(e,t){return this.has(e)?this._value:t},t.prototype.includes=function(e){return Si(this._value,e)},t.prototype.slice=function(e,r){var n=this.size;return So(e,r,n)?this:new t(this._value,To(r,n)-wo(e,n))},t.prototype.reverse=function(){return this},t.prototype.indexOf=function(e){return Si(this._value,e)?0:-1},t.prototype.lastIndexOf=function(e){return Si(this._value,e)?this.size:-1},t.prototype.__iterate=function(e,t){for(var r=this.size,n=0;n!==r&&!1!==e(this._value,t?r-++n:n++,this););return n},t.prototype.__iterator=function(e,t){var r=this,n=this.size,o=0;return new Qo((function(){return o===n?{value:void 0,done:!0}:Jo(e,t?n-++o:o++,r._value)}))},t.prototype.equals=function(e){return e instanceof t?Si(this._value,e._value):Bs(this,e)},t}(li);function Cl(e,t){return Rl([],t||Il,e,"",t&&t.length>2?[]:void 0,{"":e})}function Rl(e,t,r,n,o,i){if("string"!=typeof r&&!zo(r)&&(ii(r)||ei(r)||fa(r))){if(~e.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");e.push(r),o&&""!==n&&o.push(n);var a=t.call(i,n,ai(r).map((function(n,i){return Rl(e,t,n,i,o,r)})),o&&o.slice());return e.pop(),o&&o.pop(),a}return r}function Il(e,t){return Po(t)?t.toList():Ao(t)?t.toMap():t.toSet()}const Al={version:"4.3.7",Collection:ko,Iterable:ko,Seq:ai,Map:$a,OrderedMap:Cs,List:fs,Stack:Ls,Set:Ws,OrderedSet:hl,PairSorting:{LeftThenRight:-1,RightThenLeft:1},Record:bl,Range:Qs,Repeat:_l,is:Si,fromJS:Cl,hash:_i,isImmutable:zo,isCollection:Ro,isKeyed:Ao,isIndexed:Po,isAssociative:Lo,isOrdered:Wo,isValueObject:Ei,isPlainObject:fa,isSeq:Vo,isList:ps,isMap:bi,isOrderedMap:Oi,isStack:Ps,isSet:Vs,isOrderedSet:Us,isRecord:Bo,get:ma,getIn:Js,has:va,hasIn:el,merge:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return ka(e,t)},mergeDeep:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return La(e,t)},mergeWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return ka(t,r,e)},mergeDeepWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return La(t,r,e)},remove:ba,removeIn:xa,set:Oa,setIn:wa,update:Ca,updateIn:Ea};var jl=0;const Pl=function(){var e=((new Date).getTime().toString(16)+"FF").substr(0,11),t="ssssssss-xxxx-4xxx-yxxx-x".replace(/[xys]/g,(function(e){var t="s"===e?Math.floor(16*Math.random()):15&jl++;return("x"===e?t:3&t|8).toString(16)}));return t+e};function Ll(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var kl=["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue","spelImportFuncs","spelImportValue"],Nl=["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"],Dl=function(e){return"object"===Kn(e)&&null!==e&&"[object Object]"===Object.prototype.toString.call(e)},Fl=function(e){if("object"===Kn(e)&&null!==e){if(Array.isArray(e))return co(e);if(Dl(e))return function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ll(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ll(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},e)}return e},Ml=function(e,t){return Object.fromEntries(Object.entries(e).filter((function(e){var r=lo(e,1)[0];return!t.includes(r)})))},Vl=function(e){var t;return null!==(t=null==e?void 0:e.cardinality)&&void 0!==t?t:1},Ul=function(e,t){return e===t||($a.isMap(e)?e.equals(t):JSON.stringify(e)==JSON.stringify(t))},Bl=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?Bl(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):$a.isMap(e)?e.equals(t):"object"==Kn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?Bl(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)};var zl=function(e){return"object"===Kn(e)&&null!==e&&"function"==typeof e.toJS},$l=function(e){return zl(e)&&Al.isList(e)};function Wl(e){return $l(e)?e:new Al.List(e)}function Hl(e){return zl(e)?e.toJS():e}var ql=function(e){return e.replace(/[.*+?^${}()|[\]\\/]/g,"\\$&")},Gl=function(e,t,r,n,o,i){if(Array.isArray(e))return t},Kl=function e(t){var r;if(t instanceof Array)return t.map((function(t,r){return e(t)}));if("object"===Kn(t)&&null!==t&&Yl(t)){var n,o=Ml(t,["$$typeof","_owner","_store","ref","key"]);return o.type&&(o.type="string"==typeof(r=o.type)?r:"function"==typeof r?r.name:r),null!=o&&null!==(n=o.props)&&void 0!==n&&n.children&&(o.props.children=e(o.props.children)),o}return t},Yl=function(e){return"object"===Kn(e)&&null!==e&&!Array.isArray(e)&&Object.keys(e).includes("type")&&Object.keys(e).includes("props")&&Object.keys(e).includes("key")&&Object.keys(e).includes("ref")&&Object.keys(e).includes("$$typeof")},Xl=function(e){return"object"===Kn(e)&&null!==e&&!Array.isArray(e)&&"string"==typeof e.type&&Object.keys(e).includes("props")},Ql=function(e){return"object"===Kn(e)&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length};function Jl(e){return new Promise((function(t){setTimeout(t,e)}))}function Zl(e,t){return e||(e=[]),t||(t=[]),t.map((function(t){return[t,e.indexOf(t)]})).map((function(e,t,r){var n=lo(e,2),o=n[0];if(-1==n[1]){var i=r.slice(t+1),a=r.slice(0,t).reverse().find((function(e){var t=lo(e,2);return t[0],-1!=t[1]})),s=i.find((function(e){var t=lo(e,2);return t[0],-1!=t[1]}));return s?[o,"before",s[0]]:a?[o,"after",a[0]]:[o,"append",null]}return null})).filter((function(e){return null!==e})).reduce((function(e,t){var r=lo(t,3),n=r[0],o=r[1],i=r[2],a=e.indexOf(i);return-1==e.indexOf(n)&&(a>-1?e.splice(a+("after"==o?1:0),0,n):e.splice("append"==o?1/0:0,0,n)),e}),e.slice())}var eu=function e(t){"object"!==Kn(t)||null===t||Yl(t)||(Object.keys(t).forEach((function(r){"__cache"!==r&&e(t[r])})),Object.freeze(t))},tu=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(Dl(t)){if(t.var)return n[t.var]=r,!0;if(!Dl(r))return!1;for(var i in t)if(!e(t[i],r[i],n,[].concat(co(o),[i])))return!1;return!0}if(Array.isArray(t)){if(!Array.isArray(r))return!1;for(var a=0;a<t.length;a++)if(!e(t[a],r[a],n,[].concat(co(o),[a])))return!1;return!0}return t===r},ru=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}},nu=function(){for(var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=0;r<t.length;r++){var n=t[r];if(void 0!==n){e=n;break}}return e},ou=ru(),iu=v(6834),au=v.n(iu),su=v(8831),lu=v.n(su),uu=v(8906),cu=v.n(uu),du=v(7027),pu=v.n(du);function fu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function hu(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function gu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?hu(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):hu(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var vu=function(e){return"object"==Kn(e)&&null!==e&&!Array.isArray(e)},mu=function(e,t){return null==e||""==e?void 0:vu(e)?gu(gu({},e),{},{title:e.title||e.value}):{value:e,title:void 0!==t?t:""+e}},yu=function(e){var t=mu(e);return vu(t)?gu(gu({},mu(e)),{},{isCustom:!0}):t},bu=function(e){if(Array.isArray(e))return e.map((function(e){return mu(e)}));if(!vu(e))return e;var t=[];for(var r in e){var n=e[r];t.push(mu(r,n))}return t},Ou=function(e,t){return Array.isArray(e)?e.map((function(e){return mu(e)})).find((function(e){return""+e.value==""+t})):void 0!==e[t]?mu(t,e[t]):void 0},Eu=function(e,t){if(null==e)return t;var r=Ou(e,t);return void 0!==r?r.title:t},Su=function(e,t){if(null==e)return t;var r=Ou(e,t);return void 0!==r?r.value:t},wu=function(e,t){var r=[];if(Array.isArray(e)){var n,o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return fu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?fu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{for(o.s();!(n=o.n()).done;){var i=n.value,a=t(mu(i));null!=a&&r.push(a)}}catch(e){o.e(e)}finally{o.f()}}else for(var s in e){var l=t(mu(s,e[s]));null!=l&&r.push(l)}return r},Tu=function(e,t){return wu(t,(function(t){return-1!="".concat(t.value).indexOf(e)||-1!=t.title.indexOf(e)?t:null})).filter((function(e){return null!==e})).shift()},xu=function(e,t){return wu(t,(function(t){return""+t.value==""+e?t:null})).filter((function(e){return null!==e})).shift()},_u=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.skip(1),e.push.apply(e,r),e}))},Cu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.push.apply(e,r),e}))},Ru=function(e,t){var r=new Al.OrderedMap(no({},e.get("id"),e)),n=e;return t.forEach((function(e){var t;n=r.get(e),r=null===(t=n)||void 0===t?void 0:t.get("children1")})),n},Iu=function(e){var t=e;return function e(r,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=n.push(r.get("id")),a=r.getIn(["properties","isLocked"]);o&&a&&(t=t.deleteIn(_u(i,"properties","isLocked")));var s=r.get("children1");s&&s.map((function(t,r){e(t,i,a||o)}))}(e,new Al.List),t},Au=function(e){var t=e;return function e(r,n,o,i){if(r){var a=r.get("path"),s=r.get("id"),l=s||i||Pl(),u=n.push(l);a&&a.equals(u)||(t=t.setIn(_u(u,"path"),u)),s||(t=t.setIn(_u(u,"id"),l));var c=r.get("children1");c&&("Map"===c.constructor.name&&(t=t.setIn(_u(u,"children1"),new Al.OrderedMap(c))),c.map((function(t,r){e(t,u,o+1,r)})))}}(e,new Al.List,0),t},ju=function(e){var t=e;return function e(r,n,o,i){if(!r)return!1;var a=r.get("id")||i,s=n.push(a),l=r.get("children1");if(l){var u=l.map((function(t,r){return e(t,s,o+1,r)})).reduce((function(e,t){return e&&t}),!0);if((0==l.size||u)&&o>0)return t=t.deleteIn(_u(s)),!0}return!1}(e,new Al.List,0),t},Pu=function(e){var t=[],r={},n=[],o=0,i=0,a=0,s={};!function l(u,c,d,p,f,h,g,v){var m=u===e,y=u.get("type"),b=u.get("collapsed"),O=u.get("id"),E=u.get("children1"),S=u.getIn(["properties","isLocked"]),w=E?E.map((function(e,t){return t})).valueSeq().toArray():null,T="rule_group"===y,x="rule"===y,_="group"===y,C="case_group"===y,R=!f&&(!E||T),I=(null==w?void 0:w.length)>0,A=c.length?c[c.length-1]:null,j=C?O:g;C&&(n.push(O),i=0,a=0,s={});var P,L=j?n.indexOf(j):null,k=t.length,N=o;m||((P={}).caseNo=L,P.globalNoByType=C?L:s[y]||0,P.indexPath=[].concat(co(c.slice(1).map((function(e){return r[e].childNo}))),[v]),x?P.globalLeafNo=i:_&&(P.globalGroupNo=a)),t.push(O),r[O]={node:u,index:k,id:O,type:y,parent:A,parentType:A?r[A].type:null,children:w,childNo:v,caseId:j,caseNo:L,path:c.concat(O),lev:h,isLeaf:!E,isAtomicRule:R,isLocked:S||p,top:d?null:N,isDefaultCase:C?!E:void 0,atomicRulesCountInCase:C?0:void 0,position:P,collapsed:b,_top:k,leaf:!E};var D=0,F=0;d||(o+=1,D+=1,!I||b||T||(F+=1),m||C||(_&&a++,x&&i++,s[y]=(s[y]||0)+1)),g&&R&&r[g].atomicRulesCountInCase++;var M=0,V=0;if(I){var U=0;E.map((function(e,t){if(e){l(e,c.concat(O),d||b,p||S,f||T,h+1,j,U);var n=r[t];M=Math.max(M,n.depth||0),V+=n.height,U++}}))}D+=V,F+=M;var B=t.length-k,z=d?null:N+D;Object.assign(r[O],{depth:E?F:void 0,_height:B,height:D,bottom:z})}(e,[],!1,!1,!1,0,null,null);for(var l=0;l<t.length;l++){var u=l>0?t[l-1]:null,c=l<t.length-1?t[l+1]:null,d=r[t[l]];d.prev=u,d.next=c}return{flat:t,items:r,cases:n}},Lu=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),t++,a&&"rule_group"!=s&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t-1},ku=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),"rule"==s||"rule_group"==s?t++:a&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t},Nu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=e;return function e(n,o){t&&n.path&&delete n.path,t&&!r&&o&&delete n.id;var i=n.properties;i&&null==i.operatorOptions&&delete i.operatorOptions;var a=n.children1;if(a){for(var s in a)a[s]&&e(a[s],s);r&&(n.children1=Object.values(a))}}(e,null),n},Du=function(e){var t=[],r=e.get("children1");return r&&r.map((function(e){var r,n=e.getIn(["properties","value"]);n&&1==n.size?(r=n.get(0),Array.isArray(r)&&0==r.length&&(r=null)):r=null,t=[].concat(co(t),[r])})),t},Fu=function(e){return!e.get("children1")||0==e.get("children1").size},Mu=function(e,t){return e.getIn(_u(t,"children1")).size>0},Vu=function(e){if(null!=e&&e.toJS){var t,r=null==e||null===(t=e.toJS)||void 0===t?void 0:t.call(e);return null!=r&&r.func?e.toOrderedMap():r}return e},Uu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(e){var n=e;return n=n.toJS(),Nu(n,t,r)}},Bu=function(e){if(zu(e))return e;if($u(e))return Au(Wu(e));if("string"==typeof e&&e.startsWith('["~#iM"'))throw new Error("You are trying to load query in obsolete serialization format (Immutable string) which is not supported in versions starting from 2.1.17");if("string"==typeof e)return Au(Wu(JSON.parse(e)));throw new Error("Can't load tree!")},zu=function(e){return $a.isMap(e)},$u=function(e){return"object"==Kn(e)&&("group"==e.type||"switch_group"==e.type)};function Wu(e){var t=Cl(e,(function(e,t,r){var n,o=r&&r.length>3&&"value"===r[r.length-1]&&"args"===r[r.length-3],i=r&&r.length>3&&"value"===r[r.length-1]&&"properties"===r[r.length-2];if("properties"==e){n=t.toOrderedMap();for(var a=0;a<2;a++){var s,l,u;null===(null===(s=n.get("value"))||void 0===s||null===(l=(u=s).get)||void 0===l?void 0:l.call(u,a))&&(n=n.setIn(["value",a],void 0))}}else n=o?Vu(t):(r?i:"value"==e)&&Al.Iterable.isIndexed(t)?t.map(Vu).toList():"asyncListValues"==e?t.toJS():"children1"==e&&Al.Iterable.isIndexed(t)?new Al.OrderedMap(t.map((function(e){return[(null==e?void 0:e.get("id"))||Pl(),e]}))):Al.Iterable.isIndexed(t)?t.toList():t.toOrderedMap();return n}));return t}function Hu(e){return oo(e)||uo(e)||ao(e)||so()}var qu=v(2468),Gu=v.n(qu);function Ku(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Yu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ku(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ku(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Xu(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Qu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Qu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Qu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var Ju="jlField",Zu="jlArgs",ec=["==","!="],tc=["<","<=",">",">="],rc=["multiselect_equals","multiselect_not_equals","multiselect_contains","multiselect_not_contains"],nc=function(e){return{errors:[],settings:null==e?void 0:e.settings}},oc=function(e,t){return ic(e,t,!1)},ic=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=nc();n.settings={allowUnknownFields:!1,returnErrors:r};var o=Rg(t,void 0,!1),i=ac(o),a=e?uc(e,i,o,["rule","group","switch"],n):void 0,s=a?Bu(a):void 0;return r?[s,n.errors]:(n.errors.length&&console.warn("Errors while importing from JsonLogic:",n.errors),s)},ac=function(e){var t={},r={};for(var n in e.operators){var o=e.operators[n];if("string"==typeof o.jsonLogic){var i=o.jsonLogic+"/"+Vl(o);t[i]||(t[i]=[]),t[i].push(n)}else if("string"==typeof o.jsonLogic2){var a=o.jsonLogic2+"/"+Vl(o);t[a]||(t[a]=[]),t[a].push(n),r[n]||(r[n]={}),r[n]={template:o.jsonLogic(Ju,n,Zu),jsonLogic2:o.jsonLogic2,_jsonLogicIsExclamationOp:!!o._jsonLogicIsExclamationOp}}}var s={};for(var l in e.conjunctions)s[e.conjunctions[l].jsonLogicConj||l.toLowerCase()]=l;var u,c={},d=Xu(Mg(e));try{for(d.s();!(u=d.n()).done;){var p=lo(u.value,2),f=p[0],h=p[1],g=void 0;h.jsonLogicIsMethod?g="#"+h.jsonLogic:"string"==typeof h.jsonLogic&&(g=h.jsonLogic),g&&(c[g]||(c[g]=[]),c[g].push(f))}}catch(e){d.e(e)}finally{d.f()}var v=e.settings.jsonLogic;return{operators:t,conjunctions:s,funcs:c,varKeys:["var",v.groupVarKey,v.altVarKey],combinationOperators:r}},sc=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(null!=t&&t.combinationOperators)for(var i=0,a=Object.entries(t.combinationOperators);i<a.length;i++){var s=lo(a[i],2),l=s[0],u=s[1];if(null==o||o.includes(l)){var c=lc(u.template,e);c.match&&(n?r.errors.push("Operator matched against 2 templates: ".concat(n.newOp," and ").concat(l)):n=c,n.newOp=u.jsonLogic2)}}return n},lc=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{match:!0,jlField:null,jlArgs:[]};if(null==t||null==r)return n.match=!1,n;var o=Object.keys(t),i=Object.keys(r);if(o.length!==i.length)return n.match=!1,n;for(var a=0;a<o.length;a++){var s=o[a],l=t[s];if(s!==i[a])return n.match=!1,n;if(l===Ju&&Ql(r[s]))n.jlField=r[s];else if(l===Zu)n.jlArgs.push(r[s]);else if("object"===Kn(l)&&null!==l||Array.isArray(l))n=e(l,r[s],n);else if(l!==r[s])return n.match=!1,n}return n},uc=function e(t,r,n,o,i){var a,s,l,u=arguments.length>5&&void 0!==arguments[5]&&arguments[5],c=arguments.length>6?arguments[6]:void 0,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;Ql(t)&&(a=Object.keys(t)[0],s=t[a],Array.isArray(s)||(s=[s]));var f=i.errors.length,h=n.settings.jsonLogic.lockedOp,g="!"==a&&1==s.length&&s[0]&&Ql(s[0])&&r.varKeys.includes(Object.keys(s[0])[0]),v=sc(t,r,i);v&&((s=[])[0]=v.jlField,v.jlArgs.forEach((function(e){return s.push(e)})),a=v.newOp);var m="!"==a&&!g,y=h&&a==h,b=o.includes("switch");y?l=e(s[0],r,n,o,i,u,c,d,p,!0):m?l=e(s[0],r,n,o,i,!u,c,d,p):o.includes("val")?l=dc(a,s,r,n,u,i,p)||pc(a,s,r,n,u,c,i,p)||cc(t,c,d,n,i):(o.includes("switch")&&(l=mc(a,s,r,n,u,i,p)),null==l&&o.includes("group")&&(l=fc(a,s,r,n,u,i,p,!1)),null==l&&o.includes("rule")&&(l=vc(a,s,r,n,u,i,p)),l&&b&&!["group","switch_group"].includes(l.type)&&(l=hc(l,n)));var O=i.errors.length;return"!"!=a&&void 0===l&&O==f&&i.errors.push("Can't parse logic ".concat(JSON.stringify(t))),y&&(l.properties.isLocked=!0),l},cc=function(e,t,r,n,o){var i;if(void 0===e&&(e=null==t?void 0:t.defaultValue),void 0!==e){r=r||(null==t?void 0:t.mainWidget);var a=n.widgets[r],s=null==t?void 0:t.type;if(!s||a){if(!Ql(e)){if("time"===s&&"number"==typeof e){var l=Math.floor(e/60/60)%24,u=Math.floor(e/60)%60,c=e%60,d=a.valueFormat;if(d){var p=new Date(e);p.setMilliseconds(0),p.setHours(l),p.setMinutes(u),p.setSeconds(c),e=Gu()(p).format(d)}else e="".concat(l,":").concat(u,":").concat(c)}if(["date","datetime"].includes(s)&&e&&!(e instanceof Date))try{var f=new Date(e);f instanceof Date&&f.toISOString()===e&&(e=f)}catch(t){o.errors.push("Can't convert value ".concat(e," as Date")),e=void 0}if(e instanceof Date&&t){var h=a.valueFormat;h&&(e=Gu()(e).format(h))}var g;if(e&&null!=t&&null!==(i=t.fieldSettings)&&void 0!==i&&i.asyncFetch&&(g=Array.isArray(e)?e:[e]),null!=a&&a.jsonLogicImport)try{e=a.jsonLogicImport.call(n.ctx,e)}catch(t){var v;o.errors.push("Can't import value ".concat(e," using import func of widget ").concat(r,": ").concat(null!==(v=null==t?void 0:t.message)&&void 0!==v?v:t)),e=void 0}return{valueSrc:"value",value:e,valueType:null==a?void 0:a.type,asyncListValues:g}}o.errors.push("Unexpected logic in value: ".concat(JSON.stringify(e)))}else o.errors.push("No widget for type ".concat(s))}},dc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(r.varKeys.includes(e)&&"string"==typeof t[0]){var s,l=zg(n,t[0],a),u=ev(n,l);return u||null!==(s=i.settings)&&void 0!==s&&s.allowUnknownFields?{valueSrc:"field",value:l,valueType:null==u?void 0:u.type}:void i.errors.push("No config for field ".concat(l))}},pc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;if(e){var l,u,c,d="method"==e;if(d){var p,f,h=Hu(t);p=h[0],l=h[1],f=h.slice(2),u=[p].concat(co(f))}else l=e,u=t;var g=(d?"#":"")+l,v=(null==i?void 0:i.type)||(null==i?void 0:i.returnType),m=(r.funcs[g]||[]).filter((function(e){return!i||Wg(n,e).returnType==v}));if(m.length)c=m[0];else{var y,b=no({},e,t),O=Xu(Mg(n));try{for(O.s();!(y=O.n()).done;){var E=lo(y.value,2),S=E[0],w=E[1];if(w.jsonLogicImport&&(!v||w.returnType==v)){var T=void 0;try{T=w.jsonLogicImport(b)}catch(e){}T&&(c=S,u=T)}}}catch(e){O.e(e)}finally{O.f()}}if(c&&c){var x=Wg(n,c),_=Object.keys(x.args||{}),C=u.reduce((function(e,t,o){var i,l=_[o],u=x.args[l];return u&&(i=uc(t,r,n,["val"],a,!1,u,null,s)),void 0!==i?Yu(Yu({},e),{},no({},l,i)):e}),{});for(var R in x.args){var I,A=x.args[R],j=C[R];if(void 0===j)if(void 0!==(j=null==A?void 0:A.defaultValue)&&(j={value:j,valueSrc:null!==(I=j)&&void 0!==I&&I.func?"func":"value",valueType:A.type}),void 0===j){if(null==A||!A.isOptional)return void a.errors.push("No value for arg ".concat(R," of func ").concat(c))}else C[R]=j}return{valueSrc:"func",value:{func:c,args:C},valueType:x.returnType}}}},fc=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=r.conjunctions[e],u=n.settings.fieldSeparator;if(l){var c=t.map((function(e){return uc(e,r,n,["rule","group"],i,!1,null,null,s)})).filter((function(e){return void 0!==e})).reduce((function(e,t){return Yu(Yu({},e),{},no({},t.id,t))}),{}),d=Object.values(c).map((function(e){var t,r;return"field"==(null==e||null===(t=e.properties)||void 0===t?void 0:t.fieldSrc)&&(null==e||null===(r=e.properties)||void 0===r?void 0:r.field)})).filter((function(e){var t;return null==e||null===(t=e.includes)||void 0===t?void 0:t.call(e,u)})),p=Object.fromEntries((a=d,Array.from(new Set(a))).map((function(e){var t=e.split(u),r=Object.fromEntries(t.slice(0,-1).map((function(e,t,r){return[].concat(co(r.slice(0,t)),[e])})).map((function(e){return[e.join(u),ev(n,e)]})).filter((function(e){var t=lo(e,2),r=(t[0],t[1]);return"!group"==(null==r?void 0:r.type)})));return[e,Object.keys(r)]}))),f={conjunction:l,not:o},h=Pl(),g={},v={};return Object.entries(c).map((function(e){var t=lo(e,2),r=t[0],o=t[1];if("group"==(null==o?void 0:o.type)||"rule_group"==(null==o?void 0:o.type))g[r]=o;else{var i,a=null==o||null===(i=o.properties)||void 0===i?void 0:i.field,c=p[a]||[],d=c[c.length-1];if(d){var f=g,h=Kg(s,n),m=Kg(d,n);Bl(h,m.slice(0,h.length))||(h=[]);var y=d.split(u).slice(h.length).map((function(e,t,r){return[].concat(co(h),co(r.slice(0,t)),[e]).join(u)})).map((function(e){return{f:e,fc:ev(n,e)||{}}})).filter((function(e){return"!struct"!=e.fc.type}));y.map((function(e,t){var r=e.f,n=e.fc,o=v[r];o||(o=Pl(),v[r]=o,f[o]={type:"rule_group",id:o,children1:{},properties:{conjunction:l,not:!1,field:r,fieldSrc:"field",mode:n.mode}}),f=f[o].children1})),f[r]=o}else o&&(g[r]=o)}})),{type:"group",id:h,children1:g,properties:f}}},hc=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Pl(),children1:no({},e.id,e),properties:{conjunction:Nd(t),not:r}}},gc=function(e,t,r,n,o,i,a){var s,l=rc.map((function(e){var t;return null===(t=i.operators[e])||void 0===t?void 0:t.jsonLogic2})).includes(e),u=i.settings.groupOperators.includes(e)&&!l,c=u?0:t-1;u?c=0:ec.includes(e)&&1==c&&null===r[1]&&(t=1,c=0,r=[r[0]]);var d=e+"/"+c,p=o.operators[d];if(p){var f,h=[];if(tc.includes(e)&&3==t)f=r[1],h=[r[0],r[2]];else{var g=Hu(r);f=g[0],h=g.slice(1)}if(Ql(f)){var v=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null,f=Object.keys(t)[0],h=Object.values(t)[0],g=function(e,t){return function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;Array.isArray(t)||(t=[t]);var s=dc(e,t,r,n,o,i,a);if(s)return{fieldSrc:"field",field:s.value}}(e,t,n,o,u,d,p)||function(e,t,r,n,o){var i=pc(e,t,r,n,o,arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,arguments.length>6?arguments[6]:void 0,arguments.length>7&&void 0!==arguments[7]?arguments[7]:null);if(i)return{fieldSrc:"func",field:i.value}}(e,t,n,o,u,c,d,p)},v=d.errors.length,m=g(f,h);if(m&&(i=m.field,a=m.fieldSrc),e&&(l=!0,s=r[0],r=[]),"reduce"==f&&Array.isArray(h)&&3==h.length){var y=lo(h,3),b=y[0],O=y[1],E=y[2];if(Ql(b)&&0==E&&Ql(O)&&Array.isArray(O["+"])&&1==O["+"][0]&&Ql(O["+"][1])&&"accumulator"==O["+"][1].var)if(f=Object.keys(b)[0],h=Object.values(b)[0],"filter"==f){var S=lo(h,2),w=S[0],T=S[1];if(Ql(w)){var x=g(f=Object.keys(w)[0],h=Object.values(w)[0]);x&&(i=x.field,a=x.fieldSrc,s=T,l=!0)}}else{var _=g(f,h);_&&(i=_.field,a=_.fieldSrc,l=!0)}}var C=d.errors.length;if(i||C!=v||d.errors.push("Unknown LHS ".concat(JSON.stringify(t))),i)return{field:i,fieldSrc:a,having:s,isGroup:l,args:r}}(u,f,h,o,i,null,null,a,n);if(v){var m=v.field,y=v.fieldSrc,b=v.having,O=(v.isGroup,v.args),E=ev(i,m);if(E||null!==(s=a.settings)&&void 0!==s&&s.allowUnknownFields){var S=p[0];if(p.length>1&&E&&E.operators){if(0==(p=p.filter((function(e){return E.operators.includes(e)}))).length)return void a.errors.push("No corresponding ops for LHS ".concat(m));S=p[0]}return{field:m,fieldSrc:y,fieldConfig:E,opKey:S,args:O,having:b}}a.errors.push("No config for LHS ".concat(m))}}else a.errors.push("Incorrect operands for ".concat(e,": ").concat(JSON.stringify(r)))}},vc=function e(t,r,n,o,i,a){var s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(t){var c=Object.values(o.conjunctions).map((function(e){return e.jsonLogicConj})),d=function(e,t,r,n,o,i,a){var s=nc(a),l=gc(e,t,r,n,o,i,s);if(l)return l;a.errors.push(s.errors.join("; ")||"Unknown op ".concat(e,"/").concat(t))}(t,r.length,r,l,n,o,a);if(d){var p,f,h=d.field,g=d.fieldSrc,v=d.fieldConfig,m=d.opKey,y=d.args,b=d.having,O=ev(o,l),E=o.operators[m],S=!!o.operators[null===(s=E)||void 0===s?void 0:s.reversedOp],w="!group"==v.type,T="!group"==(null==O?void 0:O.type),x=S&&(!!o.settings.reverseOperatorsForNot||w&&!b||!w&&T&&!u),_=i&&x||!1,C=!1,R=!!o.settings.reverseOperatorsForNot;if("!group"==(null==v?void 0:v.type)&&b){p=Object.keys(b)[0],f=b[p],Array.isArray(f)||(f=[f]);for(var I=sc(b,n,a);"!"==p&&!I&&!("!"==p&&1==f.length&&f[0]&&Ql(f[0])&&n.varKeys.includes(Object.keys(f[0])[0]));){C=!C,b=b["!"],p=Object.keys(b)[0],f=b[p],R&&c.includes(p)&&1==f.length&&(b=b[p][0],p=Object.keys(b)[0],f=b[p]),I=sc(b,n,a)||I}Array.isArray(f)||(f=[f]),I&&((f=[])[0]=I.jlField,I.jlArgs.forEach((function(e){return f.push(e)})),p=I.newOp)}_&&(i=!i,m=E.reversedOp,E=o.operators[m]);var A=Eh(o,h,m,null),j=y.map((function(e){return uc(e,n,o,["val"],a,!1,v,A,l)}));if(!j.filter((function(e){return void 0===e})).length){var P,L=null==v?void 0:v.type;if("!group"!==L&&"!struct"!==L||(L=null),"!group"==(null==v?void 0:v.type)&&b){var k;if(void 0!==n.conjunctions[p]?P=fc(p,f,n,o,C,a,h,!0):(P=e(p,f,n,o,C,a,h,!0))&&("rule_group"===P.type&&(null===(k=P.properties)||void 0===k?void 0:k.field)!==h&&(P=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0,i=arguments.length>5&&void 0!==arguments[5]&&arguments[5];if(e)return{type:"rule_group",id:Pl(),children1:no({},e.id,e),properties:{conjunction:o||kd(n,r),not:i,field:t}}}(P,h,v,o)),Object.assign(P.properties,{conjunction:kd(o,v)})),!P)return;P.type="rule_group",Object.assign(P.properties,{field:h,mode:v.mode,operator:m}),"array"==v.mode&&Object.assign(P.properties,{value:j.map((function(e){return e.value})),valueSrc:j.map((function(e){return e.valueSrc})),valueType:j.map((function(e){return e.valueType}))}),i&&(P=hc(P,o,i))}else if("!group"!=(null==v?void 0:v.type)||b){var N=j.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),D=N.length?N[0]:void 0;P={type:"rule",id:Pl(),properties:Yu({field:h,fieldSrc:g,operator:m,value:j.map((function(e){return e.value})),valueSrc:j.map((function(e){return e.valueSrc})),valueType:j.map((function(e){return e.valueType}))},D?{asyncListValues:D}:{})},(i||u)&&(P=hc(P,o,i))}else P={type:"rule_group",id:Pl(),children1:{},properties:{conjunction:kd(o,v),not:!1,mode:v.mode,field:h,operator:m}},"array"===v.mode&&Object.assign(P.properties,{value:j.map((function(e){return e.value})),valueSrc:j.map((function(e){return e.valueSrc})),valueType:j.map((function(e){return e.valueType}))}),i&&(P=hc(P,o,i));return P}}}},mc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("if"===(null==e?void 0:e.toLowerCase())){var s=yc(t).map((function(e){var t=lo(e,2),o=t[0],s=t[1];return[o?uc(o,r,n,["rule","group"],i,!1,null,null,a):null,Oc(n,i,r,s)]})).map((function(e){var t=lo(e,2),r=t[0],o=t[1];return bc(r,o,n,i)}));return{type:"switch_group",id:Pl(),children1:s,properties:{}}}},yc=function(e){var t=[];return function e(r){var n=lo(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]);var s=Ql(a)?Object.keys(a)[0]:null;"if"===(null==s?void 0:s.toLowerCase())?e(a[s]):t.push([void 0,a])}(e),t},bc=function(e,t,r,n){var o;return e?(o=Yu({},e)).type?("group"!=o.type&&(o=hc(o,r)),o.type="case_group"):(n.errors.push("Unexpected case: ".concat(JSON.stringify(o))),o=void 0):o={id:Pl(),type:"case_group",properties:{}},o&&(o.properties=Yu(Yu({},o.properties),t)),o},Oc=function(e,t,r,n){var o=ev(e,"!case_value");if(o){var i=o.mainWidget,a=e.widgets[i];if(a){var s=uc(n,r,e,["val","case_val"],t,!1,o,i);if(null!=s){var l=s.value,u=s.valueSrc,c=s.valueType;return{value:[l],valueSrc:[null!=u?u:"value"],valueType:[null!=c?c:null==a?void 0:a.type],field:"!case_value"}}}else t.errors.push("No widget ".concat(i," for case value"))}else t.errors.push("Missing caseValueField in settings")},Ec=v(138),Sc=v(358),wc=v.n(Sc)();wc.trim=function(e){return"'"==e.charAt(0)?e.substring(1,e.length-1):e},wc.escapeLike=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=wc.escape(e);return"'"+(n=(t?"%":"")+(n=(n=wc.trim(n)).replace(/[%_]/g,"\\$&"))+(r?"%":""))+"'"};var Tc=function(e){var t="''",r=null==e?void 0:e.type;return"date"==r?t="'0000-00-00'":"datetime"==r?t="'0000-00-00 00:00'":"time"==r?t="'00:00'":"number"==r&&(t="0"),t},xc=function(e){var t="";return"number"==(null==e?void 0:e.type)&&(t=0),t},_c=function(e){return"".concat(e,".?[true]")},Cc=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==e)return"null";switch(Kn(e)){case"boolean":return e?"true":"false";case"number":if(!Number.isFinite(e)||isNaN(e))return;return e+(!Number.isInteger(e)||t?"f":"");case"object":if(Array.isArray(e))return function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=["int","float"];return e.map((function(e){if(null!=e){if("string"==typeof e)r="String";else{if("number"!=typeof e)throw new Error("spelEscape: Can't use value ".concat(e," in array"));r=Number.isInteger(e)?"int":"float"}if(t){if(t!=r){if(!i.includes(t)||!i.includes(r))throw new Error("spelEscape: Can't use different types in array: found ".concat(t," and ").concat(r));t="float"}}else t=r}})),t||(t="String"),n="float"==t?e.map((function(e){return Cc(e,!0)})):e.map((function(e){return Cc(e)})),o?"new ".concat(t,"[]{").concat(n.join(", "),"}"):"{".concat(n.join(", "),"}")}(e,r);throw new Error("spelEscape: Object is not supported");default:return function(e){return"'"+e.replace(/'/g,"''")+"'"}(e)}},Rc=function(e){return e&&Array.isArray(e)&&e.length?e.map((function(e){return"const"==e.type?Cc(e.value):"property"==e.type?""+e.value:"variable"==e.type?"#"+e.value:void 0})).filter((function(e){return null!=e})).join(" + "):"null"},Ic=function(e){if(null==e)return[void 0,[]];var t=[],r="case_value"==e.valueType?e.value:e;return[(Array.isArray(r)?r:[r]).map((function(e){return"value"===e.valueSrc?null===e.value?void 0:{type:"const",value:e.value}:"field"===e.valueSrc?{type:e.isVariable?"variable":"property",value:e.value}:void t.push("Unsupported valueSrc ".concat(e.valueSrc," in concatenation"))})).filter((function(e){return null!=e})),t]},Ac=function(e){return null==e?"NULL":e.toString()},jc=function(e){return null==e||"("===(null==e?void 0:e[0])&&")"===(null==e?void 0:e[(null==e?void 0:e.length)-1])?e:"("+e+")"};function Pc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Lc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Lc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Lc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function kc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Nc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?kc(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):kc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Dc="${0}.compareTo(${1})",Fc={datetime:!0,time:!0,date:!0},Mc=function(e,t){return Vc(e,t,!1)},Vc=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=Rg(t,void 0,!1),i=Uc(e,o,n,null);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SpEL:",n.errors),i)},Uc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return"group"===o||"rule_group"===o?$c(e,t,r,n):"rule"===o?qc(e,t,r,n):"switch_group"==o?zc(e,t,r,n):"case_group"==o?Bc(e,t,r,n):void 0}},Bc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type");if("case_group"==o){var i=e.get("properties")||new $a,a=lo(Kc(t,i,r,null,n,"!case_value"),3),s=a[0];return a[1],a[2],[$c(e,t,r,n),s]}r.errors.push("Unexpected child of type ".concat(o," inside switch"))},zc=function(e,t,r){e.get("properties")||new $a;var n=e.get("children1");if(n){var o=n.map((function(e){return Bc(e,t,r,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray();if(o.length){if(1==o.length&&!o[0][0])return o[0][1];for(var i=[],a=0;a<o.length;a++)a==o.length-1||o[a][0]?(i.push(o[a]),a==o.length-1&&o[a][0]&&i.push([void 0,null])):r.errors.push("No condition for case ".concat(a));for(var s="",l="",u=0;u<i.length;u++){var c=lo(i[u],2),d=c[0],p=c[1];null==p&&(p="null"),null==d&&(d="true"),u!=i.length-1?(s+="(".concat(d," ? ").concat(p," : "),l+=")"):s+="".concat(p)}return s+l}}},$c=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type"),i=e.get("properties")||new $a,a=i.get("mode"),s=e.get("children1")||new fs,l=i.get("field"),u=i.get("conjunction");u||(u=Nd(t));var c=t.conjunctions[u],d=i.get("not"),p="rule_group"===o,f=p&&"struct"!=a,h=f?l:n,g=(ev(t,h)||{}).isSpelArray,v=t.settings.fieldSeparator,m=i.get("operator");m||a&&"some"!=a||(m="some");var y=Hc(t,m,l),b=y!=m,O=m&&tv(t,y,l)||null,E=p&&(!y||0==O.cardinality),S=lo(Kc(t,i,r,y,n,null),3),w=S[0],T=S[1],x=S[2],_=s.map((function(e){return Uc(e,t,r,h)})).filter((function(e){return void 0!==e}));if(f&&!E){if(null==w)return}else if(!_.size)return;var C,R=p,I=_.size?c.spelFormatConj.call(t.ctx,_,u,d,R):null;if(f){var A=Xc(r,t,l,n),j=(v||".")+(g?"length":"size()"),P="".concat(A).concat(j),L=I?"".concat(A,".?[").concat(I,"]").concat(j):P;C=Wc(r,t,i,L,E?P:w,y,T,x,b)}else C=I;return C},Wc=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=r.get("field"),c=tv(t,i,u)||{},d=ev(t,u)||{},p=r.get("operatorOptions"),f=c.spelFormatOp||function(e,t,r){var n=t.spelOp;if(n){var o,i=n.includes("${0}"),a=Fc[r],s=n,l=Vl(t);return a?o=function(e,t,r,n,o,i,a,u){var c=Dc.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}));return"".concat(c," ").concat(s," 0")}:i?o=function(e,t,r,o,i,a,s,u){return n.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}))}:0==l?o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s)}:1==l&&(o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s," ").concat(r)}),o}}(0,c,s);if(f){var h,g=[n,i,o,a,s,Ml(c,Nl),p,d];return h=f.call.apply(f,[t.ctx].concat(g)),l&&(h=t.settings.spelFormatReverse.call(t.ctx,h)),void 0===h&&e.errors.push("Operator ".concat(i," is not supported for value source ").concat(a)),h}e.errors.push("Operator ".concat(i," is not supported"))},Hc=function(e,t,r){if(t){var n=tv(e,t,r)||{},o=n.reversedOp,i=tv(e,o,r)||{},a=n.spelOp||n.spelFormatOp,s=i.spelOp||i.spelFormatOp;if(a||s){if(!a&&s){var l=[o,t];t=l[0],o=l[1];var u=[i,n];n=u[0],i=u[1]}return t}}},qc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new $a,i=o.get("field"),a=o.get("fieldSrc"),s=o.get("operator");if(null!=i&&null!=s){var l=Hc(t,s,i);if(l){var u=l!=s,c=lo(Kc(t,o,r,l,n,null),3),d=c[0],p=c[1],f=c[2];if(void 0!==d){var h=Gc(r,t,i,a,n);if(void 0!==h)return Wc(r,t,o,h,d,l,p,f,u)}}else r.errors.push("Operator ".concat(s," is not supported"))}},Gc=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;return"func"===n?Qc(e,t,r,o):Xc(e,t,r,o)},Kc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u,c=ev(e,a)||{},d=tv(e,n,a)||{},p=Vl(d),f=t.get("value"),h=t.get("asyncListValues"),g=[],v=[];if(null!=f){var m=f.map((function(t,i){var u=s?s.get(i):null,p=l?l.get(i):null,f=Ph(t,u,e),m=Eh(e,a,n,u),y=rv(e,a,n,m,u,{forExport:!0}),b=Yc(r,e,f,u,p,y,c,n,d,o,h);return void 0!==b&&(g.push(u),v.push(p)),b})),y=m.filter((function(e){return void 0===e})).size>0;m.size<p||y||(u=p>1?m.toArray():1==p?m.first():null)}return[u,g.length>1?g:g[0],v.length>1?v:v[0]]},Yc=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"===n)d=Xc(e,t,r,u);else if("func"===n)d=Qc(e,t,r,u);else if("function"==typeof(null==i?void 0:i.spelFormatValue)){var p=i.spelFormatValue,f=[r,Nc(Nc({},lu()(a,["fieldSettings","listValues"])),{},{asyncListValues:c}),Ml(i,kl)];if(s&&(f.push(s),f.push(l)),"field"==n){var h=ev(t,r)||{};f.push(h)}d=p.call.apply(p,[t.ctx].concat(f))}else d=Cc(r);return d}},Xc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(r){var o=t.settings.fieldSeparator,i=ev(t,r)||{},a=Kg(r,t),s=gh(r,t,n),l=t.settings.formatSpelField,u=Sh(r,t,e,n),c=s.map((function(e){var t,r=lo(e,3),n=r[0],i=r[1],a=r[2];return a&&(t="!struct"==a.type||"!group"==a.type&&"struct"==a.mode?i.isSpelMap?"map":"class":"!group"==a.type?i.isSpelItemMap?"[map]":"[class]":"class"),{key:n,parent:t,isSpelVariable:null==i?void 0:i.isSpelVariable,fieldSeparator:o}}));return l.call(t.ctx,u,n,a,c,i,t)}},Qc=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=Wg(t,a);if(l){var u={},c=[],d=[];for(var p in l.args){var f,h,g=l.args[p],v=ev(t,g),m=g.defaultValue,y=g.isOptional,b=null!=m&&m.func?"func":"value",O=s?s.get(p):void 0,E=O?O.get("value"):void 0,S=O?O.get("valueSrc"):void 0;"func"!==S&&null!==(f=E)&&void 0!==f&&f.toJS&&(E=E.toJS());var w=O?O.get("asyncListValues"):void 0,T=null===(h=g.spelEscapeForFormat)||void 0===h||h,x=null,_=Eh(t,g,x,S),C=rv(t,g,x,_,S,{forExport:!0}),R=Yc(e,t,E,S,g.type,C,v,null,null,i,w);if(null!=E&&void 0===R)return void("func"!=S&&e.errors.push("Can't format value of arg ".concat(p," for func ").concat(a)));var I=void 0;if(void 0===R&&!y&&null!=m){var A=Eh(t,g,x,b),j=rv(t,g,x,A,b,{forExport:!0});if(void 0===(I=Yc(e,t,m,b,g.type,j,v,null,null,i,w)))return void("func"!=b&&e.errors.push("Can't format default value of arg ".concat(p," for func ").concat(a)))}var P=null!=R?R:I;if(void 0!==P){var L;if(c.length){var k,N=Pc(c);try{for(N.s();!(k=N.n()).done;){var D=k.value;u[D]=void 0}}catch(e){N.e(e)}finally{N.f()}c=[]}u[p]=T?P:null!==(L=E)&&void 0!==L?L:m}else y||d.push(p),c.push(p)}if(!d.length){var F;if("function"==typeof l.spelFormatFunc){var M=l.spelFormatFunc,V=[u];F=M.call.apply(M,[t.ctx].concat(V))}else if(l.spelFunc){F=l.spelFunc.replace(/\${(\w+)}/g,(function(e,t){var r;return null!==(r=u[t])&&void 0!==r?r:e}));var U,B=Object.keys(l.args||{}).reverse().filter((function(e){return!!l.args[e].isOptional})),z=Pc(B);try{for(z.s();!(U=z.n()).done;){var $=U.value;if(null!=u[$])break;F=F.replace(new RegExp("(, )?\\${"+$+"}","g"),"")}}catch(e){z.e(e)}finally{z.f()}F=F.replace(/\${(\w+)}/g,"null")}else e.errors.push("Func ".concat(a," is not supported"));return F}}else e.errors.push("Func ".concat(a," is not defined in config"))};function Jc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Zc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Zc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Zc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function ed(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function td(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ed(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ed(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var rd={number:"number",string:"text",boolean:"boolean",null:"null"},nd={String:"text"},od=function(e){return"object"==Kn(e)&&null!==e&&!Array.isArray(e)},id=function(e,t){return ad(e,t,!0)},ad=function(e,t){var r,n,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i={errors:[]},a=Rg(t,void 0,!1),s=ud(a),l=void 0;try{r=Ec.SpelExpressionEvaluator.compile(e)._compiledExpression}catch(e){i.errors.push(e)}r&&(n=sd(r,i),ou.debug("convertedObj:",n,i),(l=cd(n,s,a,i))&&"group"!=l.type&&"switch_group"!=l.type&&(l=xd(l,a,n.not)),ou.debug("jsTree:",l));var u=l?Bu(l):void 0;return o?[u,i.errors]:(i.errors.length&&console.warn("Errors while importing from SpEL:",i.errors),u)},sd=function e(t,r){var n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=t.getType(),a=t.getChildren().map((function(n){return e(n,r,t)}));if("op-or"!=i&&"op-and"!=i||(a=a.reduce((function(e,t){var r=t.type!=i||t.not?[t]:t.children;return[].concat(co(e),co(r))}),[])),"op-not"==i)return 1!=a.length&&r.errors.push("Operator NOT should have 1 child, but got ".concat(a.length,"}")),td(td({},a[0]),{},{not:!a[0].not});if("compound"==i){var s=(a=a.filter((function(e){return!("selection"==e.type&&1==e.children.length&&"boolean"==e.children[0].type&&1==e.children[0].val)}))).find((function(e){return"selection"==e.type}));s&&1!=s.children.length&&r.errors.push("Selection should have 1 child, but got ".concat(s.children.length));var l=s?s.children[0]:null,u=a[a.length-1],c="method"==u.type&&"size"==u.val.methodName||"!func"==u.type&&"size"==u.methodName,d="property"==u.type&&"length"==u.val,p=a.filter((function(e){return e!==s&&e!==u})),f={type:"compound",children:p};if((c||d)&&null!=pd(p))return{type:"!aggr",filter:l,source:f};if(a=(a=a.filter((function(e){var t="variable"==e.type&&"this"==e.val,r="variable"==e.type&&"root"==e.val;return!(t||r)}))).map((function(e){return"indexer"==e.type&&1==e.children.length?{type:"indexer",val:e.children[0].val,itype:e.children[0].type}:e})),"!func"==u.type){var h={},g=h;do{var v,m;Object.assign(g,u),a=a.filter((function(e){return e!==u})),"!func"==(null===(m=u=a[a.length-1])||void 0===m?void 0:m.type)?(g.obj={},g=g.obj):a.length>1?g.obj={type:"compound",children:a}:g.obj=u}while("!func"==(null===(v=u)||void 0===v?void 0:v.type));return h}}try{t.getRaw?n=t.getRaw():0==t.getValue.length&&(n=t.getValue())}catch(e){ou.error("[spel2js] Error in getValue()",e)}if("ternary"==i&&(n=ld(a)),"object"===Kn(n)&&null!==n&&(n.methodName||n.functionName)&&(n.args=n.args.map((function(n){return e(n,r,t)}))),"list"==i&&(n=n.map((function(n){return e(n,r,t)})),!o&&1==n.length))return n[0];if("constructorref"==i){var y=a.find((function(e){return"qualifiedidentifier"==e.type})),b=null==y?void 0:y.val;return b?{type:"!new",cls:b,args:a.filter((function(e){return"qualifiedidentifier"!=e.type}))}:void r.errors.push("Can't find qualifiedidentifier in constructorref children: ".concat(JSON.stringify(a)))}if("typeref"==i){var O=a.find((function(e){return"qualifiedidentifier"==e.type})),E=null==O?void 0:O.val;return E?(a.filter((function(e){return"qualifiedidentifier"!=e.type})),{type:"!type",cls:E}):void r.errors.push("Can't find qualifiedidentifier in typeref children: ".concat(JSON.stringify(a)))}if("function"==i||"method"==i){var S=n,w=S.functionName,T=S.methodName,x=S.args;return{type:"!func",methodName:w||T,isVar:"function"==i,args:x}}return{type:i,children:a,val:n}},ld=function(e){var t=[];return function e(r){var n=lo(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]),"ternary"==(null==a?void 0:a.type)?e(a.children):t.push([void 0,a])}(e),t},ud=function(e){var t={},r=function(r){var n=e.operators[r];if(n.spelOps)n.spelOps.forEach((function(e){var n=e;t[n]||(t[n]=[]),t[n].push(r)}));else if(n.spelOp){var o=n.spelOp;t[o]||(t[o]=[]),t[o].push(r)}else ou.log("[spel] No spelOp for operator ".concat(r))};for(var n in e.operators)r(n);var o={};for(var i in e.conjunctions)o[e.conjunctions[i].spelConj||i.toLowerCase()]=i;var a,s={},l=Jc(Mg(e));try{var u=function(){var e=lo(a.value,2),t=e[0],r=e[1],n=[],o=r.spelFunc;if("string"==typeof o){var i=Object.keys(r.args||{}).reverse().filter((function(e){return!!r.args[e].isOptional||null!=r.args[e].defaultValue})),l=o.replace(/\${(\w+)}/g,(function(e,t){return"?"})),u=i.reduce((function(e,t){return[].concat(co(e),[[t].concat(co(e[e.length-1]||[]))])}),[]).map((function(e){return o.replace(/(?:, )?\${(\w+)}/g,(function(t,r){return e.includes(r)?"":t})).replace(/\${(\w+)}/g,(function(e,t){return"?"}))}));n=[l].concat(co(u))}var c,d=Jc(n);try{for(d.s();!(c=d.n()).done;){var p=c.value;s[p]||(s[p]=[]),s[p].push(t)}}catch(e){d.e(e)}finally{d.f()}};for(l.s();!(a=l.n()).done;)u()}catch(e){l.e(e)}finally{l.f()}var c={};for(var d in e.widgets){var p=e.widgets[d],f=p.spelImportFuncs;if(p.type,f){var h,g=Jc(f);try{for(g.s();!(h=g.n()).done;){var v=h.value;if("string"==typeof v){var m=v.replace(/\${(\w+)}/g,(function(e,t){return"?"})),y=co(v.matchAll(/\${(\w+)}/g)).map((function(e){var t=lo(e,2);return t[0],t[1]}));c[m]||(c[m]=[]),c[m].push({w:d,argsOrder:y})}}}catch(e){g.e(e)}finally{g.f()}}}var b={};for(var O in e.operators){var E=e.operators[O].spelOp;if(null!=E&&E.includes("${0}")){var S=E.replace(/\${(\w+)}/g,(function(e,t){return"?"})),w=co(E.matchAll(/\${(\w+)}/g)).map((function(e){var t=lo(e,2);return t[0],t[1]}));b[S]||(b[S]=[]),b[S].push({op:O,argsOrder:w})}}return b[Dc.replace(/\${(\w+)}/g,(function(e,t){return"?"}))]=[{op:"!compare",argsOrder:["0","1"]}],{operators:t,conjunctions:o,funcs:s,valueFuncs:c,opFuncs:b}},cd=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(t){t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==a?void 0:a._groupField;var s,l=!0;if(0===t.type.indexOf("op-")||"matches"===t.type)s=dd(t,r,n,o,a);else if("!aggr"==t.type){var u,c=e(t.source,r,n,o,t);t._groupField=null==c?void 0:c.value;var d=e(t.filter,r,n,o,t);"rule"==(null===(u=d)||void 0===u?void 0:u.type)&&(d=xd(d,n,t.filter.not)),s={groupFilter:d,groupFieldValue:c},a||(s=void 0,o.errors.push("Unexpected !aggr in root"),l=!1)}else if("ternary"==t.type){var p={};t.val.forEach((function(e){var i=lo(e,2),a=i[0],s=i[1],l=Sd(a,s,r,n,o,t);l&&(p[l.id]=l)})),s={type:"switch_group",id:Pl(),children1:p,properties:{}}}if(!s&&l&&(s=fd(t,r,n,o,a)),s&&!s.type&&!a){var f=Ed(t,r,n,o);f?s=f:(s=void 0,o.errors.push("Can't convert rule of type ".concat(t.type,", it looks like var/literal")))}return s}},dd=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,s=t.type.startsWith("op-")?t.type.slice(3):t.type;if(("minus"==s||"plus"==s)&&1==t.children.length){var l=t.negative;return"minus"==s&&(l=!l),t.children[0].negative=l,cd(t.children[0],r,n,o,a)}var u="and"==s&&2==t.children.length&&"op-ge"==t.children[0].type&&"op-le"==t.children[1].type,c="or"==s&&2==t.children.length&&"op-lt"==t.children[0].type&&"op-gt"==t.children[1].type;if(u||c){var d=lo(t.children[0].children,2),p=d[0],f=d[1],h=lo(t.children[1].children,2),g=h[0],v=h[1];if(Od(p,g,t,r,n,o,a)){f.val,v.val;var m={type:"op-between",children:[p,f,v],not:c};return m._groupField=null==a?void 0:a._groupField,e(m,r,n,o,a)}}var y=r.operators[s];"eq"==s&&"null"==t.children[1].type?y=["is_null"]:"ne"==s&&"null"==t.children[1].type?y=["is_not_null"]:"le"==s&&"string"==t.children[1].type&&""==t.children[1].val?y=["is_empty"]:"gt"==s&&"string"==t.children[1].type&&""==t.children[1].val?y=["is_not_empty"]:"between"==s&&(y=["between"]);var b=function(){var e,i=t.children.map((function(e){return cd(e,r,n,o,t)}));return i.length>=2&&"!compare"==(null===(e=i)||void 0===e||null===(e=e[0])||void 0===e?void 0:e.type)&&(i=i[0].children),i};if("and"==s||"or"==s){var O={};b().forEach((function(e){if(e){var t=Pl();e.id=t,null!=e.type?O[t]=e:o.errors.push("Bad item in AND/OR: ".concat(JSON.stringify(e)))}})),i={type:"group",id:Pl(),children1:O,properties:{conjunction:r.conjunctions[s],not:t.not}}}else if(y){var E,S,w,T=b(),x=T[0],_=T.slice(1),C=null==x||null===(E=x.groupFieldValue)||void 0===E?void 0:E.value,R=null===(S=_)||void 0===S?void 0:S[0],I=y[0];if(y.length>1){var A,j,P=(null===(A=T[0])||void 0===A?void 0:A.valueType)||(null===(j=T[1])||void 0===j?void 0:j.valueType),L=null==x?void 0:x.value,k=y.map((function(e){return{op:e,widget:Eh(n,L,e)}}));if(ou.warn("[spel] Spel operator ".concat(s," can be mapped to ").concat(y,"."),"widgets:",k,"vals:",T,"valueType=",P),"eq"==s||"ne"==s){var N=k.find((function(e){e.op;var t=e.widget;return t&&"field"!=t}));N&&(I=N.op)}}null!=x&&x.groupFieldValue&&(R&&R.groupFieldValue&&"field"==R.groupFieldValue.valueSrc&&R.groupFieldValue.value==C?(I="all",_=[]):"equal"==I&&"value"==R.valueSrc&&"number"==R.valueType&&0==R.value?(I="none",_=[]):"greater"==I&&"value"==R.valueSrc&&"number"==R.valueType&&0==R.value&&(I="some",_=[]));var D=n.operators[I],F=n.operators[null===(w=D)||void 0===w?void 0:w.reversedOp],M=t.not&&["between"].includes(I),V=!!F&&(!!n.settings.reverseOperatorsForNot||M);(t.not&&V||M)&&(I=D.reversedOp,D=n.operators[I],t.not=!t.not);var U=!!t.not;if(t.not=!1,x)if(x.groupFieldValue)"field"!=x.groupFieldValue.valueSrc&&o.errors.push("Expected group field ".concat(JSON.stringify(x))),i=bd(x,I,_,n,o);else{"field"!=x.valueSrc&&"func"!=x.valueSrc&&o.errors.push("Expected field/func at LHS, but got ".concat(JSON.stringify(x)));var B=x.value;i=yd(n,o,B,I,_,t)}U&&("group"!==i.type?i=xd(i,n,!0):i.properties.not=!i.properties.not)}else a||(i=Ed(t,r,n,o));return i},pd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=e.map((function(e){if("variable"==e.type||"property"==e.type||"indexer"==e.type&&"string"==e.itype)return e.val;var o,i;n=!0,r&&(null==t||null===(o=t.errors)||void 0===o||null===(i=o.push)||void 0===i||i.call(o,"Unexpected item in field path compound: ".concat(JSON.stringify(e))))}));return n?void 0:o},fd=function e(t,r,n,o){var i,a,s=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(null!=t){var l=n.settings.fieldSeparator;if(t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==s?void 0:s._groupField,"variable"==t.type||"property"==t.type){var u=zg(n,t.val,t._groupField),c=ev(n,u),d="variable"==t.type;return{valueSrc:"field",valueType:null==c?void 0:c.type,isVariable:d,value:u}}if("compound"==t.type){var p=pd(t.children,o);if(p){var f,h=zg(n,p.join(l),t._groupField),g=ev(n,h),v="variable"==(null===(f=t.children)||void 0===f||null===(f=f[0])||void 0===f?void 0:f.type);return{valueSrc:"field",valueType:null==g?void 0:g.type,isVariable:v,value:h}}}else{if(rd[t.type]){var m=t.val,y=rd[t.type];return t.negative&&(m=-m),{valueSrc:"value",valueType:y,value:m}}if("!new"==t.type&&nd[t.cls.at(-1)]){var b=t.args.map((function(i){return e(i,r,n,o,t)})),O=null==b?void 0:b[0],E=nd[t.cls.at(-1)];return td(td({},O),{},{valueType:E})}if("list"==t.type){var S,w=t.val.map((function(i){return e(i,r,n,o,t)}));return w.length&&(null===(S=w[0])||void 0===S||S.valueType),{valueSrc:"value",valueType:"multiselect",value:w.map((function(e){return null==e?void 0:e.value}))}}if("op-plus"===t.type&&"ternary"===(null==s?void 0:s.type)&&"case_value"===(null===(a=n.settings.caseValueField)||void 0===a?void 0:a.type))return wd(t,r,n,o)}var T=gd(t,r,n,o,s);if(void 0!==T)return T;o.errors.push("Can't convert arg of type ".concat(t.type))}},hd=function e(t,r){var n,o=[],i="",a=t.type,s=t.methodName,l=(t.val,t.obj),u=t.args,c=t.isVar,d=t.cls,p=t.children,f=null==p?void 0:p[p.length-1],h=r[r.length-1];if("!func"===a){for(var g=l;g;){var v,m=lo(e(td(td({},g),{},{obj:null}),[{}]),2),y=m[0],b=m[1];if("?"!==y){var O={s:h.s,params:co(h.params),objs:co(h.objs)};h.objs.unshift("?"),h.params.unshift(g),r.push(O),h=r[r.length-1]}h.objs.unshift(y),(v=h.params).unshift.apply(v,co(b)),g="!func"===g.type?g.obj:null}var E,S=Jc(r);try{for(S.s();!(E=S.n()).done;){var w,T=E.value;o=[].concat(co((null==T?void 0:T.params)||[]),co(u||[])),i="",null!=T&&null!==(w=T.objs)&&void 0!==w&&w.length&&(i+=T.objs.join(".")+"."),i+=(c?"#":"")+s,i+="("+(u||[]).map((function(e){return"?"})).join(", ")+")",T.s=i,T.params=o}}catch(e){S.e(e)}finally{S.f()}}else"!new"===a?(o=u||[],i="new ".concat(d.join("."),"(").concat(o.map((function(e){return"?"})).join(", "),")")):"!type"===a?i="T(".concat(d.join("."),")"):"compound"===a&&"property"===f.type&&(n=f.val,["length"].includes(n))?i=p.map((function(t){var r;if(t===f)return t.val;var n=lo(e(td(td({},t),{},{obj:null}),[{}]),2),i=n[0],a=n[1];return(r=o).push.apply(r,co(a)),i})).join("."):(o=[t],i="?");return h&&(h.s=i,h.params=o),[i,o]},gd=function(e,t,r,n){var o,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=function(o){return cd(o,t,r,n,e)},s=function(e){var t=[{s:"",params:[],objs:[]}];return hd(e,t),t.map((function(e){return{s:e.s,params:e.params}})).reverse().filter((function(e){var t=e.s;return""!==t&&"?"!==t}))}(e),l=null==s||null===(o=s[0])||void 0===o?void 0:o.s;s.length&&ou.debug("Signatures for ",e,":",l,s);var u=vd(e,t,r,n,i,s,a);if(void 0!==u)return u;var c,d,p,f=md(e,t,r,n,i,s,a);if(void 0!==f)return f;var h,g=Jc(s);try{var v=function(){var e=h.value,n=e.s,o=e.params,i=t.funcs[n];if(i){c=i[0];var s=(d=Wg(r,c)).spelFunc,l=o.map(a),u=co(s.matchAll(/\${(\w+)}/g)).map((function(e){var t=lo(e,2);return t[0],t[1]}));return p=Object.fromEntries(u.map((function(e,t){return[e,l[t]]}))),1}};for(g.s();!(h=g.n()).done&&!v(););}catch(e){g.e(e)}finally{g.f()}if(!c){var m,y=Jc(Mg(r));try{for(y.s();!(m=y.n()).done;){var b=lo(m.value,2),O=b[0],E=b[1];if(E.spelImport){var S=void 0;try{S=E.spelImport(e)}catch(e){}if(S)for(var w in d=Wg(r,c=O),p={},S)p[w]=a(S[w])}}}catch(e){y.e(e)}finally{y.f()}}if(c){var T={};for(var x in d.args){var _,C=d.args[x],R=p[x];if(void 0===R)if(void 0===(R=null==C?void 0:C.defaultValue)){if(null==C||!C.isOptional)return void n.errors.push("No value for arg ".concat(x," of func ").concat(c))}else R={value:R,valueSrc:null!==(_=R)&&void 0!==_&&_.func?"func":"value",valueType:C.type};R&&(T[x]=R)}return{valueSrc:"func",value:{func:c,args:T},valueType:d.returnType}}e.methodName&&n.errors.push("Signature ".concat(l," - failed to convert"))},vd=function(e,t,r,n,o,i,a){var s,l,u,c=[];for(var d in r.widgets){var p=r.widgets[d].spelImportFuncs;if(p)for(var f=0;f<p.length;f++){var h=p[f];if(od(h)){var g={};if(tu(h,e,g)){for(var v in g)g[v]=a(g[v]);c.push({s:"widgets.".concat(d,".spelImportFuncs[").concat(f,"]"),w:d,argsObj:g})}}}}var m,y=Jc(i);try{for(y.s();!(m=y.n()).done;){var b,O=m.value,E=O.s,S=O.params,w=Jc(t.valueFuncs[E]||[]);try{var T=function(){var e=b.value,t=e.w,r=e.argsOrder,n=S.map(a),o=Object.fromEntries(r.map((function(e,t){return[e,n[t]]})));c.push({s:E,w:t,argsObj:o})};for(w.s();!(b=w.n()).done;)T()}catch(e){w.e(e)}finally{w.f()}}}catch(e){y.e(e)}finally{y.f()}for(var x=0,_=c;x<_.length;x++){var C=_[x],R=C.s,I=C.w,A=C.argsObj,j=r.widgets[I],P=j.spelImportValue,L=j.type;for(var k in u=I,l=R,s=[],A)["value"].includes(A[k].valueSrc)||s.push("".concat(k," has unsupported value src ").concat(A[k].valueSrc));var N=A.v.value;if(P&&!s.length){var D=lo(P.call(r.ctx,A.v,j,A),2);N=D[0],(s=D[1])&&!Array.isArray(s)&&(s=[s])}if(!s.length)return{valueSrc:"value",valueType:L,value:N}}u&&s.length&&n.errors.push("Signature ".concat(l," - looks like convertable to ").concat(u,", but: ").concat(s.join("; ")))},md=function(e,t,r,n,o,i,a){var s,l,u,c,d=Jc(i);try{for(d.s();!(c=d.n()).done;){var p,f=c.value,h=f.s,g=f.params,v=Jc(t.opFuncs[h]||[]);try{var m,y=function(){var t,i=p.value,c=i.op,d=i.argsOrder,f=g.map(a);if(l=c,"!compare"===c){if(o.type.startsWith("op-")&&2==o.children.length&&"number"==o.children[1].type&&0===o.children[1].val)return{v:{type:"!compare",children:f}};s.push("Result of compareTo() should be compared to 0")}u=h,s=[];var v=r.operators[l],m=(v.spelOp,v.valueTypes),y=Object.fromEntries(d.map((function(e,t){return[e,f[t]]}))),b=y[0],O=Object.keys(y).filter((function(e){return parseInt(e)>0})).map((function(e){return y[e]})),E=null===(t=f.filter((function(e){return!!e})).find((function(e){return"value"===e.valueSrc})))||void 0===t?void 0:t.valueType;if(m&&E&&!m.includes(E)&&s.push("Op supports types ".concat(m,", but got ").concat(E)),!s.length)return{v:yd(r,n,b,l,O,e)}};for(v.s();!(p=v.n()).done;)if(m=y())return m.v}catch(e){v.e(e)}finally{v.f()}}}catch(e){d.e(e)}finally{d.f()}l&&s.length&&n.errors.push("Signature ".concat(u," - looks like convertable to ").concat(l,", but: ").concat(s.join("; ")))},yd=function(e,t,r,n,o,i){var a,s;if(!o.filter((function(e){return void 0===e})).length){var l=null!==(a=r)&&void 0!==a&&a.func?"func":"field";od(r)&&r.valueSrc&&(l=r.valueSrc,r=r.value);var u=ev(e,r);if(u){var c=ev(e,null==i?void 0:i._groupField),d="!group"==u.type,p=(d&&u.mode,"!group"==(null==c?void 0:c.type)),f=e.operators[n],h=e.operators[null===(s=f)||void 0===s?void 0:s.reversedOp],g=(null==i?void 0:i.not)&&["between"].includes(n),v=!!h&&(!!e.settings.reverseOperatorsForNot||g||!d&&p);((null==i?void 0:i.not)&&v||g)&&(n=f.reversedOp,f=e.operators[n],i.not=!i.not);var m=!(null==i||!i.not),y=Eh(e,r,n),b=e.widgets[y||u.mainWidget],O=o.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),E=O.length?O[0]:void 0,S={type:"rule",id:Pl(),properties:td({field:r,fieldSrc:l,operator:n,value:o.map((function(e){return e.value})),valueSrc:o.map((function(e){return e.valueSrc})),valueType:o.map((function(e){return"value"==e.valueSrc&&((null==b?void 0:b.type)||(null==u?void 0:u.type))||e.valueType}))},E?{asyncListValues:E}:{})};return m&&(S=xd(S,e,i.not)),S}t.errors.push("No config for field ".concat(r))}},bd=function(e,t,r,n,o){var i=e.groupFilter,a=e.groupFieldValue;if("field"!=a.valueSrc)throw"Bad groupFieldValue: ".concat(JSON.stringify(a));var s=a.value,l=yd(n,o,s,t,r);if(l){var u,c=ev(n,s),d=null==c?void 0:c.mode;return(u="group"===(null==i?void 0:i.type)?td(td({},i||{}),{},{type:"rule_group",properties:td(td(td({},l.properties),(null==i?void 0:i.properties)||{}),{},{mode:d})}):td(td({},l||{}),{},i?{type:"rule_group",children1:[i],properties:td(td({},l.properties),{},{mode:d})}:{type:"rule_group",properties:td(td({},l.properties),{},{mode:d})})).id||(u.id=Pl()),u}},Od=function(e,t,r,n,o,i){if(e.type==t.type){if("!aggr"==e.type){var a=lo([e.source,t.source].map((function(e){return fd(e,n,o,i,r)})),2),s=a[0],l=a[1];return s.value==l.value}var u=lo([e,t].map((function(e){return fd(e,n,o,i,r)})),2),c=u[0],d=u[1];return c.value==d.value}return!1},Ed=function(e,t,r,n){var o={},i=Sd(null,e,t,r,n);return i&&(o[i.id]=i),{type:"switch_group",id:Pl(),children1:o,properties:{}}},Sd=function(e,t,r,n,o){var i,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,s=Td(n,o,r,t,a);return e?(i=cd(e,r,n,o,a))&&i.type?("group"!=i.type&&(i=xd(i,n)),i.type="case_group"):(o.errors.push("Unexpected case: ".concat(JSON.stringify(i))),i=void 0):i={id:Pl(),type:"case_group",properties:{}},i&&(i.properties=td(td({},i.properties),s)),i},wd=function(e,t,r,n){var o=[];return function i(a){a.map((function(a){if("op-plus"===a.type)i(a.children);else{var s=fd(a,t,r,n,e);s?o.push(s):n.errors.push("Can't convert ".concat(a.type," in concatenation"))}}))}(e.children),{valueSrc:"value",valueType:"case_value",value:o}},Td=function(e,t,r,n){var o,i,a,s,l,u,c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d={},p=ev(e,"!case_value");"op-plus"===(null==n?void 0:n.type)&&"case_value"===(null===(o=e.settings.caseValueField)||void 0===o?void 0:o.type)?(s="case_value",a=wd(n,r,e,t)):(s=null==p?void 0:p.mainWidget,l=e.widgets[s],(a=fd(n,r,e,t,c))&&"value"===a.valueSrc&&(a.valueType=(null===(u=l)||void 0===u?void 0:u.type)||(null==p?void 0:p.type)||a.valueType));var f=e.widgets[s];if("case_value"===s){var h=null==f?void 0:f.spelImportValue;if(h){var g,v=lo(h.call(e.ctx,a),2),m=v[0];v[1].map((function(e){return t.errors.push(e)})),null!=m&&(d={value:[m],valueSrc:["value"],valueType:[null!==(g=null==f?void 0:f.type)&&void 0!==g?g:"case_value"],field:"!case_value"})}}else null!=a&&null!=(null===(i=a)||void 0===i?void 0:i.value)&&(d={value:[a.value],valueSrc:[a.valueSrc],valueType:[a.valueType],field:"!case_value"});return d},xd=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Pl(),children1:no({},e.id,e),properties:{conjunction:Nd(t),not:r||!1}}};function _d(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Cd(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_d(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_d(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Rd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=e.settings.defaultField,o=(r?Id(e,r):n)||t&&nv(e,r)||null;return null==o||"string"==typeof o||zl(o)||(o=Wu(o)),o},Id=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!r)return null;var n=(null==e||null===(t=e.settings)||void 0===t?void 0:t.fieldSeparator)||".",o=ev(e,r),i=null==o?void 0:o.defaultField;return i&&(i=[].concat(co(Kg(r)),[i]).join(n)),i},Ad=function(e){var t;return(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(null===(t=e.settings.fieldSources)||void 0===t?void 0:t[0])||"field"},jd=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=ev(e,t),o=(null==n?void 0:n.operators)||[],i=e.settings.defaultOperator;i&&!o.includes(i)&&(i=null);var a=null==n?void 0:n.defaultOperator,s=null==n?void 0:n.ownDefaultOperator,l=r?dh(e,t):null;return s||i||a||l},Pd=function(e,t,r){var n=t?tv(e,t,r):null;return n&&n.options?new Al.Map(n.options&&n.options.defaults||{}):null},Ld=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],s=arguments.length>4&&void 0!==arguments[4]&&arguments[4],l=null,u=null,c=null,d=e.settings.showErrorMessage;i?(c=null==i||null===(t=i.properties)||void 0===t?void 0:t.fieldSrc,l=null==i||null===(r=i.properties)||void 0===r?void 0:r.field,u=null==i||null===(n=i.properties)||void 0===n?void 0:n.operator):a?(c=(l=Rd(e,s,o))?zl(l)?"func":"field":Ad(e),u=jd(e,l,!0)):c=Ad(e);var p=new Al.Map({fieldSrc:c,field:l,operator:u,value:new Al.List,valueSrc:new Al.List,operatorOptions:Pd(e,u,l)});if(d&&(p=p.set("valueError",new Al.List)),l&&u){var f=Jf(e,e,p,l,u,"operator",!1),h=f.newValue,g=f.newValueSrc,v=f.newValueType,m=f.newValueError,y=f.newFieldError;p=p.set("value",h).set("valueSrc",g).set("valueType",v),d&&(p=p.set("valueError",m).set("fieldError",y))}return p},kd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(t=ev(e,t))&&t.conjunctions||Object.keys(e.conjunctions);return 1==r.length?r[0]:e.settings.defaultGroupConjunction||e.settings.defaultConjunction||r[0]},Nd=function(e){return e.settings.defaultConjunction||Object.keys(e.conjunctions)[0]},Dd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return new Al.Map({conjunction:kd(e,t),not:!1})},Fd=function(e,t){var r;return t&&"group"==t.type?Dd(e,null==t||null===(r=t.properties)||void 0===r?void 0:r.field):Ld(e,null,t)},Md=function(e,t){return no({},e,new Al.Map({type:"rule",id:e,properties:Ld(t)}))},Vd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];return new Al.Map({type:"group",id:Pl(),children1:new Al.OrderedMap(t?Cd({},Md(Pl(),e)):{}),properties:Dd(e)})},Ud=function(e){return $l(e)?e:Bd([e])},Bd=function(e){return $l(e)?e:new Al.List(e)},zd=function(){return new Al.Map};function $d(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Wd(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Wd(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Wd(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Hd(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function qd(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Hd(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Hd(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Gd=function(e,t){var r={errors:[],settings:{isForDisplay:arguments.length>2&&void 0!==arguments[2]&&arguments[2],isDebugMode:arguments.length>3&&void 0!==arguments[3]&&arguments[3]}},n=Rg(t,void 0,!1),o=Kd(e,n,r,null);return r.errors.length&&console.warn("Errors while exporting to string:",r.errors),o},Kd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return e.get("children1"),"group"===o||"rule_group"===o?Yd(e,t,r,n):"rule"===o?Xd(e,t,r,n):void 0}},Yd=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=r.settings,s=a.isForDisplay,l=a.isDebugMode,u=e.get("type"),c=e.get("properties")||new $a,d=c.get("mode"),p=e.get("children1")||new fs,f="rule_group"===u,h=f&&"array"==d?c.get("field"):null,g="rule_group"===u?c.get("operator"):null,v=g?null!==(n=null===(o=t.operators[g])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1:void 0,m=f&&"array"===d&&v>=1,y=c.get("not"),b=p.map((function(e){return Kd(e,t,r,h)})).filter((function(e){return void 0!==e}));if(m||b.size||l){var O=c.get("conjunction");O||(O=Nd(t));var E,S=t.conjunctions[O],w=b.size?S.formatConj.call(t.ctx,b,O,y,s):null;if(h){var T=Xd(e,t,r,i,!0);if(T){var x,_=T.pop(),C=[w].concat(co(T));E=(x=t.settings.formatAggr).call.apply(x,[t.ctx].concat(co(C))),_&&(E=t.settings.formatReverse.call(t.ctx,E,null,null,null,null,s))}}else E=w;return l&&null==E&&(E="?"),E}},Xd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=r.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.get("properties")||new $a,u=l.get("field"),c=l.get("fieldSrc"),d=l.get("operator"),p=l.get("operatorOptions");if(null!=u&&null!=d||s){var f=ev(t,u)||{},h=tv(t,d,u)||{},g=h.reversedOp,v=tv(t,g,u)||{},m=!1,y=h.formatOp;if(!y&&g&&(y=v.formatOp)){m=!0;var b=[g,d];d=b[0],g=b[1];var O=[v,h];h=O[0],v=O[1]}if(s&&!d&&(d="?"),y||(y=function(e,t,r){var n,o=r.settings.isDebugMode,i=(null==t?void 0:t.labelForFormat)||e,a=Vl(t);return 0==a?n=function(e,t,r,n,o,a,s,l){return"".concat(e," ").concat(i)}:1==a?n=function(e,t,r,n,a,s,l,u){return o&&"?"===t&&"?"===r?e&&"?"!==e?"".concat(e," ?"):"?":"".concat(e," ").concat(i," ").concat(r)}:2==a&&(n=function(e,t,r,n,o,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(i," ").concat(d," AND ").concat(p)}),n}(d,h,r)),y){var E="func"===c?Zd(t,r,u,n):Jd(t,r,u,n);if(null!=E){var S=function(e,t,r,n,o){var i,a,s=r.settings,l=(s.isForDisplay,s.isDebugMode),u=t.get("field"),c=t.get("valueSrc"),d=t.get("valueType"),p=ev(e,u)||{},f=n||t.get("operator"),h=tv(e,f,u)||{},g=Vl(h),v=t.get("value"),m=t.get("asyncListValues"),y=[],b=[];return null!=v&&!((a=v.map((function(t,n){var i=c?c.get(n):null,a=d?d.get(n):null,s=l?t:Ph(t,i,e),g=Eh(e,u,f,i),v=rv(e,u,f,g,i,{forExport:!0}),O=Qd(e,r,s,i,a,v,p,f,h,o,m);return void 0!==O&&(y.push(i),b.push(a)),O}))).filter((function(e){return void 0===e})).size>0)&&a.size===g&&(i=1==g?a.first():a),l&&!i&&(i=g>1?new fs(Array.from({length:g}).map((function(e,t){var r,n;return null!==(r=null===(n=a)||void 0===n?void 0:n.get(t))&&void 0!==r?r:"?"}))):"?"),[i,y.length>1?y:y[0],b.length>1?b:b[0]]}(t,l,r,d,n),w=lo(S,3),T=w[0],x=w[1],_=w[2];if(void 0!==T){var C=[E,d,T,x,_,Ml(h,Nl),p,a,f,m];if(o)return C;var R,I=(R=y).call.apply(R,[t.ctx].concat(C));return m&&(I=t.settings.formatReverse.call(t.ctx,I,d,g,h,v,a)),I}}}}},Qd=function(e,t,r,n,o,i,a,s,l){var u,c=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,d=arguments.length>10?arguments[10]:void 0,p=t.settings,f=p.isForDisplay,h=p.isDebugMode;if(void 0===r)return h?"array"===(null==i?void 0:i.jsType)?[]:"?":void 0;if("field"==n)u=Jd(e,t,r,c);else if("func"==n)u=Zd(e,t,r,c);else if("function"==typeof(null==i?void 0:i.formatValue)){var g=i.formatValue,v=[r,qd(qd({},lu()(a,["fieldSettings","listValues"])),{},{asyncListValues:d}),Ml(i,kl),f];if(s&&(v.push(s),v.push(l)),"field"==n){var m=ev(e,r)||{};v.push(m)}u=g.call.apply(g,[e.ctx].concat(v))}else u=r;return u},Jd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=t.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.settings,u=(l.fieldSeparator,l.fieldSeparatorDisplay),c=null;if(r){var d=ev(e,r)||{},p=Kg(r,e),f=hh(r,e,o?n:null),h=f?f.join(u):null,g=d.label2||h;c=(0,e.settings.formatField)(Sh(r,e,t,o?n:null,{useTableName:!0}),p,g,d,e,a)}else s&&(c="?");return c},Zd=function(e,t,r){var n,o,i,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,s=t.settings,l=s.isForDisplay,u=s.isDebugMode,c=null==r||null===(n=r.get)||void 0===n?void 0:n.call(r,"func");if(!c)return u?"?()":void 0;var d=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),p=Wg(e,c);if(p||u){var f,h=Kg(c,e),g=h[h.length-1],v=l&&(null==p?void 0:p.label)||g,m={},y=[],b=[],O={},E=$d(p?Object.keys(p.args||{}):(null==d||null===(i=d.keySeq)||void 0===i?void 0:i.call(d).toArray())||[]);try{for(E.s();!(f=E.n()).done;){var S,w=f.value,T=null==p?void 0:p.args[w],x=ev(e,T),_=T||{},C=_.defaultValue,R=_.isOptional,I=null!=C&&C.func?"func":"value",A=l&&(null==T?void 0:T.label)||w,j=d?d.get(w):void 0,P=j?j.get("value"):void 0,L=j?j.get("valueSrc"):void 0;"func"!==L&&null!==(S=P)&&void 0!==S&&S.toJS&&(P=P.toJS());var k=j?j.get("asyncListValues"):void 0,N=Qd(e,t,P,L,null==T?void 0:T.type,x,T,null,null,a,k);null!=P&&void 0===N&&"func"!=L&&t.errors.push("Can't format value of arg ".concat(w," for func ").concat(c));var D=void 0;if(void 0===N&&!R&&null!=C&&void 0===(D=Qd(e,t,C,I,null==T?void 0:T.type,x,T,null,null,a,k)))return void("func"!=I&&t.errors.push("Can't format default value of arg ".concat(w," for func ").concat(c)));var F=null!=N?N:D;if(void 0!==F){if(y.length){var M,V=$d(w);try{for(V.s();!(M=V.n()).done;){var U=lo(M.value,2),B=U[0];U[1],m[B]=void 0}}catch(e){V.e(e)}finally{V.f()}y=[]}m[w]=F,O[A]=F}else R||b.push(w),y.push([w,A])}}catch(e){E.e(e)}finally{E.f()}if(!b.length||u){var z=null;if("function"==typeof(null==p?void 0:p.formatFunc)){var $=p.formatFunc,W=[m,l];z=$.call.apply($,[e.ctx].concat(W))}else{var H=Object.entries(l?O:m).map((function(e){var t=lo(e,2),r=t[0],n=t[1];return l?"".concat(r,": ").concat(n):"".concat(n)})).join(", ");z="".concat(v,"(").concat(H,")")}return z}}else t.errors.push("Func ".concat(c," is not defined in config"))},ep="EMPTY_GROUP",tp="EMPTY_RULE_GROUP",rp="EMPTY_QUERY",np="EMPTY_CASE",op="NO_CONFIG_FOR_FIELD",ip="NO_CONFIG_FOR_OPERATOR",ap="NO_CONFIG_FOR_FUNCTION",sp="INVALID_VALUE",lp="INVALID_FUNC_ARG_VALUE",up="UNSUPPORTED_FIELD_TYPE",cp="UNSUPPORTED_OPERATOR_FOR_FIELD",dp="INVALID_VALUE_SRC",pp="INCOMPLETE_RULE",fp="INCOMPLETE_LHS",hp="INCOMPLETE_RHS",gp="BAD_MULTISELECT_VALUES",vp="BAD_SELECT_VALUE",mp="INCORRECT_VALUE_TYPE",yp="INCORRECT_VALUE_JS_TYPE",bp="VALUE_LENGTH_CONSTRAINT_FAIL",Op="VALUE_MIN_CONSTRAINT_FAIL",Ep="VALUE_MAX_CONSTRAINT_FAIL",Sp="NO_CONFIG_FOR_FIELD_VALUE",wp="CANT_COMPARE_FIELD_WITH_ITSELF",Tp="CANT_COMPARE_FIELD_WITH_FIELD",xp="INCORRECT_FIELD_TYPE",_p="UNSUPPORTED_FUNCTION_FOR_FIELD",Cp="REQUIRED_FUNCTION_ARG",Rp="INCORRECT_FUNCTION_RETURN_TYPE",Ip="INVALID_RANGE",Ap="ITEM_POSITION",jp="ITEM_POSITION_ROOT",Pp="ITEM_POSITION_WITH_INDEX_PATH",Lp="ITEM_POSITION_IN_CASE",kp="range";const Np={type:"logger",log(e){this.output("log",e)},warn(e){this.output("warn",e)},error(e){this.output("error",e)},output(e,t){console&&console[e]&&console[e].apply(console,t)}};class Dp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.init(e,t)}init(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.prefix=t.prefix||"i18next:",this.logger=e||Np,this.options=t,this.debug=t.debug}log(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"log","",!0)}warn(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","",!0)}error(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"error","")}deprecate(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","WARNING DEPRECATED: ",!0)}forward(e,t,r,n){return n&&!this.debug?null:("string"==typeof e[0]&&(e[0]=`${r}${this.prefix} ${e[0]}`),this.logger[t](e))}create(e){return new Dp(this.logger,{prefix:`${this.prefix}:${e}:`,...this.options})}clone(e){return(e=e||this.options).prefix=e.prefix||this.prefix,new Dp(this.logger,e)}}var Fp=new Dp;class Mp{constructor(){this.observers={}}on(e,t){return e.split(" ").forEach((e=>{this.observers[e]||(this.observers[e]=new Map);const r=this.observers[e].get(t)||0;this.observers[e].set(t,r+1)})),this}off(e,t){this.observers[e]&&(t?this.observers[e].delete(t):delete this.observers[e])}emit(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];this.observers[e]&&Array.from(this.observers[e].entries()).forEach((e=>{let[t,n]=e;for(let e=0;e<n;e++)t(...r)})),this.observers["*"]&&Array.from(this.observers["*"].entries()).forEach((t=>{let[n,o]=t;for(let t=0;t<o;t++)n.apply(n,[e,...r])}))}}const Vp=()=>{let e,t;const r=new Promise(((r,n)=>{e=r,t=n}));return r.resolve=e,r.reject=t,r},Up=e=>null==e?"":""+e,Bp=/###/g,zp=e=>e&&e.indexOf("###")>-1?e.replace(Bp,"."):e,$p=e=>!e||"string"==typeof e,Wp=(e,t,r)=>{const n="string"!=typeof t?t:t.split(".");let o=0;for(;o<n.length-1;){if($p(e))return{};const t=zp(n[o]);!e[t]&&r&&(e[t]=new r),e=Object.prototype.hasOwnProperty.call(e,t)?e[t]:{},++o}return $p(e)?{}:{obj:e,k:zp(n[o])}},Hp=(e,t,r)=>{const{obj:n,k:o}=Wp(e,t,Object);if(void 0!==n||1===t.length)return void(n[o]=r);let i=t[t.length-1],a=t.slice(0,t.length-1),s=Wp(e,a,Object);for(;void 0===s.obj&&a.length;)i=`${a[a.length-1]}.${i}`,a=a.slice(0,a.length-1),s=Wp(e,a,Object),s&&s.obj&&void 0!==s.obj[`${s.k}.${i}`]&&(s.obj=void 0);s.obj[`${s.k}.${i}`]=r},qp=(e,t)=>{const{obj:r,k:n}=Wp(e,t);if(r)return r[n]},Gp=(e,t,r)=>{for(const n in t)"__proto__"!==n&&"constructor"!==n&&(n in e?"string"==typeof e[n]||e[n]instanceof String||"string"==typeof t[n]||t[n]instanceof String?r&&(e[n]=t[n]):Gp(e[n],t[n],r):e[n]=t[n]);return e},Kp=e=>e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&");var Yp={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;"};const Xp=e=>"string"==typeof e?e.replace(/[&<>"'\/]/g,(e=>Yp[e])):e,Qp=[" ",",","?","!",";"],Jp=new class{constructor(e){this.capacity=e,this.regExpMap=new Map,this.regExpQueue=[]}getRegExp(e){const t=this.regExpMap.get(e);if(void 0!==t)return t;const r=new RegExp(e);return this.regExpQueue.length===this.capacity&&this.regExpMap.delete(this.regExpQueue.shift()),this.regExpMap.set(e,r),this.regExpQueue.push(e),r}}(20),Zp=function(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:".";if(!e)return;if(e[t])return e[t];const n=t.split(r);let o=e;for(let e=0;e<n.length;){if(!o||"object"!=typeof o)return;let t,i="";for(let a=e;a<n.length;++a)if(a!==e&&(i+=r),i+=n[a],t=o[i],void 0!==t){if(["string","number","boolean"].indexOf(typeof t)>-1&&a<n.length-1)continue;e+=a-e+1;break}o=t}return o},ef=e=>e&&e.indexOf("_")>0?e.replace("_","-"):e;class tf extends Mp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{ns:["translation"],defaultNS:"translation"};super(),this.data=e||{},this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),void 0===this.options.ignoreJSONStructure&&(this.options.ignoreJSONStructure=!0)}addNamespaces(e){this.options.ns.indexOf(e)<0&&this.options.ns.push(e)}removeNamespaces(e){const t=this.options.ns.indexOf(e);t>-1&&this.options.ns.splice(t,1)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=void 0!==n.keySeparator?n.keySeparator:this.options.keySeparator,i=void 0!==n.ignoreJSONStructure?n.ignoreJSONStructure:this.options.ignoreJSONStructure;let a;e.indexOf(".")>-1?a=e.split("."):(a=[e,t],r&&(Array.isArray(r)?a.push(...r):"string"==typeof r&&o?a.push(...r.split(o)):a.push(r)));const s=qp(this.data,a);return!s&&!t&&!r&&e.indexOf(".")>-1&&(e=a[0],t=a[1],r=a.slice(2).join(".")),s||!i||"string"!=typeof r?s:Zp(this.data&&this.data[e]&&this.data[e][t],r,o)}addResource(e,t,r,n){let o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{silent:!1};const i=void 0!==o.keySeparator?o.keySeparator:this.options.keySeparator;let a=[e,t];r&&(a=a.concat(i?r.split(i):r)),e.indexOf(".")>-1&&(a=e.split("."),n=t,t=a[1]),this.addNamespaces(t),Hp(this.data,a,n),o.silent||this.emit("added",e,t,r,n)}addResources(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{silent:!1};for(const n in r)("string"==typeof r[n]||Array.isArray(r[n]))&&this.addResource(e,t,n,r[n],{silent:!0});n.silent||this.emit("added",e,t,r)}addResourceBundle(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{silent:!1,skipCopy:!1},a=[e,t];e.indexOf(".")>-1&&(a=e.split("."),n=r,r=t,t=a[1]),this.addNamespaces(t);let s=qp(this.data,a)||{};i.skipCopy||(r=JSON.parse(JSON.stringify(r))),n?Gp(s,r,o):s={...s,...r},Hp(this.data,a,s),i.silent||this.emit("added",e,t,r)}removeResourceBundle(e,t){this.hasResourceBundle(e,t)&&delete this.data[e][t],this.removeNamespaces(t),this.emit("removed",e,t)}hasResourceBundle(e,t){return void 0!==this.getResource(e,t)}getResourceBundle(e,t){return t||(t=this.options.defaultNS),"v1"===this.options.compatibilityAPI?{...this.getResource(e,t)}:this.getResource(e,t)}getDataByLanguage(e){return this.data[e]}hasLanguageSomeTranslations(e){const t=this.getDataByLanguage(e);return!!(t&&Object.keys(t)||[]).find((e=>t[e]&&Object.keys(t[e]).length>0))}toJSON(){return this.data}}var rf={processors:{},addPostProcessor(e){this.processors[e.name]=e},handle(e,t,r,n,o){return e.forEach((e=>{this.processors[e]&&(t=this.processors[e].process(t,r,n,o))})),t}};const nf={};class of extends Mp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};super(),((e,t,r)=>{["resourceStore","languageUtils","pluralResolver","interpolator","backendConnector","i18nFormat","utils"].forEach((e=>{t[e]&&(r[e]=t[e])}))})(0,e,this),this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),this.logger=Fp.create("translator")}changeLanguage(e){e&&(this.language=e)}exists(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}};if(null==e)return!1;const r=this.resolve(e,t);return r&&void 0!==r.res}extractFromKey(e,t){let r=void 0!==t.nsSeparator?t.nsSeparator:this.options.nsSeparator;void 0===r&&(r=":");const n=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator;let o=t.ns||this.options.defaultNS||[];const i=r&&e.indexOf(r)>-1,a=!(this.options.userDefinedKeySeparator||t.keySeparator||this.options.userDefinedNsSeparator||t.nsSeparator||((e,t,r)=>{t=t||"",r=r||"";const n=Qp.filter((e=>t.indexOf(e)<0&&r.indexOf(e)<0));if(0===n.length)return!0;const o=Jp.getRegExp(`(${n.map((e=>"?"===e?"\\?":e)).join("|")})`);let i=!o.test(e);if(!i){const t=e.indexOf(r);t>0&&!o.test(e.substring(0,t))&&(i=!0)}return i})(e,r,n));if(i&&!a){const t=e.match(this.interpolator.nestingRegexp);if(t&&t.length>0)return{key:e,namespaces:o};const i=e.split(r);(r!==n||r===n&&this.options.ns.indexOf(i[0])>-1)&&(o=i.shift()),e=i.join(n)}return"string"==typeof o&&(o=[o]),{key:e,namespaces:o}}translate(e,t,r){if("object"!=typeof t&&this.options.overloadTranslationOptionHandler&&(t=this.options.overloadTranslationOptionHandler(arguments)),"object"==typeof t&&(t={...t}),t||(t={}),null==e)return"";Array.isArray(e)||(e=[String(e)]);const n=void 0!==t.returnDetails?t.returnDetails:this.options.returnDetails,o=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator,{key:i,namespaces:a}=this.extractFromKey(e[e.length-1],t),s=a[a.length-1],l=t.lng||this.language,u=t.appendNamespaceToCIMode||this.options.appendNamespaceToCIMode;if(l&&"cimode"===l.toLowerCase()){if(u){const e=t.nsSeparator||this.options.nsSeparator;return n?{res:`${s}${e}${i}`,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:`${s}${e}${i}`}return n?{res:i,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:i}const c=this.resolve(e,t);let d=c&&c.res;const p=c&&c.usedKey||i,f=c&&c.exactUsedKey||i,h=Object.prototype.toString.apply(d),g=void 0!==t.joinArrays?t.joinArrays:this.options.joinArrays,v=!this.i18nFormat||this.i18nFormat.handleAsObject;if(v&&d&&"string"!=typeof d&&"boolean"!=typeof d&&"number"!=typeof d&&["[object Number]","[object Function]","[object RegExp]"].indexOf(h)<0&&("string"!=typeof g||!Array.isArray(d))){if(!t.returnObjects&&!this.options.returnObjects){this.options.returnedObjectHandler||this.logger.warn("accessing an object - but returnObjects options is not enabled!");const e=this.options.returnedObjectHandler?this.options.returnedObjectHandler(p,d,{...t,ns:a}):`key '${i} (${this.language})' returned an object instead of string.`;return n?(c.res=e,c.usedParams=this.getUsedParamsDetails(t),c):e}if(o){const e=Array.isArray(d),r=e?[]:{},n=e?f:p;for(const e in d)if(Object.prototype.hasOwnProperty.call(d,e)){const i=`${n}${o}${e}`;r[e]=this.translate(i,{...t,joinArrays:!1,ns:a}),r[e]===i&&(r[e]=d[e])}d=r}}else if(v&&"string"==typeof g&&Array.isArray(d))d=d.join(g),d&&(d=this.extendTranslation(d,e,t,r));else{let n=!1,a=!1;const u=void 0!==t.count&&"string"!=typeof t.count,p=of.hasDefaultValue(t),f=u?this.pluralResolver.getSuffix(l,t.count,t):"",h=t.ordinal&&u?this.pluralResolver.getSuffix(l,t.count,{ordinal:!1}):"",g=u&&!t.ordinal&&0===t.count&&this.pluralResolver.shouldUseIntlApi(),v=g&&t[`defaultValue${this.options.pluralSeparator}zero`]||t[`defaultValue${f}`]||t[`defaultValue${h}`]||t.defaultValue;!this.isValidLookup(d)&&p&&(n=!0,d=v),this.isValidLookup(d)||(a=!0,d=i);const m=(t.missingKeyNoValueFallbackToKey||this.options.missingKeyNoValueFallbackToKey)&&a?void 0:d,y=p&&v!==d&&this.options.updateMissing;if(a||n||y){if(this.logger.log(y?"updateKey":"missingKey",l,s,i,y?v:d),o){const e=this.resolve(i,{...t,keySeparator:!1});e&&e.res&&this.logger.warn("Seems the loaded translations were in flat JSON format instead of nested. Either set keySeparator: false on init or make sure your translations are published in nested format.")}let e=[];const r=this.languageUtils.getFallbackCodes(this.options.fallbackLng,t.lng||this.language);if("fallback"===this.options.saveMissingTo&&r&&r[0])for(let t=0;t<r.length;t++)e.push(r[t]);else"all"===this.options.saveMissingTo?e=this.languageUtils.toResolveHierarchy(t.lng||this.language):e.push(t.lng||this.language);const n=(e,r,n)=>{const o=p&&n!==d?n:m;this.options.missingKeyHandler?this.options.missingKeyHandler(e,s,r,o,y,t):this.backendConnector&&this.backendConnector.saveMissing&&this.backendConnector.saveMissing(e,s,r,o,y,t),this.emit("missingKey",e,s,r,d)};this.options.saveMissing&&(this.options.saveMissingPlurals&&u?e.forEach((e=>{const r=this.pluralResolver.getSuffixes(e,t);g&&t[`defaultValue${this.options.pluralSeparator}zero`]&&r.indexOf(`${this.options.pluralSeparator}zero`)<0&&r.push(`${this.options.pluralSeparator}zero`),r.forEach((r=>{n([e],i+r,t[`defaultValue${r}`]||v)}))})):n(e,i,v))}d=this.extendTranslation(d,e,t,c,r),a&&d===i&&this.options.appendNamespaceToMissingKey&&(d=`${s}:${i}`),(a||n)&&this.options.parseMissingKeyHandler&&(d="v1"!==this.options.compatibilityAPI?this.options.parseMissingKeyHandler(this.options.appendNamespaceToMissingKey?`${s}:${i}`:i,n?d:void 0):this.options.parseMissingKeyHandler(d))}return n?(c.res=d,c.usedParams=this.getUsedParamsDetails(t),c):d}extendTranslation(e,t,r,n,o){var i=this;if(this.i18nFormat&&this.i18nFormat.parse)e=this.i18nFormat.parse(e,{...this.options.interpolation.defaultVariables,...r},r.lng||this.language||n.usedLng,n.usedNS,n.usedKey,{resolved:n});else if(!r.skipInterpolation){r.interpolation&&this.interpolator.init({...r,interpolation:{...this.options.interpolation,...r.interpolation}});const a="string"==typeof e&&(r&&r.interpolation&&void 0!==r.interpolation.skipOnVariables?r.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables);let s;if(a){const t=e.match(this.interpolator.nestingRegexp);s=t&&t.length}let l=r.replace&&"string"!=typeof r.replace?r.replace:r;if(this.options.interpolation.defaultVariables&&(l={...this.options.interpolation.defaultVariables,...l}),e=this.interpolator.interpolate(e,l,r.lng||this.language||n.usedLng,r),a){const t=e.match(this.interpolator.nestingRegexp);s<(t&&t.length)&&(r.nest=!1)}!r.lng&&"v1"!==this.options.compatibilityAPI&&n&&n.res&&(r.lng=this.language||n.usedLng),!1!==r.nest&&(e=this.interpolator.nest(e,(function(){for(var e=arguments.length,n=new Array(e),a=0;a<e;a++)n[a]=arguments[a];return o&&o[0]===n[0]&&!r.context?(i.logger.warn(`It seems you are nesting recursively key: ${n[0]} in key: ${t[0]}`),null):i.translate(...n,t)}),r)),r.interpolation&&this.interpolator.reset()}const a=r.postProcess||this.options.postProcess,s="string"==typeof a?[a]:a;return null!=e&&s&&s.length&&!1!==r.applyPostProcessor&&(e=rf.handle(s,e,t,this.options&&this.options.postProcessPassResolved?{i18nResolved:{...n,usedParams:this.getUsedParamsDetails(r)},...r}:r,this)),e}resolve(e){let t,r,n,o,i,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return"string"==typeof e&&(e=[e]),e.forEach((e=>{if(this.isValidLookup(t))return;const s=this.extractFromKey(e,a),l=s.key;r=l;let u=s.namespaces;this.options.fallbackNS&&(u=u.concat(this.options.fallbackNS));const c=void 0!==a.count&&"string"!=typeof a.count,d=c&&!a.ordinal&&0===a.count&&this.pluralResolver.shouldUseIntlApi(),p=void 0!==a.context&&("string"==typeof a.context||"number"==typeof a.context)&&""!==a.context,f=a.lngs?a.lngs:this.languageUtils.toResolveHierarchy(a.lng||this.language,a.fallbackLng);u.forEach((e=>{this.isValidLookup(t)||(i=e,!nf[`${f[0]}-${e}`]&&this.utils&&this.utils.hasLoadedNamespace&&!this.utils.hasLoadedNamespace(i)&&(nf[`${f[0]}-${e}`]=!0,this.logger.warn(`key "${r}" for languages "${f.join(", ")}" won't get resolved as namespace "${i}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!")),f.forEach((r=>{if(this.isValidLookup(t))return;o=r;const i=[l];if(this.i18nFormat&&this.i18nFormat.addLookupKeys)this.i18nFormat.addLookupKeys(i,l,r,e,a);else{let e;c&&(e=this.pluralResolver.getSuffix(r,a.count,a));const t=`${this.options.pluralSeparator}zero`,n=`${this.options.pluralSeparator}ordinal${this.options.pluralSeparator}`;if(c&&(i.push(l+e),a.ordinal&&0===e.indexOf(n)&&i.push(l+e.replace(n,this.options.pluralSeparator)),d&&i.push(l+t)),p){const r=`${l}${this.options.contextSeparator}${a.context}`;i.push(r),c&&(i.push(r+e),a.ordinal&&0===e.indexOf(n)&&i.push(r+e.replace(n,this.options.pluralSeparator)),d&&i.push(r+t))}}let s;for(;s=i.pop();)this.isValidLookup(t)||(n=s,t=this.getResource(r,e,s,a))})))}))})),{res:t,usedKey:r,exactUsedKey:n,usedLng:o,usedNS:i}}isValidLookup(e){return!(void 0===e||!this.options.returnNull&&null===e||!this.options.returnEmptyString&&""===e)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};return this.i18nFormat&&this.i18nFormat.getResource?this.i18nFormat.getResource(e,t,r,n):this.resourceStore.getResource(e,t,r,n)}getUsedParamsDetails(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};const t=["defaultValue","ordinal","context","replace","lng","lngs","fallbackLng","ns","keySeparator","nsSeparator","returnObjects","returnDetails","joinArrays","postProcess","interpolation"],r=e.replace&&"string"!=typeof e.replace;let n=r?e.replace:e;if(r&&void 0!==e.count&&(n.count=e.count),this.options.interpolation.defaultVariables&&(n={...this.options.interpolation.defaultVariables,...n}),!r){n={...n};for(const e of t)delete n[e]}return n}static hasDefaultValue(e){for(const t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&"defaultValue"===t.substring(0,12)&&void 0!==e[t])return!0;return!1}}const af=e=>e.charAt(0).toUpperCase()+e.slice(1);class sf{constructor(e){this.options=e,this.supportedLngs=this.options.supportedLngs||!1,this.logger=Fp.create("languageUtils")}getScriptPartFromCode(e){if(!(e=ef(e))||e.indexOf("-")<0)return null;const t=e.split("-");return 2===t.length?null:(t.pop(),"x"===t[t.length-1].toLowerCase()?null:this.formatLanguageCode(t.join("-")))}getLanguagePartFromCode(e){if(!(e=ef(e))||e.indexOf("-")<0)return e;const t=e.split("-");return this.formatLanguageCode(t[0])}formatLanguageCode(e){if("string"==typeof e&&e.indexOf("-")>-1){const t=["hans","hant","latn","cyrl","cans","mong","arab"];let r=e.split("-");return this.options.lowerCaseLng?r=r.map((e=>e.toLowerCase())):2===r.length?(r[0]=r[0].toLowerCase(),r[1]=r[1].toUpperCase(),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=af(r[1].toLowerCase()))):3===r.length&&(r[0]=r[0].toLowerCase(),2===r[1].length&&(r[1]=r[1].toUpperCase()),"sgn"!==r[0]&&2===r[2].length&&(r[2]=r[2].toUpperCase()),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=af(r[1].toLowerCase())),t.indexOf(r[2].toLowerCase())>-1&&(r[2]=af(r[2].toLowerCase()))),r.join("-")}return this.options.cleanCode||this.options.lowerCaseLng?e.toLowerCase():e}isSupportedCode(e){return("languageOnly"===this.options.load||this.options.nonExplicitSupportedLngs)&&(e=this.getLanguagePartFromCode(e)),!this.supportedLngs||!this.supportedLngs.length||this.supportedLngs.indexOf(e)>-1}getBestMatchFromCodes(e){if(!e)return null;let t;return e.forEach((e=>{if(t)return;const r=this.formatLanguageCode(e);this.options.supportedLngs&&!this.isSupportedCode(r)||(t=r)})),!t&&this.options.supportedLngs&&e.forEach((e=>{if(t)return;const r=this.getLanguagePartFromCode(e);if(this.isSupportedCode(r))return t=r;t=this.options.supportedLngs.find((e=>e===r?e:e.indexOf("-")<0&&r.indexOf("-")<0?void 0:e.indexOf("-")>0&&r.indexOf("-")<0&&e.substring(0,e.indexOf("-"))===r||0===e.indexOf(r)&&r.length>1?e:void 0))})),t||(t=this.getFallbackCodes(this.options.fallbackLng)[0]),t}getFallbackCodes(e,t){if(!e)return[];if("function"==typeof e&&(e=e(t)),"string"==typeof e&&(e=[e]),Array.isArray(e))return e;if(!t)return e.default||[];let r=e[t];return r||(r=e[this.getScriptPartFromCode(t)]),r||(r=e[this.formatLanguageCode(t)]),r||(r=e[this.getLanguagePartFromCode(t)]),r||(r=e.default),r||[]}toResolveHierarchy(e,t){const r=this.getFallbackCodes(t||this.options.fallbackLng||[],e),n=[],o=e=>{e&&(this.isSupportedCode(e)?n.push(e):this.logger.warn(`rejecting language code not found in supportedLngs: ${e}`))};return"string"==typeof e&&(e.indexOf("-")>-1||e.indexOf("_")>-1)?("languageOnly"!==this.options.load&&o(this.formatLanguageCode(e)),"languageOnly"!==this.options.load&&"currentOnly"!==this.options.load&&o(this.getScriptPartFromCode(e)),"currentOnly"!==this.options.load&&o(this.getLanguagePartFromCode(e))):"string"==typeof e&&o(this.formatLanguageCode(e)),r.forEach((e=>{n.indexOf(e)<0&&o(this.formatLanguageCode(e))})),n}}let lf=[{lngs:["ach","ak","am","arn","br","fil","gun","ln","mfe","mg","mi","oc","pt","pt-BR","tg","tl","ti","tr","uz","wa"],nr:[1,2],fc:1},{lngs:["af","an","ast","az","bg","bn","ca","da","de","dev","el","en","eo","es","et","eu","fi","fo","fur","fy","gl","gu","ha","hi","hu","hy","ia","it","kk","kn","ku","lb","mai","ml","mn","mr","nah","nap","nb","ne","nl","nn","no","nso","pa","pap","pms","ps","pt-PT","rm","sco","se","si","so","son","sq","sv","sw","ta","te","tk","ur","yo"],nr:[1,2],fc:2},{lngs:["ay","bo","cgg","fa","ht","id","ja","jbo","ka","km","ko","ky","lo","ms","sah","su","th","tt","ug","vi","wo","zh"],nr:[1],fc:3},{lngs:["be","bs","cnr","dz","hr","ru","sr","uk"],nr:[1,2,5],fc:4},{lngs:["ar"],nr:[0,1,2,3,11,100],fc:5},{lngs:["cs","sk"],nr:[1,2,5],fc:6},{lngs:["csb","pl"],nr:[1,2,5],fc:7},{lngs:["cy"],nr:[1,2,3,8],fc:8},{lngs:["fr"],nr:[1,2],fc:9},{lngs:["ga"],nr:[1,2,3,7,11],fc:10},{lngs:["gd"],nr:[1,2,3,20],fc:11},{lngs:["is"],nr:[1,2],fc:12},{lngs:["jv"],nr:[0,1],fc:13},{lngs:["kw"],nr:[1,2,3,4],fc:14},{lngs:["lt"],nr:[1,2,10],fc:15},{lngs:["lv"],nr:[1,2,0],fc:16},{lngs:["mk"],nr:[1,2],fc:17},{lngs:["mnk"],nr:[0,1,2],fc:18},{lngs:["mt"],nr:[1,2,11,20],fc:19},{lngs:["or"],nr:[2,1],fc:2},{lngs:["ro"],nr:[1,2,20],fc:20},{lngs:["sl"],nr:[5,1,2,3],fc:21},{lngs:["he","iw"],nr:[1,2,20,21],fc:22}],uf={1:e=>Number(e>1),2:e=>Number(1!=e),3:e=>0,4:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),5:e=>Number(0==e?0:1==e?1:2==e?2:e%100>=3&&e%100<=10?3:e%100>=11?4:5),6:e=>Number(1==e?0:e>=2&&e<=4?1:2),7:e=>Number(1==e?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),8:e=>Number(1==e?0:2==e?1:8!=e&&11!=e?2:3),9:e=>Number(e>=2),10:e=>Number(1==e?0:2==e?1:e<7?2:e<11?3:4),11:e=>Number(1==e||11==e?0:2==e||12==e?1:e>2&&e<20?2:3),12:e=>Number(e%10!=1||e%100==11),13:e=>Number(0!==e),14:e=>Number(1==e?0:2==e?1:3==e?2:3),15:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&(e%100<10||e%100>=20)?1:2),16:e=>Number(e%10==1&&e%100!=11?0:0!==e?1:2),17:e=>Number(1==e||e%10==1&&e%100!=11?0:1),18:e=>Number(0==e?0:1==e?1:2),19:e=>Number(1==e?0:0==e||e%100>1&&e%100<11?1:e%100>10&&e%100<20?2:3),20:e=>Number(1==e?0:0==e||e%100>0&&e%100<20?1:2),21:e=>Number(e%100==1?1:e%100==2?2:e%100==3||e%100==4?3:0),22:e=>Number(1==e?0:2==e?1:(e<0||e>10)&&e%10==0?2:3)};const cf=["v1","v2","v3"],df=["v4"],pf={zero:0,one:1,two:2,few:3,many:4,other:5};class ff{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.languageUtils=e,this.options=t,this.logger=Fp.create("pluralResolver"),this.options.compatibilityJSON&&!df.includes(this.options.compatibilityJSON)||"undefined"!=typeof Intl&&Intl.PluralRules||(this.options.compatibilityJSON="v3",this.logger.error("Your environment seems not to be Intl API compatible, use an Intl.PluralRules polyfill. Will fallback to the compatibilityJSON v3 format handling.")),this.rules=(()=>{const e={};return lf.forEach((t=>{t.lngs.forEach((r=>{e[r]={numbers:t.nr,plurals:uf[t.fc]}}))})),e})(),this.pluralRulesCache={}}addRule(e,t){this.rules[e]=t}clearCache(){this.pluralRulesCache={}}getRule(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(this.shouldUseIntlApi())try{const r=ef("dev"===e?"en":e),n=t.ordinal?"ordinal":"cardinal",o=JSON.stringify({cleanedCode:r,type:n});if(o in this.pluralRulesCache)return this.pluralRulesCache[o];const i=new Intl.PluralRules(r,{type:n});return this.pluralRulesCache[o]=i,i}catch(e){return}return this.rules[e]||this.rules[this.languageUtils.getLanguagePartFromCode(e)]}needsPlural(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return this.shouldUseIntlApi()?r&&r.resolvedOptions().pluralCategories.length>1:r&&r.numbers.length>1}getPluralFormsOfKey(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this.getSuffixes(e,r).map((e=>`${t}${e}`))}getSuffixes(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return r?this.shouldUseIntlApi()?r.resolvedOptions().pluralCategories.sort(((e,t)=>pf[e]-pf[t])).map((e=>`${this.options.prepend}${t.ordinal?`ordinal${this.options.prepend}`:""}${e}`)):r.numbers.map((r=>this.getSuffix(e,r,t))):[]}getSuffix(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const n=this.getRule(e,r);return n?this.shouldUseIntlApi()?`${this.options.prepend}${r.ordinal?`ordinal${this.options.prepend}`:""}${n.select(t)}`:this.getSuffixRetroCompatible(n,t):(this.logger.warn(`no plural rule found for: ${e}`),"")}getSuffixRetroCompatible(e,t){const r=e.noAbs?e.plurals(t):e.plurals(Math.abs(t));let n=e.numbers[r];this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]&&(2===n?n="plural":1===n&&(n=""));const o=()=>this.options.prepend&&n.toString()?this.options.prepend+n.toString():n.toString();return"v1"===this.options.compatibilityJSON?1===n?"":"number"==typeof n?`_plural_${n.toString()}`:o():"v2"===this.options.compatibilityJSON||this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]?o():this.options.prepend&&r.toString()?this.options.prepend+r.toString():r.toString()}shouldUseIntlApi(){return!cf.includes(this.options.compatibilityJSON)}}const hf=function(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:".",o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=((e,t,r)=>{const n=qp(e,r);return void 0!==n?n:qp(t,r)})(e,t,r);return!i&&o&&"string"==typeof r&&(i=Zp(e,r,n),void 0===i&&(i=Zp(t,r,n))),i},gf=e=>e.replace(/\$/g,"$$$$");class vf{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=Fp.create("interpolator"),this.options=e,this.format=e.interpolation&&e.interpolation.format||(e=>e),this.init(e)}init(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e.interpolation||(e.interpolation={escapeValue:!0});const{escape:t,escapeValue:r,useRawValueToEscape:n,prefix:o,prefixEscaped:i,suffix:a,suffixEscaped:s,formatSeparator:l,unescapeSuffix:u,unescapePrefix:c,nestingPrefix:d,nestingPrefixEscaped:p,nestingSuffix:f,nestingSuffixEscaped:h,nestingOptionsSeparator:g,maxReplaces:v,alwaysFormat:m}=e.interpolation;this.escape=void 0!==t?t:Xp,this.escapeValue=void 0===r||r,this.useRawValueToEscape=void 0!==n&&n,this.prefix=o?Kp(o):i||"{{",this.suffix=a?Kp(a):s||"}}",this.formatSeparator=l||",",this.unescapePrefix=u?"":c||"-",this.unescapeSuffix=this.unescapePrefix?"":u||"",this.nestingPrefix=d?Kp(d):p||Kp("$t("),this.nestingSuffix=f?Kp(f):h||Kp(")"),this.nestingOptionsSeparator=g||",",this.maxReplaces=v||1e3,this.alwaysFormat=void 0!==m&&m,this.resetRegExp()}reset(){this.options&&this.init(this.options)}resetRegExp(){const e=(e,t)=>e&&e.source===t?(e.lastIndex=0,e):new RegExp(t,"g");this.regexp=e(this.regexp,`${this.prefix}(.+?)${this.suffix}`),this.regexpUnescape=e(this.regexpUnescape,`${this.prefix}${this.unescapePrefix}(.+?)${this.unescapeSuffix}${this.suffix}`),this.nestingRegexp=e(this.nestingRegexp,`${this.nestingPrefix}(.+?)${this.nestingSuffix}`)}interpolate(e,t,r,n){let o,i,a;const s=this.options&&this.options.interpolation&&this.options.interpolation.defaultVariables||{},l=e=>{if(e.indexOf(this.formatSeparator)<0){const o=hf(t,s,e,this.options.keySeparator,this.options.ignoreJSONStructure);return this.alwaysFormat?this.format(o,void 0,r,{...n,...t,interpolationkey:e}):o}const o=e.split(this.formatSeparator),i=o.shift().trim(),a=o.join(this.formatSeparator).trim();return this.format(hf(t,s,i,this.options.keySeparator,this.options.ignoreJSONStructure),a,r,{...n,...t,interpolationkey:i})};this.resetRegExp();const u=n&&n.missingInterpolationHandler||this.options.missingInterpolationHandler,c=n&&n.interpolation&&void 0!==n.interpolation.skipOnVariables?n.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables;return[{regex:this.regexpUnescape,safeValue:e=>gf(e)},{regex:this.regexp,safeValue:e=>this.escapeValue?gf(this.escape(e)):gf(e)}].forEach((t=>{for(a=0;o=t.regex.exec(e);){const r=o[1].trim();if(i=l(r),void 0===i)if("function"==typeof u){const t=u(e,o,n);i="string"==typeof t?t:""}else if(n&&Object.prototype.hasOwnProperty.call(n,r))i="";else{if(c){i=o[0];continue}this.logger.warn(`missed to pass in variable ${r} for interpolating ${e}`),i=""}else"string"==typeof i||this.useRawValueToEscape||(i=Up(i));const s=t.safeValue(i);if(e=e.replace(o[0],s),c?(t.regex.lastIndex+=i.length,t.regex.lastIndex-=o[0].length):t.regex.lastIndex=0,a++,a>=this.maxReplaces)break}})),e}nest(e,t){let r,n,o,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const a=(e,t)=>{const r=this.nestingOptionsSeparator;if(e.indexOf(r)<0)return e;const n=e.split(new RegExp(`${r}[ ]*{`));let i=`{${n[1]}`;e=n[0],i=this.interpolate(i,o);const a=i.match(/'/g),s=i.match(/"/g);(a&&a.length%2==0&&!s||s.length%2!=0)&&(i=i.replace(/'/g,'"'));try{o=JSON.parse(i),t&&(o={...t,...o})}catch(t){return this.logger.warn(`failed parsing options string in nesting for key ${e}`,t),`${e}${r}${i}`}return o.defaultValue&&o.defaultValue.indexOf(this.prefix)>-1&&delete o.defaultValue,e};for(;r=this.nestingRegexp.exec(e);){let s=[];o={...i},o=o.replace&&"string"!=typeof o.replace?o.replace:o,o.applyPostProcessor=!1,delete o.defaultValue;let l=!1;if(-1!==r[0].indexOf(this.formatSeparator)&&!/{.*}/.test(r[1])){const e=r[1].split(this.formatSeparator).map((e=>e.trim()));r[1]=e.shift(),s=e,l=!0}if(n=t(a.call(this,r[1].trim(),o),o),n&&r[0]===e&&"string"!=typeof n)return n;"string"!=typeof n&&(n=Up(n)),n||(this.logger.warn(`missed to resolve ${r[1]} for nesting ${e}`),n=""),l&&(n=s.reduce(((e,t)=>this.format(e,t,i.lng,{...i,interpolationkey:r[1].trim()})),n.trim())),e=e.replace(r[0],n),this.regexp.lastIndex=0}return e}}const mf=e=>{const t={};return(r,n,o)=>{let i=o;o&&o.interpolationkey&&o.formatParams&&o.formatParams[o.interpolationkey]&&o[o.interpolationkey]&&(i={...i,[o.interpolationkey]:void 0});const a=n+JSON.stringify(i);let s=t[a];return s||(s=e(ef(n),o),t[a]=s),s(r)}};class yf{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=Fp.create("formatter"),this.options=e,this.formats={number:mf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t});return e=>r.format(e)})),currency:mf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t,style:"currency"});return e=>r.format(e)})),datetime:mf(((e,t)=>{const r=new Intl.DateTimeFormat(e,{...t});return e=>r.format(e)})),relativetime:mf(((e,t)=>{const r=new Intl.RelativeTimeFormat(e,{...t});return e=>r.format(e,t.range||"day")})),list:mf(((e,t)=>{const r=new Intl.ListFormat(e,{...t});return e=>r.format(e)}))},this.init(e)}init(e){const t=(arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}}).interpolation;this.formatSeparator=t.formatSeparator?t.formatSeparator:t.formatSeparator||","}add(e,t){this.formats[e.toLowerCase().trim()]=t}addCached(e,t){this.formats[e.toLowerCase().trim()]=mf(t)}format(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=t.split(this.formatSeparator);if(o.length>1&&o[0].indexOf("(")>1&&o[0].indexOf(")")<0&&o.find((e=>e.indexOf(")")>-1))){const e=o.findIndex((e=>e.indexOf(")")>-1));o[0]=[o[0],...o.splice(1,e)].join(this.formatSeparator)}return o.reduce(((e,t)=>{const{formatName:o,formatOptions:i}=(e=>{let t=e.toLowerCase().trim();const r={};if(e.indexOf("(")>-1){const n=e.split("(");t=n[0].toLowerCase().trim();const o=n[1].substring(0,n[1].length-1);"currency"===t&&o.indexOf(":")<0?r.currency||(r.currency=o.trim()):"relativetime"===t&&o.indexOf(":")<0?r.range||(r.range=o.trim()):o.split(";").forEach((e=>{if(e){const[t,...n]=e.split(":"),o=n.join(":").trim().replace(/^'+|'+$/g,""),i=t.trim();r[i]||(r[i]=o),"false"===o&&(r[i]=!1),"true"===o&&(r[i]=!0),isNaN(o)||(r[i]=parseInt(o,10))}}))}return{formatName:t,formatOptions:r}})(t);if(this.formats[o]){let t=e;try{const a=n&&n.formatParams&&n.formatParams[n.interpolationkey]||{},s=a.locale||a.lng||n.locale||n.lng||r;t=this.formats[o](e,s,{...i,...n,...a})}catch(e){this.logger.warn(e)}return t}return this.logger.warn(`there was no format function for ${o}`),e}),e)}}class bf extends Mp{constructor(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};super(),this.backend=e,this.store=t,this.services=r,this.languageUtils=r.languageUtils,this.options=n,this.logger=Fp.create("backendConnector"),this.waitingReads=[],this.maxParallelReads=n.maxParallelReads||10,this.readingCalls=0,this.maxRetries=n.maxRetries>=0?n.maxRetries:5,this.retryTimeout=n.retryTimeout>=1?n.retryTimeout:350,this.state={},this.queue=[],this.backend&&this.backend.init&&this.backend.init(r,n.backend,n)}queueLoad(e,t,r,n){const o={},i={},a={},s={};return e.forEach((e=>{let n=!0;t.forEach((t=>{const a=`${e}|${t}`;!r.reload&&this.store.hasResourceBundle(e,t)?this.state[a]=2:this.state[a]<0||(1===this.state[a]?void 0===i[a]&&(i[a]=!0):(this.state[a]=1,n=!1,void 0===i[a]&&(i[a]=!0),void 0===o[a]&&(o[a]=!0),void 0===s[t]&&(s[t]=!0)))})),n||(a[e]=!0)})),(Object.keys(o).length||Object.keys(i).length)&&this.queue.push({pending:i,pendingCount:Object.keys(i).length,loaded:{},errors:[],callback:n}),{toLoad:Object.keys(o),pending:Object.keys(i),toLoadLanguages:Object.keys(a),toLoadNamespaces:Object.keys(s)}}loaded(e,t,r){const n=e.split("|"),o=n[0],i=n[1];t&&this.emit("failedLoading",o,i,t),!t&&r&&this.store.addResourceBundle(o,i,r,void 0,void 0,{skipCopy:!0}),this.state[e]=t?-1:2,t&&r&&(this.state[e]=0);const a={};this.queue.forEach((r=>{((e,t,r,n)=>{const{obj:o,k:i}=Wp(e,t,Object);o[i]=o[i]||[],o[i].push(r)})(r.loaded,[o],i),((e,t)=>{void 0!==e.pending[t]&&(delete e.pending[t],e.pendingCount--)})(r,e),t&&r.errors.push(t),0!==r.pendingCount||r.done||(Object.keys(r.loaded).forEach((e=>{a[e]||(a[e]={});const t=r.loaded[e];t.length&&t.forEach((t=>{void 0===a[e][t]&&(a[e][t]=!0)}))})),r.done=!0,r.errors.length?r.callback(r.errors):r.callback())})),this.emit("loaded",a),this.queue=this.queue.filter((e=>!e.done))}read(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.retryTimeout,i=arguments.length>5?arguments[5]:void 0;if(!e.length)return i(null,{});if(this.readingCalls>=this.maxParallelReads)return void this.waitingReads.push({lng:e,ns:t,fcName:r,tried:n,wait:o,callback:i});this.readingCalls++;const a=(a,s)=>{if(this.readingCalls--,this.waitingReads.length>0){const e=this.waitingReads.shift();this.read(e.lng,e.ns,e.fcName,e.tried,e.wait,e.callback)}a&&s&&n<this.maxRetries?setTimeout((()=>{this.read.call(this,e,t,r,n+1,2*o,i)}),o):i(a,s)},s=this.backend[r].bind(this.backend);if(2!==s.length)return s(e,t,a);try{const r=s(e,t);r&&"function"==typeof r.then?r.then((e=>a(null,e))).catch(a):a(null,r)}catch(e){a(e)}}prepareLoading(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=arguments.length>3?arguments[3]:void 0;if(!this.backend)return this.logger.warn("No backend was added via i18next.use. Will not load resources."),n&&n();"string"==typeof e&&(e=this.languageUtils.toResolveHierarchy(e)),"string"==typeof t&&(t=[t]);const o=this.queueLoad(e,t,r,n);if(!o.toLoad.length)return o.pending.length||n(),null;o.toLoad.forEach((e=>{this.loadOne(e)}))}load(e,t,r){this.prepareLoading(e,t,{},r)}reload(e,t,r){this.prepareLoading(e,t,{reload:!0},r)}loadOne(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";const r=e.split("|"),n=r[0],o=r[1];this.read(n,o,"read",void 0,void 0,((r,i)=>{r&&this.logger.warn(`${t}loading namespace ${o} for language ${n} failed`,r),!r&&i&&this.logger.log(`${t}loaded namespace ${o} for language ${n}`,i),this.loaded(e,r,i)}))}saveMissing(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:()=>{};if(this.services.utils&&this.services.utils.hasLoadedNamespace&&!this.services.utils.hasLoadedNamespace(t))this.logger.warn(`did not save key "${r}" as the namespace "${t}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!");else if(null!=r&&""!==r){if(this.backend&&this.backend.create){const s={...i,isUpdate:o},l=this.backend.create.bind(this.backend);if(l.length<6)try{let o;o=5===l.length?l(e,t,r,n,s):l(e,t,r,n),o&&"function"==typeof o.then?o.then((e=>a(null,e))).catch(a):a(null,o)}catch(e){a(e)}else l(e,t,r,n,a,s)}e&&e[0]&&this.store.addResource(e[0],t,r,n)}}}const Of=()=>({debug:!1,initImmediate:!0,ns:["translation"],defaultNS:["translation"],fallbackLng:["dev"],fallbackNS:!1,supportedLngs:!1,nonExplicitSupportedLngs:!1,load:"all",preload:!1,simplifyPluralSuffix:!0,keySeparator:".",nsSeparator:":",pluralSeparator:"_",contextSeparator:"_",partialBundledLanguages:!1,saveMissing:!1,updateMissing:!1,saveMissingTo:"fallback",saveMissingPlurals:!0,missingKeyHandler:!1,missingInterpolationHandler:!1,postProcess:!1,postProcessPassResolved:!1,returnNull:!1,returnEmptyString:!0,returnObjects:!1,joinArrays:!1,returnedObjectHandler:!1,parseMissingKeyHandler:!1,appendNamespaceToMissingKey:!1,appendNamespaceToCIMode:!1,overloadTranslationOptionHandler:e=>{let t={};if("object"==typeof e[1]&&(t=e[1]),"string"==typeof e[1]&&(t.defaultValue=e[1]),"string"==typeof e[2]&&(t.tDescription=e[2]),"object"==typeof e[2]||"object"==typeof e[3]){const r=e[3]||e[2];Object.keys(r).forEach((e=>{t[e]=r[e]}))}return t},interpolation:{escapeValue:!0,format:e=>e,prefix:"{{",suffix:"}}",formatSeparator:",",unescapePrefix:"-",nestingPrefix:"$t(",nestingSuffix:")",nestingOptionsSeparator:",",maxReplaces:1e3,skipOnVariables:!0}}),Ef=e=>("string"==typeof e.ns&&(e.ns=[e.ns]),"string"==typeof e.fallbackLng&&(e.fallbackLng=[e.fallbackLng]),"string"==typeof e.fallbackNS&&(e.fallbackNS=[e.fallbackNS]),e.supportedLngs&&e.supportedLngs.indexOf("cimode")<0&&(e.supportedLngs=e.supportedLngs.concat(["cimode"])),e),Sf=()=>{};class wf extends Mp{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0;var r;if(super(),this.options=Ef(e),this.services={},this.logger=Fp,this.modules={external:[]},r=this,Object.getOwnPropertyNames(Object.getPrototypeOf(r)).forEach((e=>{"function"==typeof r[e]&&(r[e]=r[e].bind(r))})),t&&!this.isInitialized&&!e.isClone){if(!this.options.initImmediate)return this.init(e,t),this;setTimeout((()=>{this.init(e,t)}),0)}}init(){var e=this;let t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=arguments.length>1?arguments[1]:void 0;this.isInitializing=!0,"function"==typeof t&&(r=t,t={}),!t.defaultNS&&!1!==t.defaultNS&&t.ns&&("string"==typeof t.ns?t.defaultNS=t.ns:t.ns.indexOf("translation")<0&&(t.defaultNS=t.ns[0]));const n=Of();this.options={...n,...this.options,...Ef(t)},"v1"!==this.options.compatibilityAPI&&(this.options.interpolation={...n.interpolation,...this.options.interpolation}),void 0!==t.keySeparator&&(this.options.userDefinedKeySeparator=t.keySeparator),void 0!==t.nsSeparator&&(this.options.userDefinedNsSeparator=t.nsSeparator);const o=e=>e?"function"==typeof e?new e:e:null;if(!this.options.isClone){let t;this.modules.logger?Fp.init(o(this.modules.logger),this.options):Fp.init(null,this.options),this.modules.formatter?t=this.modules.formatter:"undefined"!=typeof Intl&&(t=yf);const r=new sf(this.options);this.store=new tf(this.options.resources,this.options);const i=this.services;i.logger=Fp,i.resourceStore=this.store,i.languageUtils=r,i.pluralResolver=new ff(r,{prepend:this.options.pluralSeparator,compatibilityJSON:this.options.compatibilityJSON,simplifyPluralSuffix:this.options.simplifyPluralSuffix}),!t||this.options.interpolation.format&&this.options.interpolation.format!==n.interpolation.format||(i.formatter=o(t),i.formatter.init(i,this.options),this.options.interpolation.format=i.formatter.format.bind(i.formatter)),i.interpolator=new vf(this.options),i.utils={hasLoadedNamespace:this.hasLoadedNamespace.bind(this)},i.backendConnector=new bf(o(this.modules.backend),i.resourceStore,i,this.options),i.backendConnector.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.languageDetector&&(i.languageDetector=o(this.modules.languageDetector),i.languageDetector.init&&i.languageDetector.init(i,this.options.detection,this.options)),this.modules.i18nFormat&&(i.i18nFormat=o(this.modules.i18nFormat),i.i18nFormat.init&&i.i18nFormat.init(this)),this.translator=new of(this.services,this.options),this.translator.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.external.forEach((e=>{e.init&&e.init(this)}))}if(this.format=this.options.interpolation.format,r||(r=Sf),this.options.fallbackLng&&!this.services.languageDetector&&!this.options.lng){const e=this.services.languageUtils.getFallbackCodes(this.options.fallbackLng);e.length>0&&"dev"!==e[0]&&(this.options.lng=e[0])}this.services.languageDetector||this.options.lng||this.logger.warn("init: no languageDetector is used and no lng is defined"),["getResource","hasResourceBundle","getResourceBundle","getDataByLanguage"].forEach((t=>{this[t]=function(){return e.store[t](...arguments)}})),["addResource","addResources","addResourceBundle","removeResourceBundle"].forEach((t=>{this[t]=function(){return e.store[t](...arguments),e}}));const i=Vp(),a=()=>{const e=(e,t)=>{this.isInitializing=!1,this.isInitialized&&!this.initializedStoreOnce&&this.logger.warn("init: i18next is already initialized. You should call init just once!"),this.isInitialized=!0,this.options.isClone||this.logger.log("initialized",this.options),this.emit("initialized",this.options),i.resolve(t),r(e,t)};if(this.languages&&"v1"!==this.options.compatibilityAPI&&!this.isInitialized)return e(null,this.t.bind(this));this.changeLanguage(this.options.lng,e)};return this.options.resources||!this.options.initImmediate?a():setTimeout(a,0),i}loadResources(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Sf;const r="string"==typeof e?e:this.language;if("function"==typeof e&&(t=e),!this.options.resources||this.options.partialBundledLanguages){if(r&&"cimode"===r.toLowerCase()&&(!this.options.preload||0===this.options.preload.length))return t();const e=[],n=t=>{t&&"cimode"!==t&&this.services.languageUtils.toResolveHierarchy(t).forEach((t=>{"cimode"!==t&&e.indexOf(t)<0&&e.push(t)}))};r?n(r):this.services.languageUtils.getFallbackCodes(this.options.fallbackLng).forEach((e=>n(e))),this.options.preload&&this.options.preload.forEach((e=>n(e))),this.services.backendConnector.load(e,this.options.ns,(e=>{e||this.resolvedLanguage||!this.language||this.setResolvedLanguage(this.language),t(e)}))}else t(null)}reloadResources(e,t,r){const n=Vp();return"function"==typeof e&&(r=e,e=void 0),"function"==typeof t&&(r=t,t=void 0),e||(e=this.languages),t||(t=this.options.ns),r||(r=Sf),this.services.backendConnector.reload(e,t,(e=>{n.resolve(),r(e)})),n}use(e){if(!e)throw new Error("You are passing an undefined module! Please check the object you are passing to i18next.use()");if(!e.type)throw new Error("You are passing a wrong module! Please check the object you are passing to i18next.use()");return"backend"===e.type&&(this.modules.backend=e),("logger"===e.type||e.log&&e.warn&&e.error)&&(this.modules.logger=e),"languageDetector"===e.type&&(this.modules.languageDetector=e),"i18nFormat"===e.type&&(this.modules.i18nFormat=e),"postProcessor"===e.type&&rf.addPostProcessor(e),"formatter"===e.type&&(this.modules.formatter=e),"3rdParty"===e.type&&this.modules.external.push(e),this}setResolvedLanguage(e){if(e&&this.languages&&!(["cimode","dev"].indexOf(e)>-1))for(let e=0;e<this.languages.length;e++){const t=this.languages[e];if(!(["cimode","dev"].indexOf(t)>-1)&&this.store.hasLanguageSomeTranslations(t)){this.resolvedLanguage=t;break}}}changeLanguage(e,t){var r=this;this.isLanguageChangingTo=e;const n=Vp();this.emit("languageChanging",e);const o=e=>{this.language=e,this.languages=this.services.languageUtils.toResolveHierarchy(e),this.resolvedLanguage=void 0,this.setResolvedLanguage(e)},i=(e,i)=>{i?(o(i),this.translator.changeLanguage(i),this.isLanguageChangingTo=void 0,this.emit("languageChanged",i),this.logger.log("languageChanged",i)):this.isLanguageChangingTo=void 0,n.resolve((function(){return r.t(...arguments)})),t&&t(e,(function(){return r.t(...arguments)}))},a=t=>{e||t||!this.services.languageDetector||(t=[]);const r="string"==typeof t?t:this.services.languageUtils.getBestMatchFromCodes(t);r&&(this.language||o(r),this.translator.language||this.translator.changeLanguage(r),this.services.languageDetector&&this.services.languageDetector.cacheUserLanguage&&this.services.languageDetector.cacheUserLanguage(r)),this.loadResources(r,(e=>{i(e,r)}))};return e||!this.services.languageDetector||this.services.languageDetector.async?!e&&this.services.languageDetector&&this.services.languageDetector.async?0===this.services.languageDetector.detect.length?this.services.languageDetector.detect().then(a):this.services.languageDetector.detect(a):a(e):a(this.services.languageDetector.detect()),n}getFixedT(e,t,r){var n=this;const o=function(e,t){let i;if("object"!=typeof t){for(var a=arguments.length,s=new Array(a>2?a-2:0),l=2;l<a;l++)s[l-2]=arguments[l];i=n.options.overloadTranslationOptionHandler([e,t].concat(s))}else i={...t};i.lng=i.lng||o.lng,i.lngs=i.lngs||o.lngs,i.ns=i.ns||o.ns,""!==i.keyPrefix&&(i.keyPrefix=i.keyPrefix||r||o.keyPrefix);const u=n.options.keySeparator||".";let c;return c=i.keyPrefix&&Array.isArray(e)?e.map((e=>`${i.keyPrefix}${u}${e}`)):i.keyPrefix?`${i.keyPrefix}${u}${e}`:e,n.t(c,i)};return"string"==typeof e?o.lng=e:o.lngs=e,o.ns=t,o.keyPrefix=r,o}t(){return this.translator&&this.translator.translate(...arguments)}exists(){return this.translator&&this.translator.exists(...arguments)}setDefaultNamespace(e){this.options.defaultNS=e}hasLoadedNamespace(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!this.isInitialized)return this.logger.warn("hasLoadedNamespace: i18next was not initialized",this.languages),!1;if(!this.languages||!this.languages.length)return this.logger.warn("hasLoadedNamespace: i18n.languages were undefined or empty",this.languages),!1;const r=t.lng||this.resolvedLanguage||this.languages[0],n=!!this.options&&this.options.fallbackLng,o=this.languages[this.languages.length-1];if("cimode"===r.toLowerCase())return!0;const i=(e,t)=>{const r=this.services.backendConnector.state[`${e}|${t}`];return-1===r||0===r||2===r};if(t.precheck){const e=t.precheck(this,i);if(void 0!==e)return e}return!(!this.hasResourceBundle(r,e)&&this.services.backendConnector.backend&&(!this.options.resources||this.options.partialBundledLanguages)&&(!i(r,e)||n&&!i(o,e)))}loadNamespaces(e,t){const r=Vp();return this.options.ns?("string"==typeof e&&(e=[e]),e.forEach((e=>{this.options.ns.indexOf(e)<0&&this.options.ns.push(e)})),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}loadLanguages(e,t){const r=Vp();"string"==typeof e&&(e=[e]);const n=this.options.preload||[],o=e.filter((e=>n.indexOf(e)<0&&this.services.languageUtils.isSupportedCode(e)));return o.length?(this.options.preload=n.concat(o),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}dir(e){if(e||(e=this.resolvedLanguage||(this.languages&&this.languages.length>0?this.languages[0]:this.language)),!e)return"rtl";const t=this.services&&this.services.languageUtils||new sf(Of());return["ar","shu","sqr","ssh","xaa","yhd","yud","aao","abh","abv","acm","acq","acw","acx","acy","adf","ads","aeb","aec","afb","ajp","apc","apd","arb","arq","ars","ary","arz","auz","avl","ayh","ayl","ayn","ayp","bbz","pga","he","iw","ps","pbt","pbu","pst","prp","prd","ug","ur","ydd","yds","yih","ji","yi","hbo","men","xmn","fa","jpr","peo","pes","prs","dv","sam","ckb"].indexOf(t.getLanguagePartFromCode(e))>-1||e.toLowerCase().indexOf("-arab")>1?"rtl":"ltr"}static createInstance(){return new wf(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},arguments.length>1?arguments[1]:void 0)}cloneInstance(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Sf;const r=e.forkResourceStore;r&&delete e.forkResourceStore;const n={...this.options,...e,isClone:!0},o=new wf(n);return void 0===e.debug&&void 0===e.prefix||(o.logger=o.logger.clone(e)),["store","services","language"].forEach((e=>{o[e]=this[e]})),o.services={...this.services},o.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},r&&(o.store=new tf(this.store.data,n),o.services.resourceStore=o.store),o.translator=new of(o.services,n),o.translator.on("*",(function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];o.emit(e,...r)})),o.init(n,t),o.translator.options=n,o.translator.backendConnector.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},o}toJSON(){return{options:this.options,store:this.store,language:this.language,languages:this.languages,resolvedLanguage:this.resolvedLanguage}}}const Tf=wf.createInstance();Tf.createInstance=wf.createInstance,Tf.createInstance,Tf.dir,Tf.init,Tf.loadResources,Tf.reloadResources,Tf.use,Tf.changeLanguage,Tf.getFixedT;const xf=Tf.t;Tf.exists,Tf.setDefaultNamespace,Tf.hasLoadedNamespace,Tf.loadNamespaces,Tf.loadLanguages;var _f,Cf=(no(no(no(no(no(no(no(no(no(no(_f={},ep,"Empty group"),tp,"No conditions for group field {{field}}"),rp,"Empty query"),np,"Empty case"),op,"No config for field {{field}}"),"FIXED_OPERATOR","Fixed operator {{from}} to {{to}} for field {{field}}"),ip,"No config for operator {{operator}}"),ap,"No config for function {{funcKey}}"),sp,"Invalid value"),lp,"Invalid value of arg {{argName}} for func {{funcName}}: {{argValidationError}}"),no(no(no(no(no(no(no(no(no(no(_f,up,"Type of field {{field}} is not supported"),cp,"Operator {{operator}} is not supported for field {{field}}"),pp,"Incomplete rule"),fp,"Incomplete LHS"),hp,"Incomplete RHS"),dp,"Invalid value src {{valueSrcs, list}}"),gp+"_one","Value {{badValues, list}} is not in the list of allowed values"),gp+"_other","Values {{badValues, list}} are not in the list of allowed values"),vp,"Value {{value}} is not in the list of allowed values"),mp,"Value should have type {{wType}}, but got value of type {{valueType}}"),no(no(no(no(no(no(no(no(no(no(_f,yp,"Value should have JS type {{jsType}}, but got value of type {{valueTypeof}}"),bp,"Value {{value}} should have max length {{fieldSettings.maxLength}} but got {{length}}"),Op,"Value {{value}} should be greater than or equal to {{fieldSettings.min}}"),Op+"_"+kp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),Ep,"Value {{value}} should be less than or equal to {{fieldSettings.max}}"),Ep+"_"+kp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),Sp,"No config for field {{field}}"),wp,"Can't compare field {{field}} with itself"),Tp,"Can't compare field {{leftField}} with {{rightField}}"),xp,"Field {{field}} is of type {{type}}, but expected {{expected}}"),no(no(no(no(no(no(no(no(no(no(_f,_p,"Unsupported function {{funcKey}} for field {{field}}"),Cp,"Value of arg {{argName}} for func {{funcName}} is required"),Rp,"Function {{funcKey}} should return value of type {{returnType}}, but got {{valueType}}"),Ip,"Invalid range"),jp,"Root"),Ap+"__rule","Leaf #{{globalLeafNo}}"),Ap+"__group","Group #{{globalGroupNo}}"),Ap+"__rule_group","Rule-group #{{globalNoByType}}"),Ap+"__case_group","Case #{{globalNoByType}}"),Ap+"__rule__deleted","Deleted leaf #{{globalLeafNo}}"),no(no(no(no(no(_f,Ap+"__group__deleted","Deleted group #{{globalGroupNo}}"),Ap+"__rule_group__deleted","Deleted rule-group #{{globalNoByType}}"),Ap+"__case_group__deleted","Deleted case #{{globalNoByType}}"),Lp,"{{str}} in case #{{caseNo}}"),Pp,"{{str}} (index path: {{indexPath, list}})")),Rf="raqbvalidation",If="".concat(Rf,":"),Af=Tf.createInstance();Af.init({fallbackLng:"en"}),Af.addResources("en",Rf,Cf);var jf=function e(t,r){return null!=t&&t.str?t.str:null!=t&&t.key?e(t.key,t.args):null===r?t:Af.t(t.includes(":")?t:If+t,r)};const Pf=Af;function Lf(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function kf(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Lf(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Lf(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Nf=function(e){return"object"===Kn(e)&&null!==e&&Array.isArray(e)?"array":Kn(e)},Df=function(e,t){return 0===Ff(e,t).length},Ff=function(e,t){var r=t.settings.showErrorMessage,n=[];return e&&function e(t,o,i){var a,s,l=t.get("id"),u=t.get("children1"),c=t.getIn(["properties","valueError"]),d=t.getIn(["properties","fieldError"]),p=t.getIn(["properties","field"]),f=null!==(a=null==p||null===(s=p.get)||void 0===s?void 0:s.call(p,"func"))&&void 0!==a?a:p;((null==c?void 0:c.size)>0&&c.filter((function(e){return null!=e})).size>0||!!d)&&r&&n.push(f),u&&u.map((function(t,r){t&&e(t,o.concat(l),i+1)}))}(e,[],0),Array.from(new Set(n))},Mf=function(e,t){var r=Rg(t,void 0,!0),n={removeEmptyGroups:t.settings.removeEmptyGroupsOnLoad,removeIncompleteRules:t.settings.removeIncompleteRulesOnLoad,removeEmptyRules:t.settings.removeEmptyRulesOnLoad,forceFix:!1},o=zf(e,null,r,r,n),i=o.fixedTree,a=o.allErrors;return o.isSanitized&&a.length&&console.warn("Tree check errors: ",a),i},Vf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=Rg(t,void 0,!0),o=kf(kf({},r),{},{removeEmptyGroups:!1,removeEmptyRules:!1,removeIncompleteRules:!1,forceFix:!1});return zf(e,null,n,n,o).allErrors},Uf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=Rg(t,void 0,!0),o=kf({removeEmptyGroups:!0,removeEmptyRules:!0,removeIncompleteRules:!0,forceFix:!1},r),i=zf(e,null,n,n,o);return{fixedTree:i.fixedTree,fixedErrors:i.fixedErrors,nonFixedErrors:i.nonFixedErrors,allErrors:i.allErrors}},Bf=function(e,t,r,n,o,i,a){void 0===o&&(o=r.settings.removeEmptyGroupsOnLoad),void 0===i&&(i=r.settings.removeEmptyRulesOnLoad),void 0===a&&(a=r.settings.removeIncompleteRulesOnLoad);var s=zf(e,t,r,n,{removeEmptyGroups:o,removeEmptyRules:i,removeIncompleteRules:a,forceFix:!1}),l=s.fixedTree,u=(s.allErrors,s.fixedErrors);return s.nonFixedErrors,s.isSanitized&&u.length&&console.warn("Fixed tree errors: ",u),Au(l)},zf=function(e,t,r,n,o){if(!e)return{fixedTree:e,allErrors:[],fixedErrors:[],nonFixedErrors:[],isSanitized:!1};var i,a,s=o||{},l=s.removeEmptyGroups,u=s.removeEmptyRules,c=s.removeIncompleteRules,d=s.forceFix,p=s.translateErrors,f=void 0===p||p,h=s.includeStringifiedItems,g=void 0===h||h,v=s.stringifyFixedItems,m=void 0!==v&&v,y=s.stringifyItemsUserFriendly,b=void 0===y||y,O=s.includeItemsPositions,E=void 0===O||O,S={errors:{}},w=Hf(e,[],null,S,{config:r,oldConfig:n,removeEmptyGroups:l,removeEmptyRules:u,removeIncompleteRules:c,forceFix:d}),T=S.sanitized,x=[];for(var _ in E&&(i=Pu(w).items),S.errors){var C=S.errors[_],R=C.path,I=C.errors;f&&(I=I.map((function(e){return kf(kf({},e),{},{str:jf(e)})})));var A={path:R,errors:I};if(g){var j=Ru(m?w:e,R);if(1!==R.length&&"group"!==j.get("type")){var P=Gd(j,r,b,!0);A.itemStr=P}}if(E){var L=i[_],k=!L;if(k&&(a||(a=Pu(e).items),L=a[_]),L){var N=kf(kf({},L.position),{},{index:L.index,type:L.type,isDeleted:k});A.itemPosition=N;var D=L.index?Ap+"__"+L.type+(k?"__deleted":""):jp,F=kf({},N);if(b){for(var M,V=0,U=["caseNo","globalLeafNo","globalGroupNo","globalNoByType"];V<U.length;V++){var B=U[V];null!=F[B]&&(F[B]=F[B]+1)}F.indexPath=null===(M=N.indexPath)||void 0===M?void 0:M.map((function(e){return e+1}))}A.itemPositionStr=jf(D,F),L.index&&(L.caseId&&"case_group"!==L.type&&(A.itemPositionStr=jf(Lp,kf(kf({},F),{},{str:A.itemPositionStr}))),"case_group"!==L.type&&(A.itemPositionStr=jf(Pp,kf(kf({},F),{},{str:A.itemPositionStr}))))}}x.push(A)}for(var z=[],$=[],W=0,H=x;W<H.length;W++){var q=H[W],G=q.errors.filter((function(e){return!!e.fixed})),K=q.errors.filter((function(e){return!e.fixed&&"EMPTY_QUERY"!==e.key}));G.length&&z.push(kf(kf({},q),{},{errors:G})),K.length&&$.push(kf(kf({},q),{},{errors:K}))}return{fixedTree:w,allErrors:x,fixedErrors:z,nonFixedErrors:$,isSanitized:T}};function $f(e,t,r,n){var o=t.get("id");e.errors[o]||(e.errors[o]={path:[].concat(co(r),[o]),errors:[]}),e.errors[o].errors.push(n)}function Wf(e,t){var r=t.get("id");e.errors[r]&&e.errors[r].errors.map((function(e){e.fixed=!0}))}function Hf(e,t,r,n,o){var i=null==e?void 0:e.get("type");return"group"===i||"rule_group"===i||"case_group"==i||"switch_group"==i?function(e,t,r,n,o){var i,a,s,l,u,c,d=o.removeEmptyGroups,p=o.removeIncompleteRules,f=(o.forceFix,o.config),h=(f.settings.showErrorMessage,e.get("id")),g=e.get("children1"),v=!t.length,m=g,y=e.get("type"),b=e.get("properties"),O=null==b?void 0:b.get("field"),E=null==b?void 0:b.get("mode"),S=null==b||null===(i=b.get)||void 0===i?void 0:i.call(b,"operator"),w="rule_group"===y&&"array"===E,T="case_group"===y,x=T&&null==g,_=S?null!==(a=null===(s=f.operators[S])||void 0===s?void 0:s.cardinality)&&void 0!==a?a:1:void 0,C=T?!x:w?0==_:d,R=w||T;!h&&r&&(h=r,e=e.set("id",h),n.sanitized=!0),R&&(e=qf(e,t,r,n,o));var I={errors:{}},A=null===(u=g=null===(l=g)||void 0===l?void 0:l.map((function(e,r){return Hf(e,t.concat(h),r,I,o)})))||void 0===u?void 0:u.filter((function(e){return null!=e}));d&&(g=A);var j=I.sanitized||(null==m?void 0:m.size)!=(null===(c=g)||void 0===c?void 0:c.size),P=d&&!v;return w&&O&&(P=p),!(null!=A&&A.size)&&C&&($f(n,e,t,{key:v?rp:T?np:w?tp:ep,args:{field:O},fixed:P}),P&&(Wf(n,e),e=void 0)),j&&(n.sanitized=!0),j&&e&&(e=e.set("children1",g)),n.errors=kf(kf({},n.errors),(null==I?void 0:I.errors)||{}),e}(e,t,r,n,o):"rule"===i?qf(e,t,r,n,o):e}function qf(e,t,r,n,o){var i=o.removeIncompleteRules,a=o.removeEmptyRules,s=o.forceFix,l=o.config,u=o.oldConfig,c=l.settings.showErrorMessage,d=!c||s,p=e.get("id"),f="case_group"===e.get("type"),h=e.get("properties");if(!h){if(!f)return void $f(n,e,t,{key:pp,args:{},fixed:i||a});h=new Al.Map}var g=h.get("field")||null;f&&(g="!case_value");var v=h.get("fieldSrc")||null,m=h.get("operator")||null,y=h.get("operatorOptions"),b=h.get("valueSrc"),O=h.get("value"),E=h.get("valueError"),S=h.get("fieldError"),w=function(){var e,t;return{field:(null===(e=g)||void 0===e||null===(t=e.toJS)||void 0===t?void 0:t.call(e))||g,fieldSrc:v,operator:m,operatorOptions:y?y.toJS():{},valueSrc:b?b.toJS():null,value:O?O.toJS():null,valueError:E?E.toJS():null,fieldError:S||null}},T=w();!p&&r&&(p=r,e=e.set("id",p),n.sanitized=!0);var x=g?ev(l,g):null;g&&!x&&($f(n,e,t,{key:op,args:{field:g},side:"lhs",fixed:i||a}),g=null),null!=g||f||(h=["operator","operatorOptions","valueSrc","value","valueError","fieldError","field"].reduce((function(e,t){return e.delete(t)}),h),m=null),v||!g||f||(v=Zg(g),h=h.set("fieldSrc",v)),"range_between"!==m&&"range_not_between"!==m||(m="range_between"===m?"between":"not_between",h=h.set("operator",m));var _=m?tv(l,m,g):null;m&&!_&&($f(n,e,t,{key:ip,args:{operator:m},side:"op",fixed:i||a}),m=null);var C=g?ch(l,g):[];g&&!f&&(null!=C&&C.length?m&&-1==C.indexOf(m)&&("is_empty"===m||"is_not_empty"===m?(m="is_empty"===m?"is_null":"is_not_null",h=h.set("operator",m)):($f(n,e,t,{key:cp,args:{operator:m,field:g},side:"lhs",fixed:i||a}),m=null)):($f(n,e,t,{key:up,args:{field:g},side:"lhs",fixed:i||a}),m=null)),null!=m||f||(h=["operatorOptions","valueSrc","value","valueError"].reduce((function(e,t){return e.delete(t)}),h)),y=h.get("operatorOptions"),!m||y&&!_.options?(y=null,h=h.delete("operatorOptions")):m&&!y&&_.options&&(y=Pd(l,m,g),h=h.set("operatorOptions",y)),b=h.get("valueSrc"),O=h.get("value");var R=Jf(l,u,h,g,m,null,d,!0),I=R.newValue,A=R.newValueSrc,j=R.newValueError,P=R.validationErrors,L=R.newFieldError,k=R.fixedField;O=I,b=A,E=j,S=L,g=k,h=(h=(h=h.set("field",g)).set("value",O)).set("valueSrc",b),h=c?h.set("valueError",E).set("fieldError",S):h.delete("valueError").delete("fieldError");var N=w(),D=!Ul(T,N),F=Ah(h.toObject(),l),M=f?F.parts.value:F.score>=3;if(D&&(n.sanitized=!0,e=e.set("properties",h)),null==P||P.map((function(r){return $f(n,e,t,r)})),!M)if(f);else{var V=F.score?i:a,U={key:pp,args:{}};if(F.parts.field){if(!F.parts.value){var B,z,$,W;U.key=hp,U.side="rhs",null!==(B=N.valueSrc)&&void 0!==B&&B[0]&&(null===(z=N.valueSrc)||void 0===z?void 0:z[0])!=(null===($=T.valueSrc)||void 0===$?void 0:$[0])&&null!=(null===(W=N.value)||void 0===W?void 0:W[0])&&(U.key=dp,U.args={valueSrcs:N.valueSrc})}}else U.key=fp,U.side="lhs";U.fixed=V,$f(n,e,t,U),V&&(Wf(n,e),e=void 0)}return e}var Gf=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=arguments.length>9&&void 0!==arguments[9]&&arguments[9],c=arguments.length>10&&void 0!==arguments[10]&&arguments[10],d=[],p=o;if(null!=o){var f,h,g,v;if("field"===a){var m=lo(Yf(t,r,o,a,i,s,e,n,l,u),2);p=m[0],d=m[1]}else if("func"===a){var y=lo(Xf(t,r,o,a,i,s,e,n,l,u,c),2);p=y[0],d=y[1]}else if("value"===a||!a){var b=lo(Kf(r,o,a,i,s,e,n,l,u),2);p=b[0],d=b[1]}var O=!(null!==(f=d)&&void 0!==f&&f.find((function(e){return!e.fixed})));if(r&&!["field","func"].includes(a)&&(null===(h=d)||void 0===h||!h.length||O)){var E=Eh(e,r,n,a),S=n?tv(e,n,r):null,w=rv(e,r,n,E,a,{forExport:!0}),T="field"===a?ev(e,o):null,x=w,_=w.validateValue;if("function"==typeof _){var C=[p,x,n,S];"field"===a&&C.push(T);var R,I,A=_.call.apply(_,[e.ctx].concat(C));"object"!==Kn(A)||null===A||Array.isArray(A)?"boolean"==typeof A?0==A&&d.push({key:sp,args:{}}):"string"==typeof A&&d.push({key:A,args:null}):(I=null!==(R=A.error)&&void 0!==R&&R.key?kf({},A.error):{key:A.error,args:null},void 0!==A.fixedValue&&l&&(I.fixed=!0,I.fixedFrom=p,I.fixedTo=A.fixedValue,p=A.fixedValue),d.push(I))}}if(O=!(null!==(g=d)&&void 0!==g&&g.find((function(e){return!e.fixed}))),null!==(v=d)&&void 0!==v&&v.length&&!O&&l){var j=ev(e,r),P=null==j?void 0:j.fieldSettings,L=null==P?void 0:P.defaultValue;if(void 0!==L){var k=d[d.length-1];k.fixed=!0,k.fixedFrom=p,k.fixedTo=L,p=L,d.map((function(e){e.fixed=!0}))}}}return[p,d]},Kf=function(e,t,r,n,o,i){var a,s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7],c=[],d=t;if(e){var p=ev(i,e),f=Eh(i,e,l,r),h=i.widgets[f],g=null==h?void 0:h.type,v=null==h?void 0:h.jsType,m=null==p?void 0:p.fieldSettings,y=(null==m?void 0:m.treeValues)||(null==m?void 0:m.listValues),b=!(null==m||!m.asyncFetch),O=y||b;if(n&&g&&n!=g)return c.push({key:mp,args:{wType:g,valueType:n}}),[t,c];if(v&&(s=v,Nf(a=t)!==s&&("number"!==s||isNaN(a)))&&!O)return c.push({key:yp,args:{jsType:v,valueTypeof:Nf(t)}}),[t,c];if(m){var E=o||y;if(E&&!m.allowCustomValues&&"case_value"!==f){var S=function(e,t,r,n,o){var i=Al.List.isList(e)?e.toJS():e instanceof Array?co(e):void 0,a=e,s=[];if(i){var l=i.reduce((function(e,r){var n=lo(e,2),o=n[0],i=n[1],a=Ou(t,r);return null==a?[o,[].concat(co(i),[r])]:[[].concat(co(o),[a.value]),i]}),[[],[]]),u=lo(l,2),c=u[0],d=u[1],p=d.length>0;if(a=(r=r||!0===o)&&p?c:e,d.length){var f=r&&p;s.push({key:gp,args:{badValues:d,count:d.length},fixed:f,fixedFrom:f?i:void 0,fixedTo:f?a:void 0})}return[a,s]}var h=Ou(t,e);return null==h?(a=r?null:e,s.push({key:vp,args:{value:e},fixed:r,fixedFrom:r?e:void 0,fixedTo:r?a:void 0})):a=h.value,[a,s]}(t,E,u,0,i.settings.removeInvalidMultiSelectValuesOnLoad),w=lo(S,2);d=w[0],c=w[1]}m.maxLength>0&&null!=t&&String(t).length>m.maxLength&&(d=u?String(t).substring(0,m.maxLength):t,c.push({key:bp,args:{value:t,length:String(t).length,fieldSettings:m},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}));var T=null!=m.min&&null!=m.max?kp:void 0;null!=m.min&&t<m.min&&(d=u?m.min:t,c.push({key:Op,args:{value:t,fieldSettings:m,context:T},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0})),null!=m.max&&t>m.max&&(d=u?m.max:t,c.push({key:Ep,args:{value:t,fieldSettings:m,context:T},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}))}}return[d,c]},Yf=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,l=[],u=a.settings,c=u.fieldSeparator,d=u.canCompareFieldWithField,p="object"==Kn(t)&&(null==t?void 0:t._isFuncArg),f=Array.isArray(e)?e.join(c):e,h=ev(a,e),g=Array.isArray(r)?r.join(c):r,v=ev(a,r);return v?e&&g===f&&!p?(l.push({key:wp,args:{field:f}}),[r,l]):o&&o!=v.type?(l.push({key:xp,args:{field:g,type:v.type,expected:o}}),[r,l]):e&&!p&&d&&!d(f,h,g,v,s)?(l.push({key:Tp,args:{leftField:f,rightField:g}}),[r,l]):[r]:(l.push({key:Sp,args:{field:g}}),[r,l])},Xf=function(e,t,r,n,o,i,a){var s,l,u=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],d=arguments.length>9&&void 0!==arguments[9]&&arguments[9],p=arguments.length>10&&void 0!==arguments[10]&&arguments[10],f=r,h=[];if(!r)return[r];var g=null===(s=r.get)||void 0===s?void 0:s.call(r,"func");if(!g)return[r];var v=ev(a,t);if(null!=v&&v.funcs&&!v.funcs.includes(g))return h.push({key:_p,args:{funcKey:g,field:t}}),[r,h];var m=Wg(a,g);if(!m)return h.push({key:ap,args:{funcKey:g}}),[r,h];var y=null!==(l=m.label)&&void 0!==l?l:g;if(o&&m.returnType!=o)return h.push({key:Rp,args:{funcKey:g,funcName:y,returnType:m.returnType,valueType:o}}),[r,h];for(var b in c=c||p,m.args){var O,E=m.args[b],S=f.get("args"),w=S?S.get(b):void 0,T=ev(a,E),x=null!==(O=null==T?void 0:T.label)&&void 0!==O?O:b,_=w?w.get("value"):void 0,C=w?w.get("valueSrc"):void 0;if(void 0!==_){var R=lo(Gf(a,e,T,u,_,E.type,C,i,c,d,p),2),I=R[0],A=R[1],j=!(null!=A&&A.length),P=c&&I!==_,L=c&&!j&&!P&&(d||p);if(P&&(f=f.setIn(["args",b,"value"],I)),L&&(f=f.deleteIn(["args",b]),f=nh(a,f,m,b)),!j){var k,N,D=null!==(k=null!==(N=A.find((function(e){return!e.fixed&&!e.ignore})))&&void 0!==N?N:A.find((function(e){return!e.fixed})))&&void 0!==k?k:A[0],F=P||L,M=0===A.filter((function(e){return!e.ignore})).length;if(D){var V=jf(D);h.push({key:lp,args:{funcKey:g,funcName:y,argKey:b,argName:x,argValidationError:V,argErrors:A},ignore:M,fixed:F,fixedFrom:F?_:void 0,fixedTo:F?P?I:E.defaultValue:void 0})}}}else if(!E.isOptional&&(d||p)){var U=c&&void 0!==E.defaultValue&&(d||p);d&&h.push({key:Cp,args:{funcKey:g,funcName:y,argKey:b,argName:x},fixed:U,fixedTo:U?E.defaultValue:void 0,ignore:!U}),U&&(f=f.deleteIn(["args",b]),f=nh(a,f,m,b))}}return[f,h]},Qf=function(e,t,r,n,o){var i,a=tv(e,r,t),s=r?Vl(a):null,l=o.toJS?o.toJS():o,u=n.toJS?n.toJS():n,c=l.filter((function(e){return"value"==e||null==e})).length==s;if(null!=a&&a.validateValues&&c){var d=l[0],p=Eh(e,t,r,d),f=rv(e,t,r,p,d),h=null!=f&&f.toJS?u.map((function(t){var r=f.toJS.call(e.ctx,t,f);return r instanceof Date&&(r=r.getTime()),r})):u,g=a.validateValues(h);"boolean"==typeof g&&0==g&&(i={key:Ip,args:{jsValues:h,values:u}})}return i},Jf=function(e){var t,r,n,o,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,a=arguments.length>2?arguments[2]:void 0,s=arguments.length>3?arguments[3]:void 0,l=arguments.length>4?arguments[4]:void 0,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]&&arguments[6],d=arguments.length>7&&void 0!==arguments[7]&&arguments[7],p=arguments.length>8&&void 0!==arguments[8]&&arguments[8];i||(i=e);var f=e.settings,h=f.keepInputOnChangeFieldSrc,g=f.convertableWidgets,v=f.clearValueOnChangeField,m=f.clearValueOnChangeOp,y="!case_value"==s,b=a.get("field");!b&&y&&(b=s);var O,E=a.get("fieldType"),S=a.get("fieldSrc"),w=a.get("operator"),T=a.get("value"),x=a.get("valueSrc",new Al.List),_=a.get("valueType",new Al.List),C=a.get("valueError",new Al.List),R=a.get("asyncListValues"),I=y,A=tv(i,w),j=tv(e,l,s),P=y?1:w?Vl(A):null,L=y?1:l?Vl(j):null,k=ev(i,b),N=ev(e,s),D=!b&&E&&h,F=(null==k?void 0:k.type)||E,M=(null==N?void 0:N.type)||!s&&D&&F,V=null==k?void 0:k.listValuesType,U=null==N?void 0:N.listValuesType,B=(null===(t=b)||void 0===t||null===(r=t.get)||void 0===r?void 0:r.call(t,"func"))||b,z=((null===(n=s)||void 0===n||null===(o=n.get)||void 0===o?void 0:o.call(n,"func"))||s)!=B,$=[],W=(b||D)&&(w&&l||I)&&null!=T;if((!F||!M||F!=M||"field"===u&&z&&v||"operator"===u&&m)&&(W=!1),z&&lh.includes(M)&&(U&&U===V||(W=!1)),I||(null!=T&&T.size||!L)&&(null==T||!T.size||L)||(W=!1),"func"===S&&s){var H=lo(Gf(e,null,null,l,s,M,S,R,c,d,p),2),q=H[0],G=H[1],K=!(null!=G&&G.length),Y=q!==s,X=!K&&Y&&!G.find((function(e){return!e.fixed})),Q=c&&!K&&!X&&!!u&&s!==b;if(Q?s=b:Y&&(s=q),!K){var J=!K&&!X&&!Q,Z=G.find((function(e){return!e.fixed&&!e.ignore}));J&&Z&&(O=jf(Z)),G.map((function(e){return $.push(kf(kf({side:"lhs"},e),{},{fixed:e.fixed||Q||false}))}))}}for(var ee=0;ee<L;ee++){var te=x.get(ee)||null,re=Eh(i,b,w,te),ne=Eh(e,s,l,te),oe="value"===te?re:Eh(i,b,w,"value"),ie="value"===te?ne:Eh(e,s,l,"value");ie==oe||(g[oe]||[]).includes(ie)||!oe&&D||(W=!1)}w!=l&&[w,l].includes("proximity")&&(W=!1);var ae=x.first(),se=rv(e,s,l,null,ae),le=Oh(e,s,l,null);!s&&D&&(le=Object.keys(e.settings.valueSourcesInfo));var ue,ce=le[0];1===L&&se&&void 0!==se.type?ue=se.type:1===L&&N&&void 0!==N.type&&(ue="!group"===N.type?"number":N.type);var de=W&&"operator"===u&&1===P&&2===L,pe=[],fe=[],he=[],ge=Array.from({length:L},(function(){return null}));if(W)for(var ve=function(t){var r=T.get(t),n=_.get(t)||null,o=x.get(t)||null;de&&1===t&&(r=void 0!==pe[0]?pe[0]:T.get(0),pe[t]=r,n=_.get(0)||null,o=x.get(0)||null);var i=!o||void 0!==le.find((function(e){return e==o})),a=lo(Gf(e,s,s,l,r,n,o,R,c,d,p),2),u=a[0],f=a[1],h=!(null!=f&&f.length),g=u!==r,v=!h&&g&&!(null!=f&&f.find((function(e){return!e.fixed}))),m=!(null!=f&&f.find((function(e){return!e.fixed&&!e.ignore}))),y=!i||c&&!h&&!v&&(!m||z);h||null==f||f.map((function(e){return $.push(kf(kf({side:"rhs",delta:t},e),{},{fixed:e.fixed||y}))})),y&&(pe[t]=null,0===t&&delete pe[1]);var b=!h&&!g,O=null==f?void 0:f.find((function(e){return!e.fixed&&!e.ignore}));b&&O&&(ge[t]=jf(O)),g&&(pe[t]=u),!de||0!==t||h||g||(de=!1),de&&0===t&&["func","field"].includes(o)&&(de=!1)},me=0;me<L;me++)ve(me);if(!W)for(var ye=0;ye<L;ye++)if(1===L){var be,Oe=nu([null==N?void 0:N.defaultValue,null==N||null===(be=N.fieldSettings)||void 0===be?void 0:be.defaultValue,null==se?void 0:se.defaultValue]);pe[ye]=Oe,null!=Oe&&Oe.func&&(fe[ye]="func")}for(var Ee=0;Ee<L;Ee++){var Se,we,Te=W&&x.get(Ee)||null,xe=W&&_.get(Ee)||null;W&&de&&1===Ee&&(Te=null!==(Se=fe[Ee])&&void 0!==Se?Se:x.get(0),xe=null!==(we=he[Ee])&&void 0!==we?we:_.get(0),fe[Ee]=Te,he[Ee]=xe),le.includes(Te)||(fe[Ee]=ce),xe||(he[Ee]=ue)}var _e=T;(pe.length>0||!W)&&(_e=new Al.List(Array.from({length:L},(function(e,t){return void 0!==pe[t]?pe[t]:W?T.get(t):void 0}))));var Ce=x;(fe.length>0||!W)&&(Ce=new Al.List(Array.from({length:L},(function(e,t){var r;return null!==(r=fe[t])&&void 0!==r?r:W&&x.get(t)||null}))));var Re=_;(he.length>0||!W)&&(Re=new Al.List(Array.from({length:L},(function(e,t){var r;return null!==(r=he[t])&&void 0!==r?r:W&&_.get(t)||null}))));var Ie=Qf(e,s,l,_e,Ce);if(Ie){var Ae=jf(Ie),je=c&&L>=2,Pe=_e;je&&(pe[1]=_e.get(0),_e=_e.set(1,pe[1]),ge[1]=ge[0]),!je&&ge.push(Ae),$.push(kf(kf({side:"rhs",delta:-1},Ie),{},{fixed:je,fixedFrom:je?[Pe.get(0),Pe.get(1)]:void 0,fixedTo:je?[_e.get(0),_e.get(1)]:void 0}))}var Le=C,ke=(null==C?void 0:C.size)!==ge.length||ge.filter((function(e,t){return e!=C.get(t)})).length>0;return ke&&(Le=new Al.List(ge)),{canReuseValue:W,newValue:_e,newValueSrc:Ce,newValueType:Re,operatorCardinality:L,fixedField:s,newValueError:Le,newFieldError:O,validationErrors:$}},Zf=function(e){return"object"==Kn(e)&&null!==e&&!Array.isArray(e)},eh=function(e,t){if(e){var r=e.get("func"),n=r&&Wg(t,r);if(n){var o=e,i=!1;for(var a in n.args){var s=n.args[a],l=s.valueSources,u=s.isOptional,c=s.defaultValue,d=bh(t,l,s),p=o.get("args"),f=1==d.length?d[0]:void 0,h=p?p.get(a):void 0,g=h?h.get("value"):void 0,v=(h?h.get("valueSrc"):void 0)||f;if(void 0!==g){var m=Ph(g,v,t);if(void 0===m)return;if(m!==g&&(o=o.setIn(["args",a,"value"],m)),i)return}else if(void 0===c||Zf(c)){if(!u)return;i=!0}else o=(o=o.setIn(["args",a,"value"],oh(s))).setIn(["args",a,"valueSrc"],"value")}return o}}},th=function(e,t,r,n){var o=r.settings.fieldSeparator;e=e||new Al.Map,Array.isArray(t)&&(t=t.join(o));var i=e.get("func"),a=e.get("args");e=e.set("func",t);var s=t&&Wg(r,t),l=t&&$g(r,t),u=i&&$g(r,i),c=sh(u,l,a,r,n);return e=c.length?Object.keys(l.args).filter((function(e){return!c.includes(e)})).reduce((function(e,t){return e.deleteIn(["args",t])}),e):e.set("args",new Al.Map),rh(r,e,s)},rh=function(e,t,r){if(r)for(var n in r.args)t=nh(e,t,r,n);return t},nh=function(e,t,r,n){var o=r.args[n],i=o.valueSources,a=o.defaultValue,s=bh(e,i,o),l=s.length?s[0]:void 0,u=(a?Zf(a)&&a.func?"func":"value":void 0)||l;return t.getIn(["args",n])||(void 0!==a&&(t=t.setIn(["args",n,"value"],oh(o))),u&&(t=t.setIn(["args",n,"valueSrc"],u))),t},oh=function(e){var t=e.defaultValue;return Zf(t)&&!Al.Map.isMap(t)&&t.func?Al.fromJS(t,(function(e,t){return Al.Iterable.isIndexed(t)?t.toList():t.toOrderedMap()})):t},ih=function(e,t,r,n,o){if(e&&e.get("func")){var i=(e=e.setIn(["args",t,"value"],r)).getIn(["args",t,"valueSrc"]),a=n.valueSources,s=bh(o,a,n),l=1==s.length?s[0]:void 0;!l&&s.includes("value")&&(l="value"),!i&&l&&(e=e.setIn(["args",t,"valueSrc"],l))}return e},ah=function(e,t,r,n,o){return e&&e.get("func")&&(e=e.setIn(["args",t],new Al.Map({valueSrc:r}))),e},sh=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];return(null==e?void 0:e.returnType)!=(null==t?void 0:t.returnType)?[]:Object.keys(t.args).filter((function(i,a){var s=t.args[i],l=e.args[i];if(Object.keys(e.args).indexOf(i),!l&&(void 0!==s.defaultValue||s.isOptional))return!0;if((null==l?void 0:l.type)!=s.type)return!1;if(lh.includes(s.type)&&(!l.listValuesType||l.listValuesType!==s.listValuesType))return!1;if(r){var u,c=r.get(i),d=null==c?void 0:c.get("value"),p=null==c?void 0:c.get("valueSrc");if(p&&s.valueSources&&!s.valueSources.includes(p))return!1;var f=lo(Gf(n,null,s,null,d,s.type,p,null,o,!0),2),h=(f[0],f[1]);if(null!=h&&null!==(u=h.filter((function(e){return!e.fixed})))&&void 0!==u&&u.length)return!1}return!0}))},lh=["select","multiselect","treeselect","treemultiselect"],uh=function(e,t){var r;return(null===(r=e.types[t])||void 0===r?void 0:r.operators)||null},ch=function(e,t){var r=ev(e,t);return r?r.operators:[]},dh=function(e,t){var r,n=ch(e,t);return null!==(r=null==n?void 0:n[0])&&void 0!==r?r:null},ph=function(e,t,r){var n=null;if(e)if("field"===t){var o=ev(r,e);o&&(n=o.type)}else if("func"===t){var i=e.get("func");if(i){var a=Wg(r,i);a&&(n=a.returnType||a.type)}}return n},fh=function(e,t){return hh(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,"funcs","subfields")},hh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"fields",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"subfields";if(!e)return null;var i=t.settings.fieldSeparator,a=Kg(e,t),s=Kg(r,t);return a.slice(s.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return[].concat(co(s),co(e)).join(i)})).map((function(e){var r=Bg(t,e,n,o);return r&&r.label||cu()(e.split(i))})).filter((function(e){return null!=e}))},gh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;var n=r&&Bg(t,r)||null,o=t.settings.fieldSeparator,i=Kg(e,t),a=qg(e,r,t)?Kg(r,t):[];return i.slice(a.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return{part:[].concat(co(a),co(e)).join(o),key:e[e.length-1]}})).map((function(e){var r=e.part;return{key:e.key,cnf:Bg(t,r)}})).map((function(e,t,r){return[e.key,e.cnf,t>0?r[t-1].cnf:n]}))},vh=function(e,t,r,n){var o=arguments.length>5&&void 0!==arguments[5]&&arguments[5],i=rv(e,t,r,null,arguments.length>4&&void 0!==arguments[4]?arguments[4]:null)||{},a=tv(e,r,t)||{},s=null;if((o?1:a.cardinality)>1){var l=i.valueLabels||a.valueLabels;l&&(s=l[n]),s&&"object"!==Kn(s)&&(s={label:s,placeholder:s}),s||(s={label:e.settings.valueLabel+" "+(n+1),placeholder:e.settings.valuePlaceholder+" "+(n+1)})}else{var u=i.valueLabel,c=i.valuePlaceholder;s={label:u||e.settings.valueLabel,placeholder:c||e.settings.valuePlaceholder}}return s};function mh(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=[],i=[];if(!t)return{widgets:o,valueSrcs:i};var a=Xg(t),s=a?"".concat(a,"__").concat(r,"__").concat(n):null,l=Qg(e,"_getWidgetsAndSrcsForFieldOp",s);if(l)return l;var u="object"===Kn(t)&&(!!t.func&&!!t.arg||t._isFuncArg),c=ev(e,t),d=r?e.operators[r]:null;if(null!=c&&c.widgets){var p=function(){var a=c.widgets[f];if(!e.widgets[f])return 1;var s=e.widgets[f].valueSrc||"value",l=!0;if("field"===f&&(l=l&&bh(e,["field"],c).length>0),"func"===f&&(l=l&&bh(e,["func"],c).length>0),"value"!==n||a.operators||u||"!case_value"===t||(l=!1),a.operators&&r&&(l=l&&-1!=a.operators.indexOf(r)),n&&n!=s&&"const"!==n&&(l=!1),d&&0==d.cardinality&&"value"!==s&&(l=!1),l){var p,h;o.push(f);var g=-1!=(null===(p=c.valueSources)||void 0===p?void 0:p.indexOf(s));-1==(null==d||null===(h=d.valueSources)||void 0===h?void 0:h.indexOf(s))&&(g=!1),g&&!i.find((function(e){return e==s}))&&i.push(s)}};for(var f in c.widgets)p()}var h=function(e){var t=0;return c.preferWidgets?c.preferWidgets.includes(e)&&(t+=10-c.preferWidgets.indexOf(e)):e==c.mainWidget&&(t+=100),"field"===e&&(t-=1),"func"===e&&(t-=2),t};o.sort((function(e,t){return h(t)-h(e)}));var g={widgets:o,valueSrcs:i};return Jg(e,"_getWidgetsAndSrcsForFieldOp",s,g),g}var yh=function(e,t,r){return mh(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets},bh=function(e,t,r){var n;if(!r)return t;var o=null!==(n=r.type)&&void 0!==n?n:r.returnType;return"!group"===o&&(o="number"),t||(t=Object.keys(e.settings.valueSourcesInfo)),t.filter((function(t){var n=!0;if("field"===t&&e.__fieldsCntByType){var i=r._isFuncArg?0:1;n=n&&e.__fieldsCntByType[o]>i}return"func"===t&&(r.funcs&&(n=n&&r.funcs.length>0),e.__funcsCntByType&&(n=n&&e.__funcsCntByType[o]>0)),n}))},Oh=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=mh(e,t,r,null).valueSrcs;return bh(e,o,n)},Eh=function(e,t,r){var n=mh(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets,o=null;return n.length&&(o=n[0]),o},Sh=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{};if(e){var i=ev(t,e)||{},a=t.settings.fieldSeparator,s=Kg(e,t),l=Array.isArray(e)?e.join(a):e;if(null!=o&&o.useTableName&&i.tableName){var u=co(s);u[0]=i.tableName,l=u.join(a)}if(i.fieldName&&(l=i.fieldName),n){ev(t,n);var c=n;0==l.indexOf(c+a)?l=l.slice((c+a).length):i.fieldName||r.errors.push("Can't cut group ".concat(c," from field ").concat(l))}return l}},wh=function(e,t){var r=e.get("type"),n=e.getIn(["properties","mode"]);return"rule_group"==r&&"array"==n?Th(e,t):"group"==r||"rule_group"==r?_h(e,t):Rh(e,t)},Th=function(e,t){var r=e.get("children1"),n=e.get("properties");return xh(n.toObject(),r,t)},xh=function(e,t,r){var n,o,i=e.operator,a=0==(null!==(n=null===(o=r.operators[i])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1),s=!Ih(e,r),l=!Ch(t,r);return!(s&&(!a||l))},_h=function(e,t){var r=e.get("children1");return Ch(r,t)},Ch=function(e,t){return!((null==e?void 0:e.size)>0&&e.filter((function(e){return!wh(e,t)})).size>0)},Rh=function(e,t){var r=e.get("properties");return Ih((null==r?void 0:r.toObject())||{},t)},Ih=function(e,t){return!(Ah(e,t,!0).score>=3)},Ah=function(e,t){var r,n,o,i=e.field,a=e.fieldSrc,s=(e.fieldType,e.operator),l=e.value,u=e.valueSrc,c=(e.valueType,arguments.length>2&&void 0!==arguments[2]&&arguments[2]),d=null!==(r=null===(n=t.operators[s])||void 0===n?void 0:n.cardinality)&&void 0!==r?r:1,p=null!=u&&u.get?u.toJS():u,f={parts:{},score:0};if(f.parts.field=c?null!=i:jh(i,a,t),f.parts.operator=!!s,f.parts.value=(null==l||null===(o=l.filter((function(e,r){return jh(e,null==p?void 0:p[r],t,c)})))||void 0===o?void 0:o.size)>=(c?Math.min(d,1):d),f.score=Object.keys(f.parts).filter((function(e){return!!f.parts[e]})).length,c&&f.score<3){var h=!0;!f.parts.value&&"func"===a&&jh(i,a,t,!1,h)&&f.score++,f.parts.field||null==l||l.map((function(e,r){"func"===(null==p?void 0:p[r])&&jh(e,null==p?void 0:p[r],t,!1,h)&&f.score++}))}return f},jh=function e(t,r,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];if(!o&&"func"==r&&t){var a,s=null===(a=t.get)||void 0===a?void 0:a.call(t,"func"),l=Wg(n,s);if(l){var u=t.get("args");for(var c in l.args){var d=l.args[c],p=u?u.get(c):void 0,f=p?p.get("value"):void 0,h=p?p.get("valueSrc"):void 0;if(null==f&&void 0===(null==d?void 0:d.defaultValue)&&(null==d||!d.isOptional))return!1;if(null!=f&&!e(f,h,n,!i||o))return!1}return!0}}return null!=t},Ph=function(e,t,r){return"func"==t?eh(e,r):e},Lh=function e(t){var r=t.get("children1");if(1==(null==r?void 0:r.size)){var n=r.first();return"group"===n.get("type")?e(n):n}return null},kh=v(4308),Nh=v.n(kh),Dh=v(3523),Fh=v.n(Dh),Mh=v(502),Vh=v.n(Mh);function Uh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Bh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Uh(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Uh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function zh(e,t){return Vh().apply(e,t)}var $h={CALL:function(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),o=2;o<r;o++)n[o-2]=arguments[o];return e.call.apply(e,[t].concat(n))},JSX:function(e,t){return{type:e,props:t}},mergeObjects:function(e,t){return Bh(Bh({},e),t)},fromEntries:function(e){return Object.fromEntries(e)},strlen:function(e){return(null==e?void 0:e.length)||0},regexTest:function(e,t,r){return null!=(null==e?void 0:e.match(new RegExp(t,r)))},now:function(){return new Date},date_add:function(e,t,r){return Gu()(e).add(t,r).toDate()},toLowerCase:function(e){return e.toLowerCase()},toUpperCase:function(e){return e.toUpperCase()}};function Wh(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Hh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function qh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Hh(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Hh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Gh(e,t,r){var n;try{n=Vh().apply(e,t)}catch(e){throw e.message="".concat(r.join(".")," :: ").concat(e.message),e}return n}function Kh(e,t,r,n){var o;try{o=t.call.apply(t,[e].concat(co(r)))}catch(e){throw e.message="".concat(n.join(".")," :: ").concat(e.message),e}return o}!function(){for(var e in $h)t=e,r=$h[e],Vh().add_operation(t,r);var t,r}();var Yh=["conjunctions","fields","types","operators","widgets","settings","funcs","ctx"],Xh={asyncFetch:{type:"f",args:["search","offset"]},labelYes:{type:"r"},labelNo:{type:"r"},marks:{type:"r",isArr:!0},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]}},Qh=qh(qh({},Xh),{},{factory:{type:"rf"},formatValue:{type:"f",args:["val","fieldDef","wgtDef","isForDisplay","op","opDef","rightFieldDef"]},sqlFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelImportValue:{type:"f",args:["val","wgtDef","args"]},mongoFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},elasticSearchFormatValue:{type:"f",args:["queryType","val","op","field","config"]},jsonLogic:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},jsonLogicImport:{type:"f",args:["val"]},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]},toJS:{type:"f",args:["val"]}}),Jh={options:{factory:{type:"rf"}},formatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","isForDisplay","fieldDef"]},mongoFormatOp:{type:"f",args:["field","op","vals","useExpr","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},sqlFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},spelFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},jsonLogic:{type:"f",ignore:"string",args:["field","op","vals","opDef","operatorOptions","fieldDef"]},elasticSearchQueryType:{type:"f",ignore:"string",args:["valueType"]},textSeparators:{type:"r",isArr:!0}},Zh={widgetProps:Qh,opProps:Jh},eg=qh(qh({},Xh),{},{fieldSettings:Xh}),tg=qh(qh({},Xh),{},{fieldSettings:Xh,widgets:{x:Zh},mainWidgetProps:Qh}),rg={locale:{mui:{type:"f",args:[],invokeWith:[],ignore:"jl"}},caseValueField:tg,canCompareFieldWithField:{type:"f",args:["leftField","leftFieldConfig","rightField","rightFieldConfig","op"]},formatReverse:{type:"f",args:["q","op","reversedOp","operatorDefinition","revOperatorDefinition","isForDisplay"]},sqlFormatReverse:{type:"f",args:["q"]},spelFormatReverse:{type:"f",args:["q"]},formatField:{type:"f",args:["field","parts","label2","fieldDefinition","config","isForDisplay"]},formatSpelField:{type:"f",args:["field","parentField","parts","partsExt","fieldDefinition","config"]},formatAggr:{type:"f",args:["whereStr","aggrField","operator","value","valueSrc","valueType","opDef","operatorOptions","isForDisplay","aggrFieldDef"]},normalizeListValues:{type:"f",args:["listValues","type","fieldSettings"]},renderConfirm:{type:"f",args:["props"]},useConfirm:{type:"f",args:[]},renderField:{type:"rf"},renderOperator:{type:"rf"},renderFunc:{type:"rf"},renderConjs:{type:"rf"},renderButton:{type:"rf"},renderIcon:{type:"rf"},renderButtonGroup:{type:"rf"},renderValueSources:{type:"rf"},renderFieldSources:{type:"rf"},renderProvider:{type:"rf"},renderSwitch:{type:"rf"},renderSwitchPrefix:{type:"r"},renderItem:{type:"rf"},renderBeforeWidget:{type:"rf"},renderAfterWidget:{type:"rf"},renderBeforeActions:{type:"rf"},renderAfterActions:{type:"rf"},renderBeforeCaseValue:{type:"rf"},renderAfterCaseValue:{type:"rf"},renderRuleError:{type:"rf"}},ng={fields:{x:tg},widgets:{x:Qh},conjunctions:{x:{formatConj:{type:"f",args:["children","conj","not","isForDisplay"]},sqlFormatConj:{type:"f",args:["children","conj","not"]},spelFormatConj:{type:"f",args:["children","conj","not","omitBrackets"]}}},operators:{x:Jh},types:{x:{widgets:{x:Zh}}},funcs:{x:qh(qh(qh({},eg),{renderBrackets:{type:"r",isArr:!0},renderSeps:{type:"r",isArr:!0},jsonLogic:{type:"f",ignore:"string",args:["formattedArgs"]},jsonLogicImport:{type:"f",args:["val"]},spelImport:{type:"f",args:["spel"]},formatFunc:{type:"f",args:["formattedArgs","isForDisplay"]},sqlFormatFunc:{type:"f",args:["formattedArgs"]},mongoFormatFunc:{type:"f",args:["formattedArgs"]},spelFormatFunc:{type:"f",args:["formattedArgs"]}}),{},{args:{x:qh({},eg)}})},settings:rg},og=function(e){return"object"==Kn(e)&&null!==e&&!Array.isArray(e)},ig=function(e,t){if(e.__fieldNames)throw new Error("Don't apply `compressConfig()` to extended config");var r=lu()(e,Yh);delete r.ctx;for(var n=function e(t,r,n,o){if(og(t)){if(Yl(t)&&(t=Kl(t)),"funcs"===n[0]&&!r){var i=n[n.length-1];(r=Bg({funcs:o.BasicFuncs},i,"funcs","subfields")||void 0)&&(t.$$key=i)}if(void 0!==r&&og(r))for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(!Object.keys(t).includes(a)||void 0===t[a]&&void 0!==r[a]?t[a]="$$deleted":(t[a]=e(t[a],r[a],[].concat(co(n),[a]),o),void 0===t[a]&&delete t[a]));for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){var l;r&&Object.keys(r).includes(s)||(t[s]=e(t[s],null===(l=r)||void 0===l?void 0:l[s],[].concat(co(n),[s]),o)),void 0===t[s]&&delete t[s]}0===Object.keys(t).length&&(t=void 0)}else Array.isArray(t)&&t.forEach((function(r,i){t[i]=e(t[i],void 0,[].concat(co(n),[i]),o)}));if(void 0===r||!Bl(t,r,!0)){if("function"==typeof t)throw new Error("compressConfig: function at ".concat(n.join(".")," should be converted to JsonLogic"));return t}},o=0,i=Yh;o<i.length;o++){var a=i[o];if("ctx"===a);else if("fields"===a)r[a]=Fh()(r[a]),n(r[a],{},[a]);else if("funcs"===a)for(var s in r[a]=Fh()(r[a]||{}),r[a])n(r[a][s],null,[a,s],{BasicFuncs:f});else r[a]=Fh()(r[a]),n(r[a],t[a],[a])}return r},ag=function(e,t,r){if(!e.settings.useConfigCompress)throw new Error("Please enable `useConfigCompress` in config settings to use decompressConfig()");for(var n={},o=function e(t,r,n){if(og(r))for(var o in og(t)||(t={}),r)Object.prototype.hasOwnProperty.call(r,o)&&("$$deleted"===r[o]?delete t[o]:t[o]=e(t[o],r[o],[].concat(co(n),[o])));else t=Array.isArray(r)?Fh()(r):r;return t},i=function e(t,r,n){var i=!1;if(og(t)&&Object.prototype.hasOwnProperty.call(t,"$$key")&&t.$$key){var a=Bg({funcs:n.BasicFuncs},t.$$key,"funcs","subfields");if(!a)throw new Error("decompressConfig: basic function not found by key ".concat(t.$$key," at ").concat(r.join(".")));delete t.$$key,t=o(Fh()(a),t,r),i=!0}if(!i)if(og(t))for(var s in t)Object.prototype.hasOwnProperty.call(t,s)&&(t[s]=e(t[s],[].concat(co(r),[s]),n));else if(Array.isArray(t)){var l,u=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Wh(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Wh(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(u.s();!(l=u.n()).done;){var c=l.value;t[c]=e(t[c],[].concat(co(r),[c]),n)}}catch(e){u.e(e)}finally{u.f()}}return t},a=0,s=Yh;a<s.length;a++){var l=s[a];"ctx"===l?n[l]=Nh()({},t.ctx||{},r||{}):"funcs"===l?(n[l]=Fh()(e[l]||{}),i(n[l],[l],{BasicFuncs:f})):"fields"===l?n[l]=Fh()(e[l]||{}):(n[l]=Fh()(t[l]||{}),o(n[l],e[l]||{},[l]))}return n},sg=function(e){return e.__compliled||(lg(e=Fh()(e),e,{ctx:e.ctx},ng,[]),Object.defineProperty(e,"__compliled",{enumerable:!1,writable:!1,value:!0})),e};function lg(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:[];if(t)for(var a in i.length,n){var s=n[a],l="x"===a?i:[].concat(co(i),[a]);if("r"===s.type){var u=t,c=u[a];if(s.isArr)for(var d in c){var p=dg(c[d],r,[].concat(co(l),[d]));p!==c[d]&&(o.push("Compiled ".concat(l.join("."),"[").concat(d,"]")),c[d]=p)}else{var f=dg(c,r,l,void 0);f!==c&&(o.push("Compiled R ".concat(l.join("."))),u[a]=f)}}else if("rf"===s.type){var h=t,g=h[a],v=ug(g,r,l,s.ignore);v!==g&&(o.push("Compiled JL-RF ".concat(l.join("."))),h[a]=v)}else if("f"===s.type){var m,y=t,b=y[a],O=cg(b,r,l,s.args,s.ignore);s.invokeWith&&O&&"function"==typeof O&&(O=(m=O).call.apply(m,[null].concat(co(s.invokeWith)))),O!==b&&(o.push("Compiled JL-F ".concat(l.join("."))),y[a]=O)}else if("x"===a)for(var E in t){l=[].concat(co(i),[E]);var S=t[E];lg(e,S,r,s,o,l),S.subfields&&lg(e,S.subfields,r,n,o,l)}else lg(e,t[a],r,s,o,l)}}function ug(e,t,r){return Ql(e)?function(n,o){o=o||(null==t?void 0:t.ctx);var i=Gh(e,{props:n,ctx:o},r);return"string"==typeof i&&(i={type:i,props:n}),dg(i,{ctx:o},r)}:"string"==typeof e?function(n,o){o=o||(null==t?void 0:t.ctx);var i=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),o);return i?Kh(this,i,[n,o],r):dg({type:e,props:n},{ctx:o},r)}:e}function cg(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0;return Ql(e)&&"jl"!==o?function(){for(var o=arguments.length,i=new Array(o),a=0;a<o;a++)i[a]=arguments[a];var s=this||(null==t?void 0:t.ctx),l=(n||[]).reduce((function(e,t,r){return qh(qh({},e),{},no({},t,i[r]))}),{args:i,ctx:s});return Gh(e,l,r)}.bind(null==t?void 0:t.ctx):"string"==typeof e&&"string"!==o?function(){var n=this||(null==t?void 0:t.ctx),o=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),n);if(o){for(var i=arguments.length,a=new Array(i),s=0;s<i;s++)a[s]=arguments[s];return Kh(this,o,a,r)}throw new Error("".concat(r.join(".")," :: Function ").concat(e," is not found in ctx"))}.bind(null==t?void 0:t.ctx):e}function dg(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0;if(Xl(e)){var o,i=e.type,a=e.props;if("string"!=typeof i)throw new Error("renderReactElement for ".concat(r.join("."),": type should be string"));var s,l=function(e,t){var r;return(null==t||null===(r=t.components)||void 0===r?void 0:r[e])||t.W[e]||t.O[e]}(i,t.ctx)||i.toLowerCase();return void 0!==n&&(a=qh(qh({},a),{},{key:n})),null!==(o=a)&&void 0!==o&&o.children&&(s=dg(a.children,t,r),a=qh(qh({},a),{},{children:s})),t.ctx.RCE(l,a)}return e instanceof Array?e.map((function(e,n){return dg(e,t,r,""+n)})):e}var pg=v(2815),fg=v.n(pg),hg={reverseOperatorsForNot:!1,canShortMongoQuery:!0,formatField:function(e,t,r,n,o,i){return i?r:e},caseValueField:{type:"case_value"},fieldSources:["field"],keepInputOnChangeFieldSrc:!0,fieldItemKeysForSearch:["label","path","altLabel","grouplabel"],listKeysForSearch:["title","value"],valueSourcesInfo:{value:{}},fieldSeparator:".",fieldSeparatorDisplay:".",canReorder:!0,canRegroup:!0,canDeleteLocked:!1,canLeaveEmptyGroup:!0,shouldCreateEmptyGroup:!1,exportPreserveGroups:!1,removeEmptyGroupsOnLoad:!0,removeEmptyRulesOnLoad:!0,removeIncompleteRulesOnLoad:!1,removeInvalidMultiSelectValuesOnLoad:!0,showErrorMessage:!1,setOpOnChangeField:["keep","default"],groupOperators:["some","all","none"],defaultGroupConjunction:"AND",locale:{moment:"en"},valueLabel:"Value",valuePlaceholder:"Value",fieldLabel:"Field",operatorLabel:"Operator",funcLabel:"Function",fieldPlaceholder:"Select field",funcPlaceholder:"Select function",operatorPlaceholder:"Select operator",lockLabel:"Lock",lockedLabel:"Locked",deleteLabel:"Delete",addGroupLabel:"Add group",addCaseLabel:"Add condition",addDefaultCaseLabel:"Add default condition",defaultCaseLabel:"Default:",addRuleLabel:"Add rule",addSubRuleLabel:"Add sub rule",delGroupLabel:"Delete",notLabel:"Not",fieldSourcesPopupTitle:"Select source",valueSourcesPopupTitle:"Select value source",removeRuleConfirmOptions:null,removeGroupConfirmOptions:null};function gg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return vg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?vg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function vg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var mg,yg=0,bg=0,Og={},Eg=function(){return mg||(mg=wg({reactIndex:void 0,maxSize:3,canCompile:void 0})),mg},Sg=function(e,t){var r;for(var n in Og){var o=Og[n].findExtendedConfig(e,t);if(o){r=o;break}}return r},wg=function(){var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{reactIndex:void 0,maxSize:2,canCompile:!0},r=new Map,n=t.maxSize||2,o=++yg,i=function(e,t){r.size+1>n&&r.delete(r.keys().next().value),r.set(e,t)},a=function(e,t){var n,o=gg(r.keys());try{var i,a=function(){var o=n.value;if(Yh.filter((function(t){return o[t]===e[t]})).length===Yh.length&&(!t||o.__compliled))return{v:r.get(o)}};for(o.s();!(n=o.n()).done;)if(i=a())return i.v}catch(e){o.e(e)}finally{o.f()}var s,l=gg(r.values());try{var u,c=function(){var r=s.value;if(Yh.filter((function(t){return r[t]===e[t]})).length===Yh.length&&(!t||r.__compliled))return{v:r}};for(l.s();!(s=l.n()).done;)if(u=c())return u.v}catch(e){l.e(e)}finally{l.f()}return null};return e={getExtendedConfig:function(e){return r=function(e){return lu()(e,Yh)}(e),a(r)||function(e){var r=Rg(e,++bg,t.canCompile);return i(e,r),r}(r);var r},findExtendedConfig:a,getBasicConfig:function(e){var t,n=gg(r.keys());try{var o,i=function(){var n=t.value,o=r.get(n);if(0===Yh.map((function(t){return o[t]===e[t]})).filter((function(e){return!e})).length)return{v:n}};for(n.s();!(t=n.n()).done;)if(o=i())return o.v}catch(e){n.e(e)}finally{n.f()}return e},clearConfigMemo:function(){r.clear(),delete Og[o],mg===e&&(mg=void 0)},configId:bg,storeConfigPair:i,getSize:function(){return r.size},configStore:r,memoId:o,meta:t},void 0===t.reactIndex&&(mg=e),Og[o]=e,e};function Tg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return xg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?xg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function xg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function _g(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Cg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_g(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_g(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Rg=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(r=r&&e.settings.useConfigCompress,e.__configId)return e;var n=Sg(e,r);if(n)return n;var o=e;(e=r?e.__compliled?Fh()(e):sg(e):Fh()(e)).settings=fg()({},hg,e.settings,Gl),e.__fieldsCntByType={},e.__funcsCntByType={},e.__fieldNames={},function(e,t){for(var r in e)Ig(0,e[r],t)}(e.types,e),Ag(e.fields,e),jg(e.funcs,e);var i=e.settings.caseValueField;i&&Pg(i,e,[],!1,!0);var a=e.settings.locale.moment;return a&&Gu().locale(a),Object.defineProperty(e,"__configId",{enumerable:!1,writable:!1,value:t||Pl()}),e.__cache={},eu(e),Eg().storeConfigPair(o,e),e};function Ig(e,t,r){var n=null,o=null;t.mainWidget=t.mainWidget||Object.keys(t.widgets).filter((function(e){return"field"!=e&&"func"!=e}))[0];var i=t.excludeOperators||[];for(var a in t.widgets){var s=t.widgets[a],l=s.defaultOperator;s.operators&&(n=Zl(n,s.operators.filter((function(e){return!i.includes(e)})))),l&&!i.includes(l)&&(o&&a!==t.mainWidget||(o=l)),a==t.mainWidget&&(s.widgetProps=Cg(Cg({},t.mainWidgetProps||{}),s.widgetProps||{})),t.widgets[a]=s}t.valueSources||(t.valueSources=Object.keys(r.settings.valueSourcesInfo));var u,c=Tg(t.valueSources);try{for(c.s();!(u=c.n()).done;){var d=u.value;"value"==d||t.widgets[d]||(t.widgets[d]={})}}catch(e){c.e(e)}finally{c.f()}!t.operators&&n&&(t.operators=Array.from(new Set(n))),!t.defaultOperator&&o&&(t.defaultOperator=o)}function Ag(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];for(var n in e){var o=[].concat(co(r),[n]);Pg(e[n],t,o),e[n].subfields&&Ag(e[n].subfields,t,o)}}function jg(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];if(e){var o=(null==t||null===(r=t.settings)||void 0===r?void 0:r.fieldSeparator)||".";for(var i in e){var a=[].concat(co(n),[i]),s=a.join(o),l=e[i];if(l.returnType&&(l.type=l.returnType,t.__funcsCntByType[l.returnType]||(t.__funcsCntByType[l.returnType]=0),t.__funcsCntByType[l.returnType]++),Pg(l,t,a,!1),l.args){for(var u in l.args)Pg(l.args[u],t,[].concat(co(a),[u]),!0);var c,d=!0,p=Tg(Object.keys(l.args).reverse());try{for(p.s();!(c=p.n()).done;){var f=c.value,h=l.args[f];!d&&h.isOptional&&(ou.info("Arg ".concat(f," for func ").concat(s," can't be optional")),delete h.isOptional),h.isOptional||(d=!1)}}catch(e){p.e(e)}finally{p.f()}}l.subfields&&jg(l.subfields,t,[].concat(co(n),[i]))}}}function Pg(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]&&arguments[4],a=t.settings,s=a.showLabels,l=a.fieldSeparator;l=null!==(r=l)&&void 0!==r?r:".";var u=n[n.length-1],c=o?n.slice(0,n.length-1).join(l):n.join(l),d=!!e.returnType,p=e.type||e.returnType,f=t.types[p],h=e.excludeOperators||[],g=(e.operators||(null==f?void 0:f.operators)||[]).filter((function(e){return!h.includes(e)})),v=e.defaultOperator||(null==f?void 0:f.defaultOperator);h.includes(v)&&(v=void 0);var m=!!v&&v==e.defaultOperator;if(m&&(e.ownDefaultOperator=e.defaultOperator),f){o||d||i||(t.__fieldsCntByType[p]||(t.__fieldsCntByType[p]=0),t.__fieldsCntByType[p]++),o&&(e._isFuncArg=!0,e._argKey=u,e._funcKey=c),d&&(e._isFunc=!0,e._funcKey=c),i&&(e._isCaseValue=!0),function(e,t,r){for(var n,o,i=0,a=["listValues","treeValues","allowCustomValues","validateValue"];i<a.length;i++){var s=a[i];e[s]&&(e.fieldSettings||(e.fieldSettings={}),e.fieldSettings[s]=e[s],delete e[s])}null!==(n=e.fieldSettings)&&void 0!==n&&n.listValues&&t.settings.normalizeListValues&&(e.fieldSettings.listValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.listValues,r,e.fieldSettings)),null!==(o=e.fieldSettings)&&void 0!==o&&o.treeValues&&t.settings.normalizeListValues&&(e.fieldSettings.treeValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.treeValues,r,e.fieldSettings))}(e,t,p);var y=["widgets","operators","defaultOperator"];Object.keys(f).filter((function(e){return!y.includes(e)})).map((function(t){e[t]||(e[t]=Fl(f[t]))}));var b=f.excludeOperators||[];e.operators&&(b=b.filter((function(t){return!e.operators.includes(t)}))),e.widgets||(e.widgets={});var O=function(){var t=Cg({},e.widgets[E]||{}),r=f.widgets[E]||{};if(!o){var n=t.defaultOperator,i=[].concat(co(h),co(b)),a=e.preferWidgets&&("field"===E||e.preferWidgets.includes(E))||i.length>0;if(t.operators){var l=t.operators.filter((function(e){return!i.includes(e)}));t.operators=l,g=Zl(g,l)}else if(a&&r.operators){var c=r.operators.filter((function(e){return!i.includes(e)}));t.operators=c,g=Zl(g,c)}n&&!i.includes(n)&&(v&&(m||E!==e.mainWidget)||(v=n))}E===e.mainWidget?t.widgetProps=Cg(Cg(Cg({},r.widgetProps||{}),e.mainWidgetProps||{}),t.widgetProps||{}):t.widgetProps=Cg(Cg({},r.widgetProps||{}),t.widgetProps||{});var d=Array.from(new Set([].concat(co(Object.keys(r.opProps||{})),co(Object.keys(t.opProps||{})))));if(d.length){var p,y={},O=Tg(d);try{for(O.s();!(p=O.n()).done;){var S,w,T=p.value;y[T]=Cg(Cg({},(null===(S=r.opProps)||void 0===S?void 0:S[T])||{}),(null===(w=t.opProps)||void 0===w?void 0:w[T])||{})}}catch(e){O.e(e)}finally{O.f()}t.opProps=y}var x=t,_=x.valueLabel,C=x.valuePlaceholder;o&&(_||(t.valueLabel=e.label||u),C||s||(t.valuePlaceholder=e.label||u)),t=Cg(Cg({},r),t),e.widgets[E]=t};for(var E in f.widgets)O();if(o||(e.operators||(e.operators=Array.from(new Set(g))),e.defaultOperator||(e.defaultOperator=v)),!o&&!d&&!i){var S=function(e,t){if(!t)return{};var r=e.settings.fieldSeparator,n=co(t).reduce((function(t,n,o,i){var a=t.computedPath,s=t.computed,l=t.inGroup,u=[].concat(co(i.slice(0,o)),[n]),c=Bg(e,u);return"!group"===(null==c?void 0:c.type)&&o<i.length-1?(l=u.join(r),a=[]):null!=c&&c.fieldName?(s=!0,a=[c.fieldName]):a=[].concat(co(a),[n]),{computedPath:a,computed:s,inGroup:l}}),{computedPath:[],computed:!1,inGroup:void 0}),o=n.computedPath,i=n.computed,a=n.inGroup;return i?{fieldName:o.join(r),inGroup:a}:{}}(t,n),w=S.fieldName,T=S.inGroup;w&&(e.fieldName=w,t.__fieldNames[w]||(t.__fieldNames[w]=[]),t.__fieldNames[w].push({fullPath:n,inGroup:T}))}}else e.disabled=!0}function Lg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function kg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Lg(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Lg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Ng=au().mark(Mg),Dg=au().mark(Vg),Fg=kl;function Mg(e){return au().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Ug(e,e.funcs||{},[]),"t0",1);case 1:case"end":return t.stop()}}),Ng)}function Vg(e){return au().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Ug(e,e.fields||{},[]),"t0",1);case 1:case"end":return t.stop()}}),Dg)}function Ug(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";return au().mark((function o(i){var a,s,l;return au().wrap((function(o){for(;;)switch(o.prev=o.next){case 0:a=(null==e||null===(i=e.settings)||void 0===i?void 0:i.fieldSeparator)||".",o.t0=au().keys(t);case 2:if((o.t1=o.t0()).done){o.next=13;break}if(s=o.t1.value,!(l=t[s])[n]){o.next=9;break}return o.delegateYield(Ug(e,l[n],[].concat(co(r),[s]),n),"t2",7);case 7:o.next=11;break;case 9:return o.next=11,[[].concat(co(r),[s]).join(a),l];case 11:o.next=2;break;case 13:case"end":return o.stop()}}),o)}))()}var Bg=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"fields",i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";if(!t)return null;if("!case_value"===t)return null==e||null===(n=e.settings)||void 0===n?void 0:n.caseValueField;var a=(null==e||null===(r=e.settings)||void 0===r?void 0:r.fieldSeparator)||".",s=Kg(t,e),l=e[o];if(!l)return null;for(var u=l,c=null,d=[],p=0;p<s.length;p++){var f=s[p];d.push(f),c=u[d.join(a)],p<s.length-1&&(c&&c[i]?(u=c[i],d=[]):c=null)}return c},zg=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=e.settings.fieldSeparator,a=[o].concat(co(t.split(i))).filter((function(e){return null!=e})),s=t,l=null===(r=e.__fieldNames[s])||void 0===r||null===(n=r.find)||void 0===n||null===(n=n.call(r,(function(e){var t=e.inGroup;return!t||(null==o?void 0:o.startsWith(t))})))||void 0===n?void 0:n.fullPath;return(l||a).join(i)},$g=function(e,t){if(!t)return null;var r=Bg(e,t,"funcs","subfields");if(!r)return null;var n=r.returnType,o=r.args,i=Object.fromEntries(Object.entries(o||{}).map((function(e){var t=lo(e,2),r=t[0],n=t[1];return[r,lu()(n,["type","valueSources","defaultValue","fieldSettings","isOptional","_funcKey","_argKey","_isFuncArg"])]})));return{returnType:n,args:i}},Wg=function(e,t){return t&&Bg(e,t,"funcs","subfields")||null},Hg=function(e,t,r){var n=Wg(e,t);return n&&(n.args&&n.args[r]||null)||null},qg=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return!1;var o=(null==n||null===(r=n.settings)||void 0===r?void 0:r.fieldSeparator)||".",i=Gg(e,n),a=Gg(t,n);return i.startsWith(a+o)},Gg=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if("string"==typeof e)return e;var n=(null==r||null===(t=r.settings)||void 0===t?void 0:t.fieldSeparator)||".";return Kg(e,r).join(n)},Kg=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!e)return[];if(Array.isArray(e))return e;var i,a=(null==o||null===(t=o.settings)||void 0===t?void 0:t.fieldSeparator)||".";return null!=e&&e.func?Array.isArray(e.func)?e.func:e.func.split(a):null!=e&&null!==(r=e.get)&&void 0!==r&&r.call(e,"func")?null==e||null===(i=e.get)||void 0===i?void 0:i.call(e,"func").split(a):(null==e||null===(n=e.split)||void 0===n?void 0:n.call(e,a))||[]},Yg=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!e)return null;var n=t.settings.fieldSeparator,o=Kg(e,t);return r?o:o.map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return e.join(n)}))},Xg=function(e){var t;if("string"==typeof e||Array.isArray(e))return"field:".concat(Gg(e));if("object"===Kn(e)&&e){if(e._funcKey&&e._argKey)return"arg:".concat(Gg(e._funcKey),"__").concat(e._argKey);if(e._funcKey)return"func:".concat(Gg(e._funcKey));if(e.func&&e.arg)return"arg:".concat(Gg(e.func),"__").concat(e.arg);if(e.func)return"func:".concat(Gg(e.func));if(e.type)return null}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?"arg:".concat(Gg(e.get("func")),"__").concat(e.get("arg")):"func:".concat(Gg(e.get("func"))):null},Qg=function(e,t,r){var n;return null===(n=e.__cache)||void 0===n||null===(n=n[t])||void 0===n?void 0:n[r]},Jg=function(e,t,r,n){e.__cache&&r&&(e.__cache[t]||(e.__cache[t]={}),e.__cache[t][r]=n)},Zg=function(e){var t;if(!e)return null;if("object"===Kn(e)){if(!e.func&&e.type)return"field";if(e.func)return e.func&&e.arg?null:"func"}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?null:"func":"field"},ev=function(e,t){var r;if(!t)return null;if("object"==Kn(t)){if(!t.func&&t.type)return t;if(t.func)return t.func&&t.arg?Hg(e,t.func,t.arg):Wg(e,t.func)}return null!=t&&null!==(r=t.get)&&void 0!==r&&r.call(t,"func")?null!=t&&t.get("arg")?Hg(e,t.get("func"),t.get("arg")):Wg(e,t.get("func")):Bg(e,t)||null},tv=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return null;var n=e.operators[t];if(r){var o,i,a=Xg(r),s=a?"".concat(a,"__").concat(t):null,l=Qg(e,"getOperatorConfig",s);if(l)return l;var u=ev(e,r),c=Eh(e,r,t,null),d=e.widgets[c]||{},p=(u&&u.widgets?u.widgets[c]:{})||{},f=(null===(o=d.opProps)||void 0===o?void 0:o[t])||{},h=(null===(i=p.opProps)||void 0===i?void 0:i[t])||{},g=kg(kg(kg({},n),f),h);return Jg(e,"getOperatorConfig",s,g),g}return n},rv=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{};if(!t)return null;var s=ev(e,t),l=Xg(t);o||(o=Eh(e,t,n,i));var u=l?"".concat(l,"__").concat(n,"__").concat(o,"__").concat(i):null,c=Qg(e,"getFieldWidgetConfig",u);if(c)return c;var d=e.widgets[o]||{},p=(null==s||null===(r=s.widgets)||void 0===r?void 0:r[o])||{},f=p.widgetProps||{},h="value"!==i&&i?{}:null==s?void 0:s.fieldSettings,g=kg(kg(kg(kg({},d),p),f),h);return Jg(e,"getFieldWidgetConfig",u,g),a.forExport&&(g=Ml(g,"factory")),g},nv=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=e.settings.fieldSeparator,n=Kg(t,e),o=t?Bg(e,t):e,i=null,a=[];do{var s,l=o===e?e.fields:null===(s=o)||void 0===s?void 0:s.subfields;if(!l||!Object.keys(l).length){o=i=null;break}i=Object.keys(l)[0],a.push(i),o=l[i]}while("!struct"==o.type||"!group"==o.type);return(n||[]).concat(a).join(r)};function ov(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function iv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ov(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ov(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var av=function(e,t){var r={usedFields:[]},n=sv(e,t,r);if(n)return iv(iv({},n),r)},sv=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?lv(e,t,r):"rule"===n?uv(e,t,r):void 0}},lv=function(e,t,r){var n=e.get("properties")||new $a,o=e.get("children1"),i=e.get("id"),a=o.map((function(e){return sv(e,t,r)})).filter((function(e){return void 0!==e}));if(a.size){var s=n.get("conjunction");s||(s=Nd(t));var l=n.get("not");return{id:i,rules:a.toList(),condition:s.toUpperCase(),not:l}}},uv=function(e,t,r){var n,o=e.get("properties")||new $a,i=e.get("id"),a=o.get("operator"),s=o.get("operatorOptions"),l=o.get("field"),u=o.get("value"),c=o.get("valueSrc"),d=o.get("valueType"),p=u.filter((function(e){return void 0===e})).size>0;if(null!=l&&null!=a&&!p){var f=ev(t,l)||{},h=tv(t,a,l)||{},g=f.type||"undefined",v=Vl(h),m=t.types[f.type]||{},y=Sh(l,t,r);if(!(u.size<v)){-1==r.usedFields.indexOf(l)&&r.usedFields.push(l),u=u.toArray(),c=c.toArray(),d=(null===(n=d)||void 0===n?void 0:n.toArray())||[];for(var b=[],O=0;O<u.length;O++){var E={type:d[O],value:u[O]};if(b.push(E),"field"==c[O]){var S=u[O];-1==r.usedFields.indexOf(S)&&r.usedFields.push(S)}}var w=s?s.toJS():null;w&&!Object.keys(w).length&&(w=null);var T={id:i,fieldName:y,type:g,input:m.mainWidget,operator:a};return w&&(T.operatorOptions=w),T.values=b,T}}};function cv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function dv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?cv(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):cv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function pv(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return fv(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?fv(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function fv(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var hv=function(e,t){var r,n={usedFields:[],errors:[]},o=Rg(t,void 0,!1),i=gv(e,o,n,!1,!0),a=n.errors,s=n.usedFields,l=(o.settings.fieldSeparator,{}),u=pv(s);try{for(u.s();!(r=u.n()).done;)for(var c=r.value,d=Kg(c,t),p=(ev(o,c),l),f=0;f<d.length;f++){var h=d[f],g=ev(o,d.slice(0,f+1))||{};f!=d.length-1?"!group"==g.type&&"struct"!=g.mode?(p[h]||(p[h]=[{}]),p=p[h][0]):(p[h]||(p[h]={}),p=p[h]):p[h]||(p[h]=null)}}catch(e){u.e(e)}finally{u.f()}return{errors:a,logic:i,data:l}},gv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(e){var a,s=e.get("type"),l=(e.get("properties")||new $a).get("isLocked"),u=t.settings.jsonLogic.lockedOp;return"group"===s||"rule_group"===s?a=vv(e,t,r,n,o,i):"rule"===s?a=mv(e,t,r,n,i):"switch_group"==s?a=yv(e,t,r,n):"case_group"==s&&(a=bv(e,t,r,n,i)),l&&a&&u&&(a=no({},u,a)),a}},vv=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]&&arguments[4],d=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,p=e.get("type"),f=e.get("properties")||new $a,h=f.get("mode"),g=e.get("children1")||new fs,v=f.get("field"),m=ev(t,v),y=f.get("conjunction");y||(y=Nd(t));var b=t.conjunctions[y].jsonLogicConj||y.toLowerCase(),O=!!f.get("not"),E="rule_group"===p&&!c,S=E&&"struct"!=h,w=S?v:d,T=f.get("operator"),x=T&&tv(t,T,v)||null,_=Ov(t,f,r,T,d),C=E&&(!T||0==(null===(n=x)||void 0===n?void 0:n.cardinality)),R=E&&(null==g?void 0:g.size)>0,I=(E&&null!=g&&g.size,O),A=!1;R?(A=O,I=u):u&&(I=!I);var j=!1,P=null===(o=x)||void 0===o?void 0:o.reversedOp,L=tv(t,P,v),k=!(null!==(i=x)&&void 0!==i&&i.jsonLogic||null===(a=L)||void 0===a||!a.jsonLogic),N=!(null===(s=L)||void 0===s||!s.jsonLogic),D=null===(l=Lh(e))||void 0===l?void 0:l.get("type");if(!!t.settings.reverseOperatorsForNot&&(!E&&I&&"rule"===D||A&&1===(null==g?void 0:g.size))&&(R?A=!A:I=!I,j=!0),I&&E&&N&&(t.settings.reverseOperatorsForNot||k)){I=!I;var F=[P,T];T=F[0],P=F[1];var M=[L,x];x=M[0],L=M[1]}var V=g.map((function(e){return gv(e,t,r,j,!1,w)})).filter((function(e){return void 0!==e})),U=!!t.settings.exportPreserveGroups;if(S&&!C){if(null==_)return}else if(!V.size&&!U)return;var B=c||U||1!=V.size;B||!O||j||(B=g.some((function(e){var r,n,o,i,a=null===(r=e.get("properties"))||void 0===r?void 0:r.get("operator"),s=null===(n=t.operators)||void 0===n||null===(n=n[a])||void 0===n?void 0:n.reversedOp;return null!==(o=null===(i=t.operators)||void 0===i||null===(i=i[s])||void 0===i?void 0:i._jsonLogicIsExclamationOp)&&void 0!==o&&o})));var z={};if(B?z[b]=V.toList().toJS():z=V.first(),A&&(z={"!":z}),S){var $=wv(r,t,v,d);if(C)z=no({},T||"some",[$,z]);else{var W=V.size?{filter:[$,z]}:$;z=Tv(t,f,{reduce:[W,{"+":[1,{var:"accumulator"}]},0]},_,T,null,m)}}return I&&(z={"!":z}),z},mv=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d=e.get("properties")||new $a,p=d.get("field"),f=d.get("fieldSrc"),h=d.get("operator"),g=d.get("operatorOptions");if((g=g?g.toJS():null)&&!Object.keys(g).length&&(g=null),null!=p&&null!=h){var v=ev(t,p),m=tv(t,h,p),y=null===(n=m)||void 0===n?void 0:n.reversedOp,b=tv(t,y,p);if(null!==(o=m)&&void 0!==o&&o.jsonLogic||null!==(i=b)&&void 0!==i&&i.jsonLogic){var O=u,E=!(null!==(a=m)&&void 0!==a&&a.jsonLogic||null===(s=b)||void 0===s||!s.jsonLogic),S=!(null===(l=b)||void 0===l||!l.jsonLogic)&&(!!t.settings.reverseOperatorsForNot||E);if(O&&S||E){O=!O;var w=[y,h];h=w[0],y=w[1];var T=[b,m];m=T[0],b=T[1]}var x=Ov(t,d,r,h,c);if(void 0!==x){var _="func"===f?Sv(r,t,p,c):wv(r,t,p,c);if(void 0!==_)return Tv(t,d,_,x,h,g,v,O)}}else r.errors.push("Operator ".concat(h," is not supported"))}},yv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=e.get("children1");if(o){for(var i=o.map((function(e){return bv(e,t,r,n,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray(),a=[],s=0;s<i.length;s++)s===i.length-1||i[s][0]?(a.push(i[s]),s===i.length-1&&i[s][0]&&a.push([void 0,null])):r.errors.push("No condition for case ".concat(s));if(a.length){if(1===a.length){var l=lo(a[0],2),u=(l[0],l[1]);return null==u&&(u=null),u}for(var c={if:[]},d=c.if,p=lo(a[a.length-1],2),f=(p[0],p[1]),h=0;h<a.length-1;h++){var g=h===a.length-2,v=lo(a[h],2),m=v[0],y=v[1];null==y&&(y=null),null==m&&(m=!0),d.push(m),d.push(y),g?d.push(f):(d.push({if:[]}),d=d[d.length-1].if)}return c}}},bv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=e.get("type");if("case_group"==i){var a=e.get("properties")||new $a;return[vv(e,t,r,n,o),Ov(t,a,r,null,o,"!case_value")]}r.errors.push("Unexpected child of type ".concat(i," inside switch"))},Ov=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u=ev(e,a),c=tv(e,n,a),d=Vl(c),p=t.get("value"),f=t.get("asyncListValues");if(null!=p){var h=[],g=[],v=r.usedFields,m=p.map((function(t,i){var d=s?s.get(i):null,p=l?l.get(i):null,v=Ph(t,d,e),m=Eh(e,a,n,d),y=rv(e,a,n,m,d,{forExport:!0}),b=Ev(r,e,v,d,p,y,u,n,c,o,f);return void 0!==b&&(h.push(d),g.push(p)),b})),y=m.filter((function(e){return void 0===e})).size>0;if(!(m.size<d||y))return d>1?m.toArray():1==d?m.first():null;r.usedFields=v}},Ev=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"==n)d=wv(e,t,r,u);else if("func"==n)d=Sv(e,t,r,u);else if("function"==typeof(null==i?void 0:i.jsonLogic)){var p=i.jsonLogic,f=[r,dv(dv({},a?lu()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),Ml(i,kl)];s&&(f.push(s),f.push(l)),d=p.call.apply(p,[t.ctx].concat(f))}else d=r;return d}},Sv=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=Wg(t,a),u=Kg(a,t),c=u[u.length-1];if(l)if(null!=l&&l.jsonLogic){var d={},p=[],f=[];for(var h in l.args){var g,v=l.args[h],m=ev(t,v),y=v.defaultValue,b=v.isOptional,O=null!=y&&y.func?"func":"value",E=s?s.get(h):void 0,S=E?E.get("value"):void 0,w=E?E.get("valueSrc"):void 0;"func"!==w&&null!==(g=S)&&void 0!==g&&g.toJS&&(S=S.toJS());var T=null,x=Eh(t,v,T,w),_=rv(t,v,T,x,w,{forExport:!0}),C=Ev(e,t,S,w,v.type,_,m,null,null,i);if(null!=S&&void 0===C)return void("func"!=w&&e.errors.push("Can't format value of arg ".concat(h," for func ").concat(a)));var R=void 0;if(void 0===C&&!b&&null!=y){var I=Eh(t,v,T,O),A=rv(t,v,T,I,O,{forExport:!0});if(void 0===(R=Ev(e,t,y,O,v.type,A,m,null,null,i)))return void("func"!=O&&e.errors.push("Can't format default value of arg ".concat(h," for func ").concat(a)))}var j=null!=C?C:R;if(void 0!==j){if(p.length){var P,L=pv(p);try{for(L.s();!(P=L.n()).done;)d[P.value]=void 0}catch(e){L.e(e)}finally{L.f()}p=[]}d[h]=j}else b||f.push(h),p.push(h)}if(!f.length){var k,N=Object.values(d);if("function"==typeof l.jsonLogic){var D=l.jsonLogic,F=[d];k=D.call.apply(D,[t.ctx].concat(F))}else{var M=l.jsonLogic||c;if(l.jsonLogicIsMethod){var V=N[0],U=N.slice(1);k=U.length?{method:[V,M,U]}:{method:[V,M]}}else k=no({},M,N)}return k}}else e.errors.push("Func ".concat(a," is not supported"));else e.errors.push("Func ".concat(a," is not defined in config"))},wv=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=t.settings,a=i.fieldSeparator,s=i.jsonLogic;if(r){Array.isArray(r)&&(r=r.join(a));var l=ev(t,r)||{},u=Sh(r,t,e,o);n=no({},l.jsonLogicVar||("!group"==l.type?s.groupVarKey:"var"),u),-1==e.usedFields.indexOf(r)&&e.usedFields.push(r)}return n},Tv=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,s=arguments.length>7&&void 0!==arguments[7]&&arguments[7],l=t.get("field"),u=tv(e,o,l)||{},c="function"==typeof u.jsonLogic?u.jsonLogic:function(e,t,r,n){var o=e,i=Vl(t);"string"==typeof t.jsonLogic&&(o=t.jsonLogic);var a=["<","<=",">",">="],s=["==","!="];return function(e,t,l,u,c){return 0==i&&s.includes(o)?no({},o,[r,null]):0==i?no({},o,r):1==i?no({},o,[r,n]):2==i&&a.includes(o)?no({},o,[n[0],r,n[1]]):no({},o,[r].concat(co(n)))}}(o,u,r,n),d=[r,o,n,Ml(u,Nl),i,a],p=c.call.apply(c,[e.ctx].concat(d));return s&&(p={"!":p}),p};function xv(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return _v(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?_v(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function _v(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Cv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Rv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Cv(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Cv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Iv=function(e){return"object"==Kn(e)&&null!==e&&!Array.isArray(e)},Av=function(e,t){return jv(e,t,!1)},jv=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=Rg(t,void 0,!1),i=Pv([],e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to MongoDb:",n.errors),i)},Pv=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0;if(t){var l=t.get("type");return"group"===l||"rule_group"===l?Lv(e,t,r,n,o,i,a,s):"rule"===l?kv(e,t,r,n,o,i,a,s):void 0}},Lv=function(e,t,r,n){var o,i,a,s,l,u,c,d,p=arguments.length>4&&void 0!==arguments[4]&&arguments[4],f=t.get("type"),h=t.get("properties")||new $a,g=!!h.get("not"),v=t.get("children1")||new fs,m=r.settings,y=m.canShortMongoQuery,b=m.fieldSeparator,O=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,E=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),S=O&&E,w="rule_group"===f,T=w?h.get("field"):null,x=w?h.get("operator"):null,_=x&&tv(r,x,T)||null,C=x?null!==(o=null===(i=_)||void 0===i?void 0:i.cardinality)&&void 0!==o?o:1:void 0,R=Sh(T,r,n,S),I=(ev(r,T)||{}).mode,A=T&&"array"===I&&C>=1,j=w&&(null==v?void 0:v.size)>0,P=(w&&null!=v&&v.size,!1),L=g,k=!1;j?(k=g,L=p):p&&(L=!L);var N=null===(a=_)||void 0===a?void 0:a.reversedOp,D=tv(r,N,T),F=!(null!==(s=_)&&void 0!==s&&s.mongoFormatOp||null===(l=D)||void 0===l||!l.mongoFormatOp),M=!(null===(u=D)||void 0===u||!u.mongoFormatOp),V=null===(c=Lh(t))||void 0===c?void 0:c.get("type");if(!!r.settings.reverseOperatorsForNot&&(!w&&L&&"rule"===V||k&&1===(null==v?void 0:v.size))&&(j?k=!k:L=!L,P=!0),L&&w&&M&&(r.settings.reverseOperatorsForNot||F)){L=!L;var U=[N,x];x=U[0],N=U[1];var B=[D,_];_=B[0],D=B[1]}var z=h.get("conjunction");z||(z=Nd(r));var $=r.conjunctions[z];if($){var W=$.reversedConj;L&&"or"===(null===(d=z)||void 0===d?void 0:d.toLowerCase())&&W&&!w&&r.settings.canShortMongoQuery&&r.settings.reverseOperatorsForNot&&(z=W,$=r.conjunctions[z],L=!L,P=!0);var H=$.mongoConj,q=v.map((function(o){return Pv([].concat(co(e),[t]),o,r,n,P,"array"!=I,"array"==I?function(e){return"$$el".concat(b).concat(e)}:void 0)})).filter((function(e){return void 0!==e}));if(A||q.size){var G;if(1==q.size)G=q.first();else if(q.size>1){var K=q.toList().toJS();y&&"$and"==H&&(G=K.reduce((function(e,t){if(e){for(var r in t){if("$"==r[0]){e=void 0;break}if(null==e[r])e[r]=t[r];else{var n=e[r],o=t[r];if(Iv(n)||(n={$eq:n}),Iv(o)||(o={$eq:o}),Object.keys(n)[0]==Object.keys(o)[0]){e=void 0;break}e[r]=Object.assign({},n,o)}}return e}}),{})),G||(G=no({},H,K))}if(T)if("array"==I){var Y={$size:{$ifNull:["$"+R,[]]}},X=G?{$size:{$ifNull:[{$filter:{input:"$"+R,as:"el",cond:G}},[]]}}:Y;G={$expr:G=Pv(e,t.set("type","rule"),r,n,k,!1,(function(e){return X}),Y)}}else G=no({},R,{$elemMatch:G});return L&&(G={$not:G}),G}}},kv=function(e,t,r,n){var o,i,a,s,l,u,c,d=arguments.length>4&&void 0!==arguments[4]&&arguments[4],p=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],f=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,h=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0,g=t.get("properties")||new $a,v=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,m=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),y=v&&m,b=g.get("operator"),O=g.get("operatorOptions"),E=g.get("field"),S=g.get("fieldSrc"),w=g.get("value"),T=g.get("valueSrc"),x=g.get("valueType"),_=g.get("asyncListValues");if(null!=E&&null!=b&&void 0!==w){var C=ev(r,E),R=tv(r,b,E),I=null===(o=R)||void 0===o?void 0:o.reversedOp,A=tv(r,I,E),j=Vl(R);if(null!==(i=R)&&void 0!==i&&i.mongoFormatOp||null!==(a=A)&&void 0!==a&&a.mongoFormatOp){var P,L=d,k=!(null!==(s=R)&&void 0!==s&&s.mongoFormatOp||null===(l=A)||void 0===l||!l.mongoFormatOp);if(null!==(u=A)&&void 0!==u&&u.mongoFormatOp&&(r.settings.reverseOperatorsForNot||k)&&L||k){var N=[I,b];b=N[0],I=N[1];var D=[A,R];R=D[0],A=D[1],L=!L}var F=!1;if("func"==S){var M=lo(Fv(n,r,E,y),2);P=M[0],F=M[1]}else P=Sh(E,r,n,y),f&&(F=!0,P=f(P));if(null!=P){var V,U=[],B=[];if(null!=w){var z=w.map((function(e,t){var o=T?T.get(t):null,i=x?x.get(t):null,a=Ph(e,o,r),s=Eh(r,E,b,o),l=rv(r,E,b,s,o,{forExport:!0}),u=lo(Nv(n,r,a,o,i,l,C,y,b,R,_),2),c=u[0],d=u[1];return void 0!==c&&(F=F||d,U.push(o),B.push(i)),c})),$=z.filter((function(e){return void 0===e})).size>0;if(z.size<j||$)return;V=j>1?z.toArray():1==j?z.first():null}var W=F&&p,H=null===(c=R)||void 0===c?void 0:c.mongoFormatOp,q=[P,b,void 0!==h&&null==V?h:V,F,U.length>1?U:U[0],B.length>1?B:B[0],Ml(R,Nl),O,C],G=H.call.apply(H,[r.ctx].concat(q));return W&&(G={$expr:G}),L&&(G={$not:G}),G}}else n.errors.push("Operator ".concat(b," is not supported"))}},Nv=function(e,t,r,n,o,i,a,s,l,u,c){if(void 0===r)return[void 0,!1];var d,p=!1;if("field"==n){var f=lo(Dv(e,t,r,s),2);d=f[0],p=f[1]}else if("func"==n){var h=lo(Fv(e,t,r,s),2);d=h[0],p=h[1]}else if("function"==typeof(null==i?void 0:i.mongoFormatValue)){var g=i.mongoFormatValue,v=[r,Rv(Rv({},a?lu()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),Ml(i,kl)];l&&(v.push(l),v.push(u)),d=g.call.apply(g,[t.ctx].concat(v))}else d=r;return[d,p]},Dv=function(e,t,r,n){var o,i=t.settings.fieldSeparator;if(r){var a=ev(t,r)||{},s=Kg(r,t),l=hh(r,t),u=l?l.join(i):null;o="$"+(0,t.settings.formatField)(Sh(r,t,e,n),s,u,a,t,!1)}return[o,!0]},Fv=function(e,t,r,n){var o,i,a,s=null===(o=r.get)||void 0===o?void 0:o.call(r,"func"),l=null===(i=r.get)||void 0===i?void 0:i.call(r,"args"),u=Wg(t,s);if(!u)return e.errors.push("Func ".concat(s," is not defined in config")),[void 0,!1];var c=Kg(s,t),d=c[c.length-1],p=u.mongoFunc||d,f=u.mongoArgsAsObject,h={},g=0,v=void 0,m=[],y=[];for(var b in u.args){var O;g++;var E=u.args[b],S=ev(t,E),w=E.defaultValue,T=E.isOptional,x=null!=w&&w.func?"func":"value",_=l?l.get(b):void 0,C=_?_.get("value"):void 0,R=_?_.get("valueSrc"):void 0;"func"!==R&&null!==(O=C)&&void 0!==O&&O.toJS&&(C=C.toJS());var I=_?_.get("asyncListValues"):void 0,A=null,j=Eh(t,E,A,R),P=rv(t,E,A,j,R,{forExport:!0}),L=lo(Nv(e,t,C,R,E.type,P,S,n,null,null,I),2),k=L[0];if(L[1],null!=C&&void 0===k)return"func"!=R&&e.errors.push("Can't format value of arg ".concat(b," for func ").concat(s)),[void 0,!1];var N=void 0;if(void 0===k&&!T&&null!=w){var D=Eh(t,E,A,x),F=rv(t,E,A,D,x,{forExport:!0}),M=lo(Nv(e,t,w,x,E.type,F,S,n,null,null,I),2);if(N=M[0],M[1],void 0===N)return"func"!=x&&e.errors.push("Can't format default value of arg ".concat(b," for func ").concat(s)),[void 0,!1]}var V=null!=k?k:N;if(void 0!==V){if(m.length){var U,B=xv(m);try{for(B.s();!(U=B.n()).done;)h[U.value]=void 0}catch(e){B.e(e)}finally{B.f()}m=[]}h[b]=V,v=V}else T||y.push(b),m.push(b)}if(y.length)return[void 0,!1];if("function"==typeof u.mongoFormatFunc){var z=u.mongoFormatFunc,$=[h];a=z.call.apply(z,[t.ctx].concat($))}else{if(null===u.mongoFormatFunc)return e.errors.push("Functon ".concat(p," is not supported")),[void 0,!1];a=no({},p,f?h:1==g&&void 0!==v?v:Object.values(h))}return[a,!0]};function Mv(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Vv(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Vv(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Vv(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Uv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Bv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Uv(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Uv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var zv=function(e,t){return $v(e,t,!1)},$v=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=Rg(t,void 0,!1),i=Wv(e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SQL:",n.errors),i)},Wv=function(e,t,r){if(e){var n=e.get("type");return e.get("children1"),"group"===n||"rule_group"===n?Hv(e,t,r):"rule"===n?qv(e,t,r):void 0}},Hv=function(e,t,r){var n=e.get("type"),o=e.get("properties")||new $a,i=e.get("children1")||new fs,a="rule_group"===n?o.get("field"):null;"array"==(ev(t,a)||{}).mode&&r.errors.push("Aggregation is not supported for ".concat(a));var s=o.get("not"),l=i.map((function(e){return Wv(e,t,r)})).filter((function(e){return void 0!==e}));if(l.size){var u=o.get("conjunction");return u||(u=Nd(t)),t.conjunctions[u].sqlFormatConj.call(t.ctx,l,u,s)}},qv=function(e,t,r){var n=e.get("properties")||new $a,o=n.get("field"),i=n.get("fieldSrc"),a=n.get("operator"),s=n.get("operatorOptions"),l=n.get("valueSrc"),u=n.get("valueType"),c=n.get("value"),d=n.get("asyncListValues");if(null!=o&&null!=a){var p=ev(t,o)||{},f=tv(t,a,o)||{},h=f.reversedOp,g=tv(t,h,o)||{},v=Vl(f),m=!1,y=f.sqlOp||f.sqlFormatOp,b=g.sqlOp||g.sqlFormatOp;if(y||b){if(!y&&b){m=!0;var O=[h,a];a=O[0],h=O[1];var E=[g,f];f=E[0],g=E[1]}var S,w=[],T=[];if(null!=c){var x=c.map((function(e,n){var i=l?l.get(n):null,s=u?u.get(n):null,c=Ph(e,i,t),h=Eh(t,o,a,i),g=rv(t,o,a,h,i,{forExport:!0}),v=Gv(r,t,c,i,s,g,p,a,f,d);return void 0!==v&&(w.push(i),T.push(s)),v}));if(x.filter((function(e){return void 0===e})).size>0||x.size<v)return;S=1==v?x.first():x}var _=f.sqlFormatOp||function(e,t){var r,n=t.sqlOp||e,o=Vl(t);return 0==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(n," ").concat(d," AND ").concat(p)}),r}(a,f);if(_){var C="func"==i?Yv(r,t,o):Kv(r,t,o);if(null!=C){var R,I=[C,a,S,w.length>1?w:w[0],T.length>1?T:T[0],Ml(f,Nl),s,p];if(R=_.call.apply(_,[t.ctx].concat(I)),m&&(R=t.settings.sqlFormatReverse.call(t.ctx,R)),void 0!==R)return R;r.errors.push("Operator ".concat(a," is not supported for value source ").concat(w.join(", ")))}}else r.errors.push("Operator ".concat(a," is not supported"))}else r.errors.push("Operator ".concat(a," is not supported"))}},Gv=function(e,t,r,n,o,i,a,s,l,u){if(void 0!==r){var c;if("field"==n)c=Kv(e,t,r);else if("func"==n)c=Yv(e,t,r);else if("function"==typeof(null==i?void 0:i.sqlFormatValue)){var d=i.sqlFormatValue,p=[r,Bv(Bv({},lu()(a,["fieldSettings","listValues"])),{},{asyncListValues:u}),Ml(i,kl)];if(s&&(p.push(s),p.push(l)),"field"==n){var f=ev(t,r)||{};p.push(f)}c=d.call.apply(d,[t.ctx].concat(p))}else c=Array.isArray(r)?r.map((function(e){return wc.escape(e)})):wc.escape(r);return c}},Kv=function(e,t,r){if(r){var n=t.settings.fieldSeparator,o=ev(t,r)||{},i=Kg(r,t),a=hh(r,t),s=a?a.join(n):null;return(0,t.settings.formatField)(Sh(r,t,e,null,{useTableName:!0}),i,s,o,t)}},Yv=function(e,t,r){var n,o,i=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),a=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),s=Wg(t,i);if(s){var l=Kg(i,t),u=l[l.length-1],c=s.sqlFunc||u,d={},p=[],f=[];for(var h in s.args){var g,v=s.args[h],m=ev(t,v),y=v.defaultValue,b=v.isOptional,O=null!=y&&y.func?"func":"value",E=a?a.get(h):void 0,S=E?E.get("value"):void 0,w=E?E.get("valueSrc"):void 0;"func"!==w&&null!==(g=S)&&void 0!==g&&g.toJS&&(S=S.toJS());var T=E?E.get("asyncListValues"):void 0,x=Gv(e,t,S,w,v.type,m,v,null,null,T);if(null!=S&&void 0===x)return void("func"!=w&&e.errors.push("Can't format value of arg ".concat(h," for func ").concat(i)));var _=void 0;if(void 0===x&&!b&&null!=y&&void 0===(_=Gv(e,t,y,O,v.type,m,v,null,null,T)))return void("func"!=O&&e.errors.push("Can't format default value of arg ".concat(h," for func ").concat(i)));var C=null!=x?x:_;if(void 0!==C){if(p.length){var R,I=Mv(h);try{for(I.s();!(R=I.n()).done;)d[R.value]=void 0}catch(e){I.e(e)}finally{I.f()}p=[]}d[h]=C}else b||f.push(h),p.push(h)}if(!f.length){var A;if("function"==typeof s.sqlFormatFunc){var j=s.sqlFormatFunc,P=[d];A=j.call.apply(j,[t.ctx].concat(P))}else{var L=Object.entries(d).map((function(e){var t=lo(e,2);return t[0],t[1]})).join(", ");A="".concat(c,"(").concat(L,")")}return A}}else e.errors.push("Func ".concat(i," is not defined in config"))};function Xv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Qv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Xv(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Xv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Jv(e,t,r,n,o,i){if(e&&r&&null!=t){var a=r,s=n.operators[a];if(s){var l=s.elasticSearchQueryType,u=!1;!l&&s.reversedOp&&(u=!0,a=s.reversedOp,l=(s=n.operators[a]).elasticSearchQueryType);var c=Eh(n,e,a,o),d=n.widgets[c];if(d){var p,f,h=d.elasticSearchFormatValue;if(p="function"==typeof l?l(c):l)return f="function"==typeof h?h(p,t,a,e,n):function(e,t,r,n,o,i){var a=function(e,t){return e}(n);switch(e){case"filter":return{script:o.operators[r].elasticSearchScript(n,t)};case"exists":return{field:n};case"match":return no({},a,t[0]);case"term":return no({},n,i===Zv?{value:t[0]}:t[0]);case"geo_bounding_box":return no({},n,function(e){if(null==e)return null;var t=e.split(",").map(Number);return{top_left:{lat:t[0],lon:t[1]},bottom_right:{lat:t[2],lon:t[3]}}}(t[0]));case"range":return no({},n,function(e,t){if(e.length>1)return{gte:"".concat(e[0]),lte:"".concat(e[1])};var r=e[0];switch(t){case"on_date":case"not_on_date":case"equal":case"select_equals":case"not_equal":return{gte:"".concat(r,"||/d"),lte:"".concat(r,"||+1d")};case"less_or_equal":return{lte:"".concat(r)};case"greater_or_equal":return{gte:"".concat(r)};case"less":return{lt:"".concat(r)};case"greater":return{gt:"".concat(r)};default:return}}(t,r));case"wildcard":return no({},n,function(e){return{value:"*"+e+"*"}}(t[0]));case"regexp":return no({},n,function(e){return{value:e}}(t[0]));default:return}}(p,t,a,e,n,i),u?{bool:{must_not:no({},p,Qv({},f))}}:no({},p,Qv({},f))}}}}var Zv="ES_7_SYNTAX",em="ES_6_SYNTAX";function tm(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:em,n=Rg(t,void 0,!1);if(e){var o=e.get("type"),i=e.get("properties")||new Map;if("rule"===o&&i.get("field")){var a,s,l,u=i.get("operator"),c=i.get("field"),d=i.get("fieldSrc"),p=null===(a=i.get("value"))||void 0===a?void 0:a.toJS(),f=(null===(s=i.get("valueType"))||void 0===s||s.get(0),null===(l=i.get("valueSrc"))||void 0===l?void 0:l.get(0));if("func"===f||"func"==d)return;return p&&Array.isArray(p[0])?p[0].map((function(e){return Jv(c,[e],u,n,f,r)})):Jv(c,p,u,n,f,r)}if("group"===o||"rule_group"===o){var h=i.get("not"),g=i.get("conjunction");return g||(g=Nd(n)),function(e,t,r,n,o,i){if(e&&e.size){var a=e.valueSeq().toArray(),s=function(e,t){switch(e){case"AND":return t?"must_not":"must";case"OR":return t?"should_not":"should";case"NOT":return t?"must":"must_not";default:return}}(t,r),l=a.map((function(e){return n(e,o,i)})).filter((function(e){return void 0!==e}));if(l.length)return{bool:no({},s,l.flat(1/0))}}}(e.get("children1"),g,h,tm,n,r)}}}function rm(e,t){if(null==e)return{};var r={};for(var n in e)if({}.hasOwnProperty.call(e,n)){if(t.includes(n))continue;r[n]=e[n]}return r}function nm(e,t){if(null==e)return{};var r,n,o=rm(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.includes(r)||{}.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}function om(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}var im=["title","value","disabled","groupTitle","grouplabel","renderTitle","children","label","isCustom","isHidden"];function am(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function sm(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function lm(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?sm(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):sm(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var um=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1e3;return function(){var n=function(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){om(i,n,o,a,s,"next",e)}function s(e){om(i,n,o,a,s,"throw",e)}a(void 0)}))}}(au().mark((function n(o,i,a){var s,l,u,c,d,p;return au().wrap((function(n){for(;;)switch(n.prev=n.next){case 0:if(s=null!=(null==a?void 0:a.pageSize)?a.pageSize:t,l=bu(e).filter((function(e){var t=e.title,r=e.value;return null==o||-1!=t.toUpperCase().indexOf(o.toUpperCase())||-1!="".concat(r).toUpperCase().indexOf(o.toUpperCase())})),s&&Math.ceil(l.length/s),u=i||0,s&&Math.ceil(u/s),c=s?l.slice(u,u+s):l,d=s?u+c.length:null,p=!!s&&d<l.length,!r){n.next=11;break}return n.next=11,Jl(r);case 11:return n.abrupt("return",{values:c,hasMore:p});case 12:case"end":return n.stop()}}),n)})));return function(e,t,r){return n.apply(this,arguments)}}()},cm=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(!t)return e;var o=e||[],i=t.filter((function(e){return null==o.find((function(t){return""+t.value==""+e.value}))})).map((function(e){return n?lm(lm({},e),{},{isHidden:!0}):e}));return r?[].concat(co(i),co(o)):[].concat(co(o),co(i))},dm=function(e,t,r){var n,o=null==e||""==e?void 0:null!==(n=null==e?void 0:e.value)&&void 0!==n?n:e,i=xu(o,t),a=r&&!i?yu(o):void 0,s=i||a;return[o,s?[s]:void 0]},pm=function(e,t,r){var n=e.map((function(e,n){var o,i=null==e||""==e?void 0:null!==(o=null==e?void 0:e.value)&&void 0!==o?o:e,a=xu(i,t),s=r&&!a?yu(i):void 0;return a||s})).filter((function(e){return null!=e})),o=n.map((function(e){var t;return null!==(t=null==e?void 0:e.value)&&void 0!==t?t:e}));return o.length||(o=void 0),[o,n]},fm=function(e){if(null==e)return null;var t=e.title,r=e.value,n=e.disabled,o=e.groupTitle,i=e.grouplabel,a=e.renderTitle,s=e.children,l=e.label,u=e.isCustom,c=e.isHidden,d=nm(e,im),p={value:r,title:t||l||s};return n&&(p.disabled=n),u&&(p.isCustom=u),c&&(p.isHidden=c),(o||i)&&(p.groupTitle=o||i),a&&(p.renderTitle=a),lm(lm({},p),d)},hm=function(e){var t,r=[],n=[],o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return am(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?am(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{var i=function(){var e=t.value,o=function(e,t){if(e.findLastIndex)return e.findLastIndex(t);var r=co(e).reverse().findIndex(t);return-1==r?-1:e.length-1-r}(r,(function(t){var r,n;return(null!==(r=t.groupTitle)&&void 0!==r?r:"")==(null!==(n=e.groupTitle)&&void 0!==n?n:"")}));null==e.groupTitle||n.includes(e.groupTitle)||(n.push(e.groupTitle),1===n.length&&(r=r.map((function(e){return lm(lm({},e),{},{groupTitle:""})})))),null==e.groupTitle&&n.length&&(e=lm(lm({},e),{},{groupTitle:""})),-1!=o?r.splice(o+1,0,e):r.push(e)};for(o.s();!(t=o.n()).done;)i()}catch(e){o.e(e)}finally{o.f()}return r},gm={label:"Now",returnType:"datetime",jsonLogic:"now",jsonLogicCustomOps:{now:{}},spelFunc:"T(java.time.LocalDateTime).now()",sqlFormatFunc:function(){return"NOW()"},mongoFormatFunc:function(){return new Date},formatFunc:function(){return"NOW"}},vm={label:"Relative",returnType:"datetime",renderBrackets:["",""],renderSeps:["","",""],spelFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim,i=r+(o.charAt(0).toUpperCase()+o.slice(1)+"s");return"".concat(t,".").concat(i,"(").concat(n,")")},spelImport:function(e){var t,r,n,o,i=null===(t=e.methodName)||void 0===t?void 0:t.match(/^(minus|plus)(\w+)s$/);if(i&&(o=i[2].toLowerCase(),r=i[1],["minus","plus"].includes(r)&&["day","week","month","year"].includes(o)))return r={type:"string",val:r},o={type:"string",val:o},n=e.args[0],{date:e.obj,op:r,val:n,dim:o}},jsonLogic:function(e){var t=e.date,r=e.op;return{date_add:[t,e.val*("minus"==r?-1:1),e.dim]}},jsonLogicImport:function(e){var t=e.date_add[0],r=Math.abs(e.date_add[1]);return[t,e.date_add[1]>=0?"plus":"minus",r,e.date_add[2]]},jsonLogicCustomOps:{date_add:{}},sqlFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return"DATE_ADD(".concat(t,", INTERVAL ").concat(parseInt(n)*("minus"==r?-1:1)," ").concat(o.replace(/^'|'$/g,""),")")},mongoFormatFunc:null,formatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return n?"".concat(t," ").concat("minus"==r?"-":"+"," ").concat(n," ").concat(o):t},args:{date:{label:"Date",type:"datetime",defaultValue:{func:"NOW",args:[]},valueSources:["func","field","value"],spelEscapeForFormat:!0},op:{label:"Op",type:"select",defaultValue:"plus",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{plus:"+",minus:"-"}},spelEscapeForFormat:!1},val:{label:"Value",type:"number",fieldSettings:{min:0},defaultValue:0,valueSources:["value"],spelEscapeForFormat:!1},dim:{label:"Dimension",type:"select",defaultValue:"day",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{day:"day",week:"week",month:"month",year:"year"}},spelEscapeForFormat:!1}}},mm={label:"Lowercase",mongoFunc:"$toLower",jsonLogic:"toLowerCase",spelFunc:"${str}.toLowerCase()",jsonLogicCustomOps:{toLowerCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},ym={label:"Uppercase",mongoFunc:"$toUpper",jsonLogic:"toUpperCase",spelFunc:"${str}.toUpperCase()",jsonLogicCustomOps:{toUpperCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},bm={label:"Linear regression",returnType:"number",formatFunc:function(e,t){var r=e.coef,n=e.bias,o=e.val;return"(".concat(r," * ").concat(o," + ").concat(n,")")},sqlFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelImport:function(e){var t,r;if("op-plus"===e.type){var n=lo(e.children,2);if(r=n[0],t=n[1],"op-multiply"===r.type){var o=lo(r.children,2);return{coef:o[0],val:o[1],bias:t}}}},mongoFormatFunc:function(e){var t=e.coef,r=e.bias;return{$sum:[{$multiply:[t,e.val]},r]}},jsonLogic:function(e){var t=e.coef,r=e.bias;return{"+":[{"*":[t,e.val]},r]}},jsonLogicImport:function(e){return[e["+"][0]["*"][0],e["+"][0]["*"][1],e["+"][1]]},renderBrackets:["",""],renderSeps:[" * "," + "],args:{coef:{label:"Coef",type:"number",defaultValue:1,valueSources:["value"]},val:{label:"Value",type:"number",valueSources:["value","field"]},bias:{label:"Bias",type:"number",defaultValue:0,valueSources:["value"]}}},Om={utils:{SqlString:wc,moment:Gu(),mongoFormatOp1:function(e,t,r,n,o,i,a,s,l,u,c,d){var p="string"!=typeof n||n.startsWith("$")?n:"$"+n,f=t(i,d);if(void 0!==f)return r?a||e&&"$eq"!=e?a?{$not:no({},e,[p,f])}:no({},n,{$not:no({},e,f)}):no({},n,{$ne:f}):a||e&&"$eq"!=e?a?no({},e,[p,f]):no({},n,no({},e,f)):no({},n,f)},mongoFormatOp2:function(e,t,r,n,o,i,a,s,l,u,c){var d="string"!=typeof r||r.startsWith("$")?r:"$"+r;return t?i?{$not:{$and:[no({},e[0],[d,o[0]]),no({},e[1],[d,o[1]])]}}:no({},r,{$not:no(no({},e[0],o[0]),e[1],o[1])}):i?{$and:[no({},e[0],[d,o[0]]),no({},e[1],[d,o[1]])]}:no({},r,no(no({},e[0],o[0]),e[1],o[1]))},mongoEmptyValue:xc,escapeRegExp:ql,sqlEmptyValue:Tc,stringifyForDisplay:Ac,getTitleInListValues:Eu,spelEscape:Cc,spelFixList:_c,wrapWithBrackets:jc}};const Em=Om;function Sm(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function wm(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Tm(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?wm(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):wm(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var xm={equal:{label:"==",labelForFormat:"==",sqlOp:"=",spelOp:"==",spelOps:["==","eq"],reversedOp:"not_equal",formatOp:function(e,t,r,n,o,i,a,s,l){var u=s?"=":i.label;return"boolean"==o&&s?"No"==r?"NOT ".concat(e):"".concat(e):"".concat(e," ").concat(u," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},jsonLogic:"==",elasticSearchQueryType:"term"},not_equal:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",spelOp:"!=",spelOps:["!=","ne"],reversedOp:"equal",formatOp:function(e,t,r,n,o,i,a,s,l){return"boolean"==o&&s?"No"==r?"".concat(e):"NOT ".concat(e):"".concat(e," ").concat(i.label," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},jsonLogic:"!="},less:{label:"<",labelForFormat:"<",sqlOp:"<",spelOp:"<",spelOps:["<","lt"],reversedOp:"greater_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lt",function(e){return e},!1].concat(r))},jsonLogic:"<",elasticSearchQueryType:"range"},less_or_equal:{label:"<=",labelForFormat:"<=",sqlOp:"<=",spelOp:"<=",spelOps:["<=","le"],reversedOp:"greater",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lte",function(e){return e},!1].concat(r))},jsonLogic:"<=",elasticSearchQueryType:"range"},greater:{label:">",labelForFormat:">",sqlOp:">",spelOp:">",spelOps:[">","gt"],reversedOp:"less_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return e},!1].concat(r))},jsonLogic:">",elasticSearchQueryType:"range"},greater_or_equal:{label:">=",labelForFormat:">=",sqlOp:">=",spelOp:">=",spelOps:[">=","ge"],reversedOp:"less",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gte",function(e){return e},!1].concat(r))},jsonLogic:">=",elasticSearchQueryType:"range"},like:{label:"Contains",labelForFormat:"Contains",reversedOp:"not_like",sqlOp:"LIKE",spelOp:"${0}.contains(${1})",valueTypes:["text"],mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:function(e,t,r){return{in:[r,e]}},jsonLogic2:"#in",valueSources:["value"],elasticSearchQueryType:"regexp"},not_like:{isNotOp:!0,label:"Not contains",reversedOp:"like",labelForFormat:"Not Contains",sqlOp:"NOT LIKE",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!0].concat(n))},jsonLogic:function(e,t,r){return{"!":{in:[r,e]}}},jsonLogic2:"#!in",_jsonLogicIsExclamationOp:!0,valueSources:["value"]},starts_with:{label:"Starts with",labelForFormat:"Starts with",sqlOp:"LIKE",spelOp:"${0}.startsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?"^"+t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},ends_with:{label:"Ends with",labelForFormat:"Ends with",sqlOp:"LIKE",spelOp:"${0}.endsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e)+"$":void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},between:{label:"Between",labelForFormat:"BETWEEN",sqlOp:"BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," BETWEEN ").concat(l," AND ").concat(u):"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!1].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"not_between",jsonLogic:"<=",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null},elasticSearchQueryType:function(e){return"time"===e?"filter":"range"}},not_between:{isNotOp:!0,label:"Not between",labelForFormat:"NOT BETWEEN",sqlOp:"NOT BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," NOT BETWEEN ").concat(l," AND ").concat(u):"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!0].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"between",jsonLogic:function(e,t,r){return{"!":{"<=":[Array.isArray(r)?r[0]:r,e,Array.isArray(r)?r[1]:r]}}},jsonLogic2:"!<=",_jsonLogicIsExclamationOp:!0,validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null}},is_empty:{label:"Is empty",labelForFormat:"IS EMPTY",cardinality:0,reversedOp:"is_not_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS EMPTY"):"!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") = ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," <= ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!"},is_not_empty:{isNotOp:!0,label:"Is not empty",labelForFormat:"IS NOT EMPTY",cardinality:0,reversedOp:"is_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT EMPTY"):"!!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") <> ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," > ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!!",elasticSearchQueryType:"exists"},is_null:{label:"Is null",labelForFormat:"IS NULL",sqlOp:"IS NULL",cardinality:0,reversedOp:"is_not_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NULL"):"!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," == null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return null},!1].concat(r))},jsonLogic:"=="},is_not_null:{label:"Is not null",labelForFormat:"IS NOT NULL",sqlOp:"IS NOT NULL",cardinality:0,reversedOp:"is_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT NULL"):"!!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return null},!1].concat(r))},jsonLogic:"!=",elasticSearchQueryType:"exists"},select_equals:{label:"==",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"".concat(e," ").concat(l," ").concat(r)},spelOp:"==",spelOps:["==","eq"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"select_not_equals",jsonLogic:"==",elasticSearchQueryType:"term"},select_not_equals:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != ").concat(r)},spelOp:"!=",spelOps:["!=","ne"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"select_equals",jsonLogic:"!="},select_any_in:{label:"Any in",labelForFormat:"IN",sqlOp:"IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):"".concat(e," IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):void 0},valueTypes:["multiselect"],spelOp:"${1}.contains(${0})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))},reversedOp:"select_not_any_in",jsonLogic:"in",elasticSearchQueryType:"term"},select_not_any_in:{isNotOp:!0,label:"Not in",labelForFormat:"NOT IN",sqlOp:"NOT IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):"".concat(e," NOT IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e){return e},!1].concat(r))},reversedOp:"select_any_in",jsonLogic:function(e,t,r){return{"!":{in:[e,r]}}},jsonLogic2:"!in",_jsonLogicIsExclamationOp:!0},multiselect_contains:{label:"Contains",labelForFormat:"CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," CONTAINS [").concat(r.join(", "),"]"):"".concat(e," CONTAINS ").concat(r)},reversedOp:"multiselect_not_contains",jsonLogic2:"some-in",jsonLogic:function(e,t,r){return{some:[e,{in:[{var:""},r]}]}},spelOp:"T(CollectionUtils).containsAny(${0}, ${1})",elasticSearchQueryType:"term",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))}},multiselect_not_contains:{isNotOp:!0,label:"Not contains",labelForFormat:"NOT CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT CONTAINS [").concat(r.join(", "),"]"):"".concat(e," NOT CONTAINS ").concat(r)},reversedOp:"multiselect_contains",jsonLogic2:"!some-in",jsonLogic:function(e,t,r){return{"!":{some:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},multiselect_equals:{label:"Equals",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"value"==n?"".concat(e," ").concat(l," [").concat(r.join(", "),"]"):"".concat(e," ").concat(l," ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," = '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},spelOp:"${0}.equals(${1})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"multiselect_not_equals",jsonLogic2:"all-in",jsonLogic:function(e,t,r){return{all:[e,{in:[{var:""},r]}]}},elasticSearchQueryType:"term"},multiselect_not_equals:{isNotOp:!0,label:"Not equals",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," != [").concat(r.join(", "),"]"):"".concat(e," != ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," != '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"multiselect_equals",jsonLogic2:"!all-in",jsonLogic:function(e,t,r){return{"!":{all:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},proximity:{label:"Proximity search",cardinality:2,valueLabels:[{label:"Word 1",placeholder:"Enter first word"},{label:"Word 2",placeholder:"Enter second word"}],textSeparators:[],formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=null==a?void 0:a.get("proximity");return"".concat(e," ").concat(l," NEAR/").concat(c," ").concat(u)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=this.utils.SqlString.trim(l),d=this.utils.SqlString.trim(u),p=null==a?void 0:a.get("proximity");return"CONTAINS(".concat(e,", 'NEAR((").concat(c,", ").concat(d,"), ").concat(p,")')")},mongoFormatOp:void 0,jsonLogic:void 0,options:{optionLabel:"Near",optionTextBefore:"Near",optionPlaceholder:"Select words between",minProximity:2,maxProximity:10,defaults:{proximity:2}}},some:{label:"Some",labelForFormat:"SOME",cardinality:0,jsonLogic:"some",spelFormatOp:function(e){return"".concat(e," > 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return 0},!1].concat(r))}},all:{label:"All",labelForFormat:"ALL",cardinality:0,jsonLogic:"all",spelFormatOp:function(e,t,r){return"".concat(e," == ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))}},none:{label:"None",labelForFormat:"NONE",cardinality:0,jsonLogic:"none",spelFormatOp:function(e){return"".concat(e," == 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return 0},!1].concat(r))}}},_m={text:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"String",valuePlaceholder:"Enter string",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},textarea:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"Text",valuePlaceholder:"Enter text",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e},fullWidth:!0},number:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r){var n=r.step&&!Number.isInteger(r.step);return this.utils.spelEscape(e,n)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},slider:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number or move slider",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},select:{type:"select",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=this.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e);return n?this.utils.stringifyForDisplay(o):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},multiselect:{type:"multiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=e.map((function(e){return o.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e)}));return n?i.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e,t,r,n,o){var i=o&&o.spelOp&&o.spelOp.startsWith("${1}"),a=this.utils.spelEscape(e);return i&&(a=this.utils.spelFixList(a)),a},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},date:{type:"date",jsType:"string",valueSrc:"value",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD",valueLabel:"Date",valuePlaceholder:"Enter date",valueLabels:[{label:"Date from",placeholder:"Enter date from"},{label:"Date to",placeholder:"Enter date to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("YYYY-MM-DD"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD");return"T(java.time.LocalDate).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDate"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o,i,a;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&null!==(n=r.fmt)&&void 0!==n&&null!==(n=n.value)&&void 0!==n&&null!==(o=n.includes)&&void 0!==o&&o.call(n," ")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&null!==(a=i.toLowerCase)&&void 0!==a&&a.call(i).includes("hh:mm"))return[void 0,"Invalid date format ".concat(JSON.stringify(r.fmt))];var s=this.utils.moment(e.value,this.utils.moment.ISO_8601);return s.isValid()?[s.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},time:{type:"time",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",valueFormat:"HH:mm:ss",use12Hours:!1,valueLabel:"Time",valuePlaceholder:"Enter time",valueLabels:[{label:"Time from",placeholder:"Enter time from"},{label:"Time to",placeholder:"Enter time to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("HH:mm:ss"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("HH:mm:ss");return"T(java.time.LocalTime).parse('".concat(i,"')")},spelImportFuncs:["T(java.time.LocalTime).parse(${v})"],spelImportValue:function(e,t,r){var n,o,i;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&r.fmt&&(null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.toLowerCase)||void 0===o||!o.call(n).includes("hh:mm")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&i.includes(" ")))return[void 0,"Invalid time format ".concat(JSON.stringify(r.fmt))];var a=this.utils.moment(e.value,"HH:mm:ss");return a.isValid()?[a.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?60*r.get("hour")*60+60*r.get("minute")+r.get("second"):void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},elasticSearchFormatValue:function(e,t,r,n){return{script:{script:{source:"doc[".concat(n,"][0].getHour() >== params.min && doc[").concat(n,"][0].getHour() <== params.max"),params:{min:t[0],max:t[1]}}}}}},datetime:{type:"datetime",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD HH:mm:ss",use12Hours:!1,valueLabel:"Datetime",valuePlaceholder:"Enter datetime",valueLabels:[{label:"Datetime from",placeholder:"Enter datetime from"},{label:"Datetime to",placeholder:"Enter datetime to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat+" "+r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.toDate())},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD HH:mm:ss");return"T(java.time.LocalDateTime).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd HH:mm:ss","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDateTime"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o;if(!t)return[void 0,"No widget def to get value format"];if(null==r||null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.includes)||void 0===o||!o.call(n," "))return[void 0,"Invalid datetime format ".concat(JSON.stringify(r.fmt))];var i=this.utils.moment(e.value,this.utils.moment.ISO_8601);return i.isValid()?[i.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},boolean:{type:"boolean",jsType:"boolean",valueSrc:"value",labelYes:"Yes",labelNo:"No",formatValue:function(e,t,r,n){return n?e?"Yes":"No":JSON.stringify(!!e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},defaultValue:!1,toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},field:{valueSrc:"field",formatValue:function(e,t,r,n,o,i,a){return n&&a.label||e},sqlFormatValue:function(e,t,r,n,o,i){return e},spelFormatValue:function(e,t,r,n,o){return e},valueLabel:"Field to compare",valuePlaceholder:"Select field to compare"},func:{valueSrc:"func",valueLabel:"Function",valuePlaceholder:"Select function"},case_value:{valueSrc:"value",type:"case_value",spelFormatValue:function(e){return this.utils.spelEscape(""===e?null:e)},spelImportValue:function(e){return[e.value,[]]},jsonLogic:function(e){return""===e?null:e}}},Cm=Tm(Tm({},hg),{},{convertableWidgets:{number:["slider","rangeslider"],slider:["number","rangeslider"],rangeslider:["number","slider"],text:["textarea"],textarea:["text"]},formatSpelField:function(e,t,r,n,o,i){var a=this,s=n.map((function(e,t){var r=e.key,n=e.parent,o=e.fieldSeparator;return 0==t?"[map]"==n?"#this[".concat(a.utils.spelEscape(r),"]"):r:"map"==n||"[map]"==n?"[".concat(a.utils.spelEscape(r),"]"):"".concat(o).concat(r)})).join("");return o.fieldName&&(s=e),o.isSpelVariable&&(s="#"+s),s},sqlFormatReverse:function(e){if(null!=e)return"NOT"+this.utils.wrapWithBrackets(e)},spelFormatReverse:function(e){if(null!=e)return"!"+this.utils.wrapWithBrackets(e)},formatReverse:function(e,t,r,n,o,i){if(null!=e)return i?"NOT "+this.utils.wrapWithBrackets(e):"!"+this.utils.wrapWithBrackets(e)},formatAggr:function(e,t,r,n,o,i,a,s,l,u){var c=a.labelForFormat,d=a.cardinality;if(0==d){var p=e?" HAVE ".concat(e):"";return"".concat(c," OF ").concat(t).concat(p)}if(null==d||1==d){var f=e?" WHERE ".concat(e):"";return"COUNT OF ".concat(t).concat(f," ").concat(c," ").concat(n)}if(2==d){var h=e?" WHERE ".concat(e):"",g=n.first(),v=n.get(1);return"COUNT OF ".concat(t).concat(h," ").concat(c," ").concat(g," AND ").concat(v)}},jsonLogic:{groupVarKey:"var",altVarKey:"var",lockedOp:"locked"},canCompareFieldWithField:function(e,t,r,n){return!0},valueSourcesInfo:{value:{label:"Value"},field:{label:"Field",widget:"field"},func:{label:"Function",widget:"func"}}}),Rm=function(e,t){var r,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o={rangeslider:jm,treeselect:Pm,treemultiselect:Lm,rangeable__date:Am("date","date")},i=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Sm(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Sm(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(i.s();!(r=i.n()).done;){var a=r.value,s=o[a];if(!s)throw new Error("Can't ".concat(n?"add":"remove"," mixin ").concat(a));e=s(e,n)}}catch(e){i.e(e)}finally{i.f()}return e},Im=function(e,t){return Rm(e,t,!0)},Am=function(e,t){return function(r){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=r.types;return o=Tm(Tm({},o),{},no({},e,Tm(Tm({},o[e]),{},{widgets:Tm({},o[e].widgets)}))),n?o[e].widgets[t]=Tm({opProps:{between:{isSpecialRange:!0,textSeparators:[null,null]},not_between:{isSpecialRange:!0,textSeparators:[null,null]}}},o[e].widgets[t]):delete o[e].widgets[t],Tm(Tm({},r),{},{types:o})}},jm=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Tm({},r),t?r.rangeslider=Tm({type:"number",jsType:"number",valueSrc:"value",valueLabel:"Range",valuePlaceholder:"Select range",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},singleWidget:"slider",toJS:function(e,t){return e}},r.rangeslider):delete r.rangeslider,n=Tm(Tm({},n),{},{number:Tm(Tm({},n.number),{},{widgets:Tm({},n.number.widgets)})}),t?n.number.widgets.rangeslider=Tm({opProps:{between:{isSpecialRange:!0},not_between:{isSpecialRange:!0}},operators:["between","not_between","is_null","is_not_null"]},n.number.widgets.rangeslider):delete n.number.widgets.rangeslider,Tm(Tm({},e),{},{widgets:r,types:n})},Pm=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Tm({},r),t?r.treeselect=Tm({type:"treeselect",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,i=this.utils.getTitleInListValues(o,e);return n?this.utils.stringifyForDisplay(i):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treeselect):delete r.treeselect,n=Tm({},n),t?n.treeselect=Tm({mainWidget:"treeselect",defaultOperator:"select_equals",widgets:{treeselect:{operators:["select_equals","select_not_equals"]},treemultiselect:{operators:["select_any_in","select_not_any_in"]}}},n.treeselect):delete n.treeselect,Tm(Tm({},e),{},{widgets:r,types:n})},Lm=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Tm({},r),t?r.treemultiselect=Tm({type:"treemultiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,a=e.map((function(e){return o.utils.getTitleInListValues(i,e)}));return n?a.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treemultiselect):delete r.treemultiselect,n=Tm({},n),t?n.treemultiselect=Tm({defaultOperator:"multiselect_equals",widgets:{treemultiselect:{operators:["multiselect_equals","multiselect_not_equals"]}}},n.treemultiselect):delete n.treemultiselect,Tm(Tm({},e),{},{widgets:r,types:n})},km={addMixins:Im,removeMixins:function(e,t){return Rm(e,t,!1)}},Nm={conjunctions:{AND:{label:"And",mongoConj:"$and",jsonLogicConj:"and",sqlConj:"AND",spelConj:"and",spelConjs:["and","&&"],reversedConj:"OR",formatConj:function(e,t,r,n){var o=e.size>1?e.join(" "+(n?"AND":"&&")+" "):e.first();return(e.size>1||r)&&(o=this.utils.wrapWithBrackets(o)),r&&(o="NOT "+o),o},sqlFormatConj:function(e,t,r){var n=e.size>1?e.join(" AND "):e.first();return(e.size>1||r)&&(n=this.utils.wrapWithBrackets(n)),r&&(n="NOT "+n),n},spelFormatConj:function(e,t,r,n){r&&(n=!1);var o=e.size>1?e.join(" && "):e.first();return(e.size>1||r)&&!n&&(o=this.utils.wrapWithBrackets(o)),r&&(o="!"+o),o}},OR:{label:"Or",mongoConj:"$or",jsonLogicConj:"or",sqlConj:"OR",spelConj:"or",spelConjs:["or","||"],reversedConj:"AND",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"OR":"||")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" OR ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" || ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}}},operators:xm,widgets:_m,types:{text:{defaultOperator:"equal",mainWidget:"text",widgets:{text:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","proximity","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},textarea:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},field:{operators:["equal","not_equal","proximity"]}}},number:{defaultOperator:"equal",mainWidget:"number",widgets:{number:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]},slider:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","is_null","is_not_null"]}}},date:{defaultOperator:"equal",widgets:{date:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},time:{defaultOperator:"equal",widgets:{time:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},datetime:{defaultOperator:"equal",widgets:{datetime:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},select:{mainWidget:"select",defaultOperator:"select_equals",widgets:{select:{operators:["select_equals","select_not_equals","is_null","is_not_null"]},multiselect:{operators:["select_any_in","select_not_any_in","is_null","is_not_null"]}}},multiselect:{defaultOperator:"multiselect_equals",widgets:{multiselect:{operators:["multiselect_contains","multiselect_not_contains","multiselect_equals","multiselect_not_equals","is_null","is_not_null"]}}},boolean:{defaultOperator:"equal",widgets:{boolean:{operators:["equal","not_equal","is_null","is_not_null"],widgetProps:{}},field:{operators:["equal","not_equal"]}}},"!group":{defaultOperator:"some",mainWidget:"number",widgets:{number:{widgetProps:{min:0},operators:["some","all","none","equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between"],opProps:{equal:{label:"Count =="},not_equal:{label:"Count !="},less:{label:"Count <"},less_or_equal:{label:"Count <="},greater:{label:"Count >"},greater_or_equal:{label:"Count >="},between:{label:"Count between"},not_between:{label:"Count not between"}}}}},case_value:{mainWidget:"case_value",widgets:{case_value:{widgetProps:{}}}}},settings:Cm,ctx:Em};const Dm=Nm=Im(Nm,["rangeslider","treeselect","treemultiselect"]);var Fm="ADD_GROUP",Mm="ADD_CASE_GROUP",Vm="REMOVE_GROUP",Um="SET_CONJUNCTION",Bm="SET_NOT",zm="ADD_RULE",$m="REMOVE_RULE",Wm="SET_FIELD",Hm="SET_FIELD_SRC",qm="SET_OPERATOR",Gm="SET_VALUE",Km="SET_VALUE_SRC",Ym="SET_FUNC_VALUE",Xm="SET_OPERATOR_OPTION",Qm="SET_LOCK",Jm="SET_TREE",Zm="MOVE_ITEM",ey="after",ty="before",ry="append",ny="prepend",oy="SET_DRAG_PROGRESS",iy="SET_DRAG_START",ay="SET_DRAG_END",sy=v(1612),ly=v.n(sy);function uy(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function cy(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?uy(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):uy(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function dy(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return py(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?py(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function py(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var fy=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(_u(t)))return e;var u=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,c=i.settings.shouldCreateEmptyGroup,d=t.push(u),p=!c,f=!(null==l||!l.isDefaultCase),h=e;return(e=hy(e,t,r,u,Dd(i).merge(Cl(o)||{}),i,s))!==h&&(s||f||(e=e.setIn(_u(d,"children1"),new Al.OrderedMap),p&&(e=hy(e,d,"rule",Pl(),Ld(i),i))),e=Au(e)),e},hy=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("switch_group"===r)throw new Error("Can't add switch_group programmatically");var l=e.getIn(_u(t));if(!l)return e;var u,c,d=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,p=i.settings,f=p.maxNumberOfCases,h=p.maxNumberOfRules,g=p.maxNesting,v="switch_group"===e.get("type"),m=v?e.getIn(_u(t.take(2))):null,y=_u(t,"children1"),b=e.getIn(y),O=!!b&&b.size,E=O?b.size:null;"case_group"===r?(u=E,c=f):"group"===r?(u=t.size,c=g):"rule_group"===(null==l?void 0:l.get("type"))||(u=ku(v?m:e),c=h);var S=!c||!u||u<c,w={type:r,id:d,properties:o};by(i,w,s);var T="case_group"===r&&O&&null==b.last().get("children1");if(S){var x=new Al.OrderedMap(no({},d,new Al.Map(w)));if(O)if(T){var _=b.last(),C=new Al.OrderedMap(no(no({},d,new Al.Map(w)),_.get("id"),_));e=(e=e.deleteIn(_u(y,"children1",_.get("id")))).mergeIn(y,C)}else e=e.mergeIn(y,x);else e=e.setIn(y,x);e=Au(e)}return e},gy=function(e,t){return e=e.deleteIn(_u(t)),Au(e)},vy=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},c=e.getIn(_u(t));if(!c)return{state:e};var d=u.isEndValue,p=u.canDropArgs;if(!r)return{state:e=gy(e,t)};var f=n.settings,h=f.fieldSeparator,g=f.setOpOnChangeField,v=f.showErrorMessage;Array.isArray(r)&&(r=r.join(h));var m=c.get("type"),y=c.get("properties"),b="rule_group"==m,O=null==y?void 0:y.get("fieldSrc"),E=ev(n,r);if(!E)return console.warn("No config for LHS ".concat(r)),{state:e};var S=E.type;"!group"!==S&&"!struct"!==S||(S=null);var w=null==y?void 0:y.get("operator"),T=null==y?void 0:y.get("operatorOptions"),x=null==y?void 0:y.get("field"),_="!group"==E.type,C=_&&"array"==E.mode,R=b!=_,I=E&&-1!==(null===(i=E.operators)||void 0===i?void 0:i.indexOf(w))?w:null,A="func"===O&&(null==x||null===(a=x.get)||void 0===a?void 0:a.call(x,"func"))===(null===(s=r)||void 0===s||null===(l=s.get)||void 0===l?void 0:l.call(s,"func"))&&!!I,j=null,P="func"===O?uh(n,S):ch(n,r);if(P&&1==P.length)j=P[0];else if(A)j=I;else if(P&&P.length>1){var L,k=dy(g);try{for(k.s();!(L=k.n()).done;){var N=L.value;if("keep"!=N||R?"default"==N?j=jd(n,r,!1):"first"==N&&(j=dh(n,r)):j=I,j)break}}catch(e){k.e(e)}finally{k.f()}}if(!_&&!E.operators)return console.warn("Type ".concat(E.type," is not supported")),{state:e};b&&!_&&(e=(e=(e=e.setIn(_u(t,"type"),"rule")).deleteIn(_u(t,"children1"))).setIn(_u(t,"properties"),new Al.OrderedMap)),y||(e=e.setIn(_u(t,"properties"),new Al.OrderedMap));var D=!v;if(_){e=e.setIn(_u(t,"type"),"rule_group");var F=Jf(n,n,y,r,j,"field",D,d,p),M=(F.canReuseValue,F.newValue),V=F.newValueSrc,U=F.newValueType,B=F.operatorCardinality,z=Dd(n,E).merge({field:r,fieldSrc:"field",mode:E.mode});C&&(z=z.merge({operator:j,value:M,valueSrc:V,valueType:U})),e=(e=e.setIn(_u(t,"children1"),new Al.OrderedMap)).setIn(_u(t,"properties"),z),E.initialEmptyWhere&&1==B||(e=hy(e,t,"rule",Pl(),Ld(n,r),n)),e=Au(e)}else e=e.updateIn(_u(t,"properties"),(function(e){return e.withMutations((function(e){var t=Jf(n,n,e,r,j,"field",D,d,p),o=t.canReuseValue,i=t.newValue,a=t.newValueSrc,s=t.newValueType,l=t.newValueError,u=t.newFieldError,c=t.fixedField,f=r;c!==r&&(f=c),v&&(e=(e=e.set("fieldError",u)).set("valueError",l));var h=o?T:Pd(n,j,f);return e=e.set("field",f).delete("fieldType").set("fieldSrc",O).set("operator",j).set("operatorOptions",h).set("value",i).set("valueSrc",a).set("valueType",s),o||(e=e.delete("asyncListValues")),e}))}));return{state:e}},my=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(_u(t)))return{state:e};var l=s.canDropArgs,u=s.isEndValue,c=i.settings,d=c.fieldSeparator,p=c.showErrorMessage,f=e.getIn(_u(t,"properties","valueSrc",r+""))||null;"field"===f&&Array.isArray(n)&&(n=n.join(d));var h=e.getIn(_u(t,"properties","field"))||null,g=e.getIn(_u(t,"properties","operator"))||null,v=tv(i,g,h),m=g?Vl(v):null,y=o||ph(n,f,i),b=lo(Gf(i,h,h,g,n,y,f,a,!p,u,l),2),O=b[0],E=b[1],S=null==E?void 0:E.find((function(e){return!e.fixed&&!e.ignore})),w=S?jf(S):null,T=O!==n;T&&(n=O),e=yy(e,t,i,m);var x=Array.from({length:m},(function(o,i){return i==r?n:e.getIn(_u(t,"properties","value",i+""))||null})),_=Array.from({length:m},(function(r,n){return e.getIn(_u(t,"properties","valueSrc",n+""))||null})),C=Qf(i,h,g,x,_),R=C?jf(C):null;return(!!p||!w&&!R||T)&&(e=e.deleteIn(_u(t,"properties","asyncListValues")),void 0===n?e=(e=e.setIn(_u(t,"properties","value",r),void 0)).setIn(_u(t,"properties","valueType",r),null):(a&&(e=e.setIn(_u(t,"properties","asyncListValues"),a)),e=(e=e.setIn(_u(t,"properties","value",r),n)).setIn(_u(t,"properties","valueType",r),y))),p&&(e.getIn(_u(t,"properties","valueError"))||(e=e.setIn(_u(t,"properties","valueError"),new Al.List(new Array(m)))),e=e.setIn(_u(t,"properties","valueError",r),w),m>=2&&(e=e.setIn(_u(t,"properties","valueError",m),R))),{state:e}},yy=function(e,t,r,n){if(!n){var o=e.getIn(_u(t,"properties","field"))||null,i=e.getIn(_u(t,"properties","operator"))||null,a=tv(r,i,o);n=i?Vl(a):null}for(var s=0,l=["value","valueType","valueError","valueSrc"];s<l.length;s++){var u=l[s];e.getIn(_u(t,"properties",u))||(e=e.setIn(_u(t,"properties",u),new Al.List(n?Array.from({length:n}):[])))}return e},by=function e(t,r,n){n&&Array.isArray(n)&&(r.children1=new Al.OrderedMap(n.reduce((function(r,n){var o,i=null!==(o=n.id)&&void 0!==o?o:Pl(),a=cy(cy({},n),{},{properties:Fd(t,n).merge(Cl(n.properties)||{}),id:i});return e(t,a,a.children1),cy(cy({},r),{},no({},i,new Al.Map(a)))}),{})))},Oy={dragging:{id:null,x:null,y:null,w:null,h:null},mousePos:{},dragStart:{id:null}},Ey=function(e,t){return{type:Jm,tree:t,config:e}},Sy=function(e,t,r){var n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;return{type:zm,ruleType:arguments.length>3&&void 0!==arguments[3]?arguments[3]:"rule",children:arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,path:Wl(t),id:Pl(),properties:Ld(e,n).merge(Cl(r)||{}),config:e}},wy=function(e,t){return{type:$m,path:Wl(t),config:e}},Ty=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Mm,path:Wl(t),children:n,id:Pl(),properties:Dd(e).merge(Cl(r)||{}),config:e,meta:{isDefaultCase:!0}}},xy=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Mm,path:Wl(t),children:n,id:Pl(),properties:Dd(e).merge(Cl(r)||{}),config:e}},_y=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Fm,path:Wl(t),children:n,id:Pl(),properties:Dd(e).merge(Cl(r)||{}),config:e}},Cy=function(e,t){return{type:Vm,path:Wl(t),config:e}},Ry=function(e,t,r,n){return{type:Zm,fromPath:Wl(t),toPath:Wl(r),placement:n,config:e}},Iy=function(e,t,r){return{type:Um,path:Wl(t),conjunction:r}},Ay=function(e,t,r){return{type:Bm,path:Wl(t),not:r}},jy=function(e,t,r){return{type:Qm,path:Wl(t),lock:r}},Py=function(e,t,r,n,o){return{type:Wm,path:Wl(t),field:r,config:e,asyncListValues:n,_meta:o}},Ly=function(e,t,r){return{type:Hm,path:Wl(t),srcKey:r,config:e}},ky=function(e,t,r){return{type:qm,path:Wl(t),operator:r,config:e}},Ny=function(e,t,r,n,o,i,a){return{type:Gm,path:Wl(t),delta:r,value:n,valueType:o,asyncListValues:i,config:e,_meta:a}},Dy=function(e,t,r,n,o){return{type:Km,path:Wl(t),delta:r,srcKey:n,config:e,_meta:o}},Fy=function(e,t,r,n,o,i,a,s,l){return{type:Ym,path:Wl(t),delta:r,parentFuncs:n,argKey:o,value:i,valueType:a,asyncListValues:s,config:e,_meta:l}},My=function(e,t,r,n){return{type:Xm,path:Wl(t),name:r,value:n,config:e}};function Vy(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Uy(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Vy(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Vy(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var By=Uy(Uy(Uy({},p),{},{Export:c,Import:o,ConfigMixins:km},c),o),zy=v(7028),$y=v.n(zy);const Wy=function(e,t,r,n,o){var i=cy({tree:t},Oy);return function(){var t,a,s=arguments.length>0&&void 0!==arguments[0]?arguments[0]:i,l=arguments.length>1?arguments[1]:void 0,u=null!==(t=null!==(a=null==o?void 0:o())&&void 0!==a?a:null==l?void 0:l.config)&&void 0!==t?t:e,c={},d=function(e,t){if(!e||!e.type)return null;var r,n=[Jm,iy,oy,ay],o=ly()(pu()(e,["config","asyncListValues"]),Hl),i=e.path&&function(e,t){return e.getIn(_u(t,"properties","field"))||null}(t.tree,e.path)||e.field;return i&&(null!==(r=i)&&void 0!==r&&r.toJS&&(i=i.toJS()),o.affectedField=i),(n.includes(e.type)||0==e.type.indexOf("@@redux"))&&(o=null),o}(l,s);switch(null==l?void 0:l.type){case Jm:var p=r(u,l.tree);c.tree=p;break;case Mm:c.tree=fy(s.tree,l.path,"case_group",l.id,l.properties,u,l.children,l.meta);break;case Fm:c.tree=fy(s.tree,l.path,"group",l.id,l.properties,u,l.children,l.meta);break;case Vm:c.tree=function(e,t,r){if(!e.getIn(_u(t)))return e;e=gy(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.slice(0,-1);return Mu(e,o)||n||(e=ju(e),!Fu(e)||n)||(e=hy(e,new Al.List,"rule",Pl(),Ld(r,void 0,void 0,!1,!1),r)),Au(e)}(s.tree,l.path,u);break;case zm:c.tree=hy(s.tree,l.path,l.ruleType,l.id,l.properties,u,l.children);break;case $m:c.tree=function(e,t,r){if(!e.getIn(_u(t)))return e;e=gy(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.pop(),i=e.getIn(_u(o)),a=i.getIn(["properties","field"]),s=i.getIn(["properties","operator"]),l=a?ev(r,a):null,u=s?tv(r,s,a):null,c=a&&s&&0!=u.cardinality,d="rule_group"==i.get("type"),p=!Mu(e,o),f=d?c&&l.initialEmptyWhere:n;return p&&!f&&(d&&(e=e.deleteIn(_u(o))),e=ju(e),Fu(e)&&!n)&&(e=hy(e,new Al.List,"rule",Pl(),Ld(r,void 0,void 0,!1,!1),r)),Au(e)}(s.tree,l.path,u);break;case Um:c.tree=function(e,t,r){return e.getIn(_u(t))?e=e.setIn(_u(t,"properties","conjunction"),r):e}(s.tree,l.path,l.conjunction);break;case Bm:c.tree=function(e,t,r){return e.getIn(_u(t))?e=e.setIn(_u(t,"properties","not"),r):e}(s.tree,l.path,l.not);break;case Wm:var f=vy(s.tree,l.path,l.field,u,l.asyncListValues,l._meta).state;c.tree=f;break;case Hm:c.tree=function(e,t,r,n){var o=e.getIn(_u(t));if(!o)return e;var i=n.settings.keepInputOnChangeFieldSrc,a=o.get("properties"),s=null==a?void 0:a.get("field"),l=null==a?void 0:a.get("fieldType"),u=ev(n,s),c=(null==u?void 0:u.type)||l;c&&"!group"!==c&&"!struct"!==c||(c=null);var d=!lh.includes(c);return(e=i&&!wh(o,n)&&d?(e=(e=e.setIn(_u(t,"properties","field"),null)).deleteIn(_u(t,"properties","fieldError"))).setIn(_u(t,"properties","fieldType"),c):e.setIn(_u(t,"properties"),Ld(n,null,null,!1))).setIn(_u(t,"properties","fieldSrc"),r)}(s.tree,l.path,l.srcKey,u);break;case Qm:c.tree=function(e,t,r){return e.getIn(_u(t))?e=Iu(e.setIn(_u(t,"properties","isLocked"),r)):e}(s.tree,l.path,l.lock);break;case qm:c.tree=function(e,t,r,n){var o=e.getIn(_u(t));if(!o)return e;var i=n.settings.showErrorMessage,a=o.get("properties"),s=o.get("children1"),l=a.get("field"),u=(a.get("fieldSrc"),ev(n,l)),c="!group"==(null==u?void 0:u.type),d=tv(n,r,l),p=d?Vl(d):null;return e=e.updateIn(_u(t,"properties"),(function(e){return e.withMutations((function(e){var t=e.get("field"),o=e.get("operatorOptions"),a=(e.get("value",new Al.List),e.get("valueSrc",new Al.List),e.get("operator"),Jf(n,n,e,t,r,"operator",!0)),s=a.canReuseValue,l=a.newValue,u=a.newValueSrc,c=a.newValueType,d=a.newValueError;i&&(e=e.set("valueError",d));var p=s?o:Pd(n,r,t);return s||(e=e.delete("asyncListValues")),e.set("operator",r).set("operatorOptions",p).set("value",l).set("valueSrc",u).set("valueType",c)}))})),c&&0==p&&0==s.size&&(e=hy(e,t,"rule",Pl(),Ld(n,l),n)),e}(s.tree,l.path,l.operator,u);break;case Gm:var h=my(s.tree,l.path,l.delta,l.value,l.valueType,u,l.asyncListValues,l._meta).state;c.tree=h;break;case Ym:var g=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:{},c=t.getIn(_u(r));if(!c)return t;var d,p=-1===n,f=c.get("properties"),h=f.get("field"),g=f.get("value"),v=[],m=p?h:g.getIn([n]),y=dy(o||[]);try{for(y.s();!(d=y.n()).done;){var b=lo(d.value,2),O=b[0],E=b[1];if(v.push([O,E,m]),O!==m.get("func")){var S=v.map((function(e){var t=lo(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")||"root";throw new Error("In ".concat(p?"LHS":"RHS"," for path ").concat(S," expected func key ").concat(O," but got ").concat(parent.get("func")))}m=m.getIn(["args",E,"value"])}}catch(e){y.e(e)}finally{y.f()}if(i){var w=m.get("func"),T=Wg(e,w).args[i];m="!valueSrc"===s?ah(m,i,a,T,e):ih(m,i,a,T,e)}else m=th(m,a,e,!0),u.canDropArgs=!0;for(var x=m;v.length;){var _=lo(v.pop(),3),C=_[0],R=_[1],I=_[2],A=Wg(e,C).args[R];x=ih(I,R,x,A,e)}return p?vy(t,r,x,e,l,u):my(t,r,n,x,void 0,e,l,u)}(u,s.tree,l.path,l.delta,l.parentFuncs,l.argKey,l.value,l.valueType,l.asyncListValues,l._meta),v=g.state;c.tree=v;break;case Km:c.tree=function(e,t,r,n,o){if(!e.getIn(_u(t)))return e;var i=o.settings.showErrorMessage,a=e.getIn(_u(t,"properties","field"))||null,s=e.getIn(_u(t,"properties","operator"))||null,l=tv(o,s,a),u=s?Vl(l):null;if(e=(e=(e=(e=yy(e,t,o,u)).setIn(_u(t,"properties","value",r+""),void 0)).setIn(_u(t,"properties","valueType",r+""),null)).deleteIn(_u(t,"properties","asyncListValues")),i&&(e=e.setIn(_u(t,"properties","valueError",r),null),l.validateValues&&(e=e.setIn(_u(t,"properties","valueError",u),null))),e=void 0===n?e.setIn(_u(t,"properties","valueSrc",r+""),null):e.setIn(_u(t,"properties","valueSrc",r+""),n),n){var c=e.getIn(_u(t,"properties")),d=Jf(o,o,c,a,s,"valueSrc",!0),p=d.canReuseValue,f=d.newValue,h=d.newValueSrc,g=d.newValueType;d.newValueError,p||h.get(r)!=n||(e=(e=e.setIn(_u(t,"properties","value",r+""),f.get(r))).setIn(_u(t,"properties","valueType",r+""),g.get(r)))}return e}(s.tree,l.path,l.delta,l.srcKey,u,l._meta);break;case Xm:c.tree=function(e,t,r,n){return e.getIn(_u(t))?e.setIn(_u(t,"properties","operatorOptions",r),n):e}(s.tree,l.path,l.name,l.value);break;case Zm:c.tree=function(e,t,r,n,o){var i=Ru(e,t),a=t.pop(),s=t.size>1?Ru(e,a):null,l=s?s.get("children1"):null,u=Ru(e,r),c=n==ry||n==ny?r:r.pop(),d=n==ry||n==ny?u:r.size>1?Ru(e,c):null,p=d?d.get("children1"):null;if(!s||!d||!i)return e;var f=s.get("id")==d.get("id"),h=c.size<a.size&&Ul(c.toArray(),a.toArray().slice(0,c.size)),g=c.size>a.size&&Ul(a.toArray(),c.toArray().slice(0,a.size)),v=null,m=null;h?v=Al.List(a.toArray().slice(c.size)):g&&(m=Al.List(c.toArray().slice(a.size)));var y=p,b=l;return g||(b=b.delete(i.get("id"))),f?y=b:h&&(y=y.updateIn(Cu(v,"children1"),(function(e){return b}))),n==ty||n==ey?y=Al.OrderedMap().withMutations((function(e){var t,r=dy(y.entries());try{for(r.s();!(t=r.n()).done;){var o=lo(t.value,2),a=o[0],s=o[1];a==(null==u?void 0:u.get("id"))&&n==ty&&e.set(i.get("id"),i),e.set(a,s),a==(null==u?void 0:u.get("id"))&&n==ey&&e.set(i.get("id"),i)}}catch(e){r.e(e)}finally{r.f()}})):n==ry?y=y.merge(Al.OrderedMap(no({},i.get("id"),i))):n==ny&&(y=Al.OrderedMap(no({},i.get("id"),i)).merge(y)),g&&(b=(b=b.updateIn(Cu(m,"children1"),(function(e){return y}))).delete(i.get("id"))),f||h||(e=e.updateIn(_u(a,"children1"),(function(e){return b}))),g||(e=e.updateIn(_u(c,"children1"),(function(e){return y}))),Au(e)}(s.tree,l.fromPath,l.toPath,l.placement);break;case iy:c.dragStart=l.dragStart,c.dragging=l.dragging,c.mousePos=l.mousePos;break;case oy:c.mousePos=l.mousePos,c.dragging=l.dragging;break;case ay:c.tree=function(e,t){return t.settings.canLeaveEmptyGroup||(e=ju(e)),e}(s.tree,u),c=cy(cy({},c),Oy)}return d&&(c.__lastAction=d),n&&c.tree&&s.tree&&n(s.tree),cy(cy(cy({},s),{__lastAction:void 0}),c)}},Hy=ye().createContext();var qy=v(7694),Gy=v(200),Ky="after",Yy="before",Xy="append",Qy="prepend",Jy=function(e,t){return{type:"SET_DRAG_PROGRESS",mousePos:e,dragging:t}},Zy=function(e,t,r){return{type:"SET_DRAG_START",dragStart:e,dragging:t,mousePos:r}},eb=function(){return{type:"SET_DRAG_END"}},tb=h,rb=g,nb=y,ob=function(e,t,r){if(!t||!e||e.length<=t)return e;var n=e.substr(0,t-1);return(r?n.substr(0,n.lastIndexOf(" ")):n)+"..."},ib=function(e,t){return e===t||(null==e?void 0:e.equals(t))},ab=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?ab(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):e&&"function"==typeof e.equals?e.equals(t):"object"===Kn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?ab(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)},sb=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}}(),lb=By.Validation.validateAndFixTree,ub=function e(t){if(t){var r,n=(r=t)._reactRootContainer?"root":Object.getOwnPropertyNames(r).filter((function(e){return e.startsWith("__reactContainer")})).length>0?"container":void 0;return void 0!==n?n:e(t.parentNode)}},cb=function(e){return"root"===ub(e)},db=function(e,t){return function(r,n){var o=e.props,i=e.state,a=r!=o||n!=i;if(a&&i==n&&o!=r){var s=[];for(var l in r){var u=r[l]!=o[l];u&&("ignore"==t[l]?u=!1:"shallow_deep"==t[l]?u=!ab(r[l],o[l],!0):"shallow"==t[l]?u=!ab(r[l],o[l]):"function"==typeof t[l]&&(u=t[l](r[l],o[l],r,o))),u&&s.push(l)}s.length||(a=!1)}return a}},pb=function(e){return function(t,r){return!ab(e.props,t)||!ab(e.state,r)}},fb=function(e){if(e.shouldComponentUpdate||(e.shouldComponentUpdate=pb(e)),16==(r=ye().version.split(".").map(parseInt.bind(null,10)))[0]&&r[1]<3||r[0]<16)e.componentWillReceiveProps=function(t){e.onPropsChanged(t)};else{var t=e.shouldComponentUpdate;e.shouldComponentUpdate=function(r,n){return!ab(e.props,r)&&e.onPropsChanged(r),t.call(e,r,n)}.bind(e)}var r},hb=function(e,t,r){return ly()(e,(function(e){return function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return r(e.apply(void 0,[t].concat(o)))}}))};function gb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function vb(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?gb(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):gb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function mb(e,t,r){return t=eo(t),Zn(e,yb()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function yb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(yb=function(){return!!e})()}var bb=function(e){function t(e){var r;Gn(this,t),(r=mb(this,t,[e])).shouldComponentUpdate=db(r,{tree:function(e){return e!==r.oldValidatedTree||r.oldValidatedTree!==r.validatedTree}}),fb(r),r._updateActions(e),r.validatedTree=e.getMemoizedTree(e.config,e.tree,void 0,e.sanitizeTree),r.oldValidatedTree=r.validatedTree;var n=e.getBasicConfig(e.config);return e.onInit&&e.onInit(r.validatedTree,n,void 0,r.actions),r}return ro(t,e),Qn(t,[{key:"_updateActions",value:function(e){var t=e.config,r=e.dispatch;this.actions=hb(vb(vb(vb({},tb),rb),nb),t,r)}},{key:"onPropsChanged",value:function(e){var t=e.onChange,r=this.props.config,n=e.tree,o=(this.props.tree,e.config);if(this.oldValidatedTree=this.validatedTree,this.validatedTree=n,r!==o&&(this._updateActions(e),this.validatedTree=e.getMemoizedTree(o,n,r)),!ib(this.validatedTree,this.oldValidatedTree)){var i=e.getBasicConfig(o);t&&t(this.validatedTree,i,e.__lastAction,this.actions)}}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.renderBuilder,n=e.dispatch;return r({tree:this.validatedTree,actions:this.actions,config:t,dispatch:n})}}])}(ve.Component);bb.propTypes={config:$y().object.isRequired,onChange:$y().func,onInit:$y().func,renderBuilder:$y().func,tree:$y().any};var Ob=(0,Gy.connect)((function(e){return{tree:e.tree,__lastAction:e.__lastAction}}),null,null,{context:Hy})(bb);Ob.displayName="ConnectedQuery";const Eb=Ob;function Sb(e,t,r){return t=eo(t),Zn(e,wb()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function wb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(wb=function(){return!!e})()}var Tb=By.DefaultUtils.defaultRoot,xb=By.ConfigUtils.createConfigMemo,_b=function(e){function t(e,r){var n,o,i;Gn(this,t),(i=Sb(this,t,[e,r])).setLastTree=function(e){i.prevTree&&(i.prevprevTree=i.prevTree),i.prevTree=e},i.getConfig=function(){return i.config},i.shouldComponentUpdate=db(i,{value:function(e,t){return!1}}),fb(i);var a=xb({reactIndex:null!==(n=null===(o=i._reactInternals)||void 0===o?void 0:o.index)&&void 0!==n?n:-1,maxSize:2,canCompile:!0}),s=a.getExtendedConfig,l=a.getBasicConfig,u=a.clearConfigMemo;i.getMemoizedConfig=s,i.getBasicConfig=l,i.clearConfigMemo=u,i.getMemoizedTree=function(){var e,t,r;return function(n,o){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return o?n.__configId===r&&(ib(o,e)||ib(o,t))?t:(r=n.__configId,e=o,t=!1===a?lb(o,null,n,i||n,!1,!1,!1):lb(o,null,n,i||n)):null}}();var c=i.getMemoizedConfig(e),d=c.settings.shouldCreateEmptyGroup,p=Tb(c,!d),f=!!e.value,h=e.value||p,g=i.getMemoizedTree(c,h,void 0,f),v=Wy(c,g,i.getMemoizedTree,i.setLastTree,i.getConfig),m=(0,qy.createStore)(v);return i.config=c,i.state={store:m},i.QueryWrapper=function(e){return c.settings.renderProvider(e,c.ctx)},i}return ro(t,e),Qn(t,[{key:"componentWillUnmount",value:function(){this.clearConfigMemo()}},{key:"onPropsChanged",value:function(e){var t=this.props,r=this.config,n=this.getMemoizedConfig(e),o=r!==n,i=this.state.store.getState().tree,a=!ib(e.value,this.props.value)&&!ib(e.value,i),s=a?e.value||Tb(e):i,l=a&&!ib(e.value,this.prevTree)&&!ib(e.value,this.prevprevTree);if(this.sanitizeTree=l||o,o&&(t.settings.renderProvider!==e.settings.renderProvider&&(this.QueryWrapper=function(e){return n.settings.renderProvider(e,n.ctx)}),this.config=n),a||o){var u=this.getMemoizedTree(n,s,r,this.sanitizeTree);this.state.store.dispatch(tb.setTree(n,u))}}},{key:"render",value:function(){var e=this.props,t=e.renderBuilder,r=e.get_children,n=e.onChange,o=e.onInit,i=this.state.store,a=this.config,s=this.QueryWrapper;return ye().createElement(s,{config:a},ye().createElement(Gy.Provider,{store:i,context:Hy},ye().createElement(Eb,{config:a,getMemoizedTree:this.getMemoizedTree,getBasicConfig:this.getBasicConfig,sanitizeTree:this.sanitizeTree,onChange:n,onInit:o,renderBuilder:t||r})))}}])}(ve.Component);function Cb(){return Cb=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)({}).hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},Cb.apply(null,arguments)}_b.propTypes={conjunctions:$y().object.isRequired,fields:$y().object.isRequired,types:$y().object.isRequired,operators:$y().object.isRequired,widgets:$y().object.isRequired,settings:$y().object.isRequired,ctx:$y().object.isRequired,onChange:$y().func,onInit:$y().func,renderBuilder:$y().func,value:$y().any};var Rb=v(2584),Ib=v.n(Rb);function Ab(e,t,r){return t=eo(t),Zn(e,jb()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function jb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(jb=function(){return!!e})()}var Pb=By.ConfigUtils.getFieldConfig;function Lb(e,t,r){return t=eo(t),Zn(e,kb()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function kb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(kb=function(){return!!e})()}var Nb=By.clone,Db=By.TreeUtils.getFlatTree,Fb=!1,Mb=["isDraggingTempo","isDraggingMe","dragging"];function Vb(e,t,r){return t=eo(t),Zn(e,Ub()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function Ub(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Ub=function(){return!!e})()}const Bb=function(e){return function(t){var r;return r=function(r){function n(e){var t;return Gn(this,n),(t=Vb(this,n,[e])).handleDraggerMouseDown=function(e){var r=t.props.id,n=t.wrapper.current;t.props.onDragStart&&t.props.onDragStart(r,n,e)},t.wrapper=ye().createRef(),t}return ro(n,r),Qn(n,[{key:"render",value:function(){var r=this.props,n=r.isDraggingTempo,o=r.isDraggingMe,i=r.dragging,a=nm(r,Mb),s=a.isTrueLocked,l={};o&&n&&(Fb||(l={top:i.y,left:i.x,width:i.w}));var u=Ib()(e,"group-or-rule",o&&n?"qb-draggable":null,o&&!n?"qb-placeholder":null,s?"locked":null);return ye().createElement("div",{className:u,style:l,ref:this.wrapper,"data-id":this.props.id},ye().createElement(t,Cb({handleDraggerMouseDown:this.handleDraggerMouseDown,isDraggingMe:o,isDraggingTempo:n},a)))}}])}(ve.PureComponent),r.propTypes={isDraggingTempo:$y().bool,isDraggingMe:$y().bool,onDragStart:$y().func,dragging:$y().object,isLocked:$y().bool,isTrueLocked:$y().bool},r}};var zb=v(3790),$b=v.n(zb),Wb=v(350),Hb=v.n(Wb);function qb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Gb(e,t,r){return t=eo(t),Zn(e,Kb()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function Kb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Kb=function(){return!!e})()}var Yb=By.ConfigUtils,Xb=Yb.getFieldConfig,Qb=Yb.getOperatorConfig,Jb=function(e){function t(e){var r;return Gn(this,t),(r=Gb(this,t,[e])).shouldComponentUpdate=db(r,{selectedField:function(e,t){return!1}}),fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","selectedField","selectedFieldSrc","selectedFieldType","selectedOperator"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.selectedField,o=e.selectedFieldType,i=e.selectedOperator,a=Xb(r,n),s=co((null==a?void 0:a.operators)||(null===(t=r.types[o])||void 0===t?void 0:t.operators)||[]);n||s.includes(i)||s.push(i);var l=ly()(Hb()(r.operators,(function(e,t){return-1!==(null==s?void 0:s.indexOf(t))})),(function(e,t){return Qb(r,t,n)})),u=this.buildOptions(r,l,s),c=l[i]||{},d=i?[i]:null;return{placeholder:this.props.config.settings.operatorPlaceholder,items:u,selectedKey:i,selectedKeys:d,selectedPath:d,selectedLabel:c.label,selectedAltLabel:c.label2||c.tooltip,selectedOpts:c,fieldConfig:a}}},{key:"buildOptions",value:function(e,t,r){return t&&r?$b()(t).sort((function(e,t){return r.indexOf(e)-r.indexOf(t)})).map((function(e){var r=t[e];return{key:e,path:e,label:r.label,altLabel:r.label2,tooltip:r.tooltip}})):null}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setOperator,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderOperator,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?qb(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):qb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:n},this.meta);return l.items?s(l,t.ctx):null}}])}(ve.Component);Jb.propTypes={id:$y().string,groupId:$y().string,config:$y().object.isRequired,selectedField:$y().any,selectedFieldId:$y().string,selectedFieldType:$y().string,selectedFieldSrc:$y().string,selectedOperator:$y().string,readonly:$y().bool,customProps:$y().object,setOperator:$y().func.isRequired};var Zb=["children"],eO=function(e){var t=e.children,r=nm(e,Zb);return ye().createElement("div",r,t)},tO=function(){},rO=function(){return ye().createElement("svg",{xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",width:"18px",height:"18px"},ye().createElement("path",{d:"M0 0h24v24H0V0z",fill:"none"}),ye().createElement("path",{d:"M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"}))},nO=function(e){return function(t){var r=t.config.settings.useConfirm,n=r?r.call(t.config.ctx,t.config.ctx):null;return ye().createElement(e,Cb({},t,{confirmFn:n}))}},oO=function(e){var t=e.id,r=e.isLHS,n=e.delta;return[t,r?"L":"R",r?-1:n||0,(e.parentFuncs||[]).map((function(e){var t=lo(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")].join(":")},iO=function(e,t){var r;return"function"==typeof t?(r=function(r){return null==t?void 0:t(r,e.ctx)}).displayName=t.name:r=t,r};function aO(e,t,r){return t=eo(t),Zn(e,sO()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function sO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(sO=function(){return!!e})()}var lO=function(e){function t(){return Gn(this,t),aO(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.setOperator,s=e.selectedFieldId,l=e.showOperator,u=e.showOperatorLabel,c=e.selectedFieldWidgetConfig,d=e.readonly,p=e.id,f=e.groupId;return[l&&ye().createElement(eO,{key:"operators-for-"+s,className:"rule--operator"},t.settings.showLabels&&ye().createElement("label",{className:"rule--label"},t.settings.operatorLabel),ye().createElement(Jb,{key:"operator",config:t,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,selectedFieldId:s,selectedOperator:i,setOperator:a,customProps:t.settings.customOperatorSelectProps,readonly:d,id:p,groupId:f})),u&&ye().createElement(eO,{key:"operators-for-"+s,className:"rule--operator"},ye().createElement("div",{className:"rule--operator-wrapper"},t.settings.showLabels?ye().createElement("label",{className:"rule--label"}," "):null,ye().createElement("div",{className:"rule--operator-text-wrapper"},ye().createElement("span",{className:"rule--operator-text"},c.operatorInlineLabel))))]}}])}(ve.PureComponent);function uO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function cO(e,t,r){return t=eo(t),Zn(e,dO()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function dO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(dO=function(){return!!e})()}var pO=By.RuleUtils.getFieldPathLabels,fO=By.ConfigUtils,hO=fO.getFieldConfig,gO=fO.getFieldParts,vO=fO.getFieldPathParts,mO=function(e){function t(e){var r;return Gn(this,t),(r=cO(this,t,[e])).setField=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=r.props.id;if(!n.widgetId){var i=[o,"L",-1].join(":");n.widgetId=i}r.props.setField(e,t,n)},fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","config","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.config,o=e.parentField,i=t,a=n.settings,s=a.maxLabelsLength,l=a.fieldSeparatorDisplay,u=a.fieldPlaceholder,c=(a.fieldSeparator,!!t),d=c?null:ob(u,s),p=c?hO(n,i):null,f=p||{},h=vO(i,n),g=vO(i,n,!0),v=this.getFieldLabel(p,i,n),m=pO(i,n),y=m?m.join(l):null;(y==v||o)&&(y=null);var b=f.label2||f.tooltip,O=gO(o,n),E=o?hO(n,o):null,S=o?E&&E.subfields:n.fields,w=!c&&r,T=this.buildOptions(O,n,S,w,O),x=w?"Please select field":null;return i&&"object"===Kn(i)&&(i=void 0),{placeholder:d,items:T,parentField:o,selectedKey:i,selectedKeys:h,selectedPath:g,selectedLabel:v,selectedOpts:f,selectedAltLabel:b,selectedFullLabel:y,errorText:x}}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=gO(t,r),i=(null==e?void 0:e.label)||cu()(o);return ob(i,n)}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(!r)return null;var s=t.settings,l=s.fieldSeparator,u=s.fieldSeparatorDisplay,c=null!=i&&i.length?i.join(l)+l:"",d=function e(t){return Object.keys(t||{}).reduce((function(r,n){var i=t[n];return"!struct"===i.type?r+e(i.subfields):r+(i.type===o?1:0)}),0)};return $b()(r).map((function(s){var l=[].concat(co(null!=i?i:[]),[s]),p=r[s],f=n.getFieldLabel(p,l,t),h=pO(l,t).join(u);(h==f||null!=e&&e.length)&&(h=null);var g=p.label2,v=p.tooltip,m=p.disabled;if(!p.hideForSelect){if("!struct"==p.type){var y=n.buildOptions(e,t,p.subfields,o,l,{label:f,tooltip:v}),b=d(p.subfields)>0;return{disabled:m,key:s,path:c+s,label:f,fullLabel:h,altLabel:g,tooltip:v,items:y,matchesType:b}}var O=void 0!==o?p.type===o:void 0;return{disabled:m,key:s,path:c+s,label:f,fullLabel:h,altLabel:g,tooltip:v,grouplabel:null==a?void 0:a.label,group:a,matchesType:O}}})).filter((function(e){return!!e}))}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setFieldSrc,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?uO(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):uO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:this.setField,setFieldSrc:n},this.meta);return s(l,t.ctx)}}])}(ve.Component);function yO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function bO(e,t,r){return t=eo(t),Zn(e,OO()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function OO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(OO=function(){return!!e})()}mO.propTypes={id:$y().string,groupId:$y().string,config:$y().object.isRequired,selectedField:$y().any,selectedFieldSrc:$y().string,selectedFieldType:$y().string,parentField:$y().string,customProps:$y().object,readonly:$y().bool,setField:$y().func.isRequired,setFieldSrc:$y().func};var EO=By.clone,SO=By.ConfigUtils,wO=SO.getFieldConfig,TO=SO.getFuncConfig,xO=SO.getFieldParts,_O=SO.getFieldPathParts,CO=By.RuleUtils,RO=CO.getFuncPathLabels,IO=CO.getWidgetForFieldOp,AO=By.OtherUtils.shallowEqual,jO=function(e){function t(e){var r;return Gn(this,t),r=bO(this,t,[e]),fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldType","fieldSrc","operator","isFuncArg","isLHS","parentFuncs"].map((function(r){return"parentFuncs"===r?!AO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0;(!this.meta||["config","field","fieldType","fieldSrc","value","isLHS"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r&&(this.items=this.getItems(e,this.meta))}},{key:"getItems",value:function(e,t){var r=e.config,n=e.field,o=e.fieldType,i=e.isLHS,a=e.operator,s=e.parentFuncs,l=e.fieldDefinition,u=e.isFuncArg,c=t.lookingForFieldType,d=r.settings.canUseFuncForField,p=this.filterFuncs(r,r.funcs,n,o,i,a,d,s,u,l);return this.buildOptions(r,p,c)}},{key:"getMeta",value:function(e){var t=e.config,r=(e._field,e.fieldType),n=e.value,o=e.isLHS,i=e.isFuncArg,a=t.settings,s=a.funcPlaceholder,l=a.fieldSeparatorDisplay,u=n,c=!!n,d=c?null:s,p=c?TO(t,u):null,f=p||{},h=_O(u,t),g=_O(u,t,!0),v=this.getFuncLabel(p,u,t),m=RO(u,t),y=m?m.join(l):null;y==v&&(y=null);var b=o&&!i&&!c&&r;return{placeholder:d,selectedKey:u,selectedKeys:h,selectedPath:g,selectedLabel:v,selectedOpts:f,selectedFullLabel:y,errorText:b?"Please select function":null,lookingForFieldType:b}}},{key:"filterFuncs",value:function(e,t,r,n,o,i,a,s,l,u){t=EO(t);var c,d=e.settings.fieldSeparator,p=wO(e,r),f=p,h=IO(e,r,i,"value");return h&&e.widgets[h],l?(f=u,c=null==u?void 0:u.type):p?c=p.type:o||(c=n),function t(n,o){for(var l in n){var u=n[l].subfields,h=(o||[]).concat(l),g=h.join(d),v=TO(e,g);if("!struct"==v.type)0==t(u,h)&&delete n[l];else{var m,y=!c||v.returnType==c;null!==(m=f)&&void 0!==m&&m.funcs&&(y=y&&f.funcs.includes(g)),a&&(y=y&&a(r,p,g,v,i)),!v.allowSelfNesting&&s&&s.map((function(e){var t=lo(e,2),r=t[0];return t[1],r})).includes(g)&&(y=!1),y||delete n[l]}}return $b()(n).length}(t,[]),t}},{key:"buildOptions",value:function(e,t){var r=this,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!t)return null;var a=e.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"",c=function e(t){return Object.keys(t||{}).reduce((function(r,o){var i=t[o];return"!struct"===i.type?r+e(i.subfields):r+(i.type===n?1:0)}),0)};return $b()(t).map((function(a){var s=[].concat(co(null!=o?o:[]),[a]),d=t[a],p=r.getFuncLabel(d,s,e),f=RO(s,e).join(l);f==p&&(f=null);var h=d.tooltip;if("!struct"==d.type){var g=r.buildOptions(e,d.subfields,n,s,{label:p,tooltip:h}),v=c(d.subfields)>0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:h,items:g,matchesType:v}}var m=void 0!==n?d.returnType===n:void 0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:h,grouplabel:null==i?void 0:i.label,group:i,matchesType:m}}))}},{key:"getFuncLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=xO(t,r),i=(null==e?void 0:e.label)||cu()(o);return ob(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderFunc,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?yO(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):yO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,readonly:o,setField:n,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ve.Component);jO.propTypes={id:$y().string,groupId:$y().string,config:$y().object.isRequired,field:$y().any,fieldType:$y().string,fieldSrc:$y().string,operator:$y().string,customProps:$y().object,value:$y().string,setValue:$y().func.isRequired,readonly:$y().bool,parentFuncs:$y().array,fieldDefinition:$y().object,isFuncArg:$y().bool,isLHS:$y().bool};var PO=v(2285),LO=v.n(PO),kO=["widgetFactory"],NO=["factory"];function DO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function FO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?DO(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):DO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var MO=By.ListUtils.getTitleInListValues,VO=By.ConfigUtils._widgetDefKeysToOmit,UO=By.TreeUtils,BO=UO._fixImmutableValue,zO=UO.isImmutable,$O=(0,ve.memo)((function(e){var t=e.widgetFactory,r=nm(e,kO),n=r.config,o=r.isFuncArg,i=r.fieldDefinition||{},a=i.fieldSettings,s=i.defaultValue,l=i.valueSources,u=o&&1==(null==l?void 0:l.length)&&"const"===(null==l?void 0:l[0]),c=(null==a?void 0:a.treeValues)||(null==a?void 0:a.listValues);return u&&s?"boolean"==typeof s?s?r.labelYes||"YES":r.labelNo||"NO":c?Array.isArray(s)?s.map((function(e){return MO(c,e)||e})).join(", "):MO(c,s)||s:""+s:t?t(r,n.ctx):"?"}));$O.displayName="WidgetFactoryMemo";var WO=function(e){var t=e.delta,r=e.isFuncArg,n=e.valueSrc,o=e.value,i=e.valueError,a=e.fieldError,s=e.asyncListValues,l=e.isSpecialRange,u=e.fieldDefinition,c=e.widget,d=e.widgetDefinition,p=e.widgetValueLabel,f=e.valueLabels,h=e.textSeparators,g=e.setValue,v=e.setFuncValue,m=e.config,y=e.field,b=e.fieldSrc,O=e.fieldPath,E=e.fieldType,S=e.isLHS,w=e.operator,T=e.readonly,x=e.parentField,_=e.parentFuncs,C=e.id,R=e.groupId,I=e.widgetId,A=d.factory,j=nm(d,NO),P=o?o.map((function(e){return BO(e)})):void 0,L=(0,ve.useMemo)((function(){if(l){var e=[null==P?void 0:P.get(0),null==P?void 0:P.get(1)];return void 0===e[0]&&void 0===e[1]&&(e=void 0),e}return null==P?void 0:P.get(t)}),[l,o]),k=(0,ve.useMemo)((function(){return i?l?[i.get(0),i.get(1),i.get(2)]:null==i?void 0:i.get(t):null}),[l,o]),N=S?a:k,D=(u||{}).fieldSettings,F=p.label,M=p.placeholder,V=f?f.placeholder:null,U=zO(y)?null:y,B=pu()(FO(FO(FO({},j),D),{},{config:m,field:U,fieldPath:O,fieldSrc:b,fieldType:E,isLHS:S,parentField:x,parentFuncs:_,fieldDefinition:u,operator:w,delta:t,isSpecialRange:l,isFuncArg:r,value:L,valueSrc:n,valueError:k,fieldError:a,errorMessage:N,label:F,placeholder:M,placeholders:V,textSeparators:h,setValue:g,setFuncValue:v,readonly:T,asyncListValues:s,id:C,groupId:R,widgetId:I,widgetFactory:A,widget:c}),[].concat(co(VO),["toJS"]));return ye().createElement($O,Cb({widgetFactory:A},B))};WO.displayName="WidgetFactory";const HO=WO;function qO(e,t,r){return t=eo(t),Zn(e,GO()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function GO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(GO=function(){return!!e})()}var KO=By.ConfigUtils,YO=KO.getFieldConfig,XO=KO.getOperatorConfig,QO=KO.getFieldWidgetConfig,JO=By.RuleUtils,ZO=JO.getValueSourcesForFieldOp,eE=JO.getWidgetForFieldOp,tE=JO.getValueLabel,rE=By.DefaultUtils.createListWithOneElement,nE=By.OtherUtils.shallowEqual,oE=(By.TreeUtils.isImmutable,{cardinality:1}),iE=function(e){function t(e){var r;return Gn(this,t),(r=qO(this,t,[e]))._setValue=function(e,t,n,o,i,a){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:{};if(s.widgetId||(s.widgetId=o),e&&Array.isArray(i)){var l=[r.props.value.get(0),r.props.value.get(1)];l[0]!=i[0]&&r.props.setValue(0,i[0],n,a,s),l[1]!=i[1]&&r.props.setValue(1,i[1],n,a,s)}else r.props.setValue(t,i,n,a,s)},r._setValueSrc=function(e,t,n){var o={widgetId:t};r.props.setValueSrc(e,n,o)},r.renderWidget=function(e,t,r){var n=r.config,o=r.isFuncArg,i=r.leftField,a=r.operator,s=r.value,l=r.valueError,u=r.fieldError,c=r.readonly,d=r.parentField,p=r.parentFuncs,f=r.id,h=r.groupId,g=r.fieldSrc,v=r.fieldType,m=r.isLHS,y=r.setFuncValue,b=n.settings,O=t.widgets,E=t.iValues,S=t.aField,w=t.valueSources,T=o?E:s,x=o?i:S,_=O[e],C=_.valueSrc,R=_.valueLabel,I=_.widgetId,A=w.length>1&&!c,j=b.showLabels?ye().createElement("label",{key:"label-"+I,className:"rule--label"},R.label):null;return ye().createElement("div",{key:"wrapper-"+I,className:Ib()("func"===C?"widget--func":"widget--widget",A?"widget--has-valuerscs":"widget--has-no-valuerscs")},"func"===C?null:j,ye().createElement(HO,Cb({key:I,id:f,groupId:h,widgetId:I,valueSrc:C,delta:e,value:T,valueError:l,fieldError:u,isFuncArg:o,isLHS:m},lu()(t,["isSpecialRange","fieldDefinition","asyncListValues"]),lu()(O[e],["widget","widgetDefinition","widgetValueLabel","valueLabels","textSeparators","setValue"]),{setFuncValue:y,config:n,field:x,fieldSrc:g,fieldType:v,parentField:d,parentFuncs:p,operator:a,readonly:c})))},r.renderValueSources=function(e,t,n){var o=n.config,i=n.isFuncArg,a=n.leftField,s=n.operator,l=n.readonly,u=o.settings,c=t.valueSources,d=t.widgets,p=t.aField,f=t.valueSourcesOptions,h=i?a:p,g=d[e],v=g.valueSrc,m=g.setValueSrc,y=r.ValueSources,b=u.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return c.length>1&&!l&&ye().createElement("div",{key:"wrapper-valuesrc-"+e,className:"widget--valuesrc"},b,ye().createElement(y,{key:"valuesrc-"+e,delta:e,valueSources:f,valueSrc:v,config:o,field:h,operator:s,setValueSrc:m,readonly:l,title:u.valueSourcesPopupTitle}))},r.renderSep=function(e,t,r){var n=r.config,o=t.widgets,i=n.settings,a=o[e].sepText,s=i.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return a&&ye().createElement("div",{key:"widget-separators-"+e,className:Ib()("widget--sep",0==e&&"widget--sep-first")},s,ye().createElement("span",null,a))},r.renderWidgetDelta=function(e){return[r.renderSep(e,r.meta,r.props),r.renderValueSources(e,r.meta,r.props),r.renderWidget(e,r.meta,r.props)]},fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config),n=["config","id","parentFuncs","field","fieldId","fieldSrc","fieldType","fieldFunc","fieldArg","leftField","operator","valueSrc","asyncListValues","isLHS","isFuncArg","isForRuleGroup","isCaseValue","value"].filter((function(r){return"parentFuncs"===r?!nE(e[r],t[r],!0):"field"===r?e.fieldId!==t.fieldId:e[r]!==t[r]}));if((!this.meta||n.length>0)&&(this.meta=this.getMeta(e,n)),r){var o=e.config,i=o.settings.renderValueSources;this.ValueSources=iO(o,i)}}},{key:"getMeta",value:function(e){var t,r,n,o,i=this,a=e.config,s=e.field,l=(e.fieldSrc,e.fieldType),u=e.fieldFunc,c=e.fieldArg,d=e.operator,p=e.valueSrc,f=e.value,h=e.isForRuleGroup,g=e.isCaseValue,v=e.isFuncArg,m=(e.leftField,e.asyncListValues),y=e.parentFuncs,b=e.isLHS,O=e.id,E=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],S=a.settings.valueSourcesInfo,w=v?{func:u,arg:c}:s,T=!s&&l,x=p,_=f;(v||h||g)&&(x=rE(p),_=rE(f));var C=YO(a,w);!C&&T&&(C=a.types[l]);var R,I=eE(a,w,d);!I&&T&&(I=null===(R=a.types[l])||void 0===R?void 0:R.mainWidget);var A=v?oE:XO(a,d,w);if((null==C||null==A)&&!g)return null;var j,P,L=null==A?void 0:A.isSpecialRange,k=L&&("field"===(null===(t=x)||void 0===t?void 0:t.get(0))||"field"===(null===(r=x)||void 0===r?void 0:r.get(1))),N=L&&!k,D=N?1:null!==(P=null==(j=A)?void 0:j.cardinality)&&void 0!==P?P:1;if(0===D)return null;var F=null===(n=this.meta)||void 0===n?void 0:n.valueSources,M=null===(o=this.meta)||void 0===o?void 0:o.valueSourcesOptions;F&&!["field","operator","config","fieldDefinition","isForRuleGroup"].filter((function(e){return E.includes(e)})).length||(F=ZO(a,w,d,C),h&&(F=["value"]),w||(F=Object.keys(S)),M=F.map((function(e){return[e,{label:S[e].label}]})));var V=LO()(0,D).map((function(e){var t,r,n,o,s=null===(t=i.meta)||void 0===t||null===(t=t.widgets)||void 0===t?void 0:t[e],l=(null===(r=x)||void 0===r?void 0:r.get(e))||null,u=eE(a,w,d,l),c=QO(a,w,d,u,l);k&&(u=c.singleWidget,c=QO(a,w,d,u,l)),!c&&T&&(u=["func","field"].includes(l)?l:I,c=a.widgets[u]);var p=null===(n=c)||void 0===n?void 0:n.type,f=tE(a,w,d,e,l,N),h=tE(a,w,d,e,null,N),g=null!=A&&A.textSeparators?null==A?void 0:A.textSeparators[e]:null,v=null,m=null;L&&(v={placeholder:[(v=[tE(a,w,d,0),tE(a,w,d,1)])[0].placeholder,v[1].placeholder],label:[v[0].label,v[1].label]},m=null==A?void 0:A.textSeparators);var E=oO({id:O,isLHS:b,delta:e,parentFuncs:y}),S=E+":VS",_=null==s?void 0:s.setValueSrc;_&&(null==s?void 0:s.widgetId)===E||(_=i._setValueSrc.bind(i,e,S));var C=null==s?void 0:s.setValue;return C&&(null==s?void 0:s.widgetId)===E&&(null==s?void 0:s.widgetType)===p&&(null===(o=i.meta)||void 0===o?void 0:o.isSpecialRange)===L||(C=i._setValue.bind(i,L,e,p,E)),{valueSrc:l,valueLabel:f,widget:u,sepText:g,widgetDefinition:c,widgetValueLabel:h,valueLabels:v,textSeparators:m,setValueSrc:_,setValue:C,widgetId:E,widgetType:p}}));return{defaultWidget:I,fieldDefinition:C,operatorDefinition:A,isSpecialRange:N,cardinality:D,valueSources:F,valueSourcesOptions:M,widgets:V,iValues:_,aField:w,asyncListValues:m}}},{key:"render",value:function(){if(!this.meta)return null;var e=this.meta,t=e.defaultWidget,r=e.cardinality;if(!t)return null;var n=t;return ye().createElement(eO,{className:"rule--widget rule--widget--".concat(n.toUpperCase()),key:"widget-col-"+n},LO()(0,r).map(this.renderWidgetDelta))}}])}(ve.Component);function aE(e,t,r){return t=eo(t),Zn(e,sE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function sE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(sE=function(){return!!e})()}iE.propTypes={config:$y().object.isRequired,value:$y().any,valueSrc:$y().any,valueError:$y().any,fieldError:$y().string,field:$y().any,fieldSrc:$y().string,fieldType:$y().string,fieldId:$y().string,operator:$y().string,readonly:$y().bool,asyncListValues:$y().array,id:$y().string,groupId:$y().string,setValue:$y().func,setValueSrc:$y().func,setFuncValue:$y().func,isFuncArg:$y().bool,fieldFunc:$y().string,fieldArg:$y().string,leftField:$y().any,isForRuleGroup:$y().bool,parentField:$y().string,parentFuncs:$y().array,isLHS:$y().bool,isCaseValue:$y().bool};var lE=By.ConfigUtils.getFuncConfig,uE=By.OtherUtils.shallowEqual,cE=function(e){function t(e){var r;return Gn(this,t),(r=aE(this,t,[e])).setFunc=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=r.props,o=n.isLHS,i=n.delta,a=n.parentFuncs,s=n.id;if(!t.widgetId){var l=oO({id:s,isLHS:o,delta:i,parentFuncs:a});t.widgetId=l}r.props.setFuncValue(o?-1:i||0,a,null,e,"!func",void 0,t)},r.setArgValue=function(e,t,n,o,i){var a=r.props,s=(a.config,a.delta),l=a.isLHS,u=a.parentFuncs;r.props.setFuncValue(l?-1:s||0,u,e,t,n,o,i)},r.setArgValueSrc=function(e,t,n){var o=r.props,i=(o.config,o.delta),a=o.isLHS,s=o.parentFuncs;r.props.setFuncValue(a?-1:i||0,s,e,t,"!valueSrc",void 0,n)},r.renderFuncSelect=function(){var e,t,n=r.props,o=n.config,i=n.field,a=n.fieldType,s=n.fieldSrc,l=n.isLHS,u=n.operator,c=n.customProps,d=n.value,p=n.readonly,f=n.parentFuncs,h=n.id,g=n.groupId,v=n.isFuncArg,m=n.fieldDefinition,y={value:null!==(e=null==d||null===(t=d.get)||void 0===t?void 0:t.call(d,"func"))&&void 0!==e?e:null,setValue:r.setFunc,config:o,field:i,fieldType:a,fieldSrc:s,isLHS:l,operator:u,customProps:c,readonly:p,parentFuncs:f,isFuncArg:v,fieldDefinition:m,id:h,groupId:g},b=o.settings,O=b.showLabels,E=b.funcLabel,S=O?ye().createElement("label",{className:"rule--label"},E):null;return ye().createElement(eO,{key:"func",className:"rule--func"},S,ye().createElement(jO,y))},r.renderArgLabel=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=t.label,s=r.props.config,l=n&&1==n.length&&"const"==n[0];return s.settings.showLabels||"boolean"!=o&&!l||!i?null:ye().createElement(eO,{className:"rule--func--arg-label"},a||e)},r.renderArgLabelSep=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=r.props.config,s=n&&1==n.length&&"const"==n[0];return a.settings.showLabels||"boolean"!=o&&!s||!i?null:ye().createElement(eO,{className:"rule--func--arg-label-sep"},":")},r.renderArgVal=function(e,t,n){var o=r.props,i=o.config,a=o.field,s=o.fieldType,l=o.fieldSrc,u=o.isLHS,c=(o.operator,o.value),d=o.readonly,p=o.parentFuncs,f=o.id,h=o.groupId,g=o.fieldError,v=o.valueError,m=o.setFuncValue,y=c?c.getIn(["args",t]):null,b=y?y.get("value"):void 0,O=1==n.valueSources.length?n.valueSources[0]:void 0,E={config:i,fieldFunc:e,fieldArg:t,leftField:a,fieldType:s,fieldSrc:l,fieldError:g,valueError:v,isLHS:u,operator:null,value:b,valueSrc:y?y.get("valueSrc")||O||"value":O,setValue:r.setArgValue,setValueSrc:r.setArgValueSrc,setFuncValue:m,funcKey:e,argKey:t,argDefinition:n,readonly:d,parentFuncs:p,id:f,groupId:h};return ye().createElement(eO,{className:"rule--func--arg-value"},ye().createElement(dE,E))},r.renderArgSep=function(e,t,r,n){var o=n.renderSeps;return r?ye().createElement(eO,{className:"rule--func--arg-sep"},o?o[r-1]:", "):null},r.renderBracketBefore=function(e){var t=e.renderBrackets;return ye().createElement(eO,{key:"before_args",className:"rule--func--bracket-before"},t?t[0]:"(")},r.renderBracketAfter=function(e){var t=e.renderBrackets;return ye().createElement(eO,{key:"after_args",className:"rule--func--bracket-after"},t?t[1]:")")},r.renderFuncArgs=function(){var e=r.meta,t=e.funcDefinition,n=e.funcKey;if(!n)return null;var o=(t||{}).args;return o?ye().createElement(ye().Fragment,null,r.renderBracketBefore(t),ye().createElement(eO,{key:"args-".concat(n),className:"rule--func--args rule--func--".concat(n,"--args")},Object.keys(o).map((function(e,i){return ye().createElement(eO,{key:"arg-".concat(e,"-").concat(i),className:"rule--func--arg rule--func--".concat(n,"--arg--").concat(e)},r.renderArgSep(e,o[e],i,t),r.renderArgLabel(e,o[e]),r.renderArgLabelSep(e,o[e]),r.renderArgVal(n,e,o[e]))}))),r.renderBracketAfter(t)):null},fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","operator","value","fieldSrc","fieldType","isLHS"].map((function(r){return"parentFuncs"===r?!uE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r,n=e.config,o=(e.field,e.operator,e.value),i=null!==(t=null==o||null===(r=o.get)||void 0===r?void 0:r.call(o,"func"))&&void 0!==t?t:null;return{funcDefinition:i?lE(n,i):null,funcKey:i}}},{key:"render",value:function(){var e=this.props.parentFuncs,t=e?e.map((function(e){var t=lo(e,2),r=t[0],n=t[1];return"".concat(r,"_").concat(n)})).join("-"):"root",r=(null==e?void 0:e.length)||0;return ye().createElement(eO,{className:"rule--func--wrapper rule--func--wrapper--under-".concat(t," rule--func--wrapper--lev-").concat(r)},this.renderFuncSelect(),this.renderFuncArgs())}}])}(ve.Component);cE.propTypes={id:$y().string,groupId:$y().string,config:$y().object.isRequired,field:$y().any,fieldSrc:$y().string,fieldType:$y().string,fieldError:$y().string,operator:$y().string,customProps:$y().object,value:$y().object,setValue:$y().func.isRequired,setFuncValue:$y().func,readonly:$y().bool,parentFuncs:$y().array,fieldDefinition:$y().object,isFuncArg:$y().bool,isLHS:$y().bool,valueError:$y().string};var dE=function(e){function t(e){var r;return Gn(this,t),(r=aE(this,t,[e])).setValue=function(e,t,n,o,i){var a=r.props;(0,a.setValue)(a.argKey,t,n,o,i)},r.setValueSrc=function(e,t,n){var o=r.props;(0,o.setValueSrc)(o.argKey,t,n)},fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["parentFuncs","funcKey","argKey"].map((function(r){return"parentFuncs"===r?!uE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.parentFuncs,r=e.funcKey,n=e.argKey;return{parentFuncs:[].concat(co(t||[]),[[r,n]])}}},{key:"render",value:function(){var e=this.meta.parentFuncs;return ye().createElement(iE,Cb({},this.props,{setValue:this.setValue,setValueSrc:this.setValueSrc,isFuncArg:!0,parentFuncs:e}))}}])}(ve.Component);function pE(e,t,r){return t=eo(t),Zn(e,fE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function fE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(fE=function(){return!!e})()}dE.propTypes={funcKey:$y().string.isRequired,argKey:$y().string.isRequired,setValue:$y().func.isRequired,setValueSrc:$y().func.isRequired,readonly:$y().bool,isLHS:$y().bool,parentFuncs:$y().array,id:$y().string,groupId:$y().string};var hE=function(e){function t(e){var r;return Gn(this,t),(r=pE(this,t,[e])).renderField=function(){var e=r.props,t=e.config,n=e.classname,o=e.selectedField,i=e.selectedFieldSrc,a=e.selectedFieldType,s=e.setField,l=e.setFuncValue,u=e.parentField,c=e.readonly,d=e.id,p=e.groupId,f=e.fieldError,h=e.valueError;if(!["func","field"].includes(i))return"?";var g="func"===i?ye().createElement(cE,{isLHS:!0,config:t,value:o,fieldSrc:i,fieldType:a,fieldError:f,valueError:h,parentField:u,setValue:s,setFuncValue:l,readonly:c,id:d,groupId:p,key:"field-func-"+d}):ye().createElement(mO,{config:t,selectedField:o,selectedFieldSrc:i,selectedFieldType:a,parentField:u,setField:s,customProps:t.settings.customFieldSelectProps,readonly:c,id:d,groupId:p,key:"field-"+d}),v="func"===i?t.settings.funcLabel:t.settings.fieldLabel,m=t.settings.showLabels&&"func"!==i&&ye().createElement("label",{className:"rule--label"},v);return ye().createElement("div",{key:i,className:n},m,g)},r.renderFieldSources=function(){if(!r.meta)return null;var e=r.props,t=e.config,n=e.readonly,o=e.selectedFieldSrc,i=e.setFieldSrc,a=e.id,s=r.meta.fieldSourcesOptions,l=t.settings,u=r.ValueSources,c=l.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return s.length>1&&!n&&ye().createElement("div",{key:"fieldsrc",className:"rule--fieldsrc"},c,ye().createElement(u,{key:"fieldsrc-"+a,valueSources:s,valueSrc:o,config:t,setValueSrc:i,readonly:n,title:l.fieldSourcesPopupTitle}))},fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config);if((!this.meta||["config"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r){var n=e.config,o=n.settings.renderValueSources;this.ValueSources=function(e){return o(e,n.ctx)}}}},{key:"getMeta",value:function(e){var t=e.config.settings,r=t.valueSourcesInfo;return{fieldSourcesOptions:t.fieldSources.map((function(e){return[e,{label:r[e].label}]}))}}},{key:"render",value:function(){var e=this.props,t=(e.classname,e.canSelectFieldSource),r=t&&this.renderFieldSources(),n=this.renderField();return t?ye().createElement(eO,{className:"rule--field-wrapper"},r,n):n}}])}(ve.Component),gE=["factory"];function vE(e,t,r){return t=eo(t),Zn(e,mE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function mE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(mE=function(){return!!e})()}var yE=By.ConfigUtils.getOperatorConfig,bE=function(e){function t(){return Gn(this,t),vE(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){if(!this.props.selectedOperator)return null;var e=yE(this.props.config,this.props.selectedOperator,this.props.selectedField);if(void 0===e.options)return null;var t=e.options,r=t.factory,n=nm(t,gE),o=r(Object.assign({},n,{config:this.props.config,field:this.props.selectedField,fieldSrc:this.props.selectedFieldSrc,operator:this.props.selectedOperator,options:this.props.operatorOptions,setOption:this.props.setOperatorOption,readonly:this.props.readonly}),this.props.config.ctx),i=this.props.selectedOperator;return ye().createElement("div",{className:"rule--operator rule--operator--".concat(i.toUpperCase())},o)}}])}(ve.PureComponent);function OE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function EE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?OE(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):OE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function SE(e,t,r){return t=eo(t),Zn(e,wE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function wE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(wE=function(){return!!e})()}bE.propTypes={config:$y().object.isRequired,operatorOptions:$y().any.isRequired,selectedField:$y().any,selectedFieldSrc:$y().string,selectedOperator:$y().string.isRequired,readonly:$y().bool,setOperatorOption:$y().func.isRequired};var TE=By.ConfigUtils,xE=TE.getFieldConfig,_E=TE.getOperatorConfig,CE=TE.getFieldWidgetConfig,RE=TE.getFieldId,IE=By.RuleUtils.isEmptyRuleProperties,AE=function(e){function t(e){var r;return Gn(this,t),r=SE(this,t,[e]),fb(r),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props,n=!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if((!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","selectedOperator","config","reordableNodesCnt","isLocked"].map((function(t){return e[t]!==r[t]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),n){var o=e.config,i=o.settings,a=i.renderIcon,s=i.renderButton,l=i.renderButtonGroup,u=i.renderSwitch,c=i.renderBeforeWidget,d=i.renderAfterWidget,p=i.renderRuleError;this.Icon=iO(o,a),this.Btn=iO(o,s),this.BtnGrp=iO(o,l),this.Switch=iO(o,u),this.BeforeWidget=iO(o,c),this.AfterWidget=iO(o,d),this.RuleError=iO(o,p)}this.doRemove=function(){t.props.removeSelf()}}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.selectedOperator,o=e.config,i=e.reordableNodesCnt,a=e.isLocked,s=o.settings.keepInputOnChangeFieldSrc,l=RE(t,o),u=xE(o,t),c=u&&"!struct"===u.type,d=!!t||s&&r,p=d&&n,f=_E(o,n,t),h=f&&null!=f.options,g=CE(o,t,n,null,null)||{},v=g.hideOperator;return{selectedFieldId:l,selectedFieldWidgetConfig:g,showDragIcon:o.settings.canReorder&&i>1&&!a,showOperator:d&&!v,showOperatorLabel:d&&v&&g.operatorInlineLabel,showWidget:p&&!c,showOperatorOptions:p&&h}}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeRuleConfirmOptions;i&&!this.isEmptyCurrentRule()?o.call(r.ctx,EE(EE({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"_buildWidgetProps",value:function(e,t){var r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.operatorOptions,s=e.value,l=e.valueType,u=e.valueSrc,c=e.asyncListValues,d=e.valueError,p=e.fieldError,f=e.parentField;return{field:r,fieldSrc:n,fieldType:o,fieldId:t.selectedFieldId,operator:i,operatorOptions:a,value:s,valueType:l,valueSrc:u,asyncListValues:c,valueError:d,fieldError:p,parentField:f}}},{key:"isEmptyCurrentRule",value:function(){var e=this.props.config,t=this._buildWidgetProps(this.props,this.meta);return IE(t,e)}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.parentField,o=e.groupId,i=e.id,a=e.selectedFieldSrc,s=e.selectedField,l=e.selectedFieldType,u=e.setField,c=e.setFuncValue,d=e.setFieldSrc,p=e.fieldError,f=t.settings.immutableFieldsMode,h=this.meta.selectedFieldId;return ye().createElement(hE,{key:"field",classname:Ib()("func"==a?"rule--field--func":"rule--field"),config:t,canSelectFieldSource:!n,selectedField:s,selectedFieldSrc:a,selectedFieldType:l,selectedFieldId:h,fieldError:p,setField:f?tO:u,setFuncValue:f?tO:c,setFieldSrc:f?tO:d,parentField:n,readonly:f||r,id:i,groupId:o})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta,o=n.selectedFieldId,i=n.selectedFieldWidgetConfig,a=n.showOperator,s=n.showOperatorLabel,l=t.settings.immutableOpsMode;return ye().createElement(lO,{key:"operator",config:t,selectedField:this.props.selectedField,selectedFieldSrc:this.props.selectedFieldSrc,selectedFieldType:this.props.selectedFieldType,selectedFieldId:o,selectedOperator:this.props.selectedOperator,setOperator:l?tO:this.props.setOperator,showOperator:a,showOperatorLabel:s,selectedFieldWidgetConfig:i,readonly:l||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta.showWidget,o=t.settings.immutableValuesMode;if(!n)return null;var i=ye().createElement(iE,Cb({key:"values"},this._buildWidgetProps(this.props,this.meta),{config:t,setValue:o?tO:this.props.setValue,setValueSrc:o?tO:this.props.setValueSrc,setFuncValue:o?tO:this.props.setFuncValue,readonly:o||r,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(eO,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},i)}},{key:"renderOperatorOptions",value:function(){var e=this.props.config,t=this.meta.showOperatorOptions,r=e.settings,n=r.immutableOpsMode,o=r.immutableValuesMode;if(!t)return null;var i=ye().createElement(bE,{key:"operatorOptions",selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,operatorOptions:this.props.operatorOptions,setOperatorOption:n?tO:this.props.setOperatorOption,config:e,readonly:o});return ye().createElement(eO,{key:"op-options-for-"+this.props.selectedOperator,className:"rule--operator-options"},i)}},{key:"renderBeforeWidget",value:function(){var e=this.BeforeWidget;return e?ye().createElement(eO,{key:"before-widget-for-"+this.props.selectedOperator,className:"rule--before-widget"},ye().createElement(e,this.props)):null}},{key:"renderAfterWidget",value:function(){var e=this.AfterWidget;return e?ye().createElement(eO,{key:"after-widget-for-"+this.props.selectedOperator,className:"rule--after-widget"},ye().createElement(e,this.props)):null}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=e.fieldError,o=t.settings.showErrorMessage,i=this.RuleError,a=[n].concat(co((null==r?void 0:r.toArray())||[])).filter((function(e){return!!e})).shift()||null;return o&&a&&ye().createElement("div",{className:"rule--error"},i?ye().createElement(i,{error:a}):a)}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.meta.showDragIcon,r=this.Icon,n=ye().createElement(r,{type:"drag"});return t&&ye().createElement("div",{key:"rule-drag-icon",onMouseDown:e,className:"qb-drag-handler rule--drag-handler"},n)}},{key:"renderDel",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings,o=n.deleteLabel,i=n.immutableGroupsMode,a=n.canDeleteLocked,s=this.Icon,l=this.Btn;return!i&&(!r||r&&a)&&ye().createElement(l,{key:"rule-del",type:"delRule",onClick:this.removeSelf,label:o,config:t,renderIcon:s})}},{key:"renderLock",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.isTrueLocked,o=e.id,i=t.settings,a=i.lockLabel,s=i.lockedLabel,l=i.showLock,u=this.Switch;return l&&!(r&&!n)&&ye().createElement(u,{key:"rule-lock",type:"lock",id:o,value:r,setValue:this.setLock,label:a,checkedLabel:s,hideLabel:!0,config:t})}},{key:"render",value:function(){var e=this.meta,t=e.showOperatorOptions,r=e.selectedFieldWidgetConfig,n=this.props,o=n.valueSrc,i=n.value,a=n.config,s="value"==(null==o?void 0:o.first())&&!t&&1==i.size&&r.fullWidth,l=this.BtnGrp,u=[this.renderField(),this.renderOperator(),this.renderBeforeWidget(),this.renderWidget(),this.renderAfterWidget(),this.renderOperatorOptions()],c=ye().createElement("div",{key:"rule-body",className:Ib()("rule--body",s&&"can--shrink--value")},u),d=this.renderError(),p=this.renderDrag(),f=this.renderLock(),h=this.renderDel();return ye().createElement(ye().Fragment,null,p,ye().createElement("div",{key:"rule-body-wrapper",className:"rule--body--wrapper"},c,d),ye().createElement("div",{key:"rule-header-wrapper",className:"rule--header"},ye().createElement(l,{key:"rule-header-group",config:a},f,h)))}}])}(ve.Component);AE.propTypes={id:$y().string.isRequired,groupId:$y().string,selectedField:$y().any,selectedFieldSrc:$y().string,selectedFieldType:$y().string,selectedOperator:$y().string,operatorOptions:$y().object,config:$y().object.isRequired,value:$y().any,valueSrc:$y().any,valueType:$y().any,asyncListValues:$y().array,isDraggingMe:$y().bool,isDraggingTempo:$y().bool,parentField:$y().string,valueError:$y().any,fieldError:$y().string,isLocked:$y().bool,isTrueLocked:$y().bool,handleDraggerMouseDown:$y().func,setField:$y().func,setFieldSrc:$y().func,setOperator:$y().func,setOperatorOption:$y().func,setLock:$y().func,removeSelf:$y().func,setValue:$y().func,setValueSrc:$y().func,setFuncValue:$y().func,reordableNodesCnt:$y().number,totalRulesCnt:$y().number,parentReordableNodesCnt:$y().number};const jE=function(e){var t=(0,Gy.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:Hy})(function(e){var t;return t=function(t){function r(e){var t;return Gn(this,r),(t=Ab(this,r,[e])).dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeRule(t.props.path)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.setField=function(e,r,n){t.props.actions.setField(t.props.path,e,r,n)},t.setFieldSrc=function(e){t.props.actions.setFieldSrc(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setOperatorOption=function(e,r){t.props.actions.setOperatorOption(t.props.path,e,r)},t.setValue=function(e,r,n,o,i){t.props.actions.setValue(t.props.path,e,r,n,o,i)},t.setValueSrc=function(e,r,n){t.props.actions.setValueSrc(t.props.path,e,r,n)},t.setFuncValue=function(e,r,n,o,i,a,s){t.props.actions.setFuncValue(t.props.path,e,r,n,o,i,a,s)},t.pureShouldComponentUpdate=pb(t),t.dummyFn.isDummyFn=!0,t}return ro(r,t),Qn(r,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=Pb(this.props.config,this.props.field),n=this.props.fieldType||(null==r?void 0:r.type)||null,o=this.props.config.settings.showErrorMessage,i=(r&&r.type,!t&&this.props.isDraggingTempo),a=this.props,s=a.valueError,l=null!=([a.fieldError].concat(co((null==s?void 0:s.toArray())||[])).filter((function(e){return!!e})).shift()||null)&&o;return ye().createElement("div",{className:Ib()("group-or-rule-container","rule-container",l?"rule-with-error":null),"data-id":this.props.id},[t?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,setField:this.dummyFn,setFieldSrc:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setOperatorOption:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:i,onDragStart:this.props.onDragStart,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,setField:i?this.dummyFn:this.setField,setFieldSrc:i?this.dummyFn:this.setFieldSrc,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setOperatorOption:i?this.dummyFn:this.setOperatorOption,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ve.Component),t.propTypes={id:$y().string.isRequired,groupId:$y().string,config:$y().object.isRequired,path:$y().any.isRequired,operator:$y().string,field:$y().any,fieldSrc:$y().string,fieldType:$y().string,actions:$y().object.isRequired,onDragStart:$y().func,value:$y().any,valueSrc:$y().any,asyncListValues:$y().array,valueError:$y().any,fieldError:$y().string,operatorOptions:$y().object,reordableNodesCnt:$y().number,parentField:$y().string,isLocked:$y().bool,isTrueLocked:$y().bool,dragging:$y().object,isDraggingTempo:$y().bool},t}(e));return t.displayName="ConnectedRuleContainer",t}(Bb("rule")(nO(AE)));var PE=v(3547),LE=v.n(PE);function kE(e,t,r){return t=eo(t),Zn(e,NE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function NE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(NE=function(){return!!e})()}var DE=By.DefaultUtils.defaultGroupConjunction;const FE=function(e,t){var r=(0,Gy.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:Hy})(function(e,t){var r;return r=function(r){function n(e){var r;return Gn(this,n),(r=kE(this,n,[e]))._selectedConjunction=function(e){return(e=e||r.props).conjunction||DE(e.config,e.field)},r.setConjunction=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setConjunction(r.props.path,e)},r.setNot=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setNot(r.props.path,e)},r.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setLock(r.props.path,e)},r.dummyFn=function(){},r.removeSelf=function(){r.props.actions.removeGroup(r.props.path)},r.addGroup=function(){r.props.actions.addGroup(r.props.path)},r.addCaseGroup=function(){r.props.actions.addCaseGroup(r.props.path)},r.addDefaultCaseGroup=function(){r.props.actions.addDefaultCaseGroup(r.props.path)},r.addRule=function(){var e="rule_group"==t?r.props.field:null;r.props.actions.addRule(r.props.path,void 0,void 0,void 0,e)},r.setField=function(e,t,n){r.props.actions.setField(r.props.path,e,t,n)},r.setOperator=function(e){r.props.actions.setOperator(r.props.path,e)},r.setValue=function(e,t,n,o,i){r.props.actions.setValue(r.props.path,e,t,n,o,i)},r.setValueSrc=function(e,t,n){r.props.actions.setValueSrc(r.props.path,e,t,n)},r.setFuncValue=function(e,t,n,o,i,a,s){r.props.actions.setFuncValue(r.props.path,e,t,n,o,i,a,s)},r.pureShouldComponentUpdate=pb(r),fb(r),r.selectedConjunction=r._selectedConjunction(e),r.conjunctionOptions=r._getConjunctionOptions(e),r.dummyFn.isDummyFn=!0,r}return ro(n,r),Qn(n,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"onPropsChanged",value:function(e){var t=e.config,r=(e.id,e.conjunction),n=this.props.config,o=this.props.conjunction;n==t&&o==r||(this.selectedConjunction=this._selectedConjunction(e),this.conjunctionOptions=this._getConjunctionOptions(e))}},{key:"_getConjunctionOptions",value:function(e){var t=this;return ly()(e.config.conjunctions,(function(r,n){return{id:"conjunction-".concat(e.id,"-").concat(n),name:"conjunction[".concat(e.id,"]"),key:n,label:r.label,checked:n===t._selectedConjunction(e)}}))}},{key:"render",value:function(){var t=this.props.config.settings.showErrorMessage,r=this.props.dragging.id==this.props.id,n=this.props.path.size,o=this.props.config.settings.maxNesting,i=!r&&this.props.isDraggingTempo,a=this.props.fieldType||null,s=this.props.valueError,l=null!=(co((null==s?void 0:s.toArray())||[]).filter((function(e){return!!e})).shift()||null)&&t,u=void 0===o||n<o,c=1==n;return ye().createElement("div",{className:Ib()("group-or-rule-container","group-container",l?"group-with-error":null),"data-id":this.props.id},[r?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:this.dummyFn,setNot:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,addGroup:this.dummyFn,addCaseGroup:this.dummyFn,addDefaultCaseGroup:this.dummyFn,addRule:this.dummyFn,setField:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:r,isDraggingTempo:i,onDragStart:this.props.onDragStart,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:i?this.dummyFn:this.setConjunction,setNot:i?this.dummyFn:this.setNot,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,addGroup:i?this.dummyFn:this.addGroup,addCaseGroup:i?this.dummyFn:this.addCaseGroup,addDefaultCaseGroup:i?this.dummyFn:this.addDefaultCaseGroup,addRule:i?this.dummyFn:this.addRule,setField:i?this.dummyFn:this.setField,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ve.Component),r.propTypes={config:$y().object.isRequired,actions:$y().object.isRequired,path:$y().any.isRequired,id:$y().string.isRequired,groupId:$y().string,not:$y().bool,conjunction:$y().string,children1:$y().any,onDragStart:$y().func,reordableNodesCnt:$y().number,field:$y().any,fieldSrc:$y().string,fieldType:$y().string,parentField:$y().string,value:$y().any,valueSrc:$y().any,valueError:$y().any,isLocked:$y().bool,isTrueLocked:$y().bool,dragging:$y().object,isDraggingTempo:$y().bool},r}(e,t));return r.displayName="ConnectedGroupContainer",r};function ME(e,t,r){return t=eo(t),Zn(e,VE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function VE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(VE=function(){return!!e})()}var UE={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},BE=function(e){function t(){return Gn(this,t),ME(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.removeSelf,i=e.setLock,a=e.isLocked,s=e.isTrueLocked,l=e.id,u=e.canAddGroup,c=e.canAddRule,d=e.canDeleteGroup,p=t.settings,f=p.immutableGroupsMode,h=p.addRuleLabel,g=p.addGroupLabel,v=p.delGroupLabel,m=p.groupActionsPosition,y=p.renderButton,b=p.renderIcon,O=p.renderSwitch,E=p.renderButtonGroup,S=p.lockLabel,w=p.lockedLabel,T=p.showLock,x=p.canDeleteLocked,_=function(e){return b(e,t.ctx)},C=function(e){return y(e,t.ctx)},R=function(e){return O(e,t.ctx)},I=function(e){return E(e,t.ctx)},A=UE[m||"topRight"],j=T&&!(a&&!s)&&ye().createElement(R,{type:"lock",id:l,value:a,setValue:i,label:S,checkedLabel:w,config:t}),P=!f&&c&&!a&&ye().createElement(C,{type:"addRule",onClick:r,label:h,readonly:a,config:t,renderIcon:_}),L=!f&&u&&!a&&ye().createElement(C,{type:"addGroup",onClick:n,label:g,readonly:a,config:t,renderIcon:_}),k=!f&&d&&(!a||a&&x)&&ye().createElement(C,{type:"delGroup",onClick:o,label:v,config:t,renderIcon:_});return ye().createElement("div",{className:"group--actions ".concat(A)},ye().createElement(I,{config:t},j,P,L,k))}}])}(ve.PureComponent);function zE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function $E(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?zE(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):zE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function WE(e,t,r){return t=eo(t),Zn(e,HE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function HE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(HE=function(){return!!e})()}var qE=By.RuleUtils.isEmptyGroupChildren,GE=function(e){function t(e){var r;return Gn(this,t),(r=WE(this,t,[e])).childrenClassName=function(){return""},r.renderBeforeActions=function(){var e=r.BeforeActions;return null==e?null:ye().createElement(e,Cb({key:"group-actions-before"},r.props))},r.renderAfterActions=function(){var e=r.AfterActions;return null==e?null:ye().createElement(e,Cb({key:"group-actions-after"},r.props))},fb(r),r.onPropsChanged(e),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.renderItem=r.renderItem.bind(r),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props;if(!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config)){var n=e.config,o=n.settings,i=o.renderIcon,a=o.renderConjs,s=o.renderBeforeActions,l=o.renderAfterActions;this.Icon=iO(n,i),this.Conjs=iO(n,a),this.BeforeActions=iO(n,s),this.AfterActions=iO(n,l)}this.doRemove=function(){t.props.removeSelf()}}},{key:"isGroupTopPosition",value:function(){return LE()(this.props.config.settings.groupActionsPosition||"topRight","top")}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeGroupConfirmOptions;i&&!this.isEmptyCurrentGroup()?o.call(r.ctx,$E($E({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config;return qE(t,r)}},{key:"showNot",value:function(){return this.props.config.settings.showNot}},{key:"showConjs",value:function(){var e=this.props,t=e.conjunctionOptions;return e.children1,e.config,Object.keys(t).length>1||this.showNot()}},{key:"isNoChildren",value:function(){var e=this.props.children1;return!e||0==e.size}},{key:"isOneChild",value:function(){var e=this.props.children1;return!e||e.size<2}},{key:"renderChildrenWrapper",value:function(){return this.props.children1&&ye().createElement("div",{key:"group-children",className:Ib()("group--children",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isOneChild()?"one--child":"",this.childrenClassName())},this.renderChildren())}},{key:"renderHeaderWrapper",value:function(){var e=this.isGroupTopPosition();return ye().createElement("div",{key:"group-header",className:Ib()("group--header",this.isOneChild()?"one--child":"",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"")},this.renderHeader(),e&&this.renderBeforeActions(),e&&this.renderActions(),e&&this.renderAfterActions())}},{key:"renderFooterWrapper",value:function(){return!this.isGroupTopPosition()&&ye().createElement("div",{key:"group-footer",className:"group--footer"},this.renderBeforeActions(),this.renderActions(),this.renderAfterActions())}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(BE,{key:"group-actions",config:t,addRule:r,addGroup:n,canAddGroup:this.canAddGroup(),canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"canAddGroup",value:function(){return this.props.allowFurtherNesting}},{key:"canAddRule",value:function(){var e=this.props.config.settings.maxNumberOfRules,t=this.props.totalRulesCnt;return!e||t<e}},{key:"canDeleteGroup",value:function(){return!this.props.isRoot}},{key:"renderChildren",value:function(){var e=this.props.children1;return e?e.valueSeq().toArray().map(this.renderItem):null}},{key:"renderItem",value:function(e){if(e){var t=this.props,r=t.config,n=t.actions,o=t.onDragStart,i=t.isLocked,a="group"==e.get("type")&&null!=e.getIn(["properties","field"])?"rule_group":e.get("type");return ye().createElement(WS,Cb({},this.extraPropsForItem(e),{key:e.get("id"),id:e.get("id"),groupId:t.id,path:e.get("path"),type:a,properties:e.get("properties"),config:r,actions:n,children1:e.get("children1"),reordableNodesCnt:this.reordableNodesCntForItem(e),totalRulesCnt:this.totalRulesCntForItem(e),parentReordableNodesCnt:this.reordableNodesCnt(),onDragStart:o,isDraggingTempo:this.props.isDraggingTempo,isParentLocked:i}))}}},{key:"extraPropsForItem",value:function(e){return{}}},{key:"reordableNodesCnt",value:function(){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.reordableNodesCnt()}},{key:"showDragIcon",value:function(){var e=this.props,t=e.config,r=e.isRoot,n=e.isLocked,o=this.reordableNodesCnt();return t.settings.canReorder&&!r&&o>1&&!n}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.Icon,r=ye().createElement(t,{type:"drag"});return this.showDragIcon()&&ye().createElement("div",{key:"group-drag-icon",onMouseDown:e,className:"qb-drag-handler group--drag-handler"},r)}},{key:"conjunctionOptions",value:function(){return this.props.conjunctionOptions}},{key:"renderConjs",value:function(){var e=this.props,t=e.config,r=e.children1,n=e.id,o=e.selectedConjunction,i=e.setConjunction,a=e.not,s=e.setNot,l=e.isLocked,u=t.settings,c=u.immutableGroupsMode,d=(u.renderConjs,u.showNot,u.notLabel),p=this.conjunctionOptions();if(!this.showConjs())return null;if(!r||!r.size)return null;var f={disabled:this.isOneChild(),readonly:c||l,selectedConjunction:o,setConjunction:c?tO:i,conjunctionOptions:p,config:t,not:a||!1,id:n,setNot:c?tO:s,notLabel:d,showNot:this.showNot(),isLocked:l},h=this.Conjs;return ye().createElement(h,Cb({key:"group-conjs"},f))}},{key:"renderHeader",value:function(){return ye().createElement("div",{key:"group-conjunctions",className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"render",value:function(){return ye().createElement(ye().Fragment,null,this.renderHeaderWrapper(),this.renderChildrenWrapper(),this.renderFooterWrapper())}}])}(ve.Component);GE.propTypes={reordableNodesCnt:$y().number,conjunctionOptions:$y().object.isRequired,allowFurtherNesting:$y().bool.isRequired,isRoot:$y().bool.isRequired,not:$y().bool,selectedConjunction:$y().string,config:$y().object.isRequired,id:$y().string.isRequired,groupId:$y().string,path:$y().any,children1:$y().any,isDraggingMe:$y().bool,isDraggingTempo:$y().bool,isLocked:$y().bool,isTrueLocked:$y().bool,handleDraggerMouseDown:$y().func,onDragStart:$y().func,addRule:$y().func.isRequired,addGroup:$y().func.isRequired,removeSelf:$y().func.isRequired,setConjunction:$y().func.isRequired,setNot:$y().func.isRequired,setLock:$y().func.isRequired,actions:$y().object.isRequired};const KE=FE(Bb("group")(nO(GE)),"group");function YE(){return YE="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,r){var n=function(e,t){for(;!{}.hasOwnProperty.call(e,t)&&null!==(e=eo(e)););return e}(e,t);if(n){var o=Object.getOwnPropertyDescriptor(n,t);return o.get?o.get.call(arguments.length<3?e:r):o.value}},YE.apply(null,arguments)}function XE(e,t,r){return t=eo(t),Zn(e,QE()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function QE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(QE=function(){return!!e})()}var JE=function(e){function t(){return Gn(this,t),XE(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addRuleLabel,f=c.delGroupLabel,h=c.renderButton,g=c.renderIcon,v=c.renderSwitch,m=c.renderButtonGroup,y=c.lockLabel,b=c.lockedLabel,O=c.showLock,E=c.canDeleteLocked,S=function(e){return g(e,t.ctx)},w=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},x=function(e){return m(e,t.ctx)},_=O&&!(s&&!l)&&ye().createElement(T,{type:"lock",id:u,value:s,setValue:a,label:y,checkedLabel:b,hideLabel:!0,config:t}),C=!d&&n&&!s&&ye().createElement(w,{type:"addRuleGroup",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),R=!d&&o&&(!s||s&&E)&&ye().createElement(w,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions"},ye().createElement(x,{config:t},_,C,R))}}])}(ve.PureComponent);function ZE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function eS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ZE(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ZE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function tS(e,t,r){return t=eo(t),Zn(e,rS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function rS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(rS=function(){return!!e})()}var nS=function(e){function t(e){var r;return Gn(this,t),(r=tS(this,t,[e])).childrenClassName=function(){return"rule_group--children"},r.renderHeaderWrapper=function(){return null},r.renderFooterWrapper=function(){return null},r.renderConjs=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!1},r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){YE(eo(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"renderChildrenWrapper",value:function(){return ye().createElement(ye().Fragment,null,this.renderDrag(),this.renderField(),this.renderActions(),YE(eo(t.prototype),"renderChildrenWrapper",this).call(this))}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFuncValue,s=e.setFieldSrc,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(hE,{key:"field",classname:"group--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:a,setFieldSrc:s,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(JE,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(GE);nS.propTypes=eS(eS({},GE.propTypes),{},{selectedField:$y().any,selectedFieldSrc:$y().string,parentField:$y().string,setField:$y().func,setFieldSrc:$y().func});const oS=FE(Bb("group rule_group")(nO(nS)),"rule_group");function iS(e,t,r){return t=eo(t),Zn(e,aS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function aS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(aS=function(){return!!e})()}var sS=function(e){function t(){return Gn(this,t),iS(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addSubRuleLabel,f=c.delGroupLabel,h=c.renderButton,g=c.renderIcon,v=c.renderSwitch,m=c.renderButtonGroup,y=c.lockLabel,b=c.lockedLabel,O=c.showLock,E=c.canDeleteLocked,S=function(e){return g(e,t.ctx)},w=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},x=function(e){return m(e,t.ctx)},_=O&&!(s&&!l)&&ye().createElement(T,{type:"lock",id:u,value:s,setValue:a,label:y,checkedLabel:b,config:t}),C=!d&&n&&!s&&ye().createElement(w,{type:"addRuleGroupExt",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),R=!d&&o&&(!s||s&&E)&&ye().createElement(w,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions group--actions--tr"},ye().createElement(x,{config:t},_,C,R))}}])}(ve.PureComponent);function lS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function uS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?lS(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):lS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function cS(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function dS(e,t,r){return t=eo(t),Zn(e,pS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function pS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(pS=function(){return!!e})()}var fS=By.ConfigUtils,hS=fS.getFieldConfig,gS=fS.getFieldWidgetConfig,vS=By.RuleUtils.isEmptyRuleGroupExtPropertiesAndChildren,mS=function(e){function t(e){var r;return Gn(this,t),(r=dS(this,t,[e])).childrenClassName=function(){return"rule_group_ext--children"},r.renderFooterWrapper=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!0},r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){YE(eo(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:Ib()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderGroupField(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderGroupField",value:function(){return ye().createElement("div",{className:"group--field--count--rule"},this.renderField(),this.renderOperator(),this.renderWidget(),this.renderError())}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings,o=n.renderRuleError,i=n.showErrorMessage,a=co((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return i&&a&&ye().createElement("div",{className:"rule_group--error"},o?o({error:a},t.ctx):a)}},{key:"showNot",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,hS(t,r)||{});return null!=n.showNot?n.showNot:t.settings.showNot}},{key:"conjunctionOptions",value:function(){var e=this.props,r=e.config,n=e.selectedField,o=(e.selectedOperator,hS(r,n)||{}),i=YE(eo(t.prototype),"conjunctionOptions",this).call(this);if(o.conjunctions){var a,s={},l=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return cS(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?cS(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(o.conjunctions);try{for(l.s();!(a=l.n()).done;){var u=a.value,c=i[u];c&&(s[u]=c)}}catch(e){l.e(e)}finally{l.f()}i=s}return i}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFieldSrc,s=e.setFuncValue,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(hE,{key:"field",classname:"rule--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:s,setFieldSrc:a,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedOperator,i=(e.setField,e.setOperator),a=e.isLocked,s=t.settings.immutableFieldsMode,l=gS(t,r,o)||{},u=l.hideOperator,c=r&&u&&l.operatorInlineLabel,d=r&&!u;return ye().createElement(lO,{key:"operator",classname:"group--operator",config:t,selectedField:r,selectedFieldSrc:n,selectedOperator:o,setOperator:i,showOperator:d,showOperatorLabel:c,selectedFieldWidgetConfig:l,readonly:s||a,id:this.props.id,groupId:this.props.groupId})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config,n=this._buildWidgetProps(this.props);return vS(n,t,r)}},{key:"_buildWidgetProps",value:function(e){var t=e.selectedField,r=e.selectedFieldSrc,n=e.selectedFieldType,o=e.selectedOperator,i=e.operatorOptions,a=e.value,s=e.valueType,l=(e.valueSrc,e.asyncListValues,e.valueError);return e.fieldError,{field:t,fieldSrc:r,fieldType:n,operator:o,operatorOptions:i,value:a,valueType:s,valueSrc:["value"],valueError:l,fieldError:null,parentField:e.parentField}}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.isLocked,i=t.settings.immutableValuesMode;if(!r||!n)return null;var a=ye().createElement(iE,Cb({key:"values",isForRuleGroup:!0},this._buildWidgetProps(this.props),{config:t,setValue:i?tO:this.props.setValue,setValueSrc:tO,readonly:i||o,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(eO,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(sS,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(GE);mS.propTypes=uS(uS({},GE.propTypes),{},{selectedField:$y().any,selectedFieldSrc:$y().string,selectedOperator:$y().string,value:$y().any,parentField:$y().string,setField:$y().func,setFieldSrc:$y().func,setOperator:$y().func,setValue:$y().func,valueError:$y().any});const yS=FE(Bb("group rule_group_ext")(nO(mS)),"rule_group");function bS(e,t,r){return t=eo(t),Zn(e,OS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function OS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(OS=function(){return!!e})()}var ES={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},SS=function(e){function t(){return Gn(this,t),bS(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.setLock,i=e.isLocked,a=e.isTrueLocked,s=e.id,l=e.canAddGroup,u=e.canAddDefault,c=t.settings,d=c.immutableGroupsMode,p=c.addCaseLabel,f=c.addDefaultCaseLabel,h=c.groupActionsPosition,g=c.renderButton,v=c.renderIcon,m=c.renderSwitch,y=c.renderButtonGroup,b=c.lockLabel,O=c.lockedLabel,E=c.showLock,S=function(e){return v(e,t.ctx)},w=function(e){return g(e,t.ctx)},T=function(e){return m(e,t.ctx)},x=function(e){return y(e,t.ctx)},_=ES[h||"topRight"],C=E&&!(i&&!a)&&ye().createElement(T,{type:"lock",id:s,value:i,setValue:o,label:b,checkedLabel:O,config:t}),R=!d&&l&&!i&&ye().createElement(w,{type:"addCaseGroup",onClick:r,label:p,readonly:i,config:t,renderIcon:S}),I=!d&&u&&!i&&ye().createElement(w,{type:"addDefaultCaseGroup",onClick:n,label:f,readonly:i,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions ".concat(_)},ye().createElement(x,{config:t},C,R,I))}}])}(ve.PureComponent);function wS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function TS(e,t,r){return t=eo(t),Zn(e,xS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function xS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(xS=function(){return!!e})()}var _S=By.TreeUtils,CS=_S.getTotalReordableNodesCountInTree,RS=_S.getTotalRulesCountInTree,IS=function(e){function t(e){var r;return Gn(this,t),(r=TS(this,t,[e])).childrenClassName=function(){return"switch_group--children"},r.renderFooterWrapper=function(){return null},r.hasDefaultCase=function(){var e;return(null===(e=r.props.children1)||void 0===e?void 0:e.size)&&r.props.children1.filter((function(e){return null==e.get("children1")})).size>0},r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){YE(eo(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"canAddGroup",value:function(){var e,t=this.props.config.settings.maxNumberOfCases,r=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return!t||r<t}},{key:"canAddRule",value:function(){return!1}},{key:"reordableNodesCnt",value:function(){var e,t=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return this.hasDefaultCase()&&t--,t}},{key:"totalRulesCntForItem",value:function(e){return RS(e)}},{key:"reordableNodesCntForItem",value:function(e){var t;if(this.props.isLocked)return 0;var r=this.props.config.settings,n=r.canLeaveEmptyCase,o=r.canRegroupCases,i=(null===(t=this.props.children1)||void 0===t?void 0:t.size)||0;this.hasDefaultCase()&&i--;var a=CS(e);return 1==a&&o&&n&&i>1&&(a=111),a}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:Ib()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag")},this.renderHeader(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderConjs",value:function(){return this.props.config.settings.renderSwitchPrefix||null}},{key:"showNot",value:function(){return!1}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(SS,{config:t,addCaseGroup:r,addDefaultCaseGroup:n,canAddDefault:!this.hasDefaultCase(),canAddGroup:this.canAddGroup(),setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}}])}(GE);IS.propTypes=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?wS(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):wS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},GE.propTypes);const AS=FE(Bb("group switch_group")(nO(IS)),"switch_group");function jS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function PS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?jS(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):jS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function LS(e,t,r){return t=eo(t),Zn(e,kS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function kS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(kS=function(){return!!e})()}var NS=function(e){function t(e){var r;return Gn(this,t),(r=LS(this,t,[e])).childrenClassName=function(){return"case_group--children"},r.renderFooterWrapper=function(){return null},r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var r=this.props,n=!this.renderBeforeCaseValue||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if(YE(eo(t.prototype),"onPropsChanged",this).call(this,e),n){var o=e.config,i=o.settings,a=i.renderBeforeCaseValue,s=i.renderAfterCaseValue,l=i.renderRuleError;this.BeforeCaseValue=iO(o,a),this.AfterCaseValue=iO(o,s),this.RuleError=iO(o,l)}}},{key:"isDefaultCase",value:function(){return null==this.props.children1}},{key:"reordableNodesCnt",value:function(){return this.props.parentReordableNodesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"showDragIcon",value:function(){return!this.isDefaultCase()&&YE(eo(t.prototype),"showDragIcon",this).call(this)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:Ib()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeaderLeft(),this.renderHeaderCenter(),this.renderActions())}},{key:"renderChildrenWrapper",value:function(){return this.isDefaultCase()?null:ye().createElement("div",{className:"case_group--body"},this.renderCondition(),this.renderBeforeValue(),this.renderValue(),this.renderAfterValue())}},{key:"renderHeaderLeft",value:function(){return this.isDefaultCase()?this.props.config.settings.defaultCaseLabel||"":ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag(),this.renderError())}},{key:"renderCondition",value:function(){return this.isDefaultCase()?null:YE(eo(t.prototype),"renderChildrenWrapper",this).call(this)}},{key:"renderHeaderCenter",value:function(){return this.isDefaultCase()?ye().createElement("div",null,this.renderValue(),this.renderError()):null}},{key:"canAddGroup",value:function(){return!this.isDefaultCase()&&YE(eo(t.prototype),"canAddGroup",this).call(this)}},{key:"canAddRule",value:function(){return!this.isDefaultCase()&&YE(eo(t.prototype),"canAddRule",this).call(this)}},{key:"renderBeforeValue",value:function(){var e=this.BeforeCaseValue;return null==e?null:ye().createElement(e,Cb({key:"values-before"},this.props))}},{key:"renderAfterValue",value:function(){var e=this.AfterCaseValue;return null==e?null:ye().createElement(e,Cb({key:"values-after"},this.props))}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings.showErrorMessage,o=this.RuleError,i=co((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return n&&i&&ye().createElement("div",{className:"rule--error"},o?ye().createElement(o,{error:i}):i)}},{key:"renderValue",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.value,o=e.valueSrc,i=e.valueError,a=e.setValue,s=e.setValueSrc,l=e.setFuncValue,u=e.id,c=t.settings.immutableValuesMode,d=ye().createElement(iE,{key:"values",isCaseValue:!0,field:"!case_value",operator:null,value:n,valueSrc:null!=o?o:"value",valueError:i,fieldError:null,config:t,setValue:c?tO:a,setValueSrc:c?tO:s,setFuncValue:c?tO:l,readonly:c||r,id:u,groupId:null});return ye().createElement(eO,{className:"case_group--value"},d)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addGroup,n=e.addRule,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(BE,{config:t,addGroup:r,addRule:n,canAddRule:this.canAddRule(),canAddGroup:this.canAddGroup(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.value,r=e&&e.size?e.get(0):null,n=null!=r&&(!Array.isArray(r)||r.length>0);return YE(eo(t.prototype),"isEmptyCurrentGroup",this).call(this)&&!n}}])}(GE);NS.propTypes=PS(PS({},GE.propTypes),{},{parentReordableNodesCnt:$y().number,value:$y().any,setValue:$y().func});const DS=FE(Bb("group case_group")(nO(NS)),"case_group");var FS=["type"];function MS(e,t,r){return t=eo(t),Zn(e,VS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function VS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(VS=function(){return!!e})()}function US(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function BS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?US(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):US(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var zS=function(e){var t,r=(null===(t=e.properties)||void 0===t?void 0:t.toObject())||{},n=BS({},r);return e.isParentLocked&&(n.isLocked=!0),r.isLocked&&(n.isTrueLocked=!0),n},$S={rule:function(e){return ye().createElement(jE,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,config:e.config,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},group:function(e){return ye().createElement(KE,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group:function(e){return ye().createElement(oS,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group_ext:function(e){return ye().createElement(yS,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},switch_group:function(e){return ye().createElement(AS,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},case_group:function(e){return ye().createElement(DS,Cb({},zS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))}},WS=function(e){function t(){return Gn(this,t),MS(this,t,arguments)}return ro(t,e),Qn(t,[{key:"render",value:function(){var e,t=this.props,r=t.type,n=nm(t,FS),o="array"==(null===(e=n.properties)||void 0===e?void 0:e.get("mode"))?"_ext":"",i=n.config.settings.renderItem,a=$S[r+o];return i?i(BS(BS({},n),{},{type:r,itemComponent:a}),n.config.ctx):a?a(n):null}}])}(ve.PureComponent);function HS(e,t,r){return t=eo(t),Zn(e,qS()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function qS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(qS=function(){return!!e})()}WS.propTypes={config:$y().object.isRequired,id:$y().string.isRequired,groupId:$y().string,type:$y().oneOf(["rule","group","rule_group","switch_group","case_group"]).isRequired,path:$y().any.isRequired,properties:$y().any,children1:$y().any,actions:$y().object.isRequired,reordableNodesCnt:$y().number,onDragStart:$y().func,parentField:$y().string,isDraggingTempo:$y().bool,isParentLocked:$y().bool};var GS=By.TreeUtils,KS=GS.getTotalReordableNodesCountInTree,YS=GS.getTotalRulesCountInTree,XS=By.DefaultUtils,QS=XS.createListWithOneElement,JS=XS.emptyProperties,ZS=function(e){function t(e){var r;return Gn(this,t),(r=HS(this,t,[e])).pureShouldComponentUpdate=pb(r),r._updPath(e),r}return ro(t,e),Qn(t,[{key:"shouldComponentUpdate",value:function(e,t){return this.pureShouldComponentUpdate(e,t)}},{key:"_updPath",value:function(e){var t=e.tree.get("id");this.path=QS(t)}},{key:"render",value:function(){var e=this.props,t=e.tree,r=e.config,n=e.actions,o=e.onDragStart,i=t.get("type"),a="switch_group"==i,s=a?null:KS(t),l=a?null:YS(t),u=t.get("id");return ye().createElement(WS,{key:u,id:u,path:this.path,type:i,properties:t.get("properties")||JS(),config:r,actions:n,children1:t.get("children1")||JS(),reordableNodesCnt:s,totalRulesCnt:l,parentReordableNodesCnt:0,onDragStart:o})}}])}(ve.Component);ZS.propTypes={tree:$y().any.isRequired,config:$y().object.isRequired,actions:$y().object.isRequired,onDragStart:$y().func};const ew=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(0,Gy.connect)((function(e){return{dragging:e.dragging,dragStart:e.dragStart,mousePos:e.mousePos}}),{setDragStart:Zy,setDragProgress:Jy,setDragEnd:eb},null,{context:Hy})(function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return t=function(t){function n(e){var t;return Gn(this,n),(t=Lb(this,n,[e]))._getEventTarget=function(e,t){return e&&e.__mocked_window||document.body||window},t.onDragStart=function(e,r,n){var o=r.closest(".query-builder");void 0===t._isUsingLegacyReactDomRender&&(t._isUsingLegacyReactDomRender=cb(o)),document.body.classList.add("qb-dragging"),o.classList.add("qb-dragging");var i,a=o.closest(".query-builder-container")||o,s=(a=t._getScrollParent(a)||document.body).scrollTop,l=(t._getDraggableNodeEl(o),t._getPlaceholderNodeEl(o),o.querySelectorAll(".group--children")),u=l.length?l[0]:null;u&&(i=window.getComputedStyle(u,null).getPropertyValue("padding-left"),i=parseInt(i));var c={id:e,x:r.offsetLeft,y:r.offsetTop,w:r.offsetWidth,h:r.offsetHeight,itemInfo:t.tree.items[e],paddingLeft:i},d={id:e,x:r.offsetLeft,y:r.offsetTop,scrollTop:s,clientX:n.clientX,clientY:n.clientY,itemInfo:Nb(t.tree.items[e]),treeEl:o,treeElContainer:a},p={clientX:n.clientX,clientY:n.clientY},f=t._getEventTarget(n,d);t.eventTarget=f,f.addEventListener("mousemove",t.onDrag),f.addEventListener("mouseup",t.onDragEnd),t.props.setDragStart(d,c,p)},t.onDrag=function(e){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=Object.assign({},t.props.dragging),i=t.props.dragStart,a=o.paddingLeft,s=i.treeElContainer.scrollTop;if(o.itemInfo=t.tree.items[o.id],o.itemInfo){var l={clientX:e.clientX,clientY:e.clientY},u={clientX:i.clientX,clientY:i.clientY};if(e.__mock_dom){var c=i.treeEl,d=t._getDraggableNodeEl(c),p=t._getPlaceholderNodeEl(c);e.__mock_dom({treeEl:c,dragEl:d,plhEl:p})}if(!i.plX){var f=i.treeEl,h=t._getPlaceholderNodeEl(f);h&&(i.plX=h.getBoundingClientRect().left+window.scrollX,i.plY=h.getBoundingClientRect().top+window.scrollY)}var g=i.x,v=i.y,m=i.clientX,y=i.clientY,b=i.scrollTop,O={x:g+(e.clientX-m),y:v+(e.clientY-y)+(s-b)};o.x=O.x,o.y=O.y,o.paddingLeft=a,o.mousePos=l,o.startMousePos=u,t.props.setDragProgress(l,o),n&&t.handleDrag(o,e,r)||e.preventDefault&&e.preventDefault()}},t.onDragEnd=function(){var e=t.props.dragStart.treeEl;t.props.setDragEnd(),e.classList.remove("qb-dragging"),document.body.classList.remove("qb-dragging"),t._cacheEls={};var r=t.eventTarget||t._getEventTarget();r.removeEventListener("mousemove",t.onDrag),r.removeEventListener("mouseup",t.onDragEnd)},t.pureShouldComponentUpdate=pb(t),fb(t),t.onPropsChanged(e),t}return ro(n,t),Qn(n,[{key:"onPropsChanged",value:function(e){this.tree=Db(e.tree)}},{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=[];for(var a in e)e[a]!=r[a]&&"dragging"!=a&&"mousePos"!=a&&i.push(a);i.length||(o=!1)}return o}},{key:"componentDidUpdate",value:function(e,t){var r=this.props.dragging,n=this.props.dragStart;if(Fb=!1,n&&n.id&&(r.itemInfo=this.tree.items[r.id],r.itemInfo&&(r.itemInfo.index!=n.itemInfo.index||r.itemInfo.parent!=n.itemInfo.parent))){var o=n.treeEl,i=n.treeElContainer,a=this._getPlaceholderNodeEl(o,!0);if(a){var s=a.getBoundingClientRect().left+window.scrollX,l=a.getBoundingClientRect().top+window.scrollY,u=n.plX,c=n.plY,d=i.scrollTop;n.plX=s,n.plY=l,n.itemInfo=Nb(r.itemInfo),n.y=a.offsetTop,n.x=a.offsetLeft,n.clientY+=l-c,n.clientX+=s-u,i!=document.body&&(n.scrollTop=d),this.onDrag(this.props.mousePos,!1)}}}},{key:"_getNodeElById",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==t)return null;this._cacheEls||(this._cacheEls={});var n=this._cacheEls[t];return n&&document.contains(n)&&!r||(n=e.querySelector('.group-or-rule-container[data-id="'+t+'"]'),this._cacheEls[t]=n),n}},{key:"_getDraggableNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.draggable;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-draggable");return r=n.length?n[0]:null,this._cacheEls.draggable=r,r}},{key:"_getPlaceholderNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.placeholder;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-placeholder");return r=n.length?n[0]:null,this._cacheEls.placeholder=r,r}},{key:"_isScrollable",value:function(e){var t=window.getComputedStyle(e)["overflow-y"];return("scroll"===t||"auto"===t)&&e.scrollHeight>e.offsetHeight}},{key:"_getScrollParent",value:function(e){return null==e?null:e===document.body||this._isScrollable(e)?e:this._getScrollParent(e.parentNode)}},{key:"handleDrag",value:function(e,t,r){var n,o,i,a,s=this,l=e.itemInfo,u=e.paddingLeft,c=null,d=this.props.dragStart.treeEl,p=e.id,f=this._getDraggableNodeEl(d),h=this._getPlaceholderNodeEl(d);if(f&&h){if(n=f.getBoundingClientRect(),!(o=h.getBoundingClientRect()).width)return;var g={hrz:0,vrt:0};n.top<o.top?g.vrt=-1:n.bottom>o.bottom&&(g.vrt=1),n.left>o.left?g.hrz=1:n.left<o.left&&(g.hrz=-1);var v,m={x:(a=d.getBoundingClientRect()).left+(a.right-a.left)/2,y:g.vrt>=0?n.bottom:n.top};if(t.__mocked_hov_container)v=t.__mocked_hov_container;else{var y=document.elementFromPoint(m.x,m.y-1);if(!(v=y?y.closest(".group-or-rule-container"):null)&&y&&y.classList.contains("query-builder-container")){var b,O=null==y||null===(b=y.firstChild)||void 0===b?void 0:b.firstChild;O&&O.classList.contains("group-or-rule-container")&&(v=O)}}if(v){var E=v.classList.contains("group-container"),S=v.getAttribute("data-id"),w=v,T=!1,x=!1;if(w){var _=(i=w.getBoundingClientRect()).bottom-i.top,C=this.tree.items[S];if(!C)throw new Error("There is an issue with rendering. If you use Next.js, please check getServerSideProps() method.");var R=null,I=null,A=null,j=null;if(0==g.vrt)A=l,(I=h)&&(R=I.getBoundingClientRect());else if(E){if(g.vrt>0){var P=v.getElementsByClassName("group--header"),L=P.length?P[0]:null;if(L){var k=L.getBoundingClientRect(),N=k.bottom-k.top;n.bottom-k.top>3*N/4&&C.top>e.itemInfo.top&&(A=C,R=k,I=L,x=!0)}}else g.vrt<0&&C.lev>=l.lev&&i.bottom-n.top>=2&&C.top<e.itemInfo.top&&(A=C,R=i,I=w,T=!0);(g.vrt<0?i.bottom-n.top>_-5:n.bottom-i.top>_-5)&&(x||T||(A=C,R=i,I=w),j=C)}else(g.vrt<0?i.bottom-n.top>_/2:n.bottom-i.top>_/2)&&(A=C,R=i,I=w);var D=A&&A.id==p;if(R){var F=n.left-a.left,M=(R.left,a.left,Math.max(0,Math.round(F/u))),V=[],U=[];if(D);else{if(E&&(T?V.push([Xy,A,A.lev+1]):x&&V.push([Qy,A,A.lev+1]),j)){var B=0==j.lev,z="case_group"==j.type&&"case_group"!=l.type,$=j.prev&&this.tree.items[j.prev].caseId,W=j.next&&this.tree.items[j.next].caseId;l.caseId==$&&($=null),l.caseId==W&&(W=null);var H=$&&this.tree.items[$],q=W&&this.tree.items[W];g.vrt>0?B?U.push([Xy,j,j.lev+1]):z&&q?U.push([Qy,q,q.lev+1]):U.push([Ky,j,j.lev]):g.vrt<0&&(B?U.push([Qy,j,j.lev+1]):z&&H?U.push([Xy,H,H.lev+1]):U.push([Yy,j,j.lev]))}T||x||(g.vrt<0?V.push([Yy,A,A.lev]):g.vrt>0&&V.push([Ky,A,A.lev]))}var G=function(e){var t=e[1],r=l.caseId?s.tree.items[l.caseId]:null,n=t.caseId?s.tree.items[t.caseId]:null;return[].concat(co(e),[r,n])};V=V.map(G),U=U.map(G);var K=null,Y=(V=V.filter((function(e){var t=e[0],r=e[1];if((t==Yy||t==Ky)&&null==r.parent)return!1;if(r.collapsed&&(t==Xy||t==Qy))return!1;var n=r.id==l.id;if(!n)for(var o=r;o.parent;)if((o=s.tree.items[o.parent]).id==l.id){n=!0;break}return!n})).map((function(e){var t=e[0],r=e[1],n=(e[2],e[3],e[4],null);return(n=t==Xy||t==Qy?r:s.tree.items[r.parent])&&null==n.parent&&(n=null),e[5]=n,e}))).filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)}));0==Y.length&&U.length>0&&(Y=U.filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)})));var X=Y.map((function(e){return e[2]})),Q=l.lev,J=X.concat(Q),Z=null;-1!=J.indexOf(M)?Z=M:M>Math.max.apply(Math,co(J))?Z=Math.max.apply(Math,co(J)):M<Math.min.apply(Math,co(J))&&(Z=Math.min.apply(Math,co(J))),K=Y.find((function(e){return e[2]==Z})),D||K||!Y.length||(K=Y[0]),c=K}}}else sb.log("out of tree bounds!")}return!!c&&(this.move(l,c[1],c[0],c[3]),!0)}},{key:"canMove",value:function(e,t,r,n,o,i,a){if(!e||!t)return!1;if(e.id===t.id)return!1;var s=this.props.config.settings,l=s.canRegroup,u=s.canRegroupCases,c=s.maxNesting,d=s.maxNumberOfRules,p=s.canLeaveEmptyCase,f=(i?i.lev+1:t.lev)+(e.depth||0),h=r==Yy||r==Ky,g=r==Qy||r==Xy,v=h&&1==t.lev||g&&0==t.lev,m=e.parent!=t.parent,y=g||m,b="case_group"==e.type&&!v||"rule_group"==e.parentType||"rule_group"==t.type||"rule_group"==t.parentType||"case_group"!=e.type&&"case_group"==t.type&&h||"case_group"!=e.type&&"switch_group"==t.type||!u&&e.caseId!=t.caseId,O=t.isLocked||e.isLocked||i&&i.isLocked;if(c&&f>c)return!1;if(y&&(!l||b||O))return!1;if("case_group"!=e.type&&e.caseId!=t.caseId){var E=!!n&&2==n._height,S=o?o.atomicRulesCountInCase+1:0;if(d&&S>d)return!1;if(E&&!p)return!1}if("case_group"==e.type&&(e.isDefaultCase||t.isDefaultCase||"switch_group"==t.type&&r==Xy))return!1;var w=!0;return a&&(w=a(e.node.toJS(),t.node.toJS(),r,i?i.node.toJS():null)),w}},{key:"move",value:function(e,t,r,n){this._isUsingLegacyReactDomRender||(Fb=!0),this.props.actions.moveItem(e.path,t.path,r)}},{key:"render",value:function(){return ye().createElement(e,Cb({},this.props,{onDragStart:this.onDragStart}))}}])}(ve.Component),t.propTypes={tree:$y().any.isRequired,actions:$y().object.isRequired},t}(e,t));return r.displayName="ConnectedSortableContainer",r}(ZS);function tw(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function rw(e,t,r){return t=eo(t),Zn(e,nw()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function nw(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(nw=function(){return!!e})()}var ow=By.clone,iw=By.ConfigUtils,aw=iw.getFieldConfig,sw=iw.getFieldParts,lw=iw.getFieldPathParts,uw=By.RuleUtils,cw=uw.getFieldPathLabels,dw=uw.getWidgetForFieldOp,pw=function(e){function t(e){var r;return Gn(this,t),r=rw(this,t,[e]),fb(r),r.onPropsChanged(e),r}return ro(t,e),Qn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldSrc","fieldType","operator","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0,n=!this.meta||["config","field","fieldSrc","fieldType","operator","value","placeholder","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;r&&(this.items=this.getItems(e)),n&&(this.meta=this.getMeta(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.fieldType,o=e.operator,i=e.parentField,a=e.isFuncArg,s=e.fieldDefinition,l=t.settings.canCompareFieldWithField,u=sw(i,t),c=i?aw(t,i):null,d=i?null==c?void 0:c.subfields:t.fields,p=this.filterFields(t,d,r,i,u,o,l,a,s,n);return this.buildOptions(u,t,p,u)}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.field,o=(e.fieldType,e.operator,e.value),i=e.placeholder,a=e.isFuncArg,s=e.parentField,l=r.settings,u=l.fieldPlaceholder,c=l.fieldSeparatorDisplay,d=o,p=!!o,f=n?aw(r,n):{},h=null==f||null===(t=f.widgets)||void 0===t?void 0:t.field,g=(null==h?void 0:h.widgetProps)||{},v=p?null:a&&i||g.valuePlaceholder||u,m=p?aw(r,d):null,y=m||{},b=lw(d,r),O=lw(d,r,!0),E=this.getFieldLabel(m,d,r),S=cw(d,r),w=S?S.join(c):null;return(w==E||s)&&(w=null),{placeholder:v,selectedKey:d,selectedKeys:b,selectedPath:O,selectedLabel:E,selectedOpts:y,selectedAltLabel:y.label2||y.tooltip,selectedFullLabel:w}}},{key:"filterFields",value:function(e,t,r,n,o,i,a,s,l,u){t=ow(t);var c,d=e.settings.fieldSeparator,p=aw(e,r),f=dw(e,r,i,"value");return e.widgets[f],c=s?null==l?void 0:l.type:p?p.type:u,function t(n,o){for(var l in n){var u=n[l].subfields,f=(o||[]).concat(l),h=f.join(d),g=aw(e,h);if(g)if("!struct"==g.type||"!group"==g.type)0==t(u,f)&&delete n[l];else{var v=!(c&&g.type!=c||!s&&h==r),m=a||e.settings.canCompareFieldWithField;m&&(v=v&&m(r,p,h,g,i)),v||delete n[l]}else delete n[l]}return $b()(n).length}(t,o||[]),t}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"";return $b()(r).map((function(a){var s=[].concat(co(null!=o?o:[]),[a]),c=r[a],d=n.getFieldLabel(c,s,t),p=cw(s,t).join(l);(p==d||e)&&(p=null);var f=c.label2,h=c.tooltip;if(!c.hideForCompare)return"!struct"==c.type||"!group"==c.type?{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:h,items:n.buildOptions(e,t,c.subfields,s,{label:d,tooltip:h})}:{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:h,grouplabel:null==i?void 0:i.label,group:i}})).filter((function(e){return!!e}))}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=sw(t,r),i=(null==e?void 0:e.label)||cu()(o);return ob(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?tw(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):tw(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({isValueField:!0,config:t,customProps:r,setField:n,readonly:o,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ve.Component);pw.propTypes={id:$y().string,groupId:$y().string,setValue:$y().func.isRequired,config:$y().object.isRequired,field:$y().any,fieldSrc:$y().string,fieldType:$y().string,value:$y().string,operator:$y().string,customProps:$y().object,readonly:$y().bool,parentField:$y().string,fieldDefinition:$y().object,isFuncArg:$y().bool};const fw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.labelYes),o=e.labelNo,i=e.readonly,a=(e.widgetId,e.customProps),s=void 0===a?{}:a,l=s.radioYes||{},u=s.radioNo||{},c=function(e){return r("true"==e.target.value)};return ye().createElement(ye().Fragment,null,ye().createElement("input",Cb({type:"radio",value:!0,checked:!!t,disabled:i,onChange:c},l))," ",n,ye().createElement("input",Cb({type:"radio",value:!1,checked:!t,disabled:i,onChange:c},u))," ",o)},hw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=e.customProps,s=t||"";return ye().createElement("input",Cb({type:"text",value:s,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i},a))},gw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=(e.maxRows,e.fullWidth),s=e.customProps,l=t||"";return ye().createElement("textarea",Cb({value:l,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i,style:{width:a?"100%":void 0}},s))};By.moment;const vw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.readonly),o=e.customProps;return ye().createElement("input",Cb({type:"date",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))},mw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.use12Hours,e.readonly),o=e.customProps;return ye().createElement("input",Cb({type:"time",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))};var yw=By.moment;const bw=function(e){var t,r=e.value,n=e.setValue,o=(e.config,e.valueFormat),i=(e.use12Hours,e.readonly),a=e.customProps;return t=r?yw(r).format("YYYY-MM-DDTHH:mm"):"",ye().createElement("input",Cb({type:"datetime-local",value:t,disabled:i,onChange:function(e){var t=e.target.value;t=""==t?void 0:yw(new Date(t)).format(o),n(t)}},a))};var Ow=By.ListUtils.mapListValues;const Ew=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps;return ye().createElement("select",Cb({multiple:!0,onChange:function(e){return n(function(e){for(var t=[],r=e.options,n=0;n<r.length;n++){var o=r[n];o.selected&&t.push(o.value)}return t.length||(t=void 0),t}(e.target))},value:r,disabled:o},pu()(i,["showSearch","input","showCheckboxes"])),Ow(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))};var Sw=By.ListUtils.mapListValues;const ww=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps,a=null!=r;return ye().createElement("select",Cb({onChange:function(e){return n(e.target.value)},value:a?r:"",disabled:o},pu()(i,["showSearch","input"])),!a&&ye().createElement("option",{disabled:!0,value:""}),Sw(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))},Tw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=null==t?"":t;return ye().createElement("input",Cb({type:"number",value:u,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)}},l))},xw=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=void 0===l?{}:l,c=u.input||{},d=u.slider||u,p=function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)},f=null==t?"":t;return ye().createElement("div",{style:{display:"inline-flex"}},ye().createElement("input",Cb({key:"number",type:"number",value:f,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:p},c)),ye().createElement("input",Cb({key:"range",type:"range",value:f,disabled:n,min:o,max:i,step:a,onChange:p},d)))},_w=function(e){var t=e.items,r=e.setField,n=e.selectedKey,o=e.readonly,i=e.errorText,a=null!=n;return ye().createElement("select",{onChange:function(e){return r(e.target.value)},value:a?n:"",disabled:o,style:{color:i?"red":null}},!a&&ye().createElement("option",{disabled:!0,value:""}),function e(t){return t.map((function(t){var r=t.items,n=t.path,o=t.label,i=t.disabled,a=t.matchesType;if(r)return ye().createElement("optgroup",{disabled:i,key:n,label:o},e(r));var s=a?{fontWeight:"bold"}:{};return ye().createElement("option",{disabled:i,key:n,value:n,style:s},o)}))}(t))},Cw=function(e){var t,r=e.id,n=e.not,o=e.setNot,i=e.conjunctionOptions,a=e.setConjunction,s=e.disabled,l=e.readonly,u=e.config,c=e.showNot,d=e.notLabel,p=Object.keys(i).length,f=s,h=u.settings.forceShowConj||p>1&&!f,g=function(e){return a(e.target.value)};return[c&&(t="not",[ye().createElement("input",{key:r+t,type:"checkbox",id:r+t,checked:n,disabled:l,onChange:function(e){return o(e.target.checked)}}),ye().createElement("label",{key:r+t+"label",htmlFor:r+t},d||"NOT")]),h&&Object.keys(i).map((function(e){var t=i[e],r=t.id,n=t.name,o=t.label,u=t.checked,c=a.isDummyFn?"__dummy":"";return!l&&!s||u?[ye().createElement("input",{key:r+c,type:"radio",id:r+c,name:n+c,checked:u,disabled:l||s,value:e,onChange:g}),ye().createElement("label",{key:r+c+"label",htmlFor:r+c},o)]:null}))]};var Rw={addRuleGroup:"+",addRuleGroupExt:"+",delGroup:"x",delRuleGroup:"x",delRule:"x"};const Iw=function(e){var t=e.type,r=e.label,n=e.onClick,o=e.readonly,i=r||Rw[t];return ye().createElement("button",{onClick:n,type:"button",disabled:o},i)},Aw=function(e){var t=e.type,r={}[t]||null;return r||"drag"!==t||(r=ye().createElement(rO,null)),r},jw=function(e){var t=e.children;return e.config,ye().createElement(ye().Fragment,null,t)},Pw=function(e){e.config;var t=e.valueSources,r=e.valueSrc,n=(e.title,e.setValueSrc),o=e.readonly;return ye().createElement("select",{onChange:function(e){return n(e.target.value)},value:r||"",disabled:o},function(e){return e.map((function(e){var t=lo(e,2),r=t[0],n=t[1];return ye().createElement("option",{key:r,value:r},n.label)}))}(t))},Lw=function(e){var t=e.value,r=e.setValue,n=e.label,o=e.id,i=(e.config,e.type);return[ye().createElement("input",{key:o+i,type:"checkbox",id:o+i,checked:!!t,onChange:function(e){return r(e.target.checked)}}),ye().createElement("label",{key:o+i+"label",htmlFor:o+i},n)]},kw=function(e){var t=e.onOk,r=(e.okText,e.cancelText,e.title);confirm(r)&&t()};var Nw=function(e){return e.config,e.children};function Dw(e,t,r){return t=eo(t),Zn(e,Fw()?Reflect.construct(t,r||[],eo(e).constructor):t.apply(e,r))}function Fw(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Fw=function(){return!!e})()}var Mw=function(e){function t(){var e;Gn(this,t);for(var r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=Dw(this,t,[].concat(n))).handleChange=function(t){e.props.setOption("proximity",parseInt(t))},e}return ro(t,e),Qn(t,[{key:"render",value:function(){var e=this.props,t=e.defaults,r=e.options,n=e.config,o=e.optionLabel,i=e.optionPlaceholder,a=e.customProps,s=e.minProximity,l=e.maxProximity,u=e.optionTextBefore,c=e.readonly,d=n.settings,p=n.widgets,f=n.ctx,h=t?t.proximity:void 0,g=d.showLabels,v=r.get("proximity",h),m=LO()(s,l+1).map((function(e){return{title:e,value:e}})),y=p.select.factory,b=function(e){return y(e,f)};return ye().createElement("div",{className:"operator--PROXIMITY"},ye().createElement("div",{className:"operator--options"},g&&ye().createElement("label",{className:"rule--label"},o),!g&&u&&ye().createElement("div",{className:"operator--options--sep"},ye().createElement("span",null,u)),ye().createElement(b,Cb({config:n,value:v,listValues:m,setValue:this.handleChange,readonly:c,placeholder:i},a))),ye().createElement("div",{className:"operator--widgets"},this.props.children))}}])}(ve.PureComponent);function Vw(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Uw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Vw(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Vw(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}Mw.propTypes={config:$y().object.isRequired,setOption:$y().func.isRequired,options:$y().any.isRequired,minProximity:$y().number,maxProximity:$y().number,optionPlaceholder:$y().string,optionTextBefore:$y().string,optionLabel:$y().string,customProps:$y().object,readonly:$y().bool},Mw.defaultProps={customProps:{},minProximity:2,maxProximity:10,optionPlaceholder:"Select words between",optionLabel:"Words between",optionTextBefore:null};var Bw=Uw({},Dm.conjunctions),zw=Uw(Uw({},Dm.operators),{},{proximity:Uw(Uw({},Dm.operators.proximity),{},{options:Uw(Uw({},Dm.operators.proximity.options),{},{factory:function(e,t){return(0,t.RCE)(t.O.ProximityOperator,e)}})})}),$w={text:Uw(Uw({},Dm.widgets.text),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}}),textarea:Uw(Uw({},Dm.widgets.textarea),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextAreaWidget,e)}}),number:Uw(Uw({},Dm.widgets.number),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaNumberWidget,e)}}),slider:Uw(Uw({},Dm.widgets.slider),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSliderWidget,e)}}),select:Uw(Uw({},Dm.widgets.select),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSelectWidget,e)}}),multiselect:Uw(Uw({},Dm.widgets.multiselect),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaMultiSelectWidget,e)}}),date:Uw(Uw({},Dm.widgets.date),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateWidget,e)}}),time:Uw(Uw({},Dm.widgets.time),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTimeWidget,e)}}),datetime:Uw(Uw({},Dm.widgets.datetime),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateTimeWidget,e)}}),boolean:Uw(Uw({},Dm.widgets.boolean),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaBooleanWidget,e)}}),field:Uw(Uw({},Dm.widgets.field),{},{factory:function(e,t){return(0,t.RCE)(t.W.ValueFieldWidget,e)},customProps:{showSearch:!0}}),func:Uw(Uw({},Dm.widgets.func),{},{factory:function(e,t){return(0,t.RCE)(t.W.FuncWidget,e)},customProps:{}}),case_value:Uw(Uw({},Dm.widgets.case_value),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}})},Ww={conjunctions:Bw,operators:zw,widgets:$w,types:Uw(Uw({},Dm.types),{},{select:Uw(Uw({},Dm.types.select),{},{widgets:Uw(Uw({},Dm.types.select.widgets),{},{select:Uw(Uw({},Dm.types.select.widgets.select),{},{widgetProps:{customProps:{showSearch:!0}}})})})}),settings:Uw(Uw({},Dm.settings),{},{renderField:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderOperator:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderFunc:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderConjs:function(e,t){return(0,t.RCE)(t.W.VanillaConjs,e)},renderSwitch:function(e,t){return(0,t.RCE)(t.W.VanillaSwitch,e)},renderButton:function(e,t){return(0,t.RCE)(t.W.VanillaButton,e)},renderIcon:function(e,t){return(0,t.RCE)(t.W.VanillaIcon,e)},renderButtonGroup:function(e,t){return(0,t.RCE)(t.W.VanillaButtonGroup,e)},renderProvider:function(e,t){return(0,t.RCE)(t.W.VanillaProvider,e)},renderValueSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderFieldSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderConfirm:function(e,t){return(0,t.W.vanillaConfirm)(e)},renderSwitchPrefix:"IF",renderBeforeCaseValue:function(e,t){return(0,t.RCE)("span",{children:[" then "]})},customFieldSelectProps:{showSearch:!0},customOperatorSelectProps:{},defaultSliderWidth:"200px",defaultSelectWidth:"200px",defaultSearchWidth:"100px",defaultMaxRows:5,renderSize:"small",maxLabelsLength:100,showLock:!1,showNot:!0,forceShowConj:!1,groupActionsPosition:"topRight"}),ctx:Uw(Uw({},Dm.ctx),{},{W:Uw({},O),O:Uw({},E),RCE:function(e,t){return ye().createElement(e,t)}})};const Hw=Ww=By.ConfigMixins.removeMixins(Ww,["rangeslider","treeselect","treemultiselect"]);v(9517);var qw=By.Autocomplete,Gw=(qw.mergeListValues,qw.listValueToOption,qw.optionToListValue,qw.optionsToListValues,qw.fixListValuesGroupOrder,By.ListUtils);function Kw(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Yw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Kw(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Kw(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}Gw.mapListValues,Gw.listValuesToArray,Gw.getListValue,Gw.makeCustomListValue,Gw.searchListValue,Gw.getItemInListValues;const Xw=Yw(Yw({},By),{},{ReactUtils:b,DragIcon:rO});function Qw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Jw(){return Jw=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},Jw.apply(this,arguments)}function Zw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Qw(e,t,r[t])}))}return e}function eT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const tT={id:Xw.uuid(),type:"group"},rT="timeFilter",nT=[rT],oT=eT(Zw({},Hw.widgets),{text:eT(Zw({},Hw.widgets.text),{factory:function(e){return(0,ge.jsx)(xe.Input,{value:(null==e?void 0:e.value)||"",placeholder:null==e?void 0:e.placeholder,onChange:t=>null==e?void 0:e.setValue(t.currentTarget.value)})}}),number:eT(Zw({},Hw.widgets.number),{factory:function(e){return(0,ge.jsx)(xe.Input,{value:null==e?void 0:e.value,placeholder:null==e?void 0:e.placeholder,type:"number",onChange:t=>null==e?void 0:e.setValue(Number.parseInt(t.currentTarget.value,10))})}}),datetime:eT(Zw({},Hw.widgets.datetime),{factory:function(e){if("macros"===(null==e?void 0:e.operator))return(0,ge.jsx)(xe.Select,{id:e.id,"aria-label":"Macros value selector",menuShouldPortal:!0,options:nT.map(w.toOption),value:null==e?void 0:e.value,onChange:t=>e.setValue(t.value)});const t=(0,w.dateTime)(null==e?void 0:e.value).isValid()?(0,w.dateTime)(null==e?void 0:e.value).utc():void 0;return(0,ge.jsx)(xe.DateTimePicker,{onChange:t=>{null==e||e.setValue(null==t?void 0:t.format(Hw.widgets.datetime.valueFormat))},date:t})},sqlFormatValue:(e,t,r,n,o,i)=>{if("macros"===n)return nT.includes(e)?e:void 0;if("string"==typeof Hw.widgets.datetime.sqlFormatValue||"object"==typeof Hw.widgets.datetime.sqlFormatValue)return;const a=Hw.widgets.datetime.sqlFormatValue;return(null==a?void 0:a.call(Hw.ctx,e,t,r,n,o,i))||""}})}),iT=eT(Zw({},Hw.settings),{canRegroup:!1,maxNesting:1,canReorder:!1,showNot:!1,addRuleLabel:"Add",deleteLabel:"Remove",renderConjs:function(e){return(0,ge.jsx)(xe.Select,{id:null==e?void 0:e.id,"aria-label":"Conjunction","data-testid":ze.components.SQLQueryEditor.filterConjunction,menuShouldPortal:!0,options:(null==e?void 0:e.conjunctionOptions)?Object.keys(null==e?void 0:e.conjunctionOptions).map(w.toOption):void 0,value:null==e?void 0:e.selectedConjunction,onChange:t=>null==e?void 0:e.setConjunction(t.value)})},renderField:function(e){var t;const r=(null==e||null===(t=e.config)||void 0===t?void 0:t.fields)||{};return(0,ge.jsx)(xe.Select,{id:null==e?void 0:e.id,width:25,"aria-label":"Field","data-testid":ze.components.SQLQueryEditor.filterField,menuShouldPortal:!0,options:null==e?void 0:e.items.map((e=>{var t,n;const o=null===(n=r[e.key].mainWidgetProps)||void 0===n||null===(t=n.customProps)||void 0===t?void 0:t.icon;return{label:e.label,value:e.key,icon:o}})),value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.label)}})},renderButton:function(e){return(0,ge.jsx)(xe.Button,{type:"button",title:`${null==e?void 0:e.label} filter`,onClick:null==e?void 0:e.onClick,variant:"secondary",size:"md",icon:"Add"===(null==e?void 0:e.label)?"plus":"times"})},renderOperator:function(e){return(0,ge.jsx)(xe.Select,{options:null==e?void 0:e.items.map((e=>({label:e.label,value:e.key}))),"aria-label":"Operator","data-testid":ze.components.SQLQueryEditor.filterOperator,menuShouldPortal:!0,value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.value||"")}})}}),aT=function(e){const t=Jw({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e.operators));return eT(Zw({},t),{select_any_in:eT(Zw({},t.select_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_any_in.sqlFormatOp;return fT(e)?e:pT})()(e,r,hT(n),o,i,a,s,l)}),select_not_any_in:eT(Zw({},t.select_not_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_not_any_in.sqlFormatOp;return fT(e)?e:pT})()(e,r,hT(n),o,i,a,s,l)}),macros:{label:"Macros",sqlFormatOp:(e,t,r)=>r===rT?`$__timeFilter(${e})`:r}})}(Hw),sT=Hw.types.text.widgets.text,lT=[...sT.operators||[],"select_any_in","select_not_any_in"],uT=eT(Zw({},sT),{operators:lT}),cT=eT(Zw({},Hw.types),{text:eT(Zw({},Hw.types.text),{widgets:eT(Zw({},Hw.types.text.widgets),{text:uT})}),datetime:eT(Zw({},Hw.types.datetime),{widgets:eT(Zw({},Hw.types.datetime.widgets),{datetime:eT(Zw({},Hw.types.datetime.widgets.datetime),{operators:["macros",...Hw.types.datetime.widgets.datetime.operators||[]]})})})}),dT=eT(Zw({},Hw),{widgets:oT,settings:iT,operators:aT,types:cT}),pT=()=>"",fT=e=>"function"==typeof e;function hT(e){return(0,fe.isString)(e)?e.split(","):e}function gT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function vT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){gT(e,t,r[t])}))}return e}function mT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function yT({sql:e,config:t,onSqlChange:r}){const[n,o]=(0,ve.useState)(),i=(0,ve.useMemo)((()=>vT({},dT,t)),[t]);(0,ve.useEffect)((()=>{if(!n){var t;const r=Xw.checkTree(Xw.loadTree(null!==(t=e.whereJsonTree)&&void 0!==t?t:tT),i);o(r)}}),[i,e.whereJsonTree,n]),(0,ve.useEffect)((()=>{e.whereJsonTree||o(Xw.checkTree(Xw.loadTree(tT),i))}),[i,e.whereJsonTree]);const a=(0,ve.useCallback)(((t,n)=>{o(t);const i=mT(vT({},e),{whereJsonTree:Xw.getTree(t),whereString:Xw.sqlFormat(t,n)});r(i)}),[r,e]);return n?(0,ge.jsx)(_b,mT(vT({},i),{value:n,onChange:a,renderBuilder:e=>(0,ge.jsx)(ew,vT({},e))})):null}function bT(e){return`\n    display: flex;\n    gap: 8px;\n    flex-direction: ${e};`}function OT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function ET(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){OT(i,n,o,a,s,"next",e)}function s(e){OT(i,n,o,a,s,"throw",e)}a(void 0)}))}}function ST({query:e,fields:t,onQueryChange:r,db:n}){const o=(0,qn.A)(ET((function*(){return function(e){const t={};for(const r of e)t[r.value]={type:r.raqbFieldType||"text",valueSources:["value"],mainWidgetProps:{customProps:{icon:r.icon}}};return t}(t)})),[t]),{onSqlChange:i}=pn({query:e,onQueryChange:r,db:n});return(0,ge.jsx)(yT,{config:{fields:o.value||{}},sql:e.sql,onSqlChange:e=>{!function(e,t){var r,n;t.some((t=>(t=>{var r,n;return"multi"in t&&t.multi&&((null===(r=e.whereString)||void 0===r?void 0:r.includes(`\${${t.name}}`))||(null===(n=e.whereString)||void 0===n?void 0:n.includes(`$${t.name}`)))})(t)))&&(e.whereString=null===(r=e.whereString)||void 0===r?void 0:r.replaceAll("')",")"),e.whereString=null===(n=e.whereString)||void 0===n?void 0:n.replaceAll("('","("))}(e,(0,pe.getTemplateSrv)().getVariables()),i(e)}},JSON.stringify(o.value))}function wT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function TT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){wT(i,n,o,a,s,"next",e)}function s(e){wT(i,n,o,a,s,"throw",e)}a(void 0)}))}}$e.injectGlobal`
  .group--header {
    ${bT("row")}
  }

  .group-or-rule {
    ${bT("column")}
    .rule {
      flex-direction: row;
    }
  }

  .rule--body {
    ${bT("row")}
  }

  .group--children {
    ${bT("column")}
  }

  .group--conjunctions:empty {
    display: none;
  }
`;const xT=({query:e,db:t,queryRowFilter:r,onChange:n,onValidate:o,range:i})=>{var a;const s=Se(TT((function*(){return yield t.fields(e)})),[t,e.dataset,e.table]);return(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsxs)(an,{children:[(0,ge.jsx)(pt,{children:(0,ge.jsx)(Hn,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.filter&&(0,ge.jsx)(pt,{children:(0,ge.jsx)(Et,{label:"Filter by column value",optional:!0,children:(0,ge.jsx)(ST,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.group&&(0,ge.jsx)(pt,{children:(0,ge.jsx)(Et,{label:"Group by column",children:(0,ge.jsx)(In,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.order&&(0,ge.jsx)(pt,{children:(0,ge.jsx)(Nn,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.preview&&e.rawSql&&(0,ge.jsx)(pt,{children:(0,ge.jsx)(un,{rawSql:e.rawSql,datasourceType:null===(a=e.datasource)||void 0===a?void 0:a.type})})]}),(0,ge.jsx)(rn,{db:t,query:e,onValidate:o,range:i})]})};function _T(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function CT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){_T(i,n,o,a,s,"next",e)}function s(e){_T(i,n,o,a,s,"throw",e)}a(void 0)}))}}function RT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function IT({datasource:e,query:t,onChange:r,onRunQuery:n,range:o,queryHeaderProps:i}){var a,s,l,u,c,d;const[p,f]=(0,ve.useState)(!0),h=e.getDB(),{preconfiguredDatabase:g}=e;var v;const m=null!==(v=null==i?void 0:i.dialect)&&void 0!==v?v:"other",{loading:y,error:b}=Se(CT((function*(){return()=>{void 0!==e.getDB(e.id).init&&e.getDB(e.id).init()}})),[e]),O=Ae(t),[E,S]=(0,ve.useState)({filter:!!(null===(a=O.sql)||void 0===a?void 0:a.whereString),group:!!(null===(u=O.sql)||void 0===u||null===(l=u.groupBy)||void 0===l||null===(s=l[0])||void 0===s?void 0:s.property.name),order:!!(null===(d=O.sql)||void 0===d||null===(c=d.orderBy)||void 0===c?void 0:c.property.name),preview:!0}),[w,T]=(0,ve.useState)(O);(0,ve.useEffect)((()=>()=>{void 0!==e.getDB(e.id).dispose&&e.getDB(e.id).dispose()}),[e]);const x=(0,ve.useCallback)((e=>{AT(e)&&n&&n()}),[n]),_=(e,t=!0)=>{var n,o,i,a;T(e),r(e),_e(null===(n=e.sql)||void 0===n?void 0:n.columns)&&(null===(o=e.sql)||void 0===o?void 0:o.columns.some((e=>e.name)))&&!E.group&&S((i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){RT(e,t,r[t])}))}return e}({},E),a=null!=(a={group:!0})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i)),t&&x(e)};return y||b?null:(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(Dt,{db:h,preconfiguredDataset:g,onChange:e=>{T(e),r(e)},onRunQuery:n,onQueryRowChange:S,queryRowFilter:E,query:O,isQueryRunnable:p,dialect:m}),(0,ge.jsx)(xe.Space,{v:.5}),O.editorMode!==de.Code&&(0,ge.jsx)(xT,{db:h,query:O,onChange:e=>_(e,!1),queryRowFilter:E,onValidate:f,range:o}),O.editorMode===de.Code&&(0,ge.jsx)(nn,{db:h,query:O,queryToValidate:w,onChange:_,onRunQuery:n,onValidate:f,range:o})]})}const AT=e=>Boolean(e.rawSql);function jT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function PT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){jT(e,t,r[t])}))}return e}function LT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function kT(e){const t="string"==typeof e.rawQuery?e.rawQuery:null;if(!t)return e;var r;const n=Ae(LT(PT({refId:"Annotation"},null!==(r=e.target)&&void 0!==r?r:{}),{rawSql:t}));return LT(PT({},e),{rawQuery:void 0,workspace:void 0,subscription:void 0,queryType:void 0,target:n})}function NT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function DT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){NT(i,n,o,a,s,"next",e)}function s(e){NT(i,n,o,a,s,"throw",e)}a(void 0)}))}}function FT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function MT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){FT(e,t,r[t])}))}return e}function VT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class UT extends pe.DataSourceWithBackend{getResponseParser(){return this.responseParser}interpolateVariablesInQueries(e,t){let r=e;return e&&e.length>0&&(r=e.map((e=>VT(MT({},e),{datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),rawQuery:!0})))),r}filterQuery(e){return!e.hide}applyTemplateVariables(e,t){return{refId:e.refId,datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),format:e.format}}query(e){if(xt()){const t=this.checkForDatabaseIssue(e);if(t){const e=new Error(t);return(0,_.throwError)((()=>e))}}return e.targets.forEach((t=>{var r;e.app!==w.CoreApp.Dashboard&&e.app!==w.CoreApp.PanelViewer&&(0,pe.reportInteraction)("grafana_sql_query_executed",{datasource:null===(r=t.datasource)||void 0===r?void 0:r.type,editorMode:t.editorMode,format:t.format,app:e.app})})),super.query(e)}checkForDatabaseIssue(e){if("postgres"===this.type&&!this.preconfiguredDatabase)return"You do not currently have a default database configured for this data source. Postgres requires a default\n             database with which to connect. Please configure one through the Data Sources Configuration page, or if you\n             are using a provisioning file, update that configuration file with a default database.";if(e.app!==w.CoreApp.Explore&&this.preconfiguredDatabase)for(const t of e.targets)if(t.editorMode===de.Builder&&t.dataset!==this.preconfiguredDatabase)return"The configuration for this panel's data source has been modified. The previous database used in this panel's\n                   saved query is no longer available. Please update the query to use the new database option.\n                   Previous query parameters will be preserved until the query is updated."}metricFindQuery(e,t){var r=this;return DT((function*(){const n=null==t?void 0:t.range;if(null==n)return[];let o="tempvar";t&&t.variable&&t.variable.name&&(o=t.variable.name);const i=MT({},null==t?void 0:t.scopedVars,(0,w.getSearchFilterScopedVar)({query:e,wildcardChar:"%",options:t})),a=r.templateSrv.replace(e,i,r.interpolateVariable),s={refId:o,datasource:r.getRef(),rawSql:a,format:S.Table};let l;try{l=yield r.runMetaQuery(s,n)}catch(e){throw console.error(e),new Error("error when executing the sql query")}return r.getResponseParser().transformMetricFindResponse(l)}))()}runSql(e,t){var r=this;return DT((function*(){const n=(0,w.getDefaultTimeRange)(),o=yield r.runMetaQuery({rawSql:e,format:S.Table,refId:null==t?void 0:t.refId},n);return new w.DataFrameView(o)}))()}runMetaQuery(e,t){const r=e.refId||"meta",n=[VT(MT({},e),{datasource:e.datasource||this.getRef(),refId:r})];return(0,_.lastValueFrom)((0,pe.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",headers:this.getRequestHeaders(),data:{from:t.from.valueOf().toString(),to:t.to.valueOf().toString(),queries:n},requestId:r}).pipe(re((e=>{var t;return null!==(t=(0,pe.toDataQueryResponse)(e,n).data[0])&&void 0!==t?t:{fields:[]}}))))}targetContainsTemplate(e){let t=e.rawSql;return Fn.forEach((e=>{t=(null==t?void 0:t.replace(e,""))||""})),this.templateSrv.containsTemplate(t)}constructor(e,t=(0,pe.getTemplateSrv)()){super(e),FT(this,"templateSrv",void 0),FT(this,"id",void 0),FT(this,"responseParser",void 0),FT(this,"name",void 0),FT(this,"interval",void 0),FT(this,"db",void 0),FT(this,"preconfiguredDatabase",void 0),FT(this,"interpolateVariable",void 0),this.templateSrv=t,this.interpolateVariable=(e,t)=>"string"==typeof e?t.multi||t.includeAll?this.getQueryModel().quoteLiteral(e):String(e).replace(/'/g,"''"):"number"==typeof e?e:Array.isArray(e)?e.map((e=>this.getQueryModel().quoteLiteral(e))).join(","):e,this.name=e.name,this.responseParser=new he,this.id=e.id;const r=e.jsonData||{};var n;this.interval=r.timeInterval||"1m",this.db=this.getDB(),this.preconfiguredDatabase=null!==(n=r.database)&&void 0!==n?n:"",this.annotations={prepareAnnotation:kT,QueryEditor:IT}}}var BT=Object.defineProperty,zT=Object.defineProperties,$T=Object.getOwnPropertyDescriptors,WT=Object.getOwnPropertySymbols,HT=Object.prototype.hasOwnProperty,qT=Object.prototype.propertyIsEnumerable,GT=(e,t,r)=>t in e?BT(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,KT=(e,t)=>{for(var r in t||(t={}))HT.call(t,r)&&GT(e,r,t[r]);if(WT)for(var r of WT(t))qT.call(t,r)&&GT(e,r,t[r]);return e},YT=(e,t)=>zT(e,$T(t));const XT=({children:e,title:t,description:r,isCollapsible:n=!1,isInitiallyOpen:o=!0,kind:i="section",className:a})=>{const{colors:s,typography:l,spacing:u}=(0,xe.useTheme2)(),[c,d]=(0,ve.useState)(!n||o),p=c?"angle-up":"angle-down",f="sub-section"===i,h=`${c?"Collapse":"Expand"} section ${t}`,g={header:(0,$e.css)({display:"flex",justifyContent:"space-between",alignItems:"center"}),title:(0,$e.css)({margin:0}),subtitle:(0,$e.css)({margin:0,fontWeight:l.fontWeightRegular}),descriptionText:(0,$e.css)(YT(KT({marginTop:u(f?.25:.5),marginBottom:0},l.bodySmall),{color:s.text.secondary})),content:(0,$e.css)({marginTop:u(2)})};return ye().createElement("div",{className:a},ye().createElement("div",{className:g.header},"section"===i?ye().createElement("h3",{className:g.title},t):ye().createElement("h6",{className:g.subtitle},t),n&&ye().createElement(xe.IconButton,{name:p,onClick:()=>d(!c),type:"button",size:"xl","aria-label":h})),r&&ye().createElement("p",{className:g.descriptionText},r),c&&ye().createElement("div",{className:g.content},e))};var QT=Object.defineProperty,JT=Object.defineProperties,ZT=Object.getOwnPropertyDescriptors,ex=Object.getOwnPropertySymbols,tx=Object.prototype.hasOwnProperty,rx=Object.prototype.propertyIsEnumerable,nx=(e,t,r)=>t in e?QT(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const ox=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)tx.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&ex)for(var n of ex(e))t.indexOf(n)<0&&rx.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);return ye().createElement(XT,((e,t)=>JT(e,ZT({kind:"sub-section"})))(((e,t)=>{for(var r in t||(t={}))tx.call(t,r)&&nx(e,r,t[r]);if(ex)for(var r of ex(t))rx.call(t,r)&&nx(e,r,t[r]);return e})({},n)),r)};function ix({value:e,defaultValue:t,onChange:r,width:n}){const[o,i]=(0,ve.useState)(!1);return(0,ge.jsx)(xe.Input,{type:"number",placeholder:String(t),value:o?"":e,onChange:e=>{var n;if(""===(null===(n=e.currentTarget.value)||void 0===n?void 0:n.trim()))i(!0),r(t);else{i(!1);const t=Number(e.currentTarget.value);Number.isNaN(t)||r(t)}},width:n})}function ax(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function sx(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){ax(e,t,r[t])}))}return e}const lx=e=>{const{onOptionsChange:t,options:r}=e,n=r.jsonData,o=void 0!==n.maxIdleConnsAuto&&n.maxIdleConnsAuto,i=e=>{const o=(i=sx({},r),a=null!=(a={jsonData:sx({},n,e)})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;return t(o)},a=e=>t=>{i({[e]:t})};return(0,ge.jsxs)(ox,{title:"Connection limits",children:[(0,ge.jsx)(xe.Field,{label:(0,ge.jsx)(xe.Label,{children:(0,ge.jsxs)(ct,{gap:.5,children:[(0,ge.jsx)("span",{children:"Max open"}),(0,ge.jsx)(xe.Tooltip,{content:(0,ge.jsxs)("span",{children:["The maximum number of open connections to the database. If ",(0,ge.jsx)("i",{children:"Max idle connections"})," is greater than 0 and the ",(0,ge.jsx)("i",{children:"Max open connections"})," is less than ",(0,ge.jsx)("i",{children:"Max idle connections"}),", then",(0,ge.jsx)("i",{children:"Max idle connections"})," will be reduced to match the ",(0,ge.jsx)("i",{children:"Max open connections"})," limit. If set to 0, there is no limit on the number of open connections."]}),children:(0,ge.jsx)(xe.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,ge.jsx)(ix,{value:n.maxOpenConns,defaultValue:pe.config.sqlConnectionLimits.maxOpenConns,onChange:e=>{var t;t=e,i(o&&t?{maxOpenConns:t,maxIdleConns:t}:{maxOpenConns:t})},width:40})}),(0,ge.jsx)(xe.Field,{label:(0,ge.jsx)(xe.Label,{children:(0,ge.jsxs)(ct,{gap:.5,children:[(0,ge.jsx)("span",{children:"Auto max idle"}),(0,ge.jsx)(xe.Tooltip,{content:(0,ge.jsxs)("span",{children:["If enabled, automatically set the number of ",(0,ge.jsx)("i",{children:"Maximum idle connections"})," to the same value as",(0,ge.jsx)("i",{children:" Max open connections"}),". If the number of maximum open connections is not set it will be set to the default (",pe.config.sqlConnectionLimits.maxIdleConns,")."]}),children:(0,ge.jsx)(xe.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,ge.jsx)(xe.Switch,{value:o,onChange:()=>{let e,t;o?(t=n.maxOpenConns,e=n.maxIdleConns):void 0!==n.maxOpenConns&&(t=n.maxOpenConns,e=n.maxOpenConns),i({maxIdleConnsAuto:!o,maxIdleConns:e,maxOpenConns:t})}})}),(0,ge.jsx)(xe.Field,{label:(0,ge.jsx)(xe.Label,{children:(0,ge.jsxs)(ct,{gap:.5,children:[(0,ge.jsx)("span",{children:"Max idle"}),(0,ge.jsx)(xe.Tooltip,{content:(0,ge.jsxs)("span",{children:["The maximum number of connections in the idle connection pool.If ",(0,ge.jsx)("i",{children:"Max open connections"})," is greater than 0 but less than the ",(0,ge.jsx)("i",{children:"Max idle connections"}),", then the ",(0,ge.jsx)("i",{children:"Max idle connections"})," ","will be reduced to match the ",(0,ge.jsx)("i",{children:"Max open connections"})," limit. If set to 0, no idle connections are retained."]}),children:(0,ge.jsx)(xe.Icon,{name:"info-circle",size:"sm"})})]})}),children:o?(0,ge.jsx)(xe.InlineLabel,{width:40,children:r.jsonData.maxIdleConns}):(0,ge.jsx)(ix,{value:n.maxIdleConns,defaultValue:pe.config.sqlConnectionLimits.maxIdleConns,onChange:e=>{a("maxIdleConns")(e)},width:40})}),(0,ge.jsx)(xe.Field,{label:(0,ge.jsx)(xe.Label,{children:(0,ge.jsxs)(ct,{gap:.5,children:[(0,ge.jsx)("span",{children:"Max lifetime"}),(0,ge.jsx)(xe.Tooltip,{content:(0,ge.jsx)("span",{children:"The maximum amount of time in seconds a connection may be reused. If set to 0, connections are reused forever."}),children:(0,ge.jsx)(xe.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,ge.jsx)(ix,{value:n.connMaxLifetime,defaultValue:pe.config.sqlConnectionLimits.connMaxLifetime,onChange:e=>{a("connMaxLifetime")(e)},width:40})})]})},ux=(0,pe.createMonitoringLogger)("features.plugins.sql");function cx(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function dx(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){cx(e,t,r[t])}))}return e}function px(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function fx(e){return{ulPadding:(0,$e.css)({margin:e.spacing(1,0),paddingLeft:e.spacing(5)})}}var hx=Object.defineProperty,gx=Object.defineProperties,vx=Object.getOwnPropertyDescriptors,mx=Object.getOwnPropertySymbols,yx=Object.prototype.hasOwnProperty,bx=Object.prototype.propertyIsEnumerable,Ox=(e,t,r)=>t in e?hx(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Ex=(e,t)=>{for(var r in t||(t={}))yx.call(t,r)&&Ox(e,r,t[r]);if(mx)for(var r of mx(t))bx.call(t,r)&&Ox(e,r,t[r]);return e},Sx=(e,t)=>gx(e,vx(t));const wx=({dataSourceName:e,docsLink:t,hasRequiredFields:r=!0,className:n})=>{const o=(0,xe.useTheme2)(),i={container:(0,$e.css)({p:{margin:0},"p + p":{marginTop:o.spacing(2)}}),text:(0,$e.css)(Sx(Ex({},o.typography.body),{color:o.colors.text.secondary,a:(0,$e.css)({color:o.colors.text.link,textDecoration:"underline","&:hover":{textDecoration:"none"}})}))};return ye().createElement("div",{className:(0,$e.cx)(i.container,n)},ye().createElement("p",{className:i.text},"Before you can use the ",e," data source, you must configure it below or in the config file. For detailed instructions,"," ",ye().createElement("a",{href:t,target:"_blank",rel:"noreferrer"},"view the documentation"),"."),r&&ye().createElement("p",{className:i.text},ye().createElement("i",null,"Fields marked with * are required")))};var Tx=Object.defineProperty,xx=Object.defineProperties,_x=Object.getOwnPropertyDescriptors,Cx=Object.getOwnPropertySymbols,Rx=Object.prototype.hasOwnProperty,Ix=Object.prototype.propertyIsEnumerable,Ax=(e,t,r)=>t in e?Tx(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const jx=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)Rx.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Cx)for(var n of Cx(e))t.indexOf(n)<0&&Ix.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);return ye().createElement(XT,((e,t)=>xx(e,_x({kind:"section"})))(((e,t)=>{for(var r in t||(t={}))Rx.call(t,r)&&Ax(e,r,t[r]);if(Cx)for(var r of Cx(t))Ix.call(t,r)&&Ax(e,r,t[r]);return e})({},n)),r)};var Px,Lx,kx,Nx,Dx,Fx;!function(e){e.sqlAuth="SQL Server Authentication",e.windowsAuth="Windows Authentication",e.azureAuth="Azure AD Authentication",e.kerberosRaw="Windows AD: Username + password",e.kerberosKeytab="Windows AD: Keytab",e.kerberosCredentialCache="Windows AD: Credential cache",e.kerberosCredentialCacheLookupFile="Windows AD: Credential cache file"}(Px||(Px={})),function(e){e.disable="disable",e.false="false",e.true="true"}(Lx||(Lx={})),function(e){e.Public="AzureCloud",e.None=""}(kx||(kx={})),(Fx=Nx||(Nx={})).MSI="msi",Fx.CLIENT_SECRET="clientsecret",Fx.AD_PASSWORD="ad-password",function(e){e.Public="AzureCloud",e.None=""}(Dx||(Dx={}));const Mx=[{value:"AzureCloud",label:"Azure"}];function Vx(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ux(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Vx(e,t,r[t])}))}return e}function Bx(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const zx=(e,t)=>{const r=Symbol("Concealed client secret");return e?r:"string"==typeof t&&t.length>0?t:void 0};var $x=v(9874),Wx=v.n($x),Hx=v(857),qx=v.n(Hx);function Gx(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}let Kx=null;const Yx=new WeakMap;function Xx(){return(0,ve.useContext)(Kx||w.ThemeContext)}function Qx(e,...t){const r=Xx();let n=Yx.get(e);return n||(n=qx()(e,{maxSize:10}),Yx.set(e,n)),n(r,...t)}var Jx=function(e){return e.split(/ ?; ?/).reduce((function(e,t){var r=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}(t.split(/ ?: ?/),2),n=r[0],o=r[1];return n&&o&&(e[n.replace(/-(\w)/g,(function(e,t){return t.toUpperCase()}))]=Number.isNaN(Number(o))?o:Number(o)),e}),{})},Zx=["br","col","colgroup","dl","hr","iframe","img","input","link","menuitem","meta","ol","param","select","table","tbody","tfoot","thead","tr","ul","wbr"],e_={"accept-charset":"acceptCharset",acceptcharset:"acceptCharset",accesskey:"accessKey",allowfullscreen:"allowFullScreen",autocapitalize:"autoCapitalize",autocomplete:"autoComplete",autocorrect:"autoCorrect",autofocus:"autoFocus",autoplay:"autoPlay",autosave:"autoSave",cellpadding:"cellPadding",cellspacing:"cellSpacing",charset:"charSet",class:"className",classid:"classID",classname:"className",colspan:"colSpan",contenteditable:"contentEditable",contextmenu:"contextMenu",controlslist:"controlsList",crossorigin:"crossOrigin",dangerouslysetinnerhtml:"dangerouslySetInnerHTML",datetime:"dateTime",defaultchecked:"defaultChecked",defaultvalue:"defaultValue",enctype:"encType",for:"htmlFor",formmethod:"formMethod",formaction:"formAction",formenctype:"formEncType",formnovalidate:"formNoValidate",formtarget:"formTarget",frameborder:"frameBorder",hreflang:"hrefLang",htmlfor:"htmlFor",httpequiv:"httpEquiv","http-equiv":"httpEquiv",icon:"icon",innerhtml:"innerHTML",inputmode:"inputMode",itemid:"itemID",itemprop:"itemProp",itemref:"itemRef",itemscope:"itemScope",itemtype:"itemType",keyparams:"keyParams",keytype:"keyType",marginwidth:"marginWidth",marginheight:"marginHeight",maxlength:"maxLength",mediagroup:"mediaGroup",minlength:"minLength",nomodule:"noModule",novalidate:"noValidate",playsinline:"playsInline",radiogroup:"radioGroup",readonly:"readOnly",referrerpolicy:"referrerPolicy",rowspan:"rowSpan",spellcheck:"spellCheck",srcdoc:"srcDoc",srclang:"srcLang",srcset:"srcSet",tabindex:"tabIndex",typemustmatch:"typeMustMatch",usemap:"useMap",accentheight:"accentHeight","accent-height":"accentHeight",alignmentbaseline:"alignmentBaseline","alignment-baseline":"alignmentBaseline",allowreorder:"allowReorder",arabicform:"arabicForm","arabic-form":"arabicForm",attributename:"attributeName",attributetype:"attributeType",autoreverse:"autoReverse",basefrequency:"baseFrequency",baselineshift:"baselineShift","baseline-shift":"baselineShift",baseprofile:"baseProfile",calcmode:"calcMode",capheight:"capHeight","cap-height":"capHeight",clippath:"clipPath","clip-path":"clipPath",clippathunits:"clipPathUnits",cliprule:"clipRule","clip-rule":"clipRule",colorinterpolation:"colorInterpolation","color-interpolation":"colorInterpolation",colorinterpolationfilters:"colorInterpolationFilters","color-interpolation-filters":"colorInterpolationFilters",colorprofile:"colorProfile","color-profile":"colorProfile",colorrendering:"colorRendering","color-rendering":"colorRendering",contentscripttype:"contentScriptType",contentstyletype:"contentStyleType",diffuseconstant:"diffuseConstant",dominantbaseline:"dominantBaseline","dominant-baseline":"dominantBaseline",edgemode:"edgeMode",enablebackground:"enableBackground","enable-background":"enableBackground",externalresourcesrequired:"externalResourcesRequired",fillopacity:"fillOpacity","fill-opacity":"fillOpacity",fillrule:"fillRule","fill-rule":"fillRule",filterres:"filterRes",filterunits:"filterUnits",floodopacity:"floodOpacity","flood-opacity":"floodOpacity",floodcolor:"floodColor","flood-color":"floodColor",fontfamily:"fontFamily","font-family":"fontFamily",fontsize:"fontSize","font-size":"fontSize",fontsizeadjust:"fontSizeAdjust","font-size-adjust":"fontSizeAdjust",fontstretch:"fontStretch","font-stretch":"fontStretch",fontstyle:"fontStyle","font-style":"fontStyle",fontvariant:"fontVariant","font-variant":"fontVariant",fontweight:"fontWeight","font-weight":"fontWeight",glyphname:"glyphName","glyph-name":"glyphName",glyphorientationhorizontal:"glyphOrientationHorizontal","glyph-orientation-horizontal":"glyphOrientationHorizontal",glyphorientationvertical:"glyphOrientationVertical","glyph-orientation-vertical":"glyphOrientationVertical",glyphref:"glyphRef",gradienttransform:"gradientTransform",gradientunits:"gradientUnits",horizadvx:"horizAdvX","horiz-adv-x":"horizAdvX",horizoriginx:"horizOriginX","horiz-origin-x":"horizOriginX",imagerendering:"imageRendering","image-rendering":"imageRendering",kernelmatrix:"kernelMatrix",kernelunitlength:"kernelUnitLength",keypoints:"keyPoints",keysplines:"keySplines",keytimes:"keyTimes",lengthadjust:"lengthAdjust",letterspacing:"letterSpacing","letter-spacing":"letterSpacing",lightingcolor:"lightingColor","lighting-color":"lightingColor",limitingconeangle:"limitingConeAngle",markerend:"markerEnd","marker-end":"markerEnd",markerheight:"markerHeight",markermid:"markerMid","marker-mid":"markerMid",markerstart:"markerStart","marker-start":"markerStart",markerunits:"markerUnits",markerwidth:"markerWidth",maskcontentunits:"maskContentUnits",maskunits:"maskUnits",numoctaves:"numOctaves",overlineposition:"overlinePosition","overline-position":"overlinePosition",overlinethickness:"overlineThickness","overline-thickness":"overlineThickness",paintorder:"paintOrder","paint-order":"paintOrder","panose-1":"panose1",pathlength:"pathLength",patterncontentunits:"patternContentUnits",patterntransform:"patternTransform",patternunits:"patternUnits",pointerevents:"pointerEvents","pointer-events":"pointerEvents",pointsatx:"pointsAtX",pointsaty:"pointsAtY",pointsatz:"pointsAtZ",preservealpha:"preserveAlpha",preserveaspectratio:"preserveAspectRatio",primitiveunits:"primitiveUnits",refx:"refX",refy:"refY",renderingintent:"renderingIntent","rendering-intent":"renderingIntent",repeatcount:"repeatCount",repeatdur:"repeatDur",requiredextensions:"requiredExtensions",requiredfeatures:"requiredFeatures",shaperendering:"shapeRendering","shape-rendering":"shapeRendering",specularconstant:"specularConstant",specularexponent:"specularExponent",spreadmethod:"spreadMethod",startoffset:"startOffset",stddeviation:"stdDeviation",stitchtiles:"stitchTiles",stopcolor:"stopColor","stop-color":"stopColor",stopopacity:"stopOpacity","stop-opacity":"stopOpacity",strikethroughposition:"strikethroughPosition","strikethrough-position":"strikethroughPosition",strikethroughthickness:"strikethroughThickness","strikethrough-thickness":"strikethroughThickness",strokedasharray:"strokeDasharray","stroke-dasharray":"strokeDasharray",strokedashoffset:"strokeDashoffset","stroke-dashoffset":"strokeDashoffset",strokelinecap:"strokeLinecap","stroke-linecap":"strokeLinecap",strokelinejoin:"strokeLinejoin","stroke-linejoin":"strokeLinejoin",strokemiterlimit:"strokeMiterlimit","stroke-miterlimit":"strokeMiterlimit",strokewidth:"strokeWidth","stroke-width":"strokeWidth",strokeopacity:"strokeOpacity","stroke-opacity":"strokeOpacity",suppresscontenteditablewarning:"suppressContentEditableWarning",suppresshydrationwarning:"suppressHydrationWarning",surfacescale:"surfaceScale",systemlanguage:"systemLanguage",tablevalues:"tableValues",targetx:"targetX",targety:"targetY",textanchor:"textAnchor","text-anchor":"textAnchor",textdecoration:"textDecoration","text-decoration":"textDecoration",textlength:"textLength",textrendering:"textRendering","text-rendering":"textRendering",underlineposition:"underlinePosition","underline-position":"underlinePosition",underlinethickness:"underlineThickness","underline-thickness":"underlineThickness",unicodebidi:"unicodeBidi","unicode-bidi":"unicodeBidi",unicoderange:"unicodeRange","unicode-range":"unicodeRange",unitsperem:"unitsPerEm","units-per-em":"unitsPerEm",unselectable:"unselectable",valphabetic:"vAlphabetic","v-alphabetic":"vAlphabetic",vectoreffect:"vectorEffect","vector-effect":"vectorEffect",vertadvy:"vertAdvY","vert-adv-y":"vertAdvY",vertoriginx:"vertOriginX","vert-origin-x":"vertOriginX",vertoriginy:"vertOriginY","vert-origin-y":"vertOriginY",vhanging:"vHanging","v-hanging":"vHanging",videographic:"vIdeographic","v-ideographic":"vIdeographic",viewbox:"viewBox",viewtarget:"viewTarget",vmathematical:"vMathematical","v-mathematical":"vMathematical",wordspacing:"wordSpacing","word-spacing":"wordSpacing",writingmode:"writingMode","writing-mode":"writingMode",xchannelselector:"xChannelSelector",xheight:"xHeight","x-height":"xHeight",xlinkactuate:"xlinkActuate","xlink:actuate":"xlinkActuate",xlinkarcrole:"xlinkArcrole","xlink:arcrole":"xlinkArcrole",xlinkhref:"xlinkHref","xlink:href":"xlinkHref",xlinkrole:"xlinkRole","xlink:role":"xlinkRole",xlinkshow:"xlinkShow","xlink:show":"xlinkShow",xlinktitle:"xlinkTitle","xlink:title":"xlinkTitle",xlinktype:"xlinkType","xlink:type":"xlinkType",xmlbase:"xmlBase","xml:base":"xmlBase",xmllang:"xmlLang","xml:lang":"xmlLang","xml:space":"xmlSpace",xmlnsxlink:"xmlnsXlink","xmlns:xlink":"xmlnsXlink",xmlspace:"xmlSpace",ychannelselector:"yChannelSelector",zoomandpan:"zoomAndPan",onblur:"onBlur",onchange:"onChange",onclick:"onClick",oncontextmenu:"onContextMenu",ondoubleclick:"onDoubleClick",ondrag:"onDrag",ondragend:"onDragEnd",ondragenter:"onDragEnter",ondragexit:"onDragExit",ondragleave:"onDragLeave",ondragover:"onDragOver",ondragstart:"onDragStart",ondrop:"onDrop",onerror:"onError",onfocus:"onFocus",oninput:"onInput",oninvalid:"onInvalid",onkeydown:"onKeyDown",onkeypress:"onKeyPress",onkeyup:"onKeyUp",onload:"onLoad",onmousedown:"onMouseDown",onmouseenter:"onMouseEnter",onmouseleave:"onMouseLeave",onmousemove:"onMouseMove",onmouseout:"onMouseOut",onmouseover:"onMouseOver",onmouseup:"onMouseUp",onscroll:"onScroll",onsubmit:"onSubmit",ontouchcancel:"onTouchCancel",ontouchend:"onTouchEnd",ontouchmove:"onTouchMove",ontouchstart:"onTouchStart",onwheel:"onWheel"},t_=function(){return t_=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},t_.apply(this,arguments)},r_=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},n_=function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))};function o_(e,t){var r;if(void 0===t&&(t={}),!(e&&e instanceof Node))return null;var n,o=t.actions,i=void 0===o?[]:o,a=t.index,s=void 0===a?0:a,l=t.level,u=void 0===l?0:l,c=t.randomKey,d=e,p="".concat(u,"-").concat(s),f=[];if(c&&0===u&&(p="".concat(function(e){void 0===e&&(e=6);for(var t="",r=e;r>0;--r)t+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.round(61*Math.random())];return t}(),"-").concat(p)),Array.isArray(i)&&i.forEach((function(t){t.condition(d,p,u)&&("function"==typeof t.pre&&((d=t.pre(d,p,u))instanceof Node||(d=e)),"function"==typeof t.post&&f.push(t.post(d,p,u)))})),f.length)return f;switch(d.nodeType){case 1:return ve.createElement((n=d.nodeName,/[a-z]+[A-Z]+[a-z]+/.test(n)?n:n.toLowerCase()),function(e,t){var r={key:t};if(e instanceof Element){var n=e.getAttribute("class");n&&(r.className=n),n_([],r_(e.attributes),!1).forEach((function(e){switch(e.name){case"class":break;case"style":r[e.name]=Jx(e.value);break;case"allowfullscreen":case"allowpaymentrequest":case"async":case"autofocus":case"autoplay":case"checked":case"controls":case"default":case"defer":case"disabled":case"formnovalidate":case"hidden":case"ismap":case"itemscope":case"loop":case"multiple":case"muted":case"nomodule":case"novalidate":case"open":case"readonly":case"required":case"reversed":case"selected":case"typemustmatch":r[e_[e.name]||e.name]=!0;break;default:r[e_[e.name]||e.name]=e.value}}))}return r}(d,p),function(e,t,r){var n=n_([],r_(e),!1).map((function(e,n){return o_(e,t_(t_({},r),{index:n,level:t+1}))})).filter(Boolean);return n.length?n:null}(d.childNodes,u,t));case 3:var h=(null===(r=d.nodeValue)||void 0===r?void 0:r.toString())||"";if(/^\s+$/.test(h)&&!/[\u00A0\u202F]/.test(h))return null;if(!d.parentNode)return h;var g=d.parentNode.nodeName.toLowerCase();return Zx.includes(g)?(/\S/.test(h)&&console.warn("A textNode is not allowed inside '".concat(g,"'. Your text \"").concat(h,'" will be ignored')),null):h;default:return null}}function i_(e,t){return void 0===t&&(t={}),"string"==typeof e?function(e,t){if(void 0===t&&(t={}),!e||"string"!=typeof e)return null;var r=t.nodeOnly,n=void 0!==r&&r,o=t.selector,i=void 0===o?"body > *":o,a=t.type,s=void 0===a?"text/html":a;try{var l=(new DOMParser).parseFromString(e,s).querySelector(i);if(!(l instanceof Node))throw new TypeError("Error parsing input");return n?l:o_(l,t)}catch(e){}return null}(e,t):e instanceof Node?o_(e,t):null}var a_=v(9083),s_={FAILED:"failed",LOADED:"loaded",LOADING:"loading",PENDING:"pending",READY:"ready",UNSUPPORTED:"unsupported"};function l_(){return a_.canUseDOM}var u_=function(){var e=function(t,r){return e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},e(t,r)};return function(t,r){if("function"!=typeof r&&null!==r)throw new TypeError("Class extends value "+String(r)+" is not a constructor or null");function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),c_=function(){return c_=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},c_.apply(this,arguments)},d_=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},p_=Object.create(null),f_=function(e){function t(t){var r=e.call(this,t)||this;return Object.defineProperty(r,"isInitialized",{enumerable:!0,configurable:!0,writable:!0,value:!1}),Object.defineProperty(r,"isActive",{enumerable:!0,configurable:!0,writable:!0,value:!1}),Object.defineProperty(r,"hash",{enumerable:!0,configurable:!0,writable:!0,value:void 0}),Object.defineProperty(r,"handleLoad",{enumerable:!0,configurable:!0,writable:!0,value:function(e,t){void 0===t&&(t=!1),r.isActive&&r.setState({content:e,hasCache:t,status:s_.LOADED},r.getElement)}}),Object.defineProperty(r,"handleError",{enumerable:!0,configurable:!0,writable:!0,value:function(e){var t=r.props.onError,n="Browser does not support SVG"===e.message?s_.UNSUPPORTED:s_.FAILED;r.isActive&&r.setState({status:n},(function(){"function"==typeof t&&t(e)}))}}),Object.defineProperty(r,"request",{enumerable:!0,configurable:!0,writable:!0,value:function(){var e=r.props,t=e.cacheRequests,n=e.fetchOptions,o=e.src;try{return t&&(p_[o]={content:"",status:s_.LOADING}),fetch(o,n).then((function(e){var t=e.headers.get("content-type"),r=d_((t||"").split(/ ?; ?/),1)[0];if(e.status>299)throw new Error("Not found");if(!["image/svg+xml","text/plain"].some((function(e){return r.includes(e)})))throw new Error("Content type isn't valid: ".concat(r));return e.text()})).then((function(e){var n=r.props.src;if(o===n){if(r.handleLoad(e),t){var i=p_[o];i&&(i.content=e,i.status=s_.LOADED)}}else p_[o].status===s_.LOADING&&delete p_[o]})).catch((function(e){r.handleError(e),t&&p_[o]&&delete p_[o]}))}catch(e){return r.handleError(new Error(e.message))}}}),r.state={content:"",element:null,hasCache:!!t.cacheRequests&&!!p_[t.src],status:s_.PENDING},r.hash=t.uniqueHash||function(e){for(var t="abcdefghijklmnopqrstuvwxyz",r="".concat(t).concat(t.toUpperCase()).concat("1234567890"),n="",o=0;o<8;o++)n+=(i=r)[Math.floor(Math.random()*i.length)];var i;return n}(),r}return u_(t,e),Object.defineProperty(t.prototype,"componentDidMount",{enumerable:!1,configurable:!0,writable:!0,value:function(){if(this.isActive=!0,l_()&&!this.isInitialized){var e=this.state.status,t=this.props.src;try{if(e===s_.PENDING){if(!function(){if(!document)return!1;var e=document.createElement("div");e.innerHTML="<svg />";var t=e.firstChild;return!!t&&"http://www.w3.org/2000/svg"===t.namespaceURI}()||"undefined"==typeof window||null===window)throw new Error("Browser does not support SVG");if(!t)throw new Error("Missing src");this.load()}}catch(e){this.handleError(e)}this.isInitialized=!0}}}),Object.defineProperty(t.prototype,"componentDidUpdate",{enumerable:!1,configurable:!0,writable:!0,value:function(e,t){if(l_()){var r=this.state,n=r.hasCache,o=r.status,i=this.props,a=i.onLoad,s=i.src;if(t.status!==s_.READY&&o===s_.READY&&a&&a(s,n),e.src!==s){if(!s)return void this.handleError(new Error("Missing src"));this.load()}}}}),Object.defineProperty(t.prototype,"componentWillUnmount",{enumerable:!1,configurable:!0,writable:!0,value:function(){this.isActive=!1}}),Object.defineProperty(t.prototype,"getNode",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.props,t=e.description,r=e.title;try{var n=i_(this.processSVG(),{nodeOnly:!0});if(!(n&&n instanceof SVGSVGElement))throw new Error("Could not convert the src to a DOM Node");var o=this.updateSVGAttributes(n);if(t){var i=o.querySelector("desc");i&&i.parentNode&&i.parentNode.removeChild(i);var a=document.createElementNS("http://www.w3.org/2000/svg","desc");a.innerHTML=t,o.prepend(a)}if(void 0!==r){var s=o.querySelector("title");if(s&&s.parentNode&&s.parentNode.removeChild(s),r){var l=document.createElementNS("http://www.w3.org/2000/svg","title");l.innerHTML=r,o.prepend(l)}}return o}catch(e){return this.handleError(e)}}}),Object.defineProperty(t.prototype,"getElement",{enumerable:!1,configurable:!0,writable:!0,value:function(){try{var e=i_(this.getNode());if(!e||!ve.isValidElement(e))throw new Error("Could not convert the src to a React element");this.setState({element:e,status:s_.READY})}catch(e){this.handleError(new Error(e.message))}}}),Object.defineProperty(t.prototype,"load",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this;this.isActive&&this.setState({content:"",element:null,hasCache:!1,status:s_.LOADING},(function(){var t=e.props,r=t.cacheRequests,n=t.src,o=r&&p_[n];if(o&&o.status===s_.LOADED)e.handleLoad(o.content,!0);else{var i,a=n.match(/data:image\/svg[^,]*?(;base64)?,(.*)/);a?i=a[1]?window.atob(a[2]):decodeURIComponent(a[2]):n.includes("<svg")&&(i=n),i?e.handleLoad(i):e.request()}}))}}),Object.defineProperty(t.prototype,"updateSVGAttributes",{enumerable:!1,configurable:!0,writable:!0,value:function(e){var t=this,r=this.props,n=r.baseURL,o=void 0===n?"":n,i=r.uniquifyIDs,a=["id","href","xlink:href","xlink:role","xlink:arcrole"],s=["href","xlink:href"];return i?(function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}([],d_(e.children),!1).map((function(e){if(e.attributes&&e.attributes.length){var r=Object.values(e.attributes).map((function(e){var r=e,n=e.value.match(/url\((.*?)\)/);return n&&n[1]&&(r.value=e.value.replace(n[0],"url(".concat(o).concat(n[1],"__").concat(t.hash,")"))),r}));a.forEach((function(e){var n,o,i=r.find((function(t){return t.name===e}));i&&(n=e,o=i.value,!s.includes(n)||!o||o.includes("#"))&&(i.value="".concat(i.value,"__").concat(t.hash))}))}return e.children.length?t.updateSVGAttributes(e):e})),e):e}}),Object.defineProperty(t.prototype,"processSVG",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.state.content,t=this.props.preProcessor;return t?t(e):e}}),Object.defineProperty(t.prototype,"render",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.state,t=e.element,r=e.status,n=this.props,o=n.children,i=void 0===o?null:o,a=n.innerRef,s=n.loader,l=void 0===s?null:s,u=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];var n={};for(var o in e)({}).hasOwnProperty.call(e,o)&&(t.includes(o)||(n[o]=e[o]));return n}(this.props,"baseURL","cacheRequests","children","description","fetchOptions","innerRef","loader","onError","onLoad","preProcessor","src","title","uniqueHash","uniquifyIDs");return l_()?t?ve.cloneElement(t,c_({ref:a},u)):[s_.UNSUPPORTED,s_.FAILED].includes(r)?i:l:l}}),Object.defineProperty(t,"defaultProps",{enumerable:!0,configurable:!0,writable:!0,value:{cacheRequests:!0,uniquifyIDs:!1}}),t}(ve.PureComponent);const h_=f_,g_=(0,$e.keyframes)({"0%":{transform:"rotate(0deg)"},"100%":{transform:"rotate(359deg)"}}),v_=["grafana","favorite","heart-break","heart","panel-add","library-panel","circle-mono"];function m_(e,t){return(null==e?void 0:e.startsWith("gf-"))?"custom":v_.includes(e)?"mono":"default"===t?"unicons":"solid"===t?"solid":"mono"}function y_(e){switch(e){case"xs":return 12;case"sm":return 14;case"md":return 16;case"lg":return 18;case"xl":return 24;case"xxl":return 36;case"xxxl":return 48}}let b_;function O_(){if(b_)return b_;const e="undefined"!=typeof window&&window.__grafana_public_path__;return b_=e?e+"img/icons/":"public/img/icons/",b_}function E_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const S_=e=>({icon:(0,$e.css)({display:"inline-block",fill:"currentColor",flexShrink:0,label:"Icon",lineHeight:0,verticalAlign:"middle"}),orange:(0,$e.css)({fill:e.v1.palette.orange}),spin:(0,$e.css)({[e.transitions.handleMotion("no-preference","reduce")]:{animation:`${g_} 2s infinite linear`}})}),w_=ve.forwardRef(((e,t)=>{var{size:r="md",type:n="default",name:o,className:i,style:a,title:s=""}=e,l=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["size","type","name","className","style","title"]);const u=Qx(S_);(0,w.isIconName)(o)||console.warn("Icon component passed an invalid icon name",o);const c="fa fa-spinner"===o?"spinner":o,d=O_(),p=y_(r),f=p,h=o.startsWith("gf-bar-align")?16:o.startsWith("gf-interp")?30:p,g=`${d}${m_(c,n)}/${c}.svg`,v=(0,$e.cx)(u.icon,i,"mono"===n?{[u.orange]:"favorite"===o}:"",{[u.spin]:"spinner"===c});return(0,ge.jsx)(h_,function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){E_(e,t,r[t])}))}return e}({"aria-hidden":!(void 0!==l.tabIndex||s||l["aria-label"]||l["aria-labelledby"]||l["aria-describedby"]),innerRef:t,src:g,width:h,height:f,title:s,className:v,style:a},l))}));w_.displayName="Icon";const T_=({children:e,horizontal:t,className:r})=>{const n=Qx(x_),o=(0,$e.cx)(t?n.horizontal:n.vertical,r);return(0,ge.jsxs)("div",{role:"alert",className:o,children:[(0,ge.jsx)(w_,{className:n.fieldValidationMessageIcon,name:"exclamation-triangle"}),e]})},x_=e=>{const t=`\n      font-size: ${e.typography.size.sm};\n      font-weight: ${e.typography.fontWeightMedium};\n      padding: ${e.spacing(.5,1)};\n      color: ${e.colors.error.contrastText};\n      background: ${e.colors.error.main};\n      border-radius: ${e.shape.radius.default};\n      position: relative;\n      display: inline-block;\n      align-self: flex-start;\n\n      a {\n        color: ${e.colors.error.contrastText};\n        text-decoration: underline;\n      }\n\n      a:hover {\n        text-decoration: none;\n      }\n    `;return{vertical:(0,$e.css)(t,{margin:e.spacing(.5,0,0,0),"&:before":{content:'""',position:"absolute",left:"9px",top:"-5px",width:0,height:0,borderWidth:"0 4px 5px 4px",borderColor:`transparent transparent ${e.colors.error.main} transparent`,borderStyle:"solid"}}),horizontal:(0,$e.css)(t,{marginLeft:"10px","&:before":{content:'""',position:"absolute",left:"-5px",top:"9px",width:0,height:0,borderWidth:"4px 5px 4px 0",borderColor:"transparent #e02f44 transparent transparent",borderStyle:"solid"}}),fieldValidationMessageIcon:(0,$e.css)({marginRight:e.spacing()})}};function __(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function C_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){__(e,t,r[t])}))}return e}const R_=e=>{var{children:t,description:r,className:n,category:o}=e,i=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["children","description","className","category"]);const a=Qx(I_),s=null==o?void 0:o.map(((e,t)=>(0,ge.jsxs)("span",{className:a.categories,children:[(0,ge.jsx)("span",{children:e}),(0,ge.jsx)(w_,{name:"angle-right",className:a.chevron})]},`${e}/${t}`)));return(0,ge.jsx)("div",{className:(0,$e.cx)(a.label,n),children:(0,ge.jsxs)("label",(l=C_({},i),u={children:[(0,ge.jsxs)("div",{className:a.labelContent,children:[s,t]}),r&&(0,ge.jsx)("span",{className:a.description,children:r})]},u=null!=u?u:{},Object.getOwnPropertyDescriptors?Object.defineProperties(l,Object.getOwnPropertyDescriptors(u)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(u)).forEach((function(e){Object.defineProperty(l,e,Object.getOwnPropertyDescriptor(u,e))})),l))});var l,u},I_=e=>({label:(0,$e.css)({label:"Label",fontSize:e.typography.size.sm,fontWeight:e.typography.fontWeightMedium,lineHeight:1.25,marginBottom:e.spacing(.5),color:e.colors.text.primary,maxWidth:"480px"}),labelContent:(0,$e.css)({display:"flex",alignItems:"center"}),description:(0,$e.css)({label:"Label-description",color:e.colors.text.secondary,fontSize:e.typography.size.sm,fontWeight:e.typography.fontWeightRegular,marginTop:e.spacing(.25),display:"block"}),categories:(0,$e.css)({label:"Label-categories",display:"inline-flex",alignItems:"center"}),chevron:(0,$e.css)({margin:e.spacing(0,.25)})});function A_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const j_=ve.forwardRef(((e,t)=>{var{label:r,description:n,horizontal:o,invalid:i,loading:a,disabled:s,required:l,error:u,children:c,className:d,validationMessageHorizontalOverflow:p,htmlFor:f}=e,h=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["label","description","horizontal","invalid","loading","disabled","required","error","children","className","validationMessageHorizontalOverflow","htmlFor"]);const g=Qx(P_),v=null!=f?f:function(e){let t;const r=ve.Children.only(e);return"id"in(null==r?void 0:r.props)?t=r.props.id:"inputId"in r.props&&(t=null==r?void 0:r.props.inputId),"string"==typeof t?t:void 0}(c),m="string"==typeof r?(0,ge.jsx)(R_,{htmlFor:v,description:n,children:`${r}${l?" *":""}`}):r,y=function(e){for(const t in e)void 0===e[t]&&delete e[t];return e}({invalid:i,disabled:s,loading:a});return(0,ge.jsxs)("div",(b=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){A_(e,t,r[t])}))}return e}({className:(0,$e.cx)(g.field,o&&g.fieldHorizontal,d)},h),O=null!=(O={children:[m,(0,ge.jsxs)("div",{children:[(0,ge.jsx)("div",{ref:t,children:ve.cloneElement(c,y)}),i&&u&&!o&&(0,ge.jsx)("div",{className:(0,$e.cx)(g.fieldValidationWrapper,{[g.validationMessageHorizontalOverflow]:!!p}),children:(0,ge.jsx)(T_,{children:u})})]}),i&&u&&o&&(0,ge.jsx)("div",{className:(0,$e.cx)(g.fieldValidationWrapper,g.fieldValidationWrapperHorizontal,{[g.validationMessageHorizontalOverflow]:!!p}),children:(0,ge.jsx)(T_,{children:u})})]})?O:{},Object.getOwnPropertyDescriptors?Object.defineProperties(b,Object.getOwnPropertyDescriptors(O)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(O)).forEach((function(e){Object.defineProperty(b,e,Object.getOwnPropertyDescriptor(O,e))})),b));var b,O}));j_.displayName="Field";const P_=e=>({field:(0,$e.css)({display:"flex",flexDirection:"column",marginBottom:e.spacing(2)}),fieldHorizontal:(0,$e.css)({flexDirection:"row",justifyContent:"space-between",flexWrap:"wrap"}),fieldValidationWrapper:(0,$e.css)({marginTop:e.spacing(.5)}),fieldValidationWrapperHorizontal:(0,$e.css)({flex:"1 1 100%"}),validationMessageHorizontalOverflow:(0,$e.css)({width:0,overflowX:"visible","& > *":{whiteSpace:"nowrap"}})});function L_(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function k_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?L_(Object(r),!0).forEach((function(t){no(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):L_(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var N_=["defaultInputValue","defaultMenuIsOpen","defaultValue","inputValue","menuIsOpen","onChange","onInputChange","onMenuClose","onMenuOpen","value"];function D_(e){var t=e.defaultInputValue,r=void 0===t?"":t,n=e.defaultMenuIsOpen,o=void 0!==n&&n,i=e.defaultValue,a=void 0===i?null:i,s=e.inputValue,l=e.menuIsOpen,u=e.onChange,c=e.onInputChange,d=e.onMenuClose,p=e.onMenuOpen,f=e.value,h=nm(e,N_),g=lo((0,ve.useState)(void 0!==s?s:r),2),v=g[0],m=g[1],y=lo((0,ve.useState)(void 0!==l?l:o),2),b=y[0],O=y[1],E=lo((0,ve.useState)(void 0!==f?f:a),2),S=E[0],w=E[1],T=(0,ve.useCallback)((function(e,t){"function"==typeof u&&u(e,t),w(e)}),[u]),x=(0,ve.useCallback)((function(e,t){var r;"function"==typeof c&&(r=c(e,t)),m(void 0!==r?r:e)}),[c]),_=(0,ve.useCallback)((function(){"function"==typeof p&&p(),O(!0)}),[p]),C=(0,ve.useCallback)((function(){"function"==typeof d&&d(),O(!1)}),[d]),R=void 0!==s?s:v,I=void 0!==l?l:b,A=void 0!==f?f:S;return k_(k_({},h),{},{inputValue:R,menuIsOpen:I,onChange:T,onInputChange:x,onMenuClose:C,onMenuOpen:_,value:A})}function F_(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(F_=function(){return!!e})()}var M_=v(9089),V_=v(8398),U_=v.n(V_);const B_=Math.min,z_=Math.max,$_=Math.round,W_=Math.floor,H_=e=>({x:e,y:e}),q_={left:"right",right:"left",bottom:"top",top:"bottom"},G_={start:"end",end:"start"};function K_(e,t,r){return z_(e,B_(t,r))}function Y_(e,t){return"function"==typeof e?e(t):e}function X_(e){return e.split("-")[0]}function Q_(e){return e.split("-")[1]}function J_(e){return"x"===e?"y":"x"}function Z_(e){return"y"===e?"height":"width"}function eC(e){return["top","bottom"].includes(X_(e))?"y":"x"}function tC(e){return J_(eC(e))}function rC(e){return e.replace(/start|end/g,(e=>G_[e]))}function nC(e){return e.replace(/left|right|bottom|top/g,(e=>q_[e]))}function oC(e){return"number"!=typeof e?function(e){return{top:0,right:0,bottom:0,left:0,...e}}(e):{top:e,right:e,bottom:e,left:e}}function iC(e){const{x:t,y:r,width:n,height:o}=e;return{width:n,height:o,top:r,left:t,right:t+n,bottom:r+o,x:t,y:r}}function aC(e,t,r){let{reference:n,floating:o}=e;const i=eC(t),a=tC(t),s=Z_(a),l=X_(t),u="y"===i,c=n.x+n.width/2-o.width/2,d=n.y+n.height/2-o.height/2,p=n[s]/2-o[s]/2;let f;switch(l){case"top":f={x:c,y:n.y-o.height};break;case"bottom":f={x:c,y:n.y+n.height};break;case"right":f={x:n.x+n.width,y:d};break;case"left":f={x:n.x-o.width,y:d};break;default:f={x:n.x,y:n.y}}switch(Q_(t)){case"start":f[a]-=p*(r&&u?-1:1);break;case"end":f[a]+=p*(r&&u?-1:1)}return f}async function sC(e,t){var r;void 0===t&&(t={});const{x:n,y:o,platform:i,rects:a,elements:s,strategy:l}=e,{boundary:u="clippingAncestors",rootBoundary:c="viewport",elementContext:d="floating",altBoundary:p=!1,padding:f=0}=Y_(t,e),h=oC(f),g=s[p?"floating"===d?"reference":"floating":d],v=iC(await i.getClippingRect({element:null==(r=await(null==i.isElement?void 0:i.isElement(g)))||r?g:g.contextElement||await(null==i.getDocumentElement?void 0:i.getDocumentElement(s.floating)),boundary:u,rootBoundary:c,strategy:l})),m="floating"===d?{x:n,y:o,width:a.floating.width,height:a.floating.height}:a.reference,y=await(null==i.getOffsetParent?void 0:i.getOffsetParent(s.floating)),b=await(null==i.isElement?void 0:i.isElement(y))&&await(null==i.getScale?void 0:i.getScale(y))||{x:1,y:1},O=iC(i.convertOffsetParentRelativeRectToViewportRelativeRect?await i.convertOffsetParentRelativeRectToViewportRelativeRect({elements:s,rect:m,offsetParent:y,strategy:l}):m);return{top:(v.top-O.top+h.top)/b.y,bottom:(O.bottom-v.bottom+h.bottom)/b.y,left:(v.left-O.left+h.left)/b.x,right:(O.right-v.right+h.right)/b.x}}function lC(){return"undefined"!=typeof window}function uC(e){return pC(e)?(e.nodeName||"").toLowerCase():"#document"}function cC(e){var t;return(null==e||null==(t=e.ownerDocument)?void 0:t.defaultView)||window}function dC(e){var t;return null==(t=(pC(e)?e.ownerDocument:e.document)||window.document)?void 0:t.documentElement}function pC(e){return!!lC()&&(e instanceof Node||e instanceof cC(e).Node)}function fC(e){return!!lC()&&(e instanceof Element||e instanceof cC(e).Element)}function hC(e){return!!lC()&&(e instanceof HTMLElement||e instanceof cC(e).HTMLElement)}function gC(e){return!(!lC()||"undefined"==typeof ShadowRoot)&&(e instanceof ShadowRoot||e instanceof cC(e).ShadowRoot)}function vC(e){const{overflow:t,overflowX:r,overflowY:n,display:o}=SC(e);return/auto|scroll|overlay|hidden|clip/.test(t+n+r)&&!["inline","contents"].includes(o)}function mC(e){return["table","td","th"].includes(uC(e))}function yC(e){return[":popover-open",":modal"].some((t=>{try{return e.matches(t)}catch(e){return!1}}))}function bC(e){const t=OC(),r=fC(e)?SC(e):e;return"none"!==r.transform||"none"!==r.perspective||!!r.containerType&&"normal"!==r.containerType||!t&&!!r.backdropFilter&&"none"!==r.backdropFilter||!t&&!!r.filter&&"none"!==r.filter||["transform","perspective","filter"].some((e=>(r.willChange||"").includes(e)))||["paint","layout","strict","content"].some((e=>(r.contain||"").includes(e)))}function OC(){return!("undefined"==typeof CSS||!CSS.supports)&&CSS.supports("-webkit-backdrop-filter","none")}function EC(e){return["html","body","#document"].includes(uC(e))}function SC(e){return cC(e).getComputedStyle(e)}function wC(e){return fC(e)?{scrollLeft:e.scrollLeft,scrollTop:e.scrollTop}:{scrollLeft:e.scrollX,scrollTop:e.scrollY}}function TC(e){if("html"===uC(e))return e;const t=e.assignedSlot||e.parentNode||gC(e)&&e.host||dC(e);return gC(t)?t.host:t}function xC(e){const t=TC(e);return EC(t)?e.ownerDocument?e.ownerDocument.body:e.body:hC(t)&&vC(t)?t:xC(t)}function _C(e,t,r){var n;void 0===t&&(t=[]),void 0===r&&(r=!0);const o=xC(e),i=o===(null==(n=e.ownerDocument)?void 0:n.body),a=cC(o);if(i){const e=function(e){return e.parent&&Object.getPrototypeOf(e.parent)?e.frameElement:null}(a);return t.concat(a,a.visualViewport||[],vC(o)?o:[],e&&r?_C(e):[])}return t.concat(o,_C(o,[],r))}function CC(e){const t=SC(e);let r=parseFloat(t.width)||0,n=parseFloat(t.height)||0;const o=hC(e),i=o?e.offsetWidth:r,a=o?e.offsetHeight:n,s=$_(r)!==i||$_(n)!==a;return s&&(r=i,n=a),{width:r,height:n,$:s}}function RC(e){return fC(e)?e:e.contextElement}function IC(e){const t=RC(e);if(!hC(t))return H_(1);const r=t.getBoundingClientRect(),{width:n,height:o,$:i}=CC(t);let a=(i?$_(r.width):r.width)/n,s=(i?$_(r.height):r.height)/o;return a&&Number.isFinite(a)||(a=1),s&&Number.isFinite(s)||(s=1),{x:a,y:s}}const AC=H_(0);function jC(e){const t=cC(e);return OC()&&t.visualViewport?{x:t.visualViewport.offsetLeft,y:t.visualViewport.offsetTop}:AC}function PC(e,t,r,n){void 0===t&&(t=!1),void 0===r&&(r=!1);const o=e.getBoundingClientRect(),i=RC(e);let a=H_(1);t&&(n?fC(n)&&(a=IC(n)):a=IC(e));const s=function(e,t,r){return void 0===t&&(t=!1),!(!r||t&&r!==cC(e))&&t}(i,r,n)?jC(i):H_(0);let l=(o.left+s.x)/a.x,u=(o.top+s.y)/a.y,c=o.width/a.x,d=o.height/a.y;if(i){const e=cC(i),t=n&&fC(n)?cC(n):n;let r=e,o=r.frameElement;for(;o&&n&&t!==r;){const e=IC(o),t=o.getBoundingClientRect(),n=SC(o),i=t.left+(o.clientLeft+parseFloat(n.paddingLeft))*e.x,a=t.top+(o.clientTop+parseFloat(n.paddingTop))*e.y;l*=e.x,u*=e.y,c*=e.x,d*=e.y,l+=i,u+=a,r=cC(o),o=r.frameElement}}return iC({width:c,height:d,x:l,y:u})}const LC=[":popover-open",":modal"];function kC(e){return LC.some((t=>{try{return e.matches(t)}catch(e){return!1}}))}function NC(e){return PC(dC(e)).left+wC(e).scrollLeft}function DC(e,t,r){let n;if("viewport"===t)n=function(e,t){const r=cC(e),n=dC(e),o=r.visualViewport;let i=n.clientWidth,a=n.clientHeight,s=0,l=0;if(o){i=o.width,a=o.height;const e=OC();(!e||e&&"fixed"===t)&&(s=o.offsetLeft,l=o.offsetTop)}return{width:i,height:a,x:s,y:l}}(e,r);else if("document"===t)n=function(e){const t=dC(e),r=wC(e),n=e.ownerDocument.body,o=z_(t.scrollWidth,t.clientWidth,n.scrollWidth,n.clientWidth),i=z_(t.scrollHeight,t.clientHeight,n.scrollHeight,n.clientHeight);let a=-r.scrollLeft+NC(e);const s=-r.scrollTop;return"rtl"===SC(n).direction&&(a+=z_(t.clientWidth,n.clientWidth)-o),{width:o,height:i,x:a,y:s}}(dC(e));else if(fC(t))n=function(e,t){const r=PC(e,!0,"fixed"===t),n=r.top+e.clientTop,o=r.left+e.clientLeft,i=hC(e)?IC(e):H_(1);return{width:e.clientWidth*i.x,height:e.clientHeight*i.y,x:o*i.x,y:n*i.y}}(t,r);else{const r=jC(e);n={...t,x:t.x-r.x,y:t.y-r.y}}return iC(n)}function FC(e,t){const r=TC(e);return!(r===t||!fC(r)||EC(r))&&("fixed"===SC(r).position||FC(r,t))}function MC(e,t,r){const n=hC(t),o=dC(t),i="fixed"===r,a=PC(e,!0,i,t);let s={scrollLeft:0,scrollTop:0};const l=H_(0);if(n||!n&&!i)if(("body"!==uC(t)||vC(o))&&(s=wC(t)),n){const e=PC(t,!0,i,t);l.x=e.x+t.clientLeft,l.y=e.y+t.clientTop}else o&&(l.x=NC(o));return{x:a.left+s.scrollLeft-l.x,y:a.top+s.scrollTop-l.y,width:a.width,height:a.height}}function VC(e){return"static"===SC(e).position}function UC(e,t){return hC(e)&&"fixed"!==SC(e).position?t?t(e):e.offsetParent:null}function BC(e,t){const r=cC(e);if(kC(e))return r;if(!hC(e)){let t=TC(e);for(;t&&!EC(t);){if(fC(t)&&!VC(t))return t;t=TC(t)}return r}let n=UC(e,t);for(;n&&mC(n)&&VC(n);)n=UC(n,t);return n&&EC(n)&&VC(n)&&!bC(n)?r:n||function(e){let t=TC(e);for(;hC(t)&&!EC(t);){if(bC(t))return t;if(yC(t))return null;t=TC(t)}return null}(e)||r}const zC={convertOffsetParentRelativeRectToViewportRelativeRect:function(e){let{elements:t,rect:r,offsetParent:n,strategy:o}=e;const i="fixed"===o,a=dC(n),s=!!t&&kC(t.floating);if(n===a||s&&i)return r;let l={scrollLeft:0,scrollTop:0},u=H_(1);const c=H_(0),d=hC(n);if((d||!d&&!i)&&(("body"!==uC(n)||vC(a))&&(l=wC(n)),hC(n))){const e=PC(n);u=IC(n),c.x=e.x+n.clientLeft,c.y=e.y+n.clientTop}return{width:r.width*u.x,height:r.height*u.y,x:r.x*u.x-l.scrollLeft*u.x+c.x,y:r.y*u.y-l.scrollTop*u.y+c.y}},getDocumentElement:dC,getClippingRect:function(e){let{element:t,boundary:r,rootBoundary:n,strategy:o}=e;const i=[..."clippingAncestors"===r?kC(t)?[]:function(e,t){const r=t.get(e);if(r)return r;let n=_C(e,[],!1).filter((e=>fC(e)&&"body"!==uC(e))),o=null;const i="fixed"===SC(e).position;let a=i?TC(e):e;for(;fC(a)&&!EC(a);){const t=SC(a),r=bC(a);r||"fixed"!==t.position||(o=null),(i?!r&&!o:!r&&"static"===t.position&&o&&["absolute","fixed"].includes(o.position)||vC(a)&&!r&&FC(e,a))?n=n.filter((e=>e!==a)):o=t,a=TC(a)}return t.set(e,n),n}(t,this._c):[].concat(r),n],a=i[0],s=i.reduce(((e,r)=>{const n=DC(t,r,o);return e.top=z_(n.top,e.top),e.right=B_(n.right,e.right),e.bottom=B_(n.bottom,e.bottom),e.left=z_(n.left,e.left),e}),DC(t,a,o));return{width:s.right-s.left,height:s.bottom-s.top,x:s.left,y:s.top}},getOffsetParent:BC,getElementRects:async function(e){const t=this.getOffsetParent||BC,r=this.getDimensions,n=await r(e.floating);return{reference:MC(e.reference,await t(e.floating),e.strategy),floating:{x:0,y:0,width:n.width,height:n.height}}},getClientRects:function(e){return Array.from(e.getClientRects())},getDimensions:function(e){const{width:t,height:r}=CC(e);return{width:t,height:r}},getScale:IC,isElement:fC,isRTL:function(e){return"rtl"===SC(e).direction}};function $C(e,t,r,n){void 0===n&&(n={});const{ancestorScroll:o=!0,ancestorResize:i=!0,elementResize:a="function"==typeof ResizeObserver,layoutShift:s="function"==typeof IntersectionObserver,animationFrame:l=!1}=n,u=RC(e),c=o||i?[...u?_C(u):[],..._C(t)]:[];c.forEach((e=>{o&&e.addEventListener("scroll",r,{passive:!0}),i&&e.addEventListener("resize",r)}));const d=u&&s?function(e,t){let r,n=null;const o=dC(e);function i(){var e;clearTimeout(r),null==(e=n)||e.disconnect(),n=null}return function a(s,l){void 0===s&&(s=!1),void 0===l&&(l=1),i();const{left:u,top:c,width:d,height:p}=e.getBoundingClientRect();if(s||t(),!d||!p)return;const f={rootMargin:-W_(c)+"px "+-W_(o.clientWidth-(u+d))+"px "+-W_(o.clientHeight-(c+p))+"px "+-W_(u)+"px",threshold:z_(0,B_(1,l))||1};let h=!0;function g(e){const t=e[0].intersectionRatio;if(t!==l){if(!h)return a();t?a(!1,t):r=setTimeout((()=>{a(!1,1e-7)}),1e3)}h=!1}try{n=new IntersectionObserver(g,{...f,root:o.ownerDocument})}catch(e){n=new IntersectionObserver(g,f)}n.observe(e)}(!0),i}(u,r):null;let p,f=-1,h=null;a&&(h=new ResizeObserver((e=>{let[n]=e;n&&n.target===u&&h&&(h.unobserve(t),cancelAnimationFrame(f),f=requestAnimationFrame((()=>{var e;null==(e=h)||e.observe(t)}))),r()})),u&&!l&&h.observe(u),h.observe(t));let g=l?PC(e):null;return l&&function t(){const n=PC(e);!g||n.x===g.x&&n.y===g.y&&n.width===g.width&&n.height===g.height||r(),g=n,p=requestAnimationFrame(t)}(),r(),()=>{var e;c.forEach((e=>{o&&e.removeEventListener("scroll",r),i&&e.removeEventListener("resize",r)})),null==d||d(),null==(e=h)||e.disconnect(),h=null,l&&cancelAnimationFrame(p)}}const WC=function(e){return void 0===e&&(e=0),{name:"offset",options:e,async fn(t){var r,n;const{x:o,y:i,placement:a,middlewareData:s}=t,l=await async function(e,t){const{placement:r,platform:n,elements:o}=e,i=await(null==n.isRTL?void 0:n.isRTL(o.floating)),a=X_(r),s=Q_(r),l="y"===eC(r),u=["left","top"].includes(a)?-1:1,c=i&&l?-1:1,d=Y_(t,e);let{mainAxis:p,crossAxis:f,alignmentAxis:h}="number"==typeof d?{mainAxis:d,crossAxis:0,alignmentAxis:null}:{mainAxis:0,crossAxis:0,alignmentAxis:null,...d};return s&&"number"==typeof h&&(f="end"===s?-1*h:h),l?{x:f*c,y:p*u}:{x:p*u,y:f*c}}(t,e);return a===(null==(r=s.offset)?void 0:r.placement)&&null!=(n=s.arrow)&&n.alignmentOffset?{}:{x:o+l.x,y:i+l.y,data:{...l,placement:a}}}}},HC=function(e){return void 0===e&&(e={}),{name:"shift",options:e,async fn(t){const{x:r,y:n,placement:o}=t,{mainAxis:i=!0,crossAxis:a=!1,limiter:s={fn:e=>{let{x:t,y:r}=e;return{x:t,y:r}}},...l}=Y_(e,t),u={x:r,y:n},c=await sC(t,l),d=eC(X_(o)),p=J_(d);let f=u[p],h=u[d];if(i){const e="y"===p?"bottom":"right";f=K_(f+c["y"===p?"top":"left"],f,f-c[e])}if(a){const e="y"===d?"bottom":"right";h=K_(h+c["y"===d?"top":"left"],h,h-c[e])}const g=s.fn({...t,[p]:f,[d]:h});return{...g,data:{x:g.x-r,y:g.y-n}}}}},qC=function(e){return void 0===e&&(e={}),{name:"flip",options:e,async fn(t){var r,n;const{placement:o,middlewareData:i,rects:a,initialPlacement:s,platform:l,elements:u}=t,{mainAxis:c=!0,crossAxis:d=!0,fallbackPlacements:p,fallbackStrategy:f="bestFit",fallbackAxisSideDirection:h="none",flipAlignment:g=!0,...v}=Y_(e,t);if(null!=(r=i.arrow)&&r.alignmentOffset)return{};const m=X_(o),y=X_(s)===s,b=await(null==l.isRTL?void 0:l.isRTL(u.floating)),O=p||(y||!g?[nC(s)]:function(e){const t=nC(e);return[rC(e),t,rC(t)]}(s));p||"none"===h||O.push(...function(e,t,r,n){const o=Q_(e);let i=function(e,t,r){const n=["left","right"],o=["right","left"],i=["top","bottom"],a=["bottom","top"];switch(e){case"top":case"bottom":return r?t?o:n:t?n:o;case"left":case"right":return t?i:a;default:return[]}}(X_(e),"start"===r,n);return o&&(i=i.map((e=>e+"-"+o)),t&&(i=i.concat(i.map(rC)))),i}(s,g,h,b));const E=[s,...O],S=await sC(t,v),w=[];let T=(null==(n=i.flip)?void 0:n.overflows)||[];if(c&&w.push(S[m]),d){const e=function(e,t,r){void 0===r&&(r=!1);const n=Q_(e),o=tC(e),i=Z_(o);let a="x"===o?n===(r?"end":"start")?"right":"left":"start"===n?"bottom":"top";return t.reference[i]>t.floating[i]&&(a=nC(a)),[a,nC(a)]}(o,a,b);w.push(S[e[0]],S[e[1]])}if(T=[...T,{placement:o,overflows:w}],!w.every((e=>e<=0))){var x,_;const e=((null==(x=i.flip)?void 0:x.index)||0)+1,t=E[e];if(t)return{data:{index:e,overflows:T},reset:{placement:t}};let r=null==(_=T.filter((e=>e.overflows[0]<=0)).sort(((e,t)=>e.overflows[1]-t.overflows[1]))[0])?void 0:_.placement;if(!r)switch(f){case"bestFit":{var C;const e=null==(C=T.map((e=>[e.placement,e.overflows.filter((e=>e>0)).reduce(((e,t)=>e+t),0)])).sort(((e,t)=>e[1]-t[1]))[0])?void 0:C[0];e&&(r=e);break}case"initialPlacement":r=s}if(o!==r)return{reset:{placement:r}}}return{}}}},GC=e=>({name:"arrow",options:e,async fn(t){const{x:r,y:n,placement:o,rects:i,platform:a,elements:s,middlewareData:l}=t,{element:u,padding:c=0}=Y_(e,t)||{};if(null==u)return{};const d=oC(c),p={x:r,y:n},f=tC(o),h=Z_(f),g=await a.getDimensions(u),v="y"===f,m=v?"top":"left",y=v?"bottom":"right",b=v?"clientHeight":"clientWidth",O=i.reference[h]+i.reference[f]-p[f]-i.floating[h],E=p[f]-i.reference[f],S=await(null==a.getOffsetParent?void 0:a.getOffsetParent(u));let w=S?S[b]:0;w&&await(null==a.isElement?void 0:a.isElement(S))||(w=s.floating[b]||i.floating[h]);const T=O/2-E/2,x=w/2-g[h]/2-1,_=B_(d[m],x),C=B_(d[y],x),R=_,I=w-g[h]-C,A=w/2-g[h]/2+T,j=K_(R,A,I),P=!l.arrow&&null!=Q_(o)&&A!==j&&i.reference[h]/2-(A<R?_:C)-g[h]/2<0,L=P?A<R?A-R:A-I:0;return{[f]:p[f]+L,data:{[f]:j,centerOffset:A-j-L,...P&&{alignmentOffset:L}},reset:P}}}),KC=(e,t,r)=>{const n=new Map,o={platform:zC,...r},i={...o.platform,_c:n};return(async(e,t,r)=>{const{placement:n="bottom",strategy:o="absolute",middleware:i=[],platform:a}=r,s=i.filter(Boolean),l=await(null==a.isRTL?void 0:a.isRTL(t));let u=await a.getElementRects({reference:e,floating:t,strategy:o}),{x:c,y:d}=aC(u,n,l),p=n,f={},h=0;for(let r=0;r<s.length;r++){const{name:i,fn:g}=s[r],{x:v,y:m,data:y,reset:b}=await g({x:c,y:d,initialPlacement:n,placement:p,strategy:o,middlewareData:f,rects:u,platform:a,elements:{reference:e,floating:t}});c=null!=v?v:c,d=null!=m?m:d,f={...f,[i]:{...f[i],...y}},b&&h<=50&&(h++,"object"==typeof b&&(b.placement&&(p=b.placement),b.rects&&(u=!0===b.rects?await a.getElementRects({reference:e,floating:t,strategy:o}):b.rects),({x:c,y:d}=aC(u,p,l))),r=-1)}return{x:c,y:d,placement:p,strategy:o,middlewareData:f}})(e,t,{...o,platform:i})},YC=ve.useLayoutEffect;var XC=["className","clearValue","cx","getStyles","getClassNames","getValue","hasValue","isMulti","isRtl","options","selectOption","selectProps","setValue","theme"],QC=function(){};function JC(e,t){return t?"-"===t[0]?e+t:e+"__"+t:e}function ZC(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),o=2;o<r;o++)n[o-2]=arguments[o];var i=[].concat(n);if(t&&e)for(var a in t)t.hasOwnProperty(a)&&t[a]&&i.push("".concat(JC(e,a)));return i.filter((function(e){return e})).map((function(e){return String(e).trim()})).join(" ")}var eR=function(e){return t=e,Array.isArray(t)?e.filter(Boolean):"object"===Kn(e)&&null!==e?[e]:[];var t},tR=function(e){return e.className,e.clearValue,e.cx,e.getStyles,e.getClassNames,e.getValue,e.hasValue,e.isMulti,e.isRtl,e.options,e.selectOption,e.selectProps,e.setValue,e.theme,k_({},nm(e,XC))},rR=function(e,t,r){var n=e.cx,o=e.getStyles,i=e.getClassNames,a=e.className;return{css:o(t,e),className:n(null!=r?r:{},i(t,e),a)}};function nR(e){return[document.documentElement,document.body,window].indexOf(e)>-1}function oR(e){return nR(e)?window.pageYOffset:e.scrollTop}function iR(e,t){nR(e)?window.scrollTo(0,t):e.scrollTop=t}function aR(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:200,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:QC,o=oR(e),i=t-o,a=0;!function t(){var s=function(e,t,r,n){return r*((e=e/n-1)*e*e+1)+t}(a+=10,o,i,r);iR(e,s),a<r?window.requestAnimationFrame(t):n(e)}()}function sR(e,t){var r=e.getBoundingClientRect(),n=t.getBoundingClientRect(),o=t.offsetHeight/3;n.bottom+o>r.bottom?iR(e,Math.min(t.offsetTop+t.clientHeight-e.offsetHeight+o,e.scrollHeight)):n.top-o<r.top&&iR(e,Math.max(t.offsetTop-o,0))}function lR(){try{return document.createEvent("TouchEvent"),!0}catch(e){return!1}}var uR=!1,cR={get passive(){return uR=!0}},dR="undefined"!=typeof window?window:{};dR.addEventListener&&dR.removeEventListener&&(dR.addEventListener("p",QC,cR),dR.removeEventListener("p",QC,!1));var pR=uR;function fR(e){return null!=e}function hR(e,t,r){return e?t:r}var gR=["children","innerProps"],vR=["children","innerProps"];var mR,yR=function(e){return"auto"===e?"bottom":e},bR=(0,ve.createContext)(null),OR=function(e){var t=e.children,r=e.minMenuHeight,n=e.maxMenuHeight,o=e.menuPlacement,i=e.menuPosition,a=e.menuShouldScrollIntoView,s=e.theme,l=((0,ve.useContext)(bR)||{}).setPortalPlacement,u=(0,ve.useRef)(null),c=lo((0,ve.useState)(n),2),d=c[0],p=c[1],f=lo((0,ve.useState)(null),2),h=f[0],g=f[1],v=s.spacing.controlHeight;return YC((function(){var e=u.current;if(e){var t="fixed"===i,s=function(e){var t=e.maxHeight,r=e.menuEl,n=e.minHeight,o=e.placement,i=e.shouldScroll,a=e.isFixedPosition,s=e.controlHeight,l=function(e){var t=getComputedStyle(e),r="absolute"===t.position,n=/(auto|scroll)/;if("fixed"===t.position)return document.documentElement;for(var o=e;o=o.parentElement;)if(t=getComputedStyle(o),(!r||"static"!==t.position)&&n.test(t.overflow+t.overflowY+t.overflowX))return o;return document.documentElement}(r),u={placement:"bottom",maxHeight:t};if(!r||!r.offsetParent)return u;var c,d=l.getBoundingClientRect().height,p=r.getBoundingClientRect(),f=p.bottom,h=p.height,g=p.top,v=r.offsetParent.getBoundingClientRect().top,m=a||nR(c=l)?window.innerHeight:c.clientHeight,y=oR(l),b=parseInt(getComputedStyle(r).marginBottom,10),O=parseInt(getComputedStyle(r).marginTop,10),E=v-O,S=m-g,w=E+y,T=d-y-g,x=f-m+y+b,_=y+g-O,C=160;switch(o){case"auto":case"bottom":if(S>=h)return{placement:"bottom",maxHeight:t};if(T>=h&&!a)return i&&aR(l,x,C),{placement:"bottom",maxHeight:t};if(!a&&T>=n||a&&S>=n)return i&&aR(l,x,C),{placement:"bottom",maxHeight:a?S-b:T-b};if("auto"===o||a){var R=t,I=a?E:w;return I>=n&&(R=Math.min(I-b-s,t)),{placement:"top",maxHeight:R}}if("bottom"===o)return i&&iR(l,x),{placement:"bottom",maxHeight:t};break;case"top":if(E>=h)return{placement:"top",maxHeight:t};if(w>=h&&!a)return i&&aR(l,_,C),{placement:"top",maxHeight:t};if(!a&&w>=n||a&&E>=n){var A=t;return(!a&&w>=n||a&&E>=n)&&(A=a?E-O:w-O),i&&aR(l,_,C),{placement:"top",maxHeight:A}}return{placement:"bottom",maxHeight:t};default:throw new Error('Invalid placement provided "'.concat(o,'".'))}return u}({maxHeight:n,menuEl:e,minHeight:r,placement:o,shouldScroll:a&&!t,isFixedPosition:t,controlHeight:v});p(s.maxHeight),g(s.placement),null==l||l(s.placement)}}),[n,o,i,a,r,l,v]),t({ref:u,placerProps:k_(k_({},e),{},{placement:h||yR(o),maxHeight:d})})},ER=function(e,t){var r=e.theme,n=r.spacing.baseUnit,o=r.colors;return k_({textAlign:"center"},t?{}:{color:o.neutral40,padding:"".concat(2*n,"px ").concat(3*n,"px")})},SR=ER,wR=ER,TR=["size"],xR=["innerProps","isRtl","size"],_R={name:"8mmkcg",styles:"display:inline-block;fill:currentColor;line-height:1;stroke:currentColor;stroke-width:0"},CR=function(e){var t=e.size,r=nm(e,TR);return(0,M_.jsx)("svg",Cb({height:t,width:t,viewBox:"0 0 20 20","aria-hidden":"true",focusable:"false",css:_R},r))},RR=function(e){return(0,M_.jsx)(CR,Cb({size:20},e),(0,M_.jsx)("path",{d:"M14.348 14.849c-0.469 0.469-1.229 0.469-1.697 0l-2.651-3.030-2.651 3.029c-0.469 0.469-1.229 0.469-1.697 0-0.469-0.469-0.469-1.229 0-1.697l2.758-3.15-2.759-3.152c-0.469-0.469-0.469-1.228 0-1.697s1.228-0.469 1.697 0l2.652 3.031 2.651-3.031c0.469-0.469 1.228-0.469 1.697 0s0.469 1.229 0 1.697l-2.758 3.152 2.758 3.15c0.469 0.469 0.469 1.229 0 1.698z"}))},IR=function(e){return(0,M_.jsx)(CR,Cb({size:20},e),(0,M_.jsx)("path",{d:"M4.516 7.548c0.436-0.446 1.043-0.481 1.576 0l3.908 3.747 3.908-3.747c0.533-0.481 1.141-0.446 1.574 0 0.436 0.445 0.408 1.197 0 1.615-0.406 0.418-4.695 4.502-4.695 4.502-0.217 0.223-0.502 0.335-0.787 0.335s-0.57-0.112-0.789-0.335c0 0-4.287-4.084-4.695-4.502s-0.436-1.17 0-1.615z"}))},AR=function(e,t){var r=e.isFocused,n=e.theme,o=n.spacing.baseUnit,i=n.colors;return k_({label:"indicatorContainer",display:"flex",transition:"color 150ms"},t?{}:{color:r?i.neutral60:i.neutral20,padding:2*o,":hover":{color:r?i.neutral80:i.neutral40}})},jR=AR,PR=AR,LR=(0,M_.keyframes)(mR||(mR=function(e,t){return t||(t=e.slice(0)),Object.freeze(Object.defineProperties(e,{raw:{value:Object.freeze(t)}}))}(["\n  0%, 80%, 100% { opacity: 0; }\n  40% { opacity: 1; }\n"]))),kR=function(e){var t=e.delay,r=e.offset;return(0,M_.jsx)("span",{css:(0,M_.css)({animation:"".concat(LR," 1s ease-in-out ").concat(t,"ms infinite;"),backgroundColor:"currentColor",borderRadius:"1em",display:"inline-block",marginLeft:r?"1em":void 0,height:"1em",verticalAlign:"top",width:"1em"},"","")})},NR=["data"],DR=["innerRef","isDisabled","isHidden","inputClassName"],FR={gridArea:"1 / 2",font:"inherit",minWidth:"2px",border:0,margin:0,outline:0,padding:0},MR={flex:"1 1 auto",display:"inline-grid",gridArea:"1 / 1 / 2 / 3",gridTemplateColumns:"0 min-content","&:after":k_({content:'attr(data-value) " "',visibility:"hidden",whiteSpace:"pre"},FR)},VR=function(e){return k_({label:"input",color:"inherit",background:0,opacity:e?0:1,width:"100%"},FR)},UR=function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",r,t)},BR={ClearIndicator:function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"clearIndicator",{indicator:!0,"clear-indicator":!0}),r),t||(0,M_.jsx)(RR,null))},Control:function(e){var t=e.children,r=e.isDisabled,n=e.isFocused,o=e.innerRef,i=e.innerProps,a=e.menuIsOpen;return(0,M_.jsx)("div",Cb({ref:o},rR(e,"control",{control:!0,"control--is-disabled":r,"control--is-focused":n,"control--menu-is-open":a}),i,{"aria-disabled":r||void 0}),t)},DropdownIndicator:function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"dropdownIndicator",{indicator:!0,"dropdown-indicator":!0}),r),t||(0,M_.jsx)(IR,null))},DownChevron:IR,CrossIcon:RR,Group:function(e){var t=e.children,r=e.cx,n=e.getStyles,o=e.getClassNames,i=e.Heading,a=e.headingProps,s=e.innerProps,l=e.label,u=e.theme,c=e.selectProps;return(0,M_.jsx)("div",Cb({},rR(e,"group",{group:!0}),s),(0,M_.jsx)(i,Cb({},a,{selectProps:c,theme:u,getStyles:n,getClassNames:o,cx:r}),l),(0,M_.jsx)("div",null,t))},GroupHeading:function(e){var t=tR(e);t.data;var r=nm(t,NR);return(0,M_.jsx)("div",Cb({},rR(e,"groupHeading",{"group-heading":!0}),r))},IndicatorsContainer:function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"indicatorsContainer",{indicators:!0}),r),t)},IndicatorSeparator:function(e){var t=e.innerProps;return(0,M_.jsx)("span",Cb({},t,rR(e,"indicatorSeparator",{"indicator-separator":!0})))},Input:function(e){var t=e.cx,r=e.value,n=tR(e),o=n.innerRef,i=n.isDisabled,a=n.isHidden,s=n.inputClassName,l=nm(n,DR);return(0,M_.jsx)("div",Cb({},rR(e,"input",{"input-container":!0}),{"data-value":r||""}),(0,M_.jsx)("input",Cb({className:t({input:!0},s),ref:o,style:VR(a),disabled:i},l)))},LoadingIndicator:function(e){var t=e.innerProps,r=e.isRtl,n=e.size,o=void 0===n?4:n,i=nm(e,xR);return(0,M_.jsx)("div",Cb({},rR(k_(k_({},i),{},{innerProps:t,isRtl:r,size:o}),"loadingIndicator",{indicator:!0,"loading-indicator":!0}),t),(0,M_.jsx)(kR,{delay:0,offset:r}),(0,M_.jsx)(kR,{delay:160,offset:!0}),(0,M_.jsx)(kR,{delay:320,offset:!r}))},Menu:function(e){var t=e.children,r=e.innerRef,n=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"menu",{menu:!0}),{ref:r},n),t)},MenuList:function(e){var t=e.children,r=e.innerProps,n=e.innerRef,o=e.isMulti;return(0,M_.jsx)("div",Cb({},rR(e,"menuList",{"menu-list":!0,"menu-list--is-multi":o}),{ref:n},r),t)},MenuPortal:function(e){var t=e.appendTo,r=e.children,n=e.controlElement,o=e.innerProps,i=e.menuPlacement,a=e.menuPosition,s=(0,ve.useRef)(null),l=(0,ve.useRef)(null),u=lo((0,ve.useState)(yR(i)),2),c=u[0],d=u[1],p=(0,ve.useMemo)((function(){return{setPortalPlacement:d}}),[]),f=lo((0,ve.useState)(null),2),h=f[0],g=f[1],v=(0,ve.useCallback)((function(){if(n){var e=function(e){var t=e.getBoundingClientRect();return{bottom:t.bottom,height:t.height,left:t.left,right:t.right,top:t.top,width:t.width}}(n),t="fixed"===a?0:window.pageYOffset,r=e[c]+t;r===(null==h?void 0:h.offset)&&e.left===(null==h?void 0:h.rect.left)&&e.width===(null==h?void 0:h.rect.width)||g({offset:r,rect:e})}}),[n,a,c,null==h?void 0:h.offset,null==h?void 0:h.rect.left,null==h?void 0:h.rect.width]);YC((function(){v()}),[v]);var m=(0,ve.useCallback)((function(){"function"==typeof l.current&&(l.current(),l.current=null),n&&s.current&&(l.current=$C(n,s.current,v,{elementResize:"ResizeObserver"in window}))}),[n,v]);YC((function(){m()}),[m]);var y=(0,ve.useCallback)((function(e){s.current=e,m()}),[m]);if(!t&&"fixed"!==a||!h)return null;var b=(0,M_.jsx)("div",Cb({ref:y},rR(k_(k_({},e),{},{offset:h.offset,position:a,rect:h.rect}),"menuPortal",{"menu-portal":!0}),o),r);return(0,M_.jsx)(bR.Provider,{value:p},t?(0,V_.createPortal)(b,t):b)},LoadingMessage:function(e){var t=e.children,r=void 0===t?"Loading...":t,n=e.innerProps,o=nm(e,vR);return(0,M_.jsx)("div",Cb({},rR(k_(k_({},o),{},{children:r,innerProps:n}),"loadingMessage",{"menu-notice":!0,"menu-notice--loading":!0}),n),r)},NoOptionsMessage:function(e){var t=e.children,r=void 0===t?"No options":t,n=e.innerProps,o=nm(e,gR);return(0,M_.jsx)("div",Cb({},rR(k_(k_({},o),{},{children:r,innerProps:n}),"noOptionsMessage",{"menu-notice":!0,"menu-notice--no-options":!0}),n),r)},MultiValue:function(e){var t=e.children,r=e.components,n=e.data,o=e.innerProps,i=e.isDisabled,a=e.removeProps,s=e.selectProps,l=r.Container,u=r.Label,c=r.Remove;return(0,M_.jsx)(l,{data:n,innerProps:k_(k_({},rR(e,"multiValue",{"multi-value":!0,"multi-value--is-disabled":i})),o),selectProps:s},(0,M_.jsx)(u,{data:n,innerProps:k_({},rR(e,"multiValueLabel",{"multi-value__label":!0})),selectProps:s},t),(0,M_.jsx)(c,{data:n,innerProps:k_(k_({},rR(e,"multiValueRemove",{"multi-value__remove":!0})),{},{"aria-label":"Remove ".concat(t||"option")},a),selectProps:s}))},MultiValueContainer:UR,MultiValueLabel:UR,MultiValueRemove:function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",Cb({role:"button"},r),t||(0,M_.jsx)(RR,{size:14}))},Option:function(e){var t=e.children,r=e.isDisabled,n=e.isFocused,o=e.isSelected,i=e.innerRef,a=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"option",{option:!0,"option--is-disabled":r,"option--is-focused":n,"option--is-selected":o}),{ref:i,"aria-disabled":r},a),t)},Placeholder:function(e){var t=e.children,r=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"placeholder",{placeholder:!0}),r),t)},SelectContainer:function(e){var t=e.children,r=e.innerProps,n=e.isDisabled,o=e.isRtl;return(0,M_.jsx)("div",Cb({},rR(e,"container",{"--is-disabled":n,"--is-rtl":o}),r),t)},SingleValue:function(e){var t=e.children,r=e.isDisabled,n=e.innerProps;return(0,M_.jsx)("div",Cb({},rR(e,"singleValue",{"single-value":!0,"single-value--is-disabled":r}),n),t)},ValueContainer:function(e){var t=e.children,r=e.innerProps,n=e.isMulti,o=e.hasValue;return(0,M_.jsx)("div",Cb({},rR(e,"valueContainer",{"value-container":!0,"value-container--is-multi":n,"value-container--has-value":o}),r),t)}},zR=Number.isNaN||function(e){return"number"==typeof e&&e!=e};function $R(e,t){if(e.length!==t.length)return!1;for(var r=0;r<e.length;r++)if(!((n=e[r])===(o=t[r])||zR(n)&&zR(o)))return!1;var n,o;return!0}for(var WR={name:"7pg0cj-a11yText",styles:"label:a11yText;z-index:9999;border:0;clip:rect(1px, 1px, 1px, 1px);height:1px;width:1px;position:absolute;overflow:hidden;padding:0;white-space:nowrap"},HR=function(e){return(0,M_.jsx)("span",Cb({css:WR},e))},qR={guidance:function(e){var t=e.isSearchable,r=e.isMulti,n=e.tabSelectsValue,o=e.context,i=e.isInitialFocus;switch(o){case"menu":return"Use Up and Down to choose options, press Enter to select the currently focused option, press Escape to exit the menu".concat(n?", press Tab to select the option and exit the menu":"",".");case"input":return i?"".concat(e["aria-label"]||"Select"," is focused ").concat(t?",type to refine list":"",", press Down to open the menu, ").concat(r?" press left to focus selected values":""):"";case"value":return"Use left and right to toggle between focused values, press Backspace to remove the currently focused value";default:return""}},onChange:function(e){var t=e.action,r=e.label,n=void 0===r?"":r,o=e.labels,i=e.isDisabled;switch(t){case"deselect-option":case"pop-value":case"remove-value":return"option ".concat(n,", deselected.");case"clear":return"All selected options have been cleared.";case"initial-input-focus":return"option".concat(o.length>1?"s":""," ").concat(o.join(","),", selected.");case"select-option":return"option ".concat(n,i?" is disabled. Select another option.":", selected.");default:return""}},onFocus:function(e){var t=e.context,r=e.focused,n=e.options,o=e.label,i=void 0===o?"":o,a=e.selectValue,s=e.isDisabled,l=e.isSelected,u=e.isAppleDevice,c=function(e,t){return e&&e.length?"".concat(e.indexOf(t)+1," of ").concat(e.length):""};if("value"===t&&a)return"value ".concat(i," focused, ").concat(c(a,r),".");if("menu"===t&&u){var d=s?" disabled":"",p="".concat(l?" selected":"").concat(d);return"".concat(i).concat(p,", ").concat(c(n,r),".")}return""},onFilter:function(e){var t=e.inputValue,r=e.resultsMessage;return"".concat(r).concat(t?" for search term "+t:"",".")}},GR=function(e){var t=e.ariaSelection,r=e.focusedOption,n=e.focusedValue,o=e.focusableOptions,i=e.isFocused,a=e.selectValue,s=e.selectProps,l=e.id,u=e.isAppleDevice,c=s.ariaLiveMessages,d=s.getOptionLabel,p=s.inputValue,f=s.isMulti,h=s.isOptionDisabled,g=s.isSearchable,v=s.menuIsOpen,m=s.options,y=s.screenReaderStatus,b=s.tabSelectsValue,O=s.isLoading,E=s["aria-label"],S=s["aria-live"],w=(0,ve.useMemo)((function(){return k_(k_({},qR),c||{})}),[c]),T=(0,ve.useMemo)((function(){var e,r="";if(t&&w.onChange){var n=t.option,o=t.options,i=t.removedValue,s=t.removedValues,l=t.value,u=i||n||(e=l,Array.isArray(e)?null:e),c=u?d(u):"",p=o||s||void 0,f=p?p.map(d):[],g=k_({isDisabled:u&&h(u,a),label:c,labels:f},t);r=w.onChange(g)}return r}),[t,w,h,a,d]),x=(0,ve.useMemo)((function(){var e="",t=r||n,i=!!(r&&a&&a.includes(r));if(t&&w.onFocus){var s={focused:t,label:d(t),isDisabled:h(t,a),isSelected:i,options:o,context:t===r?"menu":"value",selectValue:a,isAppleDevice:u};e=w.onFocus(s)}return e}),[r,n,d,h,w,o,a,u]),_=(0,ve.useMemo)((function(){var e="";if(v&&m.length&&!O&&w.onFilter){var t=y({count:o.length});e=w.onFilter({inputValue:p,resultsMessage:t})}return e}),[o,p,v,w,m,y,O]),C="initial-input-focus"===(null==t?void 0:t.action),R=(0,ve.useMemo)((function(){var e="";if(w.guidance){var t=n?"value":v?"menu":"input";e=w.guidance({"aria-label":E,context:t,isDisabled:r&&h(r,a),isMulti:f,isSearchable:g,tabSelectsValue:b,isInitialFocus:C})}return e}),[E,r,n,f,h,g,v,w,a,b,C]),I=(0,M_.jsx)(ve.Fragment,null,(0,M_.jsx)("span",{id:"aria-selection"},T),(0,M_.jsx)("span",{id:"aria-focused"},x),(0,M_.jsx)("span",{id:"aria-results"},_),(0,M_.jsx)("span",{id:"aria-guidance"},R));return(0,M_.jsx)(ve.Fragment,null,(0,M_.jsx)(HR,{id:l},C&&I),(0,M_.jsx)(HR,{"aria-live":S,"aria-atomic":"false","aria-relevant":"additions text",role:"log"},i&&!C&&I))},KR=[{base:"A",letters:"AⒶＡÀÁÂẦẤẪẨÃĀĂẰẮẴẲȦǠÄǞẢÅǺǍȀȂẠẬẶḀĄȺⱯ"},{base:"AA",letters:"Ꜳ"},{base:"AE",letters:"ÆǼǢ"},{base:"AO",letters:"Ꜵ"},{base:"AU",letters:"Ꜷ"},{base:"AV",letters:"ꜸꜺ"},{base:"AY",letters:"Ꜽ"},{base:"B",letters:"BⒷＢḂḄḆɃƂƁ"},{base:"C",letters:"CⒸＣĆĈĊČÇḈƇȻꜾ"},{base:"D",letters:"DⒹＤḊĎḌḐḒḎĐƋƊƉꝹ"},{base:"DZ",letters:"ǱǄ"},{base:"Dz",letters:"ǲǅ"},{base:"E",letters:"EⒺＥÈÉÊỀẾỄỂẼĒḔḖĔĖËẺĚȄȆẸỆȨḜĘḘḚƐƎ"},{base:"F",letters:"FⒻＦḞƑꝻ"},{base:"G",letters:"GⒼＧǴĜḠĞĠǦĢǤƓꞠꝽꝾ"},{base:"H",letters:"HⒽＨĤḢḦȞḤḨḪĦⱧⱵꞍ"},{base:"I",letters:"IⒾＩÌÍÎĨĪĬİÏḮỈǏȈȊỊĮḬƗ"},{base:"J",letters:"JⒿＪĴɈ"},{base:"K",letters:"KⓀＫḰǨḲĶḴƘⱩꝀꝂꝄꞢ"},{base:"L",letters:"LⓁＬĿĹĽḶḸĻḼḺŁȽⱢⱠꝈꝆꞀ"},{base:"LJ",letters:"Ǉ"},{base:"Lj",letters:"ǈ"},{base:"M",letters:"MⓂＭḾṀṂⱮƜ"},{base:"N",letters:"NⓃＮǸŃÑṄŇṆŅṊṈȠƝꞐꞤ"},{base:"NJ",letters:"Ǌ"},{base:"Nj",letters:"ǋ"},{base:"O",letters:"OⓄＯÒÓÔỒỐỖỔÕṌȬṎŌṐṒŎȮȰÖȪỎŐǑȌȎƠỜỚỠỞỢỌỘǪǬØǾƆƟꝊꝌ"},{base:"OI",letters:"Ƣ"},{base:"OO",letters:"Ꝏ"},{base:"OU",letters:"Ȣ"},{base:"P",letters:"PⓅＰṔṖƤⱣꝐꝒꝔ"},{base:"Q",letters:"QⓆＱꝖꝘɊ"},{base:"R",letters:"RⓇＲŔṘŘȐȒṚṜŖṞɌⱤꝚꞦꞂ"},{base:"S",letters:"SⓈＳẞŚṤŜṠŠṦṢṨȘŞⱾꞨꞄ"},{base:"T",letters:"TⓉＴṪŤṬȚŢṰṮŦƬƮȾꞆ"},{base:"TZ",letters:"Ꜩ"},{base:"U",letters:"UⓊＵÙÚÛŨṸŪṺŬÜǛǗǕǙỦŮŰǓȔȖƯỪỨỮỬỰỤṲŲṶṴɄ"},{base:"V",letters:"VⓋＶṼṾƲꝞɅ"},{base:"VY",letters:"Ꝡ"},{base:"W",letters:"WⓌＷẀẂŴẆẄẈⱲ"},{base:"X",letters:"XⓍＸẊẌ"},{base:"Y",letters:"YⓎＹỲÝŶỸȲẎŸỶỴƳɎỾ"},{base:"Z",letters:"ZⓏＺŹẐŻŽẒẔƵȤⱿⱫꝢ"},{base:"a",letters:"aⓐａẚàáâầấẫẩãāăằắẵẳȧǡäǟảåǻǎȁȃạậặḁąⱥɐ"},{base:"aa",letters:"ꜳ"},{base:"ae",letters:"æǽǣ"},{base:"ao",letters:"ꜵ"},{base:"au",letters:"ꜷ"},{base:"av",letters:"ꜹꜻ"},{base:"ay",letters:"ꜽ"},{base:"b",letters:"bⓑｂḃḅḇƀƃɓ"},{base:"c",letters:"cⓒｃćĉċčçḉƈȼꜿↄ"},{base:"d",letters:"dⓓｄḋďḍḑḓḏđƌɖɗꝺ"},{base:"dz",letters:"ǳǆ"},{base:"e",letters:"eⓔｅèéêềếễểẽēḕḗĕėëẻěȅȇẹệȩḝęḙḛɇɛǝ"},{base:"f",letters:"fⓕｆḟƒꝼ"},{base:"g",letters:"gⓖｇǵĝḡğġǧģǥɠꞡᵹꝿ"},{base:"h",letters:"hⓗｈĥḣḧȟḥḩḫẖħⱨⱶɥ"},{base:"hv",letters:"ƕ"},{base:"i",letters:"iⓘｉìíîĩīĭïḯỉǐȉȋịįḭɨı"},{base:"j",letters:"jⓙｊĵǰɉ"},{base:"k",letters:"kⓚｋḱǩḳķḵƙⱪꝁꝃꝅꞣ"},{base:"l",letters:"lⓛｌŀĺľḷḹļḽḻſłƚɫⱡꝉꞁꝇ"},{base:"lj",letters:"ǉ"},{base:"m",letters:"mⓜｍḿṁṃɱɯ"},{base:"n",letters:"nⓝｎǹńñṅňṇņṋṉƞɲŉꞑꞥ"},{base:"nj",letters:"ǌ"},{base:"o",letters:"oⓞｏòóôồốỗổõṍȭṏōṑṓŏȯȱöȫỏőǒȍȏơờớỡởợọộǫǭøǿɔꝋꝍɵ"},{base:"oi",letters:"ƣ"},{base:"ou",letters:"ȣ"},{base:"oo",letters:"ꝏ"},{base:"p",letters:"pⓟｐṕṗƥᵽꝑꝓꝕ"},{base:"q",letters:"qⓠｑɋꝗꝙ"},{base:"r",letters:"rⓡｒŕṙřȑȓṛṝŗṟɍɽꝛꞧꞃ"},{base:"s",letters:"sⓢｓßśṥŝṡšṧṣṩșşȿꞩꞅẛ"},{base:"t",letters:"tⓣｔṫẗťṭțţṱṯŧƭʈⱦꞇ"},{base:"tz",letters:"ꜩ"},{base:"u",letters:"uⓤｕùúûũṹūṻŭüǜǘǖǚủůűǔȕȗưừứữửựụṳųṷṵʉ"},{base:"v",letters:"vⓥｖṽṿʋꝟʌ"},{base:"vy",letters:"ꝡ"},{base:"w",letters:"wⓦｗẁẃŵẇẅẘẉⱳ"},{base:"x",letters:"xⓧｘẋẍ"},{base:"y",letters:"yⓨｙỳýŷỹȳẏÿỷẙỵƴɏỿ"},{base:"z",letters:"zⓩｚźẑżžẓẕƶȥɀⱬꝣ"}],YR=new RegExp("["+KR.map((function(e){return e.letters})).join("")+"]","g"),XR={},QR=0;QR<KR.length;QR++)for(var JR=KR[QR],ZR=0;ZR<JR.letters.length;ZR++)XR[JR.letters[ZR]]=JR.base;var eI=function(e){return e.replace(YR,(function(e){return XR[e]}))},tI=function(e,t){void 0===t&&(t=$R);var r=null;function n(){for(var n=[],o=0;o<arguments.length;o++)n[o]=arguments[o];if(r&&r.lastThis===this&&t(n,r.lastArgs))return r.lastResult;var i=e.apply(this,n);return r={lastResult:i,lastArgs:n,lastThis:this},i}return n.clear=function(){r=null},n}(eI),rI=function(e){return e.replace(/^\s+|\s+$/g,"")},nI=function(e){return"".concat(e.label," ").concat(e.value)},oI=["innerRef"];function iI(e){var t=e.innerRef,r=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];var o=Object.entries(e).filter((function(e){var t=lo(e,1)[0];return!r.includes(t)}));return o.reduce((function(e,t){var r=lo(t,2),n=r[0],o=r[1];return e[n]=o,e}),{})}(nm(e,oI),"onExited","in","enter","exit","appear");return(0,M_.jsx)("input",Cb({ref:t},r,{css:(0,M_.css)({label:"dummyInput",background:0,border:0,caretColor:"transparent",fontSize:"inherit",gridArea:"1 / 1 / 2 / 3",outline:0,padding:0,width:1,color:"transparent",left:-100,opacity:0,position:"relative",transform:"scale(.01)"},"","")}))}var aI=["boxSizing","height","overflow","paddingRight","position"],sI={boxSizing:"border-box",overflow:"hidden",position:"relative",height:"100%"};function lI(e){e.cancelable&&e.preventDefault()}function uI(e){e.stopPropagation()}function cI(){var e=this.scrollTop,t=this.scrollHeight,r=e+this.offsetHeight;0===e?this.scrollTop=1:r===t&&(this.scrollTop=e-1)}function dI(){return"ontouchstart"in window||navigator.maxTouchPoints}var pI=!("undefined"==typeof window||!window.document||!window.document.createElement),fI=0,hI={capture:!1,passive:!1},gI=function(e){var t=e.target;return t.ownerDocument.activeElement&&t.ownerDocument.activeElement.blur()},vI={name:"1kfdb0e",styles:"position:fixed;left:0;bottom:0;right:0;top:0"};function mI(e){var t=e.children,r=e.lockEnabled,n=e.captureEnabled,o=function(e){var t=e.isEnabled,r=e.onBottomArrive,n=e.onBottomLeave,o=e.onTopArrive,i=e.onTopLeave,a=(0,ve.useRef)(!1),s=(0,ve.useRef)(!1),l=(0,ve.useRef)(0),u=(0,ve.useRef)(null),c=(0,ve.useCallback)((function(e,t){if(null!==u.current){var l=u.current,c=l.scrollTop,d=l.scrollHeight,p=l.clientHeight,f=u.current,h=t>0,g=d-p-c,v=!1;g>t&&a.current&&(n&&n(e),a.current=!1),h&&s.current&&(i&&i(e),s.current=!1),h&&t>g?(r&&!a.current&&r(e),f.scrollTop=d,v=!0,a.current=!0):!h&&-t>c&&(o&&!s.current&&o(e),f.scrollTop=0,v=!0,s.current=!0),v&&function(e){e.cancelable&&e.preventDefault(),e.stopPropagation()}(e)}}),[r,n,o,i]),d=(0,ve.useCallback)((function(e){c(e,e.deltaY)}),[c]),p=(0,ve.useCallback)((function(e){l.current=e.changedTouches[0].clientY}),[]),f=(0,ve.useCallback)((function(e){var t=l.current-e.changedTouches[0].clientY;c(e,t)}),[c]),h=(0,ve.useCallback)((function(e){if(e){var t=!!pR&&{passive:!1};e.addEventListener("wheel",d,t),e.addEventListener("touchstart",p,t),e.addEventListener("touchmove",f,t)}}),[f,p,d]),g=(0,ve.useCallback)((function(e){e&&(e.removeEventListener("wheel",d,!1),e.removeEventListener("touchstart",p,!1),e.removeEventListener("touchmove",f,!1))}),[f,p,d]);return(0,ve.useEffect)((function(){if(t){var e=u.current;return h(e),function(){g(e)}}}),[t,h,g]),function(e){u.current=e}}({isEnabled:void 0===n||n,onBottomArrive:e.onBottomArrive,onBottomLeave:e.onBottomLeave,onTopArrive:e.onTopArrive,onTopLeave:e.onTopLeave}),i=function(e){var t=e.isEnabled,r=e.accountForScrollbars,n=void 0===r||r,o=(0,ve.useRef)({}),i=(0,ve.useRef)(null),a=(0,ve.useCallback)((function(e){if(pI){var t=document.body,r=t&&t.style;if(n&&aI.forEach((function(e){var t=r&&r[e];o.current[e]=t})),n&&fI<1){var i=parseInt(o.current.paddingRight,10)||0,a=document.body?document.body.clientWidth:0,s=window.innerWidth-a+i||0;Object.keys(sI).forEach((function(e){var t=sI[e];r&&(r[e]=t)})),r&&(r.paddingRight="".concat(s,"px"))}t&&dI()&&(t.addEventListener("touchmove",lI,hI),e&&(e.addEventListener("touchstart",cI,hI),e.addEventListener("touchmove",uI,hI))),fI+=1}}),[n]),s=(0,ve.useCallback)((function(e){if(pI){var t=document.body,r=t&&t.style;fI=Math.max(fI-1,0),n&&fI<1&&aI.forEach((function(e){var t=o.current[e];r&&(r[e]=t)})),t&&dI()&&(t.removeEventListener("touchmove",lI,hI),e&&(e.removeEventListener("touchstart",cI,hI),e.removeEventListener("touchmove",uI,hI)))}}),[n]);return(0,ve.useEffect)((function(){if(t){var e=i.current;return a(e),function(){s(e)}}}),[t,a,s]),function(e){i.current=e}}({isEnabled:r});return(0,M_.jsx)(ve.Fragment,null,r&&(0,M_.jsx)("div",{onClick:gI,css:vI}),t((function(e){o(e),i(e)})))}var yI={name:"1a0ro4n-requiredInput",styles:"label:requiredInput;opacity:0;pointer-events:none;position:absolute;bottom:0;left:0;right:0;width:100%"},bI=function(e){var t=e.name,r=e.onFocus;return(0,M_.jsx)("input",{required:!0,name:t,tabIndex:-1,"aria-hidden":"true",onFocus:r,css:yI,value:"",onChange:function(){}})};function OI(e){var t;return"undefined"!=typeof window&&null!=window.navigator&&e.test((null===(t=window.navigator.userAgentData)||void 0===t?void 0:t.platform)||window.navigator.platform)}function EI(){return OI(/^Mac/i)}var SI=function(e){return e.label},wI=function(e){return e.value},TI={clearIndicator:PR,container:function(e){var t=e.isDisabled;return{label:"container",direction:e.isRtl?"rtl":void 0,pointerEvents:t?"none":void 0,position:"relative"}},control:function(e,t){var r=e.isDisabled,n=e.isFocused,o=e.theme,i=o.colors,a=o.borderRadius;return k_({label:"control",alignItems:"center",cursor:"default",display:"flex",flexWrap:"wrap",justifyContent:"space-between",minHeight:o.spacing.controlHeight,outline:"0 !important",position:"relative",transition:"all 100ms"},t?{}:{backgroundColor:r?i.neutral5:i.neutral0,borderColor:r?i.neutral10:n?i.primary:i.neutral20,borderRadius:a,borderStyle:"solid",borderWidth:1,boxShadow:n?"0 0 0 1px ".concat(i.primary):void 0,"&:hover":{borderColor:n?i.primary:i.neutral30}})},dropdownIndicator:jR,group:function(e,t){var r=e.theme.spacing;return t?{}:{paddingBottom:2*r.baseUnit,paddingTop:2*r.baseUnit}},groupHeading:function(e,t){var r=e.theme,n=r.colors,o=r.spacing;return k_({label:"group",cursor:"default",display:"block"},t?{}:{color:n.neutral40,fontSize:"75%",fontWeight:500,marginBottom:"0.25em",paddingLeft:3*o.baseUnit,paddingRight:3*o.baseUnit,textTransform:"uppercase"})},indicatorsContainer:function(){return{alignItems:"center",alignSelf:"stretch",display:"flex",flexShrink:0}},indicatorSeparator:function(e,t){var r=e.isDisabled,n=e.theme,o=n.spacing.baseUnit,i=n.colors;return k_({label:"indicatorSeparator",alignSelf:"stretch",width:1},t?{}:{backgroundColor:r?i.neutral10:i.neutral20,marginBottom:2*o,marginTop:2*o})},input:function(e,t){var r=e.isDisabled,n=e.value,o=e.theme,i=o.spacing,a=o.colors;return k_(k_({visibility:r?"hidden":"visible",transform:n?"translateZ(0)":""},MR),t?{}:{margin:i.baseUnit/2,paddingBottom:i.baseUnit/2,paddingTop:i.baseUnit/2,color:a.neutral80})},loadingIndicator:function(e,t){var r=e.isFocused,n=e.size,o=e.theme,i=o.colors,a=o.spacing.baseUnit;return k_({label:"loadingIndicator",display:"flex",transition:"color 150ms",alignSelf:"center",fontSize:n,lineHeight:1,marginRight:n,textAlign:"center",verticalAlign:"middle"},t?{}:{color:r?i.neutral60:i.neutral20,padding:2*a})},loadingMessage:wR,menu:function(e,t){var r,n=e.placement,o=e.theme,i=o.borderRadius,a=o.spacing,s=o.colors;return k_((no(r={label:"menu"},function(e){return e?{bottom:"top",top:"bottom"}[e]:"bottom"}(n),"100%"),no(r,"position","absolute"),no(r,"width","100%"),no(r,"zIndex",1),r),t?{}:{backgroundColor:s.neutral0,borderRadius:i,boxShadow:"0 0 0 1px hsla(0, 0%, 0%, 0.1), 0 4px 11px hsla(0, 0%, 0%, 0.1)",marginBottom:a.menuGutter,marginTop:a.menuGutter})},menuList:function(e,t){var r=e.maxHeight,n=e.theme.spacing.baseUnit;return k_({maxHeight:r,overflowY:"auto",position:"relative",WebkitOverflowScrolling:"touch"},t?{}:{paddingBottom:n,paddingTop:n})},menuPortal:function(e){var t=e.rect,r=e.offset,n=e.position;return{left:t.left,position:n,top:r,width:t.width,zIndex:1}},multiValue:function(e,t){var r=e.theme,n=r.spacing,o=r.borderRadius,i=r.colors;return k_({label:"multiValue",display:"flex",minWidth:0},t?{}:{backgroundColor:i.neutral10,borderRadius:o/2,margin:n.baseUnit/2})},multiValueLabel:function(e,t){var r=e.theme,n=r.borderRadius,o=r.colors,i=e.cropWithEllipsis;return k_({overflow:"hidden",textOverflow:i||void 0===i?"ellipsis":void 0,whiteSpace:"nowrap"},t?{}:{borderRadius:n/2,color:o.neutral80,fontSize:"85%",padding:3,paddingLeft:6})},multiValueRemove:function(e,t){var r=e.theme,n=r.spacing,o=r.borderRadius,i=r.colors,a=e.isFocused;return k_({alignItems:"center",display:"flex"},t?{}:{borderRadius:o/2,backgroundColor:a?i.dangerLight:void 0,paddingLeft:n.baseUnit,paddingRight:n.baseUnit,":hover":{backgroundColor:i.dangerLight,color:i.danger}})},noOptionsMessage:SR,option:function(e,t){var r=e.isDisabled,n=e.isFocused,o=e.isSelected,i=e.theme,a=i.spacing,s=i.colors;return k_({label:"option",cursor:"default",display:"block",fontSize:"inherit",width:"100%",userSelect:"none",WebkitTapHighlightColor:"rgba(0, 0, 0, 0)"},t?{}:{backgroundColor:o?s.primary:n?s.primary25:"transparent",color:r?s.neutral20:o?s.neutral0:"inherit",padding:"".concat(2*a.baseUnit,"px ").concat(3*a.baseUnit,"px"),":active":{backgroundColor:r?void 0:o?s.primary:s.primary50}})},placeholder:function(e,t){var r=e.theme,n=r.spacing,o=r.colors;return k_({label:"placeholder",gridArea:"1 / 1 / 2 / 3"},t?{}:{color:o.neutral50,marginLeft:n.baseUnit/2,marginRight:n.baseUnit/2})},singleValue:function(e,t){var r=e.isDisabled,n=e.theme,o=n.spacing,i=n.colors;return k_({label:"singleValue",gridArea:"1 / 1 / 2 / 3",maxWidth:"100%",overflow:"hidden",textOverflow:"ellipsis",whiteSpace:"nowrap"},t?{}:{color:r?i.neutral40:i.neutral80,marginLeft:o.baseUnit/2,marginRight:o.baseUnit/2})},valueContainer:function(e,t){var r=e.theme.spacing,n=e.isMulti,o=e.hasValue,i=e.selectProps.controlShouldRenderValue;return k_({alignItems:"center",display:n&&o&&i?"flex":"grid",flex:1,flexWrap:"wrap",WebkitOverflowScrolling:"touch",position:"relative",overflow:"hidden"},t?{}:{padding:"".concat(r.baseUnit/2,"px ").concat(2*r.baseUnit,"px")})}},xI={borderRadius:4,colors:{primary:"#2684FF",primary75:"#4C9AFF",primary50:"#B2D4FF",primary25:"#DEEBFF",danger:"#DE350B",dangerLight:"#FFBDAD",neutral0:"hsl(0, 0%, 100%)",neutral5:"hsl(0, 0%, 95%)",neutral10:"hsl(0, 0%, 90%)",neutral20:"hsl(0, 0%, 80%)",neutral30:"hsl(0, 0%, 70%)",neutral40:"hsl(0, 0%, 60%)",neutral50:"hsl(0, 0%, 50%)",neutral60:"hsl(0, 0%, 40%)",neutral70:"hsl(0, 0%, 30%)",neutral80:"hsl(0, 0%, 20%)",neutral90:"hsl(0, 0%, 10%)"},spacing:{baseUnit:4,controlHeight:38,menuGutter:8}},_I={"aria-live":"polite",backspaceRemovesValue:!0,blurInputOnSelect:lR(),captureMenuScroll:!lR(),classNames:{},closeMenuOnSelect:!0,closeMenuOnScroll:!1,components:{},controlShouldRenderValue:!0,escapeClearsValue:!1,filterOption:function(e,t){if(e.data.__isNew__)return!0;var r=k_({ignoreCase:!0,ignoreAccents:!0,stringify:nI,trim:!0,matchFrom:"any"},void 0),n=r.ignoreCase,o=r.ignoreAccents,i=r.stringify,a=r.trim,s=r.matchFrom,l=a?rI(t):t,u=a?rI(i(e)):i(e);return n&&(l=l.toLowerCase(),u=u.toLowerCase()),o&&(l=tI(l),u=eI(u)),"start"===s?u.substr(0,l.length)===l:u.indexOf(l)>-1},formatGroupLabel:function(e){return e.label},getOptionLabel:SI,getOptionValue:wI,isDisabled:!1,isLoading:!1,isMulti:!1,isRtl:!1,isSearchable:!0,isOptionDisabled:function(e){return!!e.isDisabled},loadingMessage:function(){return"Loading..."},maxMenuHeight:300,minMenuHeight:140,menuIsOpen:!1,menuPlacement:"bottom",menuPosition:"absolute",menuShouldBlockScroll:!1,menuShouldScrollIntoView:!function(){try{return/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)}catch(e){return!1}}(),noOptionsMessage:function(){return"No options"},openMenuOnFocus:!1,openMenuOnClick:!0,options:[],pageSize:5,placeholder:"Select...",screenReaderStatus:function(e){var t=e.count;return"".concat(t," result").concat(1!==t?"s":""," available")},styles:{},tabIndex:0,tabSelectsValue:!0,unstyled:!1};function CI(e,t,r,n){return{type:"option",data:t,isDisabled:NI(e,t,r),isSelected:DI(e,t,r),label:LI(e,t),value:kI(e,t),index:n}}function RI(e,t){return e.options.map((function(r,n){if("options"in r){var o=r.options.map((function(r,n){return CI(e,r,t,n)})).filter((function(t){return jI(e,t)}));return o.length>0?{type:"group",data:r,options:o,index:n}:void 0}var i=CI(e,r,t,n);return jI(e,i)?i:void 0})).filter(fR)}function II(e){return e.reduce((function(e,t){return"group"===t.type?e.push.apply(e,co(t.options.map((function(e){return e.data})))):e.push(t.data),e}),[])}function AI(e,t){return e.reduce((function(e,r){return"group"===r.type?e.push.apply(e,co(r.options.map((function(e){return{data:e.data,id:"".concat(t,"-").concat(r.index,"-").concat(e.index)}})))):e.push({data:r.data,id:"".concat(t,"-").concat(r.index)}),e}),[])}function jI(e,t){var r=e.inputValue,n=void 0===r?"":r,o=t.data,i=t.isSelected,a=t.label,s=t.value;return(!MI(e)||!i)&&FI(e,{label:a,value:s,data:o},n)}var PI=function(e,t){var r;return(null===(r=e.find((function(e){return e.data===t})))||void 0===r?void 0:r.id)||null},LI=function(e,t){return e.getOptionLabel(t)},kI=function(e,t){return e.getOptionValue(t)};function NI(e,t,r){return"function"==typeof e.isOptionDisabled&&e.isOptionDisabled(t,r)}function DI(e,t,r){if(r.indexOf(t)>-1)return!0;if("function"==typeof e.isOptionSelected)return e.isOptionSelected(t,r);var n=kI(e,t);return r.some((function(t){return kI(e,t)===n}))}function FI(e,t,r){return!e.filterOption||e.filterOption(t,r)}var MI=function(e){var t=e.hideSelectedOptions,r=e.isMulti;return void 0===t?r:t},VI=1,UI=function(e){ro(r,e);var t=function(e){var t=F_();return function(){var r,n=eo(e);if(t){var o=eo(this).constructor;r=Reflect.construct(n,arguments,o)}else r=n.apply(this,arguments);return Zn(this,r)}}(r);function r(e){var n;if(Gn(this,r),(n=t.call(this,e)).state={ariaSelection:null,focusedOption:null,focusedOptionId:null,focusableOptionsWithIds:[],focusedValue:null,inputIsHidden:!1,isFocused:!1,selectValue:[],clearFocusValueOnUpdate:!1,prevWasFocused:!1,inputIsHiddenAfterUpdate:void 0,prevProps:void 0,instancePrefix:""},n.blockOptionHover=!1,n.isComposing=!1,n.commonProps=void 0,n.initialTouchX=0,n.initialTouchY=0,n.openAfterFocus=!1,n.scrollToFocusedOptionOnUpdate=!1,n.userIsDragging=void 0,n.isAppleDevice=EI()||OI(/^iPhone/i)||OI(/^iPad/i)||EI()&&navigator.maxTouchPoints>1,n.controlRef=null,n.getControlRef=function(e){n.controlRef=e},n.focusedOptionRef=null,n.getFocusedOptionRef=function(e){n.focusedOptionRef=e},n.menuListRef=null,n.getMenuListRef=function(e){n.menuListRef=e},n.inputRef=null,n.getInputRef=function(e){n.inputRef=e},n.focus=n.focusInput,n.blur=n.blurInput,n.onChange=function(e,t){var r=n.props,o=r.onChange,i=r.name;t.name=i,n.ariaOnChange(e,t),o(e,t)},n.setValue=function(e,t,r){var o=n.props,i=o.closeMenuOnSelect,a=o.isMulti,s=o.inputValue;n.onInputChange("",{action:"set-value",prevInputValue:s}),i&&(n.setState({inputIsHiddenAfterUpdate:!a}),n.onMenuClose()),n.setState({clearFocusValueOnUpdate:!0}),n.onChange(e,{action:t,option:r})},n.selectOption=function(e){var t=n.props,r=t.blurInputOnSelect,o=t.isMulti,i=t.name,a=n.state.selectValue,s=o&&n.isOptionSelected(e,a),l=n.isOptionDisabled(e,a);if(s){var u=n.getOptionValue(e);n.setValue(a.filter((function(e){return n.getOptionValue(e)!==u})),"deselect-option",e)}else{if(l)return void n.ariaOnChange(e,{action:"select-option",option:e,name:i});o?n.setValue([].concat(co(a),[e]),"select-option",e):n.setValue(e,"select-option")}r&&n.blurInput()},n.removeValue=function(e){var t=n.props.isMulti,r=n.state.selectValue,o=n.getOptionValue(e),i=r.filter((function(e){return n.getOptionValue(e)!==o})),a=hR(t,i,i[0]||null);n.onChange(a,{action:"remove-value",removedValue:e}),n.focusInput()},n.clearValue=function(){var e=n.state.selectValue;n.onChange(hR(n.props.isMulti,[],null),{action:"clear",removedValues:e})},n.popValue=function(){var e=n.props.isMulti,t=n.state.selectValue,r=t[t.length-1],o=t.slice(0,t.length-1),i=hR(e,o,o[0]||null);r&&n.onChange(i,{action:"pop-value",removedValue:r})},n.getFocusedOptionId=function(e){return PI(n.state.focusableOptionsWithIds,e)},n.getFocusableOptionsWithIds=function(){return AI(RI(n.props,n.state.selectValue),n.getElementId("option"))},n.getValue=function(){return n.state.selectValue},n.cx=function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return ZC.apply(void 0,[n.props.classNamePrefix].concat(t))},n.getOptionLabel=function(e){return LI(n.props,e)},n.getOptionValue=function(e){return kI(n.props,e)},n.getStyles=function(e,t){var r=n.props.unstyled,o=TI[e](t,r);o.boxSizing="border-box";var i=n.props.styles[e];return i?i(o,t):o},n.getClassNames=function(e,t){var r,o;return null===(r=(o=n.props.classNames)[e])||void 0===r?void 0:r.call(o,t)},n.getElementId=function(e){return"".concat(n.state.instancePrefix,"-").concat(e)},n.getComponents=function(){return e=n.props,k_(k_({},BR),e.components);var e},n.buildCategorizedOptions=function(){return RI(n.props,n.state.selectValue)},n.getCategorizedOptions=function(){return n.props.menuIsOpen?n.buildCategorizedOptions():[]},n.buildFocusableOptions=function(){return II(n.buildCategorizedOptions())},n.getFocusableOptions=function(){return n.props.menuIsOpen?n.buildFocusableOptions():[]},n.ariaOnChange=function(e,t){n.setState({ariaSelection:k_({value:e},t)})},n.onMenuMouseDown=function(e){0===e.button&&(e.stopPropagation(),e.preventDefault(),n.focusInput())},n.onMenuMouseMove=function(e){n.blockOptionHover=!1},n.onControlMouseDown=function(e){if(!e.defaultPrevented){var t=n.props.openMenuOnClick;n.state.isFocused?n.props.menuIsOpen?"INPUT"!==e.target.tagName&&"TEXTAREA"!==e.target.tagName&&n.onMenuClose():t&&n.openMenu("first"):(t&&(n.openAfterFocus=!0),n.focusInput()),"INPUT"!==e.target.tagName&&"TEXTAREA"!==e.target.tagName&&e.preventDefault()}},n.onDropdownIndicatorMouseDown=function(e){if(!(e&&"mousedown"===e.type&&0!==e.button||n.props.isDisabled)){var t=n.props,r=t.isMulti,o=t.menuIsOpen;n.focusInput(),o?(n.setState({inputIsHiddenAfterUpdate:!r}),n.onMenuClose()):n.openMenu("first"),e.preventDefault()}},n.onClearIndicatorMouseDown=function(e){e&&"mousedown"===e.type&&0!==e.button||(n.clearValue(),e.preventDefault(),n.openAfterFocus=!1,"touchend"===e.type?n.focusInput():setTimeout((function(){return n.focusInput()})))},n.onScroll=function(e){"boolean"==typeof n.props.closeMenuOnScroll?e.target instanceof HTMLElement&&nR(e.target)&&n.props.onMenuClose():"function"==typeof n.props.closeMenuOnScroll&&n.props.closeMenuOnScroll(e)&&n.props.onMenuClose()},n.onCompositionStart=function(){n.isComposing=!0},n.onCompositionEnd=function(){n.isComposing=!1},n.onTouchStart=function(e){var t=e.touches,r=t&&t.item(0);r&&(n.initialTouchX=r.clientX,n.initialTouchY=r.clientY,n.userIsDragging=!1)},n.onTouchMove=function(e){var t=e.touches,r=t&&t.item(0);if(r){var o=Math.abs(r.clientX-n.initialTouchX),i=Math.abs(r.clientY-n.initialTouchY);n.userIsDragging=o>5||i>5}},n.onTouchEnd=function(e){n.userIsDragging||(n.controlRef&&!n.controlRef.contains(e.target)&&n.menuListRef&&!n.menuListRef.contains(e.target)&&n.blurInput(),n.initialTouchX=0,n.initialTouchY=0)},n.onControlTouchEnd=function(e){n.userIsDragging||n.onControlMouseDown(e)},n.onClearIndicatorTouchEnd=function(e){n.userIsDragging||n.onClearIndicatorMouseDown(e)},n.onDropdownIndicatorTouchEnd=function(e){n.userIsDragging||n.onDropdownIndicatorMouseDown(e)},n.handleInputChange=function(e){var t=n.props.inputValue,r=e.currentTarget.value;n.setState({inputIsHiddenAfterUpdate:!1}),n.onInputChange(r,{action:"input-change",prevInputValue:t}),n.props.menuIsOpen||n.onMenuOpen()},n.onInputFocus=function(e){n.props.onFocus&&n.props.onFocus(e),n.setState({inputIsHiddenAfterUpdate:!1,isFocused:!0}),(n.openAfterFocus||n.props.openMenuOnFocus)&&n.openMenu("first"),n.openAfterFocus=!1},n.onInputBlur=function(e){var t=n.props.inputValue;n.menuListRef&&n.menuListRef.contains(document.activeElement)?n.inputRef.focus():(n.props.onBlur&&n.props.onBlur(e),n.onInputChange("",{action:"input-blur",prevInputValue:t}),n.onMenuClose(),n.setState({focusedValue:null,isFocused:!1}))},n.onOptionHover=function(e){if(!n.blockOptionHover&&n.state.focusedOption!==e){var t=n.getFocusableOptions().indexOf(e);n.setState({focusedOption:e,focusedOptionId:t>-1?n.getFocusedOptionId(e):null})}},n.shouldHideSelectedOptions=function(){return MI(n.props)},n.onValueInputFocus=function(e){e.preventDefault(),e.stopPropagation(),n.focus()},n.onKeyDown=function(e){var t=n.props,r=t.isMulti,o=t.backspaceRemovesValue,i=t.escapeClearsValue,a=t.inputValue,s=t.isClearable,l=t.isDisabled,u=t.menuIsOpen,c=t.onKeyDown,d=t.tabSelectsValue,p=t.openMenuOnFocus,f=n.state,h=f.focusedOption,g=f.focusedValue,v=f.selectValue;if(!(l||"function"==typeof c&&(c(e),e.defaultPrevented))){switch(n.blockOptionHover=!0,e.key){case"ArrowLeft":if(!r||a)return;n.focusValue("previous");break;case"ArrowRight":if(!r||a)return;n.focusValue("next");break;case"Delete":case"Backspace":if(a)return;if(g)n.removeValue(g);else{if(!o)return;r?n.popValue():s&&n.clearValue()}break;case"Tab":if(n.isComposing)return;if(e.shiftKey||!u||!d||!h||p&&n.isOptionSelected(h,v))return;n.selectOption(h);break;case"Enter":if(229===e.keyCode)break;if(u){if(!h)return;if(n.isComposing)return;n.selectOption(h);break}return;case"Escape":u?(n.setState({inputIsHiddenAfterUpdate:!1}),n.onInputChange("",{action:"menu-close",prevInputValue:a}),n.onMenuClose()):s&&i&&n.clearValue();break;case" ":if(a)return;if(!u){n.openMenu("first");break}if(!h)return;n.selectOption(h);break;case"ArrowUp":u?n.focusOption("up"):n.openMenu("last");break;case"ArrowDown":u?n.focusOption("down"):n.openMenu("first");break;case"PageUp":if(!u)return;n.focusOption("pageup");break;case"PageDown":if(!u)return;n.focusOption("pagedown");break;case"Home":if(!u)return;n.focusOption("first");break;case"End":if(!u)return;n.focusOption("last");break;default:return}e.preventDefault()}},n.state.instancePrefix="react-select-"+(n.props.instanceId||++VI),n.state.selectValue=eR(e.value),e.menuIsOpen&&n.state.selectValue.length){var o=n.getFocusableOptionsWithIds(),i=n.buildFocusableOptions(),a=i.indexOf(n.state.selectValue[0]);n.state.focusableOptionsWithIds=o,n.state.focusedOption=i[a],n.state.focusedOptionId=PI(o,i[a])}return n}return Qn(r,[{key:"componentDidMount",value:function(){this.startListeningComposition(),this.startListeningToTouch(),this.props.closeMenuOnScroll&&document&&document.addEventListener&&document.addEventListener("scroll",this.onScroll,!0),this.props.autoFocus&&this.focusInput(),this.props.menuIsOpen&&this.state.focusedOption&&this.menuListRef&&this.focusedOptionRef&&sR(this.menuListRef,this.focusedOptionRef)}},{key:"componentDidUpdate",value:function(e){var t=this.props,r=t.isDisabled,n=t.menuIsOpen,o=this.state.isFocused;(o&&!r&&e.isDisabled||o&&n&&!e.menuIsOpen)&&this.focusInput(),o&&r&&!e.isDisabled?this.setState({isFocused:!1},this.onMenuClose):o||r||!e.isDisabled||this.inputRef!==document.activeElement||this.setState({isFocused:!0}),this.menuListRef&&this.focusedOptionRef&&this.scrollToFocusedOptionOnUpdate&&(sR(this.menuListRef,this.focusedOptionRef),this.scrollToFocusedOptionOnUpdate=!1)}},{key:"componentWillUnmount",value:function(){this.stopListeningComposition(),this.stopListeningToTouch(),document.removeEventListener("scroll",this.onScroll,!0)}},{key:"onMenuOpen",value:function(){this.props.onMenuOpen()}},{key:"onMenuClose",value:function(){this.onInputChange("",{action:"menu-close",prevInputValue:this.props.inputValue}),this.props.onMenuClose()}},{key:"onInputChange",value:function(e,t){this.props.onInputChange(e,t)}},{key:"focusInput",value:function(){this.inputRef&&this.inputRef.focus()}},{key:"blurInput",value:function(){this.inputRef&&this.inputRef.blur()}},{key:"openMenu",value:function(e){var t=this,r=this.state,n=r.selectValue,o=r.isFocused,i=this.buildFocusableOptions(),a="first"===e?0:i.length-1;if(!this.props.isMulti){var s=i.indexOf(n[0]);s>-1&&(a=s)}this.scrollToFocusedOptionOnUpdate=!(o&&this.menuListRef),this.setState({inputIsHiddenAfterUpdate:!1,focusedValue:null,focusedOption:i[a],focusedOptionId:this.getFocusedOptionId(i[a])},(function(){return t.onMenuOpen()}))}},{key:"focusValue",value:function(e){var t=this.state,r=t.selectValue,n=t.focusedValue;if(this.props.isMulti){this.setState({focusedOption:null});var o=r.indexOf(n);n||(o=-1);var i=r.length-1,a=-1;if(r.length){switch(e){case"previous":a=0===o?0:-1===o?i:o-1;break;case"next":o>-1&&o<i&&(a=o+1)}this.setState({inputIsHidden:-1!==a,focusedValue:r[a]})}}}},{key:"focusOption",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"first",t=this.props.pageSize,r=this.state.focusedOption,n=this.getFocusableOptions();if(n.length){var o=0,i=n.indexOf(r);r||(i=-1),"up"===e?o=i>0?i-1:n.length-1:"down"===e?o=(i+1)%n.length:"pageup"===e?(o=i-t)<0&&(o=0):"pagedown"===e?(o=i+t)>n.length-1&&(o=n.length-1):"last"===e&&(o=n.length-1),this.scrollToFocusedOptionOnUpdate=!0,this.setState({focusedOption:n[o],focusedValue:null,focusedOptionId:this.getFocusedOptionId(n[o])})}}},{key:"getTheme",value:function(){return this.props.theme?"function"==typeof this.props.theme?this.props.theme(xI):k_(k_({},xI),this.props.theme):xI}},{key:"getCommonProps",value:function(){var e=this.clearValue,t=this.cx,r=this.getStyles,n=this.getClassNames,o=this.getValue,i=this.selectOption,a=this.setValue,s=this.props,l=s.isMulti,u=s.isRtl,c=s.options;return{clearValue:e,cx:t,getStyles:r,getClassNames:n,getValue:o,hasValue:this.hasValue(),isMulti:l,isRtl:u,options:c,selectOption:i,selectProps:s,setValue:a,theme:this.getTheme()}}},{key:"hasValue",value:function(){return this.state.selectValue.length>0}},{key:"hasOptions",value:function(){return!!this.getFocusableOptions().length}},{key:"isClearable",value:function(){var e=this.props,t=e.isClearable,r=e.isMulti;return void 0===t?r:t}},{key:"isOptionDisabled",value:function(e,t){return NI(this.props,e,t)}},{key:"isOptionSelected",value:function(e,t){return DI(this.props,e,t)}},{key:"filterOption",value:function(e,t){return FI(this.props,e,t)}},{key:"formatOptionLabel",value:function(e,t){if("function"==typeof this.props.formatOptionLabel){var r=this.props.inputValue,n=this.state.selectValue;return this.props.formatOptionLabel(e,{context:t,inputValue:r,selectValue:n})}return this.getOptionLabel(e)}},{key:"formatGroupLabel",value:function(e){return this.props.formatGroupLabel(e)}},{key:"startListeningComposition",value:function(){document&&document.addEventListener&&(document.addEventListener("compositionstart",this.onCompositionStart,!1),document.addEventListener("compositionend",this.onCompositionEnd,!1))}},{key:"stopListeningComposition",value:function(){document&&document.removeEventListener&&(document.removeEventListener("compositionstart",this.onCompositionStart),document.removeEventListener("compositionend",this.onCompositionEnd))}},{key:"startListeningToTouch",value:function(){document&&document.addEventListener&&(document.addEventListener("touchstart",this.onTouchStart,!1),document.addEventListener("touchmove",this.onTouchMove,!1),document.addEventListener("touchend",this.onTouchEnd,!1))}},{key:"stopListeningToTouch",value:function(){document&&document.removeEventListener&&(document.removeEventListener("touchstart",this.onTouchStart),document.removeEventListener("touchmove",this.onTouchMove),document.removeEventListener("touchend",this.onTouchEnd))}},{key:"renderInput",value:function(){var e=this.props,t=e.isDisabled,r=e.isSearchable,n=e.inputId,o=e.inputValue,i=e.tabIndex,a=e.form,s=e.menuIsOpen,l=e.required,u=this.getComponents().Input,c=this.state,d=c.inputIsHidden,p=c.ariaSelection,f=this.commonProps,h=n||this.getElementId("input"),g=k_(k_(k_({"aria-autocomplete":"list","aria-expanded":s,"aria-haspopup":!0,"aria-errormessage":this.props["aria-errormessage"],"aria-invalid":this.props["aria-invalid"],"aria-label":this.props["aria-label"],"aria-labelledby":this.props["aria-labelledby"],"aria-required":l,role:"combobox","aria-activedescendant":this.isAppleDevice?void 0:this.state.focusedOptionId||""},s&&{"aria-controls":this.getElementId("listbox")}),!r&&{"aria-readonly":!0}),this.hasValue()?"initial-input-focus"===(null==p?void 0:p.action)&&{"aria-describedby":this.getElementId("live-region")}:{"aria-describedby":this.getElementId("placeholder")});return r?ve.createElement(u,Cb({},f,{autoCapitalize:"none",autoComplete:"off",autoCorrect:"off",id:h,innerRef:this.getInputRef,isDisabled:t,isHidden:d,onBlur:this.onInputBlur,onChange:this.handleInputChange,onFocus:this.onInputFocus,spellCheck:"false",tabIndex:i,form:a,type:"text",value:o},g)):ve.createElement(iI,Cb({id:h,innerRef:this.getInputRef,onBlur:this.onInputBlur,onChange:QC,onFocus:this.onInputFocus,disabled:t,tabIndex:i,inputMode:"none",form:a,value:""},g))}},{key:"renderPlaceholderOrValue",value:function(){var e=this,t=this.getComponents(),r=t.MultiValue,n=t.MultiValueContainer,o=t.MultiValueLabel,i=t.MultiValueRemove,a=t.SingleValue,s=t.Placeholder,l=this.commonProps,u=this.props,c=u.controlShouldRenderValue,d=u.isDisabled,p=u.isMulti,f=u.inputValue,h=u.placeholder,g=this.state,v=g.selectValue,m=g.focusedValue,y=g.isFocused;if(!this.hasValue()||!c)return f?null:ve.createElement(s,Cb({},l,{key:"placeholder",isDisabled:d,isFocused:y,innerProps:{id:this.getElementId("placeholder")}}),h);if(p)return v.map((function(t,a){var s=t===m,u="".concat(e.getOptionLabel(t),"-").concat(e.getOptionValue(t));return ve.createElement(r,Cb({},l,{components:{Container:n,Label:o,Remove:i},isFocused:s,isDisabled:d,key:u,index:a,removeProps:{onClick:function(){return e.removeValue(t)},onTouchEnd:function(){return e.removeValue(t)},onMouseDown:function(e){e.preventDefault()}},data:t}),e.formatOptionLabel(t,"value"))}));if(f)return null;var b=v[0];return ve.createElement(a,Cb({},l,{data:b,isDisabled:d}),this.formatOptionLabel(b,"value"))}},{key:"renderClearIndicator",value:function(){var e=this.getComponents().ClearIndicator,t=this.commonProps,r=this.props,n=r.isDisabled,o=r.isLoading,i=this.state.isFocused;if(!this.isClearable()||!e||n||!this.hasValue()||o)return null;var a={onMouseDown:this.onClearIndicatorMouseDown,onTouchEnd:this.onClearIndicatorTouchEnd,"aria-hidden":"true"};return ve.createElement(e,Cb({},t,{innerProps:a,isFocused:i}))}},{key:"renderLoadingIndicator",value:function(){var e=this.getComponents().LoadingIndicator,t=this.commonProps,r=this.props,n=r.isDisabled,o=r.isLoading,i=this.state.isFocused;return e&&o?ve.createElement(e,Cb({},t,{innerProps:{"aria-hidden":"true"},isDisabled:n,isFocused:i})):null}},{key:"renderIndicatorSeparator",value:function(){var e=this.getComponents(),t=e.DropdownIndicator,r=e.IndicatorSeparator;if(!t||!r)return null;var n=this.commonProps,o=this.props.isDisabled,i=this.state.isFocused;return ve.createElement(r,Cb({},n,{isDisabled:o,isFocused:i}))}},{key:"renderDropdownIndicator",value:function(){var e=this.getComponents().DropdownIndicator;if(!e)return null;var t=this.commonProps,r=this.props.isDisabled,n=this.state.isFocused,o={onMouseDown:this.onDropdownIndicatorMouseDown,onTouchEnd:this.onDropdownIndicatorTouchEnd,"aria-hidden":"true"};return ve.createElement(e,Cb({},t,{innerProps:o,isDisabled:r,isFocused:n}))}},{key:"renderMenu",value:function(){var e=this,t=this.getComponents(),r=t.Group,n=t.GroupHeading,o=t.Menu,i=t.MenuList,a=t.MenuPortal,s=t.LoadingMessage,l=t.NoOptionsMessage,u=t.Option,c=this.commonProps,d=this.state.focusedOption,p=this.props,f=p.captureMenuScroll,h=p.inputValue,g=p.isLoading,v=p.loadingMessage,m=p.minMenuHeight,y=p.maxMenuHeight,b=p.menuIsOpen,O=p.menuPlacement,E=p.menuPosition,S=p.menuPortalTarget,w=p.menuShouldBlockScroll,T=p.menuShouldScrollIntoView,x=p.noOptionsMessage,_=p.onMenuScrollToTop,C=p.onMenuScrollToBottom;if(!b)return null;var R,I=function(t,r){var n=t.type,o=t.data,i=t.isDisabled,a=t.isSelected,s=t.label,l=t.value,p=d===o,f=i?void 0:function(){return e.onOptionHover(o)},h=i?void 0:function(){return e.selectOption(o)},g="".concat(e.getElementId("option"),"-").concat(r),v={id:g,onClick:h,onMouseMove:f,onMouseOver:f,tabIndex:-1,role:"option","aria-selected":e.isAppleDevice?void 0:a};return ve.createElement(u,Cb({},c,{innerProps:v,data:o,isDisabled:i,isSelected:a,key:g,label:s,type:n,value:l,isFocused:p,innerRef:p?e.getFocusedOptionRef:void 0}),e.formatOptionLabel(t.data,"menu"))};if(this.hasOptions())R=this.getCategorizedOptions().map((function(t){if("group"===t.type){var o=t.data,i=t.options,a=t.index,s="".concat(e.getElementId("group"),"-").concat(a),l="".concat(s,"-heading");return ve.createElement(r,Cb({},c,{key:s,data:o,options:i,Heading:n,headingProps:{id:l,data:t.data},label:e.formatGroupLabel(t.data)}),t.options.map((function(e){return I(e,"".concat(a,"-").concat(e.index))})))}if("option"===t.type)return I(t,"".concat(t.index))}));else if(g){var A=v({inputValue:h});if(null===A)return null;R=ve.createElement(s,c,A)}else{var j=x({inputValue:h});if(null===j)return null;R=ve.createElement(l,c,j)}var P={minMenuHeight:m,maxMenuHeight:y,menuPlacement:O,menuPosition:E,menuShouldScrollIntoView:T},L=ve.createElement(OR,Cb({},c,P),(function(t){var r=t.ref,n=t.placerProps,a=n.placement,s=n.maxHeight;return ve.createElement(o,Cb({},c,P,{innerRef:r,innerProps:{onMouseDown:e.onMenuMouseDown,onMouseMove:e.onMenuMouseMove},isLoading:g,placement:a}),ve.createElement(mI,{captureEnabled:f,onTopArrive:_,onBottomArrive:C,lockEnabled:w},(function(t){return ve.createElement(i,Cb({},c,{innerRef:function(r){e.getMenuListRef(r),t(r)},innerProps:{role:"listbox","aria-multiselectable":c.isMulti,id:e.getElementId("listbox")},isLoading:g,maxHeight:s,focusedOption:d}),R)})))}));return S||"fixed"===E?ve.createElement(a,Cb({},c,{appendTo:S,controlElement:this.controlRef,menuPlacement:O,menuPosition:E}),L):L}},{key:"renderFormField",value:function(){var e=this,t=this.props,r=t.delimiter,n=t.isDisabled,o=t.isMulti,i=t.name,a=t.required,s=this.state.selectValue;if(a&&!this.hasValue()&&!n)return ve.createElement(bI,{name:i,onFocus:this.onValueInputFocus});if(i&&!n){if(o){if(r){var l=s.map((function(t){return e.getOptionValue(t)})).join(r);return ve.createElement("input",{name:i,type:"hidden",value:l})}var u=s.length>0?s.map((function(t,r){return ve.createElement("input",{key:"i-".concat(r),name:i,type:"hidden",value:e.getOptionValue(t)})})):ve.createElement("input",{name:i,type:"hidden",value:""});return ve.createElement("div",null,u)}var c=s[0]?this.getOptionValue(s[0]):"";return ve.createElement("input",{name:i,type:"hidden",value:c})}}},{key:"renderLiveRegion",value:function(){var e=this.commonProps,t=this.state,r=t.ariaSelection,n=t.focusedOption,o=t.focusedValue,i=t.isFocused,a=t.selectValue,s=this.getFocusableOptions();return ve.createElement(GR,Cb({},e,{id:this.getElementId("live-region"),ariaSelection:r,focusedOption:n,focusedValue:o,isFocused:i,selectValue:a,focusableOptions:s,isAppleDevice:this.isAppleDevice}))}},{key:"render",value:function(){var e=this.getComponents(),t=e.Control,r=e.IndicatorsContainer,n=e.SelectContainer,o=e.ValueContainer,i=this.props,a=i.className,s=i.id,l=i.isDisabled,u=i.menuIsOpen,c=this.state.isFocused,d=this.commonProps=this.getCommonProps();return ve.createElement(n,Cb({},d,{className:a,innerProps:{id:s,onKeyDown:this.onKeyDown},isDisabled:l,isFocused:c}),this.renderLiveRegion(),ve.createElement(t,Cb({},d,{innerRef:this.getControlRef,innerProps:{onMouseDown:this.onControlMouseDown,onTouchEnd:this.onControlTouchEnd},isDisabled:l,isFocused:c,menuIsOpen:u}),ve.createElement(o,Cb({},d,{isDisabled:l}),this.renderPlaceholderOrValue(),this.renderInput()),ve.createElement(r,Cb({},d,{isDisabled:l}),this.renderClearIndicator(),this.renderLoadingIndicator(),this.renderIndicatorSeparator(),this.renderDropdownIndicator())),this.renderMenu(),this.renderFormField())}}],[{key:"getDerivedStateFromProps",value:function(e,t){var r=t.prevProps,n=t.clearFocusValueOnUpdate,o=t.inputIsHiddenAfterUpdate,i=t.ariaSelection,a=t.isFocused,s=t.prevWasFocused,l=t.instancePrefix,u=e.options,c=e.value,d=e.menuIsOpen,p=e.inputValue,f=e.isMulti,h=eR(c),g={};if(r&&(c!==r.value||u!==r.options||d!==r.menuIsOpen||p!==r.inputValue)){var v=d?function(e,t){return II(RI(e,t))}(e,h):[],m=d?AI(RI(e,h),"".concat(l,"-option")):[],y=n?function(e,t){var r=e.focusedValue,n=e.selectValue.indexOf(r);if(n>-1){if(t.indexOf(r)>-1)return r;if(n<t.length)return t[n]}return null}(t,h):null,b=function(e,t){var r=e.focusedOption;return r&&t.indexOf(r)>-1?r:t[0]}(t,v);g={selectValue:h,focusedOption:b,focusedOptionId:PI(m,b),focusableOptionsWithIds:m,focusedValue:y,clearFocusValueOnUpdate:!1}}var O=null!=o&&e!==r?{inputIsHidden:o,inputIsHiddenAfterUpdate:void 0}:{},E=i,S=a&&s;return a&&!S&&(E={value:hR(f,h,h[0]||null),options:h,action:"initial-input-focus"},S=!s),"initial-input-focus"===(null==i?void 0:i.action)&&(E=null),k_(k_(k_({},g),O),{},{prevProps:e,ariaSelection:E,prevWasFocused:S})}}]),r}(ve.Component);UI.defaultProps=_I,Math.abs,String.fromCharCode,Object.assign;var BI=(0,ve.forwardRef)((function(e,t){var r=D_(e);return ve.createElement(UI,Cb({ref:t},r))})),zI=["defaultOptions","cacheOptions","loadOptions","options","isLoading","onInputChange","filterOption"];function $I(e){var t=e.defaultOptions,r=void 0!==t&&t,n=e.cacheOptions,o=void 0!==n&&n,i=e.loadOptions;e.options;var a=e.isLoading,s=void 0!==a&&a,l=e.onInputChange,u=e.filterOption,c=void 0===u?null:u,d=nm(e,zI),p=d.inputValue,f=(0,ve.useRef)(void 0),h=(0,ve.useRef)(!1),g=lo((0,ve.useState)(Array.isArray(r)?r:void 0),2),v=g[0],m=g[1],y=lo((0,ve.useState)(void 0!==p?p:""),2),b=y[0],O=y[1],E=lo((0,ve.useState)(!0===r),2),S=E[0],w=E[1],T=lo((0,ve.useState)(void 0),2),x=T[0],_=T[1],C=lo((0,ve.useState)([]),2),R=C[0],I=C[1],A=lo((0,ve.useState)(!1),2),j=A[0],P=A[1],L=lo((0,ve.useState)({}),2),k=L[0],N=L[1],D=lo((0,ve.useState)(void 0),2),F=D[0],M=D[1],V=lo((0,ve.useState)(void 0),2),U=V[0],B=V[1];o!==U&&(N({}),B(o)),r!==F&&(m(Array.isArray(r)?r:void 0),M(r)),(0,ve.useEffect)((function(){return h.current=!0,function(){h.current=!1}}),[]);var z=(0,ve.useCallback)((function(e,t){if(!i)return t();var r=i(e,t);r&&"function"==typeof r.then&&r.then(t,(function(){return t()}))}),[i]);(0,ve.useEffect)((function(){!0===r&&z(b,(function(e){h.current&&(m(e||[]),w(!!f.current))}))}),[]);var $=(0,ve.useCallback)((function(e,t){var r=function(e,t,r){if(r){var n=r(e,t);if("string"==typeof n)return n}return e}(e,t,l);if(!r)return f.current=void 0,O(""),_(""),I([]),w(!1),void P(!1);if(o&&k[r])O(r),_(r),I(k[r]),w(!1),P(!1);else{var n=f.current={};O(r),w(!0),P(!x),z(r,(function(e){h&&n===f.current&&(f.current=void 0,w(!1),_(r),I(e||[]),P(!1),N(e?k_(k_({},k),{},no({},r,e)):k))}))}}),[o,z,x,k,l]),W=j?[]:b&&x?R:v||[];return k_(k_({},d),{},{options:W,isLoading:S||s,onInputChange:$,filterOption:c})}var WI=(0,ve.forwardRef)((function(e,t){var r=D_($I(e));return ve.createElement(UI,Cb({ref:t},r))})),HI=["allowCreateWhileLoading","createOptionPosition","formatCreateLabel","isValidNewOption","getNewOptionData","onCreateOption","options","onChange"],qI=function(){var e=arguments.length>1?arguments[1]:void 0,t=arguments.length>2?arguments[2]:void 0,r=String(arguments.length>0&&void 0!==arguments[0]?arguments[0]:"").toLowerCase(),n=String(t.getOptionValue(e)).toLowerCase(),o=String(t.getOptionLabel(e)).toLowerCase();return n===r||o===r},GI={formatCreateLabel:function(e){return'Create "'.concat(e,'"')},isValidNewOption:function(e,t,r,n){return!(!e||t.some((function(t){return qI(e,t,n)}))||r.some((function(t){return qI(e,t,n)})))},getNewOptionData:function(e,t){return{label:t,value:e,__isNew__:!0}}};function KI(e){var t=e.allowCreateWhileLoading,r=void 0!==t&&t,n=e.createOptionPosition,o=void 0===n?"last":n,i=e.formatCreateLabel,a=void 0===i?GI.formatCreateLabel:i,s=e.isValidNewOption,l=void 0===s?GI.isValidNewOption:s,u=e.getNewOptionData,c=void 0===u?GI.getNewOptionData:u,d=e.onCreateOption,p=e.options,f=void 0===p?[]:p,h=e.onChange,g=nm(e,HI),v=g.getOptionValue,m=void 0===v?wI:v,y=g.getOptionLabel,b=void 0===y?SI:y,O=g.inputValue,E=g.isLoading,S=g.isMulti,w=g.value,T=g.name,x=(0,ve.useMemo)((function(){return l(O,eR(w),f,{getOptionValue:m,getOptionLabel:b})?c(O,a(O)):void 0}),[a,c,b,m,O,l,f,w]),_=(0,ve.useMemo)((function(){return!r&&E||!x?f:"first"===o?[x].concat(co(f)):[].concat(co(f),[x])}),[r,o,E,x,f]),C=(0,ve.useCallback)((function(e,t){if("select-option"!==t.action)return h(e,t);var r=Array.isArray(e)?e:[e];if(r[r.length-1]!==x)h(e,t);else if(d)d(O);else{var n=c(O,O),o={action:"create-option",name:T,option:n};h(hR(S,[].concat(co(eR(w)),[n]),n),o)}}),[c,O,S,T,x,d,h,w]);return k_(k_({},g),{},{options:_,onChange:C})}var YI=(0,ve.forwardRef)((function(e,t){var r=KI(D_($I(e)));return ve.createElement(UI,Cb({ref:t},r))})),XI=(0,ve.forwardRef)((function(e,t){var r=KI(D_(e));return ve.createElement(UI,Cb({ref:t},r))})),QI=v(627),JI=v.n(QI),ZI=/\s([^'"/\s><]+?)[\s/>]|([^\s=]+)=\s?(".*?"|'.*?')/g;function eA(e){var t={type:"tag",name:"",voidElement:!1,attrs:{},children:[]},r=e.match(/<\/?([^\s]+?)[/\s>]/);if(r&&(t.name=r[1],(JI()[r[1]]||"/"===e.charAt(e.length-2))&&(t.voidElement=!0),t.name.startsWith("!--"))){var n=e.indexOf("--\x3e");return{type:"comment",comment:-1!==n?e.slice(4,n):""}}for(var o=new RegExp(ZI),i=null;null!==(i=o.exec(e));)if(i[0].trim())if(i[1]){var a=i[1].trim(),s=[a,""];a.indexOf("=")>-1&&(s=a.split("=")),t.attrs[s[0]]=s[1],o.lastIndex--}else i[2]&&(t.attrs[i[2]]=i[3].trim().substring(1,i[3].length-1));return t}var tA=/<[a-zA-Z0-9\-\!\/](?:"[^"]*"|'[^']*'|[^'">])*>/g,rA=/^\s*$/,nA=Object.create(null);function oA(e,t){switch(t.type){case"text":return e+t.content;case"tag":return e+="<"+t.name+(t.attrs?function(e){var t=[];for(var r in e)t.push(r+'="'+e[r]+'"');return t.length?" "+t.join(" "):""}(t.attrs):"")+(t.voidElement?"/>":">"),t.voidElement?e:e+t.children.reduce(oA,"")+"</"+t.name+">";case"comment":return e+"\x3c!--"+t.comment+"--\x3e"}}var iA={parse:function(e,t){t||(t={}),t.components||(t.components=nA);var r,n=[],o=[],i=-1,a=!1;if(0!==e.indexOf("<")){var s=e.indexOf("<");n.push({type:"text",content:-1===s?e:e.substring(0,s)})}return e.replace(tA,(function(s,l){if(a){if(s!=="</"+r.name+">")return;a=!1}var u,c="/"!==s.charAt(1),d=s.startsWith("\x3c!--"),p=l+s.length,f=e.charAt(p);if(d){var h=eA(s);return i<0?(n.push(h),n):((u=o[i]).children.push(h),n)}if(c&&(i++,"tag"===(r=eA(s)).type&&t.components[r.name]&&(r.type="component",a=!0),r.voidElement||a||!f||"<"===f||r.children.push({type:"text",content:e.slice(p,e.indexOf("<",p))}),0===i&&n.push(r),(u=o[i-1])&&u.children.push(r),o[i]=r),(!c||r.voidElement)&&(i>-1&&(r.voidElement||r.name===s.slice(2,-1))&&(i--,r=-1===i?n:o[i]),!a&&"<"!==f&&f)){u=-1===i?n:o[i].children;var g=e.indexOf("<",p),v=e.slice(p,-1===g?void 0:g);rA.test(v)&&(v=" "),(g>-1&&i+u.length>=0||" "!==v)&&u.push({type:"text",content:v})}})),n},stringify:function(e){return e.reduce((function(e,t){return e+oA("",t)}),"")}};const aA=iA;function sA(){if(console&&console.warn){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];"string"==typeof t[0]&&(t[0]=`react-i18next:: ${t[0]}`),console.warn(...t)}}const lA={};const uA=/&(?:amp|#38|lt|#60|gt|#62|apos|#39|quot|#34|nbsp|#160|copy|#169|reg|#174|hellip|#8230|#x2F|#47);/g,cA={"&amp;":"&","&#38;":"&","&lt;":"<","&#60;":"<","&gt;":">","&#62;":">","&apos;":"'","&#39;":"'","&quot;":'"',"&#34;":'"',"&nbsp;":" ","&#160;":" ","&copy;":"©","&#169;":"©","&reg;":"®","&#174;":"®","&hellip;":"…","&#8230;":"…","&#x2F;":"/","&#47;":"/"},dA=e=>cA[e];let pA,fA={bindI18n:"languageChanged",bindI18nStore:"",transEmptyNodeValue:"",transSupportBasicHtmlNodes:!0,transWrapTextNodes:"",transKeepBasicHtmlNodesFor:["br","strong","i","p"],useSuspense:!0,unescape:e=>e.replace(uA,dA)};function hA(){return pA}function gA(e,t){if(!e)return!1;const r=e.props?e.props.children:e.children;return t?r.length>0:!!r}function vA(e){if(!e)return[];const t=e.props?e.props.children:e.children;return e.props&&e.props.i18nIsDynamicList?mA(t):t}function mA(e){return Array.isArray(e)?e:[e]}function yA(e,t){if(!e)return"";let r="";const n=mA(e),o=t.transSupportBasicHtmlNodes&&t.transKeepBasicHtmlNodesFor?t.transKeepBasicHtmlNodesFor:[];return n.forEach(((e,n)=>{if("string"==typeof e)r+=`${e}`;else if((0,ve.isValidElement)(e)){const i=Object.keys(e.props).length,a=o.indexOf(e.type)>-1,s=e.props.children;if(!s&&a&&0===i)r+=`<${e.type}/>`;else if(s||a&&0===i)if(e.props.i18nIsDynamicList)r+=`<${n}></${n}>`;else if(a&&1===i&&"string"==typeof s)r+=`<${e.type}>${s}</${e.type}>`;else{const e=yA(s,t);r+=`<${n}>${e}</${n}>`}else r+=`<${n}></${n}>`}else if(null===e)sA("Trans: the passed in value is invalid - seems you passed in a null child.");else if("object"==typeof e){const{format:t,...n}=e,o=Object.keys(n);if(1===o.length){const e=t?`${o[0]}, ${t}`:o[0];r+=`{{${e}}}`}else sA("react-i18next: the passed in object contained more than one variable - the object should look like {{ value, format }} where format is optional.",e)}else sA("Trans: the passed in value is invalid - seems you passed in a variable like {number} - please pass in variables for interpolation as full objects like {{number}}.",e)})),r}function bA(e){let{children:t,count:r,parent:n,i18nKey:o,context:i,tOptions:a={},values:s,defaults:l,components:u,ns:c,i18n:d,t:p,shouldUnescape:f,...h}=e;const g=d||hA();if(!g)return function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];"string"==typeof t[0]&&lA[t[0]]||("string"==typeof t[0]&&(lA[t[0]]=new Date),sA(...t))}("You will need to pass in an i18next instance by using i18nextReactModule"),t;const v=p||g.t.bind(g)||(e=>e),m={...fA,...g.options&&g.options.react};let y=c||v.ns||g.options&&g.options.defaultNS;y="string"==typeof y?[y]:y||["translation"];const b=yA(t,m),O=l||b||m.transEmptyNodeValue||o,{hashTransKey:E}=m,S=o||(E?E(b||O):b||O);g.options&&g.options.interpolation&&g.options.interpolation.defaultVariables&&(s=s&&Object.keys(s).length>0?{...s,...g.options.interpolation.defaultVariables}:{...g.options.interpolation.defaultVariables});const w=s||void 0!==r||!t?a.interpolation:{interpolation:{...a.interpolation,prefix:"#$?",suffix:"?$#"}},T={...a,context:i||a.context,count:r,...s,...w,defaultValue:O,ns:y},x=S?v(S,T):O;u&&Object.keys(u).forEach((e=>{const t=u[e];"function"==typeof t.type||!t.props||!t.props.children||x.indexOf(`${e}/>`)<0&&x.indexOf(`${e} />`)<0||(u[e]=(0,ve.createElement)((function(){return(0,ve.createElement)(ve.Fragment,null,t)})))}));const _=function(e,t,r,n,o,i){if(""===t)return[];const a=n.transKeepBasicHtmlNodesFor||[],s=t&&new RegExp(a.map((e=>`<${e}`)).join("|")).test(t);if(!e&&!s&&!i)return[t];const l={};!function e(t){mA(t).forEach((t=>{"string"!=typeof t&&(gA(t)?e(vA(t)):"object"!=typeof t||(0,ve.isValidElement)(t)||Object.assign(l,t))}))}(e);const u=aA.parse(`<0>${t}</0>`),c={...l,...o};function d(e,t,r){const n=vA(e),o=f(n,t.children,r);return function(e){return"[object Array]"===Object.prototype.toString.call(e)&&e.every((e=>(0,ve.isValidElement)(e)))}(n)&&0===o.length||e.props&&e.props.i18nIsDynamicList?n:o}function p(e,t,r,n,o){e.dummy?(e.children=t,r.push((0,ve.cloneElement)(e,{key:n},o?void 0:t))):r.push(...ve.Children.map([e],(e=>{const r={...e.props};return delete r.i18nIsDynamicList,(0,ve.createElement)(e.type,{...r,key:n,ref:e.ref},o?null:t)})))}function f(t,o,l){const u=mA(t);return mA(o).reduce(((t,o,h)=>{const g=o.children&&o.children[0]&&o.children[0].content&&r.services.interpolator.interpolate(o.children[0].content,c,r.language);if("tag"===o.type){let i=u[parseInt(o.name,10)];1!==l.length||i||(i=l[0][o.name]),i||(i={});const v=0!==Object.keys(o.attrs).length?function(e,t){const r={...t};return r.props=Object.assign(e.props,t.props),r}({props:o.attrs},i):i,m=(0,ve.isValidElement)(v),y=m&&gA(o,!0)&&!o.voidElement,b=s&&"object"==typeof v&&v.dummy&&!m,O="object"==typeof e&&null!==e&&Object.hasOwnProperty.call(e,o.name);if("string"==typeof v){const e=r.services.interpolator.interpolate(v,c,r.language);t.push(e)}else if(gA(v)||y)p(v,d(v,o,l),t,h);else if(b)p(v,f(u,o.children,l),t,h);else if(Number.isNaN(parseFloat(o.name)))if(O)p(v,d(v,o,l),t,h,o.voidElement);else if(n.transSupportBasicHtmlNodes&&a.indexOf(o.name)>-1)if(o.voidElement)t.push((0,ve.createElement)(o.name,{key:`${o.name}-${h}`}));else{const e=f(u,o.children,l);t.push((0,ve.createElement)(o.name,{key:`${o.name}-${h}`},e))}else if(o.voidElement)t.push(`<${o.name} />`);else{const e=f(u,o.children,l);t.push(`<${o.name}>${e}</${o.name}>`)}else if("object"!=typeof v||m)p(v,g,t,h,1!==o.children.length||!g);else{const e=o.children[0]?g:null;e&&t.push(e)}}else if("text"===o.type){const e=n.transWrapTextNodes,a=i?n.unescape(r.services.interpolator.interpolate(o.content,c,r.language)):r.services.interpolator.interpolate(o.content,c,r.language);e?t.push((0,ve.createElement)(e,{key:`${o.name}-${h}`},a)):t.push(a)}return t}),[])}return vA(f([{dummy:!0,children:e||[]}],u,mA(e||[]))[0])}(u||t,x,g,m,T,f),C=void 0!==n?n:m.defaultTransParent;return C?(0,ve.createElement)(C,h,_):_}const OA={type:"3rdParty",init(e){!function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};fA={...fA,...e}}(e.options.react),function(e){pA=e}(e)}},EA=(0,ve.createContext)();function SA(e){let{children:t,count:r,parent:n,i18nKey:o,context:i,tOptions:a={},values:s,defaults:l,components:u,ns:c,i18n:d,t:p,shouldUnescape:f,...h}=e;const{i18n:g,defaultNS:v}=(0,ve.useContext)(EA)||{},m=d||g||hA(),y=p||m&&m.t.bind(m);return bA({children:t,count:r,parent:n,i18nKey:o,context:i,tOptions:a,values:s,defaults:l,components:u,ns:c||y&&y.ns||v||m&&m.options&&m.options.defaultNS,i18n:m,t:p,shouldUnescape:f,...h})}function wA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function TA(){"object"!=typeof Tf.options.resources&&Tf.use(OA).init({resources:{},returnEmptyString:!1,lng:"en-US"})}const xA=e=>(TA(),(0,ge.jsx)(SA,function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){wA(e,t,r[t])}))}return e}({},e))),_A=Tf.t,CA=({className:e,inline:t=!1,iconClassName:r,style:n,size:o="md"})=>{const i=Qx(RA),a=Qx(IA,o),s=window.matchMedia("(prefers-reduced-motion: reduce)").matches?"hourglass":"spinner";if("string"!=typeof o||!["xs","sm","md","lg","xl","xxl","xxxl"].includes(o)){const r=`${O_()}${m_(s,"default")}/${s}.svg`;return(0,ge.jsx)("div",{"data-testid":"Spinner",style:n,className:(0,$e.cx)({[i.inline]:t},a.wrapper,e),children:(0,ge.jsx)(h_,{src:r,width:o,height:o,className:(0,$e.cx)(i.spin,a.icon,e),style:n})})}return(0,ge.jsx)("div",{"data-testid":"Spinner",style:n,className:(0,$e.cx)({[i.inline]:t},e),children:(0,ge.jsx)(w_,{className:(0,$e.cx)(i.spin,r),name:s,size:o,"aria-label":("grafana-ui.spinner.aria-label","Loading",TA(),_A("grafana-ui.spinner.aria-label","Loading",undefined))})})},RA=e=>({inline:(0,$e.css)({display:"inline-block"}),spin:(0,$e.css)({[e.transitions.handleMotion("no-preference")]:{animation:`${g_} 2s infinite linear`}})}),IA=(e,t)=>({wrapper:(0,$e.css)({fontSize:"string"==typeof t?t:`${t}px`}),icon:(0,$e.css)({display:"inline-block",fill:"currentColor",flexShrink:0,label:"Icon",lineHeight:0,verticalAlign:"middle"})});function AA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const jA=e=>{let t;return"data-testid"in e.selectProps&&e.selectProps["data-testid"]&&(t=e.selectProps["data-testid"]+"-input"),(0,ge.jsx)(BR.Input,(r=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){AA(e,t,r[t])}))}return e}({},e),n=null!=(n={"data-testid":t})?n:{},Object.getOwnPropertyDescriptors?Object.defineProperties(r,Object.getOwnPropertyDescriptors(n)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(n)).forEach((function(e){Object.defineProperty(r,e,Object.getOwnPropertyDescriptor(n,e))})),r));var r,n};function PA({selectProps:e}){const t=e.menuIsOpen,r=t?"search":"angle-down",n=t?"sm":"md";return(0,ge.jsx)(w_,{name:r,size:n})}var LA=v(8145);function kA(e){return qx()(e)}function NA(e){return NA="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},NA(e)}var DA=/^\s+/,FA=/\s+$/;function MA(e,t){if(t=t||{},(e=e||"")instanceof MA)return e;if(!(this instanceof MA))return new MA(e,t);var r=function(e){var t={r:0,g:0,b:0},r=1,n=null,o=null,i=null,a=!1,s=!1;return"string"==typeof e&&(e=function(e){e=e.replace(DA,"").replace(FA,"").toLowerCase();var t,r=!1;if(tj[e])e=tj[e],r=!0;else if("transparent"==e)return{r:0,g:0,b:0,a:0,format:"name"};return(t=hj.rgb.exec(e))?{r:t[1],g:t[2],b:t[3]}:(t=hj.rgba.exec(e))?{r:t[1],g:t[2],b:t[3],a:t[4]}:(t=hj.hsl.exec(e))?{h:t[1],s:t[2],l:t[3]}:(t=hj.hsla.exec(e))?{h:t[1],s:t[2],l:t[3],a:t[4]}:(t=hj.hsv.exec(e))?{h:t[1],s:t[2],v:t[3]}:(t=hj.hsva.exec(e))?{h:t[1],s:t[2],v:t[3],a:t[4]}:(t=hj.hex8.exec(e))?{r:aj(t[1]),g:aj(t[2]),b:aj(t[3]),a:cj(t[4]),format:r?"name":"hex8"}:(t=hj.hex6.exec(e))?{r:aj(t[1]),g:aj(t[2]),b:aj(t[3]),format:r?"name":"hex"}:(t=hj.hex4.exec(e))?{r:aj(t[1]+""+t[1]),g:aj(t[2]+""+t[2]),b:aj(t[3]+""+t[3]),a:cj(t[4]+""+t[4]),format:r?"name":"hex8"}:!!(t=hj.hex3.exec(e))&&{r:aj(t[1]+""+t[1]),g:aj(t[2]+""+t[2]),b:aj(t[3]+""+t[3]),format:r?"name":"hex"}}(e)),"object"==NA(e)&&(gj(e.r)&&gj(e.g)&&gj(e.b)?(t=function(e,t,r){return{r:255*oj(e,255),g:255*oj(t,255),b:255*oj(r,255)}}(e.r,e.g,e.b),a=!0,s="%"===String(e.r).substr(-1)?"prgb":"rgb"):gj(e.h)&&gj(e.s)&&gj(e.v)?(n=lj(e.s),o=lj(e.v),t=function(e,t,r){e=6*oj(e,360),t=oj(t,100),r=oj(r,100);var n=Math.floor(e),o=e-n,i=r*(1-t),a=r*(1-o*t),s=r*(1-(1-o)*t),l=n%6;return{r:255*[r,a,i,i,s,r][l],g:255*[s,r,r,a,i,i][l],b:255*[i,i,s,r,r,a][l]}}(e.h,n,o),a=!0,s="hsv"):gj(e.h)&&gj(e.s)&&gj(e.l)&&(n=lj(e.s),i=lj(e.l),t=function(e,t,r){var n,o,i;function a(e,t,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?e+6*(t-e)*r:r<.5?t:r<2/3?e+(t-e)*(2/3-r)*6:e}if(e=oj(e,360),t=oj(t,100),r=oj(r,100),0===t)n=o=i=r;else{var s=r<.5?r*(1+t):r+t-r*t,l=2*r-s;n=a(l,s,e+1/3),o=a(l,s,e),i=a(l,s,e-1/3)}return{r:255*n,g:255*o,b:255*i}}(e.h,n,i),a=!0,s="hsl"),e.hasOwnProperty("a")&&(r=e.a)),r=nj(r),{ok:a,format:e.format||s,r:Math.min(255,Math.max(t.r,0)),g:Math.min(255,Math.max(t.g,0)),b:Math.min(255,Math.max(t.b,0)),a:r}}(e);this._originalInput=e,this._r=r.r,this._g=r.g,this._b=r.b,this._a=r.a,this._roundA=Math.round(100*this._a)/100,this._format=t.format||r.format,this._gradientType=t.gradientType,this._r<1&&(this._r=Math.round(this._r)),this._g<1&&(this._g=Math.round(this._g)),this._b<1&&(this._b=Math.round(this._b)),this._ok=r.ok}function VA(e,t,r){e=oj(e,255),t=oj(t,255),r=oj(r,255);var n,o,i=Math.max(e,t,r),a=Math.min(e,t,r),s=(i+a)/2;if(i==a)n=o=0;else{var l=i-a;switch(o=s>.5?l/(2-i-a):l/(i+a),i){case e:n=(t-r)/l+(t<r?6:0);break;case t:n=(r-e)/l+2;break;case r:n=(e-t)/l+4}n/=6}return{h:n,s:o,l:s}}function UA(e,t,r){e=oj(e,255),t=oj(t,255),r=oj(r,255);var n,o,i=Math.max(e,t,r),a=Math.min(e,t,r),s=i,l=i-a;if(o=0===i?0:l/i,i==a)n=0;else{switch(i){case e:n=(t-r)/l+(t<r?6:0);break;case t:n=(r-e)/l+2;break;case r:n=(e-t)/l+4}n/=6}return{h:n,s:o,v:s}}function BA(e,t,r,n){var o=[sj(Math.round(e).toString(16)),sj(Math.round(t).toString(16)),sj(Math.round(r).toString(16))];return n&&o[0].charAt(0)==o[0].charAt(1)&&o[1].charAt(0)==o[1].charAt(1)&&o[2].charAt(0)==o[2].charAt(1)?o[0].charAt(0)+o[1].charAt(0)+o[2].charAt(0):o.join("")}function zA(e,t,r,n){return[sj(uj(n)),sj(Math.round(e).toString(16)),sj(Math.round(t).toString(16)),sj(Math.round(r).toString(16))].join("")}function $A(e,t){t=0===t?0:t||10;var r=MA(e).toHsl();return r.s-=t/100,r.s=ij(r.s),MA(r)}function WA(e,t){t=0===t?0:t||10;var r=MA(e).toHsl();return r.s+=t/100,r.s=ij(r.s),MA(r)}function HA(e){return MA(e).desaturate(100)}function qA(e,t){t=0===t?0:t||10;var r=MA(e).toHsl();return r.l+=t/100,r.l=ij(r.l),MA(r)}function GA(e,t){t=0===t?0:t||10;var r=MA(e).toRgb();return r.r=Math.max(0,Math.min(255,r.r-Math.round(-t/100*255))),r.g=Math.max(0,Math.min(255,r.g-Math.round(-t/100*255))),r.b=Math.max(0,Math.min(255,r.b-Math.round(-t/100*255))),MA(r)}function KA(e,t){t=0===t?0:t||10;var r=MA(e).toHsl();return r.l-=t/100,r.l=ij(r.l),MA(r)}function YA(e,t){var r=MA(e).toHsl(),n=(r.h+t)%360;return r.h=n<0?360+n:n,MA(r)}function XA(e){var t=MA(e).toHsl();return t.h=(t.h+180)%360,MA(t)}function QA(e,t){if(isNaN(t)||t<=0)throw new Error("Argument to polyad must be a positive number");for(var r=MA(e).toHsl(),n=[MA(e)],o=360/t,i=1;i<t;i++)n.push(MA({h:(r.h+i*o)%360,s:r.s,l:r.l}));return n}function JA(e){var t=MA(e).toHsl(),r=t.h;return[MA(e),MA({h:(r+72)%360,s:t.s,l:t.l}),MA({h:(r+216)%360,s:t.s,l:t.l})]}function ZA(e,t,r){t=t||6,r=r||30;var n=MA(e).toHsl(),o=360/r,i=[MA(e)];for(n.h=(n.h-(o*t>>1)+720)%360;--t;)n.h=(n.h+o)%360,i.push(MA(n));return i}function ej(e,t){t=t||6;for(var r=MA(e).toHsv(),n=r.h,o=r.s,i=r.v,a=[],s=1/t;t--;)a.push(MA({h:n,s:o,v:i})),i=(i+s)%1;return a}MA.prototype={isDark:function(){return this.getBrightness()<128},isLight:function(){return!this.isDark()},isValid:function(){return this._ok},getOriginalInput:function(){return this._originalInput},getFormat:function(){return this._format},getAlpha:function(){return this._a},getBrightness:function(){var e=this.toRgb();return(299*e.r+587*e.g+114*e.b)/1e3},getLuminance:function(){var e,t,r,n=this.toRgb();return e=n.r/255,t=n.g/255,r=n.b/255,.2126*(e<=.03928?e/12.92:Math.pow((e+.055)/1.055,2.4))+.7152*(t<=.03928?t/12.92:Math.pow((t+.055)/1.055,2.4))+.0722*(r<=.03928?r/12.92:Math.pow((r+.055)/1.055,2.4))},setAlpha:function(e){return this._a=nj(e),this._roundA=Math.round(100*this._a)/100,this},toHsv:function(){var e=UA(this._r,this._g,this._b);return{h:360*e.h,s:e.s,v:e.v,a:this._a}},toHsvString:function(){var e=UA(this._r,this._g,this._b),t=Math.round(360*e.h),r=Math.round(100*e.s),n=Math.round(100*e.v);return 1==this._a?"hsv("+t+", "+r+"%, "+n+"%)":"hsva("+t+", "+r+"%, "+n+"%, "+this._roundA+")"},toHsl:function(){var e=VA(this._r,this._g,this._b);return{h:360*e.h,s:e.s,l:e.l,a:this._a}},toHslString:function(){var e=VA(this._r,this._g,this._b),t=Math.round(360*e.h),r=Math.round(100*e.s),n=Math.round(100*e.l);return 1==this._a?"hsl("+t+", "+r+"%, "+n+"%)":"hsla("+t+", "+r+"%, "+n+"%, "+this._roundA+")"},toHex:function(e){return BA(this._r,this._g,this._b,e)},toHexString:function(e){return"#"+this.toHex(e)},toHex8:function(e){return function(e,t,r,n,o){var i=[sj(Math.round(e).toString(16)),sj(Math.round(t).toString(16)),sj(Math.round(r).toString(16)),sj(uj(n))];return o&&i[0].charAt(0)==i[0].charAt(1)&&i[1].charAt(0)==i[1].charAt(1)&&i[2].charAt(0)==i[2].charAt(1)&&i[3].charAt(0)==i[3].charAt(1)?i[0].charAt(0)+i[1].charAt(0)+i[2].charAt(0)+i[3].charAt(0):i.join("")}(this._r,this._g,this._b,this._a,e)},toHex8String:function(e){return"#"+this.toHex8(e)},toRgb:function(){return{r:Math.round(this._r),g:Math.round(this._g),b:Math.round(this._b),a:this._a}},toRgbString:function(){return 1==this._a?"rgb("+Math.round(this._r)+", "+Math.round(this._g)+", "+Math.round(this._b)+")":"rgba("+Math.round(this._r)+", "+Math.round(this._g)+", "+Math.round(this._b)+", "+this._roundA+")"},toPercentageRgb:function(){return{r:Math.round(100*oj(this._r,255))+"%",g:Math.round(100*oj(this._g,255))+"%",b:Math.round(100*oj(this._b,255))+"%",a:this._a}},toPercentageRgbString:function(){return 1==this._a?"rgb("+Math.round(100*oj(this._r,255))+"%, "+Math.round(100*oj(this._g,255))+"%, "+Math.round(100*oj(this._b,255))+"%)":"rgba("+Math.round(100*oj(this._r,255))+"%, "+Math.round(100*oj(this._g,255))+"%, "+Math.round(100*oj(this._b,255))+"%, "+this._roundA+")"},toName:function(){return 0===this._a?"transparent":!(this._a<1)&&(rj[BA(this._r,this._g,this._b,!0)]||!1)},toFilter:function(e){var t="#"+zA(this._r,this._g,this._b,this._a),r=t,n=this._gradientType?"GradientType = 1, ":"";if(e){var o=MA(e);r="#"+zA(o._r,o._g,o._b,o._a)}return"progid:DXImageTransform.Microsoft.gradient("+n+"startColorstr="+t+",endColorstr="+r+")"},toString:function(e){var t=!!e;e=e||this._format;var r=!1,n=this._a<1&&this._a>=0;return t||!n||"hex"!==e&&"hex6"!==e&&"hex3"!==e&&"hex4"!==e&&"hex8"!==e&&"name"!==e?("rgb"===e&&(r=this.toRgbString()),"prgb"===e&&(r=this.toPercentageRgbString()),"hex"!==e&&"hex6"!==e||(r=this.toHexString()),"hex3"===e&&(r=this.toHexString(!0)),"hex4"===e&&(r=this.toHex8String(!0)),"hex8"===e&&(r=this.toHex8String()),"name"===e&&(r=this.toName()),"hsl"===e&&(r=this.toHslString()),"hsv"===e&&(r=this.toHsvString()),r||this.toHexString()):"name"===e&&0===this._a?this.toName():this.toRgbString()},clone:function(){return MA(this.toString())},_applyModification:function(e,t){var r=e.apply(null,[this].concat([].slice.call(t)));return this._r=r._r,this._g=r._g,this._b=r._b,this.setAlpha(r._a),this},lighten:function(){return this._applyModification(qA,arguments)},brighten:function(){return this._applyModification(GA,arguments)},darken:function(){return this._applyModification(KA,arguments)},desaturate:function(){return this._applyModification($A,arguments)},saturate:function(){return this._applyModification(WA,arguments)},greyscale:function(){return this._applyModification(HA,arguments)},spin:function(){return this._applyModification(YA,arguments)},_applyCombination:function(e,t){return e.apply(null,[this].concat([].slice.call(t)))},analogous:function(){return this._applyCombination(ZA,arguments)},complement:function(){return this._applyCombination(XA,arguments)},monochromatic:function(){return this._applyCombination(ej,arguments)},splitcomplement:function(){return this._applyCombination(JA,arguments)},triad:function(){return this._applyCombination(QA,[3])},tetrad:function(){return this._applyCombination(QA,[4])}},MA.fromRatio=function(e,t){if("object"==NA(e)){var r={};for(var n in e)e.hasOwnProperty(n)&&(r[n]="a"===n?e[n]:lj(e[n]));e=r}return MA(e,t)},MA.equals=function(e,t){return!(!e||!t)&&MA(e).toRgbString()==MA(t).toRgbString()},MA.random=function(){return MA.fromRatio({r:Math.random(),g:Math.random(),b:Math.random()})},MA.mix=function(e,t,r){r=0===r?0:r||50;var n=MA(e).toRgb(),o=MA(t).toRgb(),i=r/100;return MA({r:(o.r-n.r)*i+n.r,g:(o.g-n.g)*i+n.g,b:(o.b-n.b)*i+n.b,a:(o.a-n.a)*i+n.a})},MA.readability=function(e,t){var r=MA(e),n=MA(t);return(Math.max(r.getLuminance(),n.getLuminance())+.05)/(Math.min(r.getLuminance(),n.getLuminance())+.05)},MA.isReadable=function(e,t,r){var n,o,i,a,s,l=MA.readability(e,t);switch(o=!1,"AA"!==(a=((i=(i=r)||{level:"AA",size:"small"}).level||"AA").toUpperCase())&&"AAA"!==a&&(a="AA"),"small"!==(s=(i.size||"small").toLowerCase())&&"large"!==s&&(s="small"),(n={level:a,size:s}).level+n.size){case"AAsmall":case"AAAlarge":o=l>=4.5;break;case"AAlarge":o=l>=3;break;case"AAAsmall":o=l>=7}return o},MA.mostReadable=function(e,t,r){var n,o,i,a,s=null,l=0;o=(r=r||{}).includeFallbackColors,i=r.level,a=r.size;for(var u=0;u<t.length;u++)(n=MA.readability(e,t[u]))>l&&(l=n,s=MA(t[u]));return MA.isReadable(e,s,{level:i,size:a})||!o?s:(r.includeFallbackColors=!1,MA.mostReadable(e,["#fff","#000"],r))};var tj=MA.names={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"0ff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000",blanchedalmond:"ffebcd",blue:"00f",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",burntsienna:"ea7e5d",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"0ff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"f0f",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"789",lightslategrey:"789",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"0f0",limegreen:"32cd32",linen:"faf0e6",magenta:"f0f",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",rebeccapurple:"663399",red:"f00",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"fff",whitesmoke:"f5f5f5",yellow:"ff0",yellowgreen:"9acd32"},rj=MA.hexNames=function(e){var t={};for(var r in e)e.hasOwnProperty(r)&&(t[e[r]]=r);return t}(tj);function nj(e){return e=parseFloat(e),(isNaN(e)||e<0||e>1)&&(e=1),e}function oj(e,t){(function(e){return"string"==typeof e&&-1!=e.indexOf(".")&&1===parseFloat(e)})(e)&&(e="100%");var r=function(e){return"string"==typeof e&&-1!=e.indexOf("%")}(e);return e=Math.min(t,Math.max(0,parseFloat(e))),r&&(e=parseInt(e*t,10)/100),Math.abs(e-t)<1e-6?1:e%t/parseFloat(t)}function ij(e){return Math.min(1,Math.max(0,e))}function aj(e){return parseInt(e,16)}function sj(e){return 1==e.length?"0"+e:""+e}function lj(e){return e<=1&&(e=100*e+"%"),e}function uj(e){return Math.round(255*parseFloat(e)).toString(16)}function cj(e){return aj(e)/255}var dj,pj,fj,hj=(pj="[\\s|\\(]+("+(dj="(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)")+")[,|\\s]+("+dj+")[,|\\s]+("+dj+")\\s*\\)?",fj="[\\s|\\(]+("+dj+")[,|\\s]+("+dj+")[,|\\s]+("+dj+")[,|\\s]+("+dj+")\\s*\\)?",{CSS_UNIT:new RegExp(dj),rgb:new RegExp("rgb"+pj),rgba:new RegExp("rgba"+fj),hsl:new RegExp("hsl"+pj),hsla:new RegExp("hsla"+fj),hsv:new RegExp("hsv"+pj),hsva:new RegExp("hsva"+fj),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,hex4:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex8:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/});function gj(e){return!!hj.CSS_UNIT.exec(e)}function vj(e){return{outline:"2px dotted transparent",outlineOffset:"2px",boxShadow:`0 0 0 2px ${e.colors.background.canvas}, 0 0 0px 4px ${e.colors.primary.main}`,transitionTimingFunction:"cubic-bezier(0.19, 1, 0.22, 1)",transitionDuration:"0.2s",transitionProperty:"outline, outline-offset, box-shadow"}}const mj=e=>(0,$e.css)({"&:focus":vj(e)}),yj=(e,t=!1)=>{const r=t?e.colors.error.border:e.components.input.borderColor,n=t?e.colors.error.shade:e.components.input.borderHover,o=e.components.input.background,i=e.components.input.text,a=e.isDark?"#2e2f35":"#bab4ca";return(0,$e.cx)(bj(e),(0,$e.css)({background:o,lineHeight:e.typography.body.lineHeight,fontSize:e.typography.size.md,color:i,border:`1px solid ${r}`,"&:-webkit-autofill, &:-webkit-autofill:hover":{boxShadow:`inset 0 0 0 1px rgba(255, 255, 255, 0), inset 0 0 0 100px ${o}!important`,WebkitTextFillColor:`${i} !important`,borderColor:a},"&:-webkit-autofill:focus":{boxShadow:`0 0 0 2px ${e.colors.background.primary}, 0 0 0px 4px ${e.colors.primary.main}, inset 0 0 0 1px rgba(255, 255, 255, 0), inset 0 0 0 100px ${o}!important`,WebkitTextFillColor:`${i} !important`},"&:hover":{borderColor:n},"&:focus":{outline:"none"},"&:disabled":{backgroundColor:e.colors.action.disabledBackground,color:e.colors.action.disabledText,border:`1px solid ${e.colors.action.disabledBackground}`,"&:hover":{borderColor:r}},"&::placeholder":{color:e.colors.text.disabled,opacity:1}}))},bj=e=>(0,$e.css)({padding:e.spacing(0,1,0,1)});function Oj(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ej(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Oj(e,t,r[t])}))}return e}const Sj=(0,ve.forwardRef)(((e,t)=>{const{className:r,addonAfter:n,addonBefore:o,prefix:i,suffix:a,invalid:s,loading:l,width:u=0}=e,c=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["className","addonAfter","addonBefore","prefix","suffix","invalid","loading","width"]),[d,p]=(0,LA.A)(),[f,h]=(0,LA.A)(),g=Xx(),v=wj({theme:g,invalid:!!s,width:u});return(0,ge.jsxs)("div",{className:(0,$e.cx)(v.wrapper,r),"data-testid":"input-wrapper",children:[!!o&&(0,ge.jsx)("div",{className:v.addon,children:o}),(0,ge.jsxs)("div",{className:v.inputWrapper,children:[i&&(0,ge.jsx)("div",{className:v.prefix,ref:d,children:i}),(0,ge.jsx)("input",(m=Ej({ref:t,className:v.input},c),y={style:{paddingLeft:i?p.width+12:void 0,paddingRight:a||l?h.width+12:void 0}},y=null!=y?y:{},Object.getOwnPropertyDescriptors?Object.defineProperties(m,Object.getOwnPropertyDescriptors(y)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(y)).forEach((function(e){Object.defineProperty(m,e,Object.getOwnPropertyDescriptor(y,e))})),m)),(a||l)&&(0,ge.jsxs)("div",{className:v.suffix,ref:f,children:[l&&(0,ge.jsx)(CA,{className:v.loadingIndicator,inline:!0}),a]})]}),!!n&&(0,ge.jsx)("div",{className:v.addon,children:n})]});var m,y}));Sj.displayName="Input";const wj=kA((({theme:e,invalid:t=!1,width:r})=>{const n="28px",o=(0,$e.css)({position:"absolute",top:0,zIndex:1,display:"flex",alignItems:"center",justifyContent:"center",flexGrow:0,flexShrink:0,fontSize:e.typography.size.md,height:"100%",minWidth:n,color:e.colors.text.secondary});return{wrapper:(0,$e.cx)((0,$e.css)({label:"input-wrapper",display:"flex",width:r?e.spacing(r):"100%",height:e.spacing(e.components.height.md),borderRadius:e.shape.radius.default,"&:hover":{"> .prefix, .suffix, .input":{borderColor:t?e.colors.error.border:e.colors.primary.border},"input[type='number']":{appearance:"textfield"},"input[type='number']::-webkit-inner-spin-button, input[type='number']::-webkit-outer-spin-button":{WebkitAppearance:"inner-spin-button !important",opacity:1}}})),inputWrapper:(0,$e.css)({label:"input-inputWrapper",position:"relative",flexGrow:1,zIndex:1,"&:not(:first-child):last-child":{"> input":{borderLeft:"none",borderTopLeftRadius:0,borderBottomLeftRadius:0}},"&:first-child:not(:last-child)":{"> input":{borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0}},"&:not(:first-child):not(:last-child)":{"> input":{borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0,borderTopLeftRadius:0,borderBottomLeftRadius:0}},input:{"&:not(:first-child)":{paddingLeft:n},"&:not(:last-child)":{paddingRight:n},"&[readonly]":{cursor:"default"}}}),input:(0,$e.cx)(mj(e),yj(e,t),(0,$e.css)({label:"input-input",position:"relative",zIndex:0,flexGrow:1,borderRadius:e.shape.radius.default,height:"100%",width:"100%"})),inputDisabled:(0,$e.css)({backgroundColor:e.colors.action.disabledBackground,color:e.colors.action.disabledText,border:`1px solid ${e.colors.action.disabledBackground}`,"&:focus":{boxShadow:"none"}}),addon:(0,$e.css)({label:"input-addon",display:"flex",justifyContent:"center",alignItems:"center",flexGrow:0,flexShrink:0,position:"relative","&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0,"> :last-child":{borderTopRightRadius:0,borderBottomRightRadius:0}},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0,"> :first-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0}},"> *:focus":{zIndex:2}}),prefix:(0,$e.cx)(o,(0,$e.css)({label:"input-prefix",paddingLeft:e.spacing(1),paddingRight:e.spacing(.5),borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0})),suffix:(0,$e.cx)(o,(0,$e.css)({label:"input-suffix",paddingLeft:e.spacing(1),paddingRight:e.spacing(1),marginBottom:"-2px",borderLeft:"none",borderTopLeftRadius:0,borderBottomLeftRadius:0,right:0})),loadingIndicator:(0,$e.css)({"& + *":{marginLeft:e.spacing(.5)}})}})),Tj=(0,ve.forwardRef)(((e,t)=>{const{children:r}=e,n=Xx(),o=wj({theme:n,invalid:!1});return(0,ge.jsx)("div",{className:(0,$e.cx)(o.suffix,(0,$e.css)({position:"relative"})),ref:t,children:r})}));function xj(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}Tj.displayName="IndicatorsContainer";const _j=(0,ve.forwardRef)((function(e,t){var{focused:r,invalid:n,disabled:o,children:i,innerProps:a,prefix:s}=e;!function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}}(e,["focused","invalid","disabled","children","innerProps","prefix"]);const l=Qx(Cj,n,!!s);return(0,ge.jsxs)("div",(u=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){xj(e,t,r[t])}))}return e}({className:l.input},a),c=null!=(c={ref:t,children:[s&&(0,ge.jsx)("div",{className:(0,$e.cx)(l.prefix),children:s}),i]})?c:{},Object.getOwnPropertyDescriptors?Object.defineProperties(u,Object.getOwnPropertyDescriptors(c)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(c)).forEach((function(e){Object.defineProperty(u,e,Object.getOwnPropertyDescriptor(c,e))})),u));var u,c})),Cj=(e,t,r)=>{const n=wj({theme:e,invalid:t});return{input:(0,$e.cx)(bj(e),(0,$e.css)({width:"100%",maxWidth:"100%",display:"flex",flexDirection:"row",alignItems:"center",flexWrap:"wrap",justifyContent:"space-between",paddingRight:0,position:"relative",boxSizing:"border-box"}),r&&(0,$e.css)({paddingLeft:0})),prefix:(0,$e.cx)(n.prefix,(0,$e.css)({position:"relative"}))}};var Rj="undefined"!=typeof document?ve.useLayoutEffect:ve.useEffect;function Ij(e,t){if(e===t)return!0;if(typeof e!=typeof t)return!1;if("function"==typeof e&&e.toString()===t.toString())return!0;let r,n,o;if(e&&t&&"object"==typeof e){if(Array.isArray(e)){if(r=e.length,r!==t.length)return!1;for(n=r;0!=n--;)if(!Ij(e[n],t[n]))return!1;return!0}if(o=Object.keys(e),r=o.length,r!==Object.keys(t).length)return!1;for(n=r;0!=n--;)if(!{}.hasOwnProperty.call(t,o[n]))return!1;for(n=r;0!=n--;){const r=o[n];if(!("_owner"===r&&e.$$typeof||Ij(e[r],t[r])))return!1}return!0}return e!=e&&t!=t}function Aj(e){return"undefined"==typeof window?1:(e.ownerDocument.defaultView||window).devicePixelRatio||1}function jj(e,t){const r=Aj(e);return Math.round(t*r)/r}function Pj(e){const t=ve.useRef(e);return Rj((()=>{t.current=e})),t}const Lj=e=>({name:"arrow",options:e,fn(t){const{element:r,padding:n}="function"==typeof e?e(t):e;return r&&(o=r,{}.hasOwnProperty.call(o,"current"))?null!=r.current?GC({element:r.current,padding:n}).fn(t):{}:r?GC({element:r,padding:n}).fn(t):{};var o}}),kj=(e,t)=>({...WC(e),options:[e,t]}),Nj=(e,t)=>({...HC(e),options:[e,t]}),Dj=(e,t)=>({...qC(e),options:[e,t]}),Fj=(e,t)=>({...Lj(e),options:[e,t]});function Mj(e){let t=e.activeElement;for(;null!=(null==(r=t)||null==(r=r.shadowRoot)?void 0:r.activeElement);){var r;t=t.shadowRoot.activeElement}return t}function Vj(e,t){if(!e||!t)return!1;const r=null==t.getRootNode?void 0:t.getRootNode();if(e.contains(t))return!0;if(r&&gC(r)){let r=t;for(;r;){if(e===r)return!0;r=r.parentNode||r.host}}return!1}function Uj(){const e=navigator.userAgentData;return null!=e&&e.platform?e.platform:navigator.platform}function Bj(){const e=navigator.userAgentData;return e&&Array.isArray(e.brands)?e.brands.map((e=>{let{brand:t,version:r}=e;return t+"/"+r})).join(" "):navigator.userAgent}function zj(){const e=/android/i;return e.test(Uj())||e.test(Bj())}function $j(e,t){const r=["mouse","pen"];return t||r.push("",void 0),r.includes(e)}function Wj(e){return(null==e?void 0:e.ownerDocument)||document}function Hj(e,t){if(null==t)return!1;if("composedPath"in e)return e.composedPath().includes(t);const r=e;return null!=r.target&&t.contains(r.target)}function qj(e){return"composedPath"in e?e.composedPath()[0]:e.target}const Gj="input:not([type='hidden']):not([disabled]),[contenteditable]:not([contenteditable='false']),textarea:not([disabled])";const Kj={...me},Yj=Kj.useInsertionEffect||(e=>e());function Xj(e){const t=ve.useRef((()=>{}));return Yj((()=>{t.current=e})),ve.useCallback((function(){for(var e=arguments.length,r=new Array(e),n=0;n<e;n++)r[n]=arguments[n];return null==t.current?void 0:t.current(...r)}),[])}var Qj="undefined"!=typeof document?ve.useLayoutEffect:ve.useEffect;function Jj(){return Jj=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},Jj.apply(this,arguments)}let Zj=!1,eP=0;const tP=()=>"floating-ui-"+Math.random().toString(36).slice(2,6)+eP++,rP=Kj.useId||function(){const[e,t]=ve.useState((()=>Zj?tP():void 0));return Qj((()=>{null==e&&t(tP())}),[]),ve.useEffect((()=>{Zj=!0}),[]),e},nP=ve.forwardRef((function(e,t){const{context:{placement:r,elements:{floating:n},middlewareData:{arrow:o,shift:i}},width:a=14,height:s=7,tipRadius:l=0,strokeWidth:u=0,staticOffset:c,stroke:d,d:p,style:{transform:f,...h}={},...g}=e,v=rP(),[m,y]=ve.useState(!1);if(Qj((()=>{n&&"rtl"===SC(n).direction&&y(!0)}),[n]),!n)return null;const[b,O]=r.split("-"),E="top"===b||"bottom"===b;let S=c;(E&&null!=i&&i.x||!E&&null!=i&&i.y)&&(S=null);const w=2*u,T=w/2,x=a/2*(l/-8+1),_=s/2*l/4,C=!!p,R=S&&"end"===O?"bottom":"top";let I=S&&"end"===O?"right":"left";S&&m&&(I="end"===O?"left":"right");const A=null!=(null==o?void 0:o.x)?S||o.x:"",j=null!=(null==o?void 0:o.y)?S||o.y:"",P=p||"M0,0 H"+a+" L"+(a-x)+","+(s-_)+" Q"+a/2+","+s+" "+x+","+(s-_)+" Z",L={top:C?"rotate(180deg)":"",left:C?"rotate(90deg)":"rotate(-90deg)",bottom:C?"":"rotate(180deg)",right:C?"rotate(-90deg)":"rotate(90deg)"}[b];return ve.createElement("svg",Jj({},g,{"aria-hidden":!0,ref:t,width:C?a:a+w,height:a,viewBox:"0 0 "+a+" "+(s>a?s:a),style:{position:"absolute",pointerEvents:"none",[I]:A,[R]:j,[b]:E||C?"100%":"calc(100% - "+w/2+"px)",transform:[L,f].filter((e=>!!e)).join(" "),...h}}),w>0&&ve.createElement("path",{clipPath:"url(#"+v+")",fill:"none",stroke:d,strokeWidth:w+(p?0:1),d:P}),ve.createElement("path",{stroke:w&&!p?g.fill:"none",d:P}),ve.createElement("clipPath",{id:v},ve.createElement("rect",{x:-T,y:T*(C?-1:1),width:a+w,height:a})))}));const oP=ve.createContext(null),iP=ve.createContext(null),aP=()=>{var e;return(null==(e=ve.useContext(oP))?void 0:e.id)||null},sP=()=>ve.useContext(iP);function lP(e){return"data-floating-ui-"+e}function uP(e){const t=(0,ve.useRef)(e);return Qj((()=>{t.current=e})),t}const cP=lP("safe-polygon");function dP(e,t,r){return r&&!$j(r)?0:"number"==typeof e?e:null==e?void 0:e[t]}function pP(e,t){let r=e.filter((e=>{var r;return e.parentId===t&&(null==(r=e.context)?void 0:r.open)})),n=r;for(;n.length;)n=e.filter((e=>{var t;return null==(t=n)?void 0:t.some((t=>{var r;return e.parentId===t.id&&(null==(r=e.context)?void 0:r.open)}))})),r=r.concat(n);return r}const fP={pointerdown:"onPointerDown",mousedown:"onMouseDown",click:"onClick"},hP={pointerdown:"onPointerDownCapture",mousedown:"onMouseDownCapture",click:"onClickCapture"},gP=e=>{var t,r;return{escapeKey:"boolean"==typeof e?e:null!=(t=null==e?void 0:e.escapeKey)&&t,outsidePress:"boolean"==typeof e?e:null==(r=null==e?void 0:e.outsidePress)||r}};function vP(e){void 0===e&&(e={});const{nodeId:t}=e,r=function(e){const{open:t=!1,onOpenChange:r,elements:n}=e,o=rP(),i=ve.useRef({}),[a]=ve.useState((()=>function(){const e=new Map;return{emit(t,r){var n;null==(n=e.get(t))||n.forEach((e=>e(r)))},on(t,r){e.set(t,[...e.get(t)||[],r])},off(t,r){var n;e.set(t,(null==(n=e.get(t))?void 0:n.filter((e=>e!==r)))||[])}}}())),s=null!=aP(),[l,u]=ve.useState(n.reference),c=Xj(((e,t,n)=>{i.current.openEvent=e?t:void 0,a.emit("openchange",{open:e,event:t,reason:n,nested:s}),null==r||r(e,t,n)})),d=ve.useMemo((()=>({setPositionReference:u})),[]),p=ve.useMemo((()=>({reference:l||n.reference||null,floating:n.floating||null,domReference:n.reference})),[l,n.reference,n.floating]);return ve.useMemo((()=>({dataRef:i,open:t,onOpenChange:c,elements:p,events:a,floatingId:o,refs:d})),[t,c,p,a,o,d])}({...e,elements:{reference:null,floating:null,...e.elements}}),n=e.rootContext||r,o=n.elements,[i,a]=ve.useState(null),[s,l]=ve.useState(null),u=(null==o?void 0:o.reference)||i,c=ve.useRef(null),d=sP();Qj((()=>{u&&(c.current=u)}),[u]);const p=function(e){void 0===e&&(e={});const{placement:t="bottom",strategy:r="absolute",middleware:n=[],platform:o,elements:{reference:i,floating:a}={},transform:s=!0,whileElementsMounted:l,open:u}=e,[c,d]=ve.useState({x:0,y:0,strategy:r,placement:t,middlewareData:{},isPositioned:!1}),[p,f]=ve.useState(n);Ij(p,n)||f(n);const[h,g]=ve.useState(null),[v,m]=ve.useState(null),y=ve.useCallback((e=>{e!==S.current&&(S.current=e,g(e))}),[]),b=ve.useCallback((e=>{e!==w.current&&(w.current=e,m(e))}),[]),O=i||h,E=a||v,S=ve.useRef(null),w=ve.useRef(null),T=ve.useRef(c),x=null!=l,_=Pj(l),C=Pj(o),R=Pj(u),I=ve.useCallback((()=>{if(!S.current||!w.current)return;const e={placement:t,strategy:r,middleware:p};C.current&&(e.platform=C.current),KC(S.current,w.current,e).then((e=>{const t={...e,isPositioned:!1!==R.current};A.current&&!Ij(T.current,t)&&(T.current=t,V_.flushSync((()=>{d(t)})))}))}),[p,t,r,C,R]);Rj((()=>{!1===u&&T.current.isPositioned&&(T.current.isPositioned=!1,d((e=>({...e,isPositioned:!1}))))}),[u]);const A=ve.useRef(!1);Rj((()=>(A.current=!0,()=>{A.current=!1})),[]),Rj((()=>{if(O&&(S.current=O),E&&(w.current=E),O&&E){if(_.current)return _.current(O,E,I);I()}}),[O,E,I,_,x]);const j=ve.useMemo((()=>({reference:S,floating:w,setReference:y,setFloating:b})),[y,b]),P=ve.useMemo((()=>({reference:O,floating:E})),[O,E]),L=ve.useMemo((()=>{const e={position:r,left:0,top:0};if(!P.floating)return e;const t=jj(P.floating,c.x),n=jj(P.floating,c.y);return s?{...e,transform:"translate("+t+"px, "+n+"px)",...Aj(P.floating)>=1.5&&{willChange:"transform"}}:{position:r,left:t,top:n}}),[r,s,P.floating,c.x,c.y]);return ve.useMemo((()=>({...c,update:I,refs:j,elements:P,floatingStyles:L})),[c,I,j,P,L])}({...e,elements:{...o,...s&&{reference:s}}}),f=ve.useCallback((e=>{const t=fC(e)?{getBoundingClientRect:()=>e.getBoundingClientRect(),contextElement:e}:e;l(t),p.refs.setReference(t)}),[p.refs]),h=ve.useCallback((e=>{(fC(e)||null===e)&&(c.current=e,a(e)),(fC(p.refs.reference.current)||null===p.refs.reference.current||null!==e&&!fC(e))&&p.refs.setReference(e)}),[p.refs]),g=ve.useMemo((()=>({...p.refs,setReference:h,setPositionReference:f,domReference:c})),[p.refs,h,f]),v=ve.useMemo((()=>({...p.elements,domReference:u})),[p.elements,u]),m=ve.useMemo((()=>({...p,...n,refs:g,elements:v,nodeId:t})),[p,g,v,t,n]);return Qj((()=>{n.dataRef.current.floatingContext=m;const e=null==d?void 0:d.nodesRef.current.find((e=>e.id===t));e&&(e.context=m)})),ve.useMemo((()=>({...p,context:m,refs:g,elements:v})),[p,g,v,m])}function mP(e,t){void 0===t&&(t={});const{open:r,onOpenChange:n,events:o,dataRef:i,elements:a}=e,{enabled:s=!0,visibleOnly:l=!0}=t,u=ve.useRef(!1),c=ve.useRef(),d=ve.useRef(!0);ve.useEffect((()=>{if(!s)return;const e=cC(a.domReference);function t(){!r&&hC(a.domReference)&&a.domReference===Mj(Wj(a.domReference))&&(u.current=!0)}function n(){d.current=!0}return e.addEventListener("blur",t),e.addEventListener("keydown",n,!0),()=>{e.removeEventListener("blur",t),e.removeEventListener("keydown",n,!0)}}),[a.domReference,r,s]),ve.useEffect((()=>{if(s)return o.on("openchange",e),()=>{o.off("openchange",e)};function e(e){let{reason:t}=e;"reference-press"!==t&&"escape-key"!==t||(u.current=!0)}}),[o,s]),ve.useEffect((()=>()=>{clearTimeout(c.current)}),[]);const p=ve.useMemo((()=>({onPointerDown(e){(function(e){return!Bj().includes("jsdom/")&&(!zj()&&0===e.width&&0===e.height||zj()&&1===e.width&&1===e.height&&0===e.pressure&&0===e.detail&&"mouse"===e.pointerType||e.width<1&&e.height<1&&0===e.pressure&&0===e.detail&&"touch"===e.pointerType)})(e.nativeEvent)||(d.current=!1)},onMouseLeave(){u.current=!1},onFocus(e){if(u.current)return;const t=qj(e.nativeEvent);if(l&&fC(t))try{if(/apple/i.test(navigator.vendor)&&Uj().toLowerCase().startsWith("mac")&&!navigator.maxTouchPoints)throw Error();if(!t.matches(":focus-visible"))return}catch(e){if(!d.current&&(!hC(r=t)||!r.matches(Gj)))return}var r;n(!0,e.nativeEvent,"focus")},onBlur(e){u.current=!1;const t=e.relatedTarget,r=e.nativeEvent,o=fC(t)&&t.hasAttribute(lP("focus-guard"))&&"outside"===t.getAttribute("data-type");c.current=window.setTimeout((()=>{var e;const s=Mj(a.domReference?a.domReference.ownerDocument:document);(t||s!==a.domReference)&&(Vj(null==(e=i.current.floatingContext)?void 0:e.refs.floating.current,s)||Vj(a.domReference,s)||o||n(!1,r,"focus"))}))}})),[i,a.domReference,n,l]);return ve.useMemo((()=>s?{reference:p}:{}),[s,p])}const yP="active",bP="selected";function OP(e,t,r){const n=new Map,o="item"===r;let i=e;if(o&&e){const{[yP]:t,[bP]:r,...n}=e;i=n}return{..."floating"===r&&{tabIndex:-1,"data-floating-ui-focusable":""},...i,...t.map((t=>{const n=t?t[r]:null;return"function"==typeof n?e?n(e):null:n})).concat(e).reduce(((e,t)=>t?(Object.entries(t).forEach((t=>{let[r,i]=t;var a;o&&[yP,bP].includes(r)||(0===r.indexOf("on")?(n.has(r)||n.set(r,[]),"function"==typeof i&&(null==(a=n.get(r))||a.push(i),e[r]=function(){for(var e,t=arguments.length,o=new Array(t),i=0;i<t;i++)o[i]=arguments[i];return null==(e=n.get(r))?void 0:e.map((e=>e(...o))).find((e=>void 0!==e))})):e[r]=i)})),e):e),{})}}function EP(e){switch(e){case"auto":return"bottom";case"auto-start":return"bottom-start";case"auto-end":return"bottom-end";default:return null!=e?e:"bottom"}}function SP(e,t,r,n,o){return{arrow:(0,$e.css)({fill:t}),container:(0,$e.css)({backgroundColor:t,borderRadius:e.shape.radius.default,border:`1px solid ${r}`,boxShadow:e.shadows.z2,color:n,fontSize:e.typography.bodySmall.fontSize,padding:e.spacing(o.topBottom,o.rightLeft),[e.transitions.handleMotion("no-preference","reduce")]:{transition:"opacity 0.3s"},zIndex:e.zIndex.tooltip,maxWidth:"400px",overflowWrap:"break-word","&[data-popper-interactive='false']":{pointerEvents:"none"}}),headerClose:(0,$e.css)({color:e.colors.text.secondary,position:"absolute",right:e.spacing(1),top:e.spacing(1.5),backgroundColor:"transparent",border:0}),header:(0,$e.css)({paddingTop:e.spacing(1),paddingBottom:e.spacing(2)}),body:(0,$e.css)({paddingTop:e.spacing(1),paddingBottom:e.spacing(1)}),footer:(0,$e.css)({paddingTop:e.spacing(2),paddingBottom:e.spacing(1)})}}function wP(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function TP(e){const{children:t,className:r,root:n,forwardedRef:o}=e,i=Xx(),a=(0,ve.useRef)(null),s=null!=n?n:null!==(l=window.document.getElementById("grafana-portal-container"))&&void 0!==l?l:document.body;var l;return a.current||(a.current=document.createElement("div"),r&&(a.current.className=r),a.current.style.position="relative",a.current.style.zIndex=`${i.zIndex.portal}`),(0,ve.useLayoutEffect)((()=>(a.current&&s.appendChild(a.current),()=>{a.current&&s.removeChild(a.current)})),[s]),U_().createPortal((0,ge.jsx)("div",{ref:o,children:t}),a.current)}const xP=ve.forwardRef(((e,t)=>{return(0,ge.jsx)(TP,(r=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){wP(e,t,r[t])}))}return e}({},e),n=null!=(n={forwardedRef:t})?n:{},Object.getOwnPropertyDescriptors?Object.defineProperties(r,Object.getOwnPropertyDescriptors(n)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(n)).forEach((function(e){Object.defineProperty(r,e,Object.getOwnPropertyDescriptor(n,e))})),r));var r,n}));function _P(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function CP(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){_P(e,t,r[t])}))}return e}xP.displayName="RefForwardingPortal";const RP=(0,ve.forwardRef)((({children:e,theme:t,interactive:r,show:n,placement:o,content:i},a)=>{const s=(0,ve.useRef)(null),[l,u]=(0,ve.useState)(n),c=null!=n?n:l,d=[kj(8),Dj({fallbackAxisSideDirection:"end",crossAxis:!1,boundary:document.body}),Nj(),Fj({element:s})],{context:p,refs:f,floatingStyles:h}=vP({open:c,placement:EP(o),onOpenChange:u,middleware:d,whileElementsMounted:$C}),g=(0,ve.useId)(),v=function(e,t){void 0===t&&(t={});const{open:r,onOpenChange:n,dataRef:o,events:i,elements:a}=e,{enabled:s=!0,delay:l=0,handleClose:u=null,mouseOnly:c=!1,restMs:d=0,move:p=!0}=t,f=sP(),h=aP(),g=uP(u),v=uP(l),m=uP(r),y=ve.useRef(),b=ve.useRef(-1),O=ve.useRef(),E=ve.useRef(-1),S=ve.useRef(!0),w=ve.useRef(!1),T=ve.useRef((()=>{})),x=ve.useRef(!1),_=ve.useCallback((()=>{var e;const t=null==(e=o.current.openEvent)?void 0:e.type;return(null==t?void 0:t.includes("mouse"))&&"mousedown"!==t}),[o]);ve.useEffect((()=>{if(s)return i.on("openchange",e),()=>{i.off("openchange",e)};function e(e){let{open:t}=e;t||(clearTimeout(b.current),clearTimeout(E.current),S.current=!0,x.current=!1)}}),[s,i]),ve.useEffect((()=>{if(!s)return;if(!g.current)return;if(!r)return;function e(e){_()&&n(!1,e,"hover")}const t=Wj(a.floating).documentElement;return t.addEventListener("mouseleave",e),()=>{t.removeEventListener("mouseleave",e)}}),[a.floating,r,n,s,g,_]);const C=ve.useCallback((function(e,t,r){void 0===t&&(t=!0),void 0===r&&(r="hover");const o=dP(v.current,"close",y.current);o&&!O.current?(clearTimeout(b.current),b.current=window.setTimeout((()=>n(!1,e,r)),o)):t&&(clearTimeout(b.current),n(!1,e,r))}),[v,n]),R=Xj((()=>{T.current(),O.current=void 0})),I=Xj((()=>{if(w.current){const e=Wj(a.floating).body;e.style.pointerEvents="",e.removeAttribute(cP),w.current=!1}}));ve.useEffect((()=>{if(s&&fC(a.domReference)){var e;const t=a.domReference;return r&&t.addEventListener("mouseleave",u),null==(e=a.floating)||e.addEventListener("mouseleave",u),p&&t.addEventListener("mousemove",i,{once:!0}),t.addEventListener("mouseenter",i),t.addEventListener("mouseleave",l),()=>{var e;r&&t.removeEventListener("mouseleave",u),null==(e=a.floating)||e.removeEventListener("mouseleave",u),p&&t.removeEventListener("mousemove",i),t.removeEventListener("mouseenter",i),t.removeEventListener("mouseleave",l)}}function t(){return!!o.current.openEvent&&["click","mousedown"].includes(o.current.openEvent.type)}function i(e){if(clearTimeout(b.current),S.current=!1,c&&!$j(y.current)||d>0&&!dP(v.current,"open"))return;const t=dP(v.current,"open",y.current);t?b.current=window.setTimeout((()=>{m.current||n(!0,e,"hover")}),t):n(!0,e,"hover")}function l(e){if(t())return;T.current();const n=Wj(a.floating);if(clearTimeout(E.current),x.current=!1,g.current&&o.current.floatingContext){r||clearTimeout(b.current),O.current=g.current({...o.current.floatingContext,tree:f,x:e.clientX,y:e.clientY,onClose(){I(),R(),C(e,!0,"safe-polygon")}});const t=O.current;return n.addEventListener("mousemove",t),void(T.current=()=>{n.removeEventListener("mousemove",t)})}("touch"!==y.current||!Vj(a.floating,e.relatedTarget))&&C(e)}function u(e){t()||o.current.floatingContext&&(null==g.current||g.current({...o.current.floatingContext,tree:f,x:e.clientX,y:e.clientY,onClose(){I(),R(),C(e)}})(e))}}),[a,s,e,c,d,p,C,R,I,n,r,m,f,v,g,o]),Qj((()=>{var e;if(s&&r&&null!=(e=g.current)&&e.__options.blockPointerEvents&&_()){w.current=!0;const e=a.floating;if(fC(a.domReference)&&e){var t;const r=Wj(a.floating).body;r.setAttribute(cP,"");const n=a.domReference,o=null==f||null==(t=f.nodesRef.current.find((e=>e.id===h)))||null==(t=t.context)?void 0:t.elements.floating;return o&&(o.style.pointerEvents=""),r.style.pointerEvents="none",n.style.pointerEvents="auto",e.style.pointerEvents="auto",()=>{r.style.pointerEvents="",n.style.pointerEvents="",e.style.pointerEvents=""}}}}),[s,r,h,a,f,g,_]),Qj((()=>{r||(y.current=void 0,x.current=!1,R(),I())}),[r,R,I]),ve.useEffect((()=>()=>{R(),clearTimeout(b.current),clearTimeout(E.current),I()}),[s,a.domReference,R,I]);const A=ve.useMemo((()=>{function e(e){y.current=e.pointerType}return{onPointerDown:e,onPointerEnter:e,onMouseMove(e){const{nativeEvent:t}=e;function o(){S.current||m.current||n(!0,t,"hover")}c&&!$j(y.current)||r||0===d||x.current&&e.movementX**2+e.movementY**2<2||(clearTimeout(E.current),"touch"===y.current?o():(x.current=!0,E.current=window.setTimeout(o,d)))}}}),[c,n,r,m,d]),j=ve.useMemo((()=>({onMouseEnter(){clearTimeout(b.current)},onMouseLeave(e){C(e.nativeEvent,!1)}})),[C]);return ve.useMemo((()=>s?{reference:A,floating:j}:{}),[s,A,j])}(p,{delay:{close:r?100:0},move:!1}),m=mP(p),y=function(e,t){void 0===t&&(t={});const{open:r,onOpenChange:n,elements:o,dataRef:i}=e,{enabled:a=!0,escapeKey:s=!0,outsidePress:l=!0,outsidePressEvent:u="pointerdown",referencePress:c=!1,referencePressEvent:d="pointerdown",ancestorScroll:p=!1,bubbles:f,capture:h}=t,g=sP(),v=Xj("function"==typeof l?l:()=>!1),m="function"==typeof l?v:l,y=ve.useRef(!1),b=ve.useRef(!1),{escapeKey:O,outsidePress:E}=gP(f),{escapeKey:S,outsidePress:w}=gP(h),T=ve.useRef(!1),x=Xj((e=>{var t;if(!r||!a||!s||"Escape"!==e.key)return;if(T.current)return;const o=null==(t=i.current.floatingContext)?void 0:t.nodeId,l=g?pP(g.nodesRef.current,o):[];if(!O&&(e.stopPropagation(),l.length>0)){let e=!0;if(l.forEach((t=>{var r;null==(r=t.context)||!r.open||t.context.dataRef.current.__escapeKeyBubbles||(e=!1)})),!e)return}n(!1,function(e){return"nativeEvent"in e}(e)?e.nativeEvent:e,"escape-key")})),_=Xj((e=>{var t;const r=()=>{var t;x(e),null==(t=qj(e))||t.removeEventListener("keydown",r)};null==(t=qj(e))||t.addEventListener("keydown",r)})),C=Xj((e=>{var t;const r=y.current;y.current=!1;const a=b.current;if(b.current=!1,"click"===u&&a)return;if(r)return;if("function"==typeof m&&!m(e))return;const s=qj(e),l="["+lP("inert")+"]",c=Wj(o.floating).querySelectorAll(l);let d=fC(s)?s:null;for(;d&&!EC(d);){const e=TC(d);if(EC(e)||!fC(e))break;d=e}if(c.length&&fC(s)&&!s.matches("html,body")&&!Vj(s,o.floating)&&Array.from(c).every((e=>!Vj(d,e))))return;if(hC(s)&&A){const t=s.clientWidth>0&&s.scrollWidth>s.clientWidth,r=s.clientHeight>0&&s.scrollHeight>s.clientHeight;let n=r&&e.offsetX>s.clientWidth;if(r&&"rtl"===SC(s).direction&&(n=e.offsetX<=s.offsetWidth-s.clientWidth),n||t&&e.offsetY>s.clientHeight)return}const p=null==(t=i.current.floatingContext)?void 0:t.nodeId,f=g&&pP(g.nodesRef.current,p).some((t=>{var r;return Hj(e,null==(r=t.context)?void 0:r.elements.floating)}));if(Hj(e,o.floating)||Hj(e,o.domReference)||f)return;const h=g?pP(g.nodesRef.current,p):[];if(h.length>0){let e=!0;if(h.forEach((t=>{var r;null==(r=t.context)||!r.open||t.context.dataRef.current.__outsidePressBubbles||(e=!1)})),!e)return}n(!1,e,"outside-press")})),R=Xj((e=>{var t;const r=()=>{var t;C(e),null==(t=qj(e))||t.removeEventListener(u,r)};null==(t=qj(e))||t.addEventListener(u,r)}));ve.useEffect((()=>{if(!r||!a)return;i.current.__escapeKeyBubbles=O,i.current.__outsidePressBubbles=E;let e=-1;function t(e){n(!1,e,"ancestor-scroll")}function l(){window.clearTimeout(e),T.current=!0}function c(){e=window.setTimeout((()=>{T.current=!1}),OC()?5:0)}const d=Wj(o.floating);s&&(d.addEventListener("keydown",S?_:x,S),d.addEventListener("compositionstart",l),d.addEventListener("compositionend",c)),m&&d.addEventListener(u,w?R:C,w);let f=[];return p&&(fC(o.domReference)&&(f=_C(o.domReference)),fC(o.floating)&&(f=f.concat(_C(o.floating))),!fC(o.reference)&&o.reference&&o.reference.contextElement&&(f=f.concat(_C(o.reference.contextElement)))),f=f.filter((e=>{var t;return e!==(null==(t=d.defaultView)?void 0:t.visualViewport)})),f.forEach((e=>{e.addEventListener("scroll",t,{passive:!0})})),()=>{s&&(d.removeEventListener("keydown",S?_:x,S),d.removeEventListener("compositionstart",l),d.removeEventListener("compositionend",c)),m&&d.removeEventListener(u,w?R:C,w),f.forEach((e=>{e.removeEventListener("scroll",t)})),window.clearTimeout(e)}}),[i,o,s,m,u,r,n,p,a,O,E,x,S,_,C,w,R]),ve.useEffect((()=>{y.current=!1}),[m,u]);const I=ve.useMemo((()=>({onKeyDown:x,[fP[d]]:e=>{c&&n(!1,e.nativeEvent,"reference-press")}})),[x,n,c,d]),A=ve.useMemo((()=>({onKeyDown:x,onMouseDown(){b.current=!0},onMouseUp(){b.current=!0},[hP[u]]:()=>{y.current=!0}})),[x,u]);return ve.useMemo((()=>a?{reference:I,floating:A}:{}),[a,I,A])}(p),{getReferenceProps:b,getFloatingProps:O}=function(e){void 0===e&&(e=[]);const t=e.map((e=>null==e?void 0:e.reference)),r=e.map((e=>null==e?void 0:e.floating)),n=e.map((e=>null==e?void 0:e.item)),o=ve.useCallback((t=>OP(t,e,"reference")),t),i=ve.useCallback((t=>OP(t,e,"floating")),r),a=ve.useCallback((t=>OP(t,e,"item")),n);return ve.useMemo((()=>({getReferenceProps:o,getFloatingProps:i,getItemProps:a})),[o,i,a])}([y,v,m]),E="function"==typeof i,S=Qx(IP)[null!=t?t:"info"],w=(0,ve.useCallback)((e=>{f.setReference(e),"function"==typeof a?a(e):a&&(a.current=e)}),[a,f]),T="aria-label"in e.props&&e.props["aria-label"]===i;return(0,ge.jsxs)(ge.Fragment,{children:[(0,ve.cloneElement)(e,CP({ref:w,tabIndex:0,"aria-describedby":!T&&c?g:void 0},b())),c&&(0,ge.jsx)(TP,{children:(0,ge.jsxs)("div",(x=CP({ref:f.setFloating,style:h},O()),_={children:[(0,ge.jsx)(nP,{className:S.arrow,ref:s,context:p}),(0,ge.jsxs)("div",{"data-testid":ze.components.Tooltip.container,id:g,role:"tooltip",className:S.container,children:["string"==typeof i&&i,(0,ve.isValidElement)(i)&&(0,ve.cloneElement)(i),E&&i({})]})]},_=null!=_?_:{},Object.getOwnPropertyDescriptors?Object.defineProperties(x,Object.getOwnPropertyDescriptors(_)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(_)).forEach((function(e){Object.defineProperty(x,e,Object.getOwnPropertyDescriptor(_,e))})),x))})]});var x,_}));RP.displayName="Tooltip";const IP=e=>{const t=SP(e,e.components.tooltip.background,e.components.tooltip.background,e.components.tooltip.text,{topBottom:.5,rightLeft:1});return{info:t,"info-alt":t,error:SP(e,e.colors.error.main,e.colors.error.main,e.colors.error.contrastText,{topBottom:.5,rightLeft:1})}};function AP(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function jP(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){AP(e,t,r[t])}))}return e}function PP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function LP(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}const kP=ve.forwardRef(((e,t)=>{var{variant:r="primary",size:n="md",fill:o="solid",icon:i,fullWidth:a,children:s,className:l,type:u="button",tooltip:c,disabled:d,tooltipPlacement:p,onClick:f}=e,h=LP(e,["variant","size","fill","icon","fullWidth","children","className","type","tooltip","disabled","tooltipPlacement","onClick"]);const g=Xx(),v=DP({theme:g,size:n,variant:r,fill:o,fullWidth:a,iconOnly:!s}),m=(0,$e.cx)(v.button,{[v.disabled]:d},l),y=Boolean(c),b=(0,ge.jsxs)("button",PP(jP({className:m,type:u,onClick:d?void 0:f},h),{"aria-disabled":y&&d,disabled:!y&&d,ref:c?void 0:t,children:[(0,ge.jsx)(NP,{icon:i,size:n,className:v.icon}),s&&(0,ge.jsx)("span",{className:v.content,children:s})]}));return c?(0,ge.jsx)(RP,{ref:t,content:c,placement:p,children:b}):b}));kP.displayName="Button";ve.forwardRef(((e,t)=>{var{variant:r="primary",size:n="md",fill:o="solid",icon:i,fullWidth:a,children:s,className:l,onBlur:u,onFocus:c,disabled:d,tooltip:p,tooltipPlacement:f}=e,h=LP(e,["variant","size","fill","icon","fullWidth","children","className","onBlur","onFocus","disabled","tooltip","tooltipPlacement"]);const g=Xx(),v=DP({theme:g,fullWidth:a,size:n,variant:r,fill:o,iconOnly:!s}),m=(0,$e.cx)(v.button,{[(0,$e.css)(v.disabled,{pointerEvents:"none"})]:d},l),y=(0,ge.jsxs)("a",PP(jP({className:m},h),{tabIndex:d?-1:0,"aria-disabled":d,ref:p?void 0:t,children:[(0,ge.jsx)(NP,{icon:i,size:n,className:v.icon}),s&&(0,ge.jsx)("span",{className:v.content,children:s})]}));return p?(0,ge.jsx)(RP,{ref:t,content:p,placement:f,children:y}):y})).displayName="LinkButton";const NP=({icon:e,size:t,className:r,iconType:n})=>e?ve.isValidElement(e)?ve.cloneElement(e,{className:r,size:t}):(0,ge.jsx)(w_,{name:e,size:t,className:r,type:n}):null,DP=e=>{const{theme:t,variant:r,fill:n="solid",size:o,iconOnly:i,fullWidth:a}=e,{height:s,padding:l,fontSize:u}=function(e,t){switch(e){case"sm":return{padding:1,fontSize:t.typography.size.sm,height:t.components.height.sm};case"lg":return{padding:3,fontSize:t.typography.size.lg,height:t.components.height.lg};default:return{padding:2,fontSize:t.typography.size.md,height:t.components.height.md}}}(o,t),c=function(e,t,r){switch(t){case"secondary":return FP(e,e.colors.secondary,r);case"destructive":return FP(e,e.colors.error,r);case"success":return FP(e,e.colors.success,r);default:return FP(e,e.colors.primary,r)}}(t,r,n),d=function(e,t,r){const n={cursor:"not-allowed",boxShadow:"none",color:e.colors.text.disabled,transition:"none"};return PP(jP({},n),"text"===r?{background:"transparent",border:"1px solid transparent"}:"outline"===r?{background:"transparent",border:`1px solid ${e.colors.border.weak}`}:{background:e.colors.action.disabledBackground,border:"1px solid transparent"})}(t,0,n),p=vj(t),f=t.spacing.gridSize*l-1;return{button:(0,$e.css)(PP(jP({label:"button",display:"inline-flex",alignItems:"center",fontSize:u,fontWeight:t.typography.fontWeightMedium,fontFamily:t.typography.fontFamily,padding:`0 ${f}px`,height:t.spacing(s),lineHeight:t.spacing.gridSize*s-2+"px",verticalAlign:"middle",cursor:"pointer",borderRadius:t.shape.radius.default,"&:focus":p,"&:focus-visible":p,"&:focus:not(:focus-visible)":{outline:"none",boxShadow:"none"}},a&&{flexGrow:1,justifyContent:"center"},c),{":disabled":d,"&[disabled]":d})),disabled:(0,$e.css)(d,{"&:hover":(0,$e.css)(d)}),img:(0,$e.css)({width:"16px",height:"16px",margin:t.spacing(0,1,0,.5)}),icon:i?(0,$e.css)({marginRight:t.spacing(-l/2),marginLeft:t.spacing(-l/2)}):(0,$e.css)({marginRight:t.spacing(l/2)}),content:(0,$e.css)({display:"flex",flexDirection:"row",alignItems:"center",whiteSpace:"nowrap",overflow:"hidden",height:"100%"})}};function FP(e,t,r){let n=t.border,o="transparent",i="transparent";return"secondary"===t.name&&(o=t.border,i=e.colors.emphasize(t.border,.25),n=e.colors.border.strong),"outline"===r?{background:"transparent",color:t.text,border:`1px solid ${n}`,transition:e.transitions.create(["background-color","border-color","color"],{duration:e.transitions.duration.short}),"&:hover":{background:t.transparent,borderColor:e.colors.emphasize(n,.25),color:t.text}}:"text"===r?{background:"transparent",color:t.text,border:"1px solid transparent",transition:e.transitions.create(["background-color","color"],{duration:e.transitions.duration.short}),"&:focus":{outline:"none",textDecoration:"none"},"&:hover":{background:t.transparent,textDecoration:"none"}}:{background:t.main,color:t.contrastText,border:`1px solid ${o}`,transition:e.transitions.create(["background-color","box-shadow","border-color","color"],{duration:e.transitions.duration.short}),"&:hover":{background:t.shade,color:t.contrastText,boxShadow:e.shadows.z1,borderColor:i}}}const MP=e=>(0,$e.css)({background:"transparent",color:e.colors.text.primary,border:"none",padding:0});function VP(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function UP(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){VP(e,t,r[t])}))}return e}function BP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function zP(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}const $P=ve.forwardRef(((e,t)=>{const{size:r="md",variant:n="secondary"}=e;let o;"xxl"===r||"xxxl"===r?((0,w.deprecationWarning)("IconButton",'size="xxl" and size="xxxl"','size="xl"'),o="xl"):o=r;const i=Qx(WP,o,n);let a,s;if("tooltip"in e){const{tooltip:t}=e;a="string"==typeof t?t:void 0}else if("ariaLabel"in e||"aria-label"in e){const{ariaLabel:r,"aria-label":n}=e;a=n||r,s=t}if("tooltip"in e){const{name:r,iconType:n,className:l,tooltip:u,tooltipPlacement:c}=e,d=zP(e,["name","iconType","className","tooltip","tooltipPlacement"]);return(0,ge.jsx)(RP,{ref:t,content:u,placement:c,children:(0,ge.jsx)("button",BP(UP({},d),{ref:s,"aria-label":a,className:(0,$e.cx)(i.button,l),type:"button",children:(0,ge.jsx)(NP,{icon:r,size:o,className:i.icon,iconType:n})}))})}{const{name:t,iconType:r,className:n}=e,l=zP(e,["name","iconType","className"]);return(0,ge.jsx)("button",BP(UP({},l),{ref:s,"aria-label":a,className:(0,$e.cx)(i.button,n),type:"button",children:(0,ge.jsx)(NP,{icon:t,size:o,className:i.icon,iconType:r})}))}}));$P.displayName="IconButton";const WP=(e,t,r)=>{const n=y_(t)+e.spacing.gridSize;let o=e.colors.text.primary;return"primary"===r?o=e.colors.primary.text:"destructive"===r&&(o=e.colors.error.text),{button:(0,$e.css)({zIndex:0,position:"relative",margin:`0 ${e.spacing.x0_5} 0 0`,boxShadow:"none",border:"none",display:"inline-flex",background:"transparent",justifyContent:"center",alignItems:"center",padding:0,color:o,"&[disabled], &:disabled":{cursor:"not-allowed",color:e.colors.action.disabledText,opacity:.65},"&:before":{zIndex:-1,position:"absolute",opacity:0,width:`${n}px`,height:`${n}px`,borderRadius:e.shape.radius.default,content:'""',[e.transitions.handleMotion("no-preference","reduce")]:{transitionDuration:"0.2s",transitionTimingFunction:"cubic-bezier(0.4, 0, 0.2, 1)",transitionProperty:"opacity"}},"&:focus, &:focus-visible":vj(e),"&:focus:not(:focus-visible)":{outline:"none",boxShadow:"none"},"&:hover":{"&:before":{backgroundColor:"secondary"===r?e.colors.action.hover:w.colorManipulator.alpha(o,.12),opacity:1}}}),icon:(0,$e.css)({verticalAlign:"baseline"})}},HP=kA((e=>({menu:(0,$e.css)({label:"grafana-select-menu",background:e.components.dropdown.background,boxShadow:e.shadows.z3,position:"relative",minWidth:"100%",zIndex:1}),option:(0,$e.css)({label:"grafana-select-option",padding:"8px",position:"relative",display:"flex",alignItems:"center",flexDirection:"row",flexShrink:0,whiteSpace:"nowrap",cursor:"pointer",borderLeft:"2px solid transparent","&:hover":{background:e.colors.action.hover,"@media (forced-colors: active), (prefers-contrast: more)":{border:`1px solid ${e.colors.primary.border}`}}}),optionIcon:(0,$e.css)({marginRight:e.spacing(1)}),optionImage:(0,$e.css)({label:"grafana-select-option-image",width:"16px",marginRight:"10px"}),optionDescription:(0,$e.css)({label:"grafana-select-option-description",fontWeight:"normal",fontSize:e.typography.size.sm,color:e.colors.text.secondary,whiteSpace:"normal",lineHeight:e.typography.body.lineHeight}),optionBody:(0,$e.css)({label:"grafana-select-option-body",display:"flex",fontWeight:e.typography.fontWeightMedium,flexDirection:"column",flexGrow:1}),optionFocused:(0,$e.css)({label:"grafana-select-option-focused",background:e.colors.action.focus,"@media (forced-colors: active), (prefers-contrast: more)":{border:`1px solid ${e.colors.primary.border}`}}),optionSelected:(0,$e.css)({background:e.colors.action.selected,"&::before":{backgroundImage:e.colors.gradients.brandVertical,borderRadius:e.shape.radius.default,content:'" "',display:"block",height:"100%",position:"absolute",transform:"translateX(-50%)",width:e.spacing(.5),left:0}}),optionDisabled:(0,$e.css)({label:"grafana-select-option-disabled",backgroundColor:e.colors.action.disabledBackground,color:e.colors.action.disabledText,cursor:"not-allowed"}),singleValue:(0,$e.css)({label:"grafana-select-single-value",color:e.components.input.text,gridArea:"1 / 1 / 2 / 3",whiteSpace:"nowrap",overflow:"hidden",textOverflow:"ellipsis",boxSizing:"border-box",maxWidth:"100%"}),valueContainer:(0,$e.css)({label:"grafana-select-value-container",alignItems:"center",display:"grid",position:"relative",boxSizing:"border-box",flex:"1 1 0%",outline:"none",overflow:"hidden"}),valueContainerMulti:(0,$e.css)({label:"grafana-select-value-container-multi",flexWrap:"wrap",display:"flex"}),valueContainerMultiNoWrap:(0,$e.css)({display:"grid",gridAutoFlow:"column"}),loadingMessage:(0,$e.css)({label:"grafana-select-loading-message",padding:e.spacing(1),textAlign:"center",width:"100%"}),multiValueContainer:(0,$e.css)({label:"grafana-select-multi-value-container",display:"flex",alignItems:"center",lineHeight:1,background:e.colors.background.secondary,borderRadius:e.shape.radius.default,margin:e.spacing(.25,1,.25,0),padding:e.spacing(.25,0,.25,1),color:e.colors.text.primary,fontSize:e.typography.size.sm,overflow:"hidden",whiteSpace:"nowrap","&:hover":{background:e.colors.emphasize(e.colors.background.secondary)}}),multiValueRemove:(0,$e.css)({label:"grafana-select-multi-value-remove",margin:e.spacing(0,.5),cursor:"pointer",svg:{marginBottom:0}}),singleValueRemove:(0,$e.css)({cursor:"pointer","&:hover":{color:e.colors.text.primary}}),groupHeader:(0,$e.css)({padding:e.spacing(1,1,1,.75),borderLeft:"2px solid transparent"}),group:(0,$e.css)({"&:not(:first-child)":{borderTop:`1px solid ${e.colors.border.weak}`},':has(+ [role="option"])':{borderBottom:`1px solid ${e.colors.border.weak}`}}),toggleAllButton:(0,$e.css)({width:"100%",border:0,padding:0,textAlign:"left"})})));function qP(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function GP(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){qP(e,t,r[t])}))}return e}function KP(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const YP=({innerProps:e,children:t})=>{const r=Xx(),n=HP(r);return(0,ge.jsx)("div",KP(GP({},e),{className:n.multiValueContainer,children:t}))},XP=({children:e,innerProps:t})=>{const r=Xx(),n=HP(r);return(0,ge.jsx)($P,KP(GP({},t),{name:"times",size:"sm",className:n.multiValueRemove,tooltip:"Remove"}))};function QP(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const JP=e=>{const{isDisabled:t,isFocused:r,children:n,selectProps:{invalid:o=!1}}=e,i=Qx(ZP,r,t,o);return(0,ge.jsx)(BR.SelectContainer,(a=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){QP(e,t,r[t])}))}return e}({},e),s=null!=(s={className:(0,$e.cx)(i.wrapper,e.className),children:n})?s:{},Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(s)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(s)).forEach((function(e){Object.defineProperty(a,e,Object.getOwnPropertyDescriptor(s,e))})),a));var a,s},ZP=(e,t,r,n)=>{const o=wj({theme:e,invalid:n});return{wrapper:(0,$e.cx)(o.wrapper,yj(e,n),t&&(0,$e.css)(vj(e)),r&&o.inputDisabled,(0,$e.css)({position:"relative",boxSizing:"border-box",flexDirection:"row",flexWrap:"wrap",alignItems:"stretch",justifyContent:"space-between",minHeight:"32px",height:"auto",maxWidth:"100%",padding:0,cursor:r?"not-allowed":"pointer"}))}};function eL(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,to(e,t)}var tL=Number.isNaN||function(e){return"number"==typeof e&&e!=e};function rL(e,t){if(e.length!==t.length)return!1;for(var r=0;r<e.length;r++)if(!((n=e[r])===(o=t[r])||tL(n)&&tL(o)))return!1;var n,o;return!0}const nL=function(e,t){var r;void 0===t&&(t=rL);var n,o=[],i=!1;return function(){for(var a=[],s=0;s<arguments.length;s++)a[s]=arguments[s];return i&&r===this&&t(a,o)||(n=e.apply(this,a),i=!0,r=this,o=a),n}};var oL="object"==typeof performance&&"function"==typeof performance.now?function(){return performance.now()}:function(){return Date.now()};function iL(e){cancelAnimationFrame(e.id)}var aL=-1;function sL(e){if(void 0===e&&(e=!1),-1===aL||e){var t=document.createElement("div"),r=t.style;r.width="50px",r.height="50px",r.overflow="scroll",document.body.appendChild(t),aL=t.offsetWidth-t.clientWidth,document.body.removeChild(t)}return aL}var lL=null;function uL(e){if(void 0===e&&(e=!1),null===lL||e){var t=document.createElement("div"),r=t.style;r.width="50px",r.height="50px",r.overflow="scroll",r.direction="rtl";var n=document.createElement("div"),o=n.style;return o.width="100px",o.height="100px",t.appendChild(n),document.body.appendChild(t),t.scrollLeft>0?lL="positive-descending":(t.scrollLeft=1,lL=0===t.scrollLeft?"negative":"positive-ascending"),document.body.removeChild(t),lL}return lL}var cL=function(e,t){return e};function dL(e){var t,r=e.getItemOffset,n=e.getEstimatedTotalSize,o=e.getItemSize,i=e.getOffsetForIndexAndAlignment,a=e.getStartIndexForOffset,s=e.getStopIndexForStartIndex,l=e.initInstanceProps,u=e.shouldResetStyleCacheOnItemSizeChange,c=e.validateProps;return t=function(e){function t(t){var n;return(n=e.call(this,t)||this)._instanceProps=l(n.props,Jn(n)),n._outerRef=void 0,n._resetIsScrollingTimeoutId=null,n.state={instance:Jn(n),isScrolling:!1,scrollDirection:"forward",scrollOffset:"number"==typeof n.props.initialScrollOffset?n.props.initialScrollOffset:0,scrollUpdateWasRequested:!1},n._callOnItemsRendered=void 0,n._callOnItemsRendered=nL((function(e,t,r,o){return n.props.onItemsRendered({overscanStartIndex:e,overscanStopIndex:t,visibleStartIndex:r,visibleStopIndex:o})})),n._callOnScroll=void 0,n._callOnScroll=nL((function(e,t,r){return n.props.onScroll({scrollDirection:e,scrollOffset:t,scrollUpdateWasRequested:r})})),n._getItemStyle=void 0,n._getItemStyle=function(e){var t,i=n.props,a=i.direction,s=i.itemSize,l=i.layout,c=n._getItemStyleCache(u&&s,u&&l,u&&a);if(c.hasOwnProperty(e))t=c[e];else{var d=r(n.props,e,n._instanceProps),p=o(n.props,e,n._instanceProps),f="horizontal"===a||"horizontal"===l,h="rtl"===a,g=f?d:0;c[e]=t={position:"absolute",left:h?void 0:g,right:h?g:void 0,top:f?0:d,height:f?"100%":p,width:f?p:"100%"}}return t},n._getItemStyleCache=void 0,n._getItemStyleCache=nL((function(e,t,r){return{}})),n._onScrollHorizontal=function(e){var t=e.currentTarget,r=t.clientWidth,o=t.scrollLeft,i=t.scrollWidth;n.setState((function(e){if(e.scrollOffset===o)return null;var t=n.props.direction,a=o;if("rtl"===t)switch(uL()){case"negative":a=-o;break;case"positive-descending":a=i-r-o}return a=Math.max(0,Math.min(a,i-r)),{isScrolling:!0,scrollDirection:e.scrollOffset<a?"forward":"backward",scrollOffset:a,scrollUpdateWasRequested:!1}}),n._resetIsScrollingDebounced)},n._onScrollVertical=function(e){var t=e.currentTarget,r=t.clientHeight,o=t.scrollHeight,i=t.scrollTop;n.setState((function(e){if(e.scrollOffset===i)return null;var t=Math.max(0,Math.min(i,o-r));return{isScrolling:!0,scrollDirection:e.scrollOffset<t?"forward":"backward",scrollOffset:t,scrollUpdateWasRequested:!1}}),n._resetIsScrollingDebounced)},n._outerRefSetter=function(e){var t=n.props.outerRef;n._outerRef=e,"function"==typeof t?t(e):null!=t&&"object"==typeof t&&t.hasOwnProperty("current")&&(t.current=e)},n._resetIsScrollingDebounced=function(){var e,t,r,o;null!==n._resetIsScrollingTimeoutId&&iL(n._resetIsScrollingTimeoutId),n._resetIsScrollingTimeoutId=(e=n._resetIsScrolling,t=150,r=oL(),o={id:requestAnimationFrame((function n(){oL()-r>=t?e.call(null):o.id=requestAnimationFrame(n)}))})},n._resetIsScrolling=function(){n._resetIsScrollingTimeoutId=null,n.setState({isScrolling:!1},(function(){n._getItemStyleCache(-1,null)}))},n}eL(t,e),t.getDerivedStateFromProps=function(e,t){return pL(e,t),c(e),null};var d=t.prototype;return d.scrollTo=function(e){e=Math.max(0,e),this.setState((function(t){return t.scrollOffset===e?null:{scrollDirection:t.scrollOffset<e?"forward":"backward",scrollOffset:e,scrollUpdateWasRequested:!0}}),this._resetIsScrollingDebounced)},d.scrollToItem=function(e,t){void 0===t&&(t="auto");var r=this.props,n=r.itemCount,o=r.layout,a=this.state.scrollOffset;e=Math.max(0,Math.min(e,n-1));var s=0;if(this._outerRef){var l=this._outerRef;s="vertical"===o?l.scrollWidth>l.clientWidth?sL():0:l.scrollHeight>l.clientHeight?sL():0}this.scrollTo(i(this.props,e,t,a,this._instanceProps,s))},d.componentDidMount=function(){var e=this.props,t=e.direction,r=e.initialScrollOffset,n=e.layout;if("number"==typeof r&&null!=this._outerRef){var o=this._outerRef;"horizontal"===t||"horizontal"===n?o.scrollLeft=r:o.scrollTop=r}this._callPropsCallbacks()},d.componentDidUpdate=function(){var e=this.props,t=e.direction,r=e.layout,n=this.state,o=n.scrollOffset;if(n.scrollUpdateWasRequested&&null!=this._outerRef){var i=this._outerRef;if("horizontal"===t||"horizontal"===r)if("rtl"===t)switch(uL()){case"negative":i.scrollLeft=-o;break;case"positive-ascending":i.scrollLeft=o;break;default:var a=i.clientWidth,s=i.scrollWidth;i.scrollLeft=s-a-o}else i.scrollLeft=o;else i.scrollTop=o}this._callPropsCallbacks()},d.componentWillUnmount=function(){null!==this._resetIsScrollingTimeoutId&&iL(this._resetIsScrollingTimeoutId)},d.render=function(){var e=this.props,t=e.children,r=e.className,o=e.direction,i=e.height,a=e.innerRef,s=e.innerElementType,l=e.innerTagName,u=e.itemCount,c=e.itemData,d=e.itemKey,p=void 0===d?cL:d,f=e.layout,h=e.outerElementType,g=e.outerTagName,v=e.style,m=e.useIsScrolling,y=e.width,b=this.state.isScrolling,O="horizontal"===o||"horizontal"===f,E=O?this._onScrollHorizontal:this._onScrollVertical,S=this._getRangeToRender(),w=S[0],T=S[1],x=[];if(u>0)for(var _=w;_<=T;_++)x.push((0,ve.createElement)(t,{data:c,key:p(_,c),index:_,isScrolling:m?b:void 0,style:this._getItemStyle(_)}));var C=n(this.props,this._instanceProps);return(0,ve.createElement)(h||g||"div",{className:r,onScroll:E,ref:this._outerRefSetter,style:Cb({position:"relative",height:i,width:y,overflow:"auto",WebkitOverflowScrolling:"touch",willChange:"transform",direction:o},v)},(0,ve.createElement)(s||l||"div",{children:x,ref:a,style:{height:O?"100%":C,pointerEvents:b?"none":void 0,width:O?C:"100%"}}))},d._callPropsCallbacks=function(){if("function"==typeof this.props.onItemsRendered&&this.props.itemCount>0){var e=this._getRangeToRender(),t=e[0],r=e[1],n=e[2],o=e[3];this._callOnItemsRendered(t,r,n,o)}if("function"==typeof this.props.onScroll){var i=this.state,a=i.scrollDirection,s=i.scrollOffset,l=i.scrollUpdateWasRequested;this._callOnScroll(a,s,l)}},d._getRangeToRender=function(){var e=this.props,t=e.itemCount,r=e.overscanCount,n=this.state,o=n.isScrolling,i=n.scrollDirection,l=n.scrollOffset;if(0===t)return[0,0,0,0];var u=a(this.props,l,this._instanceProps),c=s(this.props,u,l,this._instanceProps),d=o&&"backward"!==i?1:Math.max(1,r),p=o&&"forward"!==i?1:Math.max(1,r);return[Math.max(0,u-d),Math.max(0,Math.min(t-1,c+p)),u,c]},t}(ve.PureComponent),t.defaultProps={direction:"ltr",itemData:void 0,layout:"vertical",overscanCount:2,useIsScrolling:!1},t}var pL=function(e,t){e.children,e.direction,e.height,e.layout,e.innerTagName,e.outerTagName,e.width,t.instance},fL=dL({getItemOffset:function(e,t){return t*e.itemSize},getItemSize:function(e,t){return e.itemSize},getEstimatedTotalSize:function(e){var t=e.itemCount;return e.itemSize*t},getOffsetForIndexAndAlignment:function(e,t,r,n,o,i){var a=e.direction,s=e.height,l=e.itemCount,u=e.itemSize,c=e.layout,d=e.width,p="horizontal"===a||"horizontal"===c?d:s,f=Math.max(0,l*u-p),h=Math.min(f,t*u),g=Math.max(0,t*u-p+u+i);switch("smart"===r&&(r=n>=g-p&&n<=h+p?"auto":"center"),r){case"start":return h;case"end":return g;case"center":var v=Math.round(g+(h-g)/2);return v<Math.ceil(p/2)?0:v>f+Math.floor(p/2)?f:v;default:return n>=g&&n<=h?n:n<g?g:h}},getStartIndexForOffset:function(e,t){var r=e.itemCount,n=e.itemSize;return Math.max(0,Math.min(r-1,Math.floor(t/n)))},getStopIndexForStartIndex:function(e,t,r){var n=e.direction,o=e.height,i=e.itemCount,a=e.itemSize,s=e.layout,l=e.width,u=t*a,c="horizontal"===n||"horizontal"===s?l:o,d=Math.ceil((c+r-u)/a);return Math.max(0,Math.min(i-1,t+d-1))},initInstanceProps:function(e){},shouldResetStyleCacheOnItemSizeChange:!0,validateProps:function(e){e.itemSize}}),hL=v(1332);const gL=({children:e})=>{const[t,r]=(0,ve.useState)(!1),[n,o]=(0,ve.useState)(!1),i=(0,ve.useRef)(null),a=(0,ve.useRef)(null),s=Qx(vL);return(0,ve.useEffect)((()=>{const e=new IntersectionObserver((e=>{e.forEach((e=>{e.target===i.current?r(!e.isIntersecting):e.target===a.current&&o(!e.isIntersecting)}))}));return[i,a].forEach((t=>{t.current&&e.observe(t.current)})),()=>e.disconnect()}),[]),(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)("div",{className:(0,$e.cx)(s.scrollIndicator,s.scrollTopIndicator,{[s.scrollIndicatorVisible]:t})}),(0,ge.jsxs)("div",{className:s.scrollContent,children:[(0,ge.jsx)("div",{ref:i}),e,(0,ge.jsx)("div",{ref:a})]}),(0,ge.jsx)("div",{className:(0,$e.cx)(s.scrollIndicator,s.scrollBottomIndicator,{[s.scrollIndicatorVisible]:n})})]})},vL=e=>({scrollContent:(0,$e.css)({flex:1,position:"relative"}),scrollIndicator:(0,$e.css)({height:e.spacing(6),left:0,opacity:0,pointerEvents:"none",position:"absolute",right:0,[e.transitions.handleMotion("no-preference","reduce")]:{transition:e.transitions.create("opacity")},zIndex:1}),scrollTopIndicator:(0,$e.css)({background:`linear-gradient(0deg, transparent, ${e.colors.background.canvas})`,top:0}),scrollBottomIndicator:(0,$e.css)({background:`linear-gradient(180deg, transparent, ${e.colors.background.canvas})`,bottom:0}),scrollIndicatorVisible:(0,$e.css)({opacity:1})});function mL(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function yL(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){mL(e,t,r[t])}))}return e}function bL(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const OL=({autoHide:e=!1,autoHideTimeout:t=200,setScrollTop:r,className:n,testId:o,autoHeightMin:i="0",autoHeightMax:a="100%",hideTracksWhenNotNeeded:s=!1,hideHorizontalTrack:l,hideVerticalTrack:u,scrollRefCallback:c,showScrollIndicators:d=!1,updateAfterMountMs:p,scrollTop:f,onScroll:h,children:g,divId:v})=>{const m=(0,ve.useRef)(null),y=Qx(EL);function b(e,t,r){return r.style&&t&&(r.style.display="none"),(0,ge.jsx)("div",bL(yL({},r),{className:e}))}(0,ve.useEffect)((()=>{m.current&&c&&c(m.current.view)}),[m,c]),function(e,t){(0,ve.useEffect)((()=>{e&&null!=t&&e.scrollTop(t)}),[t,e])}(m.current,f),(0,ve.useEffect)((()=>{p&&setTimeout((()=>{const e=m.current;(null==e?void 0:e.update)&&e.update()}),p)}),[p]);const O=(0,ve.useCallback)((e=>b("track-horizontal",l,e)),[l]),E=(0,ve.useCallback)((e=>b("track-vertical",u,e)),[u]),S=(0,ve.useCallback)((e=>(0,ge.jsx)("div",bL(yL({},e),{className:"thumb-horizontal"}))),[]),w=(0,ve.useCallback)((e=>(0,ge.jsx)("div",bL(yL({},e),{className:"thumb-vertical"}))),[]),T=(0,ve.useCallback)((e=>(e.style&&"touch"===e.style.WebkitOverflowScrolling&&(e.style.WebkitOverflowScrolling="auto"),(0,ge.jsx)("div",bL(yL({},e),{className:"scrollbar-view",id:v})))),[v]),x=(0,ve.useCallback)((()=>{m.current&&r&&r(m.current.getValues())}),[r]);return(0,ge.jsx)(hL.Ay,{"data-testid":o,ref:m,className:(0,$e.cx)(y.customScrollbar,n,{[y.scrollbarWithScrollIndicators]:d}),onScrollStop:x,autoHeight:!0,autoHide:e,autoHideTimeout:t,hideTracksWhenNotNeeded:s,autoHeightMax:a,autoHeightMin:i,renderTrackHorizontal:O,renderTrackVertical:E,renderThumbHorizontal:S,renderThumbVertical:w,renderView:T,onScroll:h,children:d?(0,ge.jsx)(gL,{children:g}):g})},EL=e=>({customScrollbar:(0,$e.css)({display:"flex",flexGrow:1,".scrollbar-view":{display:"flex",flexGrow:1,flexDirection:"column"},".track-vertical":{borderRadius:e.shape.borderRadius(2),width:`${e.spacing(1)} !important`,right:0,bottom:e.spacing(.25),top:e.spacing(.25)},".track-horizontal":{borderRadius:e.shape.borderRadius(2),height:`${e.spacing(1)} !important`,right:e.spacing(.25),bottom:e.spacing(.25),left:e.spacing(.25)},".thumb-vertical":{background:e.colors.action.focus,borderRadius:e.shape.borderRadius(2),opacity:0},".thumb-horizontal":{background:e.colors.action.focus,borderRadius:e.shape.borderRadius(2),opacity:0},"&:hover":{".thumb-vertical, .thumb-horizontal":{opacity:1,transition:"opacity 0.3s ease-in-out"}}}),scrollbarWithScrollIndicators:(0,$e.css)({".scrollbar-view":{position:"static !important"}})});var SL;function wL(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function TL(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){wL(e,t,r[t])}))}return e}function xL(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}!function(e){e.allSelected="allSelected",e.indeterminate="indeterminate",e.noneSelected="noneSelected"}(SL||(SL={}));const _L=({children:e,maxHeight:t,innerRef:r,innerProps:n,selectProps:o})=>{const i=Xx(),a=HP(i),{toggleAllOptions:s,components:l}=o;var u;const c=null!==(u=null==l?void 0:l.Option)&&void 0!==u?u:AL;return(0,ge.jsx)("div",xL(TL({},n),{className:a.menu,style:{maxHeight:t},"aria-label":"Select options menu",children:(0,ge.jsxs)(OL,{scrollRefCallback:r,autoHide:!1,autoHeightMax:"inherit",hideHorizontalTrack:!0,children:[s&&(0,ge.jsx)(IL,{state:s.state,optionComponent:c,selectedCount:s.selectedCount,onClick:s.selectAllClicked}),e]})}))};_L.displayName="SelectMenu";const CL=({children:e,maxHeight:t,innerRef:r,options:n,selectProps:o,focusedOption:i})=>{const a=Xx(),s=HP(a),l=(0,ve.useRef)(null),{toggleAllOptions:u,components:c}=o;var d;const p=null!==(d=null==c?void 0:c.Option)&&void 0!==d?d:AL,f=(0,ve.useMemo)((()=>n.flatMap((e=>e.options?[e,...e.options]:[e]))),[n]),h=f.findIndex((e=>e.value===(null==i?void 0:i.value)));if((0,ve.useLayoutEffect)((()=>{var e;null===(e=l.current)||void 0===e||e.scrollToItem(h)}),[h]),!Array.isArray(e))return null;const g=e.flatMap(((e,t)=>RL(e)?[ve.cloneElement(e,{children:null}),...e.props.children.slice(0,-1),ve.cloneElement(e.props.children.at(-1),{innerProps:xL(TL({},e.props.children.at(-1).props.innerProps),{style:{borderBottom:`1px solid ${a.colors.border.weak}`,height:37}})})]:[e]));var v;u&&g.unshift((0,ge.jsx)(IL,{optionComponent:p,state:u.state,selectedCount:u.selectedCount,onClick:u.selectAllClicked}));let m=null!==(v=(0,fe.max)(f.map((e=>{var t;return null===(t=e.label)||void 0===t?void 0:t.length}))))&&void 0!==v?v:0;u&&m<12&&(m=12);const y=8*m+16+58,b=Math.min(37*g.length,t);return(0,ge.jsx)(fL,{outerRef:r,ref:l,className:s.menu,height:b,width:y,"aria-label":"Select options menu",itemCount:g.length,itemSize:37,children:({index:e,style:t})=>(0,ge.jsx)("div",{style:xL(TL({},t),{overflow:"hidden"}),children:g[e]})})},RL=e=>ve.isValidElement(e)&&Array.isArray(e.props.children);CL.displayName="VirtualizedSelectMenu";const IL=({state:e,onClick:t,selectedCount:r,optionComponent:n})=>{const o=Xx(),i=HP(o);return(0,ge.jsx)("button",{"data-testid":ze.components.Select.toggleAllOptions,className:(0,$e.css)(MP(o),i.toggleAllButton,{height:37}),onClick:t,children:n({isDisabled:!1,isSelected:e===SL.allSelected,isFocused:!1,data:{},indeterminate:e===SL.indeterminate,innerRef:()=>{},innerProps:{},children:(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xA,{i18nKey:"select.select-menu.selected-count",children:"Selected "}),`(${null!=r?r:0})`]})})})},AL=({children:e,data:t,innerProps:r,innerRef:n,isFocused:o,isSelected:i,renderOptionLabel:a})=>{const s=Xx(),l=HP(s),u=t.icon?(0,w.toIconName)(t.icon):void 0,{onMouseMove:c,onMouseOver:d}=r,p=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(r,["onMouseMove","onMouseOver"]);return(0,ge.jsxs)("div",xL(TL({ref:n,className:(0,$e.cx)(l.option,o&&l.optionFocused,i&&l.optionSelected,t.isDisabled&&l.optionDisabled)},p),{"data-testid":ze.components.Select.option,title:t.title,children:[u&&(0,ge.jsx)(w_,{name:u,className:l.optionIcon}),t.imgUrl&&(0,ge.jsx)("img",{className:l.optionImage,src:t.imgUrl,alt:t.label||String(t.value)}),(0,ge.jsxs)("div",{className:l.optionBody,children:[(0,ge.jsx)("span",{children:a?a(t):e}),t.description&&(0,ge.jsx)("div",{className:l.optionDescription,children:t.description}),t.component&&(0,ge.jsx)(t.component,{})]})]}))};function jL(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function PL(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){jL(e,t,r[t])}))}return e}AL.displayName="SelectMenuOptions";const LL=({children:e,cx:t,getClassNames:r,getStyles:n,Heading:o,headingProps:i,label:a,selectProps:s,theme:l})=>{const u=Qx(HP);return(0,ge.jsxs)("div",{className:u.group,children:[(0,ge.jsx)(o,(c=PL({cx:t,getClassNames:r,getStyles:n,selectProps:s,theme:l},i),d={children:a},d=null!=d?d:{},Object.getOwnPropertyDescriptors?Object.defineProperties(c,Object.getOwnPropertyDescriptors(d)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(d)).forEach((function(e){Object.defineProperty(c,e,Object.getOwnPropertyDescriptor(d,e))})),c)),e]});var c,d};var kL=v(952);const NL=ve.forwardRef((({childElement:e,children:t},r)=>{const[n,o]=(0,ve.useState)(!1),i=(0,ve.useRef)(null);(0,ve.useImperativeHandle)(r,(()=>i.current));const a=(0,ve.useMemo)((()=>new ResizeObserver((e=>{for(const t of e)t.target.clientWidth&&t.target.scrollWidth&&(t.target.scrollWidth>t.target.clientWidth&&o(!0),t.target.scrollWidth<=t.target.clientWidth&&o(!1))}))),[]);(0,ve.useEffect)((()=>{const{current:e}=i;return e&&a.observe(e),()=>{a.disconnect()}}),[o,a]);return n?(0,ge.jsx)(RP,{ref:i,content:(e=>"string"==typeof e?e:kL.renderToStaticMarkup((0,ge.jsx)(ge.Fragment,{children:e})).replace(/(<([^>]+)>)/gi,""))(t),children:e(void 0)}):e(i)}));NL.displayName="TruncatedText";const DL=(e,t)=>{switch(e){case"bold":return t.typography.fontWeightBold;case"medium":return t.typography.fontWeightMedium;case"light":return t.typography.fontWeightLight;case"regular":case void 0:return t.typography.fontWeightRegular}},FL=(e,t)=>{switch(e){case"error":return t.colors.error.text;case"success":return t.colors.success.text;case"info":return t.colors.info.text;case"warning":return t.colors.warning.text;default:return e?t.colors.text[e]:void 0}},ML=(e,t,r)=>{if(r)return e.typography[r];switch(t){case"span":return;case"h1":return e.typography.h1;case"h2":return e.typography.h2;case"h3":return e.typography.h3;case"h4":return e.typography.h4;case"h5":return e.typography.h5;case"h6":return e.typography.h6;default:return e.typography.body}};function VL(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function UL(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){VL(e,t,r[t])}))}return e}const BL=ve.forwardRef(((e,t)=>{var{element:r="span",variant:n,weight:o,color:i,truncate:a,italic:s,textAlignment:l,children:u,tabular:c}=e,d=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["element","variant","weight","color","truncate","italic","textAlignment","children","tabular"]);const p=Qx(zL,r,n,i,o,a,s,l,c),f=e=>{return(0,ve.createElement)(r,(t=UL({},d),n=null!=(n={style:void 0,className:p,ref:e})?n:{},Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(n)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(n)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(n,e))})),t),u);var t,n};return a&&"span"!==r?(0,ge.jsx)(NL,{childElement:f,children:u,ref:t}):f(void 0)}));BL.displayName="Text";const zL=(e,t,r,n,o,i,a,s,l)=>(0,$e.css)([UL({margin:0,padding:0},ML(e,t,r)),r&&UL({},e.typography[r]),n&&{color:FL(n,e)},o&&{fontWeight:DL(o,e)},i&&{overflow:"hidden",textOverflow:"ellipsis",whiteSpace:"nowrap"},a&&{fontStyle:"italic"},s&&{textAlign:s},l&&{fontFeatureSettings:'"tnum"'}]),$L=e=>{const t=Qx(HP);var r;return(0,ge.jsx)("div",{className:t.groupHeader,children:(0,ge.jsx)(BL,{weight:"bold",variant:"bodySmall",color:"secondary",children:null!==(r=e.children)&&void 0!==r?r:""})})};function WL(e,t){return e.replace(new RegExp("(^|\\s)"+t+"(?:\\s|$)","g"),"$1").replace(/\s+/g," ").replace(/^\s*|\s*$/g,"")}const HL=ye().createContext(null);var qL=function(e){return e.scrollTop},GL="unmounted",KL="exited",YL="entering",XL="entered",QL="exiting",JL=function(e){function t(t,r){var n;n=e.call(this,t,r)||this;var o,i=r&&!r.isMounting?t.enter:t.appear;return n.appearStatus=null,t.in?i?(o=KL,n.appearStatus=YL):o=XL:o=t.unmountOnExit||t.mountOnEnter?GL:KL,n.state={status:o},n.nextCallback=null,n}eL(t,e),t.getDerivedStateFromProps=function(e,t){return e.in&&t.status===GL?{status:KL}:null};var r=t.prototype;return r.componentDidMount=function(){this.updateStatus(!0,this.appearStatus)},r.componentDidUpdate=function(e){var t=null;if(e!==this.props){var r=this.state.status;this.props.in?r!==YL&&r!==XL&&(t=YL):r!==YL&&r!==XL||(t=QL)}this.updateStatus(!1,t)},r.componentWillUnmount=function(){this.cancelNextCallback()},r.getTimeouts=function(){var e,t,r,n=this.props.timeout;return e=t=r=n,null!=n&&"number"!=typeof n&&(e=n.exit,t=n.enter,r=void 0!==n.appear?n.appear:t),{exit:e,enter:t,appear:r}},r.updateStatus=function(e,t){if(void 0===e&&(e=!1),null!==t)if(this.cancelNextCallback(),t===YL){if(this.props.unmountOnExit||this.props.mountOnEnter){var r=this.props.nodeRef?this.props.nodeRef.current:U_().findDOMNode(this);r&&qL(r)}this.performEnter(e)}else this.performExit();else this.props.unmountOnExit&&this.state.status===KL&&this.setState({status:GL})},r.performEnter=function(e){var t=this,r=this.props.enter,n=this.context?this.context.isMounting:e,o=this.props.nodeRef?[n]:[U_().findDOMNode(this),n],i=o[0],a=o[1],s=this.getTimeouts(),l=n?s.appear:s.enter;e||r?(this.props.onEnter(i,a),this.safeSetState({status:YL},(function(){t.props.onEntering(i,a),t.onTransitionEnd(l,(function(){t.safeSetState({status:XL},(function(){t.props.onEntered(i,a)}))}))}))):this.safeSetState({status:XL},(function(){t.props.onEntered(i)}))},r.performExit=function(){var e=this,t=this.props.exit,r=this.getTimeouts(),n=this.props.nodeRef?void 0:U_().findDOMNode(this);t?(this.props.onExit(n),this.safeSetState({status:QL},(function(){e.props.onExiting(n),e.onTransitionEnd(r.exit,(function(){e.safeSetState({status:KL},(function(){e.props.onExited(n)}))}))}))):this.safeSetState({status:KL},(function(){e.props.onExited(n)}))},r.cancelNextCallback=function(){null!==this.nextCallback&&(this.nextCallback.cancel(),this.nextCallback=null)},r.safeSetState=function(e,t){t=this.setNextCallback(t),this.setState(e,t)},r.setNextCallback=function(e){var t=this,r=!0;return this.nextCallback=function(n){r&&(r=!1,t.nextCallback=null,e(n))},this.nextCallback.cancel=function(){r=!1},this.nextCallback},r.onTransitionEnd=function(e,t){this.setNextCallback(t);var r=this.props.nodeRef?this.props.nodeRef.current:U_().findDOMNode(this),n=null==e&&!this.props.addEndListener;if(r&&!n){if(this.props.addEndListener){var o=this.props.nodeRef?[this.nextCallback]:[r,this.nextCallback],i=o[0],a=o[1];this.props.addEndListener(i,a)}null!=e&&setTimeout(this.nextCallback,e)}else setTimeout(this.nextCallback,0)},r.render=function(){var e=this.state.status;if(e===GL)return null;var t=this.props,r=t.children,n=(t.in,t.mountOnEnter,t.unmountOnExit,t.appear,t.enter,t.exit,t.timeout,t.addEndListener,t.onEnter,t.onEntering,t.onEntered,t.onExit,t.onExiting,t.onExited,t.nodeRef,rm(t,["children","in","mountOnEnter","unmountOnExit","appear","enter","exit","timeout","addEndListener","onEnter","onEntering","onEntered","onExit","onExiting","onExited","nodeRef"]));return ye().createElement(HL.Provider,{value:null},"function"==typeof r?r(e,n):ye().cloneElement(ye().Children.only(r),n))},t}(ye().Component);function ZL(){}JL.contextType=HL,JL.propTypes={},JL.defaultProps={in:!1,mountOnEnter:!1,unmountOnExit:!1,appear:!1,enter:!0,exit:!0,onEnter:ZL,onEntering:ZL,onEntered:ZL,onExit:ZL,onExiting:ZL,onExited:ZL},JL.UNMOUNTED=GL,JL.EXITED=KL,JL.ENTERING=YL,JL.ENTERED=XL,JL.EXITING=QL;const ek=JL;var tk=function(e,t){return e&&t&&t.split(" ").forEach((function(t){return n=t,void((r=e).classList?r.classList.remove(n):"string"==typeof r.className?r.className=WL(r.className,n):r.setAttribute("class",WL(r.className&&r.className.baseVal||"",n)));var r,n}))},rk=function(e){function t(){for(var t,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(t=e.call.apply(e,[this].concat(n))||this).appliedClasses={appear:{},enter:{},exit:{}},t.onEnter=function(e,r){var n=t.resolveArguments(e,r),o=n[0],i=n[1];t.removeClasses(o,"exit"),t.addClass(o,i?"appear":"enter","base"),t.props.onEnter&&t.props.onEnter(e,r)},t.onEntering=function(e,r){var n=t.resolveArguments(e,r),o=n[0],i=n[1]?"appear":"enter";t.addClass(o,i,"active"),t.props.onEntering&&t.props.onEntering(e,r)},t.onEntered=function(e,r){var n=t.resolveArguments(e,r),o=n[0],i=n[1]?"appear":"enter";t.removeClasses(o,i),t.addClass(o,i,"done"),t.props.onEntered&&t.props.onEntered(e,r)},t.onExit=function(e){var r=t.resolveArguments(e)[0];t.removeClasses(r,"appear"),t.removeClasses(r,"enter"),t.addClass(r,"exit","base"),t.props.onExit&&t.props.onExit(e)},t.onExiting=function(e){var r=t.resolveArguments(e)[0];t.addClass(r,"exit","active"),t.props.onExiting&&t.props.onExiting(e)},t.onExited=function(e){var r=t.resolveArguments(e)[0];t.removeClasses(r,"exit"),t.addClass(r,"exit","done"),t.props.onExited&&t.props.onExited(e)},t.resolveArguments=function(e,r){return t.props.nodeRef?[t.props.nodeRef.current,e]:[e,r]},t.getClassNames=function(e){var r=t.props.classNames,n="string"==typeof r,o=n?(n&&r?r+"-":"")+e:r[e];return{baseClassName:o,activeClassName:n?o+"-active":r[e+"Active"],doneClassName:n?o+"-done":r[e+"Done"]}},t}eL(t,e);var r=t.prototype;return r.addClass=function(e,t,r){var n=this.getClassNames(t)[r+"ClassName"],o=this.getClassNames("enter").doneClassName;"appear"===t&&"done"===r&&o&&(n+=" "+o),"active"===r&&e&&qL(e),n&&(this.appliedClasses[t][r]=n,function(e,t){e&&t&&t.split(" ").forEach((function(t){return n=t,void((r=e).classList?r.classList.add(n):function(e,t){return e.classList?!!t&&e.classList.contains(t):-1!==(" "+(e.className.baseVal||e.className)+" ").indexOf(" "+t+" ")}(r,n)||("string"==typeof r.className?r.className=r.className+" "+n:r.setAttribute("class",(r.className&&r.className.baseVal||"")+" "+n)));var r,n}))}(e,n))},r.removeClasses=function(e,t){var r=this.appliedClasses[t],n=r.base,o=r.active,i=r.done;this.appliedClasses[t]={},n&&tk(e,n),o&&tk(e,o),i&&tk(e,i)},r.render=function(){var e=this.props,t=(e.classNames,rm(e,["classNames"]));return ye().createElement(ek,Cb({},t,{onEnter:this.onEnter,onEntered:this.onEntered,onEntering:this.onEntering,onExit:this.onExit,onExiting:this.onExiting,onExited:this.onExited}))},t}(ye().Component);rk.defaultProps={classNames:""},rk.propTypes={};const nk=rk;function ok(e){const{visible:t,children:r,duration:n=250}=e,o=Qx(ik,n),i=(0,ve.useRef)(null);return(0,ge.jsx)(nk,{in:t,mountOnEnter:!0,unmountOnExit:!0,timeout:n,classNames:o,nodeRef:i,children:ve.cloneElement(r,{ref:i})})}const ik=(e,t)=>({enter:(0,$e.css)({label:"enter",opacity:0}),enterActive:(0,$e.css)({label:"enterActive",opacity:1,[e.transitions.handleMotion("no-preference","reduce")]:{transition:`opacity ${t}ms ease-out`}}),exit:(0,$e.css)({label:"exit",opacity:1}),exitActive:(0,$e.css)({label:"exitActive",opacity:0,[e.transitions.handleMotion("no-preference","reduce")]:{transition:`opacity ${t}ms ease-out`}})});function ak(e){const{visible:t,children:r,duration:n=250,horizontal:o,size:i}=e,a=Qx(sk,n,o?"width":"height",i),s=(0,ve.useRef)(null);return(0,ge.jsx)(nk,{in:t,mountOnEnter:!0,unmountOnExit:!0,timeout:n,classNames:a,nodeRef:s,children:ve.cloneElement(r,{ref:s})})}const sk=(e,t,r,n)=>({enter:(0,$e.css)({label:"enter",[`${r}`]:0,opacity:0}),enterActive:(0,$e.css)({label:"enterActive",[`${r}`]:`${n}px`,opacity:1,[e.transitions.handleMotion("no-preference")]:{transition:`opacity ${t}ms ease-out, ${r} ${t}ms ease-out`},[e.transitions.handleMotion("reduce")]:{transition:`opacity ${t}ms ease-out`}}),exit:(0,$e.css)({label:"exit",[`${r}`]:`${n}px`,opacity:1}),exitActive:(0,$e.css)({label:"exitActive",opacity:0,[`${r}`]:0,[e.transitions.handleMotion("no-preference")]:{transition:`opacity ${t}ms ease-out, ${r} ${t}ms ease-out`},[e.transitions.handleMotion("reduce")]:{transition:`opacity ${t}ms ease-out`}})});function lk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const uk=e=>({singleValue:(0,$e.css)({label:"singleValue",whiteSpace:"nowrap",overflow:"hidden",textOverflow:"ellipsis",boxSizing:"border-box",maxWidth:"100%",gridArea:"1 / 1 / 2 / 3"}),spinnerWrapper:(0,$e.css)({width:"16px",height:"16px",display:"inline-block",marginRight:"10px",position:"relative",verticalAlign:"middle",overflow:"hidden"}),spinnerIcon:(0,$e.css)({width:"100%",height:"100%",position:"absolute"}),optionIcon:(0,$e.css)({marginRight:e.spacing(1),color:e.colors.text.secondary}),disabled:(0,$e.css)({color:e.colors.text.disabled}),isOpen:(0,$e.css)({color:e.colors.text.disabled})}),ck=e=>{const{children:t,data:r,isDisabled:n}=e,o=Qx(uk),i=function(e,t={}){const{duration:r=250,delay:n=250}=t,[o,i]=(0,ve.useState)(e),a=(0,ve.useRef)();return(0,ve.useEffect)((()=>{let t;if(e)t=setTimeout((()=>{a.current=new Date,i(e)}),n);else{const n=a.current?Date.now()-a.current.valueOf():0,o=()=>{a.current=void 0,i(e)};n>=r?o():t=setTimeout(o,r-n)}return()=>{t&&(clearTimeout(t),t=void 0)}}),[e,r,n]),o}(r.loading||!1,{delay:250,duration:750}),a=r.icon?(0,w.toIconName)(r.icon):void 0;var s,l,u;return(0,ge.jsxs)(BR.SingleValue,(l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){lk(e,t,r[t])}))}return e}({},e),u=null!=(u={className:(0,$e.cx)(o.singleValue,n&&o.disabled,e.selectProps.menuIsOpen&&o.isOpen),children:[r.imgUrl?(0,ge.jsx)(dk,{loading:i,imgUrl:r.imgUrl,styles:o,alt:String(null!==(s=r.label)&&void 0!==s?s:r.value)}):(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(ak,{horizontal:!0,size:16,visible:i,duration:150,children:(0,ge.jsx)("div",{className:o.spinnerWrapper,children:(0,ge.jsx)(CA,{className:o.spinnerIcon,inline:!0})})}),a&&(0,ge.jsx)(w_,{name:a,role:"img",className:o.optionIcon})]}),!r.hideText&&t]})?u:{},Object.getOwnPropertyDescriptors?Object.defineProperties(l,Object.getOwnPropertyDescriptors(u)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(u)).forEach((function(e){Object.defineProperty(l,e,Object.getOwnPropertyDescriptor(u,e))})),l))},dk=e=>(0,ge.jsxs)("div",{className:e.styles.spinnerWrapper,children:[(0,ge.jsx)(ok,{duration:150,visible:e.loading,children:(0,ge.jsx)(CA,{className:e.styles.spinnerIcon,inline:!0})}),(0,ge.jsx)(ok,{duration:150,visible:!e.loading,children:(0,ge.jsx)("img",{className:e.styles.spinnerIcon,src:e.imgUrl,alt:e.alt})})]});class pk extends ve.Component{render(){const{children:e}=this.props,{selectProps:t}=this.props;if(t&&Array.isArray(e)&&Array.isArray(e[0])&&void 0!==t.maxVisibleValues&&(!t.showAllSelectedWhenOpen||!t.menuIsOpen)){const[r,...n]=e,o=r.slice(0,t.maxVisibleValues);return this.renderContainer([o,...n])}return this.renderContainer(e)}renderContainer(e){var t,r;const{isMulti:n,theme:o,selectProps:i}=this.props,a=(null===(t=this.props.selectProps)||void 0===t?void 0:t.noMultiValueWrap)&&!(null===(r=this.props.selectProps)||void 0===r?void 0:r.menuIsOpen),s=HP(o),l=i["data-testid"],u=(0,$e.cx)(s.valueContainer,{[s.valueContainerMulti]:n&&!a,[s.valueContainerMultiNoWrap]:n&&a});return(0,ge.jsx)("div",{"data-testid":l,className:u,children:e})}}const fk=(e=>{const t=t=>{const r=Kx||w.ThemeContext;return(0,ge.jsx)(r.Consumer,{children:r=>{return(0,ge.jsx)(e,(n=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Gx(e,t,r[t])}))}return e}({},t),o=null!=(o={theme:r})?o:{},Object.getOwnPropertyDescriptors?Object.defineProperties(n,Object.getOwnPropertyDescriptors(o)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(o)).forEach((function(e){Object.defineProperty(n,e,Object.getOwnPropertyDescriptor(o,e))})),n));var n,o}})};return t.displayName=`WithTheme(${e.displayName})`,Wx()(t,e),t})(pk);function hk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function gk(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){hk(e,t,r[t])}))}return e}function vk(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const mk=(e,t)=>{if(Array.isArray(e)){const t=e.filter(Boolean);return(null==t?void 0:t.length)?t:void 0}if("object"==typeof e)return[e];if("string"==typeof e||"number"==typeof e){const r=yk(e,t);if(r)return[r]}},yk=(e,t)=>{for(const r of t)if("options"in r){let t=yk(e,r.options);if(t)return t}else if("value"in r&&r.value===e)return r;return null},bk=e=>e.map((e=>{var{description:t}=e;return function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["description"])}));function Ok(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ek(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ok(e,t,r[t])}))}return e}function Sk(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const wk=e=>{const{children:t,innerProps:r,selectProps:{menuIsOpen:n,onMenuClose:o,onMenuOpen:i},isFocused:a,isMulti:s,getValue:l,innerRef:u}=e,c=e.selectProps;return c.renderControl?ve.createElement(c.renderControl,{isOpen:n,value:s?l():l()[0],ref:u,onClick:n?o:i,onBlur:o,disabled:!!c.disabled,invalid:!!c.invalid}):(0,ge.jsx)(_j,{ref:u,innerProps:r,prefix:c.prefix,focused:a,invalid:!!c.invalid,disabled:!!c.disabled,children:t})};function Tk(e){var{allowCustomValue:t=!1,allowCreateWhileLoading:r=!1,"aria-label":n,"data-testid":o,autoFocus:i=!1,backspaceRemovesValue:a=!0,blurInputOnSelect:s,cacheOptions:l,className:u,closeMenuOnSelect:c=!0,components:d,createOptionPosition:p="last",defaultOptions:f,defaultValue:h,disabled:g=!1,filterOption:v,formatCreateLabel:m,getOptionLabel:y,getOptionValue:b,inputValue:O,invalid:E,isClearable:S=!1,id:T,isLoading:x=!1,isMulti:_=!1,inputId:C,isOpen:R,isOptionDisabled:I,isSearchable:A=!0,loadOptions:j,loadingMessage:P="Loading options...",maxMenuHeight:L=300,minMenuHeight:k,maxVisibleValues:N,menuPlacement:D="auto",menuPosition:F,menuShouldPortal:M=!0,noOptionsMessage:V=xf("grafana-ui.select.no-options-label","No options found"),onBlur:U,onChange:B,onCloseMenu:z,onCreateOption:$,onInputChange:W,onKeyDown:H,onMenuScrollToBottom:q,onMenuScrollToTop:G,onOpenMenu:K,onFocus:Y,toggleAllOptions:X,openMenuOnFocus:Q=!1,options:J=[],placeholder:Z=xf("grafana-ui.select.placeholder","Choose"),prefix:ee,renderControl:te,showAllSelectedWhenOpen:re=!0,tabSelectsValue:ne=!0,value:oe,virtualized:ie=!1,noMultiValueWrap:ae,width:se,isValidNewOption:le,formatOptionLabel:ue,hideSelectedOptions:ce}=e,de=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["allowCustomValue","allowCreateWhileLoading","aria-label","data-testid","autoFocus","backspaceRemovesValue","blurInputOnSelect","cacheOptions","className","closeMenuOnSelect","components","createOptionPosition","defaultOptions","defaultValue","disabled","filterOption","formatCreateLabel","getOptionLabel","getOptionValue","inputValue","invalid","isClearable","id","isLoading","isMulti","inputId","isOpen","isOptionDisabled","isSearchable","loadOptions","loadingMessage","maxMenuHeight","minMenuHeight","maxVisibleValues","menuPlacement","menuPosition","menuShouldPortal","noOptionsMessage","onBlur","onChange","onCloseMenu","onCreateOption","onInputChange","onKeyDown","onMenuScrollToBottom","onMenuScrollToTop","onOpenMenu","onFocus","toggleAllOptions","openMenuOnFocus","options","placeholder","prefix","renderControl","showAllSelectedWhenOpen","tabSelectsValue","value","virtualized","noMultiValueWrap","width","isValidNewOption","formatOptionLabel","hideSelectedOptions"]);const pe=Xx(),he=HP(pe),me=(0,ve.useRef)(null),[ye,be]=(0,ve.useState)(!1),Oe=function(e,t){return(0,ve.useMemo)((()=>vk(gk({},function(e){return{clearIndicator:()=>({}),container:()=>({}),control:()=>({}),dropdownIndicator:()=>({}),group:()=>({}),groupHeading:()=>({}),indicatorsContainer:()=>({}),indicatorSeparator:()=>({}),input:function(e){return vk(gk({},e),{color:"inherit",margin:0,padding:0,zIndex:1,overflow:"hidden"})},loadingIndicator:()=>({}),loadingMessage:()=>({}),menu:()=>({}),menuList:({maxHeight:e})=>({maxHeight:e}),multiValue:()=>({}),multiValueLabel:()=>({overflow:"hidden",textOverflow:"ellipsis"}),multiValueRemove:()=>({}),noOptionsMessage:()=>({}),option:()=>({}),placeholder:t=>vk(gk({},t),{color:e.colors.text.secondary}),singleValue:()=>({}),valueContainer:()=>({})}}(e)),{menuPortal:t=>vk(gk({},t),{zIndex:e.zIndex.portal}),menu:({top:t,bottom:r,position:n})=>({top:t,bottom:r,position:n,minWidth:"100%",zIndex:e.zIndex.dropdown}),container:()=>({width:t?e.spacing(t):"100%",display:"auto"===t?"inline-flex":"flex"}),option:(e,t)=>vk(gk({},e),{opacity:t.isDisabled?.5:1})})),[e,t])}(pe,se),[Ee,Se]=(0,ve.useState)(!!O);(0,ve.useEffect)((()=>{if(j&&R&&me.current&&me.current.controlRef&&"auto"===D){const e=window.innerHeight-me.current.controlRef.getBoundingClientRect().bottom;be(e<L)}}),[L,D,j,R]);const we=(0,ve.useCallback)(((e,t)=>{if(_&&null==e)return B([],t);B(e,t)}),[_,B]);let Te=BI;const xe={};let _e,Ce={};if(_&&j)_e=oe;else if(_&&oe&&Array.isArray(oe)&&!j)_e=oe.map((e=>{var t;return yk(null!==(t=e.value)&&void 0!==t?t:e,J)||("string"==typeof e?(0,w.toOption)(e):e)}));else if(j){const e=h||oe;_e=e?[e]:[]}else _e=mk(oe,J);const Re={"aria-label":n,"data-testid":o,autoFocus:i,backspaceRemovesValue:a,blurInputOnSelect:s,captureMenuScroll:q||G,closeMenuOnSelect:c,defaultValue:h,disabled:g,filterOption:Ee?v:null,getOptionLabel:y,getOptionValue:b,hideSelectedOptions:ce,inputValue:O,invalid:E,isClearable:S,id:T,isDisabled:g,isLoading:x,isMulti:_,inputId:C,isOptionDisabled:I,isSearchable:A,maxMenuHeight:L,minMenuHeight:k,maxVisibleValues:N,menuIsOpen:R,menuPlacement:"auto"===D&&ye?"top":D,menuPosition:F,menuShouldBlockScroll:!0,menuPortalTarget:M&&"undefined"!=typeof document?document.body:void 0,menuShouldScrollIntoView:!1,onBlur:U,onChange:we,onInputChange:(e,t)=>{var r;const n=null!==(r=null==W?void 0:W(e,t))&&void 0!==r?r:e,o=!!n;return o!==Ee&&Se(o),n},onKeyDown:H,onMenuClose:z,onMenuOpen:K,onMenuScrollToBottom:q,onMenuScrollToTop:G,onFocus:Y,formatOptionLabel:ue,openMenuOnFocus:Q,options:ie?bk(J):J,placeholder:Z,prefix:ee,renderControl:te,showAllSelectedWhenOpen:re,tabSelectsValue:ne,value:_?_e:null==_e?void 0:_e[0],noMultiValueWrap:ae};t&&(Te=XI,xe.allowCreateWhileLoading=r,xe.formatCreateLabel=null!=m?m:xk,xe.onCreateOption=$,xe.createOptionPosition=p,xe.isValidNewOption=le),j&&(Te=t?YI:WI,Ce={loadOptions:j,cacheOptions:l,defaultOptions:f});const Ie=ie?CL:_L;let Ae=SL.noneSelected;(null==X?void 0:X.enabled)&&(0,fe.isArray)(_e)&&(Ae=(null==X?void 0:X.determineToggleAllState)?X.determineToggleAllState(_e,J):function(e,t){return t.length===e.length?SL.allSelected:0===e.length?SL.noneSelected:SL.indeterminate}(_e,J));const je=(0,ve.useCallback)((()=>{let e=Ae===SL.noneSelected?J:[];(null==X?void 0:X.optionsFilter)&&(e=Ae===SL.noneSelected?J.filter(X.optionsFilter):J.filter((0,fe.negate)(X.optionsFilter))),B(e,{action:"select-option",option:{}})}),[J,X,B,Ae]);return(0,ge.jsx)(ge.Fragment,{children:(0,ge.jsx)(Te,Ek({ref:me,components:Ek({MenuList:Ie,Group:LL,GroupHeading:$L,ValueContainer:fk,IndicatorsContainer:_k,IndicatorSeparator:Ck,Control:wk,Option:AL,ClearIndicator(e){const{clearValue:t}=e;return(0,ge.jsx)(w_,{name:"times",role:"button","aria-label":"select-clear-value",className:he.singleValueRemove,onMouseDown:e=>{e.preventDefault(),e.stopPropagation(),t()}})},LoadingIndicator:()=>(0,ge.jsx)(CA,{inline:!0}),LoadingMessage:()=>(0,ge.jsx)("div",{className:he.loadingMessage,children:P}),NoOptionsMessage:()=>(0,ge.jsx)("div",{className:he.loadingMessage,"aria-label":"No options provided",children:V}),DropdownIndicator:PA,SingleValue:e=>(0,ge.jsx)(ck,Sk(Ek({},e),{isDisabled:g})),SelectContainer:JP,MultiValueContainer:YP,MultiValueRemove:g?()=>null:XP,Input:jA},d),toggleAllOptions:(null==X?void 0:X.enabled)&&{state:Ae,selectAllClicked:je,selectedCount:(0,fe.isArray)(_e)?_e.length:void 0},styles:Oe,className:u},Re,xe,Ce,de))})}function xk(e){return(0,ge.jsxs)("div",{style:{display:"flex",gap:"8px",alignItems:"center"},children:[(0,ge.jsx)("div",{children:e}),(0,ge.jsx)("div",{style:{flexGrow:1}}),(0,ge.jsx)("div",{className:"muted small",style:{display:"flex",gap:"8px",alignItems:"center"},children:(0,ge.jsx)(xA,{i18nKey:"grafana-ui.select.default-create-label",children:"Hit enter to add"})})]})}function _k(e){const{showAllSelectedWhenOpen:t,maxVisibleValues:r,menuIsOpen:n}=e.selectProps,o=e.getValue();if(void 0!==r&&Array.isArray(e.children)){const i=o.length;if(i>r&&(!t||!n)){const t=[...e.children];return t.splice(-1,0,(0,ge.jsx)("span",{id:"excess-values",children:`(+${i-r})`},"excess-values")),(0,ge.jsx)(Tj,Sk(Ek({},e),{children:t}))}}return(0,ge.jsx)(Tj,Ek({},e))}function Ck(){return(0,ge.jsx)(ge.Fragment,{})}function Rk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ik(e){return(0,ge.jsx)(Tk,function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Rk(e,t,r[t])}))}return e}({},e))}function Ak(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function jk(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ak(e,t,r[t])}))}return e}function Pk(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Lk=e=>{const{managedIdentityEnabled:t,azureEntraPasswordCredentialsEnabled:r,credentials:n,azureCloudOptions:o,onCredentialsChange:i,disabled:a}=e,s=[{value:Nx.CLIENT_SECRET,label:"App Registration"}];t&&s.push({value:Nx.MSI,label:"Managed Identity"}),r&&s.push({value:Nx.AD_PASSWORD,label:"Azure Entra Password"});const l=({property:e,value:t})=>{if(i){const r=Pk(jk({},n),{[e]:t});i(r)}};return(0,ge.jsxs)("div",{children:[(0,ge.jsx)(j_,{label:"Authentication",description:"Choose the type of authentication to Azure services",htmlFor:"authentication-type",children:(0,ge.jsx)(Ik,{width:20,value:s.find((e=>e.value===n.authType)),options:s,onChange:e=>{if(i){const t=Pk(jk({},n),{authType:e.value||Nx.MSI});i(t)}},disabled:a})}),n.authType===Nx.CLIENT_SECRET&&(0,ge.jsxs)(ge.Fragment,{children:[o&&(0,ge.jsx)(j_,{label:"Azure Cloud",htmlFor:"azure-cloud-type",disabled:a,children:(0,ge.jsx)(Ik,{value:o.find((e=>e.value===n.azureCloud)),options:o,onChange:e=>{const t=e.value||"";l({property:"azureCloud",value:t})},isDisabled:a,inputId:"azure-cloud-type","aria-label":"Azure Cloud",width:20})}),(0,ge.jsx)(j_,{label:"Directory (tenant) ID",required:!0,htmlFor:"tenant-id",invalid:!n.tenantId,error:"Tenant ID is required",children:(0,ge.jsx)(Sj,{width:45,placeholder:"XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX",value:n.tenantId||"",onChange:e=>{const t=e.target.value;l({property:"tenantId",value:t})},disabled:a,"aria-label":"Tenant ID"})}),(0,ge.jsx)(j_,{label:"Application (client) ID",required:!0,htmlFor:"client-id",invalid:!n.clientId,error:"Client ID is required",children:(0,ge.jsx)(Sj,{width:45,placeholder:"XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX",value:n.clientId||"",onChange:e=>{const t=e.target.value;l({property:"clientId",value:t})},disabled:a,"aria-label":"Client ID"})}),!a&&("symbol"==typeof n.clientSecret?(0,ge.jsx)(j_,{label:"Client Secret",htmlFor:"client-secret",required:!0,children:(0,ge.jsxs)("div",{className:"width-30",style:{display:"flex",gap:"4px"},children:[(0,ge.jsx)(Sj,{"aria-label":"Client Secret",placeholder:"configured",disabled:!0,"data-testid":"client-secret",width:45}),(0,ge.jsx)(kP,{variant:"secondary",type:"button",onClick:()=>{l({property:"clientSecret",value:""})},disabled:a,children:"Reset"})]})}):(0,ge.jsx)(j_,{label:"Client Secret",required:!0,htmlFor:"client-secret",invalid:!n.clientSecret,error:"Client secret is required",children:(0,ge.jsx)(Sj,{width:45,"aria-label":"Client Secret",placeholder:"XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX",value:n.clientSecret||"",onChange:e=>{const t=e.target.value;l({property:"clientSecret",value:t})},id:"client-secret",disabled:a})}))]}),n.authType===Nx.AD_PASSWORD&&r&&(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(j_,{label:"User Id",required:!0,htmlFor:"user-id",invalid:!n.userId,error:"User ID is required",children:(0,ge.jsx)(Sj,{width:45,value:n.userId||"",onChange:e=>{const t=e.target.value;l({property:"userId",value:t})},disabled:a,"aria-label":"User ID"})}),(0,ge.jsx)(j_,{label:"Application Client ID",required:!0,htmlFor:"application-client-id",invalid:!n.clientId,error:"Application Client ID is required",children:(0,ge.jsx)(Sj,{width:45,value:n.clientId||"",onChange:e=>{const t=e.target.value;l({property:"clientId",value:t})},disabled:a,"aria-label":"Application Client ID"})}),!a&&("symbol"==typeof n.password?(0,ge.jsx)(j_,{label:"Password",htmlFor:"password",required:!0,children:(0,ge.jsxs)("div",{className:"width-30",style:{display:"flex",gap:"4px"},children:[(0,ge.jsx)(Sj,{"aria-label":"Password",placeholder:"configured",disabled:!0,"data-testid":"password",width:45}),(0,ge.jsx)(kP,{variant:"secondary",type:"button",onClick:()=>{l({property:"password",value:""})},disabled:a,children:"Reset"})]})}):(0,ge.jsx)(j_,{label:"Password",required:!0,htmlFor:"password",invalid:!n.password,error:"Password is required",children:(0,ge.jsx)(Sj,{width:45,"aria-label":"Password",value:n.password||"",onChange:e=>{const t=e.target.value;l({property:"password",value:t})},id:"password",disabled:a})}))]})]})},kk=e=>{const{dataSourceConfig:t,onChange:r}=e,n=pe.config.azure.managedIdentityEnabled,o=pe.config.azure.azureEntraPasswordCredentialsEnabled,i=(0,ve.useMemo)((()=>((e,t)=>{var r,n,o,i,a,s,l;const u=null===(r=e.jsonData)||void 0===r?void 0:r.azureCredentials,c=null===(n=e.secureJsonFields)||void 0===n?void 0:n.azureClientSecret,d=null===(o=e.secureJsonData)||void 0===o?void 0:o.azureClientSecret,p=null===(i=e.secureJsonFields)||void 0===i?void 0:i.password,f=null===(a=e.secureJsonData)||void 0===a?void 0:a.password,h=!!(null===(s=t.azure)||void 0===s?void 0:s.managedIdentityEnabled),g=(null===(l=t.azure)||void 0===l?void 0:l.cloud)||kx.Public;if(!u)return((e,t)=>e?{authType:Nx.MSI}:{authType:Nx.CLIENT_SECRET,azureCloud:t})(h,g);switch(u.authType){case Nx.MSI:return h?{authType:Nx.MSI}:{authType:Nx.CLIENT_SECRET,azureCloud:g};case Nx.CLIENT_SECRET:return{authType:Nx.CLIENT_SECRET,azureCloud:u.azureCloud||g,tenantId:u.tenantId,clientId:u.clientId,clientSecret:zx(c,d)};case Nx.AD_PASSWORD:return{authType:Nx.AD_PASSWORD,userId:u.userId,clientId:u.clientId,password:zx(p,f)}}})(t,pe.config)),[t]),a=e=>{r(((e,t,r)=>{var n,o;const i=!!(null===(n=t.azure)||void 0===n?void 0:n.managedIdentityEnabled),a=(null===(o=t.azure)||void 0===o?void 0:o.cloud)||kx.Public;switch(r.authType){case Nx.MSI:if(!i)throw new Error("Managed Identity authentication is not enabled in Grafana config.");return Bx(Ux({},e),{jsonData:Bx(Ux({},e.jsonData),{azureCredentials:{authType:Nx.MSI}})});case Nx.CLIENT_SECRET:return Bx(Ux({},e),{jsonData:Bx(Ux({},e.jsonData),{azureCredentials:{authType:Nx.CLIENT_SECRET,azureCloud:r.azureCloud||a,tenantId:r.tenantId,clientId:r.clientId}}),secureJsonData:Bx(Ux({},e.secureJsonData),{azureClientSecret:"string"==typeof r.clientSecret&&r.clientSecret.length>0?r.clientSecret:void 0}),secureJsonFields:Bx(Ux({},e.secureJsonFields),{azureClientSecret:"symbol"==typeof r.clientSecret})});case Nx.AD_PASSWORD:return Bx(Ux({},e),{jsonData:Bx(Ux({},e.jsonData),{azureCredentials:{authType:Nx.AD_PASSWORD,userId:r.userId,clientId:r.clientId}}),secureJsonData:Bx(Ux({},e.secureJsonData),{password:"string"==typeof r.password&&r.password.length>0?r.password:void 0}),secureJsonFields:Bx(Ux({},e.secureJsonFields),{password:"symbol"==typeof r.password})})}})(t,pe.config,e))};return s=()=>{t.jsonData.authType||a(i)},(0,ve.useEffect)(s,[]),(0,ge.jsx)(Lk,{managedIdentityEnabled:n,azureEntraPasswordCredentialsEnabled:o,credentials:i,azureCloudOptions:Mx,onCredentialsChange:a,disabled:t.readOnly});var s};function Nk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Dk(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Nk(e,t,r[t])}))}return e}const Fk=(0,ge.jsxs)("span",{children:["Use the format ",(0,ge.jsx)("code",{children:"user@EXAMPLE.COM"}),". Realm is derived from the username."]}),Mk=e=>{const{options:t,onOptionsChange:r}=e,n=t.jsonData,o=null==n?void 0:n.keytabFilePath,i=null==n?void 0:n.credentialCache,a=null==n?void 0:n.credentialCacheLookupFile;return(0,ge.jsxs)(ge.Fragment,{children:[n.authenticationType===Px.kerberosKeytab&&(0,ge.jsxs)(xe.FieldSet,{label:"Windows AD: Keytab",children:[(0,ge.jsx)(xe.Field,{label:"Username",required:!0,invalid:!t.user,error:"Username is required",description:Fk,children:(0,ge.jsx)(xe.Input,{value:t.user||"",placeholder:"name@EXAMPLE.COM",onChange:e=>r(Dk({},t,{user:e.currentTarget.value})),width:40})}),(0,ge.jsx)(xe.Field,{label:"Keytab file path",required:!0,invalid:!o,error:"Keytab file path is required",children:(0,ge.jsx)(xe.Input,{placeholder:"/home/grot/grot.keytab",onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"keytabFilePath",t.currentTarget.value)},width:40,required:!0,value:o||""})})]}),n.authenticationType===Px.kerberosCredentialCache&&(0,ge.jsx)(xe.FieldSet,{label:"Windows AD: Credential cache",children:(0,ge.jsx)(xe.Field,{label:"Credential cache path",required:!0,invalid:!i,error:"Credential cache path is required",children:(0,ge.jsx)(xe.Input,{placeholder:"/tmp/krb5cc_1000",onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"credentialCache",t.currentTarget.value)},width:40,value:i||"",required:!0})})}),n.authenticationType===Px.kerberosCredentialCacheLookupFile&&(0,ge.jsxs)(xe.FieldSet,{label:"Windows AD: Credential cache file",children:[(0,ge.jsx)(xe.Field,{label:"Username",required:!0,invalid:!t.user,error:"Username is required",description:Fk,children:(0,ge.jsx)(xe.Input,{value:t.user||"",placeholder:"name@EXAMPLE.COM",onChange:e=>r(Dk({},t,{user:e.currentTarget.value})),width:40})}),(0,ge.jsx)(xe.Field,{label:"Credential cache file path",required:!0,invalid:!a,error:"Credential cache file path is required",children:(0,ge.jsx)(xe.Input,{placeholder:"/home/grot/cache.json",onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"credentialCacheLookupFile",t.currentTarget.value)},width:40,value:a||"",required:!0})})]})]})},Vk=e=>{const{options:t}=e,r=t.jsonData,n=null==r?void 0:r.configFilePath;return(0,ge.jsx)(ge.Fragment,{children:(0,ge.jsx)(ox,{title:"Windows AD: Advanced Settings",children:(0,ge.jsxs)(xe.FieldSet,{children:[(0,ge.jsx)(xe.Field,{label:"UDP Preference Limit",description:(0,ge.jsxs)("span",{children:["The default is ",(0,ge.jsx)("code",{children:"1"})," and means always use TCP and is optional."]}),children:(0,ge.jsx)(xe.Input,{type:"text",width:40,placeholder:"0",defaultValue:r.UDPConnectionLimit,onChange:t=>{const r=Number(t.currentTarget.value);Number.isNaN(r)||(t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"UDPConnectionLimit",t)})(r)}})}),(0,ge.jsx)(xe.Field,{label:"DNS Lookup KDC",description:(0,ge.jsxs)("span",{children:["Indicate whether DNS `SRV` records should be used to locate the KDCs and other servers for a realm. The default is ",(0,ge.jsx)("code",{children:"true"}),"."]}),children:(0,ge.jsx)(xe.Input,{type:"text",width:40,placeholder:"true",defaultValue:r.enableDNSLookupKDC,onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"enableDNSLookupKDC",t.currentTarget.value)}})}),(0,ge.jsx)(xe.Field,{label:"krb5 config file path",description:(0,ge.jsxs)("span",{children:["The path to the configuration file for the"," ",(0,ge.jsx)("a",{href:"https://web.mit.edu/kerberos/krb5-1.12/doc/admin/conf_files/krb5_conf.html",children:"MIT krb5 package"}),". The default is ",(0,ge.jsx)("code",{children:"/etc/krb5.conf"}),"."]}),children:(0,ge.jsx)(xe.Input,{onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"configFilePath",t.currentTarget.value)},width:40,required:!0,value:n||"/etc/krb5.conf"})})]})})})};function Uk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Bk(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Uk(e,t,r[t])}))}return e}const zk=40;function $k(e){return{ulPadding:(0,$e.css)({margin:e.spacing(1,0),paddingLeft:e.spacing(5)})}}function Wk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}class Hk{quoteLiteral(e){return"'"+e.replace(/'/g,"''")+"'"}constructor(e,t,r){Wk(this,"target",void 0),Wk(this,"templateSrv",void 0),Wk(this,"scopedVars",void 0),this.target=Ae(e||{refId:"A"}),this.templateSrv=t,this.scopedVars=r}}function qk(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Gk(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){qk(i,n,o,a,s,"next",e)}function s(e){qk(i,n,o,a,s,"throw",e)}a(void 0)}))}}function Kk(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Yk=({getColumns:e,getTables:t})=>(r,n)=>{return o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Kk(e,t,r[t])}))}return e}({},n&&Lr(0,n)),i={tables:{resolve:function(){var e=Gk((function*(e){return yield t.current(null==e?void 0:e.table)}));return function(t){return e.apply(this,arguments)}}(),parseName:e=>{if(!e)return{table:""};let t=e,r=t.value;for(;t.next&&t.next.type!==ie.Whitespace;)r+=t.next.value,t=t.next;return t.value.endsWith(".")&&(r=t.value.slice(0,t.value.length-1)),{table:r}}},columns:{resolve:function(){var t=Gk((function*(t){if(!(null==t?void 0:t.table))return[];const[r,n,o]=t.table.split(".");return yield e.current({table:`${n}.${o}`,dataset:r,refId:"A"})}));return function(e){return t.apply(this,arguments)}}()}},i=null!=i?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o;var o,i};function Xk(){return Xk=Gk((function*(e,t){const r=yield e.fields(t);return r.length>0?r.map((e=>({name:e.value,type:e.value,description:e.value}))):[]})),Xk.apply(this,arguments)}function Qk(){return(Qk=Gk((function*(e,t){var r;return(yield null===(r=e.lookup)||void 0===r?void 0:r.call(e,t))||[]}))).apply(this,arguments)}function Jk(e){switch(e){case"datetimeoffset":case"date":case"datetime2":case"smalldatetime":case"datetime":case"time":return"clock-nine";case"bit":return"toggle-off";case"tinyint":case"smallint":case"int":case"bigint":case"decimal":case"numeric":case"real":case"float":case"money":case"smallmoney":return"calculator-alt";case"char":case"varchar":case"text":case"nchar":case"nvarchar":case"ntext":case"binary":case"varbinary":case"image":return"text";default:return}}function Zk(e){switch(e){case"datetimeoffset":case"datetime2":case"smalldatetime":case"datetime":return"datetime";case"time":return"time";case"date":return"date";case"bit":return"boolean";case"tinyint":case"smallint":case"int":case"bigint":case"decimal":case"numeric":case"real":case"float":case"money":case"smallmoney":return"number";default:return"text"}}function eN({sql:e,dataset:t,table:r}){var n,o,i,a;let s="";return e&&_e(e.columns)?(s+=function(e,t){const r=e.map((e=>{let t="";var r;if(e.name&&e.alias)t+=`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>`${e.name}`))}) AS ${e.alias}`;else if(e.name){var n;t+=`${e.name}(${null===(n=e.parameters)||void 0===n?void 0:n.map((e=>`${e.name}`))})`}else if(e.alias){var o;t+=`${null===(o=e.parameters)||void 0===o?void 0:o.map((e=>`${e.name}`))} AS ${e.alias}`}else{var i;t+=`${null===(i=e.parameters)||void 0===i?void 0:i.map((e=>`${e.name}`))}`}return t}));return`SELECT ${tN(t)?"TOP("+t+")":""} ${r.join(", ")} `}(e.columns,e.limit),t&&r&&(s+=`FROM ${t}.${r} `),e.whereString&&(s+=`WHERE ${e.whereString} `),(null===(o=e.groupBy)||void 0===o||null===(n=o[0])||void 0===n?void 0:n.property.name)&&(s+=`GROUP BY ${e.groupBy.map((e=>e.property.name)).filter((e=>!(0,fe.isEmpty)(e))).join(", ")} `),(null===(i=e.orderBy)||void 0===i?void 0:i.property.name)&&(s+=`ORDER BY ${e.orderBy.property.name} `),(null===(a=e.orderBy)||void 0===a?void 0:a.property.name)&&e.orderByDirection&&(s+=`${e.orderByDirection} `),s):s}const tN=e=>void 0!==e&&e>=0;function rN(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function nN(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){rN(i,n,o,a,s,"next",e)}function s(e){rN(i,n,o,a,s,"throw",e)}a(void 0)}))}}const oN=new w.DataSourcePlugin(class extends UT{getQueryModel(e,t,r){return new Hk(e,t,r)}fetchDatasets(){var e=this;return nN((function*(){var t,r;return null!==(r=null===(t=(yield e.runSql("SELECT name FROM sys.databases WHERE name NOT IN ('master', 'tempdb', 'model', 'msdb');",{refId:"datasets"})).fields.name)||void 0===t?void 0:t.values.flat())&&void 0!==r?r:[]}))()}fetchTables(e){var t=this;return nN((function*(){var r,n,o;return null!==(o=null===(r=(yield t.runSql((n=e,`SELECT TABLE_SCHEMA + '.' + TABLE_NAME as schemaAndName\n    FROM [${n}].INFORMATION_SCHEMA.TABLES`),{refId:"tables"})).fields.schemaAndName)||void 0===r?void 0:r.values.flat())&&void 0!==o?o:[]}))()}fetchFields(e){var t=this;return nN((function*(){if(!e.table)return[];const[r,n]=e.table.split("."),o=yield t.runSql(function(e,t){return`\n   USE ${e}\n   SELECT COLUMN_NAME as 'column',DATA_TYPE as 'type'\n   FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME='${t}';`}(e.dataset,n),{refId:"columns"}),i=[];for(let e=0;e<o.length;e++){const t=o.fields.column.values[e],r=o.fields.type.values[e];i.push({label:t,value:t,type:r,icon:Jk(r),raqbFieldType:Zk(r)})}return i}))()}getSqlLanguageDefinition(e){if(void 0!==this.sqlLanguageDefinition)return this.sqlLanguageDefinition;const t={getColumns:{current:t=>function(e,t){return Xk.apply(this,arguments)}(e,t)},getTables:{current:t=>function(e,t){return Qk.apply(this,arguments)}(e,t)}};return this.sqlLanguageDefinition={id:"sql",completionProvider:Yk(t),formatter:ln},this.sqlLanguageDefinition}getDB(){if(void 0!==this.db)return this.db;var e=this,t=this;return{init:()=>Promise.resolve(!0),datasets:()=>this.fetchDatasets(),tables:e=>this.fetchTables(e),getEditorLanguageDefinition:()=>this.getSqlLanguageDefinition(this.db),fields:function(){var t=nN((function*(t){return(null==t?void 0:t.dataset)&&(null==t?void 0:t.table)?e.fetchFields(t):[]}));return function(e){return t.apply(this,arguments)}}(),validateQuery:e=>Promise.resolve({isError:!1,isValid:!0,query:e,error:"",rawSql:e.rawSql}),dsID:()=>this.id,dispose:e=>{},toRawSql:eN,lookup:function(){var e=nN((function*(e){if(e){const r=e.split(".").filter((e=>e));return r.length>2?[]:1===r.length?(yield t.fetchTables(r[0])).map((e=>({name:e,completion:e}))):[]}return(yield t.fetchDatasets()).map((e=>({name:e,completion:`${e}.`})))}));return function(t){return e.apply(this,arguments)}}()}}constructor(e){var t,r;super(e),r=void 0,(t="sqlLanguageDefinition")in this?Object.defineProperty(this,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):this[t]=r}}).setQueryEditor(IT).setQueryEditorHelp((function(){const e=(0,xe.useStyles2)(fx);return(0,ge.jsxs)("div",{children:[(0,ge.jsx)("h2",{children:"MSSQL cheat sheet"}),"Time series:",(0,ge.jsxs)("ul",{className:e.ulPadding,children:[(0,ge.jsx)("li",{children:"return column named time (in UTC), as a unix time stamp or any sql native date data type. You can use the macros below."}),(0,ge.jsx)("li",{children:"any other columns returned will be the time point values."})]}),"Optional:",(0,ge.jsxs)("ul",{className:e.ulPadding,children:[(0,ge.jsxs)("li",{children:["return column named ",(0,ge.jsx)("i",{children:"metric"})," to represent the series name."]}),(0,ge.jsx)("li",{children:"If multiple value columns are returned the metric column is used as prefix."}),(0,ge.jsx)("li",{children:"If no column named metric is found the column name of the value column is used as series name"})]}),(0,ge.jsx)("p",{children:"Resultsets of time series queries need to be sorted by time."}),"Table:",(0,ge.jsx)("ul",{className:e.ulPadding,children:(0,ge.jsx)("li",{children:"return any set of columns"})}),"Macros:",(0,ge.jsxs)("ul",{className:e.ulPadding,children:[(0,ge.jsx)("li",{children:"$__time(column) -> column AS time"}),(0,ge.jsx)("li",{children:"$__timeEpoch(column) -> DATEDIFF(second, '1970-01-01', column) AS time"}),(0,ge.jsx)("li",{children:"$__timeFilter(column) -> column BETWEEN '2017-04-21T05:01:17Z' AND '2017-04-21T05:01:17Z'"}),(0,ge.jsx)("li",{children:"$__unixEpochFilter(column) -> column >= 1492750877 AND column <= 1492750877"}),(0,ge.jsx)("li",{children:"$__unixEpochNanoFilter(column) -> column >= 1494410783152415214 AND column <= 1494497183142514872"}),(0,ge.jsx)("li",{children:"$__timeGroup(column, '5m'[, fillvalue]) -> CAST(ROUND(DATEDIFF(second, '1970-01-01', column)/300.0, 0) as bigint)*300 by setting fillvalue grafana will fill in missing values according to the interval fillvalue can be either a literal value, NULL or previous; previous will fill in the previous seen value or NULL if none has been seen yet"}),(0,ge.jsx)("li",{children:"$__timeGroupAlias(column, '5m'[, fillvalue]) -> CAST(ROUND(DATEDIFF(second, '1970-01-01', column)/300.0, 0) as bigint)*300 AS [time]"}),(0,ge.jsx)("li",{children:"$__unixEpochGroup(column,'5m') -> FLOOR(column/300)*300"}),(0,ge.jsx)("li",{children:"$__unixEpochGroupAlias(column,'5m') -> FLOOR(column/300)*300 AS [time]"})]}),(0,ge.jsx)("p",{children:"Example of group by and order by with $__timeGroup:"}),(0,ge.jsx)("pre",{children:(0,ge.jsxs)("code",{children:["SELECT $__timeGroup(date_time_col, '1h') AS time, sum(value) as value ",(0,ge.jsx)("br",{}),"FROM yourtable",(0,ge.jsx)("br",{}),"GROUP BY $__timeGroup(date_time_col, '1h')",(0,ge.jsx)("br",{}),"ORDER BY 1",(0,ge.jsx)("br",{})]})}),"Or build your own conditionals using these macros which just return the values:",(0,ge.jsxs)("ul",{className:e.ulPadding,children:[(0,ge.jsx)("li",{children:"$__timeFrom() -> '2017-04-21T05:01:17Z'"}),(0,ge.jsx)("li",{children:"$__timeTo() -> '2017-04-21T05:01:17Z'"}),(0,ge.jsx)("li",{children:"$__unixEpochFrom() -> 1492750877"}),(0,ge.jsx)("li",{children:"$__unixEpochTo() -> 1492750877"}),(0,ge.jsx)("li",{children:"$__unixEpochNanoFrom() -> 1494410783152415214"}),(0,ge.jsx)("li",{children:"$__unixEpochNanoTo() -> 1494497183142514872"})]})]})})).setConfigEditor((e=>{var t;!function({onOptionsChange:e,options:t}){(0,ve.useEffect)((()=>{const r=t.jsonData;let n=dx({},t),o=!1;if(t.database&&(ux.logDebug(`Migrating from options.database with value ${t.database} for ${t.name}`),n.database="",n.jsonData=px(dx({},r),{database:t.database}),o=!0),void 0===r.maxOpenConns&&void 0===r.maxIdleConns&&void 0===r.maxIdleConnsAuto){const{maxOpenConns:e,maxIdleConns:t}=pe.config.sqlConnectionLimits;ux.logDebug(`Setting default max open connections to ${e} and setting max idle connection to ${t}`),n.jsonData=px(dx({},n.jsonData),{maxOpenConns:e,maxIdleConns:t,maxIdleConnsAuto:!0}),o=!0}if(void 0===r.connMaxLifetime){const{connMaxLifetime:e}=pe.config.sqlConnectionLimits;n.jsonData=px(dx({},n.jsonData),{connMaxLifetime:e}),o=!0}o&&e(n)}),[e,t])}(e);const{options:r,onOptionsChange:n}=e,o=(0,xe.useStyles2)($k),i=r.jsonData,a=pe.config.azureAuthEnabled,s=kk,l=e=>t=>{n(Bk({},r,{[e]:t.currentTarget.value}))},u=[{value:Lx.disable,label:"disable"},{value:Lx.false,label:"false"},{value:Lx.true,label:"true"}];return(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(wx,{dataSourceName:"Microsoft SQL Server",docsLink:"https://grafana.com/docs/grafana/latest/datasources/mssql/",hasRequiredFields:!0}),(0,ge.jsxs)(xe.Alert,{title:"User Permission",severity:"info",children:["The database user should only be granted SELECT permissions on the specified database and tables you want to query. Grafana does not validate that queries are safe so queries can contain any SQL statement. For example, statements like ",(0,ge.jsx)("code",{children:"USE otherdb;"})," and ",(0,ge.jsx)("code",{children:"DROP TABLE user;"})," would be executed. To protect against this we ",(0,ge.jsx)("em",{children:"highly"})," recommend you create a specific MS SQL user with restricted permissions. Check out the"," ",(0,ge.jsx)(xe.Link,{rel:"noreferrer",target:"_blank",href:"http://docs.grafana.org/features/datasources/mssql/",children:"Microsoft SQL Server Data Source Docs"})," ","for more information."]}),(0,ge.jsx)(xe.Divider,{}),(0,ge.jsxs)(jx,{title:"Connection",children:[(0,ge.jsx)(xe.Field,{label:"Host",required:!0,invalid:!r.url,error:"Host is required",children:(0,ge.jsx)(xe.Input,{width:zk,name:"host",type:"text",value:r.url||"",placeholder:"localhost:1433",onChange:l("url")})}),(0,ge.jsx)(xe.Field,{label:"Database",required:!0,invalid:!i.database,error:"Database is required",children:(0,ge.jsx)(xe.Input,{width:zk,name:"database",value:i.database||"",placeholder:"database name",onChange:(0,w.onUpdateDatasourceJsonDataOption)(e,"database")})})]}),(0,ge.jsxs)(jx,{title:"TLS/SSL Auth",children:[(0,ge.jsx)(xe.Field,{htmlFor:"encrypt",description:(0,ge.jsxs)(ge.Fragment,{children:["Determines whether or to which extent a secure SSL TCP/IP connection will be negotiated with the server.",(0,ge.jsxs)("ul",{className:o.ulPadding,children:[(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"disable"})," - Data sent between client and server is not encrypted."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"false"})," - Data sent between client and server is not encrypted beyond the login packet. (default)"]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"true"})," - Data sent between client and server is encrypted."]})]}),"If you're using an older version of Microsoft SQL Server like 2008 and 2008R2 you may need to disable encryption to be able to connect."]}),label:"Encrypt",children:(0,ge.jsx)(xe.Select,{options:u,value:i.encrypt||Lx.false,inputId:"encrypt",onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"encrypt",t.value)},width:zk})}),i.encrypt===Lx.true?(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xe.Field,{htmlFor:"skipTlsVerify",label:"Skip TLS Verify",children:(0,ge.jsx)(xe.Switch,{id:"skipTlsVerify",onChange:t=>{(0,w.updateDatasourcePluginJsonDataOption)(e,"tlsSkipVerify",t.currentTarget.checked)},value:i.tlsSkipVerify||!1})}),i.tlsSkipVerify?null:(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xe.Field,{description:(0,ge.jsx)("span",{children:"Path to file containing the public key certificate of the CA that signed the SQL Server certificate. Needed when the server certificate is self signed."}),label:"TLS/SSL Root Certificate",children:(0,ge.jsx)(xe.Input,{value:i.sslRootCertFile||"",onChange:(0,w.onUpdateDatasourceJsonDataOption)(e,"sslRootCertFile"),placeholder:"TLS/SSL root certificate file path",width:zk})}),(0,ge.jsx)(xe.Field,{label:"Hostname in server certificate",children:(0,ge.jsx)(xe.Input,{placeholder:"Common Name (CN) in server certificate",value:i.serverName||"",onChange:(0,w.onUpdateDatasourceJsonDataOption)(e,"serverName"),width:zk})})]})]}):null]}),(0,ge.jsxs)(jx,{title:"Authentication",children:[(0,ge.jsx)(xe.Field,{label:"Authentication Type",htmlFor:"authenticationType",description:(0,ge.jsxs)("ul",{className:o.ulPadding,children:[(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"SQL Server Authentication"})," This is the default mechanism to connect to MS SQL Server. Enter the SQL Server Authentication login or the Windows Authentication login in the DOMAIN\\User format."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Windows Authentication"})," Windows Integrated Security - single sign on for users who are already logged onto Windows and have enabled this option for MS SQL Server."]}),a&&(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Azure Authentication"})," Securely authenticate and access Azure resources and applications using Azure AD credentials - Managed Service Identity and Client Secret Credentials are supported."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Windows AD: Username + password"})," Windows Active Directory - Sign on for domain user via username/password."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Windows AD: Keytab"})," Windows Active Directory - Sign on for domain user via keytab file."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Windows AD: Credential cache"})," Windows Active Directory - Sign on for domain user via credential cache."]}),(0,ge.jsxs)("li",{children:[(0,ge.jsx)("i",{children:"Windows AD: Credential cache file"})," Windows Active Directory - Sign on for domain user via credential cache file."]})]}),children:(0,ge.jsx)(xe.Select,{value:i.authenticationType||Px.sqlAuth,inputId:"authenticationType",options:(()=>{const e=[{value:Px.sqlAuth,label:"SQL Server Authentication"},{value:Px.windowsAuth,label:"Windows Authentication"},{value:Px.kerberosRaw,label:"Windows AD: Username + password"},{value:Px.kerberosKeytab,label:"Windows AD: Keytab file"},{value:Px.kerberosCredentialCache,label:"Windows AD: Credential cache"},{value:Px.kerberosCredentialCacheLookupFile,label:"Windows AD: Credential cache file"}];return a?[...e,{value:Px.azureAuth,label:Px.azureAuth}]:e})(),onChange:e=>{var t,o;n(Bk({},r,{jsonData:(t=Bk({},i,{authenticationType:e.value}),o={azureCredentials:void 0,keytabFilePath:void 0,credentialCache:void 0,credentialCacheLookupFile:void 0},o=null!=o?o:{},Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(o)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(o)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(o,e))})),t),secureJsonData:Bk({},r.secureJsonData,{password:""}),secureJsonFields:Bk({},r.secureJsonFields,{password:!1}),user:""}))},width:zk})}),(0,ge.jsx)(Mk,Bk({},e)),(i.authenticationType===Px.sqlAuth||i.authenticationType===Px.kerberosRaw||!i.authenticationType)&&(0,ge.jsxs)(ge.Fragment,{children:[(0,ge.jsx)(xe.Field,{label:"Username",required:!0,invalid:!r.user,error:"Username is required",description:i.authenticationType===Px.kerberosRaw?Fk:"",children:(0,ge.jsx)(xe.Input,{value:r.user||"",placeholder:i.authenticationType===Px.kerberosRaw?"name@EXAMPLE.COM":"user",onChange:l("user"),width:zk})}),(0,ge.jsx)(xe.Field,{label:"Password",required:!0,invalid:!r.secureJsonFields.password&&!(null===(t=r.secureJsonData)||void 0===t?void 0:t.password),error:"Password is required",children:(0,ge.jsx)(xe.SecretInput,{width:zk,placeholder:"Password",isConfigured:r.secureJsonFields&&r.secureJsonFields.password,onReset:()=>{(0,w.updateDatasourcePluginResetOption)(e,"password")},onChange:(0,w.onUpdateDatasourceSecureJsonDataOption)(e,"password"),required:!0})})]}),a&&i.authenticationType===Px.azureAuth&&(0,ge.jsx)(xe.FieldSet,{label:"Azure Authentication Settings",children:(0,ge.jsx)(s,{dataSourceConfig:r,onChange:n})})]}),(0,ge.jsx)(xe.Divider,{}),(0,ge.jsxs)(jx,{title:"Additional settings",description:"Additional settings are optional settings that can be configured for more control over your data source. This includes connection limits, connection timeout, group-by time interval, and Secure Socks Proxy.",isCollapsible:!0,isInitiallyOpen:!0,children:[(0,ge.jsx)(lx,{options:r,onOptionsChange:n}),(0,ge.jsxs)(ox,{title:"Connection details",children:[(0,ge.jsx)(xe.Field,{description:(0,ge.jsxs)("span",{children:["A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example",(0,ge.jsx)("code",{children:"1m"})," if your data is written every minute."]}),label:"Min time interval",children:(0,ge.jsx)(xe.Input,{width:zk,placeholder:"1m",value:i.timeInterval||"",onChange:(0,w.onUpdateDatasourceJsonDataOption)(e,"timeInterval")})}),(0,ge.jsx)(xe.Field,{description:(0,ge.jsxs)("span",{children:["The number of seconds to wait before canceling the request when connecting to the database. The default is ",(0,ge.jsx)("code",{children:"0"}),", meaning no timeout."]}),label:"Connection timeout",children:(0,ge.jsx)(ix,{width:zk,defaultValue:60,value:i.connectionTimeout||0,onChange:t=>{t&&t<0&&(t=0),(0,w.updateDatasourcePluginJsonDataOption)(e,"connectionTimeout",t)}})})]}),pe.config.secureSocksDSProxyEnabled&&(0,ge.jsx)(xe.SecureSocksProxySettings,{options:r,onOptionsChange:n}),(0,ge.jsx)(Vk,Bk({},e))]})]})}))})(),m})()));
//# sourceMappingURL=module.js.map